! -----------------------------------------------------------------------------  
! This file was automatically created by SARAH version 4.12.3 
! SARAH References: arXiv:0806.0538, 0909.2863, 1002.0840, 1207.0906, 1309.7223  
! (c) Florian Staub, 2013  
! ------------------------------------------------------------------------------  
! File created at 8:14 on 5.4.2018   
! ----------------------------------------------------------------------  
 
 
Module BranchingRatios_4HDM_S3 
 
Use Control 
Use Settings 
Use Couplings_4HDM_S3 
Use Model_Data_4HDM_S3 
Use LoopCouplings_4HDM_S3 
Use Fu3Decays_4HDM_S3 
Use Fe3Decays_4HDM_S3 
Use Fd3Decays_4HDM_S3 
Use TreeLevelDecays_4HDM_S3 
Use OneLoopDecays_4HDM_S3


 Contains 
 
Subroutine CalculateBR(CTBD,fac3,epsI,deltaM,kont,MAh,MAh2,MFd,MFd2,MFe,              & 
& MFe2,MFu,MFu2,MHap,MHap2,Mhha,Mhha2,MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,           & 
& MVWp2,MVZ,MVZ2,TW,ZDR,ZER,ZUR,v,ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,v1,v2,g1,             & 
& g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,           & 
& Yu,Yd,Ye,mu1,mu2,mu0,gPFu,gTFu,BRFu,gPFe,gTFe,BRFe,gPFd,gTFd,BRFd,gPVZ,gTVZ,           & 
& BRVZ,gPVWp,gTVWp,BRVWp,gPHhSM,gTHhSM,BRHhSM,gPAh,gTAh,BRAh,gPHp,gTHp,BRHp)

Real(dp), Intent(in) :: epsI, deltaM, fac3 
Integer, Intent(inout) :: kont 
Logical, Intent(in) :: CTBD 
Real(dp),Intent(inout) :: g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,            & 
& lam8,mu1,mu2,mu0

Complex(dp),Intent(inout) :: Yu(3,3),Yd(3,3),Ye(3,3)

Real(dp),Intent(in) :: MAh(3),MAh2(3),MFd(3),MFd2(3),MFe(3),MFe2(3),MFu(3),MFu2(3),MHap,MHap2,               & 
& Mhha,Mhha2,MHhSM(3),MHhSM2(3),MHp(3),MHp2(3),Msiga,Msiga2,MVWp,MVWp2,MVZ,              & 
& MVZ2,TW,v,ZA(3,3),ZH(3,3),ZP(3,3),ZZ(2,2),betaH

Complex(dp),Intent(in) :: ZDR(3,3),ZER(3,3),ZUR(3,3),ZDL(3,3),ZEL(3,3),ZUL(3,3),ZW(2,2)

Real(dp),Intent(inout) :: v1,v2

Real(dp),Intent(inout) :: gPFu(3,168),gTFu(3),BRFu(3,168),gPFe(3,165),gTFe(3),BRFe(3,165),gPFd(3,168),          & 
& gTFd(3),BRFd(3,168),gPVZ(1,54),gTVZ,BRVZ(1,54),gPVWp(1,36),gTVWp,BRVWp(1,36),          & 
& gPHhSM(3,80),gTHhSM(3),BRHhSM(3,80),gPAh(3,78),gTAh(3),BRAh(3,78),gPHp(3,41),          & 
& gTHp(3),BRHp(3,41)

Complex(dp) :: cplHiggsPP(3),cplHiggsGG(3),cplPseudoHiggsPP(3),cplPseudoHiggsGG(3),cplHiggsZZvirt(3),& 
& cplHiggsWWvirt(3)

Real(dp) :: gFuFucFdFd(3,3,3,3),gFuFucFeFe(3,3,3,3),gFuFucFuFu(3,3,3,3),gFuFdcFeFv(3,3,3,3),      & 
& gFuFucFvFv(3,3,3,3),gFeFecFdFd(3,3,3,3),gFeFecFeFe(3,3,3,3),gFeFecFuFu(3,3,3,3),       & 
& gFeFecFvFv(3,3,3,3),gFeFvcFuFd(3,3,3,3),gFdFdcFdFd(3,3,3,3),gFdFdcFeFe(3,3,3,3),       & 
& gFdFdcFuFu(3,3,3,3),gFdFdcFvFv(3,3,3,3),gFdFucFvFe(3,3,3,3)

Complex(dp) :: coup 
Real(dp) :: vev 
Iname = Iname + 1 
NameOfUnit(Iname) = 'CalculateBR'
 
Write(*,*) "Calculating branching ratios and decay widths" 
gTVWp = gamW 
gTVZ = gamZ 
! One-Loop Decays 
If (OneLoopDecays) Then 
Call CalculateOneLoopDecays(gP1LFu,gP1LFe,gP1LFd,gP1LHhSM,gP1LAh,gP1LHp,              & 
& MHhSM,MHhSM2,MAh,MAh2,MHp,MHp2,MFd,MFd2,MFu,MFu2,MFe,MFe2,MHap,MHap2,Msiga,            & 
& Msiga2,Mhha,Mhha2,MVZ,MVZ2,MVWp,MVWp2,ZH,ZA,ZP,ZDL,ZDR,ZUL,ZUR,ZEL,ZER,v1,             & 
& v2,g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,               & 
& lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,epsI,deltaM,kont)

End if 


gPFu = 0._dp 
gTFu = 0._dp 
BRFu = 0._dp 
Call FuTwoBodyDecay(-1,DeltaM,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,               & 
& MHap2,Mhha,Mhha2,MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,               & 
& TW,ZDR,ZER,ZUR,v,ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,g1,g2,g3,lam1,lam3,lam4,             & 
& lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,               & 
& mu0,v1,v2,gPFu(:,1:33),gTFu,BRFu(:,1:33))

Do i1=1,3
gTFu(i1) =Sum(gPFu(i1,:)) 
If (gTFu(i1).Gt.0._dp) BRFu(i1,: ) =gPFu(i1,:)/gTFu(i1) 
If (OneLoopDecays) Then 
gT1LFu(i1) =Sum(gP1LFu(i1,:)) 
If (gT1LFu(i1).Gt.0._dp) BR1LFu(i1,: ) =gP1LFu(i1,:)/gT1LFu(i1) 
End if
End Do 
 

gPFe = 0._dp 
gTFe = 0._dp 
BRFe = 0._dp 
Call FeTwoBodyDecay(-1,DeltaM,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,               & 
& MHap2,Mhha,Mhha2,MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,               & 
& TW,ZDR,ZER,ZUR,v,ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,g1,g2,g3,lam1,lam3,lam4,             & 
& lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,               & 
& mu0,v1,v2,gPFe(:,1:30),gTFe,BRFe(:,1:30))

Do i1=1,3
gTFe(i1) =Sum(gPFe(i1,:)) 
If (gTFe(i1).Gt.0._dp) BRFe(i1,: ) =gPFe(i1,:)/gTFe(i1) 
If (OneLoopDecays) Then 
gT1LFe(i1) =Sum(gP1LFe(i1,:)) 
If (gT1LFe(i1).Gt.0._dp) BR1LFe(i1,: ) =gP1LFe(i1,:)/gT1LFe(i1) 
End if
End Do 
 

gPFd = 0._dp 
gTFd = 0._dp 
BRFd = 0._dp 
Call FdTwoBodyDecay(-1,DeltaM,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,               & 
& MHap2,Mhha,Mhha2,MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,               & 
& TW,ZDR,ZER,ZUR,v,ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,g1,g2,g3,lam1,lam3,lam4,             & 
& lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,               & 
& mu0,v1,v2,gPFd(:,1:33),gTFd,BRFd(:,1:33))

Do i1=1,3
gTFd(i1) =Sum(gPFd(i1,:)) 
If (gTFd(i1).Gt.0._dp) BRFd(i1,: ) =gPFd(i1,:)/gTFd(i1) 
If (OneLoopDecays) Then 
gT1LFd(i1) =Sum(gP1LFd(i1,:)) 
If (gT1LFd(i1).Gt.0._dp) BR1LFd(i1,: ) =gP1LFd(i1,:)/gT1LFd(i1) 
End if
End Do 
 

gPVZ = 0._dp 
gTVZ = 0._dp 
BRVZ = 0._dp 
Call VZTwoBodyDecay(-1,DeltaM,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,               & 
& MHap2,Mhha,Mhha2,MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,               & 
& TW,ZDR,ZER,ZUR,v,ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,g1,g2,g3,lam1,lam3,lam4,             & 
& lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,               & 
& mu0,v1,v2,gPVZ,gTVZ,BRVZ)

Do i1=1,1
gTVZ =Sum(gPVZ(i1,:)) 
If (gTVZ.Gt.0._dp) BRVZ(i1,: ) =gPVZ(i1,:)/gTVZ 
End Do 
 

! Set Goldstone Widhts 
gTAh(1)=gTVZ


gPVWp = 0._dp 
gTVWp = 0._dp 
BRVWp = 0._dp 
Call VWpTwoBodyDecay(-1,DeltaM,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,              & 
& MHap2,Mhha,Mhha2,MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,               & 
& TW,ZDR,ZER,ZUR,v,ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,g1,g2,g3,lam1,lam3,lam4,             & 
& lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,               & 
& mu0,v1,v2,gPVWp,gTVWp,BRVWp)

Do i1=1,1
gTVWp =Sum(gPVWp(i1,:)) 
If (gTVWp.Gt.0._dp) BRVWp(i1,: ) =gPVWp(i1,:)/gTVWp 
End Do 
 

! Set Goldstone Widhts 
gTHp(1)=gTVWp


gPHhSM = 0._dp 
gTHhSM = 0._dp 
BRHhSM = 0._dp 
Call HhSMTwoBodyDecay(-1,DeltaM,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,             & 
& MHap2,Mhha,Mhha2,MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,               & 
& TW,ZDR,ZER,ZUR,v,ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,g1,g2,g3,lam1,lam3,lam4,             & 
& lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,               & 
& mu0,v1,v2,gPHhSM,gTHhSM,BRHhSM)

Do i1=1,3
gTHhSM(i1) =Sum(gPHhSM(i1,:)) 
If (gTHhSM(i1).Gt.0._dp) BRHhSM(i1,: ) =gPHhSM(i1,:)/gTHhSM(i1) 
If (OneLoopDecays) Then 
gT1LHhSM(i1) =Sum(gP1LHhSM(i1,:)) 
If (gT1LHhSM(i1).Gt.0._dp) BR1LHhSM(i1,: ) =gP1LHhSM(i1,:)/gT1LHhSM(i1) 
End if
End Do 
 

gPAh = 0._dp 
gTAh = 0._dp 
BRAh = 0._dp 
Call AhTwoBodyDecay(-1,DeltaM,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,               & 
& MHap2,Mhha,Mhha2,MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,               & 
& TW,ZDR,ZER,ZUR,v,ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,g1,g2,g3,lam1,lam3,lam4,             & 
& lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,               & 
& mu0,v1,v2,gPAh,gTAh,BRAh)

Do i1=1,3
gTAh(i1) =Sum(gPAh(i1,:)) 
If (gTAh(i1).Gt.0._dp) BRAh(i1,: ) =gPAh(i1,:)/gTAh(i1) 
If (OneLoopDecays) Then 
gT1LAh(i1) =Sum(gP1LAh(i1,:)) 
If (gT1LAh(i1).Gt.0._dp) BR1LAh(i1,: ) =gP1LAh(i1,:)/gT1LAh(i1) 
End if
End Do 
 

! Set Goldstone Widhts 
gTAh(1)=gTVZ


gPHp = 0._dp 
gTHp = 0._dp 
BRHp = 0._dp 
Call HpTwoBodyDecay(-1,DeltaM,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,               & 
& MHap2,Mhha,Mhha2,MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,               & 
& TW,ZDR,ZER,ZUR,v,ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,g1,g2,g3,lam1,lam3,lam4,             & 
& lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,               & 
& mu0,v1,v2,gPHp,gTHp,BRHp)

Do i1=1,3
gTHp(i1) =Sum(gPHp(i1,:)) 
If (gTHp(i1).Gt.0._dp) BRHp(i1,: ) =gPHp(i1,:)/gTHp(i1) 
If (OneLoopDecays) Then 
gT1LHp(i1) =Sum(gP1LHp(i1,:)) 
If (gT1LHp(i1).Gt.0._dp) BR1LHp(i1,: ) =gP1LHp(i1,:)/gT1LHp(i1) 
End if
End Do 
 

! Set Goldstone Widhts 
gTHp(1)=gTVWp


If (.Not.CTBD) Then 
If ((Enable3BDecaysF).and.(Calc3BodyDecay_Fu)) Then 
If (MaxVal(gTFu).Lt.MaxVal(fac3*Abs(MFu))) Then 
Call FuThreeBodyDecay(-1,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,MHap2,              & 
& Mhha,Mhha2,MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,              & 
& ZER,ZUR,v,ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,g1,g2,g3,lam1,lam3,lam4,lam2,               & 
& lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,v1,             & 
& v2,gTAh,gTHhSM,gTHp,gTVWp,gTVZ,gFuFucFdFd,gFuFucFeFe,gFuFucFuFu,gFuFdcFeFv,            & 
& gFuFucFvFv,epsI,deltaM,.False.,gTFu,gPFu(:,34:168),BRFu(:,34:168))

Else 
Call FuThreeBodyDecay(-1,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,MHap2,              & 
& Mhha,Mhha2,MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,              & 
& ZER,ZUR,v,ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,g1,g2,g3,lam1,lam3,lam4,lam2,               & 
& lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,v1,             & 
& v2,gTAh,gTHhSM,gTHp,gTVWp,gTVZ,gFuFucFdFd,gFuFucFeFe,gFuFucFuFu,gFuFdcFeFv,            & 
& gFuFucFvFv,epsI,deltaM,.True.,gTFu,gPFu(:,34:168),BRFu(:,34:168))

End If 
 
End If 
Else 
Call FuThreeBodyDecay(-1,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,MHap2,              & 
& Mhha,Mhha2,MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,              & 
& ZER,ZUR,v,ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,g1,g2,g3,lam1,lam3,lam4,lam2,               & 
& lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,v1,             & 
& v2,gTAh,gTHhSM,gTHp,gTVWp,gTVZ,gFuFucFdFd,gFuFucFeFe,gFuFucFuFu,gFuFdcFeFv,            & 
& gFuFucFvFv,epsI,deltaM,.False.,gTFu,gPFu(:,34:168),BRFu(:,34:168))

End If 
Do i1=1,3
gTFu(i1) =Sum(gPFu(i1,:)) 
If (gTFu(i1).Gt.0._dp) BRFu(i1,: ) =gPFu(i1,:)/gTFu(i1) 
End Do 
 

If (.Not.CTBD) Then 
If ((Enable3BDecaysF).and.(Calc3BodyDecay_Fe)) Then 
If (MaxVal(gTFe).Lt.MaxVal(fac3*Abs(MFe))) Then 
Call FeThreeBodyDecay(-1,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,MHap2,              & 
& Mhha,Mhha2,MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,              & 
& ZER,ZUR,v,ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,g1,g2,g3,lam1,lam3,lam4,lam2,               & 
& lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,v1,             & 
& v2,gTAh,gTHhSM,gTHp,gTVWp,gTVZ,gFeFecFdFd,gFeFecFeFe,gFeFecFuFu,gFeFecFvFv,            & 
& gFeFvcFuFd,epsI,deltaM,.False.,gTFe,gPFe(:,31:165),BRFe(:,31:165))

Else 
Call FeThreeBodyDecay(-1,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,MHap2,              & 
& Mhha,Mhha2,MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,              & 
& ZER,ZUR,v,ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,g1,g2,g3,lam1,lam3,lam4,lam2,               & 
& lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,v1,             & 
& v2,gTAh,gTHhSM,gTHp,gTVWp,gTVZ,gFeFecFdFd,gFeFecFeFe,gFeFecFuFu,gFeFecFvFv,            & 
& gFeFvcFuFd,epsI,deltaM,.True.,gTFe,gPFe(:,31:165),BRFe(:,31:165))

End If 
 
End If 
Else 
Call FeThreeBodyDecay(-1,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,MHap2,              & 
& Mhha,Mhha2,MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,              & 
& ZER,ZUR,v,ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,g1,g2,g3,lam1,lam3,lam4,lam2,               & 
& lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,v1,             & 
& v2,gTAh,gTHhSM,gTHp,gTVWp,gTVZ,gFeFecFdFd,gFeFecFeFe,gFeFecFuFu,gFeFecFvFv,            & 
& gFeFvcFuFd,epsI,deltaM,.False.,gTFe,gPFe(:,31:165),BRFe(:,31:165))

End If 
Do i1=1,3
gTFe(i1) =Sum(gPFe(i1,:)) 
If (gTFe(i1).Gt.0._dp) BRFe(i1,: ) =gPFe(i1,:)/gTFe(i1) 
End Do 
 

If (.Not.CTBD) Then 
If ((Enable3BDecaysF).and.(Calc3BodyDecay_Fd)) Then 
If (MaxVal(gTFd).Lt.MaxVal(fac3*Abs(MFd))) Then 
Call FdThreeBodyDecay(-1,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,MHap2,              & 
& Mhha,Mhha2,MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,              & 
& ZER,ZUR,v,ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,g1,g2,g3,lam1,lam3,lam4,lam2,               & 
& lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,v1,             & 
& v2,gTAh,gTHhSM,gTHp,gTVWp,gTVZ,gFdFdcFdFd,gFdFdcFeFe,gFdFdcFuFu,gFdFdcFvFv,            & 
& gFdFucFvFe,epsI,deltaM,.False.,gTFd,gPFd(:,34:168),BRFd(:,34:168))

Else 
Call FdThreeBodyDecay(-1,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,MHap2,              & 
& Mhha,Mhha2,MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,              & 
& ZER,ZUR,v,ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,g1,g2,g3,lam1,lam3,lam4,lam2,               & 
& lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,v1,             & 
& v2,gTAh,gTHhSM,gTHp,gTVWp,gTVZ,gFdFdcFdFd,gFdFdcFeFe,gFdFdcFuFu,gFdFdcFvFv,            & 
& gFdFucFvFe,epsI,deltaM,.True.,gTFd,gPFd(:,34:168),BRFd(:,34:168))

End If 
 
End If 
Else 
Call FdThreeBodyDecay(-1,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,MHap2,              & 
& Mhha,Mhha2,MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,              & 
& ZER,ZUR,v,ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,g1,g2,g3,lam1,lam3,lam4,lam2,               & 
& lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,v1,             & 
& v2,gTAh,gTHhSM,gTHp,gTVWp,gTVZ,gFdFdcFdFd,gFdFdcFeFe,gFdFdcFuFu,gFdFdcFvFv,            & 
& gFdFucFvFe,epsI,deltaM,.False.,gTFd,gPFd(:,34:168),BRFd(:,34:168))

End If 
Do i1=1,3
gTFd(i1) =Sum(gPFd(i1,:)) 
If (gTFd(i1).Gt.0._dp) BRFd(i1,: ) =gPFd(i1,:)/gTFd(i1) 
End Do 
 

! No 3-body decays for VZ  
! No 3-body decays for VWp  
! No 3-body decays for HhSM  
! No 3-body decays for Ah  
! No 3-body decays for Hp  
Iname = Iname - 1 
 
End Subroutine CalculateBR 
End Module BranchingRatios_4HDM_S3 
 