! -----------------------------------------------------------------------------  
! This file was automatically created by SARAH version 4.12.3 
! SARAH References: arXiv:0806.0538, 0909.2863, 1002.0840, 1207.0906, 1309.7223  
! (c) Florian Staub, 2013  
! ------------------------------------------------------------------------------  
! File created at 8:16 on 5.4.2018   
! ----------------------------------------------------------------------  
 
 
Module CouplingsForDecays_4HDM_S3
 
Use Control 
Use Settings 
Use Model_Data_4HDM_S3 
Use Couplings_4HDM_S3 
Use LoopCouplings_4HDM_S3 
Use Tadpoles_4HDM_S3 
 Use TreeLevelMasses_4HDM_S3 
Use Mathematics, Only: CompareMatrices, Adjungate 
 
Use StandardModel 
Contains 
 
 
 
Subroutine CouplingsFor_Fu_decays_2B(m_in,i1,MAhinput,MAh2input,MFdinput,             & 
& MFd2input,MFeinput,MFe2input,MFuinput,MFu2input,MHapinput,MHap2input,Mhhainput,        & 
& Mhha2input,MHhSMinput,MHhSM2input,MHpinput,MHp2input,Msigainput,Msiga2input,           & 
& MVWpinput,MVWp2input,MVZinput,MVZ2input,TWinput,ZDRinput,ZERinput,ZURinput,            & 
& vinput,ZDLinput,ZELinput,ZULinput,ZAinput,ZHinput,ZPinput,ZWinput,ZZinput,             & 
& betaHinput,g1input,g2input,g3input,lam1input,lam3input,lam4input,lam2input,            & 
& lam12input,lam7input,lam11input,lam10input,lam13input,lam6input,lam14input,            & 
& lam5input,lam8input,Yuinput,Ydinput,Yeinput,mu1input,mu2input,mu0input,v1input,        & 
& v2input,cplcFuFuAhL,cplcFuFuAhR,cplcFuFdHpL,cplcFuFdHpR,cplcFuFdVWpL,cplcFuFdVWpR,     & 
& cplcFuFuHhSML,cplcFuFuHhSMR,cplcFuFuVZL,cplcFuFuVZR,deltaM)

Implicit None 

Real(dp), Intent(in) :: m_in 
Real(dp), Intent(in) :: deltaM 
Integer, Intent(in) :: i1 
Real(dp),Intent(in) :: g1input,g2input,g3input,lam1input,lam3input,lam4input,lam2input,lam12input,           & 
& lam7input,lam11input,lam10input,lam13input,lam6input,lam14input,lam5input,             & 
& lam8input,mu1input,mu2input,mu0input,v1input,v2input

Complex(dp),Intent(in) :: Yuinput(3,3),Ydinput(3,3),Yeinput(3,3)

Real(dp),Intent(in) :: MAhinput(3),MAh2input(3),MFdinput(3),MFd2input(3),MFeinput(3),MFe2input(3),           & 
& MFuinput(3),MFu2input(3),MHapinput,MHap2input,Mhhainput,Mhha2input,MHhSMinput(3),      & 
& MHhSM2input(3),MHpinput(3),MHp2input(3),Msigainput,Msiga2input,MVWpinput,              & 
& MVWp2input,MVZinput,MVZ2input,TWinput,vinput,ZAinput(3,3),ZHinput(3,3),ZPinput(3,3),   & 
& ZZinput(2,2),betaHinput

Complex(dp),Intent(in) :: ZDRinput(3,3),ZERinput(3,3),ZURinput(3,3),ZDLinput(3,3),ZELinput(3,3),ZULinput(3,3),  & 
& ZWinput(2,2)

Real(dp) :: g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,            & 
& lam8,mu1,mu2,mu0,v1,v2

Complex(dp) :: Yu(3,3),Yd(3,3),Ye(3,3)

Complex(dp),Intent(out) :: cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcFuFdHpL(3,3,3),cplcFuFdHpR(3,3,3),          & 
& cplcFuFdVWpL(3,3),cplcFuFdVWpR(3,3),cplcFuFuHhSML(3,3,3),cplcFuFuHhSMR(3,3,3),         & 
& cplcFuFuVZL(3,3),cplcFuFuVZR(3,3)

Integer :: i2, i3, gt1, gt2, gt3, kont 
Real(dp) :: MAh(3),MAh2(3),MFd(3),MFd2(3),MFe(3),MFe2(3),MFu(3),MFu2(3),MHap,MHap2,               & 
& Mhha,Mhha2,MHhSM(3),MHhSM2(3),MHp(3),MHp2(3),Msiga,Msiga2,MVWp,MVWp2,MVZ,              & 
& MVZ2,TW,v,ZA(3,3),ZH(3,3),ZP(3,3),ZZ(2,2),betaH

Complex(dp) :: ZDR(3,3),ZER(3,3),ZUR(3,3),ZDL(3,3),ZEL(3,3),ZUL(3,3),ZW(2,2)

Real(dp) :: gSM(11), sinW2, dt, tz, Qin 
Iname = Iname + 1 
NameOfUnit(Iname) = 'Couplings_Fu_2B'
 
sinW2=1._dp-mW2/mZ2 
g1 = g1input 
g2 = g2input 
g3 = g3input 
lam1 = lam1input 
lam3 = lam3input 
lam4 = lam4input 
lam2 = lam2input 
lam12 = lam12input 
lam7 = lam7input 
lam11 = lam11input 
lam10 = lam10input 
lam13 = lam13input 
lam6 = lam6input 
lam14 = lam14input 
lam5 = lam5input 
lam8 = lam8input 
Yu = Yuinput 
Yd = Ydinput 
Ye = Yeinput 
mu1 = mu1input 
mu2 = mu2input 
mu0 = mu0input 
v1 = v1input 
v2 = v2input 
Qin=sqrt(getRenormalizationScale()) 
If (m_in.le.Qin) Then 
  If (m_in.le.mz) Then 
    Call RunSM(mz,deltaM,v2/v1,g1,g2,g3,Yu,Yd,Ye,v1,v2) 
  Else 
    Call RunSM(m_in,deltaM,v2/v1,g1,g2,g3,Yu,Yd,Ye,v1,v2) 
  End if 
End if 
Call SolveTadpoleEquations(g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,             & 
& lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,v1,v2,(/ ZeroC, ZeroC, ZeroC, ZeroC /))

! --- Calculate running tree-level masses for loop induced couplings and Quark mixing matrices --- 
Call TreeMasses(MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,MHap2,Mhha,Mhha2,            & 
& MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,ZER,ZUR,v,               & 
& ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,v1,v2,g1,g2,g3,lam1,lam3,lam4,lam2,lam12,             & 
& lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,.True.,kont)

If (ExternalZfactors) Then 
! --- Use the 1-loop mixing matrices calculated at M_SUSY in the vertices --- 
ZA = ZAinput 
ZH = ZHinput 
ZP = ZPinput 
ZW = ZWinput 
ZZ = ZZinput 
End if 
If (PoleMassesInLoops) Then 
! --- Use the pole masses --- 
MAh = MAhinput 
MAh2 = MAh2input 
MFd = MFdinput 
MFd2 = MFd2input 
MFe = MFeinput 
MFe2 = MFe2input 
MFu = MFuinput 
MFu2 = MFu2input 
MHap = MHapinput 
MHap2 = MHap2input 
Mhha = Mhhainput 
Mhha2 = Mhha2input 
MHhSM = MHhSMinput 
MHhSM2 = MHhSM2input 
MHp = MHpinput 
MHp2 = MHp2input 
Msiga = Msigainput 
Msiga2 = Msiga2input 
MVWp = MVWpinput 
MVWp2 = MVWp2input 
MVZ = MVZinput 
MVZ2 = MVZ2input 
v = vinput 
betaH = betaHinput 
End if 
cplcFuFuAhL = 0._dp 
cplcFuFuAhR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFuFuAhT(gt1,gt2,gt3,Yu,ZA,ZUL,ZUR,cplcFuFuAhL(gt1,gt2,gt3)              & 
& ,cplcFuFuAhR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFuFdHpL = 0._dp 
cplcFuFdHpR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFuFdHpT(gt1,gt2,gt3,Yu,Yd,ZP,ZDL,ZDR,ZUL,ZUR,cplcFuFdHpL(gt1,gt2,gt3)   & 
& ,cplcFuFdHpR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFuFuHhSML = 0._dp 
cplcFuFuHhSMR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFuFuHhSMT(gt1,gt2,gt3,Yu,ZH,ZUL,ZUR,cplcFuFuHhSML(gt1,gt2,gt3)          & 
& ,cplcFuFuHhSMR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFuFdVWpL = 0._dp 
cplcFuFdVWpR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFuFdVWpT(gt1,gt2,g2,ZDL,ZUL,cplcFuFdVWpL(gt1,gt2),cplcFuFdVWpR(gt1,gt2))

 End Do 
End Do 


cplcFuFuVZL = 0._dp 
cplcFuFuVZR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFuFuVZT(gt1,gt2,g1,g2,TW,cplcFuFuVZL(gt1,gt2),cplcFuFuVZR(gt1,gt2))

 End Do 
End Do 


Iname = Iname - 1 
 
End subroutine CouplingsFor_Fu_decays_2B
 
Subroutine CouplingsFor_Fe_decays_2B(m_in,i1,MAhinput,MAh2input,MFdinput,             & 
& MFd2input,MFeinput,MFe2input,MFuinput,MFu2input,MHapinput,MHap2input,Mhhainput,        & 
& Mhha2input,MHhSMinput,MHhSM2input,MHpinput,MHp2input,Msigainput,Msiga2input,           & 
& MVWpinput,MVWp2input,MVZinput,MVZ2input,TWinput,ZDRinput,ZERinput,ZURinput,            & 
& vinput,ZDLinput,ZELinput,ZULinput,ZAinput,ZHinput,ZPinput,ZWinput,ZZinput,             & 
& betaHinput,g1input,g2input,g3input,lam1input,lam3input,lam4input,lam2input,            & 
& lam12input,lam7input,lam11input,lam10input,lam13input,lam6input,lam14input,            & 
& lam5input,lam8input,Yuinput,Ydinput,Yeinput,mu1input,mu2input,mu0input,v1input,        & 
& v2input,cplcFeFeAhL,cplcFeFeAhR,cplcFeFeHhSML,cplcFeFeHhSMR,cplcFeFeVZL,               & 
& cplcFeFeVZR,cplcFeFvcHpL,cplcFeFvcHpR,cplcFeFvcVWpL,cplcFeFvcVWpR,deltaM)

Implicit None 

Real(dp), Intent(in) :: m_in 
Real(dp), Intent(in) :: deltaM 
Integer, Intent(in) :: i1 
Real(dp),Intent(in) :: g1input,g2input,g3input,lam1input,lam3input,lam4input,lam2input,lam12input,           & 
& lam7input,lam11input,lam10input,lam13input,lam6input,lam14input,lam5input,             & 
& lam8input,mu1input,mu2input,mu0input,v1input,v2input

Complex(dp),Intent(in) :: Yuinput(3,3),Ydinput(3,3),Yeinput(3,3)

Real(dp),Intent(in) :: MAhinput(3),MAh2input(3),MFdinput(3),MFd2input(3),MFeinput(3),MFe2input(3),           & 
& MFuinput(3),MFu2input(3),MHapinput,MHap2input,Mhhainput,Mhha2input,MHhSMinput(3),      & 
& MHhSM2input(3),MHpinput(3),MHp2input(3),Msigainput,Msiga2input,MVWpinput,              & 
& MVWp2input,MVZinput,MVZ2input,TWinput,vinput,ZAinput(3,3),ZHinput(3,3),ZPinput(3,3),   & 
& ZZinput(2,2),betaHinput

Complex(dp),Intent(in) :: ZDRinput(3,3),ZERinput(3,3),ZURinput(3,3),ZDLinput(3,3),ZELinput(3,3),ZULinput(3,3),  & 
& ZWinput(2,2)

Real(dp) :: g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,            & 
& lam8,mu1,mu2,mu0,v1,v2

Complex(dp) :: Yu(3,3),Yd(3,3),Ye(3,3)

Complex(dp),Intent(out) :: cplcFeFeAhL(3,3,3),cplcFeFeAhR(3,3,3),cplcFeFeHhSML(3,3,3),cplcFeFeHhSMR(3,3,3),      & 
& cplcFeFeVZL(3,3),cplcFeFeVZR(3,3),cplcFeFvcHpL(3,3,3),cplcFeFvcHpR(3,3,3),             & 
& cplcFeFvcVWpL(3,3),cplcFeFvcVWpR(3,3)

Integer :: i2, i3, gt1, gt2, gt3, kont 
Real(dp) :: MAh(3),MAh2(3),MFd(3),MFd2(3),MFe(3),MFe2(3),MFu(3),MFu2(3),MHap,MHap2,               & 
& Mhha,Mhha2,MHhSM(3),MHhSM2(3),MHp(3),MHp2(3),Msiga,Msiga2,MVWp,MVWp2,MVZ,              & 
& MVZ2,TW,v,ZA(3,3),ZH(3,3),ZP(3,3),ZZ(2,2),betaH

Complex(dp) :: ZDR(3,3),ZER(3,3),ZUR(3,3),ZDL(3,3),ZEL(3,3),ZUL(3,3),ZW(2,2)

Real(dp) :: gSM(11), sinW2, dt, tz, Qin 
Iname = Iname + 1 
NameOfUnit(Iname) = 'Couplings_Fe_2B'
 
sinW2=1._dp-mW2/mZ2 
g1 = g1input 
g2 = g2input 
g3 = g3input 
lam1 = lam1input 
lam3 = lam3input 
lam4 = lam4input 
lam2 = lam2input 
lam12 = lam12input 
lam7 = lam7input 
lam11 = lam11input 
lam10 = lam10input 
lam13 = lam13input 
lam6 = lam6input 
lam14 = lam14input 
lam5 = lam5input 
lam8 = lam8input 
Yu = Yuinput 
Yd = Ydinput 
Ye = Yeinput 
mu1 = mu1input 
mu2 = mu2input 
mu0 = mu0input 
v1 = v1input 
v2 = v2input 
Qin=sqrt(getRenormalizationScale()) 
If (m_in.le.Qin) Then 
  If (m_in.le.mz) Then 
    Call RunSM(mz,deltaM,v2/v1,g1,g2,g3,Yu,Yd,Ye,v1,v2) 
  Else 
    Call RunSM(m_in,deltaM,v2/v1,g1,g2,g3,Yu,Yd,Ye,v1,v2) 
  End if 
End if 
Call SolveTadpoleEquations(g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,             & 
& lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,v1,v2,(/ ZeroC, ZeroC, ZeroC, ZeroC /))

! --- Calculate running tree-level masses for loop induced couplings and Quark mixing matrices --- 
Call TreeMasses(MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,MHap2,Mhha,Mhha2,            & 
& MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,ZER,ZUR,v,               & 
& ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,v1,v2,g1,g2,g3,lam1,lam3,lam4,lam2,lam12,             & 
& lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,.True.,kont)

If (ExternalZfactors) Then 
! --- Use the 1-loop mixing matrices calculated at M_SUSY in the vertices --- 
ZA = ZAinput 
ZH = ZHinput 
ZP = ZPinput 
ZW = ZWinput 
ZZ = ZZinput 
End if 
If (PoleMassesInLoops) Then 
! --- Use the pole masses --- 
MAh = MAhinput 
MAh2 = MAh2input 
MFd = MFdinput 
MFd2 = MFd2input 
MFe = MFeinput 
MFe2 = MFe2input 
MFu = MFuinput 
MFu2 = MFu2input 
MHap = MHapinput 
MHap2 = MHap2input 
Mhha = Mhhainput 
Mhha2 = Mhha2input 
MHhSM = MHhSMinput 
MHhSM2 = MHhSM2input 
MHp = MHpinput 
MHp2 = MHp2input 
Msiga = Msigainput 
Msiga2 = Msiga2input 
MVWp = MVWpinput 
MVWp2 = MVWp2input 
MVZ = MVZinput 
MVZ2 = MVZ2input 
v = vinput 
betaH = betaHinput 
End if 
cplcFeFeAhL = 0._dp 
cplcFeFeAhR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFeFeAhT(gt1,gt2,gt3,Ye,ZA,ZEL,ZER,cplcFeFeAhL(gt1,gt2,gt3)              & 
& ,cplcFeFeAhR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFeFeHhSML = 0._dp 
cplcFeFeHhSMR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFeFeHhSMT(gt1,gt2,gt3,Ye,ZH,ZEL,ZER,cplcFeFeHhSML(gt1,gt2,gt3)          & 
& ,cplcFeFeHhSMR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFeFvcHpL = 0._dp 
cplcFeFvcHpR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFeFvcHpT(gt1,gt2,gt3,Ye,ZP,ZER,cplcFeFvcHpL(gt1,gt2,gt3),               & 
& cplcFeFvcHpR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFeFeVZL = 0._dp 
cplcFeFeVZR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFeFeVZT(gt1,gt2,g1,g2,TW,cplcFeFeVZL(gt1,gt2),cplcFeFeVZR(gt1,gt2))

 End Do 
End Do 


cplcFeFvcVWpL = 0._dp 
cplcFeFvcVWpR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFeFvcVWpT(gt1,gt2,g2,ZEL,cplcFeFvcVWpL(gt1,gt2),cplcFeFvcVWpR(gt1,gt2))

 End Do 
End Do 


Iname = Iname - 1 
 
End subroutine CouplingsFor_Fe_decays_2B
 
Subroutine CouplingsFor_Fd_decays_2B(m_in,i1,MAhinput,MAh2input,MFdinput,             & 
& MFd2input,MFeinput,MFe2input,MFuinput,MFu2input,MHapinput,MHap2input,Mhhainput,        & 
& Mhha2input,MHhSMinput,MHhSM2input,MHpinput,MHp2input,Msigainput,Msiga2input,           & 
& MVWpinput,MVWp2input,MVZinput,MVZ2input,TWinput,ZDRinput,ZERinput,ZURinput,            & 
& vinput,ZDLinput,ZELinput,ZULinput,ZAinput,ZHinput,ZPinput,ZWinput,ZZinput,             & 
& betaHinput,g1input,g2input,g3input,lam1input,lam3input,lam4input,lam2input,            & 
& lam12input,lam7input,lam11input,lam10input,lam13input,lam6input,lam14input,            & 
& lam5input,lam8input,Yuinput,Ydinput,Yeinput,mu1input,mu2input,mu0input,v1input,        & 
& v2input,cplcFdFdAhL,cplcFdFdAhR,cplcFdFdHhSML,cplcFdFdHhSMR,cplcFdFdVZL,               & 
& cplcFdFdVZR,cplcFdFucHpL,cplcFdFucHpR,cplcFdFucVWpL,cplcFdFucVWpR,deltaM)

Implicit None 

Real(dp), Intent(in) :: m_in 
Real(dp), Intent(in) :: deltaM 
Integer, Intent(in) :: i1 
Real(dp),Intent(in) :: g1input,g2input,g3input,lam1input,lam3input,lam4input,lam2input,lam12input,           & 
& lam7input,lam11input,lam10input,lam13input,lam6input,lam14input,lam5input,             & 
& lam8input,mu1input,mu2input,mu0input,v1input,v2input

Complex(dp),Intent(in) :: Yuinput(3,3),Ydinput(3,3),Yeinput(3,3)

Real(dp),Intent(in) :: MAhinput(3),MAh2input(3),MFdinput(3),MFd2input(3),MFeinput(3),MFe2input(3),           & 
& MFuinput(3),MFu2input(3),MHapinput,MHap2input,Mhhainput,Mhha2input,MHhSMinput(3),      & 
& MHhSM2input(3),MHpinput(3),MHp2input(3),Msigainput,Msiga2input,MVWpinput,              & 
& MVWp2input,MVZinput,MVZ2input,TWinput,vinput,ZAinput(3,3),ZHinput(3,3),ZPinput(3,3),   & 
& ZZinput(2,2),betaHinput

Complex(dp),Intent(in) :: ZDRinput(3,3),ZERinput(3,3),ZURinput(3,3),ZDLinput(3,3),ZELinput(3,3),ZULinput(3,3),  & 
& ZWinput(2,2)

Real(dp) :: g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,            & 
& lam8,mu1,mu2,mu0,v1,v2

Complex(dp) :: Yu(3,3),Yd(3,3),Ye(3,3)

Complex(dp),Intent(out) :: cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFdFdHhSML(3,3,3),cplcFdFdHhSMR(3,3,3),      & 
& cplcFdFdVZL(3,3),cplcFdFdVZR(3,3),cplcFdFucHpL(3,3,3),cplcFdFucHpR(3,3,3),             & 
& cplcFdFucVWpL(3,3),cplcFdFucVWpR(3,3)

Integer :: i2, i3, gt1, gt2, gt3, kont 
Real(dp) :: MAh(3),MAh2(3),MFd(3),MFd2(3),MFe(3),MFe2(3),MFu(3),MFu2(3),MHap,MHap2,               & 
& Mhha,Mhha2,MHhSM(3),MHhSM2(3),MHp(3),MHp2(3),Msiga,Msiga2,MVWp,MVWp2,MVZ,              & 
& MVZ2,TW,v,ZA(3,3),ZH(3,3),ZP(3,3),ZZ(2,2),betaH

Complex(dp) :: ZDR(3,3),ZER(3,3),ZUR(3,3),ZDL(3,3),ZEL(3,3),ZUL(3,3),ZW(2,2)

Real(dp) :: gSM(11), sinW2, dt, tz, Qin 
Iname = Iname + 1 
NameOfUnit(Iname) = 'Couplings_Fd_2B'
 
sinW2=1._dp-mW2/mZ2 
g1 = g1input 
g2 = g2input 
g3 = g3input 
lam1 = lam1input 
lam3 = lam3input 
lam4 = lam4input 
lam2 = lam2input 
lam12 = lam12input 
lam7 = lam7input 
lam11 = lam11input 
lam10 = lam10input 
lam13 = lam13input 
lam6 = lam6input 
lam14 = lam14input 
lam5 = lam5input 
lam8 = lam8input 
Yu = Yuinput 
Yd = Ydinput 
Ye = Yeinput 
mu1 = mu1input 
mu2 = mu2input 
mu0 = mu0input 
v1 = v1input 
v2 = v2input 
Qin=sqrt(getRenormalizationScale()) 
If (m_in.le.Qin) Then 
  If (m_in.le.mz) Then 
    Call RunSM(mz,deltaM,v2/v1,g1,g2,g3,Yu,Yd,Ye,v1,v2) 
  Else 
    Call RunSM(m_in,deltaM,v2/v1,g1,g2,g3,Yu,Yd,Ye,v1,v2) 
  End if 
End if 
Call SolveTadpoleEquations(g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,             & 
& lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,v1,v2,(/ ZeroC, ZeroC, ZeroC, ZeroC /))

! --- Calculate running tree-level masses for loop induced couplings and Quark mixing matrices --- 
Call TreeMasses(MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,MHap2,Mhha,Mhha2,            & 
& MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,ZER,ZUR,v,               & 
& ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,v1,v2,g1,g2,g3,lam1,lam3,lam4,lam2,lam12,             & 
& lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,.True.,kont)

If (ExternalZfactors) Then 
! --- Use the 1-loop mixing matrices calculated at M_SUSY in the vertices --- 
ZA = ZAinput 
ZH = ZHinput 
ZP = ZPinput 
ZW = ZWinput 
ZZ = ZZinput 
End if 
If (PoleMassesInLoops) Then 
! --- Use the pole masses --- 
MAh = MAhinput 
MAh2 = MAh2input 
MFd = MFdinput 
MFd2 = MFd2input 
MFe = MFeinput 
MFe2 = MFe2input 
MFu = MFuinput 
MFu2 = MFu2input 
MHap = MHapinput 
MHap2 = MHap2input 
Mhha = Mhhainput 
Mhha2 = Mhha2input 
MHhSM = MHhSMinput 
MHhSM2 = MHhSM2input 
MHp = MHpinput 
MHp2 = MHp2input 
Msiga = Msigainput 
Msiga2 = Msiga2input 
MVWp = MVWpinput 
MVWp2 = MVWp2input 
MVZ = MVZinput 
MVZ2 = MVZ2input 
v = vinput 
betaH = betaHinput 
End if 
cplcFdFdAhL = 0._dp 
cplcFdFdAhR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFdFdAhT(gt1,gt2,gt3,Yd,ZA,ZDL,ZDR,cplcFdFdAhL(gt1,gt2,gt3)              & 
& ,cplcFdFdAhR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFdFdHhSML = 0._dp 
cplcFdFdHhSMR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFdFdHhSMT(gt1,gt2,gt3,Yd,ZH,ZDL,ZDR,cplcFdFdHhSML(gt1,gt2,gt3)          & 
& ,cplcFdFdHhSMR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFdFucHpL = 0._dp 
cplcFdFucHpR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFdFucHpT(gt1,gt2,gt3,Yu,Yd,ZP,ZDL,ZDR,ZUL,ZUR,cplcFdFucHpL(gt1,gt2,gt3) & 
& ,cplcFdFucHpR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFdFdVZL = 0._dp 
cplcFdFdVZR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFdFdVZT(gt1,gt2,g1,g2,TW,cplcFdFdVZL(gt1,gt2),cplcFdFdVZR(gt1,gt2))

 End Do 
End Do 


cplcFdFucVWpL = 0._dp 
cplcFdFucVWpR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFdFucVWpT(gt1,gt2,g2,ZDL,ZUL,cplcFdFucVWpL(gt1,gt2),cplcFdFucVWpR(gt1,gt2))

 End Do 
End Do 


Iname = Iname - 1 
 
End subroutine CouplingsFor_Fd_decays_2B
 
Subroutine CouplingsFor_VZ_decays_2B(m_in,i1,MAhinput,MAh2input,MFdinput,             & 
& MFd2input,MFeinput,MFe2input,MFuinput,MFu2input,MHapinput,MHap2input,Mhhainput,        & 
& Mhha2input,MHhSMinput,MHhSM2input,MHpinput,MHp2input,Msigainput,Msiga2input,           & 
& MVWpinput,MVWp2input,MVZinput,MVZ2input,TWinput,ZDRinput,ZERinput,ZURinput,            & 
& vinput,ZDLinput,ZELinput,ZULinput,ZAinput,ZHinput,ZPinput,ZWinput,ZZinput,             & 
& betaHinput,g1input,g2input,g3input,lam1input,lam3input,lam4input,lam2input,            & 
& lam12input,lam7input,lam11input,lam10input,lam13input,lam6input,lam14input,            & 
& lam5input,lam8input,Yuinput,Ydinput,Yeinput,mu1input,mu2input,mu0input,v1input,        & 
& v2input,cplAhHhSMVZ,cplcFdFdVZL,cplcFdFdVZR,cplcFeFeVZL,cplcFeFeVZR,cplcFuFuVZL,       & 
& cplcFuFuVZR,cplcFvFvVZL,cplcFvFvVZR,cplHapcHapVZ,cplhhasigaVZ,cplHhSMVZVZ,             & 
& cplHpcHpVZ,cplHpcVWpVZ,cplcVWpVWpVZ,deltaM)

Implicit None 

Real(dp), Intent(in) :: m_in 
Real(dp), Intent(in) :: deltaM 
Integer, Intent(in) :: i1 
Real(dp),Intent(in) :: g1input,g2input,g3input,lam1input,lam3input,lam4input,lam2input,lam12input,           & 
& lam7input,lam11input,lam10input,lam13input,lam6input,lam14input,lam5input,             & 
& lam8input,mu1input,mu2input,mu0input,v1input,v2input

Complex(dp),Intent(in) :: Yuinput(3,3),Ydinput(3,3),Yeinput(3,3)

Real(dp),Intent(in) :: MAhinput(3),MAh2input(3),MFdinput(3),MFd2input(3),MFeinput(3),MFe2input(3),           & 
& MFuinput(3),MFu2input(3),MHapinput,MHap2input,Mhhainput,Mhha2input,MHhSMinput(3),      & 
& MHhSM2input(3),MHpinput(3),MHp2input(3),Msigainput,Msiga2input,MVWpinput,              & 
& MVWp2input,MVZinput,MVZ2input,TWinput,vinput,ZAinput(3,3),ZHinput(3,3),ZPinput(3,3),   & 
& ZZinput(2,2),betaHinput

Complex(dp),Intent(in) :: ZDRinput(3,3),ZERinput(3,3),ZURinput(3,3),ZDLinput(3,3),ZELinput(3,3),ZULinput(3,3),  & 
& ZWinput(2,2)

Real(dp) :: g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,            & 
& lam8,mu1,mu2,mu0,v1,v2

Complex(dp) :: Yu(3,3),Yd(3,3),Ye(3,3)

Complex(dp),Intent(out) :: cplAhHhSMVZ(3,3),cplcFdFdVZL(3,3),cplcFdFdVZR(3,3),cplcFeFeVZL(3,3),cplcFeFeVZR(3,3), & 
& cplcFuFuVZL(3,3),cplcFuFuVZR(3,3),cplcFvFvVZL(3,3),cplcFvFvVZR(3,3),cplHapcHapVZ,      & 
& cplhhasigaVZ,cplHhSMVZVZ(3),cplHpcHpVZ(3,3),cplHpcVWpVZ(3),cplcVWpVWpVZ

Integer :: i2, i3, gt1, gt2, gt3, kont 
Real(dp) :: MAh(3),MAh2(3),MFd(3),MFd2(3),MFe(3),MFe2(3),MFu(3),MFu2(3),MHap,MHap2,               & 
& Mhha,Mhha2,MHhSM(3),MHhSM2(3),MHp(3),MHp2(3),Msiga,Msiga2,MVWp,MVWp2,MVZ,              & 
& MVZ2,TW,v,ZA(3,3),ZH(3,3),ZP(3,3),ZZ(2,2),betaH

Complex(dp) :: ZDR(3,3),ZER(3,3),ZUR(3,3),ZDL(3,3),ZEL(3,3),ZUL(3,3),ZW(2,2)

Real(dp) :: gSM(11), sinW2, dt, tz, Qin 
Iname = Iname + 1 
NameOfUnit(Iname) = 'Couplings_VZ_2B'
 
sinW2=1._dp-mW2/mZ2 
g1 = g1input 
g2 = g2input 
g3 = g3input 
lam1 = lam1input 
lam3 = lam3input 
lam4 = lam4input 
lam2 = lam2input 
lam12 = lam12input 
lam7 = lam7input 
lam11 = lam11input 
lam10 = lam10input 
lam13 = lam13input 
lam6 = lam6input 
lam14 = lam14input 
lam5 = lam5input 
lam8 = lam8input 
Yu = Yuinput 
Yd = Ydinput 
Ye = Yeinput 
mu1 = mu1input 
mu2 = mu2input 
mu0 = mu0input 
v1 = v1input 
v2 = v2input 
Qin=sqrt(getRenormalizationScale()) 
If (m_in.le.Qin) Then 
  If (m_in.le.mz) Then 
    Call RunSM(mz,deltaM,v2/v1,g1,g2,g3,Yu,Yd,Ye,v1,v2) 
  Else 
    Call RunSM(m_in,deltaM,v2/v1,g1,g2,g3,Yu,Yd,Ye,v1,v2) 
  End if 
End if 
Call SolveTadpoleEquations(g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,             & 
& lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,v1,v2,(/ ZeroC, ZeroC, ZeroC, ZeroC /))

! --- Calculate running tree-level masses for loop induced couplings and Quark mixing matrices --- 
Call TreeMasses(MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,MHap2,Mhha,Mhha2,            & 
& MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,ZER,ZUR,v,               & 
& ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,v1,v2,g1,g2,g3,lam1,lam3,lam4,lam2,lam12,             & 
& lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,.True.,kont)

If (ExternalZfactors) Then 
! --- Use the 1-loop mixing matrices calculated at M_SUSY in the vertices --- 
ZA = ZAinput 
ZH = ZHinput 
ZP = ZPinput 
ZW = ZWinput 
ZZ = ZZinput 
End if 
If (PoleMassesInLoops) Then 
! --- Use the pole masses --- 
MAh = MAhinput 
MAh2 = MAh2input 
MFd = MFdinput 
MFd2 = MFd2input 
MFe = MFeinput 
MFe2 = MFe2input 
MFu = MFuinput 
MFu2 = MFu2input 
MHap = MHapinput 
MHap2 = MHap2input 
Mhha = Mhhainput 
Mhha2 = Mhha2input 
MHhSM = MHhSMinput 
MHhSM2 = MHhSM2input 
MHp = MHpinput 
MHp2 = MHp2input 
Msiga = Msigainput 
Msiga2 = Msiga2input 
MVWp = MVWpinput 
MVWp2 = MVWp2input 
MVZ = MVZinput 
MVZ2 = MVZ2input 
v = vinput 
betaH = betaHinput 
End if 
cplAhHhSMVZ = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingAhHhSMVZT(gt1,gt2,g1,g2,ZH,ZA,TW,cplAhHhSMVZ(gt1,gt2))

 End Do 
End Do 


cplHapcHapVZ = 0._dp 
Call CouplingHapcHapVZT(g1,g2,TW,cplHapcHapVZ)



cplhhasigaVZ = 0._dp 
Call CouplinghhasigaVZT(g1,g2,TW,cplhhasigaVZ)



cplHpcHpVZ = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingHpcHpVZT(gt1,gt2,g1,g2,ZP,TW,cplHpcHpVZ(gt1,gt2))

 End Do 
End Do 


cplHhSMVZVZ = 0._dp 
Do gt1 = 1, 3
Call CouplingHhSMVZVZT(gt1,g1,g2,v1,v2,ZH,TW,cplHhSMVZVZ(gt1))

End Do 


cplHpcVWpVZ = 0._dp 
Do gt1 = 1, 3
Call CouplingHpcVWpVZT(gt1,g1,g2,v1,v2,ZP,TW,cplHpcVWpVZ(gt1))

End Do 


cplcVWpVWpVZ = 0._dp 
Call CouplingcVWpVWpVZT(g2,TW,cplcVWpVWpVZ)



cplcFdFdVZL = 0._dp 
cplcFdFdVZR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFdFdVZT(gt1,gt2,g1,g2,TW,cplcFdFdVZL(gt1,gt2),cplcFdFdVZR(gt1,gt2))

 End Do 
End Do 


cplcFeFeVZL = 0._dp 
cplcFeFeVZR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFeFeVZT(gt1,gt2,g1,g2,TW,cplcFeFeVZL(gt1,gt2),cplcFeFeVZR(gt1,gt2))

 End Do 
End Do 


cplcFuFuVZL = 0._dp 
cplcFuFuVZR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFuFuVZT(gt1,gt2,g1,g2,TW,cplcFuFuVZL(gt1,gt2),cplcFuFuVZR(gt1,gt2))

 End Do 
End Do 


cplcFvFvVZL = 0._dp 
cplcFvFvVZR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFvFvVZT(gt1,gt2,g1,g2,TW,cplcFvFvVZL(gt1,gt2),cplcFvFvVZR(gt1,gt2))

 End Do 
End Do 


Iname = Iname - 1 
 
End subroutine CouplingsFor_VZ_decays_2B
 
Subroutine CouplingsFor_VWp_decays_2B(m_in,i1,MAhinput,MAh2input,MFdinput,            & 
& MFd2input,MFeinput,MFe2input,MFuinput,MFu2input,MHapinput,MHap2input,Mhhainput,        & 
& Mhha2input,MHhSMinput,MHhSM2input,MHpinput,MHp2input,Msigainput,Msiga2input,           & 
& MVWpinput,MVWp2input,MVZinput,MVZ2input,TWinput,ZDRinput,ZERinput,ZURinput,            & 
& vinput,ZDLinput,ZELinput,ZULinput,ZAinput,ZHinput,ZPinput,ZWinput,ZZinput,             & 
& betaHinput,g1input,g2input,g3input,lam1input,lam3input,lam4input,lam2input,            & 
& lam12input,lam7input,lam11input,lam10input,lam13input,lam6input,lam14input,            & 
& lam5input,lam8input,Yuinput,Ydinput,Yeinput,mu1input,mu2input,mu0input,v1input,        & 
& v2input,cplAhHpcVWp,cplcFdFucVWpL,cplcFdFucVWpR,cplcFeFvcVWpL,cplcFeFvcVWpR,           & 
& cplHaphhacVWp,cplHapsigacVWp,cplHhSMHpcVWp,cplHhSMcVWpVWp,cplHpcVWpVZ,cplcVWpVWpVZ,deltaM)

Implicit None 

Real(dp), Intent(in) :: m_in 
Real(dp), Intent(in) :: deltaM 
Integer, Intent(in) :: i1 
Real(dp),Intent(in) :: g1input,g2input,g3input,lam1input,lam3input,lam4input,lam2input,lam12input,           & 
& lam7input,lam11input,lam10input,lam13input,lam6input,lam14input,lam5input,             & 
& lam8input,mu1input,mu2input,mu0input,v1input,v2input

Complex(dp),Intent(in) :: Yuinput(3,3),Ydinput(3,3),Yeinput(3,3)

Real(dp),Intent(in) :: MAhinput(3),MAh2input(3),MFdinput(3),MFd2input(3),MFeinput(3),MFe2input(3),           & 
& MFuinput(3),MFu2input(3),MHapinput,MHap2input,Mhhainput,Mhha2input,MHhSMinput(3),      & 
& MHhSM2input(3),MHpinput(3),MHp2input(3),Msigainput,Msiga2input,MVWpinput,              & 
& MVWp2input,MVZinput,MVZ2input,TWinput,vinput,ZAinput(3,3),ZHinput(3,3),ZPinput(3,3),   & 
& ZZinput(2,2),betaHinput

Complex(dp),Intent(in) :: ZDRinput(3,3),ZERinput(3,3),ZURinput(3,3),ZDLinput(3,3),ZELinput(3,3),ZULinput(3,3),  & 
& ZWinput(2,2)

Real(dp) :: g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,            & 
& lam8,mu1,mu2,mu0,v1,v2

Complex(dp) :: Yu(3,3),Yd(3,3),Ye(3,3)

Complex(dp),Intent(out) :: cplAhHpcVWp(3,3),cplcFdFucVWpL(3,3),cplcFdFucVWpR(3,3),cplcFeFvcVWpL(3,3),            & 
& cplcFeFvcVWpR(3,3),cplHaphhacVWp,cplHapsigacVWp,cplHhSMHpcVWp(3,3),cplHhSMcVWpVWp(3),  & 
& cplHpcVWpVZ(3),cplcVWpVWpVZ

Integer :: i2, i3, gt1, gt2, gt3, kont 
Real(dp) :: MAh(3),MAh2(3),MFd(3),MFd2(3),MFe(3),MFe2(3),MFu(3),MFu2(3),MHap,MHap2,               & 
& Mhha,Mhha2,MHhSM(3),MHhSM2(3),MHp(3),MHp2(3),Msiga,Msiga2,MVWp,MVWp2,MVZ,              & 
& MVZ2,TW,v,ZA(3,3),ZH(3,3),ZP(3,3),ZZ(2,2),betaH

Complex(dp) :: ZDR(3,3),ZER(3,3),ZUR(3,3),ZDL(3,3),ZEL(3,3),ZUL(3,3),ZW(2,2)

Real(dp) :: gSM(11), sinW2, dt, tz, Qin 
Iname = Iname + 1 
NameOfUnit(Iname) = 'Couplings_VWp_2B'
 
sinW2=1._dp-mW2/mZ2 
g1 = g1input 
g2 = g2input 
g3 = g3input 
lam1 = lam1input 
lam3 = lam3input 
lam4 = lam4input 
lam2 = lam2input 
lam12 = lam12input 
lam7 = lam7input 
lam11 = lam11input 
lam10 = lam10input 
lam13 = lam13input 
lam6 = lam6input 
lam14 = lam14input 
lam5 = lam5input 
lam8 = lam8input 
Yu = Yuinput 
Yd = Ydinput 
Ye = Yeinput 
mu1 = mu1input 
mu2 = mu2input 
mu0 = mu0input 
v1 = v1input 
v2 = v2input 
Qin=sqrt(getRenormalizationScale()) 
If (m_in.le.Qin) Then 
  If (m_in.le.mz) Then 
    Call RunSM(mz,deltaM,v2/v1,g1,g2,g3,Yu,Yd,Ye,v1,v2) 
  Else 
    Call RunSM(m_in,deltaM,v2/v1,g1,g2,g3,Yu,Yd,Ye,v1,v2) 
  End if 
End if 
Call SolveTadpoleEquations(g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,             & 
& lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,v1,v2,(/ ZeroC, ZeroC, ZeroC, ZeroC /))

! --- Calculate running tree-level masses for loop induced couplings and Quark mixing matrices --- 
Call TreeMasses(MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,MHap2,Mhha,Mhha2,            & 
& MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,ZER,ZUR,v,               & 
& ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,v1,v2,g1,g2,g3,lam1,lam3,lam4,lam2,lam12,             & 
& lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,.True.,kont)

If (ExternalZfactors) Then 
! --- Use the 1-loop mixing matrices calculated at M_SUSY in the vertices --- 
ZA = ZAinput 
ZH = ZHinput 
ZP = ZPinput 
ZW = ZWinput 
ZZ = ZZinput 
End if 
If (PoleMassesInLoops) Then 
! --- Use the pole masses --- 
MAh = MAhinput 
MAh2 = MAh2input 
MFd = MFdinput 
MFd2 = MFd2input 
MFe = MFeinput 
MFe2 = MFe2input 
MFu = MFuinput 
MFu2 = MFu2input 
MHap = MHapinput 
MHap2 = MHap2input 
Mhha = Mhhainput 
Mhha2 = Mhha2input 
MHhSM = MHhSMinput 
MHhSM2 = MHhSM2input 
MHp = MHpinput 
MHp2 = MHp2input 
Msiga = Msigainput 
Msiga2 = Msiga2input 
MVWp = MVWpinput 
MVWp2 = MVWp2input 
MVZ = MVZinput 
MVZ2 = MVZ2input 
v = vinput 
betaH = betaHinput 
End if 
cplAhHpcVWp = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingAhHpcVWpT(gt1,gt2,g2,ZA,ZP,cplAhHpcVWp(gt1,gt2))

 End Do 
End Do 


cplHaphhacVWp = 0._dp 
Call CouplingHaphhacVWpT(g2,cplHaphhacVWp)



cplHapsigacVWp = 0._dp 
Call CouplingHapsigacVWpT(g2,cplHapsigacVWp)



cplHhSMHpcVWp = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingHhSMHpcVWpT(gt1,gt2,g2,ZH,ZP,cplHhSMHpcVWp(gt1,gt2))

 End Do 
End Do 


cplHhSMcVWpVWp = 0._dp 
Do gt1 = 1, 3
Call CouplingHhSMcVWpVWpT(gt1,g2,v1,v2,ZH,cplHhSMcVWpVWp(gt1))

End Do 


cplHpcVWpVZ = 0._dp 
Do gt1 = 1, 3
Call CouplingHpcVWpVZT(gt1,g1,g2,v1,v2,ZP,TW,cplHpcVWpVZ(gt1))

End Do 


cplcVWpVWpVZ = 0._dp 
Call CouplingcVWpVWpVZT(g2,TW,cplcVWpVWpVZ)



cplcFdFucVWpL = 0._dp 
cplcFdFucVWpR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFdFucVWpT(gt1,gt2,g2,ZDL,ZUL,cplcFdFucVWpL(gt1,gt2),cplcFdFucVWpR(gt1,gt2))

 End Do 
End Do 


cplcFeFvcVWpL = 0._dp 
cplcFeFvcVWpR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFeFvcVWpT(gt1,gt2,g2,ZEL,cplcFeFvcVWpL(gt1,gt2),cplcFeFvcVWpR(gt1,gt2))

 End Do 
End Do 


Iname = Iname - 1 
 
End subroutine CouplingsFor_VWp_decays_2B
 
Subroutine CouplingsFor_HhSM_decays_2B(m_in,i1,MAhinput,MAh2input,MFdinput,           & 
& MFd2input,MFeinput,MFe2input,MFuinput,MFu2input,MHapinput,MHap2input,Mhhainput,        & 
& Mhha2input,MHhSMinput,MHhSM2input,MHpinput,MHp2input,Msigainput,Msiga2input,           & 
& MVWpinput,MVWp2input,MVZinput,MVZ2input,TWinput,ZDRinput,ZERinput,ZURinput,            & 
& vinput,ZDLinput,ZELinput,ZULinput,ZAinput,ZHinput,ZPinput,ZWinput,ZZinput,             & 
& betaHinput,g1input,g2input,g3input,lam1input,lam3input,lam4input,lam2input,            & 
& lam12input,lam7input,lam11input,lam10input,lam13input,lam6input,lam14input,            & 
& lam5input,lam8input,Yuinput,Ydinput,Yeinput,mu1input,mu2input,mu0input,v1input,        & 
& v2input,cplHiggsPP,cplHiggsGG,cplHiggsZZvirt,cplHiggsWWvirt,cplAhAhHhSM,               & 
& cplAhHhSMVZ,cplcFdFdHhSML,cplcFdFdHhSMR,cplcFeFeHhSML,cplcFeFeHhSMR,cplcFuFuHhSML,     & 
& cplcFuFuHhSMR,cplHapHhSMcHap,cplhhahhaHhSM,cplHhSMHhSMHhSM,cplHhSMHpcHp,               & 
& cplHhSMHpcVWp,cplHhSMsigasiga,cplHhSMcVWpVWp,cplHhSMVZVZ,deltaM)

Implicit None 

Real(dp), Intent(in) :: m_in 
Real(dp), Intent(in) :: deltaM 
Integer, Intent(in) :: i1 
Real(dp),Intent(in) :: g1input,g2input,g3input,lam1input,lam3input,lam4input,lam2input,lam12input,           & 
& lam7input,lam11input,lam10input,lam13input,lam6input,lam14input,lam5input,             & 
& lam8input,mu1input,mu2input,mu0input,v1input,v2input

Complex(dp),Intent(in) :: Yuinput(3,3),Ydinput(3,3),Yeinput(3,3)

Real(dp),Intent(in) :: MAhinput(3),MAh2input(3),MFdinput(3),MFd2input(3),MFeinput(3),MFe2input(3),           & 
& MFuinput(3),MFu2input(3),MHapinput,MHap2input,Mhhainput,Mhha2input,MHhSMinput(3),      & 
& MHhSM2input(3),MHpinput(3),MHp2input(3),Msigainput,Msiga2input,MVWpinput,              & 
& MVWp2input,MVZinput,MVZ2input,TWinput,vinput,ZAinput(3,3),ZHinput(3,3),ZPinput(3,3),   & 
& ZZinput(2,2),betaHinput

Complex(dp),Intent(in) :: ZDRinput(3,3),ZERinput(3,3),ZURinput(3,3),ZDLinput(3,3),ZELinput(3,3),ZULinput(3,3),  & 
& ZWinput(2,2)

Real(dp) :: g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,            & 
& lam8,mu1,mu2,mu0,v1,v2

Complex(dp) :: Yu(3,3),Yd(3,3),Ye(3,3)

Complex(dp),Intent(out) :: cplHiggsPP(3),cplHiggsGG(3),cplHiggsZZvirt(3),cplHiggsWWvirt(3),cplAhAhHhSM(3,3,3),   & 
& cplAhHhSMVZ(3,3),cplcFdFdHhSML(3,3,3),cplcFdFdHhSMR(3,3,3),cplcFeFeHhSML(3,3,3),       & 
& cplcFeFeHhSMR(3,3,3),cplcFuFuHhSML(3,3,3),cplcFuFuHhSMR(3,3,3),cplHapHhSMcHap(3),      & 
& cplhhahhaHhSM(3),cplHhSMHhSMHhSM(3,3,3),cplHhSMHpcHp(3,3,3),cplHhSMHpcVWp(3,3),        & 
& cplHhSMsigasiga(3),cplHhSMcVWpVWp(3),cplHhSMVZVZ(3)

Integer :: i2, i3, gt1, gt2, gt3, kont 
Real(dp) :: MAh(3),MAh2(3),MFd(3),MFd2(3),MFe(3),MFe2(3),MFu(3),MFu2(3),MHap,MHap2,               & 
& Mhha,Mhha2,MHhSM(3),MHhSM2(3),MHp(3),MHp2(3),Msiga,Msiga2,MVWp,MVWp2,MVZ,              & 
& MVZ2,TW,v,ZA(3,3),ZH(3,3),ZP(3,3),ZZ(2,2),betaH

Complex(dp) :: ZDR(3,3),ZER(3,3),ZUR(3,3),ZDL(3,3),ZEL(3,3),ZUL(3,3),ZW(2,2)

Complex(dp) :: ratFd(3),ratFe(3),ratFu(3),ratHap,ratHp(3),ratVWp

Complex(dp) :: ratPFd(3),ratPFe(3),ratPFu(3),ratPHap,ratPHp(3),ratPVWp

Complex(dp) :: coup 
Real(dp) :: vev, gNLO, NLOqcd, NNLOqcd, NNNLOqcd, AlphaSQ, AlphaSQhlf 
Real(dp) :: g1SM,g2SM,g3SM,vSM
Complex(dp) ::YuSM(3,3),YdSM(3,3),YeSM(3,3)
Real(dp) :: gSM(11), sinW2, dt, tz, Qin 
Iname = Iname + 1 
NameOfUnit(Iname) = 'Couplings_HhSM_2B'
 
sinW2=1._dp-mW2/mZ2 
g1 = g1input 
g2 = g2input 
g3 = g3input 
lam1 = lam1input 
lam3 = lam3input 
lam4 = lam4input 
lam2 = lam2input 
lam12 = lam12input 
lam7 = lam7input 
lam11 = lam11input 
lam10 = lam10input 
lam13 = lam13input 
lam6 = lam6input 
lam14 = lam14input 
lam5 = lam5input 
lam8 = lam8input 
Yu = Yuinput 
Yd = Ydinput 
Ye = Yeinput 
mu1 = mu1input 
mu2 = mu2input 
mu0 = mu0input 
v1 = v1input 
v2 = v2input 
Qin=sqrt(getRenormalizationScale()) 
If (m_in.le.Qin) Then 
  If (m_in.le.mz) Then 
    Call RunSM(mz,deltaM,v2/v1,g1,g2,g3,Yu,Yd,Ye,v1,v2) 
  Else 
    Call RunSM(m_in,deltaM,v2/v1,g1,g2,g3,Yu,Yd,Ye,v1,v2) 
  End if 
End if 
! Run always SM gauge couplings if present 
  Qin=sqrt(getRenormalizationScale()) 
  Call RunSMohdm(m_in,deltaM,g1SM,g2SM,g3SM,YuSM,YdSM,YeSM,vSM) 
   ! SM pole masses needed for diphoton/digluon rate 
   ! But only top and W play a role. 
   vSM=1/Sqrt((G_F*Sqrt(2._dp))) ! On-Shell VEV needed for loop 
   YuSM(3,3)=sqrt(2._dp)*mf_u(3)/vSM  ! On-Shell top needed in loop 
   ! Other running values kept to get H->ff correct 
Call SetMatchingConditions(g1SM,g2SM,g3SM,YuSM,YdSM,YeSM,vSM,v1,v2,g1,g2,             & 
& g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,              & 
& Yu,Yd,Ye,mu1,mu2,mu0,.False.)

! Run always SM gauge couplings if present 
! alphaS(mH/2) for NLO corrections to diphoton rate 
Call RunSMgauge(m_in/2._dp,deltaM, g1,g2,g3) 
AlphaSQhlf=g3**2/(4._dp*Pi) 
! alphaS(mH) for digluon rate 
Call RunSMgauge(m_in,deltaM, g1,g2,g3) 
AlphaSQ=g3**2/(4._dp*Pi) 
Call SolveTadpoleEquations(g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,             & 
& lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,v1,v2,(/ ZeroC, ZeroC, ZeroC, ZeroC /))

! --- Calculate running tree-level masses for loop induced couplings and Quark mixing matrices --- 
Call TreeMasses(MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,MHap2,Mhha,Mhha2,            & 
& MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,ZER,ZUR,v,               & 
& ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,v1,v2,g1,g2,g3,lam1,lam3,lam4,lam2,lam12,             & 
& lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,.True.,kont)

If (ExternalZfactors) Then 
! --- Use the 1-loop mixing matrices calculated at M_SUSY in the vertices --- 
ZA = ZAinput 
ZH = ZHinput 
ZP = ZPinput 
ZW = ZWinput 
ZZ = ZZinput 
End if 
cplAhAhHhSM = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingAhAhHhSMT(gt1,gt2,gt3,lam1,lam3,lam4,lam2,lam7,lam6,lam5,lam8,           & 
& v1,v2,ZH,ZA,cplAhAhHhSM(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplHapHhSMcHap = 0._dp 
Do gt2 = 1, 3
Call CouplingHapHhSMcHapT(gt2,lam10,v2,ZH,cplHapHhSMcHap(gt2))

End Do 


cplhhahhaHhSM = 0._dp 
Do gt3 = 1, 3
Call CouplinghhahhaHhSMT(gt3,lam12,lam11,lam10,lam14,v1,v2,ZH,cplhhahhaHhSM(gt3))

End Do 


cplHhSMHhSMHhSM = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingHhSMHhSMHhSMT(gt1,gt2,gt3,lam1,lam3,lam4,lam7,lam6,lam5,lam8,            & 
& v1,v2,ZH,cplHhSMHhSMHhSM(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplHhSMHpcHp = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingHhSMHpcHpT(gt1,gt2,gt3,lam1,lam3,lam4,lam7,lam6,lam5,lam8,               & 
& v1,v2,ZH,ZP,cplHhSMHpcHp(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplHhSMsigasiga = 0._dp 
Do gt1 = 1, 3
Call CouplingHhSMsigasigaT(gt1,lam12,lam11,lam10,lam14,v1,v2,ZH,cplHhSMsigasiga(gt1))

End Do 


cplAhHhSMVZ = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingAhHhSMVZT(gt1,gt2,g1,g2,ZH,ZA,TW,cplAhHhSMVZ(gt1,gt2))

 End Do 
End Do 


cplHhSMHpcVWp = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingHhSMHpcVWpT(gt1,gt2,g2,ZH,ZP,cplHhSMHpcVWp(gt1,gt2))

 End Do 
End Do 


cplHhSMcVWpVWp = 0._dp 
Do gt1 = 1, 3
Call CouplingHhSMcVWpVWpT(gt1,g2,v1,v2,ZH,cplHhSMcVWpVWp(gt1))

End Do 


cplHhSMVZVZ = 0._dp 
Do gt1 = 1, 3
Call CouplingHhSMVZVZT(gt1,g1,g2,v1,v2,ZH,TW,cplHhSMVZVZ(gt1))

End Do 


cplcFdFdHhSML = 0._dp 
cplcFdFdHhSMR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFdFdHhSMT(gt1,gt2,gt3,Yd,ZH,ZDL,ZDR,cplcFdFdHhSML(gt1,gt2,gt3)          & 
& ,cplcFdFdHhSMR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFeFeHhSML = 0._dp 
cplcFeFeHhSMR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFeFeHhSMT(gt1,gt2,gt3,Ye,ZH,ZEL,ZER,cplcFeFeHhSML(gt1,gt2,gt3)          & 
& ,cplcFeFeHhSMR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFuFuHhSML = 0._dp 
cplcFuFuHhSMR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFuFuHhSMT(gt1,gt2,gt3,Yu,ZH,ZUL,ZUR,cplcFuFuHhSML(gt1,gt2,gt3)          & 
& ,cplcFuFuHhSMR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


vev=1/Sqrt((G_F*Sqrt(2._dp)))
cplHiggsWWvirt = cplHhSMcVWpVWp/vev 
cplHiggsZZvirt = cplHhSMVZVZ*Sqrt(7._dp/12._dp-10._dp/9._dp*Sin(TW)**2+40._dp/27._dp*Sin(TW)**4)/vev 
 

!----------------------------------------------------
! Coupling ratios for HiggsBounds 
!----------------------------------------------------
 
Do i2=1, 3
rHB_S_S_Fd(i1,i2) = Abs((cplcFdFdHhSML(i2,i2,i1)+cplcFdFdHhSMR(i2,i2,i1))*vev/(2._dp*MFd(i2))) 
rHB_S_P_Fd(i1,i2) = Abs((cplcFdFdHhSML(i2,i2,i1)-cplcFdFdHhSMR(i2,i2,i1))*vev/(2._dp*MFd(i2))) 
End Do 
Do i2=1, 3
rHB_S_S_Fe(i1,i2) = Abs((cplcFeFeHhSML(i2,i2,i1)+cplcFeFeHhSMR(i2,i2,i1))*vev/(2._dp*MFe(i2))) 
rHB_S_P_Fe(i1,i2) = Abs((cplcFeFeHhSML(i2,i2,i1)-cplcFeFeHhSMR(i2,i2,i1))*vev/(2._dp*MFe(i2))) 
End Do 
Do i2=1, 3
rHB_S_S_Fu(i1,i2) = Abs((cplcFuFuHhSML(i2,i2,i1)+cplcFuFuHhSMR(i2,i2,i1))*vev/(2._dp*MFu(i2))) 
rHB_S_P_Fu(i1,i2) = Abs((cplcFuFuHhSML(i2,i2,i1)-cplcFuFuHhSMR(i2,i2,i1))*vev/(2._dp*MFu(i2))) 
End Do 
rHB_S_VWp(i1) = Abs(-0.5_dp*cplHhSMcVWpVWp(i1)*vev/MVWp2) 
rHB_S_VZ(i1) = Abs(-0.5_dp*cplHhSMVZVZ(i1)*vev/MVZ2) 
If (PoleMassesInLoops) Then 
! --- Use the pole masses --- 
MAh = MAhinput 
MAh2 = MAh2input 
MFd = MFdinput 
MFd2 = MFd2input 
MFe = MFeinput 
MFe2 = MFe2input 
MFu = MFuinput 
MFu2 = MFu2input 
MHap = MHapinput 
MHap2 = MHap2input 
Mhha = Mhhainput 
Mhha2 = Mhha2input 
MHhSM = MHhSMinput 
MHhSM2 = MHhSM2input 
MHp = MHpinput 
MHp2 = MHp2input 
Msiga = Msigainput 
Msiga2 = Msiga2input 
MVWp = MVWpinput 
MVWp2 = MVWp2input 
MVZ = MVZinput 
MVZ2 = MVZ2input 
v = vinput 
betaH = betaHinput 
End if 
!----------------------------------------------------
! Scalar Higgs coupling ratios 
!----------------------------------------------------
 
Do i2=1, 3
ratFd(i2) = cplcFdFdHhSML(i2,i2,i1)*1._dp*vev/MFd(i2) 
End Do 
Do i2=1, 3
ratFe(i2) = cplcFeFeHhSML(i2,i2,i1)*1._dp*vev/MFe(i2) 
End Do 
Do i2=1, 3
ratFu(i2) = cplcFuFuHhSML(i2,i2,i1)*1._dp*vev/MFu(i2) 
End Do 
ratHap = 0.5_dp*cplHapHhSMcHap(i1)*vev/MHap2 
Do i2=1, 3
ratHp(i2) = 0.5_dp*cplHhSMHpcHp(i1,i2,i2)*vev/MHp2(i2) 
End Do 
ratVWp = -0.5_dp*cplHhSMcVWpVWp(i1)*vev/MVWp2 
If (HigherOrderDiboson) Then 
  gNLO = Sqrt(AlphaSQhlf*4._dp*Pi) 
Else  
  gNLO = -1._dp 
End if 
Call CoupHiggsToPhoton(m_in,i1,ratFd,ratFe,ratFu,ratHap,ratHp,ratVWp,MFd,             & 
& MFe,MFu,MHap,MHp,MVWp,gNLO,coup)

cplHiggsPP(i1) = coup*Alpha 
CoupHPP(i1) = coup 
Call CoupHiggsToPhotonSM(m_in,MFd,MFe,MFu,MHap,MHp,MVWp,gNLO,coup)

ratioPP(i1) = Abs(cplHiggsPP(i1)/(coup*Alpha)) 
  gNLO = -1._dp 
Call CoupHiggsToGluon(m_in,i1,ratFd,ratFu,MFd,MFu,gNLO,coup)

cplHiggsGG(i1) = coup*AlphaSQ 
CoupHGG(i1) = coup 
Call CoupHiggsToGluonSM(m_in,MFd,MFu,gNLO,coup)

If (HigherOrderDiboson) Then 
  NLOqcd = 12._dp*oo48pi2*(95._dp/4._dp - 7._dp/6._dp*NFlav(m_in))*g3**2 
  NNLOqcd = 0.0005785973353112832_dp*(410.52103034222284_dp - 52.326413200014684_dp*NFlav(m_in)+NFlav(m_in)**2 & 
 & +(2.6337085360233763_dp +0.7392866066030529_dp *NFlav(m_in))*Log(m_in**2/mf_u(3)**2))*g3**4 
  NNNLOqcd = 0.00017781840290519607_dp*(42.74607514668917_dp + 11.191050460173795_dp*Log(m_in**2/mf_u(3)**2) + Log(m_in**2/mf_u(3)**2)**2)*g3**6 
Else 
  NLOqcd = 0._dp 
  NNLOqcd = 0._dp 
  NNNLOqcd = 0._dp 
End if 
coup = coup*Sqrt(1._dp + NLOqcd+NNLOqcd+NNNLOqcd) 
cplHiggsGG(i1) = cplHiggsGG(i1)*Sqrt(1._dp + NLOqcd+NNLOqcd+NNNLOqcd) 
CoupHGG(i1)=cplHiggsGG(i1) 
ratioGG(i1) = Abs(cplHiggsGG(i1)/(coup*AlphaSQ)) 
If (i1.eq.1) Then 
CPL_A_H_Z = Abs(cplAhHhSMVZ**2/(g2**2/(cos(TW)**2*4._dp)))
CPL_H_H_Z = 0._dp 
End if 
cplAhAhHhSM = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingAhAhHhSMT(gt1,gt2,gt3,lam1,lam3,lam4,lam2,lam7,lam6,lam5,lam8,           & 
& v1,v2,ZH,ZA,cplAhAhHhSM(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplHapHhSMcHap = 0._dp 
Do gt2 = 1, 3
Call CouplingHapHhSMcHapT(gt2,lam10,v2,ZH,cplHapHhSMcHap(gt2))

End Do 


cplhhahhaHhSM = 0._dp 
Do gt3 = 1, 3
Call CouplinghhahhaHhSMT(gt3,lam12,lam11,lam10,lam14,v1,v2,ZH,cplhhahhaHhSM(gt3))

End Do 


cplHhSMHhSMHhSM = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingHhSMHhSMHhSMT(gt1,gt2,gt3,lam1,lam3,lam4,lam7,lam6,lam5,lam8,            & 
& v1,v2,ZH,cplHhSMHhSMHhSM(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplHhSMHpcHp = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingHhSMHpcHpT(gt1,gt2,gt3,lam1,lam3,lam4,lam7,lam6,lam5,lam8,               & 
& v1,v2,ZH,ZP,cplHhSMHpcHp(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplHhSMsigasiga = 0._dp 
Do gt1 = 1, 3
Call CouplingHhSMsigasigaT(gt1,lam12,lam11,lam10,lam14,v1,v2,ZH,cplHhSMsigasiga(gt1))

End Do 


cplAhHhSMVZ = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingAhHhSMVZT(gt1,gt2,g1,g2,ZH,ZA,TW,cplAhHhSMVZ(gt1,gt2))

 End Do 
End Do 


cplHhSMHpcVWp = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingHhSMHpcVWpT(gt1,gt2,g2,ZH,ZP,cplHhSMHpcVWp(gt1,gt2))

 End Do 
End Do 


cplHhSMcVWpVWp = 0._dp 
Do gt1 = 1, 3
Call CouplingHhSMcVWpVWpT(gt1,g2,v1,v2,ZH,cplHhSMcVWpVWp(gt1))

End Do 


cplHhSMVZVZ = 0._dp 
Do gt1 = 1, 3
Call CouplingHhSMVZVZT(gt1,g1,g2,v1,v2,ZH,TW,cplHhSMVZVZ(gt1))

End Do 


cplcFdFdHhSML = 0._dp 
cplcFdFdHhSMR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFdFdHhSMT(gt1,gt2,gt3,Yd,ZH,ZDL,ZDR,cplcFdFdHhSML(gt1,gt2,gt3)          & 
& ,cplcFdFdHhSMR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFeFeHhSML = 0._dp 
cplcFeFeHhSMR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFeFeHhSMT(gt1,gt2,gt3,Ye,ZH,ZEL,ZER,cplcFeFeHhSML(gt1,gt2,gt3)          & 
& ,cplcFeFeHhSMR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFuFuHhSML = 0._dp 
cplcFuFuHhSMR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFuFuHhSMT(gt1,gt2,gt3,Yu,ZH,ZUL,ZUR,cplcFuFuHhSML(gt1,gt2,gt3)          & 
& ,cplcFuFuHhSMR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


Iname = Iname - 1 
 
End subroutine CouplingsFor_HhSM_decays_2B
 
Subroutine CouplingsFor_Ah_decays_2B(m_in,i1,MAhinput,MAh2input,MFdinput,             & 
& MFd2input,MFeinput,MFe2input,MFuinput,MFu2input,MHapinput,MHap2input,Mhhainput,        & 
& Mhha2input,MHhSMinput,MHhSM2input,MHpinput,MHp2input,Msigainput,Msiga2input,           & 
& MVWpinput,MVWp2input,MVZinput,MVZ2input,TWinput,ZDRinput,ZERinput,ZURinput,            & 
& vinput,ZDLinput,ZELinput,ZULinput,ZAinput,ZHinput,ZPinput,ZWinput,ZZinput,             & 
& betaHinput,g1input,g2input,g3input,lam1input,lam3input,lam4input,lam2input,            & 
& lam12input,lam7input,lam11input,lam10input,lam13input,lam6input,lam14input,            & 
& lam5input,lam8input,Yuinput,Ydinput,Yeinput,mu1input,mu2input,mu0input,v1input,        & 
& v2input,cplPseudoHiggsPP,cplPseudoHiggsGG,cplAhAhHhSM,cplcFdFdAhL,cplcFdFdAhR,         & 
& cplcFeFeAhL,cplcFeFeAhR,cplcFuFuAhL,cplcFuFuAhR,cplAhhhasiga,cplAhHhSMVZ,              & 
& cplAhHpcHp,cplAhHpcVWp,deltaM)

Implicit None 

Real(dp), Intent(in) :: m_in 
Real(dp), Intent(in) :: deltaM 
Integer, Intent(in) :: i1 
Real(dp),Intent(in) :: g1input,g2input,g3input,lam1input,lam3input,lam4input,lam2input,lam12input,           & 
& lam7input,lam11input,lam10input,lam13input,lam6input,lam14input,lam5input,             & 
& lam8input,mu1input,mu2input,mu0input,v1input,v2input

Complex(dp),Intent(in) :: Yuinput(3,3),Ydinput(3,3),Yeinput(3,3)

Real(dp),Intent(in) :: MAhinput(3),MAh2input(3),MFdinput(3),MFd2input(3),MFeinput(3),MFe2input(3),           & 
& MFuinput(3),MFu2input(3),MHapinput,MHap2input,Mhhainput,Mhha2input,MHhSMinput(3),      & 
& MHhSM2input(3),MHpinput(3),MHp2input(3),Msigainput,Msiga2input,MVWpinput,              & 
& MVWp2input,MVZinput,MVZ2input,TWinput,vinput,ZAinput(3,3),ZHinput(3,3),ZPinput(3,3),   & 
& ZZinput(2,2),betaHinput

Complex(dp),Intent(in) :: ZDRinput(3,3),ZERinput(3,3),ZURinput(3,3),ZDLinput(3,3),ZELinput(3,3),ZULinput(3,3),  & 
& ZWinput(2,2)

Real(dp) :: g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,            & 
& lam8,mu1,mu2,mu0,v1,v2

Complex(dp) :: Yu(3,3),Yd(3,3),Ye(3,3)

Complex(dp),Intent(out) :: cplPseudoHiggsPP(3),cplPseudoHiggsGG(3),cplAhAhHhSM(3,3,3),cplcFdFdAhL(3,3,3),        & 
& cplcFdFdAhR(3,3,3),cplcFeFeAhL(3,3,3),cplcFeFeAhR(3,3,3),cplcFuFuAhL(3,3,3),           & 
& cplcFuFuAhR(3,3,3),cplAhhhasiga(3),cplAhHhSMVZ(3,3),cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3)

Integer :: i2, i3, gt1, gt2, gt3, kont 
Real(dp) :: MAh(3),MAh2(3),MFd(3),MFd2(3),MFe(3),MFe2(3),MFu(3),MFu2(3),MHap,MHap2,               & 
& Mhha,Mhha2,MHhSM(3),MHhSM2(3),MHp(3),MHp2(3),Msiga,Msiga2,MVWp,MVWp2,MVZ,              & 
& MVZ2,TW,v,ZA(3,3),ZH(3,3),ZP(3,3),ZZ(2,2),betaH

Complex(dp) :: ZDR(3,3),ZER(3,3),ZUR(3,3),ZDL(3,3),ZEL(3,3),ZUL(3,3),ZW(2,2)

Complex(dp) :: ratFd(3),ratFe(3),ratFu(3),ratHap,ratHp(3),ratVWp

Complex(dp) :: ratPFd(3),ratPFe(3),ratPFu(3),ratPHap,ratPHp(3),ratPVWp

Complex(dp) :: coup 
Real(dp) :: vev, gNLO, NLOqcd, NNLOqcd, NNNLOqcd, AlphaSQ, AlphaSQhlf 
Real(dp) :: g1SM,g2SM,g3SM,vSM
Complex(dp) ::YuSM(3,3),YdSM(3,3),YeSM(3,3)
Real(dp) :: gSM(11), sinW2, dt, tz, Qin 
Iname = Iname + 1 
NameOfUnit(Iname) = 'Couplings_Ah_2B'
 
sinW2=1._dp-mW2/mZ2 
g1 = g1input 
g2 = g2input 
g3 = g3input 
lam1 = lam1input 
lam3 = lam3input 
lam4 = lam4input 
lam2 = lam2input 
lam12 = lam12input 
lam7 = lam7input 
lam11 = lam11input 
lam10 = lam10input 
lam13 = lam13input 
lam6 = lam6input 
lam14 = lam14input 
lam5 = lam5input 
lam8 = lam8input 
Yu = Yuinput 
Yd = Ydinput 
Ye = Yeinput 
mu1 = mu1input 
mu2 = mu2input 
mu0 = mu0input 
v1 = v1input 
v2 = v2input 
Qin=sqrt(getRenormalizationScale()) 
If (m_in.le.Qin) Then 
  If (m_in.le.mz) Then 
    Call RunSM(mz,deltaM,v2/v1,g1,g2,g3,Yu,Yd,Ye,v1,v2) 
  Else 
    Call RunSM(m_in,deltaM,v2/v1,g1,g2,g3,Yu,Yd,Ye,v1,v2) 
  End if 
End if 
! Run always SM gauge couplings if present 
  Qin=sqrt(getRenormalizationScale()) 
  Call RunSMohdm(m_in,deltaM,g1SM,g2SM,g3SM,YuSM,YdSM,YeSM,vSM) 
   ! SM pole masses needed for diphoton/digluon rate 
   ! But only top and W play a role. 
   vSM=1/Sqrt((G_F*Sqrt(2._dp))) ! On-Shell VEV needed for loop 
   YuSM(3,3)=sqrt(2._dp)*mf_u(3)/vSM  ! On-Shell top needed in loop 
   ! Other running values kept to get H->ff correct 
Call SetMatchingConditions(g1SM,g2SM,g3SM,YuSM,YdSM,YeSM,vSM,v1,v2,g1,g2,             & 
& g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,              & 
& Yu,Yd,Ye,mu1,mu2,mu0,.False.)

! Run always SM gauge couplings if present 
! alphaS(mH/2) for NLO corrections to diphoton rate 
Call RunSMgauge(m_in/2._dp,deltaM, g1,g2,g3) 
AlphaSQhlf=g3**2/(4._dp*Pi) 
! alphaS(mH) for digluon rate 
Call RunSMgauge(m_in,deltaM, g1,g2,g3) 
AlphaSQ=g3**2/(4._dp*Pi) 
Call SolveTadpoleEquations(g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,             & 
& lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,v1,v2,(/ ZeroC, ZeroC, ZeroC, ZeroC /))

! --- Calculate running tree-level masses for loop induced couplings and Quark mixing matrices --- 
Call TreeMasses(MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,MHap2,Mhha,Mhha2,            & 
& MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,ZER,ZUR,v,               & 
& ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,v1,v2,g1,g2,g3,lam1,lam3,lam4,lam2,lam12,             & 
& lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,.True.,kont)

If (ExternalZfactors) Then 
! --- Use the 1-loop mixing matrices calculated at M_SUSY in the vertices --- 
ZA = ZAinput 
ZH = ZHinput 
ZP = ZPinput 
ZW = ZWinput 
ZZ = ZZinput 
End if 
cplAhAhHhSM = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingAhAhHhSMT(gt1,gt2,gt3,lam1,lam3,lam4,lam2,lam7,lam6,lam5,lam8,           & 
& v1,v2,ZH,ZA,cplAhAhHhSM(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplAhhhasiga = 0._dp 
Do gt1 = 1, 3
Call CouplingAhhhasigaT(gt1,lam12,v2,ZA,cplAhhhasiga(gt1))

End Do 


cplAhHpcHp = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingAhHpcHpT(gt1,gt2,gt3,lam2,lam7,lam6,v1,v2,ZA,ZP,cplAhHpcHp(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplAhHhSMVZ = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingAhHhSMVZT(gt1,gt2,g1,g2,ZH,ZA,TW,cplAhHhSMVZ(gt1,gt2))

 End Do 
End Do 


cplAhHpcVWp = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingAhHpcVWpT(gt1,gt2,g2,ZA,ZP,cplAhHpcVWp(gt1,gt2))

 End Do 
End Do 


cplcFdFdAhL = 0._dp 
cplcFdFdAhR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFdFdAhT(gt1,gt2,gt3,Yd,ZA,ZDL,ZDR,cplcFdFdAhL(gt1,gt2,gt3)              & 
& ,cplcFdFdAhR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFeFeAhL = 0._dp 
cplcFeFeAhR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFeFeAhT(gt1,gt2,gt3,Ye,ZA,ZEL,ZER,cplcFeFeAhL(gt1,gt2,gt3)              & 
& ,cplcFeFeAhR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFuFuAhL = 0._dp 
cplcFuFuAhR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFuFuAhT(gt1,gt2,gt3,Yu,ZA,ZUL,ZUR,cplcFuFuAhL(gt1,gt2,gt3)              & 
& ,cplcFuFuAhR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


vev=1/Sqrt((G_F*Sqrt(2._dp)))
!----------------------------------------------------
! Coupling ratios for HiggsBounds 
!----------------------------------------------------
 
Do i2=1, 3
rHB_P_S_Fd(i1,i2) = 1._dp*Abs((cplcFdFdAhL(i2,i2,i1)+cplcFdFdAhR(i2,i2,i1))*vev/(2._dp*MFd(i2))) 
rHB_P_P_Fd(i1,i2) = 1._dp*Abs((cplcFdFdAhL(i2,i2,i1)-cplcFdFdAhR(i2,i2,i1))*vev/(2._dp*MFd(i2))) 
End Do 
Do i2=1, 3
rHB_P_S_Fe(i1,i2) = 1._dp*Abs((cplcFeFeAhL(i2,i2,i1)+cplcFeFeAhR(i2,i2,i1))*vev/(2._dp*MFe(i2))) 
rHB_P_P_Fe(i1,i2) = 1._dp*Abs((cplcFeFeAhL(i2,i2,i1)-cplcFeFeAhR(i2,i2,i1))*vev/(2._dp*MFe(i2))) 
End Do 
Do i2=1, 3
rHB_P_S_Fu(i1,i2) = 1._dp*Abs((cplcFuFuAhL(i2,i2,i1)+cplcFuFuAhR(i2,i2,i1))*vev/(2._dp*MFu(i2))) 
rHB_P_P_Fu(i1,i2) = 1._dp*Abs((cplcFuFuAhL(i2,i2,i1)-cplcFuFuAhR(i2,i2,i1))*vev/(2._dp*MFu(i2))) 
End Do 
If (PoleMassesInLoops) Then 
! --- Use the pole masses --- 
MAh = MAhinput 
MAh2 = MAh2input 
MFd = MFdinput 
MFd2 = MFd2input 
MFe = MFeinput 
MFe2 = MFe2input 
MFu = MFuinput 
MFu2 = MFu2input 
MHap = MHapinput 
MHap2 = MHap2input 
Mhha = Mhhainput 
Mhha2 = Mhha2input 
MHhSM = MHhSMinput 
MHhSM2 = MHhSM2input 
MHp = MHpinput 
MHp2 = MHp2input 
Msiga = Msigainput 
Msiga2 = Msiga2input 
MVWp = MVWpinput 
MVWp2 = MVWp2input 
MVZ = MVZinput 
MVZ2 = MVZ2input 
v = vinput 
betaH = betaHinput 
End if 
!----------------------------------------------------
! Pseudo Scalar Higgs coupling ratios 
!----------------------------------------------------
 
Do i2=1, 3
ratPFd(i2) = cplcFdFdAhL(i2,i2,i1)*1._dp*vev/MFd(i2) 
End Do 
Do i2=1, 3
ratPFe(i2) = cplcFeFeAhL(i2,i2,i1)*1._dp*vev/MFe(i2) 
End Do 
Do i2=1, 3
ratPFu(i2) = cplcFuFuAhL(i2,i2,i1)*1._dp*vev/MFu(i2) 
End Do 
ratPHap = 0._dp 
Do i2=1, 3
ratPHp(i2) = 0.5_dp*cplAhHpcHp(i1,i2,i2)*vev/MHp2(i2) 
End Do 
ratPVWp = 0._dp 
If (HigherOrderDiboson) Then 
  gNLO = g3 
Else  
  gNLO = -1._dp 
End if 
Call CoupPseudoHiggsToPhoton(m_in,i1,ratPFd,ratPFe,ratPFu,ratPHap,ratPHp,             & 
& ratPVWp,MFd,MFe,MFu,MHap,MHp,MVWp,gNLO,coup)

cplPseudoHiggsPP(i1) = 2._dp*coup*Alpha 
CoupAPP(i1) = 2._dp*coup 
Call CoupHiggsToPhotonSM(m_in,MFd,MFe,MFu,MHap,MHp,MVWp,gNLO,coup)

ratioPPP(i1) = Abs(cplPseudoHiggsPP(i1)/(coup*oo4pi*(1._dp-mW2/mZ2)*g2**2)) 
  gNLO = -1._dp 
Call CoupPseudoHiggsToGluon(m_in,i1,ratPFd,ratPFu,MFd,MFu,gNLO,coup)

If (HigherOrderDiboson) Then 
  NLOqcd = 12._dp*oo48pi2*(97._dp/4._dp - 7._dp/6._dp*NFlav(m_in))*g3**2 
  NNLOqcd = (171.544_dp +  5._dp*Log(m_in**2/mf_u(3)**2))*g3**4/(4._dp*Pi**2)**2 
  NNNLOqcd = 0._dp 
Else 
  NLOqcd = 0._dp 
  NNLOqcd = 0._dp 
  NNNLOqcd = 0._dp 
End if 
cplPseudoHiggsGG(i1) = 2._dp*coup*AlphaSQ*Sqrt(1._dp + NLOqcd+NNLOqcd+NNNLOqcd) 
CoupAGG(i1) = 2._dp*coup*AlphaSQ*Sqrt(1._dp + NLOqcd+NNLOqcd+NNNLOqcd) 
Call CoupHiggsToGluonSM(m_in,MFd,MFu,gNLO,coup)

coup = coup*Sqrt(1._dp + NLOqcd+NNLOqcd+NNNLOqcd) 
ratioPGG(i1) = Abs(cplPseudoHiggsGG(i1)/(coup*AlphaSQ)) 

If (i1.eq.2) Then 
CPL_A_A_Z = 0._dp 
End if 
cplAhAhHhSM = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingAhAhHhSMT(gt1,gt2,gt3,lam1,lam3,lam4,lam2,lam7,lam6,lam5,lam8,           & 
& v1,v2,ZH,ZA,cplAhAhHhSM(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplAhhhasiga = 0._dp 
Do gt1 = 1, 3
Call CouplingAhhhasigaT(gt1,lam12,v2,ZA,cplAhhhasiga(gt1))

End Do 


cplAhHpcHp = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingAhHpcHpT(gt1,gt2,gt3,lam2,lam7,lam6,v1,v2,ZA,ZP,cplAhHpcHp(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplAhHhSMVZ = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingAhHhSMVZT(gt1,gt2,g1,g2,ZH,ZA,TW,cplAhHhSMVZ(gt1,gt2))

 End Do 
End Do 


cplAhHpcVWp = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingAhHpcVWpT(gt1,gt2,g2,ZA,ZP,cplAhHpcVWp(gt1,gt2))

 End Do 
End Do 


cplcFdFdAhL = 0._dp 
cplcFdFdAhR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFdFdAhT(gt1,gt2,gt3,Yd,ZA,ZDL,ZDR,cplcFdFdAhL(gt1,gt2,gt3)              & 
& ,cplcFdFdAhR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFeFeAhL = 0._dp 
cplcFeFeAhR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFeFeAhT(gt1,gt2,gt3,Ye,ZA,ZEL,ZER,cplcFeFeAhL(gt1,gt2,gt3)              & 
& ,cplcFeFeAhR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFuFuAhL = 0._dp 
cplcFuFuAhR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFuFuAhT(gt1,gt2,gt3,Yu,ZA,ZUL,ZUR,cplcFuFuAhL(gt1,gt2,gt3)              & 
& ,cplcFuFuAhR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


Iname = Iname - 1 
 
End subroutine CouplingsFor_Ah_decays_2B
 
Subroutine CouplingsFor_Hp_decays_2B(m_in,i1,MAhinput,MAh2input,MFdinput,             & 
& MFd2input,MFeinput,MFe2input,MFuinput,MFu2input,MHapinput,MHap2input,Mhhainput,        & 
& Mhha2input,MHhSMinput,MHhSM2input,MHpinput,MHp2input,Msigainput,Msiga2input,           & 
& MVWpinput,MVWp2input,MVZinput,MVZ2input,TWinput,ZDRinput,ZERinput,ZURinput,            & 
& vinput,ZDLinput,ZELinput,ZULinput,ZAinput,ZHinput,ZPinput,ZWinput,ZZinput,             & 
& betaHinput,g1input,g2input,g3input,lam1input,lam3input,lam4input,lam2input,            & 
& lam12input,lam7input,lam11input,lam10input,lam13input,lam6input,lam14input,            & 
& lam5input,lam8input,Yuinput,Ydinput,Yeinput,mu1input,mu2input,mu0input,v1input,        & 
& v2input,cplAhHpcHp,cplAhcHpVWp,cplcFdFucHpL,cplcFdFucHpR,cplcFeFvcHpL,cplcFeFvcHpR,    & 
& cplHaphhacHp,cplHapsigacHp,cplHhSMHpcHp,cplHhSMcHpVWp,cplHpcHpVZ,cplcHpVWpVZ,deltaM)

Implicit None 

Real(dp), Intent(in) :: m_in 
Real(dp), Intent(in) :: deltaM 
Integer, Intent(in) :: i1 
Real(dp),Intent(in) :: g1input,g2input,g3input,lam1input,lam3input,lam4input,lam2input,lam12input,           & 
& lam7input,lam11input,lam10input,lam13input,lam6input,lam14input,lam5input,             & 
& lam8input,mu1input,mu2input,mu0input,v1input,v2input

Complex(dp),Intent(in) :: Yuinput(3,3),Ydinput(3,3),Yeinput(3,3)

Real(dp),Intent(in) :: MAhinput(3),MAh2input(3),MFdinput(3),MFd2input(3),MFeinput(3),MFe2input(3),           & 
& MFuinput(3),MFu2input(3),MHapinput,MHap2input,Mhhainput,Mhha2input,MHhSMinput(3),      & 
& MHhSM2input(3),MHpinput(3),MHp2input(3),Msigainput,Msiga2input,MVWpinput,              & 
& MVWp2input,MVZinput,MVZ2input,TWinput,vinput,ZAinput(3,3),ZHinput(3,3),ZPinput(3,3),   & 
& ZZinput(2,2),betaHinput

Complex(dp),Intent(in) :: ZDRinput(3,3),ZERinput(3,3),ZURinput(3,3),ZDLinput(3,3),ZELinput(3,3),ZULinput(3,3),  & 
& ZWinput(2,2)

Real(dp) :: g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,            & 
& lam8,mu1,mu2,mu0,v1,v2

Complex(dp) :: Yu(3,3),Yd(3,3),Ye(3,3)

Complex(dp),Intent(out) :: cplAhHpcHp(3,3,3),cplAhcHpVWp(3,3),cplcFdFucHpL(3,3,3),cplcFdFucHpR(3,3,3),           & 
& cplcFeFvcHpL(3,3,3),cplcFeFvcHpR(3,3,3),cplHaphhacHp(3),cplHapsigacHp(3),              & 
& cplHhSMHpcHp(3,3,3),cplHhSMcHpVWp(3,3),cplHpcHpVZ(3,3),cplcHpVWpVZ(3)

Integer :: i2, i3, gt1, gt2, gt3, kont 
Real(dp) :: MAh(3),MAh2(3),MFd(3),MFd2(3),MFe(3),MFe2(3),MFu(3),MFu2(3),MHap,MHap2,               & 
& Mhha,Mhha2,MHhSM(3),MHhSM2(3),MHp(3),MHp2(3),Msiga,Msiga2,MVWp,MVWp2,MVZ,              & 
& MVZ2,TW,v,ZA(3,3),ZH(3,3),ZP(3,3),ZZ(2,2),betaH

Complex(dp) :: ZDR(3,3),ZER(3,3),ZUR(3,3),ZDL(3,3),ZEL(3,3),ZUL(3,3),ZW(2,2)

Real(dp) :: gSM(11), sinW2, dt, tz, Qin 
Iname = Iname + 1 
NameOfUnit(Iname) = 'Couplings_Hp_2B'
 
sinW2=1._dp-mW2/mZ2 
g1 = g1input 
g2 = g2input 
g3 = g3input 
lam1 = lam1input 
lam3 = lam3input 
lam4 = lam4input 
lam2 = lam2input 
lam12 = lam12input 
lam7 = lam7input 
lam11 = lam11input 
lam10 = lam10input 
lam13 = lam13input 
lam6 = lam6input 
lam14 = lam14input 
lam5 = lam5input 
lam8 = lam8input 
Yu = Yuinput 
Yd = Ydinput 
Ye = Yeinput 
mu1 = mu1input 
mu2 = mu2input 
mu0 = mu0input 
v1 = v1input 
v2 = v2input 
Qin=sqrt(getRenormalizationScale()) 
If (m_in.le.Qin) Then 
  If (m_in.le.mz) Then 
    Call RunSM(mz,deltaM,v2/v1,g1,g2,g3,Yu,Yd,Ye,v1,v2) 
  Else 
    Call RunSM(m_in,deltaM,v2/v1,g1,g2,g3,Yu,Yd,Ye,v1,v2) 
  End if 
End if 
Call SolveTadpoleEquations(g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,             & 
& lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,v1,v2,(/ ZeroC, ZeroC, ZeroC, ZeroC /))

! --- Calculate running tree-level masses for loop induced couplings and Quark mixing matrices --- 
Call TreeMasses(MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,MHap2,Mhha,Mhha2,            & 
& MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,ZER,ZUR,v,               & 
& ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,v1,v2,g1,g2,g3,lam1,lam3,lam4,lam2,lam12,             & 
& lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,.True.,kont)

If (ExternalZfactors) Then 
! --- Use the 1-loop mixing matrices calculated at M_SUSY in the vertices --- 
ZA = ZAinput 
ZH = ZHinput 
ZP = ZPinput 
ZW = ZWinput 
ZZ = ZZinput 
End if 
If (PoleMassesInLoops) Then 
! --- Use the pole masses --- 
MAh = MAhinput 
MAh2 = MAh2input 
MFd = MFdinput 
MFd2 = MFd2input 
MFe = MFeinput 
MFe2 = MFe2input 
MFu = MFuinput 
MFu2 = MFu2input 
MHap = MHapinput 
MHap2 = MHap2input 
Mhha = Mhhainput 
Mhha2 = Mhha2input 
MHhSM = MHhSMinput 
MHhSM2 = MHhSM2input 
MHp = MHpinput 
MHp2 = MHp2input 
Msiga = Msigainput 
Msiga2 = Msiga2input 
MVWp = MVWpinput 
MVWp2 = MVWp2input 
MVZ = MVZinput 
MVZ2 = MVZ2input 
v = vinput 
betaH = betaHinput 
End if 
cplAhHpcHp = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingAhHpcHpT(gt1,gt2,gt3,lam2,lam7,lam6,v1,v2,ZA,ZP,cplAhHpcHp(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplHaphhacHp = 0._dp 
Do gt3 = 1, 3
Call CouplingHaphhacHpT(gt3,lam12,lam11,lam14,v1,v2,ZP,cplHaphhacHp(gt3))

End Do 


cplHapsigacHp = 0._dp 
Do gt3 = 1, 3
Call CouplingHapsigacHpT(gt3,lam12,lam11,lam14,v1,v2,ZP,cplHapsigacHp(gt3))

End Do 


cplHhSMHpcHp = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingHhSMHpcHpT(gt1,gt2,gt3,lam1,lam3,lam4,lam7,lam6,lam5,lam8,               & 
& v1,v2,ZH,ZP,cplHhSMHpcHp(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplAhcHpVWp = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingAhcHpVWpT(gt1,gt2,g2,ZA,ZP,cplAhcHpVWp(gt1,gt2))

 End Do 
End Do 


cplHhSMcHpVWp = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingHhSMcHpVWpT(gt1,gt2,g2,ZH,ZP,cplHhSMcHpVWp(gt1,gt2))

 End Do 
End Do 


cplHpcHpVZ = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingHpcHpVZT(gt1,gt2,g1,g2,ZP,TW,cplHpcHpVZ(gt1,gt2))

 End Do 
End Do 


cplcHpVWpVZ = 0._dp 
Do gt1 = 1, 3
Call CouplingcHpVWpVZT(gt1,g1,g2,v1,v2,ZP,TW,cplcHpVWpVZ(gt1))

End Do 


cplcFdFucHpL = 0._dp 
cplcFdFucHpR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFdFucHpT(gt1,gt2,gt3,Yu,Yd,ZP,ZDL,ZDR,ZUL,ZUR,cplcFdFucHpL(gt1,gt2,gt3) & 
& ,cplcFdFucHpR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFeFvcHpL = 0._dp 
cplcFeFvcHpR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFeFvcHpT(gt1,gt2,gt3,Ye,ZP,ZER,cplcFeFvcHpL(gt1,gt2,gt3),               & 
& cplcFeFvcHpR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


Iname = Iname - 1 
 
End subroutine CouplingsFor_Hp_decays_2B
 
Subroutine CouplingsFor_Fu_decays_3B(m_in,i1,MAhinput,MAh2input,MFdinput,             & 
& MFd2input,MFeinput,MFe2input,MFuinput,MFu2input,MHapinput,MHap2input,Mhhainput,        & 
& Mhha2input,MHhSMinput,MHhSM2input,MHpinput,MHp2input,Msigainput,Msiga2input,           & 
& MVWpinput,MVWp2input,MVZinput,MVZ2input,TWinput,ZDRinput,ZERinput,ZURinput,            & 
& vinput,ZDLinput,ZELinput,ZULinput,ZAinput,ZHinput,ZPinput,ZWinput,ZZinput,             & 
& betaHinput,g1input,g2input,g3input,lam1input,lam3input,lam4input,lam2input,            & 
& lam12input,lam7input,lam11input,lam10input,lam13input,lam6input,lam14input,            & 
& lam5input,lam8input,Yuinput,Ydinput,Yeinput,mu1input,mu2input,mu0input,v1input,        & 
& v2input,cplcFdFdAhL,cplcFdFdAhR,cplcFdFdHhSML,cplcFdFdHhSMR,cplcFdFdVZL,               & 
& cplcFdFdVZR,cplcFdFucHpL,cplcFdFucHpR,cplcFdFucVWpL,cplcFdFucVWpR,cplcFeFeAhL,         & 
& cplcFeFeAhR,cplcFeFeHhSML,cplcFeFeHhSMR,cplcFeFeVZL,cplcFeFeVZR,cplcFeFvcHpL,          & 
& cplcFeFvcHpR,cplcFeFvcVWpL,cplcFeFvcVWpR,cplcFuFdHpL,cplcFuFdHpR,cplcFuFdVWpL,         & 
& cplcFuFdVWpR,cplcFuFuAhL,cplcFuFuAhR,cplcFuFuHhSML,cplcFuFuHhSMR,cplcFuFuVZL,          & 
& cplcFuFuVZR,cplcFvFvVZL,cplcFvFvVZR,deltaM)

Implicit None 

Real(dp), Intent(in) :: m_in 
Real(dp), Intent(in) :: deltaM 
Integer, Intent(in) :: i1 
Real(dp),Intent(in) :: g1input,g2input,g3input,lam1input,lam3input,lam4input,lam2input,lam12input,           & 
& lam7input,lam11input,lam10input,lam13input,lam6input,lam14input,lam5input,             & 
& lam8input,mu1input,mu2input,mu0input,v1input,v2input

Complex(dp),Intent(in) :: Yuinput(3,3),Ydinput(3,3),Yeinput(3,3)

Real(dp),Intent(in) :: MAhinput(3),MAh2input(3),MFdinput(3),MFd2input(3),MFeinput(3),MFe2input(3),           & 
& MFuinput(3),MFu2input(3),MHapinput,MHap2input,Mhhainput,Mhha2input,MHhSMinput(3),      & 
& MHhSM2input(3),MHpinput(3),MHp2input(3),Msigainput,Msiga2input,MVWpinput,              & 
& MVWp2input,MVZinput,MVZ2input,TWinput,vinput,ZAinput(3,3),ZHinput(3,3),ZPinput(3,3),   & 
& ZZinput(2,2),betaHinput

Complex(dp),Intent(in) :: ZDRinput(3,3),ZERinput(3,3),ZURinput(3,3),ZDLinput(3,3),ZELinput(3,3),ZULinput(3,3),  & 
& ZWinput(2,2)

Real(dp) :: g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,            & 
& lam8,mu1,mu2,mu0,v1,v2

Complex(dp) :: Yu(3,3),Yd(3,3),Ye(3,3)

Complex(dp),Intent(out) :: cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFdFdHhSML(3,3,3),cplcFdFdHhSMR(3,3,3),      & 
& cplcFdFdVZL(3,3),cplcFdFdVZR(3,3),cplcFdFucHpL(3,3,3),cplcFdFucHpR(3,3,3),             & 
& cplcFdFucVWpL(3,3),cplcFdFucVWpR(3,3),cplcFeFeAhL(3,3,3),cplcFeFeAhR(3,3,3),           & 
& cplcFeFeHhSML(3,3,3),cplcFeFeHhSMR(3,3,3),cplcFeFeVZL(3,3),cplcFeFeVZR(3,3),           & 
& cplcFeFvcHpL(3,3,3),cplcFeFvcHpR(3,3,3),cplcFeFvcVWpL(3,3),cplcFeFvcVWpR(3,3),         & 
& cplcFuFdHpL(3,3,3),cplcFuFdHpR(3,3,3),cplcFuFdVWpL(3,3),cplcFuFdVWpR(3,3),             & 
& cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcFuFuHhSML(3,3,3),cplcFuFuHhSMR(3,3,3),       & 
& cplcFuFuVZL(3,3),cplcFuFuVZR(3,3),cplcFvFvVZL(3,3),cplcFvFvVZR(3,3)

Integer :: i2, i3, gt1, gt2, gt3, kont 
Real(dp) :: MAh(3),MAh2(3),MFd(3),MFd2(3),MFe(3),MFe2(3),MFu(3),MFu2(3),MHap,MHap2,               & 
& Mhha,Mhha2,MHhSM(3),MHhSM2(3),MHp(3),MHp2(3),Msiga,Msiga2,MVWp,MVWp2,MVZ,              & 
& MVZ2,TW,v,ZA(3,3),ZH(3,3),ZP(3,3),ZZ(2,2),betaH

Complex(dp) :: ZDR(3,3),ZER(3,3),ZUR(3,3),ZDL(3,3),ZEL(3,3),ZUL(3,3),ZW(2,2)

Real(dp) :: gSM(11), sinW2, dt, tz, Qin 
Iname = Iname + 1 
NameOfUnit(Iname) = 'Couplings_Fu_3B'
 
sinW2=1._dp-mW2/mZ2 
g1 = g1input 
g2 = g2input 
g3 = g3input 
lam1 = lam1input 
lam3 = lam3input 
lam4 = lam4input 
lam2 = lam2input 
lam12 = lam12input 
lam7 = lam7input 
lam11 = lam11input 
lam10 = lam10input 
lam13 = lam13input 
lam6 = lam6input 
lam14 = lam14input 
lam5 = lam5input 
lam8 = lam8input 
Yu = Yuinput 
Yd = Ydinput 
Ye = Yeinput 
mu1 = mu1input 
mu2 = mu2input 
mu0 = mu0input 
v1 = v1input 
v2 = v2input 
Qin=sqrt(getRenormalizationScale()) 
If (m_in.le.Qin) Then 
  If (m_in.le.mz) Then 
    Call RunSM(mz,deltaM,v2/v1,g1,g2,g3,Yu,Yd,Ye,v1,v2) 
  Else 
    Call RunSM(m_in,deltaM,v2/v1,g1,g2,g3,Yu,Yd,Ye,v1,v2) 
  End if 
End if 
Call SolveTadpoleEquations(g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,             & 
& lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,v1,v2,(/ ZeroC, ZeroC, ZeroC, ZeroC /))

! --- Calculate running tree-level masses for loop induced couplings and Quark mixing matrices --- 
Call TreeMasses(MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,MHap2,Mhha,Mhha2,            & 
& MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,ZER,ZUR,v,               & 
& ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,v1,v2,g1,g2,g3,lam1,lam3,lam4,lam2,lam12,             & 
& lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,.True.,kont)

If (ExternalZfactors) Then 
! --- Use the 1-loop mixing matrices calculated at M_SUSY in the vertices --- 
ZA = ZAinput 
ZH = ZHinput 
ZP = ZPinput 
ZW = ZWinput 
ZZ = ZZinput 
End if 
If (PoleMassesInLoops) Then 
! --- Use the pole masses --- 
MAh = MAhinput 
MAh2 = MAh2input 
MFd = MFdinput 
MFd2 = MFd2input 
MFe = MFeinput 
MFe2 = MFe2input 
MFu = MFuinput 
MFu2 = MFu2input 
MHap = MHapinput 
MHap2 = MHap2input 
Mhha = Mhhainput 
Mhha2 = Mhha2input 
MHhSM = MHhSMinput 
MHhSM2 = MHhSM2input 
MHp = MHpinput 
MHp2 = MHp2input 
Msiga = Msigainput 
Msiga2 = Msiga2input 
MVWp = MVWpinput 
MVWp2 = MVWp2input 
MVZ = MVZinput 
MVZ2 = MVZ2input 
v = vinput 
betaH = betaHinput 
End if 
cplcFdFdAhL = 0._dp 
cplcFdFdAhR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFdFdAhT(gt1,gt2,gt3,Yd,ZA,ZDL,ZDR,cplcFdFdAhL(gt1,gt2,gt3)              & 
& ,cplcFdFdAhR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFeFeAhL = 0._dp 
cplcFeFeAhR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFeFeAhT(gt1,gt2,gt3,Ye,ZA,ZEL,ZER,cplcFeFeAhL(gt1,gt2,gt3)              & 
& ,cplcFeFeAhR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFuFuAhL = 0._dp 
cplcFuFuAhR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFuFuAhT(gt1,gt2,gt3,Yu,ZA,ZUL,ZUR,cplcFuFuAhL(gt1,gt2,gt3)              & 
& ,cplcFuFuAhR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFdFdHhSML = 0._dp 
cplcFdFdHhSMR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFdFdHhSMT(gt1,gt2,gt3,Yd,ZH,ZDL,ZDR,cplcFdFdHhSML(gt1,gt2,gt3)          & 
& ,cplcFdFdHhSMR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFuFdHpL = 0._dp 
cplcFuFdHpR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFuFdHpT(gt1,gt2,gt3,Yu,Yd,ZP,ZDL,ZDR,ZUL,ZUR,cplcFuFdHpL(gt1,gt2,gt3)   & 
& ,cplcFuFdHpR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFeFeHhSML = 0._dp 
cplcFeFeHhSMR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFeFeHhSMT(gt1,gt2,gt3,Ye,ZH,ZEL,ZER,cplcFeFeHhSML(gt1,gt2,gt3)          & 
& ,cplcFeFeHhSMR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFuFuHhSML = 0._dp 
cplcFuFuHhSMR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFuFuHhSMT(gt1,gt2,gt3,Yu,ZH,ZUL,ZUR,cplcFuFuHhSML(gt1,gt2,gt3)          & 
& ,cplcFuFuHhSMR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFdFucHpL = 0._dp 
cplcFdFucHpR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFdFucHpT(gt1,gt2,gt3,Yu,Yd,ZP,ZDL,ZDR,ZUL,ZUR,cplcFdFucHpL(gt1,gt2,gt3) & 
& ,cplcFdFucHpR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFeFvcHpL = 0._dp 
cplcFeFvcHpR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFeFvcHpT(gt1,gt2,gt3,Ye,ZP,ZER,cplcFeFvcHpL(gt1,gt2,gt3),               & 
& cplcFeFvcHpR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFuFdVWpL = 0._dp 
cplcFuFdVWpR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFuFdVWpT(gt1,gt2,g2,ZDL,ZUL,cplcFuFdVWpL(gt1,gt2),cplcFuFdVWpR(gt1,gt2))

 End Do 
End Do 


cplcFdFdVZL = 0._dp 
cplcFdFdVZR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFdFdVZT(gt1,gt2,g1,g2,TW,cplcFdFdVZL(gt1,gt2),cplcFdFdVZR(gt1,gt2))

 End Do 
End Do 


cplcFeFeVZL = 0._dp 
cplcFeFeVZR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFeFeVZT(gt1,gt2,g1,g2,TW,cplcFeFeVZL(gt1,gt2),cplcFeFeVZR(gt1,gt2))

 End Do 
End Do 


cplcFuFuVZL = 0._dp 
cplcFuFuVZR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFuFuVZT(gt1,gt2,g1,g2,TW,cplcFuFuVZL(gt1,gt2),cplcFuFuVZR(gt1,gt2))

 End Do 
End Do 


cplcFdFucVWpL = 0._dp 
cplcFdFucVWpR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFdFucVWpT(gt1,gt2,g2,ZDL,ZUL,cplcFdFucVWpL(gt1,gt2),cplcFdFucVWpR(gt1,gt2))

 End Do 
End Do 


cplcFvFvVZL = 0._dp 
cplcFvFvVZR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFvFvVZT(gt1,gt2,g1,g2,TW,cplcFvFvVZL(gt1,gt2),cplcFvFvVZR(gt1,gt2))

 End Do 
End Do 


cplcFeFvcVWpL = 0._dp 
cplcFeFvcVWpR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFeFvcVWpT(gt1,gt2,g2,ZEL,cplcFeFvcVWpL(gt1,gt2),cplcFeFvcVWpR(gt1,gt2))

 End Do 
End Do 


Iname = Iname - 1 
 
End subroutine CouplingsFor_Fu_decays_3B
 
Subroutine CouplingsFor_Fe_decays_3B(m_in,i1,MAhinput,MAh2input,MFdinput,             & 
& MFd2input,MFeinput,MFe2input,MFuinput,MFu2input,MHapinput,MHap2input,Mhhainput,        & 
& Mhha2input,MHhSMinput,MHhSM2input,MHpinput,MHp2input,Msigainput,Msiga2input,           & 
& MVWpinput,MVWp2input,MVZinput,MVZ2input,TWinput,ZDRinput,ZERinput,ZURinput,            & 
& vinput,ZDLinput,ZELinput,ZULinput,ZAinput,ZHinput,ZPinput,ZWinput,ZZinput,             & 
& betaHinput,g1input,g2input,g3input,lam1input,lam3input,lam4input,lam2input,            & 
& lam12input,lam7input,lam11input,lam10input,lam13input,lam6input,lam14input,            & 
& lam5input,lam8input,Yuinput,Ydinput,Yeinput,mu1input,mu2input,mu0input,v1input,        & 
& v2input,cplcFdFdAhL,cplcFdFdAhR,cplcFdFdHhSML,cplcFdFdHhSMR,cplcFdFdVZL,               & 
& cplcFdFdVZR,cplcFeFeAhL,cplcFeFeAhR,cplcFeFeHhSML,cplcFeFeHhSMR,cplcFeFeVZL,           & 
& cplcFeFeVZR,cplcFeFvcHpL,cplcFeFvcHpR,cplcFeFvcVWpL,cplcFeFvcVWpR,cplcFuFdHpL,         & 
& cplcFuFdHpR,cplcFuFdVWpL,cplcFuFdVWpR,cplcFuFuAhL,cplcFuFuAhR,cplcFuFuHhSML,           & 
& cplcFuFuHhSMR,cplcFuFuVZL,cplcFuFuVZR,cplcFvFeHpL,cplcFvFeHpR,cplcFvFeVWpL,            & 
& cplcFvFeVWpR,cplcFvFvVZL,cplcFvFvVZR,deltaM)

Implicit None 

Real(dp), Intent(in) :: m_in 
Real(dp), Intent(in) :: deltaM 
Integer, Intent(in) :: i1 
Real(dp),Intent(in) :: g1input,g2input,g3input,lam1input,lam3input,lam4input,lam2input,lam12input,           & 
& lam7input,lam11input,lam10input,lam13input,lam6input,lam14input,lam5input,             & 
& lam8input,mu1input,mu2input,mu0input,v1input,v2input

Complex(dp),Intent(in) :: Yuinput(3,3),Ydinput(3,3),Yeinput(3,3)

Real(dp),Intent(in) :: MAhinput(3),MAh2input(3),MFdinput(3),MFd2input(3),MFeinput(3),MFe2input(3),           & 
& MFuinput(3),MFu2input(3),MHapinput,MHap2input,Mhhainput,Mhha2input,MHhSMinput(3),      & 
& MHhSM2input(3),MHpinput(3),MHp2input(3),Msigainput,Msiga2input,MVWpinput,              & 
& MVWp2input,MVZinput,MVZ2input,TWinput,vinput,ZAinput(3,3),ZHinput(3,3),ZPinput(3,3),   & 
& ZZinput(2,2),betaHinput

Complex(dp),Intent(in) :: ZDRinput(3,3),ZERinput(3,3),ZURinput(3,3),ZDLinput(3,3),ZELinput(3,3),ZULinput(3,3),  & 
& ZWinput(2,2)

Real(dp) :: g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,            & 
& lam8,mu1,mu2,mu0,v1,v2

Complex(dp) :: Yu(3,3),Yd(3,3),Ye(3,3)

Complex(dp),Intent(out) :: cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFdFdHhSML(3,3,3),cplcFdFdHhSMR(3,3,3),      & 
& cplcFdFdVZL(3,3),cplcFdFdVZR(3,3),cplcFeFeAhL(3,3,3),cplcFeFeAhR(3,3,3),               & 
& cplcFeFeHhSML(3,3,3),cplcFeFeHhSMR(3,3,3),cplcFeFeVZL(3,3),cplcFeFeVZR(3,3),           & 
& cplcFeFvcHpL(3,3,3),cplcFeFvcHpR(3,3,3),cplcFeFvcVWpL(3,3),cplcFeFvcVWpR(3,3),         & 
& cplcFuFdHpL(3,3,3),cplcFuFdHpR(3,3,3),cplcFuFdVWpL(3,3),cplcFuFdVWpR(3,3),             & 
& cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcFuFuHhSML(3,3,3),cplcFuFuHhSMR(3,3,3),       & 
& cplcFuFuVZL(3,3),cplcFuFuVZR(3,3),cplcFvFeHpL(3,3,3),cplcFvFeHpR(3,3,3),               & 
& cplcFvFeVWpL(3,3),cplcFvFeVWpR(3,3),cplcFvFvVZL(3,3),cplcFvFvVZR(3,3)

Integer :: i2, i3, gt1, gt2, gt3, kont 
Real(dp) :: MAh(3),MAh2(3),MFd(3),MFd2(3),MFe(3),MFe2(3),MFu(3),MFu2(3),MHap,MHap2,               & 
& Mhha,Mhha2,MHhSM(3),MHhSM2(3),MHp(3),MHp2(3),Msiga,Msiga2,MVWp,MVWp2,MVZ,              & 
& MVZ2,TW,v,ZA(3,3),ZH(3,3),ZP(3,3),ZZ(2,2),betaH

Complex(dp) :: ZDR(3,3),ZER(3,3),ZUR(3,3),ZDL(3,3),ZEL(3,3),ZUL(3,3),ZW(2,2)

Real(dp) :: gSM(11), sinW2, dt, tz, Qin 
Iname = Iname + 1 
NameOfUnit(Iname) = 'Couplings_Fe_3B'
 
sinW2=1._dp-mW2/mZ2 
g1 = g1input 
g2 = g2input 
g3 = g3input 
lam1 = lam1input 
lam3 = lam3input 
lam4 = lam4input 
lam2 = lam2input 
lam12 = lam12input 
lam7 = lam7input 
lam11 = lam11input 
lam10 = lam10input 
lam13 = lam13input 
lam6 = lam6input 
lam14 = lam14input 
lam5 = lam5input 
lam8 = lam8input 
Yu = Yuinput 
Yd = Ydinput 
Ye = Yeinput 
mu1 = mu1input 
mu2 = mu2input 
mu0 = mu0input 
v1 = v1input 
v2 = v2input 
Qin=sqrt(getRenormalizationScale()) 
If (m_in.le.Qin) Then 
  If (m_in.le.mz) Then 
    Call RunSM(mz,deltaM,v2/v1,g1,g2,g3,Yu,Yd,Ye,v1,v2) 
  Else 
    Call RunSM(m_in,deltaM,v2/v1,g1,g2,g3,Yu,Yd,Ye,v1,v2) 
  End if 
End if 
Call SolveTadpoleEquations(g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,             & 
& lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,v1,v2,(/ ZeroC, ZeroC, ZeroC, ZeroC /))

! --- Calculate running tree-level masses for loop induced couplings and Quark mixing matrices --- 
Call TreeMasses(MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,MHap2,Mhha,Mhha2,            & 
& MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,ZER,ZUR,v,               & 
& ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,v1,v2,g1,g2,g3,lam1,lam3,lam4,lam2,lam12,             & 
& lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,.True.,kont)

If (ExternalZfactors) Then 
! --- Use the 1-loop mixing matrices calculated at M_SUSY in the vertices --- 
ZA = ZAinput 
ZH = ZHinput 
ZP = ZPinput 
ZW = ZWinput 
ZZ = ZZinput 
End if 
If (PoleMassesInLoops) Then 
! --- Use the pole masses --- 
MAh = MAhinput 
MAh2 = MAh2input 
MFd = MFdinput 
MFd2 = MFd2input 
MFe = MFeinput 
MFe2 = MFe2input 
MFu = MFuinput 
MFu2 = MFu2input 
MHap = MHapinput 
MHap2 = MHap2input 
Mhha = Mhhainput 
Mhha2 = Mhha2input 
MHhSM = MHhSMinput 
MHhSM2 = MHhSM2input 
MHp = MHpinput 
MHp2 = MHp2input 
Msiga = Msigainput 
Msiga2 = Msiga2input 
MVWp = MVWpinput 
MVWp2 = MVWp2input 
MVZ = MVZinput 
MVZ2 = MVZ2input 
v = vinput 
betaH = betaHinput 
End if 
cplcFdFdAhL = 0._dp 
cplcFdFdAhR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFdFdAhT(gt1,gt2,gt3,Yd,ZA,ZDL,ZDR,cplcFdFdAhL(gt1,gt2,gt3)              & 
& ,cplcFdFdAhR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFeFeAhL = 0._dp 
cplcFeFeAhR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFeFeAhT(gt1,gt2,gt3,Ye,ZA,ZEL,ZER,cplcFeFeAhL(gt1,gt2,gt3)              & 
& ,cplcFeFeAhR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFuFuAhL = 0._dp 
cplcFuFuAhR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFuFuAhT(gt1,gt2,gt3,Yu,ZA,ZUL,ZUR,cplcFuFuAhL(gt1,gt2,gt3)              & 
& ,cplcFuFuAhR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFdFdHhSML = 0._dp 
cplcFdFdHhSMR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFdFdHhSMT(gt1,gt2,gt3,Yd,ZH,ZDL,ZDR,cplcFdFdHhSML(gt1,gt2,gt3)          & 
& ,cplcFdFdHhSMR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFuFdHpL = 0._dp 
cplcFuFdHpR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFuFdHpT(gt1,gt2,gt3,Yu,Yd,ZP,ZDL,ZDR,ZUL,ZUR,cplcFuFdHpL(gt1,gt2,gt3)   & 
& ,cplcFuFdHpR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFeFeHhSML = 0._dp 
cplcFeFeHhSMR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFeFeHhSMT(gt1,gt2,gt3,Ye,ZH,ZEL,ZER,cplcFeFeHhSML(gt1,gt2,gt3)          & 
& ,cplcFeFeHhSMR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFvFeHpL = 0._dp 
cplcFvFeHpR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFvFeHpT(gt1,gt2,gt3,Ye,ZP,ZER,cplcFvFeHpL(gt1,gt2,gt3),cplcFvFeHpR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFuFuHhSML = 0._dp 
cplcFuFuHhSMR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFuFuHhSMT(gt1,gt2,gt3,Yu,ZH,ZUL,ZUR,cplcFuFuHhSML(gt1,gt2,gt3)          & 
& ,cplcFuFuHhSMR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFeFvcHpL = 0._dp 
cplcFeFvcHpR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFeFvcHpT(gt1,gt2,gt3,Ye,ZP,ZER,cplcFeFvcHpL(gt1,gt2,gt3),               & 
& cplcFeFvcHpR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFuFdVWpL = 0._dp 
cplcFuFdVWpR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFuFdVWpT(gt1,gt2,g2,ZDL,ZUL,cplcFuFdVWpL(gt1,gt2),cplcFuFdVWpR(gt1,gt2))

 End Do 
End Do 


cplcFdFdVZL = 0._dp 
cplcFdFdVZR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFdFdVZT(gt1,gt2,g1,g2,TW,cplcFdFdVZL(gt1,gt2),cplcFdFdVZR(gt1,gt2))

 End Do 
End Do 


cplcFvFeVWpL = 0._dp 
cplcFvFeVWpR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFvFeVWpT(gt1,gt2,g2,ZEL,cplcFvFeVWpL(gt1,gt2),cplcFvFeVWpR(gt1,gt2))

 End Do 
End Do 


cplcFeFeVZL = 0._dp 
cplcFeFeVZR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFeFeVZT(gt1,gt2,g1,g2,TW,cplcFeFeVZL(gt1,gt2),cplcFeFeVZR(gt1,gt2))

 End Do 
End Do 


cplcFuFuVZL = 0._dp 
cplcFuFuVZR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFuFuVZT(gt1,gt2,g1,g2,TW,cplcFuFuVZL(gt1,gt2),cplcFuFuVZR(gt1,gt2))

 End Do 
End Do 


cplcFvFvVZL = 0._dp 
cplcFvFvVZR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFvFvVZT(gt1,gt2,g1,g2,TW,cplcFvFvVZL(gt1,gt2),cplcFvFvVZR(gt1,gt2))

 End Do 
End Do 


cplcFeFvcVWpL = 0._dp 
cplcFeFvcVWpR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFeFvcVWpT(gt1,gt2,g2,ZEL,cplcFeFvcVWpL(gt1,gt2),cplcFeFvcVWpR(gt1,gt2))

 End Do 
End Do 


Iname = Iname - 1 
 
End subroutine CouplingsFor_Fe_decays_3B
 
Subroutine CouplingsFor_Fd_decays_3B(m_in,i1,MAhinput,MAh2input,MFdinput,             & 
& MFd2input,MFeinput,MFe2input,MFuinput,MFu2input,MHapinput,MHap2input,Mhhainput,        & 
& Mhha2input,MHhSMinput,MHhSM2input,MHpinput,MHp2input,Msigainput,Msiga2input,           & 
& MVWpinput,MVWp2input,MVZinput,MVZ2input,TWinput,ZDRinput,ZERinput,ZURinput,            & 
& vinput,ZDLinput,ZELinput,ZULinput,ZAinput,ZHinput,ZPinput,ZWinput,ZZinput,             & 
& betaHinput,g1input,g2input,g3input,lam1input,lam3input,lam4input,lam2input,            & 
& lam12input,lam7input,lam11input,lam10input,lam13input,lam6input,lam14input,            & 
& lam5input,lam8input,Yuinput,Ydinput,Yeinput,mu1input,mu2input,mu0input,v1input,        & 
& v2input,cplcFdFdAhL,cplcFdFdAhR,cplcFdFdHhSML,cplcFdFdHhSMR,cplcFdFdVZL,               & 
& cplcFdFdVZR,cplcFdFucHpL,cplcFdFucHpR,cplcFdFucVWpL,cplcFdFucVWpR,cplcFeFeAhL,         & 
& cplcFeFeAhR,cplcFeFeHhSML,cplcFeFeHhSMR,cplcFeFeVZL,cplcFeFeVZR,cplcFuFdHpL,           & 
& cplcFuFdHpR,cplcFuFdVWpL,cplcFuFdVWpR,cplcFuFuAhL,cplcFuFuAhR,cplcFuFuHhSML,           & 
& cplcFuFuHhSMR,cplcFuFuVZL,cplcFuFuVZR,cplcFvFeHpL,cplcFvFeHpR,cplcFvFeVWpL,            & 
& cplcFvFeVWpR,cplcFvFvVZL,cplcFvFvVZR,deltaM)

Implicit None 

Real(dp), Intent(in) :: m_in 
Real(dp), Intent(in) :: deltaM 
Integer, Intent(in) :: i1 
Real(dp),Intent(in) :: g1input,g2input,g3input,lam1input,lam3input,lam4input,lam2input,lam12input,           & 
& lam7input,lam11input,lam10input,lam13input,lam6input,lam14input,lam5input,             & 
& lam8input,mu1input,mu2input,mu0input,v1input,v2input

Complex(dp),Intent(in) :: Yuinput(3,3),Ydinput(3,3),Yeinput(3,3)

Real(dp),Intent(in) :: MAhinput(3),MAh2input(3),MFdinput(3),MFd2input(3),MFeinput(3),MFe2input(3),           & 
& MFuinput(3),MFu2input(3),MHapinput,MHap2input,Mhhainput,Mhha2input,MHhSMinput(3),      & 
& MHhSM2input(3),MHpinput(3),MHp2input(3),Msigainput,Msiga2input,MVWpinput,              & 
& MVWp2input,MVZinput,MVZ2input,TWinput,vinput,ZAinput(3,3),ZHinput(3,3),ZPinput(3,3),   & 
& ZZinput(2,2),betaHinput

Complex(dp),Intent(in) :: ZDRinput(3,3),ZERinput(3,3),ZURinput(3,3),ZDLinput(3,3),ZELinput(3,3),ZULinput(3,3),  & 
& ZWinput(2,2)

Real(dp) :: g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,            & 
& lam8,mu1,mu2,mu0,v1,v2

Complex(dp) :: Yu(3,3),Yd(3,3),Ye(3,3)

Complex(dp),Intent(out) :: cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFdFdHhSML(3,3,3),cplcFdFdHhSMR(3,3,3),      & 
& cplcFdFdVZL(3,3),cplcFdFdVZR(3,3),cplcFdFucHpL(3,3,3),cplcFdFucHpR(3,3,3),             & 
& cplcFdFucVWpL(3,3),cplcFdFucVWpR(3,3),cplcFeFeAhL(3,3,3),cplcFeFeAhR(3,3,3),           & 
& cplcFeFeHhSML(3,3,3),cplcFeFeHhSMR(3,3,3),cplcFeFeVZL(3,3),cplcFeFeVZR(3,3),           & 
& cplcFuFdHpL(3,3,3),cplcFuFdHpR(3,3,3),cplcFuFdVWpL(3,3),cplcFuFdVWpR(3,3),             & 
& cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcFuFuHhSML(3,3,3),cplcFuFuHhSMR(3,3,3),       & 
& cplcFuFuVZL(3,3),cplcFuFuVZR(3,3),cplcFvFeHpL(3,3,3),cplcFvFeHpR(3,3,3),               & 
& cplcFvFeVWpL(3,3),cplcFvFeVWpR(3,3),cplcFvFvVZL(3,3),cplcFvFvVZR(3,3)

Integer :: i2, i3, gt1, gt2, gt3, kont 
Real(dp) :: MAh(3),MAh2(3),MFd(3),MFd2(3),MFe(3),MFe2(3),MFu(3),MFu2(3),MHap,MHap2,               & 
& Mhha,Mhha2,MHhSM(3),MHhSM2(3),MHp(3),MHp2(3),Msiga,Msiga2,MVWp,MVWp2,MVZ,              & 
& MVZ2,TW,v,ZA(3,3),ZH(3,3),ZP(3,3),ZZ(2,2),betaH

Complex(dp) :: ZDR(3,3),ZER(3,3),ZUR(3,3),ZDL(3,3),ZEL(3,3),ZUL(3,3),ZW(2,2)

Real(dp) :: gSM(11), sinW2, dt, tz, Qin 
Iname = Iname + 1 
NameOfUnit(Iname) = 'Couplings_Fd_3B'
 
sinW2=1._dp-mW2/mZ2 
g1 = g1input 
g2 = g2input 
g3 = g3input 
lam1 = lam1input 
lam3 = lam3input 
lam4 = lam4input 
lam2 = lam2input 
lam12 = lam12input 
lam7 = lam7input 
lam11 = lam11input 
lam10 = lam10input 
lam13 = lam13input 
lam6 = lam6input 
lam14 = lam14input 
lam5 = lam5input 
lam8 = lam8input 
Yu = Yuinput 
Yd = Ydinput 
Ye = Yeinput 
mu1 = mu1input 
mu2 = mu2input 
mu0 = mu0input 
v1 = v1input 
v2 = v2input 
Qin=sqrt(getRenormalizationScale()) 
If (m_in.le.Qin) Then 
  If (m_in.le.mz) Then 
    Call RunSM(mz,deltaM,v2/v1,g1,g2,g3,Yu,Yd,Ye,v1,v2) 
  Else 
    Call RunSM(m_in,deltaM,v2/v1,g1,g2,g3,Yu,Yd,Ye,v1,v2) 
  End if 
End if 
Call SolveTadpoleEquations(g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,             & 
& lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,v1,v2,(/ ZeroC, ZeroC, ZeroC, ZeroC /))

! --- Calculate running tree-level masses for loop induced couplings and Quark mixing matrices --- 
Call TreeMasses(MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,MHap2,Mhha,Mhha2,            & 
& MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,ZER,ZUR,v,               & 
& ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,v1,v2,g1,g2,g3,lam1,lam3,lam4,lam2,lam12,             & 
& lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,.True.,kont)

If (ExternalZfactors) Then 
! --- Use the 1-loop mixing matrices calculated at M_SUSY in the vertices --- 
ZA = ZAinput 
ZH = ZHinput 
ZP = ZPinput 
ZW = ZWinput 
ZZ = ZZinput 
End if 
If (PoleMassesInLoops) Then 
! --- Use the pole masses --- 
MAh = MAhinput 
MAh2 = MAh2input 
MFd = MFdinput 
MFd2 = MFd2input 
MFe = MFeinput 
MFe2 = MFe2input 
MFu = MFuinput 
MFu2 = MFu2input 
MHap = MHapinput 
MHap2 = MHap2input 
Mhha = Mhhainput 
Mhha2 = Mhha2input 
MHhSM = MHhSMinput 
MHhSM2 = MHhSM2input 
MHp = MHpinput 
MHp2 = MHp2input 
Msiga = Msigainput 
Msiga2 = Msiga2input 
MVWp = MVWpinput 
MVWp2 = MVWp2input 
MVZ = MVZinput 
MVZ2 = MVZ2input 
v = vinput 
betaH = betaHinput 
End if 
cplcFdFdAhL = 0._dp 
cplcFdFdAhR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFdFdAhT(gt1,gt2,gt3,Yd,ZA,ZDL,ZDR,cplcFdFdAhL(gt1,gt2,gt3)              & 
& ,cplcFdFdAhR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFeFeAhL = 0._dp 
cplcFeFeAhR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFeFeAhT(gt1,gt2,gt3,Ye,ZA,ZEL,ZER,cplcFeFeAhL(gt1,gt2,gt3)              & 
& ,cplcFeFeAhR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFuFuAhL = 0._dp 
cplcFuFuAhR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFuFuAhT(gt1,gt2,gt3,Yu,ZA,ZUL,ZUR,cplcFuFuAhL(gt1,gt2,gt3)              & 
& ,cplcFuFuAhR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFdFdHhSML = 0._dp 
cplcFdFdHhSMR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFdFdHhSMT(gt1,gt2,gt3,Yd,ZH,ZDL,ZDR,cplcFdFdHhSML(gt1,gt2,gt3)          & 
& ,cplcFdFdHhSMR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFuFdHpL = 0._dp 
cplcFuFdHpR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFuFdHpT(gt1,gt2,gt3,Yu,Yd,ZP,ZDL,ZDR,ZUL,ZUR,cplcFuFdHpL(gt1,gt2,gt3)   & 
& ,cplcFuFdHpR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFeFeHhSML = 0._dp 
cplcFeFeHhSMR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFeFeHhSMT(gt1,gt2,gt3,Ye,ZH,ZEL,ZER,cplcFeFeHhSML(gt1,gt2,gt3)          & 
& ,cplcFeFeHhSMR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFvFeHpL = 0._dp 
cplcFvFeHpR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFvFeHpT(gt1,gt2,gt3,Ye,ZP,ZER,cplcFvFeHpL(gt1,gt2,gt3),cplcFvFeHpR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFuFuHhSML = 0._dp 
cplcFuFuHhSMR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFuFuHhSMT(gt1,gt2,gt3,Yu,ZH,ZUL,ZUR,cplcFuFuHhSML(gt1,gt2,gt3)          & 
& ,cplcFuFuHhSMR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFdFucHpL = 0._dp 
cplcFdFucHpR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
  Do gt3 = 1, 3
Call CouplingcFdFucHpT(gt1,gt2,gt3,Yu,Yd,ZP,ZDL,ZDR,ZUL,ZUR,cplcFdFucHpL(gt1,gt2,gt3) & 
& ,cplcFdFucHpR(gt1,gt2,gt3))

  End Do 
 End Do 
End Do 


cplcFuFdVWpL = 0._dp 
cplcFuFdVWpR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFuFdVWpT(gt1,gt2,g2,ZDL,ZUL,cplcFuFdVWpL(gt1,gt2),cplcFuFdVWpR(gt1,gt2))

 End Do 
End Do 


cplcFdFdVZL = 0._dp 
cplcFdFdVZR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFdFdVZT(gt1,gt2,g1,g2,TW,cplcFdFdVZL(gt1,gt2),cplcFdFdVZR(gt1,gt2))

 End Do 
End Do 


cplcFvFeVWpL = 0._dp 
cplcFvFeVWpR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFvFeVWpT(gt1,gt2,g2,ZEL,cplcFvFeVWpL(gt1,gt2),cplcFvFeVWpR(gt1,gt2))

 End Do 
End Do 


cplcFeFeVZL = 0._dp 
cplcFeFeVZR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFeFeVZT(gt1,gt2,g1,g2,TW,cplcFeFeVZL(gt1,gt2),cplcFeFeVZR(gt1,gt2))

 End Do 
End Do 


cplcFuFuVZL = 0._dp 
cplcFuFuVZR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFuFuVZT(gt1,gt2,g1,g2,TW,cplcFuFuVZL(gt1,gt2),cplcFuFuVZR(gt1,gt2))

 End Do 
End Do 


cplcFdFucVWpL = 0._dp 
cplcFdFucVWpR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFdFucVWpT(gt1,gt2,g2,ZDL,ZUL,cplcFdFucVWpL(gt1,gt2),cplcFdFucVWpR(gt1,gt2))

 End Do 
End Do 


cplcFvFvVZL = 0._dp 
cplcFvFvVZR = 0._dp 
Do gt1 = 1, 3
 Do gt2 = 1, 3
Call CouplingcFvFvVZT(gt1,gt2,g1,g2,TW,cplcFvFvVZL(gt1,gt2),cplcFvFvVZR(gt1,gt2))

 End Do 
End Do 


Iname = Iname - 1 
 
End subroutine CouplingsFor_Fd_decays_3B
 
Function NFlav(m_in) 
Implicit None 
Real(dp), Intent(in) :: m_in 
Real(dp) :: NFlav 
If (m_in.lt.mf_d(3)) Then 
  NFlav = 4._dp 
Else If (m_in.lt.mf_u(3)) Then 
  NFlav = 5._dp 
Else 
  NFlav = 6._dp 
End if 
End Function

Subroutine RunSM(scale_out,deltaM,tb,g1,g2,g3,Yu, Yd, Ye, vd, vu) 
Implicit None
Real(dp), Intent(in) :: scale_out,deltaM, tb
Real(dp), Intent(out) :: g1, g2, g3, vd, vu
Complex(dp), Intent(out) :: Yu(3,3), Yd(3,3), Ye(3,3)
Real(dp) :: dt, gSM(14), gSM2(2), gSM3(3), mtopMS,  sinw2, vev, tz, alphaStop 
Integer :: kont

RunningTopMZ = .false.

Yd = 0._dp
Ye = 0._dp
Yu = 0._dp

If (.not.RunningTopMZ) Then

! Calculating alpha_S(m_top)
gSM2(1)=sqrt(Alpha_mZ*4*Pi) 
gSM2(2)=sqrt(AlphaS_mZ*4*Pi) 


tz=Log(sqrt(mz2)/mf_u(3)) 
dt=tz/50._dp 
Call odeint(gSM2,2,tz,0._dp,deltaM,dt,0._dp,RGEAlphaS,kont)



alphaStop = gSM2(2)**2/4._dp/Pi



! m_top^pole to m_top^MS(m_top) 

mtopMS = mf_u(3)*(1._dp - 4._dp/3._dp*alphaStop/Pi)


! Running m_top^MS(m_top) to M_Z 

gSM3(1)=gSM2(1) 
gSM3(2)=gSM2(2)
gSM3(3)=mtopMS

tz=Log(sqrt(mz2)/mf_u(3)) 
dt=tz/50._dp 
Call odeint(gSM3,3,0._dp,tz,deltaM,dt,0._dp,RGEtop,kont)


mf_u_mz_running = gSM3(3)


RunningTopMZ = .True.

End if

! Starting values at MZ

gSM(1)=sqrt(Alpha_mZ*4*Pi) 
gSM(2)=sqrt(AlphaS_mZ*4*Pi) 
gSM(3)= 0.486E-03_dp ! mf_l_mz(1) 
gSM(4)= 0.10272 !mf_l_mz(2) 
gSM(5)= 1.74624 !mf_l_mz(3) 
gSM(6)= 1.27E-03_dp ! mf_u_mz(1) 
gSM(7)= 0.619  ! mf_u_mz(2) 
gSM(8)= mf_u_mz_running ! m_top 
gSM(9)= 2.9E-03_dp !mf_d_mz(1) 
gSM(10)= 0.055 !mf_d_mz(2) 
gSM(11)= 2.85 ! mf_d_mz(3) 
 

! To get the running sin(w2) 
SinW2 = 0.22290_dp
gSM(12) = 5._dp/3._dp*Alpha_MZ/(1-sinW2)
gSM(13) = Alpha_MZ/Sinw2
gSM(14) = AlphaS_mZ

  nUp =2._dp 
  nDown =3._dp 
  nLep =3._dp 
 

If (scale_out.gt.sqrt(mz2)) Then

 ! From M_Z to Min(M_top,scale_out) 
 If (scale_out.gt.mf_u(3)) Then 
  tz=Log(sqrt(mz2)/mf_u(3)) 
  dt=tz/50._dp 
 Else 
  tz=Log(sqrt(mz2)/scale_out) 
  dt=tz/50._dp 
 End if 

  Call odeint(gSM,14,tz,0._dp,deltaM,dt,0._dp,rge11,kont)


 ! From M_top to M_SUSY if M_top < M_SUSY 
 If (scale_out.gt.mf_u(3)) Then 
  tz=Log(mf_u(3)/scale_out) 
  dt=tz/50._dp 
  nUp =3._dp 
  Call odeint(gSM,14,tz,0._dp,deltaM,dt,0._dp,rge11,kont)
 End if 
Else

 ! From M_Z down to scale_out
  tz=Log(scale_out/sqrt(mz2)) 
  dt=tz/50._dp 
  Call odeint(gSM,14,0._dp,tz,deltaM,dt,0._dp,rge11_SMa,kont)

End if

! Calculating Couplings 

 sinW2=1._dp-mW2/mZ2 
 vev=Sqrt(mZ2*(1._dp-sinW2)*SinW2/(gSM(1)**2/4._dp))
 vd=vev/Sqrt(1._dp+tb**2)
 vu=tb*vd
 
Yd(1,1) =gSM(9)*sqrt(2._dp)/vd 
Yd(2,2) =gSM(10)*sqrt(2._dp)/vd 
Yd(3,3) =gSM(11)*sqrt(2._dp)/vd 
Ye(1,1) =gSM(3)*sqrt(2._dp)/vd 
Ye(2,2)=gSM(4)*sqrt(2._dp)/vd 
Ye(3,3)=gSM(5)*sqrt(2._dp)/vd 
Yu(1,1)=gSM(6)*sqrt(2._dp)/vu 
Yu(2,2)=gSM(7)*sqrt(2._dp)/vu 
Yu(3,3)=gSM(8)*sqrt(2._dp)/vu 


g3 =gSM(2) 
g3running=gSM(2) 

g1 = sqrt(gSM(12)*4._dp*Pi*3._dp/5._dp)
g2 = sqrt(gSM(13)*4._dp*Pi)
! g3 = sqrt(gSM(3)*4._dp*Pi)

sinw2 = g1**2/(g1**2 + g2**2)

!g2=gSM(1)/sqrt(sinW2) 
!g1 = g2*Sqrt(sinW2/(1._dp-sinW2)) 

If (GenerationMixing) Then 

If (YukawaScheme.Eq.1) Then ! CKM into Yu
 If (TransposedYukawa) Then ! check, if superpotential is Yu Hu u q  or Yu Hu q u
   Yu= Matmul(Transpose(CKM),Transpose(Yu))
 Else 
   Yu=Transpose(Matmul(Transpose(CKM),Transpose(Yu)))
 End if 

Else ! CKM into Yd 
 
 If (TransposedYukawa) Then ! 
  Yd= Matmul(Conjg(CKM),Transpose(Yd))
 Else 
  Yd=Transpose(Matmul(Conjg(CKM),Transpose(Yd)))
 End if 

End if ! Yukawa scheme
End If ! Generatoin mixing


End Subroutine RunSM


Subroutine RunSMohdm(scale_out,deltaM,g1,g2,g3,Yu, Yd, Ye, v) 
Implicit None
Real(dp), Intent(in) :: scale_out,deltaM
Real(dp), Intent(out) :: g1, g2, g3, v
Complex(dp), Intent(out) :: Yu(3,3), Yd(3,3), Ye(3,3)
Real(dp) :: dt, gSM(14), gSM2(2), gSM3(3), mtopMS,  sinw2, vev, tz, alphaStop 
Integer :: kont

Yd = 0._dp
Ye = 0._dp
Yu = 0._dp

If (.not.RunningTopMZ) Then

! Calculating alpha_S(m_top)
gSM2(1)=sqrt(Alpha_mZ*4*Pi) 
gSM2(2)=sqrt(AlphaS_mZ*4*Pi) 


tz=Log(sqrt(mz2)/mf_u(3)) 
dt=tz/50._dp 
Call odeint(gSM2,2,tz,0._dp,deltaM,dt,0._dp,RGEAlphaS,kont)



alphaStop = gSM2(2)**2/4._dp/Pi



! m_top^pole to m_top^MS(m_top) 

mtopMS = mf_u(3)*(1._dp - 4._dp/3._dp*alphaStop/Pi)


! Running m_top^MS(m_top) to M_Z 

gSM3(1)=gSM2(1) 
gSM3(2)=gSM2(2)
gSM3(3)=mtopMS

tz=Log(sqrt(mz2)/mf_u(3)) 
dt=tz/50._dp 
Call odeint(gSM3,3,0._dp,tz,deltaM,dt,0._dp,RGEtop,kont)


mf_u_mz_running = gSM3(3)


RunningTopMZ = .True.

End if

! Starting values at MZ

gSM(1)=sqrt(Alpha_mZ*4*Pi) 
gSM(2)=sqrt(AlphaS_mZ*4*Pi) 
gSM(3)= 0.486E-03_dp ! mf_l_mz(1) 
gSM(4)= 0.10272 !mf_l_mz(2) 
gSM(5)= 1.74624 !mf_l_mz(3) 
gSM(6)= 1.27E-03_dp ! mf_u_mz(1) 
gSM(7)= 0.619  ! mf_u_mz(2) 
gSM(8)= mf_u_mz_running ! m_top 
gSM(9)= 2.9E-03_dp !mf_d_mz(1) 
gSM(10)= 0.055 !mf_d_mz(2) 
gSM(11)= 2.85 ! mf_d_mz(3) 
 

! To get the running sin(w2) 
SinW2 = 0.22290_dp
gSM(12) = 5._dp/3._dp*Alpha_MZ/(1-sinW2)
gSM(13) = Alpha_MZ/Sinw2
gSM(14) = AlphaS_mZ

  nUp =2._dp 
  nDown =3._dp 
  nLep =3._dp 
 

If (scale_out.gt.sqrt(mz2)) Then

 ! From M_Z to Min(M_top,scale_out) 
 If (scale_out.gt.mf_u(3)) Then 
  tz=Log(sqrt(mz2)/mf_u(3)) 
  dt=tz/50._dp 
 Else 
  tz=Log(sqrt(mz2)/scale_out) 
  dt=tz/50._dp 
 End if 

  Call odeint(gSM,14,tz,0._dp,deltaM,dt,0._dp,rge11,kont)


 ! From M_top to M_SUSY if M_top < M_SUSY 
 If (scale_out.gt.mf_u(3)) Then 
  tz=Log(mf_u(3)/scale_out) 
  dt=tz/50._dp 
  nUp =3._dp 
  Call odeint(gSM,14,tz,0._dp,deltaM,dt,0._dp,rge11,kont)
 End if 
Else

 ! From M_Z down to scale_out
  If (abs(scale_out - sqrt(mz2)).gt.1.0E-3_dp) Then 
   tz=Log(scale_out/sqrt(mz2)) 
   dt=tz/50._dp 
   Call odeint(gSM,14,0._dp,tz,deltaM,dt,0._dp,rge11_SMa,kont)
  End if
End if

! Calculating Couplings 

 sinW2=1._dp-mW2/mZ2 
 vev=Sqrt(mZ2*(1._dp-sinW2)*SinW2/(gSM(1)**2/4._dp))
 v = vev
 
Yd(1,1) =gSM(9)*sqrt(2._dp)/v 
Yd(2,2) =gSM(10)*sqrt(2._dp)/v 
Yd(3,3) =gSM(11)*sqrt(2._dp)/v 
Ye(1,1) =gSM(3)*sqrt(2._dp)/v 
Ye(2,2)=gSM(4)*sqrt(2._dp)/v 
Ye(3,3)=gSM(5)*sqrt(2._dp)/v 
Yu(1,1)=gSM(6)*sqrt(2._dp)/v 
Yu(2,2)=gSM(7)*sqrt(2._dp)/v 
Yu(3,3)=gSM(8)*sqrt(2._dp)/v 


g3 =gSM(2) 
g3running=gSM(2) 

g1 = sqrt(gSM(12)*4._dp*Pi*3._dp/5._dp)
g2 = sqrt(gSM(13)*4._dp*Pi)
! g3 = sqrt(gSM(3)*4._dp*Pi)

sinw2 = g1**2/(g1**2 + g2**2)

g2=gSM(1)/sqrt(sinW2) 
g1 = g2*Sqrt(sinW2/(1._dp-sinW2)) 

If (GenerationMixing) Then 

If (YukawaScheme.Eq.1) Then ! CKM into Yu
 If (TransposedYukawa) Then ! check, if superpotential is Yu Hu u q  or Yu Hu q u
   Yu= Matmul(Transpose(CKM),Transpose(Yu))
 Else 
   Yu=Transpose(Matmul(Transpose(CKM),Transpose(Yu)))
 End if 

Else ! CKM into Yd 
 
 If (TransposedYukawa) Then ! 
  Yd= Matmul(Conjg(CKM),Transpose(Yd))
 Else 
  Yd=Transpose(Matmul(Conjg(CKM),Transpose(Yd)))
 End if 

End if ! Yukawa scheme
End If ! Generation mixing



End Subroutine RunSMohdm

Subroutine RunSMgauge(scale_out,deltaM,g1,g2,g3) 
Implicit None
Real(dp), Intent(in) :: scale_out,deltaM
Real(dp), Intent(out) :: g1, g2, g3
Complex(dp) :: Yu(3,3), Yd(3,3), Ye(3,3)
Real(dp) :: v, dt, gSM(14), gSM2(2), gSM3(3), mtopMS,  sinw2, vev, tz, alphaStop 
Integer :: kont

Yd = 0._dp
Ye = 0._dp
Yu = 0._dp

RunningTopMZ = .false.

If (.not.RunningTopMZ) Then

! Calculating alpha_S(m_top)
gSM2(1)=sqrt(Alpha_mZ*4*Pi) 
gSM2(2)=sqrt(AlphaS_mZ*4*Pi) 


tz=Log(sqrt(mz2)/mf_u(3)) 
dt=tz/50._dp 
Call odeint(gSM2,2,tz,0._dp,deltaM,dt,0._dp,RGEAlphaS,kont)



alphaStop = gSM2(2)**2/4._dp/Pi



! m_top^pole to m_top^MS(m_top) 

mtopMS = mf_u(3)*(1._dp - 4._dp/3._dp*alphaStop/Pi)


! Running m_top^MS(m_top) to M_Z 

gSM3(1)=gSM2(1) 
gSM3(2)=gSM2(2)
gSM3(3)=mtopMS

tz=Log(sqrt(mz2)/mf_u(3)) 
dt=tz/50._dp 
Call odeint(gSM3,3,0._dp,tz,deltaM,dt,0._dp,RGEtop,kont)


mf_u_mz_running = gSM3(3)


RunningTopMZ = .True.

End if

! Starting values at MZ

gSM(1)=sqrt(Alpha_mZ*4*Pi) 
gSM(2)=sqrt(AlphaS_mZ*4*Pi) 
gSM(3)= 0.486E-03_dp ! mf_l_mz(1) 
gSM(4)= 0.10272 !mf_l_mz(2) 
gSM(5)= 1.74624 !mf_l_mz(3) 
gSM(6)= 1.27E-03_dp ! mf_u_mz(1) 
gSM(7)= 0.619  ! mf_u_mz(2) 
gSM(8)= mf_u_mz_running ! m_top 
gSM(9)= 2.9E-03_dp !mf_d_mz(1) 
gSM(10)= 0.055 !mf_d_mz(2) 
gSM(11)= 2.85 ! mf_d_mz(3) 
 

! To get the running sin(w2) 
SinW2 = 0.22290_dp
gSM(12) = 5._dp/3._dp*Alpha_MZ/(1-sinW2)
gSM(13) = Alpha_MZ/Sinw2
gSM(14) = AlphaS_mZ

  nUp =2._dp 
  nDown =3._dp 
  nLep =3._dp 
 

If (scale_out.gt.sqrt(mz2)) Then

 ! From M_Z to Min(M_top,scale_out) 
 If (scale_out.gt.mf_u(3)) Then 
  tz=Log(sqrt(mz2)/mf_u(3)) 
  dt=tz/50._dp 
 Else 
  tz=Log(sqrt(mz2)/scale_out) 
  dt=tz/50._dp 
 End if 

  Call odeint(gSM,14,tz,0._dp,deltaM,dt,0._dp,rge11,kont)


 ! From M_top to M_SUSY if M_top < M_SUSY 
 If (scale_out.gt.mf_u(3)) Then 
  tz=Log(mf_u(3)/scale_out) 
  dt=tz/50._dp 
  nUp =3._dp 
  Call odeint(gSM,14,tz,0._dp,deltaM,dt,0._dp,rge11,kont)
 End if 
Else

 ! From M_Z down to scale_out
  tz=Log(scale_out/sqrt(mz2)) 
  dt=tz/50._dp 
  Call odeint(gSM,14,0._dp,tz,deltaM,dt,0._dp,rge11_SMa,kont)

End if

! Calculating Couplings 

 sinW2=1._dp-mW2/mZ2 
 vev=Sqrt(mZ2*(1._dp-sinW2)*SinW2/(gSM(1)**2/4._dp))
 v = vev
 
Yd(1,1) =gSM(9)*sqrt(2._dp)/v 
Yd(2,2) =gSM(10)*sqrt(2._dp)/v 
Yd(3,3) =gSM(11)*sqrt(2._dp)/v 
Ye(1,1) =gSM(3)*sqrt(2._dp)/v 
Ye(2,2)=gSM(4)*sqrt(2._dp)/v 
Ye(3,3)=gSM(5)*sqrt(2._dp)/v 
Yu(1,1)=gSM(6)*sqrt(2._dp)/v 
Yu(2,2)=gSM(7)*sqrt(2._dp)/v 
Yu(3,3)=gSM(8)*sqrt(2._dp)/v 


g3 =gSM(2) 
g3running=gSM(2) 

g1 = sqrt(gSM(12)*4._dp*Pi*3._dp/5._dp)
g2 = sqrt(gSM(13)*4._dp*Pi)
! g3 = sqrt(gSM(3)*4._dp*Pi)

sinw2 = g1**2/(g1**2 + g2**2)

g2=gSM(1)/sqrt(sinW2) 
g1 = g2*Sqrt(sinW2/(1._dp-sinW2)) 

If (GenerationMixing) Then 
If (TransposedYukawa) Then ! check, if superpotential is Yu Hu u q  or Yu Hu q u
 Yu= Matmul(Transpose(CKM),Transpose(Yu))
Else 
 Yu=Transpose(Matmul(Transpose(CKM),Transpose(Yu)))
End if 
End If


End Subroutine RunSMgauge
End Module CouplingsForDecays_4HDM_S3
