! -----------------------------------------------------------------------------  
! This file was automatically created by SARAH version 4.12.3 
! SARAH References: arXiv:0806.0538, 0909.2863, 1002.0840, 1207.0906, 1309.7223  
! (c) Florian Staub, 2013  
! ------------------------------------------------------------------------------  
! File created at 8:16 on 5.4.2018   
! ----------------------------------------------------------------------  
 
 
Module Tadpoles_4HDM_S3 
 
Use Model_Data_4HDM_S3 
Use TreeLevelMasses_4HDM_S3 
Use Control 
Use Settings 
Use Mathematics 

Contains 


Subroutine SolveTadpoleEquations(g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,             & 
& lam11,lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,v1,v2,Tad1Loop)

Implicit None
Real(dp),Intent(inout) :: g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,            & 
& lam8,mu1,mu2,mu0,v1,v2

Complex(dp),Intent(inout) :: Yu(3,3),Yd(3,3),Ye(3,3)

Complex(dp), Intent(in) :: Tad1Loop(4)

! For numerical routines 
Real(dp) :: gC(75)
logical :: broycheck 
Real(dp) :: broyx(2)

If (HighScaleModel.Eq."LOW") Then 
mu0 = -((lam8*v1**3 + 2*lam5*v1*v2**2 + 2*lam6*v1*v2**2 + 4*lam7*v1*v2**2 + 4*lam4*v2**3 -  & 
&  Tad1Loop(1))/v1)
mu1 = -(lam5*v1**2)/2._dp - (lam6*v1**2)/2._dp - lam7*v1**2 - 3*lam4*v1*v2 - 4*lam1*v2**2 - & 
&  4*lam3*v2**2 + Tad1Loop(2)/(sqrt(3._dp)*v2)

 ! ----------- Check solutions for consistency  -------- 

 ! Check for NaNs 
If (mu0.ne.mu0) Then 
   Write(*,*) "NaN appearing in solution of tadpole equations for mu0" 
   Call TerminateProgram  
 End If 
 If (mu1.ne.mu1) Then 
   Write(*,*) "NaN appearing in solution of tadpole equations for mu1" 
   Call TerminateProgram  
 End If 
 Else 
mu0 = -((lam8*v1**3 + 2*lam5*v1*v2**2 + 2*lam6*v1*v2**2 + 4*lam7*v1*v2**2 + 4*lam4*v2**3 -  & 
&  Tad1Loop(1))/v1)
mu1 = -(lam5*v1**2)/2._dp - (lam6*v1**2)/2._dp - lam7*v1**2 - 3*lam4*v1*v2 - 4*lam1*v2**2 - & 
&  4*lam3*v2**2 + Tad1Loop(2)/(sqrt(3._dp)*v2)

 ! ----------- Check solutions for consistency  -------- 

 ! Check for NaNs 
If (mu0.ne.mu0) Then 
   Write(*,*) "NaN appearing in solution of tadpole equations for mu0" 
   Call TerminateProgram  
 End If 
 If (mu1.ne.mu1) Then 
   Write(*,*) "NaN appearing in solution of tadpole equations for mu1" 
   Call TerminateProgram  
 End If 
 End if 
End Subroutine SolveTadpoleEquations

Subroutine CalculateTadpoles(g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,           & 
& lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,v1,v2,Tad1Loop,TadpoleValues)

Real(dp),Intent(in) :: g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,            & 
& lam8,mu1,mu2,mu0,v1,v2

Complex(dp),Intent(in) :: Yu(3,3),Yd(3,3),Ye(3,3)

Complex(dp), Intent(in) :: Tad1Loop(3)

Real(dp), Intent(out) :: TadpoleValues(3)

TadpoleValues(1) = Real(lam8*v1**3 + 4*lam4*v2**3 + v1*(mu0 + 2*(lam5 + lam6 + 2._dp*(lam7))& 
& *v2**2) - Tad1Loop(1),dp) 
TadpoleValues(2) = Real((sqrt(3._dp)*v2*(2._dp*(mu1) + (lam5 + lam6 + 2._dp*(lam7))   & 
& *v1**2 + 6*lam4*v1*v2 + 8*(lam1 + lam3)*v2**2))/2._dp - Tad1Loop(2),dp) 
TadpoleValues(3) = Real((v2*(2._dp*(mu1) + (lam5 + lam6 + 2._dp*(lam7))               & 
& *v1**2 + 6*lam4*v1*v2 + 8*(lam1 + lam3)*v2**2))/2._dp - Tad1Loop(2)/sqrt(3._dp),dp) 
End Subroutine CalculateTadpoles 

End Module Tadpoles_4HDM_S3 
 
