! -----------------------------------------------------------------------------  
! This file was automatically created by SARAH version 4.12.3 
! SARAH References: arXiv:0806.0538, 0909.2863, 1002.0840, 1207.0906, 1309.7223  
! (c) Florian Staub, 2013  
! ------------------------------------------------------------------------------  
! File created at 8:11 on 5.4.2018   
! ----------------------------------------------------------------------  
 
 
Module TreeLevelMasses_4HDM_S3 
 
Use Control 
Use Mathematics 
Use MathematicsQP 
Use Settings 
Use Model_Data_4HDM_S3 
!Use StandardModel 
 
 
Logical :: SignOfMassChanged =.False.  
Logical :: SignOfMuChanged =.False.  
Contains 
 
Subroutine TreeMasses(MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,MHap2,Mhha,            & 
& Mhha2,MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,ZER,               & 
& ZUR,v,ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,v1,v2,g1,g2,g3,lam1,lam3,lam4,lam2,             & 
& lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,GenerationMixing,kont)

Implicit None 
 
Real(dp),Intent(in) :: g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,            & 
& lam8,mu1,mu2,mu0

Complex(dp),Intent(in) :: Yu(3,3),Yd(3,3),Ye(3,3)

Real(dp),Intent(out) :: MAh(3),MAh2(3),MFd(3),MFd2(3),MFe(3),MFe2(3),MFu(3),MFu2(3),MHap,MHap2,               & 
& Mhha,Mhha2,MHhSM(3),MHhSM2(3),MHp(3),MHp2(3),Msiga,Msiga2,MVWp,MVWp2,MVZ,              & 
& MVZ2,TW,v,ZA(3,3),ZH(3,3),ZP(3,3),ZZ(2,2),betaH

Complex(dp),Intent(out) :: ZDR(3,3),ZER(3,3),ZUR(3,3),ZDL(3,3),ZEL(3,3),ZUL(3,3),ZW(2,2)

Real(dp),Intent(in) :: v1,v2

Logical, Intent(in) :: GenerationMixing 
Integer, Intent(inout) :: kont 
Integer :: i1,i2,i3,i4,j1,j2,j3,kontSave 
Iname = Iname + 1 
NameOfUnit(Iname) = 'TreeMasses4HDM_S3'
 
kont = 0 
Call CalculateVPVZ(g1,g2,v1,v2,ZZ,MVZ,MVZ2,TW,kont)

Call CalculateVWp(g2,v1,v2,ZW,MVWp,MVWp2,kont)

MHap2 = mu2 + 2*lam10*v2**2 
  If (MHap2.ne.MHap2) Then 
      Write(*,*) 'NaN appearing in MHap2' 
      Call TerminateProgram 
    End If 
  If (MHap2.Ge.0._dp) Then 
MHap = sqrt(MHap2) 
  Else 
    If (ErrorLevel.Ge.0) Then 
      Write(10,*) 'Warning from MHap2' 
      Write(10,*) 'mass squarred is negative: ',MHap2 
    End If 
     Write(ErrCan,*) 'Warning from routine MHap2' 
     Write(ErrCan,*) 'in the calculation of the masses' 
     Write(ErrCan,*) 'occurred a negative mass squared!' 
     Write(ErrCan,*) MHap2 
     Write(*,*) 'Warning from routine MHap2' 
     Write(*,*) 'in the calculation of the masses' 
     Write(*,*) 'occurred a negative mass squared!' 
     Write(*,*) MHap2 
        MHap= 1._dp 
        MHap2= 1._dp 
   SignOfMassChanged = .True. 
 End if 


! ------------------------------- 
Msiga2 = mu2 + (lam14*v1**2)/2._dp + 2*(lam10 + lam11 - 2._dp*(lam12))*v2**2 
  If (Msiga2.ne.Msiga2) Then 
      Write(*,*) 'NaN appearing in Msiga2' 
      Call TerminateProgram 
    End If 
  If (Msiga2.Ge.0._dp) Then 
Msiga = sqrt(Msiga2) 
  Else 
    If (ErrorLevel.Ge.0) Then 
      Write(10,*) 'Warning from Msiga2' 
      Write(10,*) 'mass squarred is negative: ',Msiga2 
    End If 
     Write(ErrCan,*) 'Warning from routine Msiga2' 
     Write(ErrCan,*) 'in the calculation of the masses' 
     Write(ErrCan,*) 'occurred a negative mass squared!' 
     Write(ErrCan,*) Msiga2 
     Write(*,*) 'Warning from routine Msiga2' 
     Write(*,*) 'in the calculation of the masses' 
     Write(*,*) 'occurred a negative mass squared!' 
     Write(*,*) Msiga2 
        Msiga= 1._dp 
        Msiga2= 1._dp 
   SignOfMassChanged = .True. 
 End if 


! ------------------------------- 
Mhha2 = mu2 + (lam14*v1**2)/2._dp + 2*(lam10 + lam11 + 2._dp*(lam12))*v2**2 
  If (Mhha2.ne.Mhha2) Then 
      Write(*,*) 'NaN appearing in Mhha2' 
      Call TerminateProgram 
    End If 
  If (Mhha2.Ge.0._dp) Then 
Mhha = sqrt(Mhha2) 
  Else 
    If (ErrorLevel.Ge.0) Then 
      Write(10,*) 'Warning from Mhha2' 
      Write(10,*) 'mass squarred is negative: ',Mhha2 
    End If 
     Write(ErrCan,*) 'Warning from routine Mhha2' 
     Write(ErrCan,*) 'in the calculation of the masses' 
     Write(ErrCan,*) 'occurred a negative mass squared!' 
     Write(ErrCan,*) Mhha2 
     Write(*,*) 'Warning from routine Mhha2' 
     Write(*,*) 'in the calculation of the masses' 
     Write(*,*) 'occurred a negative mass squared!' 
     Write(*,*) Mhha2 
        Mhha= 1._dp 
        Mhha2= 1._dp 
   SignOfMassChanged = .True. 
 End if 


! ------------------------------- 
Call CalculateMHhSM(mu1,mu0,lam1,lam3,lam4,lam7,lam6,lam5,lam8,v1,v2,ZH,              & 
& MHhSM,MHhSM2,kont)

kontSave = kont 
Call CalculateMAh(g1,g2,mu1,mu0,lam1,lam3,lam4,lam2,lam7,lam6,lam5,lam8,              & 
& v1,v2,TW,ZA,MAh,MAh2,kont)

kont = kontSave 
kontSave = kont 
Call CalculateMHp(g2,mu1,mu0,lam1,lam3,lam4,lam7,lam6,lam5,lam8,v1,v2,ZP,             & 
& MHp,MHp2,kont)

kont = kontSave 
Call CalculateMFd(Yd,v1,ZDL,ZDR,MFd,kont)

MFd2 = MFd**2 
Call CalculateMFu(Yu,v1,ZUL,ZUR,MFu,kont)

MFu2 = MFu**2 
Call CalculateMFe(Ye,v1,ZEL,ZER,MFe,kont)

MFe2 = MFe**2 

 
 Call SortGoldstones(MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,MHap2,Mhha,              & 
& Mhha2,MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,ZER,               & 
& ZUR,v,ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,kont)

If (SignOfMassChanged) Then  
 If (.Not.IgnoreNegativeMasses) Then 
  Write(*,*) " Stopping calculation because of negative mass squared." 
  Call TerminateProgram 
 Else 
  SignOfMassChanged= .False. 
  kont=0  
 End If 
End If 
If (SignOfMuChanged) Then 
 If (.Not.IgnoreMuSignFlip) Then 
  Write(*,*) " Stopping calculation because of negative mass squared in tadpoles." 
  Call TerminateProgram 
 Else 
  SignOfMuChanged= .False. 
  kont=0 
 End If 
End If 

 ! -------------------------------- 
! Setting Goldstone masses 
! -------------------------------- 
 
MAh(1)=MVZ*sqrt(RXiZ)
MAh2(1)=MVZ2*RXiZ
MHp(1)=MVWp*sqrt(RXiWp)
MHp2(1)=MVWp2*RXiWp
TW = ACos(Abs(ZZ(1,1)))
v = Sqrt(v1**2 + 4*v2**2)
betaH = ATan(Abs(ZA(1,3)/ZA(3,3)))
Iname = Iname - 1 
 
End Subroutine  TreeMasses 
 
 
Subroutine RunningFermionMasses(MFeIN,MFe2IN,MFdIN,MFd2IN,MFuIN,MFu2IN,               & 
& v1,v2,g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,            & 
& lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,kont)

Implicit None 
 
Integer, Intent(inout) :: kont 
Real(dp),Intent(in) :: g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,            & 
& lam8,mu1,mu2,mu0

Complex(dp),Intent(in) :: Yu(3,3),Yd(3,3),Ye(3,3)

Real(dp),Intent(in) :: v1,v2

Real(dp),Intent(inout) :: MFeIN(3),MFe2IN(3),MFdIN(3),MFd2IN(3),MFuIN(3),MFu2IN(3)

Real(dp) :: MFe(3),MFe2(3),MFd(3),MFd2(3),MFu(3),MFu2(3)

Call CalculateMFe(Ye,v1,ZEL,ZER,MFe,kont)

MFe2 = MFe**2 
MFeIN(1:2) = MFe(1:2) 
MFe2IN(1:2) = MFe2(1:2) 
Call CalculateMFd(Yd,v1,ZDL,ZDR,MFd,kont)

MFd2 = MFd**2 
MFdIN(1:2) = MFd(1:2) 
MFd2IN(1:2) = MFd2(1:2) 
Call CalculateMFu(Yu,v1,ZUL,ZUR,MFu,kont)

MFu2 = MFu**2 
MFuIN(1:2) = MFu(1:2) 
MFu2IN(1:2) = MFu2(1:2) 
End Subroutine RunningFermionMasses 

Subroutine TreeMassesEffPot(MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,MHap2,           & 
& Mhha,Mhha2,MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,              & 
& ZER,ZUR,v,ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,v1,v2,g1,g2,g3,lam1,lam3,lam4,              & 
& lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,               & 
& mu0,GenerationMixing,kont)

Implicit None 
 
Real(dp),Intent(in) :: g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,            & 
& lam8,mu1,mu2,mu0

Complex(dp),Intent(in) :: Yu(3,3),Yd(3,3),Ye(3,3)

Real(dp),Intent(out) :: MAh(3),MAh2(3),MFd(3),MFd2(3),MFe(3),MFe2(3),MFu(3),MFu2(3),MHap,MHap2,               & 
& Mhha,Mhha2,MHhSM(3),MHhSM2(3),MHp(3),MHp2(3),Msiga,Msiga2,MVWp,MVWp2,MVZ,              & 
& MVZ2,TW,v,ZA(3,3),ZH(3,3),ZP(3,3),ZZ(2,2),betaH

Complex(dp),Intent(out) :: ZDR(3,3),ZER(3,3),ZUR(3,3),ZDL(3,3),ZEL(3,3),ZUL(3,3),ZW(2,2)

Real(dp),Intent(in) :: v1,v2

Logical, Intent(in) :: GenerationMixing 
Integer, Intent(inout) :: kont 
Integer :: i1,i2,i3,i4,j1,j2,j3,kontSave 
Iname = Iname + 1 
NameOfUnit(Iname) = 'TreeMasses4HDM_S3'
 
kont = 0 
Call CalculateVPVZEffPot(g1,g2,v1,v2,ZZ,MVZ,MVZ2,TW,kont)

Call CalculateVWpEffPot(g2,v1,v2,ZW,MVWp,MVWp2,kont)

MHap2 = mu2 + 2*lam10*v2**2 
  If (MHap2.ne.MHap2) Then 
      Write(*,*) 'NaN appearing in MHap2' 
      Call TerminateProgram 
    End If 
  If (MHap2.Ge.0._dp) Then 
MHap = sqrt(MHap2) 
  Else 
 End if 


! ------------------------------- 
Msiga2 = mu2 + (lam14*v1**2)/2._dp + 2*(lam10 + lam11 - 2._dp*(lam12))*v2**2 
  If (Msiga2.ne.Msiga2) Then 
      Write(*,*) 'NaN appearing in Msiga2' 
      Call TerminateProgram 
    End If 
  If (Msiga2.Ge.0._dp) Then 
Msiga = sqrt(Msiga2) 
  Else 
 End if 


! ------------------------------- 
Mhha2 = mu2 + (lam14*v1**2)/2._dp + 2*(lam10 + lam11 + 2._dp*(lam12))*v2**2 
  If (Mhha2.ne.Mhha2) Then 
      Write(*,*) 'NaN appearing in Mhha2' 
      Call TerminateProgram 
    End If 
  If (Mhha2.Ge.0._dp) Then 
Mhha = sqrt(Mhha2) 
  Else 
 End if 


! ------------------------------- 
Call CalculateMHhSMEffPot(mu1,mu0,lam1,lam3,lam4,lam7,lam6,lam5,lam8,v1,              & 
& v2,ZH,MHhSM,MHhSM2,kont)

kontSave = kont 
Call CalculateMAhEffPot(g1,g2,mu1,mu0,lam1,lam3,lam4,lam2,lam7,lam6,lam5,             & 
& lam8,v1,v2,TW,ZA,MAh,MAh2,kont)

kont = kontSave 
kontSave = kont 
Call CalculateMHpEffPot(g2,mu1,mu0,lam1,lam3,lam4,lam7,lam6,lam5,lam8,v1,             & 
& v2,ZP,MHp,MHp2,kont)

kont = kontSave 
Call CalculateMFdEffPot(Yd,v1,ZDL,ZDR,MFd,kont)

MFd2 = MFd**2 
Call CalculateMFuEffPot(Yu,v1,ZUL,ZUR,MFu,kont)

MFu2 = MFu**2 
Call CalculateMFeEffPot(Ye,v1,ZEL,ZER,MFe,kont)

MFe2 = MFe**2 

 
 If (SignOfMassChanged) Then  
 If (.Not.IgnoreNegativeMasses) Then 
  Write(*,*) " Stopping calculation because of negative mass squared." 
  Call TerminateProgram 
 Else 
  SignOfMassChanged= .False. 
  kont=0  
 End If 
End If 
If (SignOfMuChanged) Then 
 If (.Not.IgnoreMuSignFlip) Then 
  Write(*,*) " Stopping calculation because of negative mass squared in tadpoles." 
  Call TerminateProgram 
 Else 
  SignOfMuChanged= .False. 
  kont=0 
 End If 
End If 
Iname = Iname - 1 
 
End Subroutine  TreeMassesEffPot 
 
 
Subroutine CalculateMHhSM(mu1,mu0,lam1,lam3,lam4,lam7,lam6,lam5,lam8,v1,              & 
& v2,ZH,MHhSM,MHhSM2,kont)

Real(dp), Intent(in) :: mu1,mu0,lam1,lam3,lam4,lam7,lam6,lam5,lam8,v1,v2

Integer, Intent(inout) :: kont 
Integer :: i1,i2,i3,i4, ierr 
Integer :: j1,j2,j3,j4, pos 
Real(dp), Intent(out) :: MHhSM(3), MHhSM2(3) 
Real(dp), Intent(out) :: ZH(3,3) 
 
Real(dp) :: mat(3,3)  

Real(dp) ::  test(2) 

Iname = Iname + 1 
NameOfUnit(Iname) = 'CalculateMHhSM'
 
mat(1,1) = 0._dp 
mat(1,1) = mat(1,1)+mu0
mat(1,1) = mat(1,1)+3*lam8*v1**2
mat(1,1) = mat(1,1)+2*lam5*v2**2
mat(1,1) = mat(1,1)+2*lam6*v2**2
mat(1,1) = mat(1,1)+4*lam7*v2**2
mat(1,2) = 0._dp 
mat(1,2) = mat(1,2)+sqrt(3._dp)*lam5*v1*v2
mat(1,2) = mat(1,2)+sqrt(3._dp)*lam6*v1*v2
mat(1,2) = mat(1,2)+2*sqrt(3._dp)*lam7*v1*v2
mat(1,2) = mat(1,2)+3*sqrt(3._dp)*lam4*v2**2
mat(1,3) = 0._dp 
mat(1,3) = mat(1,3)+lam5*v1*v2
mat(1,3) = mat(1,3)+lam6*v1*v2
mat(1,3) = mat(1,3)+2*lam7*v1*v2
mat(1,3) = mat(1,3)+3*lam4*v2**2
mat(2,2) = 0._dp 
mat(2,2) = mat(2,2)+mu1
mat(2,2) = mat(2,2)+(lam5*v1**2)/2._dp
mat(2,2) = mat(2,2)+(lam6*v1**2)/2._dp
mat(2,2) = mat(2,2)+lam7*v1**2
mat(2,2) = mat(2,2)+3*lam4*v1*v2
mat(2,2) = mat(2,2)+10*lam1*v2**2
mat(2,2) = mat(2,2)+10*lam3*v2**2
mat(2,3) = 0._dp 
mat(2,3) = mat(2,3)+3*sqrt(3._dp)*lam4*v1*v2
mat(2,3) = mat(2,3)+2*sqrt(3._dp)*lam1*v2**2
mat(2,3) = mat(2,3)+2*sqrt(3._dp)*lam3*v2**2
mat(3,3) = 0._dp 
mat(3,3) = mat(3,3)+mu1
mat(3,3) = mat(3,3)+(lam5*v1**2)/2._dp
mat(3,3) = mat(3,3)+(lam6*v1**2)/2._dp
mat(3,3) = mat(3,3)+lam7*v1**2
mat(3,3) = mat(3,3)-3*lam4*v1*v2
mat(3,3) = mat(3,3)+6*lam1*v2**2
mat(3,3) = mat(3,3)+6*lam3*v2**2

 
 Do i1=2,3
  Do i2 = 1, i1-1 
  mat(i1,i2) = mat(i2,i1) 
  End do 
End do 

 
Call EigenSystem(mat,MHhSM2,ZH,ierr,test) 
 
 
If ((ierr.Eq.-8).Or.(ierr.Eq.-9)) Then 
  Write(ErrCan,*) "Possible numerical problem in "//NameOfUnit(Iname) 
  If (ErrorLevel.Eq.2) Then 
  Write(*,*) "Possible numerical problem in "//NameOfUnit(Iname) 
    Call TerminateProgram 
  End If 
  ierr = 0 
End If 
 
If ((ierr.Ne.0.).And.(ErrorLevel.Ge.-1)) Then 
  Write(10,*) 'Warning from Subroutine '//NameOfUnit(Iname) 
  Write(10,*) 'Diagonalization failed, ierr : ',ierr 
  kont = ierr 
  Iname = Iname - 1 
  Return 
End If 


Do i1=1,3
  If (Abs(MHhSM2(i1)).Le.MaxMassNumericalZero) MHhSM2(i1) = 1.E-10_dp 
  If (MHhSM2(i1).ne.MHhSM2(i1)) Then 
      Write(*,*) 'NaN appearing in '//NameOfUnit(Iname) 
      Call TerminateProgram 
    End If 
  If (MHhSM2(i1).Ge.0._dp) Then 
  MHhSM(i1)=Sqrt(MHhSM2(i1) ) 
  Else 
    If (ErrorLevel.Ge.0) Then 
      Write(10,*) 'Warning from Subroutine '//NameOfUnit(Iname) 
      Write(10,*) 'a mass squarred is negative: ',i1,MHhSM2(i1) 
    End If 
  MHhSM(i1) = 1._dp 
     Write(ErrCan,*) 'Warning from routine '//NameOfUnit(Iname) 
     Write(ErrCan,*) 'in the calculation of the masses' 
     Write(ErrCan,*) 'occurred a negative mass squared!' 
     Write(ErrCan,*) i1,MHhSM2(i1) 
     Write(*,*) 'Warning from routine '//NameOfUnit(Iname) 
     Write(*,*) 'in the calculation of the masses' 
     Write(*,*) 'occurred a negative mass squared!' 
     Write(*,*) i1,MHhSM2(i1) 
  MHhSM2(i1) = 1._dp 
   SignOfMassChanged = .True. 
! kont = -104 
 End if 
End Do 
Iname = Iname - 1 
 
End Subroutine CalculateMHhSM 

Subroutine CalculateMAh(g1,g2,mu1,mu0,lam1,lam3,lam4,lam2,lam7,lam6,lam5,             & 
& lam8,v1,v2,TW,ZA,MAh,MAh2,kont)

Real(dp), Intent(in) :: g1,g2,mu1,mu0,lam1,lam3,lam4,lam2,lam7,lam6,lam5,lam8,v1,v2,TW

Integer, Intent(inout) :: kont 
Integer :: i1,i2,i3,i4, ierr 
Integer :: j1,j2,j3,j4, pos 
Real(dp), Intent(out) :: MAh(3), MAh2(3) 
Real(dp), Intent(out) :: ZA(3,3) 
 
Real(dp) :: mat(3,3)  

Real(dp) ::  test(2) 

Iname = Iname + 1 
NameOfUnit(Iname) = 'CalculateMAh'
 
mat(1,1) = 0._dp 
mat(1,1) = mat(1,1)+mu0
mat(1,1) = mat(1,1)+lam8*v1**2
mat(1,1) = mat(1,1)+2*lam5*v2**2
mat(1,1) = mat(1,1)+2*lam6*v2**2
mat(1,1) = mat(1,1)-4*lam7*v2**2
mat(1,1) = mat(1,1)+(g2**2*v1**2*Cos(TW)**2*RXiZ)/4._dp
mat(1,1) = mat(1,1)+(g1*g2*v1**2*Cos(TW)*RXiZ*Sin(TW))/2._dp
mat(1,1) = mat(1,1)+(g1**2*v1**2*RXiZ*Sin(TW)**2)/4._dp
mat(1,2) = 0._dp 
mat(1,2) = mat(1,2)+2*sqrt(3._dp)*lam7*v1*v2
mat(1,2) = mat(1,2)+sqrt(3._dp)*lam4*v2**2
mat(1,2) = mat(1,2)+(sqrt(3._dp)*g2**2*v1*v2*Cos(TW)**2*RXiZ)/4._dp
mat(1,2) = mat(1,2)+(sqrt(3._dp)*g1*g2*v1*v2*Cos(TW)*RXiZ*Sin(TW))/2._dp
mat(1,2) = mat(1,2)+(sqrt(3._dp)*g1**2*v1*v2*RXiZ*Sin(TW)**2)/4._dp
mat(1,3) = 0._dp 
mat(1,3) = mat(1,3)+2*lam7*v1*v2
mat(1,3) = mat(1,3)+lam4*v2**2
mat(1,3) = mat(1,3)+(g2**2*v1*v2*Cos(TW)**2*RXiZ)/4._dp
mat(1,3) = mat(1,3)+(g1*g2*v1*v2*Cos(TW)*RXiZ*Sin(TW))/2._dp
mat(1,3) = mat(1,3)+(g1**2*v1*v2*RXiZ*Sin(TW)**2)/4._dp
mat(2,2) = 0._dp 
mat(2,2) = mat(2,2)+mu1
mat(2,2) = mat(2,2)+(lam5*v1**2)/2._dp
mat(2,2) = mat(2,2)+(lam6*v1**2)/2._dp
mat(2,2) = mat(2,2)-(lam7*v1**2)
mat(2,2) = mat(2,2)+lam4*v1*v2
mat(2,2) = mat(2,2)+4*lam1*v2**2
mat(2,2) = mat(2,2)-2*lam2*v2**2
mat(2,2) = mat(2,2)+2*lam3*v2**2
mat(2,2) = mat(2,2)+(3*g2**2*v2**2*Cos(TW)**2*RXiZ)/4._dp
mat(2,2) = mat(2,2)+(3*g1*g2*v2**2*Cos(TW)*RXiZ*Sin(TW))/2._dp
mat(2,2) = mat(2,2)+(3*g1**2*v2**2*RXiZ*Sin(TW)**2)/4._dp
mat(2,3) = 0._dp 
mat(2,3) = mat(2,3)+sqrt(3._dp)*lam4*v1*v2
mat(2,3) = mat(2,3)+2*sqrt(3._dp)*lam2*v2**2
mat(2,3) = mat(2,3)+2*sqrt(3._dp)*lam3*v2**2
mat(2,3) = mat(2,3)+(sqrt(3._dp)*g2**2*v2**2*Cos(TW)**2*RXiZ)/4._dp
mat(2,3) = mat(2,3)+(sqrt(3._dp)*g1*g2*v2**2*Cos(TW)*RXiZ*Sin(TW))/2._dp
mat(2,3) = mat(2,3)+(sqrt(3._dp)*g1**2*v2**2*RXiZ*Sin(TW)**2)/4._dp
mat(3,3) = 0._dp 
mat(3,3) = mat(3,3)+mu1
mat(3,3) = mat(3,3)+(lam5*v1**2)/2._dp
mat(3,3) = mat(3,3)+(lam6*v1**2)/2._dp
mat(3,3) = mat(3,3)-(lam7*v1**2)
mat(3,3) = mat(3,3)-(lam4*v1*v2)
mat(3,3) = mat(3,3)+4*lam1*v2**2
mat(3,3) = mat(3,3)-6*lam2*v2**2
mat(3,3) = mat(3,3)-2*lam3*v2**2
mat(3,3) = mat(3,3)+(g2**2*v2**2*Cos(TW)**2*RXiZ)/4._dp
mat(3,3) = mat(3,3)+(g1*g2*v2**2*Cos(TW)*RXiZ*Sin(TW))/2._dp
mat(3,3) = mat(3,3)+(g1**2*v2**2*RXiZ*Sin(TW)**2)/4._dp

 
 Do i1=2,3
  Do i2 = 1, i1-1 
  mat(i1,i2) = mat(i2,i1) 
  End do 
End do 

 
Call EigenSystem(mat,MAh2,ZA,ierr,test) 
 
 
If ((ierr.Eq.-8).Or.(ierr.Eq.-9)) Then 
  Write(ErrCan,*) "Possible numerical problem in "//NameOfUnit(Iname) 
  If (ErrorLevel.Eq.2) Then 
  Write(*,*) "Possible numerical problem in "//NameOfUnit(Iname) 
    Call TerminateProgram 
  End If 
  ierr = 0 
End If 
 
If ((ierr.Ne.0.).And.(ErrorLevel.Ge.-1)) Then 
  Write(10,*) 'Warning from Subroutine '//NameOfUnit(Iname) 
  Write(10,*) 'Diagonalization failed, ierr : ',ierr 
  kont = ierr 
  Iname = Iname - 1 
  Return 
End If 


Do i1=1,3
  If (Abs(MAh2(i1)).Le.MaxMassNumericalZero) MAh2(i1) = 1.E-10_dp 
  If (MAh2(i1).ne.MAh2(i1)) Then 
      Write(*,*) 'NaN appearing in '//NameOfUnit(Iname) 
      Call TerminateProgram 
    End If 
  If (MAh2(i1).Ge.0._dp) Then 
  MAh(i1)=Sqrt(MAh2(i1) ) 
  Else 
    If (ErrorLevel.Ge.0) Then 
      Write(10,*) 'Warning from Subroutine '//NameOfUnit(Iname) 
      Write(10,*) 'a mass squarred is negative: ',i1,MAh2(i1) 
    End If 
  MAh(i1) = 1._dp 
     Write(ErrCan,*) 'Warning from routine '//NameOfUnit(Iname) 
     Write(ErrCan,*) 'in the calculation of the masses' 
     Write(ErrCan,*) 'occurred a negative mass squared!' 
     Write(ErrCan,*) i1,MAh2(i1) 
     Write(*,*) 'Warning from routine '//NameOfUnit(Iname) 
     Write(*,*) 'in the calculation of the masses' 
     Write(*,*) 'occurred a negative mass squared!' 
     Write(*,*) i1,MAh2(i1) 
  MAh2(i1) = 1._dp 
   SignOfMassChanged = .True. 
! kont = -104 
 End if 
End Do 
Iname = Iname - 1 
 
End Subroutine CalculateMAh 

Subroutine CalculateMHp(g2,mu1,mu0,lam1,lam3,lam4,lam7,lam6,lam5,lam8,v1,             & 
& v2,ZP,MHp,MHp2,kont)

Real(dp), Intent(in) :: g2,mu1,mu0,lam1,lam3,lam4,lam7,lam6,lam5,lam8,v1,v2

Integer, Intent(inout) :: kont 
Integer :: i1,i2,i3,i4, ierr 
Integer :: j1,j2,j3,j4, pos 
Real(dp), Intent(out) :: MHp(3), MHp2(3) 
Real(dp), Intent(out) :: ZP(3,3) 
 
Real(dp) :: mat(3,3)  

Real(dp) ::  test(2) 

Iname = Iname + 1 
NameOfUnit(Iname) = 'CalculateMHp'
 
mat(1,1) = 0._dp 
mat(1,1) = mat(1,1)+mu0
mat(1,1) = mat(1,1)+lam8*v1**2
mat(1,1) = mat(1,1)+2*lam5*v2**2
mat(1,1) = mat(1,1)+(g2**2*v1**2*RXiWp)/4._dp
mat(1,2) = 0._dp 
mat(1,2) = mat(1,2)+(sqrt(3._dp)*lam6*v1*v2)/2._dp
mat(1,2) = mat(1,2)+sqrt(3._dp)*lam7*v1*v2
mat(1,2) = mat(1,2)+sqrt(3._dp)*lam4*v2**2
mat(1,2) = mat(1,2)+(sqrt(3._dp)*g2**2*v1*v2*RXiWp)/4._dp
mat(1,3) = 0._dp 
mat(1,3) = mat(1,3)+(lam6*v1*v2)/2._dp
mat(1,3) = mat(1,3)+lam7*v1*v2
mat(1,3) = mat(1,3)+lam4*v2**2
mat(1,3) = mat(1,3)+(g2**2*v1*v2*RXiWp)/4._dp
mat(2,2) = 0._dp 
mat(2,2) = mat(2,2)+mu1
mat(2,2) = mat(2,2)+(lam5*v1**2)/2._dp
mat(2,2) = mat(2,2)+lam4*v1*v2
mat(2,2) = mat(2,2)+4*lam1*v2**2
mat(2,2) = mat(2,2)+2*lam3*v2**2
mat(2,2) = mat(2,2)+(3*g2**2*v2**2*RXiWp)/4._dp
mat(2,3) = 0._dp 
mat(2,3) = mat(2,3)+sqrt(3._dp)*lam4*v1*v2
mat(2,3) = mat(2,3)+2*sqrt(3._dp)*lam3*v2**2
mat(2,3) = mat(2,3)+(sqrt(3._dp)*g2**2*v2**2*RXiWp)/4._dp
mat(3,3) = 0._dp 
mat(3,3) = mat(3,3)+mu1
mat(3,3) = mat(3,3)+(lam5*v1**2)/2._dp
mat(3,3) = mat(3,3)-(lam4*v1*v2)
mat(3,3) = mat(3,3)+4*lam1*v2**2
mat(3,3) = mat(3,3)-2*lam3*v2**2
mat(3,3) = mat(3,3)+(g2**2*v2**2*RXiWp)/4._dp

 
 Do i1=2,3
  Do i2 = 1, i1-1 
  mat(i1,i2) = mat(i2,i1) 
  End do 
End do 

 
Call EigenSystem(mat,MHp2,ZP,ierr,test) 
 
 
If ((ierr.Eq.-8).Or.(ierr.Eq.-9)) Then 
  Write(ErrCan,*) "Possible numerical problem in "//NameOfUnit(Iname) 
  If (ErrorLevel.Eq.2) Then 
  Write(*,*) "Possible numerical problem in "//NameOfUnit(Iname) 
    Call TerminateProgram 
  End If 
  ierr = 0 
End If 
 
If ((ierr.Ne.0.).And.(ErrorLevel.Ge.-1)) Then 
  Write(10,*) 'Warning from Subroutine '//NameOfUnit(Iname) 
  Write(10,*) 'Diagonalization failed, ierr : ',ierr 
  kont = ierr 
  Iname = Iname - 1 
  Return 
End If 


Do i1=1,3
  If (Abs(MHp2(i1)).Le.MaxMassNumericalZero) MHp2(i1) = 1.E-10_dp 
  If (MHp2(i1).ne.MHp2(i1)) Then 
      Write(*,*) 'NaN appearing in '//NameOfUnit(Iname) 
      Call TerminateProgram 
    End If 
  If (MHp2(i1).Ge.0._dp) Then 
  MHp(i1)=Sqrt(MHp2(i1) ) 
  Else 
    If (ErrorLevel.Ge.0) Then 
      Write(10,*) 'Warning from Subroutine '//NameOfUnit(Iname) 
      Write(10,*) 'a mass squarred is negative: ',i1,MHp2(i1) 
    End If 
  MHp(i1) = 1._dp 
     Write(ErrCan,*) 'Warning from routine '//NameOfUnit(Iname) 
     Write(ErrCan,*) 'in the calculation of the masses' 
     Write(ErrCan,*) 'occurred a negative mass squared!' 
     Write(ErrCan,*) i1,MHp2(i1) 
     Write(*,*) 'Warning from routine '//NameOfUnit(Iname) 
     Write(*,*) 'in the calculation of the masses' 
     Write(*,*) 'occurred a negative mass squared!' 
     Write(*,*) i1,MHp2(i1) 
  MHp2(i1) = 1._dp 
   SignOfMassChanged = .True. 
! kont = -104 
 End if 
End Do 
Iname = Iname - 1 
 
End Subroutine CalculateMHp 

Subroutine CalculateMFd(Yd,v1,ZDL,ZDR,MFd,kont)

Real(dp),Intent(in) :: v1

Complex(dp),Intent(in) :: Yd(3,3)

Integer, Intent(inout) :: kont 
Integer :: i1,i2,i3,i4, ierr 
Integer :: j1,j2,j3,j4 
Real(dp), Intent(out) :: MFd(3) 
 Complex(dp), Intent(out) :: ZDL(3,3), ZDR(3,3) 
 
 Complex(dp) :: mat(3,3)=0._dp, mat2(3,3)=0._dp, phaseM 

Complex(dp) :: ZDL2(3,3), ZDR2(3,3) 
 
 Real(dp) :: ZDL1(3,3), ZDR1(3,3), test(2), MFd2(3) 
 
 Iname = Iname + 1 
NameOfUnit(Iname) = 'CalculateMFd'
 
MFd = 0._dp 
ZDL = 0._dp 
ZDR = 0._dp 
mat(1,1) = 0._dp 
mat(1,1) = mat(1,1)+(v1*Yd(1,1))/sqrt(2._dp)
mat(1,2) = 0._dp 
mat(1,2) = mat(1,2)+(v1*Yd(2,1))/sqrt(2._dp)
mat(1,3) = 0._dp 
mat(1,3) = mat(1,3)+(v1*Yd(3,1))/sqrt(2._dp)
mat(2,1) = 0._dp 
mat(2,1) = mat(2,1)+(v1*Yd(1,2))/sqrt(2._dp)
mat(2,2) = 0._dp 
mat(2,2) = mat(2,2)+(v1*Yd(2,2))/sqrt(2._dp)
mat(2,3) = 0._dp 
mat(2,3) = mat(2,3)+(v1*Yd(3,2))/sqrt(2._dp)
mat(3,1) = 0._dp 
mat(3,1) = mat(3,1)+(v1*Yd(1,3))/sqrt(2._dp)
mat(3,2) = 0._dp 
mat(3,2) = mat(3,2)+(v1*Yd(2,3))/sqrt(2._dp)
mat(3,3) = 0._dp 
mat(3,3) = mat(3,3)+(v1*Yd(3,3))/sqrt(2._dp)

 
mat2 = Matmul(Transpose(Conjg(mat)),mat) 
If (Maxval(Abs(Aimag(mat2))).Eq.0._dp) Then 
Call EigenSystem(Real(mat2,dp),MFd2,ZDR1,ierr,test) 
ZDR2 = ZDR1 
Else 
Call EigenSystem(mat2,MFd2,ZDR2,ierr,test) 
 End If 
 
If ((ierr.Eq.-8).Or.(ierr.Eq.-9)) Then 
  Write(ErrCan,*) "Possible numerical problem in "//NameOfUnit(Iname) 
  If (ErrorLevel.Eq.2) Then 
  Write(*,*) "Possible numerical problem in "//NameOfUnit(Iname) 
    Call TerminateProgram 
  End If 
  ierr = 0 
End If 
 
mat2 = Matmul(mat,Transpose(Conjg(mat))) 
If (Maxval(Abs(Aimag(mat2))).Eq.0._dp) Then 
Call EigenSystem (Real(mat2,dp),MFd2,ZDL1,ierr,test) 
                  
                  
ZDL2 = ZDL1 
Else 
Call EigenSystem(mat2,MFd2,ZDL2,ierr,test) 
 
 
End If 
ZDL2 = Conjg(ZDL2) 
 
If ((ierr.Eq.-8).Or.(ierr.Eq.-9)) Then 
  Write(ErrCan,*) "Possible numerical problem in "//NameOfUnit(Iname) 
  If (ErrorLevel.Eq.2) Then 
  Write(*,*) "Possible numerical problem in "//NameOfUnit(Iname) 
    Call TerminateProgram 
  End If 
  ierr = 0 
End If 
 
mat2 = Matmul(Matmul( Conjg(ZDL2),mat),Transpose( Conjg(ZDR2))) 
Do i1=1,3
If (Abs(mat2(i1,i1)).gt.0._dp) Then 
phaseM = mat2(i1,i1) / Abs(mat2(i1,i1)) 
ZDR2(i1,:) = phaseM *ZDR2(i1,:) 
 End if 
End Do 
 
Do i1=1,3
If (Abs(ZDR2(i1,i1)).gt.0._dp) Then 
phaseM = ZDR2(i1,i1) / Abs(ZDR2(i1,i1)) 
ZDR2(i1,:) = Conjg(phaseM) *ZDR2(i1,:) 
 ZDL2(i1,:) = phaseM *ZDL2(i1,:) 
 End if 
  If (MFd2(i1).ne.MFd2(i1)) Then 
      Write(*,*) 'NaN appearing in '//NameOfUnit(Iname) 
      Call TerminateProgram 
    End If 
  If (Abs(MFd2(i1)).Le.MaxMassNumericalZero) MFd2(i1) = Abs(MFd2(i1))+1.E-10_dp 
  If (MFd2(i1).Le.0._dp) Then 
    If (ErrorLevel.Ge.0) Then 
      Write(10,*) 'Warning from Subroutine '//NameOfUnit(Iname) 
      Write(10,*) 'a mass squarred is negative: ',i1,MFd2(i1) 
      Write(*,*) 'Warning from Subroutine '//NameOfUnit(Iname) 
      Write(*,*) 'a mass squarred is negative: ',i1,MFd2(i1) 
      Call TerminateProgram 
    End If 
     Write(ErrCan,*) 'Warning from routine '//NameOfUnit(Iname) 
     Write(ErrCan,*) 'in the calculation of the masses' 
     Write(ErrCan,*) 'occurred a negative mass squared!' 
     Write(ErrCan,*) i1,MFd2(i1) 
     Write(*,*) 'Warning from routine '//NameOfUnit(Iname) 
     Write(*,*) 'in the calculation of the masses' 
     Write(*,*) 'occurred a negative mass squared!' 
     Write(*,*) i1,MFd2(i1) 
  MFd2(i1) = 1._dp 
   SignOfMassChanged = .True. 
! kont = -104 
 End if 
End Do 
 
If (ierr.Ne.0.) Then 
  Write(ErrCan,*) 'Warning from Subroutine CalculateMFd, ierr =',ierr 
  kont = ierr 
  Iname = Iname - 1 
  Return 
End If 


MFd = Sqrt( MFd2 ) 
ZDL = ZDL2 
ZDR = ZDR2 
Iname = Iname - 1 
 
End Subroutine CalculateMFd 

Subroutine CalculateMFu(Yu,v1,ZUL,ZUR,MFu,kont)

Real(dp),Intent(in) :: v1

Complex(dp),Intent(in) :: Yu(3,3)

Integer, Intent(inout) :: kont 
Integer :: i1,i2,i3,i4, ierr 
Integer :: j1,j2,j3,j4 
Real(dp), Intent(out) :: MFu(3) 
 Complex(dp), Intent(out) :: ZUL(3,3), ZUR(3,3) 
 
 Complex(dp) :: mat(3,3)=0._dp, mat2(3,3)=0._dp, phaseM 

Complex(dp) :: ZUL2(3,3), ZUR2(3,3) 
 
 Real(dp) :: ZUL1(3,3), ZUR1(3,3), test(2), MFu2(3) 
 
 Iname = Iname + 1 
NameOfUnit(Iname) = 'CalculateMFu'
 
MFu = 0._dp 
ZUL = 0._dp 
ZUR = 0._dp 
mat(1,1) = 0._dp 
mat(1,1) = mat(1,1)+(v1*Yu(1,1))/sqrt(2._dp)
mat(1,2) = 0._dp 
mat(1,2) = mat(1,2)+(v1*Yu(2,1))/sqrt(2._dp)
mat(1,3) = 0._dp 
mat(1,3) = mat(1,3)+(v1*Yu(3,1))/sqrt(2._dp)
mat(2,1) = 0._dp 
mat(2,1) = mat(2,1)+(v1*Yu(1,2))/sqrt(2._dp)
mat(2,2) = 0._dp 
mat(2,2) = mat(2,2)+(v1*Yu(2,2))/sqrt(2._dp)
mat(2,3) = 0._dp 
mat(2,3) = mat(2,3)+(v1*Yu(3,2))/sqrt(2._dp)
mat(3,1) = 0._dp 
mat(3,1) = mat(3,1)+(v1*Yu(1,3))/sqrt(2._dp)
mat(3,2) = 0._dp 
mat(3,2) = mat(3,2)+(v1*Yu(2,3))/sqrt(2._dp)
mat(3,3) = 0._dp 
mat(3,3) = mat(3,3)+(v1*Yu(3,3))/sqrt(2._dp)

 
mat2 = Matmul(Transpose(Conjg(mat)),mat) 
If (Maxval(Abs(Aimag(mat2))).Eq.0._dp) Then 
Call EigenSystem(Real(mat2,dp),MFu2,ZUR1,ierr,test) 
ZUR2 = ZUR1 
Else 
Call EigenSystem(mat2,MFu2,ZUR2,ierr,test) 
 End If 
 
If ((ierr.Eq.-8).Or.(ierr.Eq.-9)) Then 
  Write(ErrCan,*) "Possible numerical problem in "//NameOfUnit(Iname) 
  If (ErrorLevel.Eq.2) Then 
  Write(*,*) "Possible numerical problem in "//NameOfUnit(Iname) 
    Call TerminateProgram 
  End If 
  ierr = 0 
End If 
 
mat2 = Matmul(mat,Transpose(Conjg(mat))) 
If (Maxval(Abs(Aimag(mat2))).Eq.0._dp) Then 
Call EigenSystem (Real(mat2,dp),MFu2,ZUL1,ierr,test) 
                  
                  
ZUL2 = ZUL1 
Else 
Call EigenSystem(mat2,MFu2,ZUL2,ierr,test) 
 
 
End If 
ZUL2 = Conjg(ZUL2) 
 
If ((ierr.Eq.-8).Or.(ierr.Eq.-9)) Then 
  Write(ErrCan,*) "Possible numerical problem in "//NameOfUnit(Iname) 
  If (ErrorLevel.Eq.2) Then 
  Write(*,*) "Possible numerical problem in "//NameOfUnit(Iname) 
    Call TerminateProgram 
  End If 
  ierr = 0 
End If 
 
mat2 = Matmul(Matmul( Conjg(ZUL2),mat),Transpose( Conjg(ZUR2))) 
Do i1=1,3
If (Abs(mat2(i1,i1)).gt.0._dp) Then 
phaseM = mat2(i1,i1) / Abs(mat2(i1,i1)) 
ZUR2(i1,:) = phaseM *ZUR2(i1,:) 
 End if 
End Do 
 
Do i1=1,3
If (Abs(ZUR2(i1,i1)).gt.0._dp) Then 
phaseM = ZUR2(i1,i1) / Abs(ZUR2(i1,i1)) 
ZUR2(i1,:) = Conjg(phaseM) *ZUR2(i1,:) 
 ZUL2(i1,:) = phaseM *ZUL2(i1,:) 
 End if 
  If (MFu2(i1).ne.MFu2(i1)) Then 
      Write(*,*) 'NaN appearing in '//NameOfUnit(Iname) 
      Call TerminateProgram 
    End If 
  If (Abs(MFu2(i1)).Le.MaxMassNumericalZero) MFu2(i1) = Abs(MFu2(i1))+1.E-10_dp 
  If (MFu2(i1).Le.0._dp) Then 
    If (ErrorLevel.Ge.0) Then 
      Write(10,*) 'Warning from Subroutine '//NameOfUnit(Iname) 
      Write(10,*) 'a mass squarred is negative: ',i1,MFu2(i1) 
      Write(*,*) 'Warning from Subroutine '//NameOfUnit(Iname) 
      Write(*,*) 'a mass squarred is negative: ',i1,MFu2(i1) 
      Call TerminateProgram 
    End If 
     Write(ErrCan,*) 'Warning from routine '//NameOfUnit(Iname) 
     Write(ErrCan,*) 'in the calculation of the masses' 
     Write(ErrCan,*) 'occurred a negative mass squared!' 
     Write(ErrCan,*) i1,MFu2(i1) 
     Write(*,*) 'Warning from routine '//NameOfUnit(Iname) 
     Write(*,*) 'in the calculation of the masses' 
     Write(*,*) 'occurred a negative mass squared!' 
     Write(*,*) i1,MFu2(i1) 
  MFu2(i1) = 1._dp 
   SignOfMassChanged = .True. 
! kont = -104 
 End if 
End Do 
 
If (ierr.Ne.0.) Then 
  Write(ErrCan,*) 'Warning from Subroutine CalculateMFu, ierr =',ierr 
  kont = ierr 
  Iname = Iname - 1 
  Return 
End If 


MFu = Sqrt( MFu2 ) 
ZUL = ZUL2 
ZUR = ZUR2 
Iname = Iname - 1 
 
End Subroutine CalculateMFu 

Subroutine CalculateMFe(Ye,v1,ZEL,ZER,MFe,kont)

Real(dp),Intent(in) :: v1

Complex(dp),Intent(in) :: Ye(3,3)

Integer, Intent(inout) :: kont 
Integer :: i1,i2,i3,i4, ierr 
Integer :: j1,j2,j3,j4 
Real(dp), Intent(out) :: MFe(3) 
 Complex(dp), Intent(out) :: ZEL(3,3), ZER(3,3) 
 
 Complex(dp) :: mat(3,3)=0._dp, mat2(3,3)=0._dp, phaseM 

Complex(dp) :: ZEL2(3,3), ZER2(3,3) 
 
 Real(dp) :: ZEL1(3,3), ZER1(3,3), test(2), MFe2(3) 
 
 Iname = Iname + 1 
NameOfUnit(Iname) = 'CalculateMFe'
 
MFe = 0._dp 
ZEL = 0._dp 
ZER = 0._dp 
mat(1,1) = 0._dp 
mat(1,1) = mat(1,1)+(v1*Ye(1,1))/sqrt(2._dp)
mat(1,2) = 0._dp 
mat(1,2) = mat(1,2)+(v1*Ye(2,1))/sqrt(2._dp)
mat(1,3) = 0._dp 
mat(1,3) = mat(1,3)+(v1*Ye(3,1))/sqrt(2._dp)
mat(2,1) = 0._dp 
mat(2,1) = mat(2,1)+(v1*Ye(1,2))/sqrt(2._dp)
mat(2,2) = 0._dp 
mat(2,2) = mat(2,2)+(v1*Ye(2,2))/sqrt(2._dp)
mat(2,3) = 0._dp 
mat(2,3) = mat(2,3)+(v1*Ye(3,2))/sqrt(2._dp)
mat(3,1) = 0._dp 
mat(3,1) = mat(3,1)+(v1*Ye(1,3))/sqrt(2._dp)
mat(3,2) = 0._dp 
mat(3,2) = mat(3,2)+(v1*Ye(2,3))/sqrt(2._dp)
mat(3,3) = 0._dp 
mat(3,3) = mat(3,3)+(v1*Ye(3,3))/sqrt(2._dp)

 
mat2 = Matmul(Transpose(Conjg(mat)),mat) 
If (Maxval(Abs(Aimag(mat2))).Eq.0._dp) Then 
Call EigenSystem(Real(mat2,dp),MFe2,ZER1,ierr,test) 
ZER2 = ZER1 
Else 
Call EigenSystem(mat2,MFe2,ZER2,ierr,test) 
 End If 
 
If ((ierr.Eq.-8).Or.(ierr.Eq.-9)) Then 
  Write(ErrCan,*) "Possible numerical problem in "//NameOfUnit(Iname) 
  If (ErrorLevel.Eq.2) Then 
  Write(*,*) "Possible numerical problem in "//NameOfUnit(Iname) 
    Call TerminateProgram 
  End If 
  ierr = 0 
End If 
 
mat2 = Matmul(mat,Transpose(Conjg(mat))) 
If (Maxval(Abs(Aimag(mat2))).Eq.0._dp) Then 
Call EigenSystem (Real(mat2,dp),MFe2,ZEL1,ierr,test) 
                  
                  
ZEL2 = ZEL1 
Else 
Call EigenSystem(mat2,MFe2,ZEL2,ierr,test) 
 
 
End If 
ZEL2 = Conjg(ZEL2) 
 
If ((ierr.Eq.-8).Or.(ierr.Eq.-9)) Then 
  Write(ErrCan,*) "Possible numerical problem in "//NameOfUnit(Iname) 
  If (ErrorLevel.Eq.2) Then 
  Write(*,*) "Possible numerical problem in "//NameOfUnit(Iname) 
    Call TerminateProgram 
  End If 
  ierr = 0 
End If 
 
mat2 = Matmul(Matmul( Conjg(ZEL2),mat),Transpose( Conjg(ZER2))) 
Do i1=1,3
If (Abs(mat2(i1,i1)).gt.0._dp) Then 
phaseM = mat2(i1,i1) / Abs(mat2(i1,i1)) 
ZER2(i1,:) = phaseM *ZER2(i1,:) 
 End if 
End Do 
 
Do i1=1,3
If (Abs(ZER2(i1,i1)).gt.0._dp) Then 
phaseM = ZER2(i1,i1) / Abs(ZER2(i1,i1)) 
ZER2(i1,:) = Conjg(phaseM) *ZER2(i1,:) 
 ZEL2(i1,:) = phaseM *ZEL2(i1,:) 
 End if 
  If (MFe2(i1).ne.MFe2(i1)) Then 
      Write(*,*) 'NaN appearing in '//NameOfUnit(Iname) 
      Call TerminateProgram 
    End If 
  If (Abs(MFe2(i1)).Le.MaxMassNumericalZero) MFe2(i1) = Abs(MFe2(i1))+1.E-10_dp 
  If (MFe2(i1).Le.0._dp) Then 
    If (ErrorLevel.Ge.0) Then 
      Write(10,*) 'Warning from Subroutine '//NameOfUnit(Iname) 
      Write(10,*) 'a mass squarred is negative: ',i1,MFe2(i1) 
      Write(*,*) 'Warning from Subroutine '//NameOfUnit(Iname) 
      Write(*,*) 'a mass squarred is negative: ',i1,MFe2(i1) 
      Call TerminateProgram 
    End If 
     Write(ErrCan,*) 'Warning from routine '//NameOfUnit(Iname) 
     Write(ErrCan,*) 'in the calculation of the masses' 
     Write(ErrCan,*) 'occurred a negative mass squared!' 
     Write(ErrCan,*) i1,MFe2(i1) 
     Write(*,*) 'Warning from routine '//NameOfUnit(Iname) 
     Write(*,*) 'in the calculation of the masses' 
     Write(*,*) 'occurred a negative mass squared!' 
     Write(*,*) i1,MFe2(i1) 
  MFe2(i1) = 1._dp 
   SignOfMassChanged = .True. 
! kont = -104 
 End if 
End Do 
 
If (ierr.Ne.0.) Then 
  Write(ErrCan,*) 'Warning from Subroutine CalculateMFe, ierr =',ierr 
  kont = ierr 
  Iname = Iname - 1 
  Return 
End If 


MFe = Sqrt( MFe2 ) 
ZEL = ZEL2 
ZER = ZER2 
Iname = Iname - 1 
 
End Subroutine CalculateMFe 

Subroutine CalculateVPVZ(g1,g2,v1,v2,ZZ,MVZ,MVZ2,TW,kont)

Real(dp), Intent(in) :: g1,g2,v1,v2

Real(dp), Intent(out) :: TW

Integer, Intent(inout) :: kont 
Integer :: i1,i2,i3,i4, ierr 
Integer :: j1,j2,j3,j4 
Real(dp), Intent(out) :: MVZ, MVZ2
Real(dp) :: VPVZ2(2),VPVZ(2)  

Real(dp), Intent(out) :: ZZ(2,2) 
 
Real(dp) :: mat(2,2)  

Real(dp) ::  test(2) 

Iname = Iname + 1 
NameOfUnit(Iname) = 'CalculateVPVZ'
 
mat(1,1) = 0._dp 
mat(1,1) = mat(1,1)+(g1**2*v1**2)/4._dp
mat(1,1) = mat(1,1)+g1**2*v2**2
mat(1,2) = 0._dp 
mat(1,2) = mat(1,2)-(g1*g2*v1**2)/4._dp
mat(1,2) = mat(1,2)-(g1*g2*v2**2)
mat(2,2) = 0._dp 
mat(2,2) = mat(2,2)+(g2**2*v1**2)/4._dp
mat(2,2) = mat(2,2)+g2**2*v2**2

 
 Do i1=2,2
  Do i2 = 1, i1-1 
  mat(i1,i2) = mat(i2,i1) 
  End do 
End do 

 
Call EigenSystem(mat,VPVZ2,ZZ,ierr,test) 
 
 
ZZ = Transpose(ZZ) 
If ((ierr.Eq.-8).Or.(ierr.Eq.-9)) Then 
  Write(ErrCan,*) "Possible numerical problem in "//NameOfUnit(Iname) 
  If (ErrorLevel.Eq.2) Then 
  Write(*,*) "Possible numerical problem in "//NameOfUnit(Iname) 
    Call TerminateProgram 
  End If 
  ierr = 0 
End If 
 
If ((ierr.Ne.0.).And.(ErrorLevel.Ge.-1)) Then 
  Write(10,*) 'Warning from Subroutine '//NameOfUnit(Iname) 
  Write(10,*) 'Diagonalization failed, ierr : ',ierr 
  kont = ierr 
  Iname = Iname - 1 
  Return 
End If 


Do i1=1,2
  If (Abs(VPVZ2(i1)).Le.1.E-10_dp*(Maxval(VPVZ2))) VPVZ2(i1) = 1.E-10_dp 
  If (VPVZ2(i1).ne.VPVZ2(i1)) Then 
      Write(*,*) 'NaN appearing in '//NameOfUnit(Iname) 
      Call TerminateProgram 
    End If 
  If (VPVZ2(i1).Ge.0._dp) Then 
  VPVZ(i1) =Sqrt(VPVZ2(i1) ) 
  Else 
    If (ErrorLevel.Ge.0) Then 
      Write(10,*) 'Warning from Subroutine '//NameOfUnit(Iname) 
      Write(10,*) 'a mass squarred is negative: ',i1,VPVZ2(i1) 
    End If 
  VPVZ(i1)= 1._dp 
  VPVZ2(i1)= 1._dp  
     Write(ErrCan,*) 'Warning from routine '//NameOfUnit(Iname) 
     Write(ErrCan,*) 'in the calculation of the masses' 
     Write(ErrCan,*) 'occurred a negative mass squared!' 
     Write(ErrCan,*) i1,VPVZ2(i1) 
     Write(*,*) 'Warning from routine '//NameOfUnit(Iname) 
     Write(*,*) 'in the calculation of the masses' 
     Write(*,*) 'occurred a negative mass squared!' 
     Write(*,*) i1,VPVZ2(i1) 
  VPVZ(i1)= 1._dp 
  VPVZ2(i1) = 1._dp  
   SignOfMassChanged = .True. 
! kont = -104 
 End if 
End Do 
 
MVZ = VPVZ(2) 
MVZ2 = VPVZ2(2) 
TW = ACos(Abs(ZZ(1,1)))

 Iname = Iname - 1 
 
End Subroutine CalculateVPVZ 

Subroutine CalculateVWp(g2,v1,v2,ZW,MVWp,MVWp2,kont)

Real(dp), Intent(in) :: g2,v1,v2

Integer, Intent(inout) :: kont 
Integer :: i1,i2,i3,i4, ierr 
Integer :: j1,j2,j3,j4 
Real(dp), Intent(out) :: MVWp, MVWp2
Real(dp) :: VWp2(2),VWp(2)  

Complex(dp), Intent(out) :: ZW(2,2) 
 
Complex(dp) :: mat(2,2)  

Real(dp) ::  test(2) 

Iname = Iname + 1 
NameOfUnit(Iname) = 'CalculateVWp'
 
mat(1,1) = 0._dp 
mat(1,1) = mat(1,1)+(g2**2*v1**2)/4._dp
mat(1,1) = mat(1,1)+g2**2*v2**2
mat(1,2) = 0._dp 
mat(2,2) = 0._dp 
mat(2,2) = mat(2,2)+(g2**2*v1**2)/4._dp
mat(2,2) = mat(2,2)+g2**2*v2**2

 
 Do i1=2,2
  Do i2 = 1, i1-1 
  mat(i1,i2) = Conjg(mat(i2,i1)) 
  End do 
End do 

 
Call EigenSystem(mat,VWp2,ZW,ierr,test) 
 
 
ZW = Transpose(ZW) 
If ((ierr.Eq.-8).Or.(ierr.Eq.-9)) Then 
  Write(ErrCan,*) "Possible numerical problem in "//NameOfUnit(Iname) 
  If (ErrorLevel.Eq.2) Then 
  Write(*,*) "Possible numerical problem in "//NameOfUnit(Iname) 
    Call TerminateProgram 
  End If 
  ierr = 0 
End If 
 
If ((ierr.Ne.0.).And.(ErrorLevel.Ge.-1)) Then 
  Write(10,*) 'Warning from Subroutine '//NameOfUnit(Iname) 
  Write(10,*) 'Diagonalization failed, ierr : ',ierr 
  kont = ierr 
  Iname = Iname - 1 
  Return 
End If 


Do i1=1,2
  If (Abs(VWp2(i1)).Le.1.E-10_dp*(Maxval(VWp2))) VWp2(i1) = 1.E-10_dp 
  If (VWp2(i1).ne.VWp2(i1)) Then 
      Write(*,*) 'NaN appearing in '//NameOfUnit(Iname) 
      Call TerminateProgram 
    End If 
  If (VWp2(i1).Ge.0._dp) Then 
  VWp(i1) =Sqrt(VWp2(i1) ) 
  Else 
    If (ErrorLevel.Ge.0) Then 
      Write(10,*) 'Warning from Subroutine '//NameOfUnit(Iname) 
      Write(10,*) 'a mass squarred is negative: ',i1,VWp2(i1) 
    End If 
  VWp(i1)= 1._dp 
  VWp2(i1)= 1._dp  
     Write(ErrCan,*) 'Warning from routine '//NameOfUnit(Iname) 
     Write(ErrCan,*) 'in the calculation of the masses' 
     Write(ErrCan,*) 'occurred a negative mass squared!' 
     Write(ErrCan,*) i1,VWp2(i1) 
     Write(*,*) 'Warning from routine '//NameOfUnit(Iname) 
     Write(*,*) 'in the calculation of the masses' 
     Write(*,*) 'occurred a negative mass squared!' 
     Write(*,*) i1,VWp2(i1) 
  VWp(i1)= 1._dp 
  VWp2(i1) = 1._dp  
   SignOfMassChanged = .True. 
! kont = -104 
 End if 
End Do 
 
MVWp = VWp(1) 
MVWp2 = VWp2(1) 

 Iname = Iname - 1 
 
End Subroutine CalculateVWp 

Subroutine CalculateMHhSMEffPot(mu1,mu0,lam1,lam3,lam4,lam7,lam6,lam5,lam8,           & 
& v1,v2,ZH,MHhSM,MHhSM2,kont)

Real(dp), Intent(in) :: mu1,mu0,lam1,lam3,lam4,lam7,lam6,lam5,lam8,v1,v2

Integer, Intent(inout) :: kont 
Integer :: i1,i2,i3,i4, ierr 
Integer :: j1,j2,j3,j4, pos 
Real(dp), Intent(out) :: MHhSM(3), MHhSM2(3) 
Real(dp), Intent(out) :: ZH(3,3) 
 
Real(dp) :: mat(3,3)  

Real(dp) :: MHhSM2temp(3), Q2 
Real(dp) :: ZHtemp(3,3),ZHtemp2(3,3) 
 
Real(dp) ::  test(2) 

Iname = Iname + 1 
NameOfUnit(Iname) = 'CalculateMHhSM'
 
mat(1,1) = 0._dp 
mat(1,1) = mat(1,1)+mu0
mat(1,1) = mat(1,1)+3*lam8*v1**2
mat(1,1) = mat(1,1)+2*lam5*v2**2
mat(1,1) = mat(1,1)+2*lam6*v2**2
mat(1,1) = mat(1,1)+4*lam7*v2**2
mat(1,2) = 0._dp 
mat(1,2) = mat(1,2)+sqrt(3._dp)*lam5*v1*v2
mat(1,2) = mat(1,2)+sqrt(3._dp)*lam6*v1*v2
mat(1,2) = mat(1,2)+2*sqrt(3._dp)*lam7*v1*v2
mat(1,2) = mat(1,2)+3*sqrt(3._dp)*lam4*v2**2
mat(1,3) = 0._dp 
mat(1,3) = mat(1,3)+lam5*v1*v2
mat(1,3) = mat(1,3)+lam6*v1*v2
mat(1,3) = mat(1,3)+2*lam7*v1*v2
mat(1,3) = mat(1,3)+3*lam4*v2**2
mat(2,2) = 0._dp 
mat(2,2) = mat(2,2)+mu1
mat(2,2) = mat(2,2)+(lam5*v1**2)/2._dp
mat(2,2) = mat(2,2)+(lam6*v1**2)/2._dp
mat(2,2) = mat(2,2)+lam7*v1**2
mat(2,2) = mat(2,2)+3*lam4*v1*v2
mat(2,2) = mat(2,2)+10*lam1*v2**2
mat(2,2) = mat(2,2)+10*lam3*v2**2
mat(2,3) = 0._dp 
mat(2,3) = mat(2,3)+3*sqrt(3._dp)*lam4*v1*v2
mat(2,3) = mat(2,3)+2*sqrt(3._dp)*lam1*v2**2
mat(2,3) = mat(2,3)+2*sqrt(3._dp)*lam3*v2**2
mat(3,3) = 0._dp 
mat(3,3) = mat(3,3)+mu1
mat(3,3) = mat(3,3)+(lam5*v1**2)/2._dp
mat(3,3) = mat(3,3)+(lam6*v1**2)/2._dp
mat(3,3) = mat(3,3)+lam7*v1**2
mat(3,3) = mat(3,3)-3*lam4*v1*v2
mat(3,3) = mat(3,3)+6*lam1*v2**2
mat(3,3) = mat(3,3)+6*lam3*v2**2

 
 Do i1=2,3
  Do i2 = 1, i1-1 
  mat(i1,i2) = mat(i2,i1) 
  End do 
End do 

 
Call EigenSystem(mat,MHhSM2,ZH,ierr,test) 
 
 
! Fix phases
Do i1=1,3
  pos=Maxloc(Abs(ZH(i1,:)),1)
  If (Real(ZH(i1,pos),dp).lt.0._dp) Then
    ZH(i1,:)=-ZH(i1,:)
  End if
End do
If ((ierr.Eq.-8).Or.(ierr.Eq.-9)) Then 
  Write(ErrCan,*) "Possible numerical problem in "//NameOfUnit(Iname) 
  If (ErrorLevel.Eq.2) Then 
  Write(*,*) "Possible numerical problem in "//NameOfUnit(Iname) 
    Call TerminateProgram 
  End If 
  ierr = 0 
End If 
 
If ((ierr.Ne.0.).And.(ErrorLevel.Ge.-1)) Then 
  Write(10,*) 'Warning from Subroutine '//NameOfUnit(Iname) 
  Write(10,*) 'Diagonalization failed, ierr : ',ierr 
  kont = ierr 
  Iname = Iname - 1 
  Return 
End If 


Do i1=1,3
  If (MHhSM2(i1).ne.MHhSM2(i1)) Then 
      Write(*,*) 'NaN appearing in '//NameOfUnit(Iname) 
      Call TerminateProgram 
    End If 
  If (MHhSM2(i1).Ge.0._dp) Then 
  MHhSM(i1)=Sqrt(MHhSM2(i1) ) 
  Else 
  MHhSM(i1) = 1._dp 
! kont = -104 
 End if 
End Do 
Iname = Iname - 1 
 
End Subroutine CalculateMHhSMEffPot 

Subroutine CalculateMAhEffPot(g1,g2,mu1,mu0,lam1,lam3,lam4,lam2,lam7,lam6,            & 
& lam5,lam8,v1,v2,TW,ZA,MAh,MAh2,kont)

Real(dp), Intent(in) :: g1,g2,mu1,mu0,lam1,lam3,lam4,lam2,lam7,lam6,lam5,lam8,v1,v2,TW

Integer, Intent(inout) :: kont 
Integer :: i1,i2,i3,i4, ierr, pos 
Integer :: j1,j2,j3,j4 
Real(dp), Intent(out) :: MAh(3), MAh2(3) 
Real(dp), Intent(out) :: ZA(3,3) 
 
Real(dp) :: ZAFIX(3,3) 
 
Real(dp) :: mat(3,3)  

Real(dp) ::  test(2), Q2 

Iname = Iname + 1 
NameOfUnit(Iname) = 'CalculateMAh'
 
mat(1,1) = 0._dp 
mat(1,1) = mat(1,1)+mu0
mat(1,1) = mat(1,1)+lam8*v1**2
mat(1,1) = mat(1,1)+2*lam5*v2**2
mat(1,1) = mat(1,1)+2*lam6*v2**2
mat(1,1) = mat(1,1)-4*lam7*v2**2
mat(1,2) = 0._dp 
mat(1,2) = mat(1,2)+2*sqrt(3._dp)*lam7*v1*v2
mat(1,2) = mat(1,2)+sqrt(3._dp)*lam4*v2**2
mat(1,3) = 0._dp 
mat(1,3) = mat(1,3)+2*lam7*v1*v2
mat(1,3) = mat(1,3)+lam4*v2**2
mat(2,2) = 0._dp 
mat(2,2) = mat(2,2)+mu1
mat(2,2) = mat(2,2)+(lam5*v1**2)/2._dp
mat(2,2) = mat(2,2)+(lam6*v1**2)/2._dp
mat(2,2) = mat(2,2)-(lam7*v1**2)
mat(2,2) = mat(2,2)+lam4*v1*v2
mat(2,2) = mat(2,2)+4*lam1*v2**2
mat(2,2) = mat(2,2)-2*lam2*v2**2
mat(2,2) = mat(2,2)+2*lam3*v2**2
mat(2,3) = 0._dp 
mat(2,3) = mat(2,3)+sqrt(3._dp)*lam4*v1*v2
mat(2,3) = mat(2,3)+2*sqrt(3._dp)*lam2*v2**2
mat(2,3) = mat(2,3)+2*sqrt(3._dp)*lam3*v2**2
mat(3,3) = 0._dp 
mat(3,3) = mat(3,3)+mu1
mat(3,3) = mat(3,3)+(lam5*v1**2)/2._dp
mat(3,3) = mat(3,3)+(lam6*v1**2)/2._dp
mat(3,3) = mat(3,3)-(lam7*v1**2)
mat(3,3) = mat(3,3)-(lam4*v1*v2)
mat(3,3) = mat(3,3)+4*lam1*v2**2
mat(3,3) = mat(3,3)-6*lam2*v2**2
mat(3,3) = mat(3,3)-2*lam3*v2**2

 
 Do i1=2,3
  Do i2 = 1, i1-1 
  mat(i1,i2) = mat(i2,i1) 
  End do 
End do 

 
Call EigenSystem(mat,MAh2,ZA,ierr,test) 
 
 
! Fix phases
Do i1=1,3
  pos=Maxloc(Abs(ZA(i1,:)),1)
  If (Real(ZA(i1,pos),dp).lt.0._dp) Then
    ZA(i1,:)=-ZA(i1,:)
  End if
End do
If ((ierr.Eq.-8).Or.(ierr.Eq.-9)) Then 
  Write(ErrCan,*) "Possible numerical problem in "//NameOfUnit(Iname) 
  If (ErrorLevel.Eq.2) Then 
  Write(*,*) "Possible numerical problem in "//NameOfUnit(Iname) 
    Call TerminateProgram 
  End If 
  ierr = 0 
End If 
 
If ((ierr.Ne.0.).And.(ErrorLevel.Ge.-1)) Then 
  Write(10,*) 'Warning from Subroutine '//NameOfUnit(Iname) 
  Write(10,*) 'Diagonalization failed, ierr : ',ierr 
  kont = ierr 
  Iname = Iname - 1 
  Return 
End If 


Do i1=1,3
  If (MAh2(i1).ne.MAh2(i1)) Then 
      Write(*,*) 'NaN appearing in '//NameOfUnit(Iname) 
      Call TerminateProgram 
    End If 
  If (MAh2(i1).Ge.0._dp) Then 
  MAh(i1)=Sqrt(MAh2(i1) ) 
  Else 
  MAh(i1) = 1._dp 
! kont = -104 
 End if 
End Do 
Iname = Iname - 1 
 
End Subroutine CalculateMAhEffPot 

Subroutine CalculateMHpEffPot(g2,mu1,mu0,lam1,lam3,lam4,lam7,lam6,lam5,               & 
& lam8,v1,v2,ZP,MHp,MHp2,kont)

Real(dp), Intent(in) :: g2,mu1,mu0,lam1,lam3,lam4,lam7,lam6,lam5,lam8,v1,v2

Integer, Intent(inout) :: kont 
Integer :: i1,i2,i3,i4, ierr, pos 
Integer :: j1,j2,j3,j4 
Real(dp), Intent(out) :: MHp(3), MHp2(3) 
Real(dp), Intent(out) :: ZP(3,3) 
 
Real(dp) :: ZPFIX(3,3) 
 
Real(dp) :: mat(3,3)  

Real(dp) ::  test(2), Q2 

Iname = Iname + 1 
NameOfUnit(Iname) = 'CalculateMHp'
 
mat(1,1) = 0._dp 
mat(1,1) = mat(1,1)+mu0
mat(1,1) = mat(1,1)+lam8*v1**2
mat(1,1) = mat(1,1)+2*lam5*v2**2
mat(1,2) = 0._dp 
mat(1,2) = mat(1,2)+(sqrt(3._dp)*lam6*v1*v2)/2._dp
mat(1,2) = mat(1,2)+sqrt(3._dp)*lam7*v1*v2
mat(1,2) = mat(1,2)+sqrt(3._dp)*lam4*v2**2
mat(1,3) = 0._dp 
mat(1,3) = mat(1,3)+(lam6*v1*v2)/2._dp
mat(1,3) = mat(1,3)+lam7*v1*v2
mat(1,3) = mat(1,3)+lam4*v2**2
mat(2,2) = 0._dp 
mat(2,2) = mat(2,2)+mu1
mat(2,2) = mat(2,2)+(lam5*v1**2)/2._dp
mat(2,2) = mat(2,2)+lam4*v1*v2
mat(2,2) = mat(2,2)+4*lam1*v2**2
mat(2,2) = mat(2,2)+2*lam3*v2**2
mat(2,3) = 0._dp 
mat(2,3) = mat(2,3)+sqrt(3._dp)*lam4*v1*v2
mat(2,3) = mat(2,3)+2*sqrt(3._dp)*lam3*v2**2
mat(3,3) = 0._dp 
mat(3,3) = mat(3,3)+mu1
mat(3,3) = mat(3,3)+(lam5*v1**2)/2._dp
mat(3,3) = mat(3,3)-(lam4*v1*v2)
mat(3,3) = mat(3,3)+4*lam1*v2**2
mat(3,3) = mat(3,3)-2*lam3*v2**2

 
 Do i1=2,3
  Do i2 = 1, i1-1 
  mat(i1,i2) = mat(i2,i1) 
  End do 
End do 

 
Call EigenSystem(mat,MHp2,ZP,ierr,test) 
 
 
! Fix phases
Do i1=1,3
  pos=Maxloc(Abs(ZP(i1,:)),1)
  If (Real(ZP(i1,pos),dp).lt.0._dp) Then
    ZP(i1,:)=-ZP(i1,:)
  End if
End do
If ((ierr.Eq.-8).Or.(ierr.Eq.-9)) Then 
  Write(ErrCan,*) "Possible numerical problem in "//NameOfUnit(Iname) 
  If (ErrorLevel.Eq.2) Then 
  Write(*,*) "Possible numerical problem in "//NameOfUnit(Iname) 
    Call TerminateProgram 
  End If 
  ierr = 0 
End If 
 
If ((ierr.Ne.0.).And.(ErrorLevel.Ge.-1)) Then 
  Write(10,*) 'Warning from Subroutine '//NameOfUnit(Iname) 
  Write(10,*) 'Diagonalization failed, ierr : ',ierr 
  kont = ierr 
  Iname = Iname - 1 
  Return 
End If 


Do i1=1,3
  If (MHp2(i1).ne.MHp2(i1)) Then 
      Write(*,*) 'NaN appearing in '//NameOfUnit(Iname) 
      Call TerminateProgram 
    End If 
  If (MHp2(i1).Ge.0._dp) Then 
  MHp(i1)=Sqrt(MHp2(i1) ) 
  Else 
  MHp(i1) = 1._dp 
! kont = -104 
 End if 
End Do 
Iname = Iname - 1 
 
End Subroutine CalculateMHpEffPot 

Subroutine CalculateMFdEffPot(Yd,v1,ZDL,ZDR,MFd,kont)

Real(dp),Intent(in) :: v1

Complex(dp),Intent(in) :: Yd(3,3)

Integer, Intent(inout) :: kont 
Integer :: i1,i2,i3,i4, ierr 
Integer :: j1,j2,j3,j4 
Real(dp), Intent(out) :: MFd(3) 
 Complex(dp), Intent(out) :: ZDL(3,3), ZDR(3,3) 
 
 Complex(dp) :: mat(3,3)=0._dp, mat2(3,3)=0._dp, phaseM 

Complex(dp) :: ZDL2(3,3), ZDR2(3,3) 
 
 Real(dp) :: ZDL1(3,3), ZDR1(3,3), test(2), MFd2(3) 
 
 Iname = Iname + 1 
NameOfUnit(Iname) = 'CalculateMFd'
 
MFd = 0._dp 
ZDL = 0._dp 
ZDR = 0._dp 
mat(1,1) = 0._dp 
mat(1,1) = mat(1,1)+(v1*Yd(1,1))/sqrt(2._dp)
mat(1,2) = 0._dp 
mat(1,2) = mat(1,2)+(v1*Yd(2,1))/sqrt(2._dp)
mat(1,3) = 0._dp 
mat(1,3) = mat(1,3)+(v1*Yd(3,1))/sqrt(2._dp)
mat(2,1) = 0._dp 
mat(2,1) = mat(2,1)+(v1*Yd(1,2))/sqrt(2._dp)
mat(2,2) = 0._dp 
mat(2,2) = mat(2,2)+(v1*Yd(2,2))/sqrt(2._dp)
mat(2,3) = 0._dp 
mat(2,3) = mat(2,3)+(v1*Yd(3,2))/sqrt(2._dp)
mat(3,1) = 0._dp 
mat(3,1) = mat(3,1)+(v1*Yd(1,3))/sqrt(2._dp)
mat(3,2) = 0._dp 
mat(3,2) = mat(3,2)+(v1*Yd(2,3))/sqrt(2._dp)
mat(3,3) = 0._dp 
mat(3,3) = mat(3,3)+(v1*Yd(3,3))/sqrt(2._dp)

 
mat2 = Matmul(Transpose(Conjg(mat)),mat) 
If (Maxval(Abs(Aimag(mat2))).Eq.0._dp) Then 
Call EigenSystem(Real(mat2,dp),MFd2,ZDR1,ierr,test) 
ZDR2 = ZDR1 
Else 
Call EigenSystem(mat2,MFd2,ZDR2,ierr,test) 
 End If 
 
If ((ierr.Eq.-8).Or.(ierr.Eq.-9)) Then 
  Write(ErrCan,*) "Possible numerical problem in "//NameOfUnit(Iname) 
  If (ErrorLevel.Eq.2) Then 
  Write(*,*) "Possible numerical problem in "//NameOfUnit(Iname) 
    Call TerminateProgram 
  End If 
  ierr = 0 
End If 
 
mat2 = Matmul(mat,Transpose(Conjg(mat))) 
If (Maxval(Abs(Aimag(mat2))).Eq.0._dp) Then 
Call EigenSystem (Real(mat2,dp),MFd2,ZDL1,ierr,test) 
                  
                  
ZDL2 = ZDL1 
Else 
Call EigenSystem(mat2,MFd2,ZDL2,ierr,test) 
 
 
End If 
ZDL2 = Conjg(ZDL2) 
 
If ((ierr.Eq.-8).Or.(ierr.Eq.-9)) Then 
  Write(ErrCan,*) "Possible numerical problem in "//NameOfUnit(Iname) 
  If (ErrorLevel.Eq.2) Then 
  Write(*,*) "Possible numerical problem in "//NameOfUnit(Iname) 
    Call TerminateProgram 
  End If 
  ierr = 0 
End If 
 
mat2 = Matmul(Matmul( Conjg(ZDL2),mat),Transpose( Conjg(ZDR2))) 
Do i1=1,3
If (Abs(mat2(i1,i1)).gt.0._dp) Then 
phaseM = mat2(i1,i1) / Abs(mat2(i1,i1)) 
ZDR2(i1,:) = phaseM *ZDR2(i1,:) 
 End if 
End Do 
 
Do i1=1,3
If (Abs(ZDR2(i1,i1)).gt.0._dp) Then 
phaseM = ZDR2(i1,i1) / Abs(ZDR2(i1,i1)) 
ZDR2(i1,:) = Conjg(phaseM) *ZDR2(i1,:) 
 ZDL2(i1,:) = phaseM *ZDL2(i1,:) 
 End if 
  If (MFd2(i1).ne.MFd2(i1)) Then 
      Write(*,*) 'NaN appearing in '//NameOfUnit(Iname) 
      Call TerminateProgram 
    End If 
  If (Abs(MFd2(i1)).Le.MaxMassNumericalZero) MFd2(i1) = Abs(MFd2(i1))+1.E-10_dp 
  If (MFd2(i1).Le.0._dp) Then 
! kont = -104 
 End if 
End Do 
 
If (ierr.Ne.0.) Then 
  Write(ErrCan,*) 'Warning from Subroutine CalculateMFd, ierr =',ierr 
  kont = ierr 
  Iname = Iname - 1 
  Return 
End If 


MFd = Sqrt( MFd2 ) 
ZDL = ZDL2 
ZDR = ZDR2 
Iname = Iname - 1 
 
End Subroutine CalculateMFdEffPot 

Subroutine CalculateMFuEffPot(Yu,v1,ZUL,ZUR,MFu,kont)

Real(dp),Intent(in) :: v1

Complex(dp),Intent(in) :: Yu(3,3)

Integer, Intent(inout) :: kont 
Integer :: i1,i2,i3,i4, ierr 
Integer :: j1,j2,j3,j4 
Real(dp), Intent(out) :: MFu(3) 
 Complex(dp), Intent(out) :: ZUL(3,3), ZUR(3,3) 
 
 Complex(dp) :: mat(3,3)=0._dp, mat2(3,3)=0._dp, phaseM 

Complex(dp) :: ZUL2(3,3), ZUR2(3,3) 
 
 Real(dp) :: ZUL1(3,3), ZUR1(3,3), test(2), MFu2(3) 
 
 Iname = Iname + 1 
NameOfUnit(Iname) = 'CalculateMFu'
 
MFu = 0._dp 
ZUL = 0._dp 
ZUR = 0._dp 
mat(1,1) = 0._dp 
mat(1,1) = mat(1,1)+(v1*Yu(1,1))/sqrt(2._dp)
mat(1,2) = 0._dp 
mat(1,2) = mat(1,2)+(v1*Yu(2,1))/sqrt(2._dp)
mat(1,3) = 0._dp 
mat(1,3) = mat(1,3)+(v1*Yu(3,1))/sqrt(2._dp)
mat(2,1) = 0._dp 
mat(2,1) = mat(2,1)+(v1*Yu(1,2))/sqrt(2._dp)
mat(2,2) = 0._dp 
mat(2,2) = mat(2,2)+(v1*Yu(2,2))/sqrt(2._dp)
mat(2,3) = 0._dp 
mat(2,3) = mat(2,3)+(v1*Yu(3,2))/sqrt(2._dp)
mat(3,1) = 0._dp 
mat(3,1) = mat(3,1)+(v1*Yu(1,3))/sqrt(2._dp)
mat(3,2) = 0._dp 
mat(3,2) = mat(3,2)+(v1*Yu(2,3))/sqrt(2._dp)
mat(3,3) = 0._dp 
mat(3,3) = mat(3,3)+(v1*Yu(3,3))/sqrt(2._dp)

 
mat2 = Matmul(Transpose(Conjg(mat)),mat) 
If (Maxval(Abs(Aimag(mat2))).Eq.0._dp) Then 
Call EigenSystem(Real(mat2,dp),MFu2,ZUR1,ierr,test) 
ZUR2 = ZUR1 
Else 
Call EigenSystem(mat2,MFu2,ZUR2,ierr,test) 
 End If 
 
If ((ierr.Eq.-8).Or.(ierr.Eq.-9)) Then 
  Write(ErrCan,*) "Possible numerical problem in "//NameOfUnit(Iname) 
  If (ErrorLevel.Eq.2) Then 
  Write(*,*) "Possible numerical problem in "//NameOfUnit(Iname) 
    Call TerminateProgram 
  End If 
  ierr = 0 
End If 
 
mat2 = Matmul(mat,Transpose(Conjg(mat))) 
If (Maxval(Abs(Aimag(mat2))).Eq.0._dp) Then 
Call EigenSystem (Real(mat2,dp),MFu2,ZUL1,ierr,test) 
                  
                  
ZUL2 = ZUL1 
Else 
Call EigenSystem(mat2,MFu2,ZUL2,ierr,test) 
 
 
End If 
ZUL2 = Conjg(ZUL2) 
 
If ((ierr.Eq.-8).Or.(ierr.Eq.-9)) Then 
  Write(ErrCan,*) "Possible numerical problem in "//NameOfUnit(Iname) 
  If (ErrorLevel.Eq.2) Then 
  Write(*,*) "Possible numerical problem in "//NameOfUnit(Iname) 
    Call TerminateProgram 
  End If 
  ierr = 0 
End If 
 
mat2 = Matmul(Matmul( Conjg(ZUL2),mat),Transpose( Conjg(ZUR2))) 
Do i1=1,3
If (Abs(mat2(i1,i1)).gt.0._dp) Then 
phaseM = mat2(i1,i1) / Abs(mat2(i1,i1)) 
ZUR2(i1,:) = phaseM *ZUR2(i1,:) 
 End if 
End Do 
 
Do i1=1,3
If (Abs(ZUR2(i1,i1)).gt.0._dp) Then 
phaseM = ZUR2(i1,i1) / Abs(ZUR2(i1,i1)) 
ZUR2(i1,:) = Conjg(phaseM) *ZUR2(i1,:) 
 ZUL2(i1,:) = phaseM *ZUL2(i1,:) 
 End if 
  If (MFu2(i1).ne.MFu2(i1)) Then 
      Write(*,*) 'NaN appearing in '//NameOfUnit(Iname) 
      Call TerminateProgram 
    End If 
  If (Abs(MFu2(i1)).Le.MaxMassNumericalZero) MFu2(i1) = Abs(MFu2(i1))+1.E-10_dp 
  If (MFu2(i1).Le.0._dp) Then 
! kont = -104 
 End if 
End Do 
 
If (ierr.Ne.0.) Then 
  Write(ErrCan,*) 'Warning from Subroutine CalculateMFu, ierr =',ierr 
  kont = ierr 
  Iname = Iname - 1 
  Return 
End If 


MFu = Sqrt( MFu2 ) 
ZUL = ZUL2 
ZUR = ZUR2 
Iname = Iname - 1 
 
End Subroutine CalculateMFuEffPot 

Subroutine CalculateMFeEffPot(Ye,v1,ZEL,ZER,MFe,kont)

Real(dp),Intent(in) :: v1

Complex(dp),Intent(in) :: Ye(3,3)

Integer, Intent(inout) :: kont 
Integer :: i1,i2,i3,i4, ierr 
Integer :: j1,j2,j3,j4 
Real(dp), Intent(out) :: MFe(3) 
 Complex(dp), Intent(out) :: ZEL(3,3), ZER(3,3) 
 
 Complex(dp) :: mat(3,3)=0._dp, mat2(3,3)=0._dp, phaseM 

Complex(dp) :: ZEL2(3,3), ZER2(3,3) 
 
 Real(dp) :: ZEL1(3,3), ZER1(3,3), test(2), MFe2(3) 
 
 Iname = Iname + 1 
NameOfUnit(Iname) = 'CalculateMFe'
 
MFe = 0._dp 
ZEL = 0._dp 
ZER = 0._dp 
mat(1,1) = 0._dp 
mat(1,1) = mat(1,1)+(v1*Ye(1,1))/sqrt(2._dp)
mat(1,2) = 0._dp 
mat(1,2) = mat(1,2)+(v1*Ye(2,1))/sqrt(2._dp)
mat(1,3) = 0._dp 
mat(1,3) = mat(1,3)+(v1*Ye(3,1))/sqrt(2._dp)
mat(2,1) = 0._dp 
mat(2,1) = mat(2,1)+(v1*Ye(1,2))/sqrt(2._dp)
mat(2,2) = 0._dp 
mat(2,2) = mat(2,2)+(v1*Ye(2,2))/sqrt(2._dp)
mat(2,3) = 0._dp 
mat(2,3) = mat(2,3)+(v1*Ye(3,2))/sqrt(2._dp)
mat(3,1) = 0._dp 
mat(3,1) = mat(3,1)+(v1*Ye(1,3))/sqrt(2._dp)
mat(3,2) = 0._dp 
mat(3,2) = mat(3,2)+(v1*Ye(2,3))/sqrt(2._dp)
mat(3,3) = 0._dp 
mat(3,3) = mat(3,3)+(v1*Ye(3,3))/sqrt(2._dp)

 
mat2 = Matmul(Transpose(Conjg(mat)),mat) 
If (Maxval(Abs(Aimag(mat2))).Eq.0._dp) Then 
Call EigenSystem(Real(mat2,dp),MFe2,ZER1,ierr,test) 
ZER2 = ZER1 
Else 
Call EigenSystem(mat2,MFe2,ZER2,ierr,test) 
 End If 
 
If ((ierr.Eq.-8).Or.(ierr.Eq.-9)) Then 
  Write(ErrCan,*) "Possible numerical problem in "//NameOfUnit(Iname) 
  If (ErrorLevel.Eq.2) Then 
  Write(*,*) "Possible numerical problem in "//NameOfUnit(Iname) 
    Call TerminateProgram 
  End If 
  ierr = 0 
End If 
 
mat2 = Matmul(mat,Transpose(Conjg(mat))) 
If (Maxval(Abs(Aimag(mat2))).Eq.0._dp) Then 
Call EigenSystem (Real(mat2,dp),MFe2,ZEL1,ierr,test) 
                  
                  
ZEL2 = ZEL1 
Else 
Call EigenSystem(mat2,MFe2,ZEL2,ierr,test) 
 
 
End If 
ZEL2 = Conjg(ZEL2) 
 
If ((ierr.Eq.-8).Or.(ierr.Eq.-9)) Then 
  Write(ErrCan,*) "Possible numerical problem in "//NameOfUnit(Iname) 
  If (ErrorLevel.Eq.2) Then 
  Write(*,*) "Possible numerical problem in "//NameOfUnit(Iname) 
    Call TerminateProgram 
  End If 
  ierr = 0 
End If 
 
mat2 = Matmul(Matmul( Conjg(ZEL2),mat),Transpose( Conjg(ZER2))) 
Do i1=1,3
If (Abs(mat2(i1,i1)).gt.0._dp) Then 
phaseM = mat2(i1,i1) / Abs(mat2(i1,i1)) 
ZER2(i1,:) = phaseM *ZER2(i1,:) 
 End if 
End Do 
 
Do i1=1,3
If (Abs(ZER2(i1,i1)).gt.0._dp) Then 
phaseM = ZER2(i1,i1) / Abs(ZER2(i1,i1)) 
ZER2(i1,:) = Conjg(phaseM) *ZER2(i1,:) 
 ZEL2(i1,:) = phaseM *ZEL2(i1,:) 
 End if 
  If (MFe2(i1).ne.MFe2(i1)) Then 
      Write(*,*) 'NaN appearing in '//NameOfUnit(Iname) 
      Call TerminateProgram 
    End If 
  If (Abs(MFe2(i1)).Le.MaxMassNumericalZero) MFe2(i1) = Abs(MFe2(i1))+1.E-10_dp 
  If (MFe2(i1).Le.0._dp) Then 
! kont = -104 
 End if 
End Do 
 
If (ierr.Ne.0.) Then 
  Write(ErrCan,*) 'Warning from Subroutine CalculateMFe, ierr =',ierr 
  kont = ierr 
  Iname = Iname - 1 
  Return 
End If 


MFe = Sqrt( MFe2 ) 
ZEL = ZEL2 
ZER = ZER2 
Iname = Iname - 1 
 
End Subroutine CalculateMFeEffPot 

Subroutine CalculateVPVZEffPot(g1,g2,v1,v2,ZZ,MVZ,MVZ2,TW,kont)

Real(dp), Intent(in) :: g1,g2,v1,v2

Real(dp), Intent(out) :: TW

Integer, Intent(inout) :: kont 
Integer :: i1,i2,i3,i4, ierr 
Integer :: j1,j2,j3,j4 
Real(dp), Intent(out) :: MVZ, MVZ2
Real(dp) :: VPVZ2(2),VPVZ(2)  

Real(dp), Intent(out) :: ZZ(2,2) 
 
Real(dp) :: mat(2,2)  

Real(dp) ::  test(2) 

Iname = Iname + 1 
NameOfUnit(Iname) = 'CalculateVPVZ'
 
mat(1,1) = 0._dp 
mat(1,1) = mat(1,1)+(g1**2*v1Fix**2)/4._dp
mat(1,1) = mat(1,1)+g1**2*v2Fix**2
mat(1,2) = 0._dp 
mat(1,2) = mat(1,2)-(g1*g2*v1Fix**2)/4._dp
mat(1,2) = mat(1,2)-(g1*g2*v2Fix**2)
mat(2,2) = 0._dp 
mat(2,2) = mat(2,2)+(g2**2*v1Fix**2)/4._dp
mat(2,2) = mat(2,2)+g2**2*v2Fix**2

 
 Do i1=2,2
  Do i2 = 1, i1-1 
  mat(i1,i2) = mat(i2,i1) 
  End do 
End do 

 
Call EigenSystem(mat,VPVZ2,ZZ,ierr,test) 
 
 
ZZ = Transpose(ZZ) 
If ((ierr.Eq.-8).Or.(ierr.Eq.-9)) Then 
  Write(ErrCan,*) "Possible numerical problem in "//NameOfUnit(Iname) 
  If (ErrorLevel.Eq.2) Then 
  Write(*,*) "Possible numerical problem in "//NameOfUnit(Iname) 
    Call TerminateProgram 
  End If 
  ierr = 0 
End If 
 
If ((ierr.Ne.0.).And.(ErrorLevel.Ge.-1)) Then 
  Write(10,*) 'Warning from Subroutine '//NameOfUnit(Iname) 
  Write(10,*) 'Diagonalization failed, ierr : ',ierr 
  kont = ierr 
  Iname = Iname - 1 
  Return 
End If 


Do i1=1,2
  If (Abs(VPVZ2(i1)).Le.1.E-10_dp*(Maxval(VPVZ2))) VPVZ2(i1) = 1.E-10_dp 
  If (VPVZ2(i1).ne.VPVZ2(i1)) Then 
      Write(*,*) 'NaN appearing in '//NameOfUnit(Iname) 
      Call TerminateProgram 
    End If 
  If (VPVZ2(i1).Ge.0._dp) Then 
  VPVZ(i1) =Sqrt(VPVZ2(i1) ) 
  Else 
  VPVZ(i1)= 1._dp 
  VPVZ(i1)= 1._dp 
! kont = -104 
 End if 
End Do 
 
MVZ = VPVZ(2) 
MVZ2 = VPVZ2(2) 

 Iname = Iname - 1 
 
End Subroutine CalculateVPVZEffPot 

Subroutine CalculateVWpEffPot(g2,v1,v2,ZW,MVWp,MVWp2,kont)

Real(dp), Intent(in) :: g2,v1,v2

Integer, Intent(inout) :: kont 
Integer :: i1,i2,i3,i4, ierr 
Integer :: j1,j2,j3,j4 
Real(dp), Intent(out) :: MVWp, MVWp2
Real(dp) :: VWp2(2),VWp(2)  

Complex(dp), Intent(out) :: ZW(2,2) 
 
Complex(dp) :: mat(2,2)  

Real(dp) ::  test(2) 

Iname = Iname + 1 
NameOfUnit(Iname) = 'CalculateVWp'
 
mat(1,1) = 0._dp 
mat(1,1) = mat(1,1)+(g2**2*v1Fix**2)/4._dp
mat(1,1) = mat(1,1)+g2**2*v2Fix**2
mat(1,2) = 0._dp 
mat(2,2) = 0._dp 
mat(2,2) = mat(2,2)+(g2**2*v1Fix**2)/4._dp
mat(2,2) = mat(2,2)+g2**2*v2Fix**2

 
 Do i1=2,2
  Do i2 = 1, i1-1 
  mat(i1,i2) = Conjg(mat(i2,i1)) 
  End do 
End do 

 
Call EigenSystem(mat,VWp2,ZW,ierr,test) 
 
 
ZW = Transpose(ZW) 
If ((ierr.Eq.-8).Or.(ierr.Eq.-9)) Then 
  Write(ErrCan,*) "Possible numerical problem in "//NameOfUnit(Iname) 
  If (ErrorLevel.Eq.2) Then 
  Write(*,*) "Possible numerical problem in "//NameOfUnit(Iname) 
    Call TerminateProgram 
  End If 
  ierr = 0 
End If 
 
If ((ierr.Ne.0.).And.(ErrorLevel.Ge.-1)) Then 
  Write(10,*) 'Warning from Subroutine '//NameOfUnit(Iname) 
  Write(10,*) 'Diagonalization failed, ierr : ',ierr 
  kont = ierr 
  Iname = Iname - 1 
  Return 
End If 


Do i1=1,2
  If (Abs(VWp2(i1)).Le.1.E-10_dp*(Maxval(VWp2))) VWp2(i1) = 1.E-10_dp 
  If (VWp2(i1).ne.VWp2(i1)) Then 
      Write(*,*) 'NaN appearing in '//NameOfUnit(Iname) 
      Call TerminateProgram 
    End If 
  If (VWp2(i1).Ge.0._dp) Then 
  VWp(i1) =Sqrt(VWp2(i1) ) 
  Else 
  VWp(i1)= 1._dp 
  VWp(i1)= 1._dp 
! kont = -104 
 End if 
End Do 
 
MVWp = VWp(1) 
MVWp2 = VWp2(1) 

 Iname = Iname - 1 
 
End Subroutine CalculateVWpEffPot 

Subroutine TreeMassesSM(MFd,MFd2,MFe,MFe2,MFu,MFu2,MVWp,MVWp2,MVZ,MVZ2,               & 
& TW,ZDR,ZER,ZUR,ZDL,ZEL,ZUL,ZW,ZZ,v1,v2,g1,g2,g3,lam1,lam3,lam4,lam2,lam12,             & 
& lam7,lam11,lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,GenerationMixing,kont)

Implicit None 
 
Real(dp),Intent(in) :: g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,            & 
& lam8,mu1,mu2,mu0

Complex(dp),Intent(in) :: Yu(3,3),Yd(3,3),Ye(3,3)

Real(dp),Intent(out) :: MFd(3),MFd2(3),MFe(3),MFe2(3),MFu(3),MFu2(3),MVWp,MVWp2,MVZ,MVZ2,TW,ZZ(2,2)

Complex(dp),Intent(out) :: ZDR(3,3),ZER(3,3),ZUR(3,3),ZDL(3,3),ZEL(3,3),ZUL(3,3),ZW(2,2)

Real(dp),Intent(in) :: v1,v2

Logical, Intent(in) :: GenerationMixing 
Integer, Intent(inout) :: kont 
Integer :: i1,i2,i3,i4,j1,j2,j3,kontSave 
Iname = Iname + 1 
NameOfUnit(Iname) = 'TreeMasses4HDM_S3'
 
kont = 0 
Call CalculateMFd(Yd,v1,ZDL,ZDR,MFd,kont)

MFd2 = MFd**2 
Call CalculateMFu(Yu,v1,ZUL,ZUR,MFu,kont)

MFu2 = MFu**2 
Call CalculateMFe(Ye,v1,ZEL,ZER,MFe,kont)

MFe2 = MFe**2 

 
 Call CalculateVPVZ(g1,g2,v1,v2,ZZ,MVZ,MVZ2,TW,kont)

Call CalculateVWp(g2,v1,v2,ZW,MVWp,MVWp2,kont)

Iname = Iname - 1 
 
End Subroutine  TreeMassesSM 
 
 
Subroutine SortGoldstones(MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,MHap2,             & 
& Mhha,Mhha2,MHhSM,MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,              & 
& ZER,ZUR,v,ZDL,ZEL,ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,kont)

Real(dp),Intent(inout) :: MAh(3),MAh2(3),MFd(3),MFd2(3),MFe(3),MFe2(3),MFu(3),MFu2(3),MHap,MHap2,               & 
& Mhha,Mhha2,MHhSM(3),MHhSM2(3),MHp(3),MHp2(3),Msiga,Msiga2,MVWp,MVWp2,MVZ,              & 
& MVZ2,TW,v,ZA(3,3),ZH(3,3),ZP(3,3),ZZ(2,2),betaH

Complex(dp),Intent(inout) :: ZDR(3,3),ZER(3,3),ZUR(3,3),ZDL(3,3),ZEL(3,3),ZUL(3,3),ZW(2,2)

Integer, Intent(inout) :: kont 
Integer :: i1, i2, pos 
Real(dp) :: MAhtemp(3) 
Complex(dp) :: ZAhtemp(3,3) 
Real(dp) :: MHptemp(3) 
Complex(dp) :: ZHptemp(3,3) 


pos = MinLoc(Abs(MAh2-MVZ2*RXiZ),1) 
If (pos.ne.1) Then 
  MAhtemp = MAh2 
  ZAhtemp = ZA 
  MAh2(1) = MAhtemp(pos) 
  ZA(1,:) = ZAhtemp(pos,:) 
  MAh2(pos) = MAhtemp(1) 
  ZA(pos,:) = ZAhtemp(1,:) 
End if 

 ! Reorder the physical states by their mass 
Do i1=2,3
 pos = Minloc(MAh2(i1:3),1) + i1 -1  
If (pos.ne.i1) Then 
  MAhtemp = MAh2 
  ZAhtemp = ZA 
  MAh2(i1) = MAhtemp(pos) 
  ZA(i1,:) = ZAhtemp(pos,:) 
  MAh2(pos) = MAhtemp(i1) 
  ZA(pos,:) = ZAhtemp(i1,:) 
End if 
End do 
MAh = sqrt(MAh2) 

 
 
pos = MinLoc(Abs(MHp2-MVWp2*RXiWp),1) 
If (pos.ne.1) Then 
  MHptemp = MHp2 
  ZHptemp = ZP 
  MHp2(1) = MHptemp(pos) 
  ZP(1,:) = ZHptemp(pos,:) 
  MHp2(pos) = MHptemp(1) 
  ZP(pos,:) = ZHptemp(1,:) 
End if 

 ! Reorder the physical states by their mass 
Do i1=2,3
 pos = Minloc(MHp2(i1:3),1) + i1 -1  
If (pos.ne.i1) Then 
  MHptemp = MHp2 
  ZHptemp = ZP 
  MHp2(i1) = MHptemp(pos) 
  ZP(i1,:) = ZHptemp(pos,:) 
  MHp2(pos) = MHptemp(i1) 
  ZP(pos,:) = ZHptemp(i1,:) 
End if 
End do 
MHp = sqrt(MHp2) 

 
 
End subroutine SortGoldstones 


End Module TreeLevelMasses_4HDM_S3 
 
