! -----------------------------------------------------------------------------  
! This file was automatically created by SARAH version 4.12.3 
! SARAH References: arXiv:0806.0538, 0909.2863, 1002.0840, 1207.0906, 1309.7223  
! (c) Florian Staub, 2013  
! ------------------------------------------------------------------------------  
! File created at 8:13 on 5.4.2018   
! ----------------------------------------------------------------------  
 
 
Module OneLoopDecay_Ah_4HDM_S3
Use Control 
Use Settings 
Use LoopFunctions 
Use AddLoopFunctions 
Use Model_Data_4HDM_S3 
Use DecayFFS 
Use DecayFFV 
Use DecaySSS 
Use DecaySFF 
Use DecaySSV 
Use DecaySVV 
Use Bremsstrahlung 

Contains 

Subroutine Amplitude_Tree_4HDM_S3_AhToHhSMAh(cplAhAhHhSM,MAh,MHhSM,MAh2,              & 
& MHhSM2,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MHhSM(3),MAh2(3),MHhSM2(3)

Complex(dp), Intent(in) :: cplAhAhHhSM(3,3,3)

Complex(dp) :: Amp(3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 

Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MHhSM(gt2) 
Mex3 = MAh(gt3) 
! Tree-Level Vertex 
coupT1 = cplAhAhHhSM(gt1,gt3,gt2)
Call TreeAmp_StoSS(Mex1,Mex2,Mex3,coupT1,AmpC) 
! Colour and symmetry factor 
Amp(gt1, gt2, gt3) = AmpC 
    End Do
  End Do
End Do
End Subroutine Amplitude_Tree_4HDM_S3_AhToHhSMAh


Subroutine Gamma_Real_4HDM_S3_AhToHhSMAh(MLambda,em,gs,cplAhAhHhSM,MAh,               & 
& MHhSM,GammarealPhoton,GammarealGluon)

Implicit None

Complex(dp), Intent(in) :: cplAhAhHhSM(3,3,3)

Real(dp), Intent(in) :: MAh(3),MHhSM(3)

Real(dp), Intent(in) :: MLambda, em, gs 

Real(dp), Intent(out) :: GammarealPhoton(3,3,3), GammarealGluon(3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3, kont 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 

Real(dp) :: Mloop1, Mloop2, Mloop3 
Complex(dp) :: Coup 
 
Do i1=2,3
  Do i2=1,3
    Do i3=2,3
Coup = cplAhAhHhSM(i1,i3,i2)
Mex1 = MAh(i1)
Mex2 = MHhSM(i2)
Mex3 = MAh(i3)
If (Mex1.gt.(Mex2+Mex3)) Then 
 Gammarealphoton(i1,i2,i3) = 0._dp 
  GammarealGluon(i1,i2,i3) = 0._dp 
Else 
  GammarealGluon(i1,i2,i3) = 0._dp 
  GammarealPhoton(i1,i2,i3) = 0._dp 

End if 
    End Do
  End Do
End Do
End Subroutine Gamma_Real_4HDM_S3_AhToHhSMAh


Subroutine Amplitude_WAVE_4HDM_S3_AhToHhSMAh(cplAhAhHhSM,ctcplAhAhHhSM,               & 
& MAh,MAh2,MHhSM,MHhSM2,ZfAh,ZfHhSM,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MAh2(3),MHhSM(3),MHhSM2(3)

Complex(dp), Intent(in) :: cplAhAhHhSM(3,3,3)

Complex(dp), Intent(in) :: ctcplAhAhHhSM(3,3,3)

Complex(dp), Intent(in) :: ZfAh(3,3),ZfHhSM(3,3)

Complex(dp), Intent(out) :: Amp(3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MHhSM(gt2) 
Mex3 = MAh(gt3) 
!----------------------------- 
! Coupling counter term 
!----------------------------- 
ZcoupT1 = ctcplAhAhHhSM(gt1,gt3,gt2) 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
Do i1=1,3
ZcoupT1 = ZcoupT1 + 0.5_dp*ZfAh(i1,gt1)*cplAhAhHhSM(i1,gt3,gt2)
End Do


! External Field 2 
Do i1=1,3
ZcoupT1 = ZcoupT1 + 0.5_dp*ZfHhSM(i1,gt2)*cplAhAhHhSM(gt1,gt3,i1)
End Do


! External Field 3 
Do i1=1,3
ZcoupT1 = ZcoupT1 + 0.5_dp*ZfAh(i1,gt3)*cplAhAhHhSM(gt1,i1,gt2)
End Do


! Getting the amplitude 
Call TreeAmp_StoSS(Mex1,Mex2,Mex3,ZcoupT1,AmpC) 
Amp(gt1, gt2, gt3) = AmpC 
    End Do
  End Do
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_AhToHhSMAh


Subroutine Amplitude_VERTEX_4HDM_S3_AhToHhSMAh(MAh,MFd,MFe,MFu,MHap,Mhha,             & 
& MHhSM,MHp,Msiga,MVWp,MVZ,MAh2,MFd2,MFe2,MFu2,MHap2,Mhha2,MHhSM2,MHp2,Msiga2,           & 
& MVWp2,MVZ2,cplAhAhHhSM,cplcFdFdAhL,cplcFdFdAhR,cplcFeFeAhL,cplcFeFeAhR,cplcFuFuAhL,    & 
& cplcFuFuAhR,cplcgWpgWpAh,cplcgWCgWCAh,cplAhhhasiga,cplAhHhSMVZ,cplAhHpcHp,             & 
& cplAhHpcVWp,cplAhcHpVWp,cplcFdFdHhSML,cplcFdFdHhSMR,cplcFeFeHhSML,cplcFeFeHhSMR,       & 
& cplcFuFuHhSML,cplcFuFuHhSMR,cplcgWpgWpHhSM,cplcgWCgWCHhSM,cplHapHhSMcHap,              & 
& cplhhahhaHhSM,cplHhSMHhSMHhSM,cplHhSMHpcHp,cplHhSMHpcVWp,cplHhSMsigasiga,              & 
& cplHhSMcHpVWp,cplHhSMcVWpVWp,cplHhSMVZVZ,cplAhAhAhAh1,cplAhAhHapcHap1,cplAhAhhhahha1,  & 
& cplAhAhHhSMHhSM1,cplAhAhHpcHp1,cplAhAhsigasiga1,cplAhAhcVWpVWp1,cplAhAhVZVZ1,          & 
& cplAhhhaHhSMsiga1,cplAhHhSMHpcHp1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHap,Mhha,MHhSM(3),MHp(3),Msiga,MVWp,MVZ,MAh2(3),         & 
& MFd2(3),MFe2(3),MFu2(3),MHap2,Mhha2,MHhSM2(3),MHp2(3),Msiga2,MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhAhHhSM(3,3,3),cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFeFeAhL(3,3,3),          & 
& cplcFeFeAhR(3,3,3),cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcgWpgWpAh(3),              & 
& cplcgWCgWCAh(3),cplAhhhasiga(3),cplAhHhSMVZ(3,3),cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),   & 
& cplAhcHpVWp(3,3),cplcFdFdHhSML(3,3,3),cplcFdFdHhSMR(3,3,3),cplcFeFeHhSML(3,3,3),       & 
& cplcFeFeHhSMR(3,3,3),cplcFuFuHhSML(3,3,3),cplcFuFuHhSMR(3,3,3),cplcgWpgWpHhSM(3),      & 
& cplcgWCgWCHhSM(3),cplHapHhSMcHap(3),cplhhahhaHhSM(3),cplHhSMHhSMHhSM(3,3,3),           & 
& cplHhSMHpcHp(3,3,3),cplHhSMHpcVWp(3,3),cplHhSMsigasiga(3),cplHhSMcHpVWp(3,3),          & 
& cplHhSMcVWpVWp(3),cplHhSMVZVZ(3),cplAhAhAhAh1(3,3,3,3),cplAhAhHapcHap1(3,3),           & 
& cplAhAhhhahha1(3,3),cplAhAhHhSMHhSM1(3,3,3,3),cplAhAhHpcHp1(3,3,3,3),cplAhAhsigasiga1(3,3),& 
& cplAhAhcVWpVWp1(3,3),cplAhAhVZVZ1(3,3),cplAhhhaHhSMsiga1(3,3),cplAhHhSMHpcHp1(3,3,3,3)

Complex(dp), Intent(out) :: Amp(3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
Amp(gt1, gt2, gt3) = 0._dp 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MHhSM(gt2) 
Mex3 = MAh(gt3) 


! {Ah, HhSM, Ah}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MAh(i1) 
ML2 = MHhSM(i2) 
ML3 = MAh(i3) 
coup1 = cplAhAhHhSM(gt1,i1,i2)
coup2 = cplAhAhHhSM(i1,i3,gt2)
coup3 = cplAhAhHhSM(gt3,i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Ah, HhSM, VZ}
Do i1=1,3
  Do i2=1,3
ML1 = MAh(i1) 
ML2 = MHhSM(i2) 
ML3 = MVZ 
coup1 = cplAhAhHhSM(gt1,i1,i2)
coup2 = cplAhHhSMVZ(i1,gt2)
coup3 = cplAhHhSMVZ(gt3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Fd, Fd, Fd}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFd(i1) 
ML2 = MFd(i2) 
ML3 = MFd(i3) 
coup1L = cplcFdFdAhL(i2,i1,gt1)
coup1R = cplcFdFdAhR(i2,i1,gt1)
coup2L = cplcFdFdHhSML(i1,i3,gt2)
coup2R = cplcFdFdHhSMR(i1,i3,gt2)
coup3L = cplcFdFdAhL(i3,i2,gt3)
coup3R = cplcFdFdAhR(i3,i2,gt3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(6)*AmpC 
    End Do
  End Do
End Do


! {Fe, Fe, Fe}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFe(i1) 
ML2 = MFe(i2) 
ML3 = MFe(i3) 
coup1L = cplcFeFeAhL(i2,i1,gt1)
coup1R = cplcFeFeAhR(i2,i1,gt1)
coup2L = cplcFeFeHhSML(i1,i3,gt2)
coup2R = cplcFeFeHhSMR(i1,i3,gt2)
coup3L = cplcFeFeAhL(i3,i2,gt3)
coup3R = cplcFeFeAhR(i3,i2,gt3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(2)*AmpC 
    End Do
  End Do
End Do


! {Fu, Fu, Fu}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFu(i1) 
ML2 = MFu(i2) 
ML3 = MFu(i3) 
coup1L = cplcFuFuAhL(i2,i1,gt1)
coup1R = cplcFuFuAhR(i2,i1,gt1)
coup2L = cplcFuFuHhSML(i1,i3,gt2)
coup2R = cplcFuFuHhSMR(i1,i3,gt2)
coup3L = cplcFuFuAhL(i3,i2,gt3)
coup3R = cplcFuFuAhR(i3,i2,gt3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(6)*AmpC 
    End Do
  End Do
End Do


! {gWp, gWp, gWp}
ML1 = MVWp 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcgWpgWpAh(gt1)
coup2 = cplcgWpgWpHhSM(gt2)
coup3 = cplcgWpgWpAh(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(2)*AmpC 


! {gWpC, gWpC, gWpC}
ML1 = MVWp 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcgWCgWCAh(gt1)
coup2 = cplcgWCgWCHhSM(gt2)
coup3 = cplcgWCgWCAh(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(2)*AmpC 


! {hha, siga, hha}
ML1 = Mhha 
ML2 = Msiga 
ML3 = Mhha 
coup1 = cplAhhhasiga(gt1)
coup2 = cplhhahhaHhSM(gt2)
coup3 = cplAhhhasiga(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {HhSM, Ah, HhSM}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHhSM(i1) 
ML2 = MAh(i2) 
ML3 = MHhSM(i3) 
coup1 = cplAhAhHhSM(gt1,i2,i1)
coup2 = cplHhSMHhSMHhSM(gt2,i1,i3)
coup3 = cplAhAhHhSM(gt3,i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {HhSM, VZ, HhSM}
Do i1=1,3
    Do i3=1,3
ML1 = MHhSM(i1) 
ML2 = MVZ 
ML3 = MHhSM(i3) 
coup1 = -cplAhHhSMVZ(gt1,i1)
coup2 = cplHhSMHhSMHhSM(gt2,i1,i3)
coup3 = cplAhHhSMVZ(gt3,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, Hp, Hp}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplHhSMHpcHp(gt2,i3,i1)
coup3 = cplAhHpcHp(gt3,i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(2)*AmpC 
    End Do
  End Do
End Do


! {Hp, VWp, Hp}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = -cplAhHpcVWp(gt1,i1)
coup2 = cplHhSMHpcHp(gt2,i3,i1)
coup3 = cplAhcHpVWp(gt3,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, Hp, VWp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = -cplHhSMcHpVWp(gt2,i1)
coup3 = cplAhHpcVWp(gt3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {siga, hha, siga}
ML1 = Msiga 
ML2 = Mhha 
ML3 = Msiga 
coup1 = cplAhhhasiga(gt1)
coup2 = cplHhSMsigasiga(gt2)
coup3 = cplAhhhasiga(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {VWp, Hp, Hp}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = -cplAhcHpVWp(gt1,i2)
coup2 = -cplHhSMHpcVWp(gt2,i3)
coup3 = cplAhHpcHp(gt3,i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VWp, Hp, VWp}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = -cplAhcHpVWp(gt1,i2)
coup2 = cplHhSMcVWpVWp(gt2)
coup3 = cplAhHpcVWp(gt3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do


! {VZ, HhSM, Ah}
  Do i2=1,3
    Do i3=1,3
ML1 = MVZ 
ML2 = MHhSM(i2) 
ML3 = MAh(i3) 
coup1 = -cplAhHhSMVZ(gt1,i2)
coup2 = cplAhHhSMVZ(i3,gt2)
coup3 = cplAhAhHhSM(gt3,i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VZ, HhSM, VZ}
  Do i2=1,3
ML1 = MVZ 
ML2 = MHhSM(i2) 
ML3 = MVZ 
coup1 = -cplAhHhSMVZ(gt1,i2)
coup2 = cplHhSMVZVZ(gt2)
coup3 = cplAhHhSMVZ(gt3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do


! {conj[Hp], conj[VWp], conj[Hp]}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = -cplAhcHpVWp(gt1,i1)
coup2 = cplHhSMHpcHp(gt2,i1,i3)
coup3 = cplAhHpcVWp(gt3,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {conj[Hp], conj[Hp], conj[VWp]}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplAhHpcHp(gt1,i2,i1)
coup2 = -cplHhSMHpcVWp(gt2,i1)
coup3 = cplAhcHpVWp(gt3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {conj[VWp], conj[Hp], conj[Hp]}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = -cplAhHpcVWp(gt1,i2)
coup2 = -cplHhSMcHpVWp(gt2,i3)
coup3 = cplAhHpcHp(gt3,i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {conj[VWp], conj[Hp], conj[VWp]}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = -cplAhHpcVWp(gt1,i2)
coup2 = cplHhSMcVWpVWp(gt2)
coup3 = cplAhcHpVWp(gt3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do


! {Ah, HhSM}
Do i1=1,3
  Do i2=1,3
ML1 = MAh(i1) 
ML2 = MHhSM(i2) 
coup1 = cplAhAhHhSM(gt1,i1,i2)
coup2 = cplAhAhHhSMHhSM1(gt3,i1,gt2,i2)
Call Amp_VERTEX_StoSS_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {hha, siga}
ML1 = Mhha 
ML2 = Msiga 
coup1 = cplAhhhasiga(gt1)
coup2 = cplAhhhaHhSMsiga1(gt3,gt2)
Call Amp_VERTEX_StoSS_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {Hp, Hp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplAhHhSMHpcHp1(gt3,gt2,i2,i1)
Call Amp_VERTEX_StoSS_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Ah, Ah}
Do i1=1,3
  Do i2=1,3
ML1 = MAh(i1) 
ML2 = MAh(i2) 
coup1 = cplAhAhAhAh1(gt1,gt3,i1,i2)
coup2 = cplAhAhHhSM(i1,i2,gt2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1._dp/2._dp)*AmpC 

  End Do
End Do


! {Hap, Hap}
ML1 = MHap 
ML2 = MHap 
coup1 = cplAhAhHapcHap1(gt1,gt3)
coup2 = cplHapHhSMcHap(gt2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 



! {hha, hha}
ML1 = Mhha 
ML2 = Mhha 
coup1 = cplAhAhhhahha1(gt1,gt3)
coup2 = cplhhahhaHhSM(gt2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1._dp/2._dp)*AmpC 



! {HhSM, HhSM}
Do i1=1,3
  Do i2=1,3
ML1 = MHhSM(i1) 
ML2 = MHhSM(i2) 
coup1 = cplAhAhHhSMHhSM1(gt1,gt3,i1,i2)
coup2 = cplHhSMHhSMHhSM(gt2,i1,i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1._dp/2._dp)*AmpC 

  End Do
End Do


! {Hp, Hp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
coup1 = cplAhAhHpcHp1(gt1,gt3,i1,i2)
coup2 = cplHhSMHpcHp(gt2,i2,i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 

  End Do
End Do


! {siga, siga}
ML1 = Msiga 
ML2 = Msiga 
coup1 = cplAhAhsigasiga1(gt1,gt3)
coup2 = cplHhSMsigasiga(gt2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1._dp/2._dp)*AmpC 



! {VWp, VWp}
ML1 = MVWp 
ML2 = MVWp 
coup1 = cplAhAhcVWpVWp1(gt1,gt3)
coup2 = cplHhSMcVWpVWp(gt2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 



! {VZ, VZ}
ML1 = MVZ 
ML2 = MVZ 
coup1 = cplAhAhVZVZ1(gt1,gt3)
coup2 = cplHhSMVZVZ(gt2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1._dp/2._dp)*AmpC 



! {Ah, HhSM}
Do i1=1,3
  Do i2=1,3
ML1 = MAh(i1) 
ML2 = MHhSM(i2) 
coup1 = cplAhAhHhSMHhSM1(gt1,i1,gt2,i2)
coup2 = cplAhAhHhSM(gt3,i1,i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 

  End Do
End Do


! {hha, siga}
ML1 = Mhha 
ML2 = Msiga 
coup1 = cplAhhhaHhSMsiga1(gt1,gt2)
coup2 = cplAhhhasiga(gt3)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 



! {Hp, Hp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
coup1 = cplAhHhSMHpcHp1(gt1,gt2,i1,i2)
coup2 = cplAhHpcHp(gt3,i2,i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 

  End Do
End Do
    End Do
  End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_AhToHhSMAh


Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhToHhSMAh(MAh,MFd,MFe,MFu,MHap,               & 
& Mhha,MHhSM,MHp,Msiga,MVWp,MVZ,MAh2,MFd2,MFe2,MFu2,MHap2,Mhha2,MHhSM2,MHp2,             & 
& Msiga2,MVWp2,MVZ2,cplAhAhHhSM,cplcFdFdAhL,cplcFdFdAhR,cplcFeFeAhL,cplcFeFeAhR,         & 
& cplcFuFuAhL,cplcFuFuAhR,cplcgWpgWpAh,cplcgWCgWCAh,cplAhhhasiga,cplAhHhSMVZ,            & 
& cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplcFdFdHhSML,cplcFdFdHhSMR,cplcFeFeHhSML,          & 
& cplcFeFeHhSMR,cplcFuFuHhSML,cplcFuFuHhSMR,cplcgWpgWpHhSM,cplcgWCgWCHhSM,               & 
& cplHapHhSMcHap,cplhhahhaHhSM,cplHhSMHhSMHhSM,cplHhSMHpcHp,cplHhSMHpcVWp,               & 
& cplHhSMsigasiga,cplHhSMcHpVWp,cplHhSMcVWpVWp,cplHhSMVZVZ,cplAhAhAhAh1,cplAhAhHapcHap1, & 
& cplAhAhhhahha1,cplAhAhHhSMHhSM1,cplAhAhHpcHp1,cplAhAhsigasiga1,cplAhAhcVWpVWp1,        & 
& cplAhAhVZVZ1,cplAhhhaHhSMsiga1,cplAhHhSMHpcHp1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHap,Mhha,MHhSM(3),MHp(3),Msiga,MVWp,MVZ,MAh2(3),         & 
& MFd2(3),MFe2(3),MFu2(3),MHap2,Mhha2,MHhSM2(3),MHp2(3),Msiga2,MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhAhHhSM(3,3,3),cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFeFeAhL(3,3,3),          & 
& cplcFeFeAhR(3,3,3),cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcgWpgWpAh(3),              & 
& cplcgWCgWCAh(3),cplAhhhasiga(3),cplAhHhSMVZ(3,3),cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),   & 
& cplAhcHpVWp(3,3),cplcFdFdHhSML(3,3,3),cplcFdFdHhSMR(3,3,3),cplcFeFeHhSML(3,3,3),       & 
& cplcFeFeHhSMR(3,3,3),cplcFuFuHhSML(3,3,3),cplcFuFuHhSMR(3,3,3),cplcgWpgWpHhSM(3),      & 
& cplcgWCgWCHhSM(3),cplHapHhSMcHap(3),cplhhahhaHhSM(3),cplHhSMHhSMHhSM(3,3,3),           & 
& cplHhSMHpcHp(3,3,3),cplHhSMHpcVWp(3,3),cplHhSMsigasiga(3),cplHhSMcHpVWp(3,3),          & 
& cplHhSMcVWpVWp(3),cplHhSMVZVZ(3),cplAhAhAhAh1(3,3,3,3),cplAhAhHapcHap1(3,3),           & 
& cplAhAhhhahha1(3,3),cplAhAhHhSMHhSM1(3,3,3,3),cplAhAhHpcHp1(3,3,3,3),cplAhAhsigasiga1(3,3),& 
& cplAhAhcVWpVWp1(3,3),cplAhAhVZVZ1(3,3),cplAhhhaHhSMsiga1(3,3),cplAhHhSMHpcHp1(3,3,3,3)

Complex(dp), Intent(out) :: Amp(3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
Amp(gt1, gt2, gt3) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MHhSM(gt2) 
Mex3 = MAh(gt3) 
    End Do
  End Do
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhToHhSMAh


Subroutine Amplitude_Tree_4HDM_S3_AhTocFdFd(cplcFdFdAhL,cplcFdFdAhR,MAh,              & 
& MFd,MAh2,MFd2,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MAh2(3),MFd2(3)

Complex(dp), Intent(in) :: cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3)

Complex(dp) :: Amp(2,3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 

Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MFd(gt2) 
Mex3 = MFd(gt3) 
! Tree-Level Vertex 
coupT1L = cplcFdFdAhL(gt2,gt3,gt1)
coupT1R = cplcFdFdAhR(gt2,gt3,gt1)
Call TreeAmp_StoFF(Mex1,Mex2,Mex3,coupT1L,coupT1R,AmpC) 
! Colour and symmetry factor 
Amp(:,gt1, gt2, gt3) = AmpC 
    End Do
  End Do
End Do
End Subroutine Amplitude_Tree_4HDM_S3_AhTocFdFd


Subroutine Gamma_Real_4HDM_S3_AhTocFdFd(MLambda,em,gs,cplcFdFdAhL,cplcFdFdAhR,        & 
& MAh,MFd,GammarealPhoton,GammarealGluon)

Implicit None

Complex(dp), Intent(in) :: cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3)

Real(dp), Intent(in) :: MAh(3),MFd(3)

Real(dp), Intent(in) :: MLambda, em, gs 

Real(dp), Intent(out) :: GammarealPhoton(3,3,3), GammarealGluon(3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3, kont 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 

Real(dp) :: Mloop1, Mloop2, Mloop3 
Complex(dp) :: CoupL, CoupR 
 
Do i1=2,3
  Do i2=1,3
    Do i3=1,3
CoupL = cplcFdFdAhL(i2,i3,i1)
CoupR = cplcFdFdAhR(i2,i3,i1)
Mex1 = MAh(i1)
Mex2 = MFd(i2)
Mex3 = MFd(i3)
If (Mex1.gt.(Mex2+Mex3)) Then 
 Call hardradiationSFF(Mex1,Mex2,Mex3,MLambda,em,0._dp,0._dp,0._dp,1._dp/3._dp,-1._dp/3._dp,1._dp/3._dp,CoupL,CoupR,Gammarealphoton(i1,i2,i3),kont)
 Call hardradiationSFF(Mex1,Mex2,Mex3,MLambda,gs,0._dp,0._dp,0._dp,4._dp,-4._dp,4._dp,CoupL,CoupR,Gammarealgluon(i1,i2,i3),kont)
Else 
  GammarealGluon(i1,i2,i3) = 0._dp 
  GammarealPhoton(i1,i2,i3) = 0._dp 

End if 
    End Do
  End Do
End Do
End Subroutine Gamma_Real_4HDM_S3_AhTocFdFd


Subroutine Amplitude_WAVE_4HDM_S3_AhTocFdFd(cplcFdFdAhL,cplcFdFdAhR,ctcplcFdFdAhL,    & 
& ctcplcFdFdAhR,MAh,MAh2,MFd,MFd2,ZfAh,ZfDL,ZfDR,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MAh2(3),MFd(3),MFd2(3)

Complex(dp), Intent(in) :: cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3)

Complex(dp), Intent(in) :: ctcplcFdFdAhL(3,3,3),ctcplcFdFdAhR(3,3,3)

Complex(dp), Intent(in) :: ZfAh(3,3),ZfDL(3,3),ZfDR(3,3)

Complex(dp), Intent(out) :: Amp(2,3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MFd(gt2) 
Mex3 = MFd(gt3) 
!----------------------------- 
! Coupling counter term 
!----------------------------- 
ZcoupT1L = ctcplcFdFdAhL(gt2,gt3,gt1) 
ZcoupT1R = ctcplcFdFdAhR(gt2,gt3,gt1) 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
Do i1=1,3
ZcoupT1L = ZcoupT1L + 0.5_dp*ZfAh(i1,gt1)*cplcFdFdAhL(gt2,gt3,i1)
ZcoupT1R = ZcoupT1R + 0.5_dp*ZfAh(i1,gt1)*cplcFdFdAhR(gt2,gt3,i1)
End Do


! External Field 2 
Do i1=1,3
ZcoupT1L = ZcoupT1L + 0.5_dp*ZfDR(i1,gt2)*cplcFdFdAhL(i1,gt3,gt1)
ZcoupT1R = ZcoupT1R + 0.5_dp*Conjg(ZfDL(i1,gt2))*cplcFdFdAhR(i1,gt3,gt1)
End Do


! External Field 3 
Do i1=1,3
ZcoupT1L = ZcoupT1L + 0.5_dp*ZfDL(i1,gt3)*cplcFdFdAhL(gt2,i1,gt1)
ZcoupT1R = ZcoupT1R + 0.5_dp*Conjg(ZfDR(i1,gt3))*cplcFdFdAhR(gt2,i1,gt1)
End Do


! Getting the amplitude 
Call TreeAmp_StoFF(Mex1,Mex2,Mex3,ZcoupT1L,ZcoupT1R,AmpC) 
Amp(:,gt1, gt2, gt3) = AmpC 
    End Do
  End Do
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_AhTocFdFd


Subroutine Amplitude_VERTEX_4HDM_S3_AhTocFdFd(MAh,MFd,MFu,MHhSM,MHp,MVG,              & 
& MVP,MVWp,MVZ,MAh2,MFd2,MFu2,MHhSM2,MHp2,MVG2,MVP2,MVWp2,MVZ2,cplAhAhHhSM,              & 
& cplcFdFdAhL,cplcFdFdAhR,cplcFuFuAhL,cplcFuFuAhR,cplAhHhSMVZ,cplAhHpcHp,cplAhHpcVWp,    & 
& cplAhcHpVWp,cplcFdFdHhSML,cplcFdFdHhSMR,cplcFuFdHpL,cplcFuFdHpR,cplcFdFdVGL,           & 
& cplcFdFdVGR,cplcFdFdVPL,cplcFdFdVPR,cplcFuFdVWpL,cplcFuFdVWpR,cplcFdFdVZL,             & 
& cplcFdFdVZR,cplcFdFucHpL,cplcFdFucHpR,cplcFdFucVWpL,cplcFdFucVWpR,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFu(3),MHhSM(3),MHp(3),MVG,MVP,MVWp,MVZ,MAh2(3),MFd2(3),MFu2(3),        & 
& MHhSM2(3),MHp2(3),MVG2,MVP2,MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhAhHhSM(3,3,3),cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFuFuAhL(3,3,3),          & 
& cplcFuFuAhR(3,3,3),cplAhHhSMVZ(3,3),cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),cplAhcHpVWp(3,3),& 
& cplcFdFdHhSML(3,3,3),cplcFdFdHhSMR(3,3,3),cplcFuFdHpL(3,3,3),cplcFuFdHpR(3,3,3),       & 
& cplcFdFdVGL(3,3),cplcFdFdVGR(3,3),cplcFdFdVPL(3,3),cplcFdFdVPR(3,3),cplcFuFdVWpL(3,3), & 
& cplcFuFdVWpR(3,3),cplcFdFdVZL(3,3),cplcFdFdVZR(3,3),cplcFdFucHpL(3,3,3),               & 
& cplcFdFucHpR(3,3,3),cplcFdFucVWpL(3,3),cplcFdFucVWpR(3,3)

Complex(dp), Intent(out) :: Amp(2,3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
Amp(:,gt1, gt2, gt3) = 0._dp 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MFd(gt2) 
Mex3 = MFd(gt3) 


! {Ah, HhSM, Fd}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MAh(i1) 
ML2 = MHhSM(i2) 
ML3 = MFd(i3) 
coup1 = cplAhAhHhSM(gt1,i1,i2)
coup2L = cplcFdFdAhL(gt2,i3,i1)
coup2R = cplcFdFdAhR(gt2,i3,i1)
coup3L = cplcFdFdHhSML(i3,gt3,i2)
coup3R = cplcFdFdHhSMR(i3,gt3,i2)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_SSF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {HhSM, Ah, Fd}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHhSM(i1) 
ML2 = MAh(i2) 
ML3 = MFd(i3) 
coup1 = cplAhAhHhSM(gt1,i2,i1)
coup2L = cplcFdFdHhSML(gt2,i3,i1)
coup2R = cplcFdFdHhSMR(gt2,i3,i1)
coup3L = cplcFdFdAhL(i3,gt3,i2)
coup3R = cplcFdFdAhR(i3,gt3,i2)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_SSF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {HhSM, VZ, Fd}
Do i1=1,3
    Do i3=1,3
ML1 = MHhSM(i1) 
ML2 = MVZ 
ML3 = MFd(i3) 
coup1 = cplAhHhSMVZ(gt1,i1)
coup2L = cplcFdFdHhSML(gt2,i3,i1)
coup2R = cplcFdFdHhSMR(gt2,i3,i1)
coup3L = cplcFdFdVZL(i3,gt3)
coup3R = cplcFdFdVZR(i3,gt3)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_SVF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, Hp, Fu}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MFu(i3) 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2L = cplcFdFucHpL(gt2,i3,i1)
coup2R = cplcFdFucHpR(gt2,i3,i1)
coup3L = cplcFuFdHpL(i3,gt3,i2)
coup3R = cplcFuFdHpR(i3,gt3,i2)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_SSF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Hp, VWp, Fu}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MFu(i3) 
coup1 = cplAhHpcVWp(gt1,i1)
coup2L = cplcFdFucHpL(gt2,i3,i1)
coup2R = cplcFdFucHpR(gt2,i3,i1)
coup3L = cplcFuFdVWpL(i3,gt3)
coup3R = cplcFuFdVWpR(i3,gt3)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_SVF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {VWp, Hp, Fu}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MFu(i3) 
coup1 = cplAhcHpVWp(gt1,i2)
coup2L = cplcFdFucVWpL(gt2,i3)
coup2R = cplcFdFucVWpR(gt2,i3)
coup3L = cplcFuFdHpL(i3,gt3,i2)
coup3R = cplcFuFdHpR(i3,gt3,i2)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_VSF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VZ, HhSM, Fd}
  Do i2=1,3
    Do i3=1,3
ML1 = MVZ 
ML2 = MHhSM(i2) 
ML3 = MFd(i3) 
coup1 = cplAhHhSMVZ(gt1,i2)
coup2L = cplcFdFdVZL(gt2,i3)
coup2R = cplcFdFdVZR(gt2,i3)
coup3L = cplcFdFdHhSML(i3,gt3,i2)
coup3R = cplcFdFdHhSMR(i3,gt3,i2)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_VSF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {bar[Fd], bar[Fd], Ah}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFd(i1) 
ML2 = MFd(i2) 
ML3 = MAh(i3) 
coup1L = cplcFdFdAhL(i1,i2,gt1)
coup1R = cplcFdFdAhR(i1,i2,gt1)
coup2L = cplcFdFdAhL(gt2,i1,i3)
coup2R = cplcFdFdAhR(gt2,i1,i3)
coup3L = cplcFdFdAhL(i2,gt3,i3)
coup3R = cplcFdFdAhR(i2,gt3,i3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_FFS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {bar[Fd], bar[Fd], HhSM}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFd(i1) 
ML2 = MFd(i2) 
ML3 = MHhSM(i3) 
coup1L = cplcFdFdAhL(i1,i2,gt1)
coup1R = cplcFdFdAhR(i1,i2,gt1)
coup2L = cplcFdFdHhSML(gt2,i1,i3)
coup2R = cplcFdFdHhSMR(gt2,i1,i3)
coup3L = cplcFdFdHhSML(i2,gt3,i3)
coup3R = cplcFdFdHhSMR(i2,gt3,i3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_FFS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {bar[Fd], bar[Fd], VG}
Do i1=1,3
  Do i2=1,3
ML1 = MFd(i1) 
ML2 = MFd(i2) 
ML3 = MVG 
coup1L = cplcFdFdAhL(i1,i2,gt1)
coup1R = cplcFdFdAhR(i1,i2,gt1)
coup2L = cplcFdFdVGL(gt2,i1)
coup2R = cplcFdFdVGR(gt2,i1)
coup3L = cplcFdFdVGL(i2,gt3)
coup3R = cplcFdFdVGR(i2,gt3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_FFV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(4._dp/3._dp)*AmpC 
  End Do
End Do


! {bar[Fd], bar[Fd], VP}
Do i1=1,3
  Do i2=1,3
ML1 = MFd(i1) 
ML2 = MFd(i2) 
ML3 = MVP 
coup1L = cplcFdFdAhL(i1,i2,gt1)
coup1R = cplcFdFdAhR(i1,i2,gt1)
coup2L = cplcFdFdVPL(gt2,i1)
coup2R = cplcFdFdVPR(gt2,i1)
coup3L = cplcFdFdVPL(i2,gt3)
coup3R = cplcFdFdVPR(i2,gt3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_FFV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {bar[Fd], bar[Fd], VZ}
Do i1=1,3
  Do i2=1,3
ML1 = MFd(i1) 
ML2 = MFd(i2) 
ML3 = MVZ 
coup1L = cplcFdFdAhL(i1,i2,gt1)
coup1R = cplcFdFdAhR(i1,i2,gt1)
coup2L = cplcFdFdVZL(gt2,i1)
coup2R = cplcFdFdVZR(gt2,i1)
coup3L = cplcFdFdVZL(i2,gt3)
coup3R = cplcFdFdVZR(i2,gt3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_FFV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {bar[Fu], bar[Fu], conj[Hp]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFu(i1) 
ML2 = MFu(i2) 
ML3 = MHp(i3) 
coup1L = cplcFuFuAhL(i1,i2,gt1)
coup1R = cplcFuFuAhR(i1,i2,gt1)
coup2L = cplcFdFucHpL(gt2,i1,i3)
coup2R = cplcFdFucHpR(gt2,i1,i3)
coup3L = cplcFuFdHpL(i2,gt3,i3)
coup3R = cplcFuFdHpR(i2,gt3,i3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_FFS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {bar[Fu], bar[Fu], conj[VWp]}
Do i1=1,3
  Do i2=1,3
ML1 = MFu(i1) 
ML2 = MFu(i2) 
ML3 = MVWp 
coup1L = cplcFuFuAhL(i1,i2,gt1)
coup1R = cplcFuFuAhR(i1,i2,gt1)
coup2L = cplcFdFucVWpL(gt2,i1)
coup2R = cplcFdFucVWpR(gt2,i1)
coup3L = cplcFuFdVWpL(i2,gt3)
coup3R = cplcFuFdVWpR(i2,gt3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_FFV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do
    End Do
  End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_AhTocFdFd


Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhTocFdFd(MAh,MFd,MFu,MHhSM,MHp,               & 
& MVG,MVP,MVWp,MVZ,MAh2,MFd2,MFu2,MHhSM2,MHp2,MVG2,MVP2,MVWp2,MVZ2,cplAhAhHhSM,          & 
& cplcFdFdAhL,cplcFdFdAhR,cplcFuFuAhL,cplcFuFuAhR,cplAhHhSMVZ,cplAhHpcHp,cplAhHpcVWp,    & 
& cplAhcHpVWp,cplcFdFdHhSML,cplcFdFdHhSMR,cplcFuFdHpL,cplcFuFdHpR,cplcFdFdVGL,           & 
& cplcFdFdVGR,cplcFdFdVPL,cplcFdFdVPR,cplcFuFdVWpL,cplcFuFdVWpR,cplcFdFdVZL,             & 
& cplcFdFdVZR,cplcFdFucHpL,cplcFdFucHpR,cplcFdFucVWpL,cplcFdFucVWpR,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFu(3),MHhSM(3),MHp(3),MVG,MVP,MVWp,MVZ,MAh2(3),MFd2(3),MFu2(3),        & 
& MHhSM2(3),MHp2(3),MVG2,MVP2,MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhAhHhSM(3,3,3),cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFuFuAhL(3,3,3),          & 
& cplcFuFuAhR(3,3,3),cplAhHhSMVZ(3,3),cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),cplAhcHpVWp(3,3),& 
& cplcFdFdHhSML(3,3,3),cplcFdFdHhSMR(3,3,3),cplcFuFdHpL(3,3,3),cplcFuFdHpR(3,3,3),       & 
& cplcFdFdVGL(3,3),cplcFdFdVGR(3,3),cplcFdFdVPL(3,3),cplcFdFdVPR(3,3),cplcFuFdVWpL(3,3), & 
& cplcFuFdVWpR(3,3),cplcFdFdVZL(3,3),cplcFdFdVZR(3,3),cplcFdFucHpL(3,3,3),               & 
& cplcFdFucHpR(3,3,3),cplcFdFucVWpL(3,3),cplcFdFucVWpR(3,3)

Complex(dp), Intent(out) :: Amp(2,3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
Amp(:,gt1, gt2, gt3) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MFd(gt2) 
Mex3 = MFd(gt3) 


! {bar[Fd], bar[Fd], VG}
Do i1=1,3
  Do i2=1,3
ML1 = MFd(i1) 
ML2 = MFd(i2) 
ML3 = MVG 
coup1L = cplcFdFdAhL(i1,i2,gt1)
coup1R = cplcFdFdAhR(i1,i2,gt1)
coup2L = cplcFdFdVGL(gt2,i1)
coup2R = cplcFdFdVGR(gt2,i1)
coup3L = cplcFdFdVGL(i2,gt3)
coup3R = cplcFdFdVGR(i2,gt3)
Call Amp_VERTEX_StoFF_Topology1_FFV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(4._dp/3._dp)*AmpC 
  End Do
End Do


! {bar[Fd], bar[Fd], VP}
Do i1=1,3
  Do i2=1,3
ML1 = MFd(i1) 
ML2 = MFd(i2) 
ML3 = MVP 
coup1L = cplcFdFdAhL(i1,i2,gt1)
coup1R = cplcFdFdAhR(i1,i2,gt1)
coup2L = cplcFdFdVPL(gt2,i1)
coup2R = cplcFdFdVPR(gt2,i1)
coup3L = cplcFdFdVPL(i2,gt3)
coup3R = cplcFdFdVPR(i2,gt3)
Call Amp_VERTEX_StoFF_Topology1_FFV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do
    End Do
  End Do
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhTocFdFd


Subroutine Amplitude_Tree_4HDM_S3_AhTocFeFe(cplcFeFeAhL,cplcFeFeAhR,MAh,              & 
& MFe,MAh2,MFe2,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFe(3),MAh2(3),MFe2(3)

Complex(dp), Intent(in) :: cplcFeFeAhL(3,3,3),cplcFeFeAhR(3,3,3)

Complex(dp) :: Amp(2,3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 

Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MFe(gt2) 
Mex3 = MFe(gt3) 
! Tree-Level Vertex 
coupT1L = cplcFeFeAhL(gt2,gt3,gt1)
coupT1R = cplcFeFeAhR(gt2,gt3,gt1)
Call TreeAmp_StoFF(Mex1,Mex2,Mex3,coupT1L,coupT1R,AmpC) 
! Colour and symmetry factor 
Amp(:,gt1, gt2, gt3) = AmpC 
    End Do
  End Do
End Do
End Subroutine Amplitude_Tree_4HDM_S3_AhTocFeFe


Subroutine Gamma_Real_4HDM_S3_AhTocFeFe(MLambda,em,gs,cplcFeFeAhL,cplcFeFeAhR,        & 
& MAh,MFe,GammarealPhoton,GammarealGluon)

Implicit None

Complex(dp), Intent(in) :: cplcFeFeAhL(3,3,3),cplcFeFeAhR(3,3,3)

Real(dp), Intent(in) :: MAh(3),MFe(3)

Real(dp), Intent(in) :: MLambda, em, gs 

Real(dp), Intent(out) :: GammarealPhoton(3,3,3), GammarealGluon(3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3, kont 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 

Real(dp) :: Mloop1, Mloop2, Mloop3 
Complex(dp) :: CoupL, CoupR 
 
Do i1=2,3
  Do i2=1,3
    Do i3=1,3
CoupL = cplcFeFeAhL(i2,i3,i1)
CoupR = cplcFeFeAhR(i2,i3,i1)
Mex1 = MAh(i1)
Mex2 = MFe(i2)
Mex3 = MFe(i3)
If (Mex1.gt.(Mex2+Mex3)) Then 
 Call hardradiationSFF(Mex1,Mex2,Mex3,MLambda,em,0._dp,0._dp,0._dp,1._dp,-1._dp,1._dp,CoupL,CoupR,Gammarealphoton(i1,i2,i3),kont)
  GammarealGluon(i1,i2,i3) = 0._dp 
Else 
  GammarealGluon(i1,i2,i3) = 0._dp 
  GammarealPhoton(i1,i2,i3) = 0._dp 

End if 
    End Do
  End Do
End Do
End Subroutine Gamma_Real_4HDM_S3_AhTocFeFe


Subroutine Amplitude_WAVE_4HDM_S3_AhTocFeFe(cplcFeFeAhL,cplcFeFeAhR,ctcplcFeFeAhL,    & 
& ctcplcFeFeAhR,MAh,MAh2,MFe,MFe2,ZfAh,ZfEL,ZfER,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MAh2(3),MFe(3),MFe2(3)

Complex(dp), Intent(in) :: cplcFeFeAhL(3,3,3),cplcFeFeAhR(3,3,3)

Complex(dp), Intent(in) :: ctcplcFeFeAhL(3,3,3),ctcplcFeFeAhR(3,3,3)

Complex(dp), Intent(in) :: ZfAh(3,3),ZfEL(3,3),ZfER(3,3)

Complex(dp), Intent(out) :: Amp(2,3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MFe(gt2) 
Mex3 = MFe(gt3) 
!----------------------------- 
! Coupling counter term 
!----------------------------- 
ZcoupT1L = ctcplcFeFeAhL(gt2,gt3,gt1) 
ZcoupT1R = ctcplcFeFeAhR(gt2,gt3,gt1) 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
Do i1=1,3
ZcoupT1L = ZcoupT1L + 0.5_dp*ZfAh(i1,gt1)*cplcFeFeAhL(gt2,gt3,i1)
ZcoupT1R = ZcoupT1R + 0.5_dp*ZfAh(i1,gt1)*cplcFeFeAhR(gt2,gt3,i1)
End Do


! External Field 2 
Do i1=1,3
ZcoupT1L = ZcoupT1L + 0.5_dp*ZfER(i1,gt2)*cplcFeFeAhL(i1,gt3,gt1)
ZcoupT1R = ZcoupT1R + 0.5_dp*Conjg(ZfEL(i1,gt2))*cplcFeFeAhR(i1,gt3,gt1)
End Do


! External Field 3 
Do i1=1,3
ZcoupT1L = ZcoupT1L + 0.5_dp*ZfEL(i1,gt3)*cplcFeFeAhL(gt2,i1,gt1)
ZcoupT1R = ZcoupT1R + 0.5_dp*Conjg(ZfER(i1,gt3))*cplcFeFeAhR(gt2,i1,gt1)
End Do


! Getting the amplitude 
Call TreeAmp_StoFF(Mex1,Mex2,Mex3,ZcoupT1L,ZcoupT1R,AmpC) 
Amp(:,gt1, gt2, gt3) = AmpC 
    End Do
  End Do
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_AhTocFeFe


Subroutine Amplitude_VERTEX_4HDM_S3_AhTocFeFe(MAh,MFe,MHhSM,MHp,MVP,MVWp,             & 
& MVZ,MAh2,MFe2,MHhSM2,MHp2,MVP2,MVWp2,MVZ2,cplAhAhHhSM,cplcFeFeAhL,cplcFeFeAhR,         & 
& cplAhHhSMVZ,cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplcFeFeHhSML,cplcFeFeHhSMR,            & 
& cplcFvFeHpL,cplcFvFeHpR,cplcFeFeVPL,cplcFeFeVPR,cplcFvFeVWpL,cplcFvFeVWpR,             & 
& cplcFeFeVZL,cplcFeFeVZR,cplcFeFvcHpL,cplcFeFvcHpR,cplcFeFvcVWpL,cplcFeFvcVWpR,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFe(3),MHhSM(3),MHp(3),MVP,MVWp,MVZ,MAh2(3),MFe2(3),MHhSM2(3),MHp2(3),         & 
& MVP2,MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhAhHhSM(3,3,3),cplcFeFeAhL(3,3,3),cplcFeFeAhR(3,3,3),cplAhHhSMVZ(3,3),            & 
& cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),cplAhcHpVWp(3,3),cplcFeFeHhSML(3,3,3),              & 
& cplcFeFeHhSMR(3,3,3),cplcFvFeHpL(3,3,3),cplcFvFeHpR(3,3,3),cplcFeFeVPL(3,3),           & 
& cplcFeFeVPR(3,3),cplcFvFeVWpL(3,3),cplcFvFeVWpR(3,3),cplcFeFeVZL(3,3),cplcFeFeVZR(3,3),& 
& cplcFeFvcHpL(3,3,3),cplcFeFvcHpR(3,3,3),cplcFeFvcVWpL(3,3),cplcFeFvcVWpR(3,3)

Complex(dp), Intent(out) :: Amp(2,3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
Amp(:,gt1, gt2, gt3) = 0._dp 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MFe(gt2) 
Mex3 = MFe(gt3) 


! {Ah, HhSM, Fe}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MAh(i1) 
ML2 = MHhSM(i2) 
ML3 = MFe(i3) 
coup1 = cplAhAhHhSM(gt1,i1,i2)
coup2L = cplcFeFeAhL(gt2,i3,i1)
coup2R = cplcFeFeAhR(gt2,i3,i1)
coup3L = cplcFeFeHhSML(i3,gt3,i2)
coup3R = cplcFeFeHhSMR(i3,gt3,i2)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_SSF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {HhSM, Ah, Fe}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHhSM(i1) 
ML2 = MAh(i2) 
ML3 = MFe(i3) 
coup1 = cplAhAhHhSM(gt1,i2,i1)
coup2L = cplcFeFeHhSML(gt2,i3,i1)
coup2R = cplcFeFeHhSMR(gt2,i3,i1)
coup3L = cplcFeFeAhL(i3,gt3,i2)
coup3R = cplcFeFeAhR(i3,gt3,i2)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_SSF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {HhSM, VZ, Fe}
Do i1=1,3
    Do i3=1,3
ML1 = MHhSM(i1) 
ML2 = MVZ 
ML3 = MFe(i3) 
coup1 = cplAhHhSMVZ(gt1,i1)
coup2L = cplcFeFeHhSML(gt2,i3,i1)
coup2R = cplcFeFeHhSMR(gt2,i3,i1)
coup3L = cplcFeFeVZL(i3,gt3)
coup3R = cplcFeFeVZR(i3,gt3)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_SVF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, Hp, Fv}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = 0. 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2L = cplcFeFvcHpL(gt2,i3,i1)
coup2R = cplcFeFvcHpR(gt2,i3,i1)
coup3L = cplcFvFeHpL(i3,gt3,i2)
coup3R = cplcFvFeHpR(i3,gt3,i2)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_SSF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Hp, VWp, Fv}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = 0. 
coup1 = cplAhHpcVWp(gt1,i1)
coup2L = cplcFeFvcHpL(gt2,i3,i1)
coup2R = cplcFeFvcHpR(gt2,i3,i1)
coup3L = cplcFvFeVWpL(i3,gt3)
coup3R = cplcFvFeVWpR(i3,gt3)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_SVF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {VWp, Hp, Fv}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = 0. 
coup1 = cplAhcHpVWp(gt1,i2)
coup2L = cplcFeFvcVWpL(gt2,i3)
coup2R = cplcFeFvcVWpR(gt2,i3)
coup3L = cplcFvFeHpL(i3,gt3,i2)
coup3R = cplcFvFeHpR(i3,gt3,i2)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_VSF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VZ, HhSM, Fe}
  Do i2=1,3
    Do i3=1,3
ML1 = MVZ 
ML2 = MHhSM(i2) 
ML3 = MFe(i3) 
coup1 = cplAhHhSMVZ(gt1,i2)
coup2L = cplcFeFeVZL(gt2,i3)
coup2R = cplcFeFeVZR(gt2,i3)
coup3L = cplcFeFeHhSML(i3,gt3,i2)
coup3R = cplcFeFeHhSMR(i3,gt3,i2)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_VSF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {bar[Fe], bar[Fe], Ah}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFe(i1) 
ML2 = MFe(i2) 
ML3 = MAh(i3) 
coup1L = cplcFeFeAhL(i1,i2,gt1)
coup1R = cplcFeFeAhR(i1,i2,gt1)
coup2L = cplcFeFeAhL(gt2,i1,i3)
coup2R = cplcFeFeAhR(gt2,i1,i3)
coup3L = cplcFeFeAhL(i2,gt3,i3)
coup3R = cplcFeFeAhR(i2,gt3,i3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_FFS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {bar[Fe], bar[Fe], HhSM}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFe(i1) 
ML2 = MFe(i2) 
ML3 = MHhSM(i3) 
coup1L = cplcFeFeAhL(i1,i2,gt1)
coup1R = cplcFeFeAhR(i1,i2,gt1)
coup2L = cplcFeFeHhSML(gt2,i1,i3)
coup2R = cplcFeFeHhSMR(gt2,i1,i3)
coup3L = cplcFeFeHhSML(i2,gt3,i3)
coup3R = cplcFeFeHhSMR(i2,gt3,i3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_FFS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {bar[Fe], bar[Fe], VP}
Do i1=1,3
  Do i2=1,3
ML1 = MFe(i1) 
ML2 = MFe(i2) 
ML3 = MVP 
coup1L = cplcFeFeAhL(i1,i2,gt1)
coup1R = cplcFeFeAhR(i1,i2,gt1)
coup2L = cplcFeFeVPL(gt2,i1)
coup2R = cplcFeFeVPR(gt2,i1)
coup3L = cplcFeFeVPL(i2,gt3)
coup3R = cplcFeFeVPR(i2,gt3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_FFV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {bar[Fe], bar[Fe], VZ}
Do i1=1,3
  Do i2=1,3
ML1 = MFe(i1) 
ML2 = MFe(i2) 
ML3 = MVZ 
coup1L = cplcFeFeAhL(i1,i2,gt1)
coup1R = cplcFeFeAhR(i1,i2,gt1)
coup2L = cplcFeFeVZL(gt2,i1)
coup2R = cplcFeFeVZR(gt2,i1)
coup3L = cplcFeFeVZL(i2,gt3)
coup3R = cplcFeFeVZR(i2,gt3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_FFV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do
    End Do
  End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_AhTocFeFe


Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhTocFeFe(MAh,MFe,MHhSM,MHp,MVP,               & 
& MVWp,MVZ,MAh2,MFe2,MHhSM2,MHp2,MVP2,MVWp2,MVZ2,cplAhAhHhSM,cplcFeFeAhL,cplcFeFeAhR,    & 
& cplAhHhSMVZ,cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplcFeFeHhSML,cplcFeFeHhSMR,            & 
& cplcFvFeHpL,cplcFvFeHpR,cplcFeFeVPL,cplcFeFeVPR,cplcFvFeVWpL,cplcFvFeVWpR,             & 
& cplcFeFeVZL,cplcFeFeVZR,cplcFeFvcHpL,cplcFeFvcHpR,cplcFeFvcVWpL,cplcFeFvcVWpR,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFe(3),MHhSM(3),MHp(3),MVP,MVWp,MVZ,MAh2(3),MFe2(3),MHhSM2(3),MHp2(3),         & 
& MVP2,MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhAhHhSM(3,3,3),cplcFeFeAhL(3,3,3),cplcFeFeAhR(3,3,3),cplAhHhSMVZ(3,3),            & 
& cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),cplAhcHpVWp(3,3),cplcFeFeHhSML(3,3,3),              & 
& cplcFeFeHhSMR(3,3,3),cplcFvFeHpL(3,3,3),cplcFvFeHpR(3,3,3),cplcFeFeVPL(3,3),           & 
& cplcFeFeVPR(3,3),cplcFvFeVWpL(3,3),cplcFvFeVWpR(3,3),cplcFeFeVZL(3,3),cplcFeFeVZR(3,3),& 
& cplcFeFvcHpL(3,3,3),cplcFeFvcHpR(3,3,3),cplcFeFvcVWpL(3,3),cplcFeFvcVWpR(3,3)

Complex(dp), Intent(out) :: Amp(2,3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
Amp(:,gt1, gt2, gt3) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MFe(gt2) 
Mex3 = MFe(gt3) 


! {bar[Fe], bar[Fe], VP}
Do i1=1,3
  Do i2=1,3
ML1 = MFe(i1) 
ML2 = MFe(i2) 
ML3 = MVP 
coup1L = cplcFeFeAhL(i1,i2,gt1)
coup1R = cplcFeFeAhR(i1,i2,gt1)
coup2L = cplcFeFeVPL(gt2,i1)
coup2R = cplcFeFeVPR(gt2,i1)
coup3L = cplcFeFeVPL(i2,gt3)
coup3R = cplcFeFeVPR(i2,gt3)
Call Amp_VERTEX_StoFF_Topology1_FFV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do
    End Do
  End Do
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhTocFeFe


Subroutine Amplitude_Tree_4HDM_S3_AhTocFuFu(cplcFuFuAhL,cplcFuFuAhR,MAh,              & 
& MFu,MAh2,MFu2,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFu(3),MAh2(3),MFu2(3)

Complex(dp), Intent(in) :: cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3)

Complex(dp) :: Amp(2,3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 

Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MFu(gt2) 
Mex3 = MFu(gt3) 
! Tree-Level Vertex 
coupT1L = cplcFuFuAhL(gt2,gt3,gt1)
coupT1R = cplcFuFuAhR(gt2,gt3,gt1)
Call TreeAmp_StoFF(Mex1,Mex2,Mex3,coupT1L,coupT1R,AmpC) 
! Colour and symmetry factor 
Amp(:,gt1, gt2, gt3) = AmpC 
    End Do
  End Do
End Do
End Subroutine Amplitude_Tree_4HDM_S3_AhTocFuFu


Subroutine Gamma_Real_4HDM_S3_AhTocFuFu(MLambda,em,gs,cplcFuFuAhL,cplcFuFuAhR,        & 
& MAh,MFu,GammarealPhoton,GammarealGluon)

Implicit None

Complex(dp), Intent(in) :: cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3)

Real(dp), Intent(in) :: MAh(3),MFu(3)

Real(dp), Intent(in) :: MLambda, em, gs 

Real(dp), Intent(out) :: GammarealPhoton(3,3,3), GammarealGluon(3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3, kont 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 

Real(dp) :: Mloop1, Mloop2, Mloop3 
Complex(dp) :: CoupL, CoupR 
 
Do i1=2,3
  Do i2=1,3
    Do i3=1,3
CoupL = cplcFuFuAhL(i2,i3,i1)
CoupR = cplcFuFuAhR(i2,i3,i1)
Mex1 = MAh(i1)
Mex2 = MFu(i2)
Mex3 = MFu(i3)
If (Mex1.gt.(Mex2+Mex3)) Then 
 Call hardradiationSFF(Mex1,Mex2,Mex3,MLambda,em,0._dp,0._dp,0._dp,4._dp/3._dp,-4._dp/3._dp,4._dp/3._dp,CoupL,CoupR,Gammarealphoton(i1,i2,i3),kont)
 Call hardradiationSFF(Mex1,Mex2,Mex3,MLambda,gs,0._dp,0._dp,0._dp,4._dp,-4._dp,4._dp,CoupL,CoupR,Gammarealgluon(i1,i2,i3),kont)
Else 
  GammarealGluon(i1,i2,i3) = 0._dp 
  GammarealPhoton(i1,i2,i3) = 0._dp 

End if 
    End Do
  End Do
End Do
End Subroutine Gamma_Real_4HDM_S3_AhTocFuFu


Subroutine Amplitude_WAVE_4HDM_S3_AhTocFuFu(cplcFuFuAhL,cplcFuFuAhR,ctcplcFuFuAhL,    & 
& ctcplcFuFuAhR,MAh,MAh2,MFu,MFu2,ZfAh,ZfUL,ZfUR,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MAh2(3),MFu(3),MFu2(3)

Complex(dp), Intent(in) :: cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3)

Complex(dp), Intent(in) :: ctcplcFuFuAhL(3,3,3),ctcplcFuFuAhR(3,3,3)

Complex(dp), Intent(in) :: ZfAh(3,3),ZfUL(3,3),ZfUR(3,3)

Complex(dp), Intent(out) :: Amp(2,3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MFu(gt2) 
Mex3 = MFu(gt3) 
!----------------------------- 
! Coupling counter term 
!----------------------------- 
ZcoupT1L = ctcplcFuFuAhL(gt2,gt3,gt1) 
ZcoupT1R = ctcplcFuFuAhR(gt2,gt3,gt1) 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
Do i1=1,3
ZcoupT1L = ZcoupT1L + 0.5_dp*ZfAh(i1,gt1)*cplcFuFuAhL(gt2,gt3,i1)
ZcoupT1R = ZcoupT1R + 0.5_dp*ZfAh(i1,gt1)*cplcFuFuAhR(gt2,gt3,i1)
End Do


! External Field 2 
Do i1=1,3
ZcoupT1L = ZcoupT1L + 0.5_dp*ZfUR(i1,gt2)*cplcFuFuAhL(i1,gt3,gt1)
ZcoupT1R = ZcoupT1R + 0.5_dp*Conjg(ZfUL(i1,gt2))*cplcFuFuAhR(i1,gt3,gt1)
End Do


! External Field 3 
Do i1=1,3
ZcoupT1L = ZcoupT1L + 0.5_dp*ZfUL(i1,gt3)*cplcFuFuAhL(gt2,i1,gt1)
ZcoupT1R = ZcoupT1R + 0.5_dp*Conjg(ZfUR(i1,gt3))*cplcFuFuAhR(gt2,i1,gt1)
End Do


! Getting the amplitude 
Call TreeAmp_StoFF(Mex1,Mex2,Mex3,ZcoupT1L,ZcoupT1R,AmpC) 
Amp(:,gt1, gt2, gt3) = AmpC 
    End Do
  End Do
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_AhTocFuFu


Subroutine Amplitude_VERTEX_4HDM_S3_AhTocFuFu(MAh,MFd,MFu,MHhSM,MHp,MVG,              & 
& MVP,MVWp,MVZ,MAh2,MFd2,MFu2,MHhSM2,MHp2,MVG2,MVP2,MVWp2,MVZ2,cplAhAhHhSM,              & 
& cplcFdFdAhL,cplcFdFdAhR,cplcFuFuAhL,cplcFuFuAhR,cplAhHhSMVZ,cplAhHpcHp,cplAhHpcVWp,    & 
& cplAhcHpVWp,cplcFuFdHpL,cplcFuFdHpR,cplcFuFdVWpL,cplcFuFdVWpR,cplcFuFuHhSML,           & 
& cplcFuFuHhSMR,cplcFuFuVGL,cplcFuFuVGR,cplcFuFuVPL,cplcFuFuVPR,cplcFuFuVZL,             & 
& cplcFuFuVZR,cplcFdFucHpL,cplcFdFucHpR,cplcFdFucVWpL,cplcFdFucVWpR,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFu(3),MHhSM(3),MHp(3),MVG,MVP,MVWp,MVZ,MAh2(3),MFd2(3),MFu2(3),        & 
& MHhSM2(3),MHp2(3),MVG2,MVP2,MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhAhHhSM(3,3,3),cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFuFuAhL(3,3,3),          & 
& cplcFuFuAhR(3,3,3),cplAhHhSMVZ(3,3),cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),cplAhcHpVWp(3,3),& 
& cplcFuFdHpL(3,3,3),cplcFuFdHpR(3,3,3),cplcFuFdVWpL(3,3),cplcFuFdVWpR(3,3),             & 
& cplcFuFuHhSML(3,3,3),cplcFuFuHhSMR(3,3,3),cplcFuFuVGL(3,3),cplcFuFuVGR(3,3),           & 
& cplcFuFuVPL(3,3),cplcFuFuVPR(3,3),cplcFuFuVZL(3,3),cplcFuFuVZR(3,3),cplcFdFucHpL(3,3,3),& 
& cplcFdFucHpR(3,3,3),cplcFdFucVWpL(3,3),cplcFdFucVWpR(3,3)

Complex(dp), Intent(out) :: Amp(2,3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
Amp(:,gt1, gt2, gt3) = 0._dp 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MFu(gt2) 
Mex3 = MFu(gt3) 


! {Ah, HhSM, Fu}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MAh(i1) 
ML2 = MHhSM(i2) 
ML3 = MFu(i3) 
coup1 = cplAhAhHhSM(gt1,i1,i2)
coup2L = cplcFuFuAhL(gt2,i3,i1)
coup2R = cplcFuFuAhR(gt2,i3,i1)
coup3L = cplcFuFuHhSML(i3,gt3,i2)
coup3R = cplcFuFuHhSMR(i3,gt3,i2)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_SSF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {HhSM, Ah, Fu}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHhSM(i1) 
ML2 = MAh(i2) 
ML3 = MFu(i3) 
coup1 = cplAhAhHhSM(gt1,i2,i1)
coup2L = cplcFuFuHhSML(gt2,i3,i1)
coup2R = cplcFuFuHhSMR(gt2,i3,i1)
coup3L = cplcFuFuAhL(i3,gt3,i2)
coup3R = cplcFuFuAhR(i3,gt3,i2)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_SSF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {HhSM, VZ, Fu}
Do i1=1,3
    Do i3=1,3
ML1 = MHhSM(i1) 
ML2 = MVZ 
ML3 = MFu(i3) 
coup1 = cplAhHhSMVZ(gt1,i1)
coup2L = cplcFuFuHhSML(gt2,i3,i1)
coup2R = cplcFuFuHhSMR(gt2,i3,i1)
coup3L = cplcFuFuVZL(i3,gt3)
coup3R = cplcFuFuVZR(i3,gt3)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_SVF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {VZ, HhSM, Fu}
  Do i2=1,3
    Do i3=1,3
ML1 = MVZ 
ML2 = MHhSM(i2) 
ML3 = MFu(i3) 
coup1 = cplAhHhSMVZ(gt1,i2)
coup2L = cplcFuFuVZL(gt2,i3)
coup2R = cplcFuFuVZR(gt2,i3)
coup3L = cplcFuFuHhSML(i3,gt3,i2)
coup3R = cplcFuFuHhSMR(i3,gt3,i2)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_VSF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {bar[Fd], bar[Fd], Hp}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFd(i1) 
ML2 = MFd(i2) 
ML3 = MHp(i3) 
coup1L = cplcFdFdAhL(i1,i2,gt1)
coup1R = cplcFdFdAhR(i1,i2,gt1)
coup2L = cplcFuFdHpL(gt2,i1,i3)
coup2R = cplcFuFdHpR(gt2,i1,i3)
coup3L = cplcFdFucHpL(i2,gt3,i3)
coup3R = cplcFdFucHpR(i2,gt3,i3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_FFS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {bar[Fd], bar[Fd], VWp}
Do i1=1,3
  Do i2=1,3
ML1 = MFd(i1) 
ML2 = MFd(i2) 
ML3 = MVWp 
coup1L = cplcFdFdAhL(i1,i2,gt1)
coup1R = cplcFdFdAhR(i1,i2,gt1)
coup2L = cplcFuFdVWpL(gt2,i1)
coup2R = cplcFuFdVWpR(gt2,i1)
coup3L = cplcFdFucVWpL(i2,gt3)
coup3R = cplcFdFucVWpR(i2,gt3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_FFV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {bar[Fu], bar[Fu], Ah}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFu(i1) 
ML2 = MFu(i2) 
ML3 = MAh(i3) 
coup1L = cplcFuFuAhL(i1,i2,gt1)
coup1R = cplcFuFuAhR(i1,i2,gt1)
coup2L = cplcFuFuAhL(gt2,i1,i3)
coup2R = cplcFuFuAhR(gt2,i1,i3)
coup3L = cplcFuFuAhL(i2,gt3,i3)
coup3R = cplcFuFuAhR(i2,gt3,i3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_FFS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {bar[Fu], bar[Fu], HhSM}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFu(i1) 
ML2 = MFu(i2) 
ML3 = MHhSM(i3) 
coup1L = cplcFuFuAhL(i1,i2,gt1)
coup1R = cplcFuFuAhR(i1,i2,gt1)
coup2L = cplcFuFuHhSML(gt2,i1,i3)
coup2R = cplcFuFuHhSMR(gt2,i1,i3)
coup3L = cplcFuFuHhSML(i2,gt3,i3)
coup3R = cplcFuFuHhSMR(i2,gt3,i3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_FFS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {bar[Fu], bar[Fu], VG}
Do i1=1,3
  Do i2=1,3
ML1 = MFu(i1) 
ML2 = MFu(i2) 
ML3 = MVG 
coup1L = cplcFuFuAhL(i1,i2,gt1)
coup1R = cplcFuFuAhR(i1,i2,gt1)
coup2L = cplcFuFuVGL(gt2,i1)
coup2R = cplcFuFuVGR(gt2,i1)
coup3L = cplcFuFuVGL(i2,gt3)
coup3R = cplcFuFuVGR(i2,gt3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_FFV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(4._dp/3._dp)*AmpC 
  End Do
End Do


! {bar[Fu], bar[Fu], VP}
Do i1=1,3
  Do i2=1,3
ML1 = MFu(i1) 
ML2 = MFu(i2) 
ML3 = MVP 
coup1L = cplcFuFuAhL(i1,i2,gt1)
coup1R = cplcFuFuAhR(i1,i2,gt1)
coup2L = cplcFuFuVPL(gt2,i1)
coup2R = cplcFuFuVPR(gt2,i1)
coup3L = cplcFuFuVPL(i2,gt3)
coup3R = cplcFuFuVPR(i2,gt3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_FFV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {bar[Fu], bar[Fu], VZ}
Do i1=1,3
  Do i2=1,3
ML1 = MFu(i1) 
ML2 = MFu(i2) 
ML3 = MVZ 
coup1L = cplcFuFuAhL(i1,i2,gt1)
coup1R = cplcFuFuAhR(i1,i2,gt1)
coup2L = cplcFuFuVZL(gt2,i1)
coup2R = cplcFuFuVZR(gt2,i1)
coup3L = cplcFuFuVZL(i2,gt3)
coup3R = cplcFuFuVZR(i2,gt3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_FFV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {conj[Hp], conj[Hp], Fd}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MFd(i3) 
coup1 = cplAhHpcHp(gt1,i2,i1)
coup2L = cplcFuFdHpL(gt2,i3,i1)
coup2R = cplcFuFdHpR(gt2,i3,i1)
coup3L = cplcFdFucHpL(i3,gt3,i2)
coup3R = cplcFdFucHpR(i3,gt3,i2)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_SSF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {conj[Hp], conj[VWp], Fd}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MFd(i3) 
coup1 = cplAhcHpVWp(gt1,i1)
coup2L = cplcFuFdHpL(gt2,i3,i1)
coup2R = cplcFuFdHpR(gt2,i3,i1)
coup3L = cplcFdFucVWpL(i3,gt3)
coup3R = cplcFdFucVWpR(i3,gt3)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_SVF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {conj[VWp], conj[Hp], Fd}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MFd(i3) 
coup1 = cplAhHpcVWp(gt1,i2)
coup2L = cplcFuFdVWpL(gt2,i3)
coup2R = cplcFuFdVWpR(gt2,i3)
coup3L = cplcFdFucHpL(i3,gt3,i2)
coup3R = cplcFdFucHpR(i3,gt3,i2)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_VSF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
    End Do
  End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_AhTocFuFu


Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhTocFuFu(MAh,MFd,MFu,MHhSM,MHp,               & 
& MVG,MVP,MVWp,MVZ,MAh2,MFd2,MFu2,MHhSM2,MHp2,MVG2,MVP2,MVWp2,MVZ2,cplAhAhHhSM,          & 
& cplcFdFdAhL,cplcFdFdAhR,cplcFuFuAhL,cplcFuFuAhR,cplAhHhSMVZ,cplAhHpcHp,cplAhHpcVWp,    & 
& cplAhcHpVWp,cplcFuFdHpL,cplcFuFdHpR,cplcFuFdVWpL,cplcFuFdVWpR,cplcFuFuHhSML,           & 
& cplcFuFuHhSMR,cplcFuFuVGL,cplcFuFuVGR,cplcFuFuVPL,cplcFuFuVPR,cplcFuFuVZL,             & 
& cplcFuFuVZR,cplcFdFucHpL,cplcFdFucHpR,cplcFdFucVWpL,cplcFdFucVWpR,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFu(3),MHhSM(3),MHp(3),MVG,MVP,MVWp,MVZ,MAh2(3),MFd2(3),MFu2(3),        & 
& MHhSM2(3),MHp2(3),MVG2,MVP2,MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhAhHhSM(3,3,3),cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFuFuAhL(3,3,3),          & 
& cplcFuFuAhR(3,3,3),cplAhHhSMVZ(3,3),cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),cplAhcHpVWp(3,3),& 
& cplcFuFdHpL(3,3,3),cplcFuFdHpR(3,3,3),cplcFuFdVWpL(3,3),cplcFuFdVWpR(3,3),             & 
& cplcFuFuHhSML(3,3,3),cplcFuFuHhSMR(3,3,3),cplcFuFuVGL(3,3),cplcFuFuVGR(3,3),           & 
& cplcFuFuVPL(3,3),cplcFuFuVPR(3,3),cplcFuFuVZL(3,3),cplcFuFuVZR(3,3),cplcFdFucHpL(3,3,3),& 
& cplcFdFucHpR(3,3,3),cplcFdFucVWpL(3,3),cplcFdFucVWpR(3,3)

Complex(dp), Intent(out) :: Amp(2,3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
Amp(:,gt1, gt2, gt3) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MFu(gt2) 
Mex3 = MFu(gt3) 


! {bar[Fu], bar[Fu], VG}
Do i1=1,3
  Do i2=1,3
ML1 = MFu(i1) 
ML2 = MFu(i2) 
ML3 = MVG 
coup1L = cplcFuFuAhL(i1,i2,gt1)
coup1R = cplcFuFuAhR(i1,i2,gt1)
coup2L = cplcFuFuVGL(gt2,i1)
coup2R = cplcFuFuVGR(gt2,i1)
coup3L = cplcFuFuVGL(i2,gt3)
coup3R = cplcFuFuVGR(i2,gt3)
Call Amp_VERTEX_StoFF_Topology1_FFV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(4._dp/3._dp)*AmpC 
  End Do
End Do


! {bar[Fu], bar[Fu], VP}
Do i1=1,3
  Do i2=1,3
ML1 = MFu(i1) 
ML2 = MFu(i2) 
ML3 = MVP 
coup1L = cplcFuFuAhL(i1,i2,gt1)
coup1R = cplcFuFuAhR(i1,i2,gt1)
coup2L = cplcFuFuVPL(gt2,i1)
coup2R = cplcFuFuVPR(gt2,i1)
coup3L = cplcFuFuVPL(i2,gt3)
coup3R = cplcFuFuVPR(i2,gt3)
Call Amp_VERTEX_StoFF_Topology1_FFV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do
    End Do
  End Do
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhTocFuFu


Subroutine Amplitude_Tree_4HDM_S3_AhTosigahha(cplAhhhasiga,MAh,Mhha,Msiga,            & 
& MAh2,Mhha2,Msiga2,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),Mhha,Msiga,MAh2(3),Mhha2,Msiga2

Complex(dp), Intent(in) :: cplAhhhasiga(3)

Complex(dp) :: Amp(3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 

Do gt1=1,3
! External masses 
Mex1 = MAh(gt1) 
Mex2 = Msiga 
Mex3 = Mhha 
! Tree-Level Vertex 
coupT1 = cplAhhhasiga(gt1)
Call TreeAmp_StoSS(Mex1,Mex2,Mex3,coupT1,AmpC) 
! Colour and symmetry factor 
Amp(gt1) = AmpC 
End Do
End Subroutine Amplitude_Tree_4HDM_S3_AhTosigahha


Subroutine Gamma_Real_4HDM_S3_AhTosigahha(MLambda,em,gs,cplAhhhasiga,MAh,             & 
& Mhha,Msiga,GammarealPhoton,GammarealGluon)

Implicit None

Complex(dp), Intent(in) :: cplAhhhasiga(3)

Real(dp), Intent(in) :: MAh(3),Mhha,Msiga

Real(dp), Intent(in) :: MLambda, em, gs 

Real(dp), Intent(out) :: GammarealPhoton(3), GammarealGluon(3) 

Integer :: i1, i2, i3, gt1, gt2, gt3, kont 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 

Real(dp) :: Mloop1, Mloop2, Mloop3 
Complex(dp) :: Coup 
 
Do i1=2,3
Coup = cplAhhhasiga(i1)
Mex1 = MAh(i1)
Mex2 = Msiga
Mex3 = Mhha
If (Mex1.gt.(Mex2+Mex3)) Then 
 Gammarealphoton(i1) = 0._dp 
  GammarealGluon(i1) = 0._dp 
Else 
  GammarealGluon(i1) = 0._dp 
  GammarealPhoton(i1) = 0._dp 

End if 
End Do
End Subroutine Gamma_Real_4HDM_S3_AhTosigahha


Subroutine Amplitude_WAVE_4HDM_S3_AhTosigahha(cplAhhhasiga,ctcplAhhhasiga,            & 
& MAh,MAh2,Mhha,Mhha2,Msiga,Msiga2,ZfAh,Zfhha,Zfsiga,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MAh2(3),Mhha,Mhha2,Msiga,Msiga2

Complex(dp), Intent(in) :: cplAhhhasiga(3)

Complex(dp), Intent(in) :: ctcplAhhhasiga(3)

Complex(dp), Intent(in) :: ZfAh(3,3),Zfhha,Zfsiga

Complex(dp), Intent(out) :: Amp(3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
! External masses 
Mex1 = MAh(gt1) 
Mex2 = Msiga 
Mex3 = Mhha 
!----------------------------- 
! Coupling counter term 
!----------------------------- 
ZcoupT1 = ctcplAhhhasiga(gt1) 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
Do i1=1,3
ZcoupT1 = ZcoupT1 + 0.5_dp*ZfAh(i1,gt1)*cplAhhhasiga(i1)
End Do


! External Field 2 
ZcoupT1 = ZcoupT1 + 0.5_dp*Zfsiga*cplAhhhasiga(gt1)


! External Field 3 
ZcoupT1 = ZcoupT1 + 0.5_dp*Zfhha*cplAhhhasiga(gt1)


! Getting the amplitude 
Call TreeAmp_StoSS(Mex1,Mex2,Mex3,ZcoupT1,AmpC) 
Amp(gt1) = AmpC 
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_AhTosigahha


Subroutine Amplitude_VERTEX_4HDM_S3_AhTosigahha(MAh,MHap,Mhha,MHhSM,MHp,              & 
& Msiga,MVWp,MVZ,MAh2,MHap2,Mhha2,MHhSM2,MHp2,Msiga2,MVWp2,MVZ2,cplAhAhHhSM,             & 
& cplAhhhasiga,cplAhHhSMVZ,cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplHaphhacHp,              & 
& cplHaphhacVWp,cplHapsigacHp,cplHapsigacVWp,cplhhahhaHhSM,cplhhaHpcHap,cplhhasigaVZ,    & 
& cplhhacHapVWp,cplHhSMsigasiga,cplHpsigacHap,cplsigacHapVWp,cplAhAhhhahha1,             & 
& cplAhAhsigasiga1,cplAhHaphhacHp1,cplAhHapsigacHp1,cplAhhhaHhSMsiga1,cplAhhhaHpcHap1,   & 
& cplAhHpsigacHap1,cplhhahhasigasiga1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MHap,Mhha,MHhSM(3),MHp(3),Msiga,MVWp,MVZ,MAh2(3),MHap2,Mhha2,MHhSM2(3),        & 
& MHp2(3),Msiga2,MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhAhHhSM(3,3,3),cplAhhhasiga(3),cplAhHhSMVZ(3,3),cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),& 
& cplAhcHpVWp(3,3),cplHaphhacHp(3),cplHaphhacVWp,cplHapsigacHp(3),cplHapsigacVWp,        & 
& cplhhahhaHhSM(3),cplhhaHpcHap(3),cplhhasigaVZ,cplhhacHapVWp,cplHhSMsigasiga(3),        & 
& cplHpsigacHap(3),cplsigacHapVWp,cplAhAhhhahha1(3,3),cplAhAhsigasiga1(3,3),             & 
& cplAhHaphhacHp1(3,3),cplAhHapsigacHp1(3,3),cplAhhhaHhSMsiga1(3,3),cplAhhhaHpcHap1(3,3),& 
& cplAhHpsigacHap1(3,3),cplhhahhasigasiga1

Complex(dp), Intent(out) :: Amp(3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
Amp(gt1) = 0._dp 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = Msiga 
Mex3 = Mhha 


! {Ah, HhSM, hha}
Do i1=1,3
  Do i2=1,3
ML1 = MAh(i1) 
ML2 = MHhSM(i2) 
ML3 = Mhha 
coup1 = cplAhAhHhSM(gt1,i1,i2)
coup2 = cplAhhhasiga(i1)
coup3 = cplhhahhaHhSM(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {hha, siga, Ah}
    Do i3=1,3
ML1 = Mhha 
ML2 = Msiga 
ML3 = MAh(i3) 
coup1 = cplAhhhasiga(gt1)
coup2 = cplAhhhasiga(i3)
coup3 = cplAhhhasiga(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
    End Do


! {hha, siga, VZ}
ML1 = Mhha 
ML2 = Msiga 
ML3 = MVZ 
coup1 = cplAhhhasiga(gt1)
coup2 = cplhhasigaVZ
coup3 = cplhhasigaVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 


! {HhSM, Ah, siga}
Do i1=1,3
  Do i2=1,3
ML1 = MHhSM(i1) 
ML2 = MAh(i2) 
ML3 = Msiga 
coup1 = cplAhAhHhSM(gt1,i2,i1)
coup2 = cplHhSMsigasiga(i1)
coup3 = cplAhhhasiga(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {HhSM, VZ, siga}
Do i1=1,3
ML1 = MHhSM(i1) 
ML2 = MVZ 
ML3 = Msiga 
coup1 = -cplAhHhSMVZ(gt1,i1)
coup2 = cplHhSMsigasiga(i1)
coup3 = cplhhasigaVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
End Do


! {Hp, Hp, Hap}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MHap 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplHapsigacHp(i1)
coup3 = cplhhaHpcHap(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, VWp, Hap}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MHap 
coup1 = -cplAhHpcVWp(gt1,i1)
coup2 = cplHapsigacHp(i1)
coup3 = cplhhacHapVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
End Do


! {siga, hha, HhSM}
    Do i3=1,3
ML1 = Msiga 
ML2 = Mhha 
ML3 = MHhSM(i3) 
coup1 = cplAhhhasiga(gt1)
coup2 = cplHhSMsigasiga(i3)
coup3 = cplhhahhaHhSM(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
    End Do


! {VWp, Hp, Hap}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MHap 
coup1 = -cplAhcHpVWp(gt1,i2)
coup2 = cplHapsigacVWp
coup3 = cplhhaHpcHap(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do


! {VZ, HhSM, hha}
  Do i2=1,3
ML1 = MVZ 
ML2 = MHhSM(i2) 
ML3 = Mhha 
coup1 = -cplAhHhSMVZ(gt1,i2)
coup2 = cplhhasigaVZ
coup3 = cplhhahhaHhSM(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do


! {conj[Hp], conj[Hp], conj[Hap]}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MHap 
coup1 = cplAhHpcHp(gt1,i2,i1)
coup2 = cplHpsigacHap(i1)
coup3 = cplHaphhacHp(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {conj[Hp], conj[VWp], conj[Hap]}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MHap 
coup1 = -cplAhcHpVWp(gt1,i1)
coup2 = cplHpsigacHap(i1)
coup3 = -cplHaphhacVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
End Do


! {conj[VWp], conj[Hp], conj[Hap]}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MHap 
coup1 = -cplAhHpcVWp(gt1,i2)
coup2 = -cplsigacHapVWp
coup3 = cplHaphhacHp(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do


! {Ah, HhSM}
Do i1=1,3
  Do i2=1,3
ML1 = MAh(i1) 
ML2 = MHhSM(i2) 
coup1 = cplAhAhHhSM(gt1,i1,i2)
coup2 = cplAhhhaHhSMsiga1(i1,i2)
Call Amp_VERTEX_StoSS_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {hha, siga}
ML1 = Mhha 
ML2 = Msiga 
coup1 = cplAhhhasiga(gt1)
coup2 = cplhhahhasigasiga1
Call Amp_VERTEX_StoSS_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 


! {Ah, hha}
Do i1=1,3
ML1 = MAh(i1) 
ML2 = Mhha 
coup1 = cplAhAhhhahha1(gt1,i1)
coup2 = cplAhhhasiga(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 

End Do


! {Hap, Hp}
  Do i2=1,3
ML1 = MHap 
ML2 = MHp(i2) 
coup1 = cplAhHaphhacHp1(gt1,i2)
coup2 = cplHpsigacHap(i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 

  End Do


! {HhSM, siga}
Do i1=1,3
ML1 = MHhSM(i1) 
ML2 = Msiga 
coup1 = cplAhhhaHhSMsiga1(gt1,i1)
coup2 = cplHhSMsigasiga(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 

End Do


! {Hp, Hap}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MHap 
coup1 = cplAhhhaHpcHap1(gt1,i1)
coup2 = cplHapsigacHp(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 

End Do


! {Ah, siga}
Do i1=1,3
ML1 = MAh(i1) 
ML2 = Msiga 
coup1 = cplAhAhsigasiga1(gt1,i1)
coup2 = cplAhhhasiga(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 

End Do


! {Hap, Hp}
  Do i2=1,3
ML1 = MHap 
ML2 = MHp(i2) 
coup1 = cplAhHapsigacHp1(gt1,i2)
coup2 = cplhhaHpcHap(i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 

  End Do


! {hha, HhSM}
  Do i2=1,3
ML1 = Mhha 
ML2 = MHhSM(i2) 
coup1 = cplAhhhaHhSMsiga1(gt1,i2)
coup2 = cplhhahhaHhSM(i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 

  End Do


! {Hp, Hap}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MHap 
coup1 = cplAhHpsigacHap1(gt1,i1)
coup2 = cplHaphhacHp(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 

End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_AhTosigahha


Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhTosigahha(MAh,MHap,Mhha,MHhSM,               & 
& MHp,Msiga,MVWp,MVZ,MAh2,MHap2,Mhha2,MHhSM2,MHp2,Msiga2,MVWp2,MVZ2,cplAhAhHhSM,         & 
& cplAhhhasiga,cplAhHhSMVZ,cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplHaphhacHp,              & 
& cplHaphhacVWp,cplHapsigacHp,cplHapsigacVWp,cplhhahhaHhSM,cplhhaHpcHap,cplhhasigaVZ,    & 
& cplhhacHapVWp,cplHhSMsigasiga,cplHpsigacHap,cplsigacHapVWp,cplAhAhhhahha1,             & 
& cplAhAhsigasiga1,cplAhHaphhacHp1,cplAhHapsigacHp1,cplAhhhaHhSMsiga1,cplAhhhaHpcHap1,   & 
& cplAhHpsigacHap1,cplhhahhasigasiga1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MHap,Mhha,MHhSM(3),MHp(3),Msiga,MVWp,MVZ,MAh2(3),MHap2,Mhha2,MHhSM2(3),        & 
& MHp2(3),Msiga2,MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhAhHhSM(3,3,3),cplAhhhasiga(3),cplAhHhSMVZ(3,3),cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),& 
& cplAhcHpVWp(3,3),cplHaphhacHp(3),cplHaphhacVWp,cplHapsigacHp(3),cplHapsigacVWp,        & 
& cplhhahhaHhSM(3),cplhhaHpcHap(3),cplhhasigaVZ,cplhhacHapVWp,cplHhSMsigasiga(3),        & 
& cplHpsigacHap(3),cplsigacHapVWp,cplAhAhhhahha1(3,3),cplAhAhsigasiga1(3,3),             & 
& cplAhHaphhacHp1(3,3),cplAhHapsigacHp1(3,3),cplAhhhaHhSMsiga1(3,3),cplAhhhaHpcHap1(3,3),& 
& cplAhHpsigacHap1(3,3),cplhhahhasigasiga1

Complex(dp), Intent(out) :: Amp(3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
Amp(gt1) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = Msiga 
Mex3 = Mhha 
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhTosigahha


Subroutine Amplitude_Tree_4HDM_S3_AhToHhSMVZ(cplAhHhSMVZ,MAh,MHhSM,MVZ,               & 
& MAh2,MHhSM2,MVZ2,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MHhSM(3),MVZ,MAh2(3),MHhSM2(3),MVZ2

Complex(dp), Intent(in) :: cplAhHhSMVZ(3,3)

Complex(dp) :: Amp(2,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 

Do gt1=1,3
  Do gt2=1,3
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MHhSM(gt2) 
Mex3 = MVZ 
! Tree-Level Vertex 
coupT1 = cplAhHhSMVZ(gt1,gt2)
Call TreeAmp_StoSV(Mex1,Mex2,Mex3,coupT1,AmpC) 
! Colour and symmetry factor 
Amp(:,gt1, gt2) = AmpC 
  End Do
End Do
End Subroutine Amplitude_Tree_4HDM_S3_AhToHhSMVZ


Subroutine Gamma_Real_4HDM_S3_AhToHhSMVZ(MLambda,em,gs,cplAhHhSMVZ,MAh,               & 
& MHhSM,MVZ,GammarealPhoton,GammarealGluon)

Implicit None

Complex(dp), Intent(in) :: cplAhHhSMVZ(3,3)

Real(dp), Intent(in) :: MAh(3),MHhSM(3),MVZ

Real(dp), Intent(in) :: MLambda, em, gs 

Real(dp), Intent(out) :: GammarealPhoton(3,3), GammarealGluon(3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3, kont 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 

Real(dp) :: Mloop1, Mloop2, Mloop3 
Complex(dp) :: Coup 
 
Do i1=2,3
  Do i2=1,3
Coup = cplAhHhSMVZ(i1,i2)
Mex1 = MAh(i1)
Mex2 = MHhSM(i2)
Mex3 = MVZ
If (Mex1.gt.(Mex2+Mex3)) Then 
 Gammarealphoton(i1,i2) = 0._dp 
 GammarealGluon(i1,i2) = 0._dp 
Else 
  GammarealGluon(i1,i2) = 0._dp 
  GammarealPhoton(i1,i2) = 0._dp 

End if 
  End Do
End Do
End Subroutine Gamma_Real_4HDM_S3_AhToHhSMVZ


Subroutine Amplitude_WAVE_4HDM_S3_AhToHhSMVZ(cplAhHhSMVZ,ctcplAhHhSMVZ,               & 
& MAh,MAh2,MHhSM,MHhSM2,MVZ,MVZ2,ZfAh,ZfHhSM,ZfVZ,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MAh2(3),MHhSM(3),MHhSM2(3),MVZ,MVZ2

Complex(dp), Intent(in) :: cplAhHhSMVZ(3,3)

Complex(dp), Intent(in) :: ctcplAhHhSMVZ(3,3)

Complex(dp), Intent(in) :: ZfAh(3,3),ZfHhSM(3,3),ZfVZ

Complex(dp), Intent(out) :: Amp(2,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
  Do gt2=1,3
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MHhSM(gt2) 
Mex3 = MVZ 
!----------------------------- 
! Coupling counter term 
!----------------------------- 
ZcoupT1 = ctcplAhHhSMVZ(gt1,gt2) 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
Do i1=1,3
ZcoupT1 = ZcoupT1 + 0.5_dp*ZfAh(i1,gt1)*cplAhHhSMVZ(i1,gt2)
End Do


! External Field 2 
Do i1=1,3
ZcoupT1 = ZcoupT1 + 0.5_dp*ZfHhSM(i1,gt2)*cplAhHhSMVZ(gt1,i1)
End Do


! External Field 3 
ZcoupT1 = ZcoupT1 + 0.5_dp*ZfVZ*cplAhHhSMVZ(gt1,gt2)


! Getting the amplitude 
Call TreeAmp_StoSV(Mex1,Mex2,Mex3,ZcoupT1,AmpC) 
Amp(:,gt1, gt2) = AmpC 
  End Do
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_AhToHhSMVZ


Subroutine Amplitude_VERTEX_4HDM_S3_AhToHhSMVZ(MAh,MFd,MFe,MFu,Mhha,MHhSM,            & 
& MHp,Msiga,MVWp,MVZ,MAh2,MFd2,MFe2,MFu2,Mhha2,MHhSM2,MHp2,Msiga2,MVWp2,MVZ2,            & 
& cplAhAhHhSM,cplcFdFdAhL,cplcFdFdAhR,cplcFeFeAhL,cplcFeFeAhR,cplcFuFuAhL,               & 
& cplcFuFuAhR,cplcgWpgWpAh,cplcgWCgWCAh,cplAhhhasiga,cplAhHhSMVZ,cplAhHpcHp,             & 
& cplAhHpcVWp,cplAhcHpVWp,cplcFdFdHhSML,cplcFdFdHhSMR,cplcFdFdVZL,cplcFdFdVZR,           & 
& cplcFeFeHhSML,cplcFeFeHhSMR,cplcFeFeVZL,cplcFeFeVZR,cplcFuFuHhSML,cplcFuFuHhSMR,       & 
& cplcFuFuVZL,cplcFuFuVZR,cplcgWpgWpHhSM,cplcgWpgWpVZ,cplcgWCgWCHhSM,cplcgWCgWCVZ,       & 
& cplhhahhaHhSM,cplhhasigaVZ,cplHhSMHhSMHhSM,cplHhSMHpcHp,cplHhSMHpcVWp,cplHhSMsigasiga, & 
& cplHhSMcHpVWp,cplHhSMcVWpVWp,cplHhSMVZVZ,cplHpcHpVZ,cplHpcVWpVZ,cplcHpVWpVZ,           & 
& cplcVWpVWpVZ,cplAhAhVZVZ1,cplAhHpcVWpVZ1,cplAhcHpVWpVZ1,cplHhSMHhSMVZVZ1,              & 
& cplHhSMHpcVWpVZ1,cplHhSMcHpVWpVZ1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),Mhha,MHhSM(3),MHp(3),Msiga,MVWp,MVZ,MAh2(3),              & 
& MFd2(3),MFe2(3),MFu2(3),Mhha2,MHhSM2(3),MHp2(3),Msiga2,MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhAhHhSM(3,3,3),cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFeFeAhL(3,3,3),          & 
& cplcFeFeAhR(3,3,3),cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcgWpgWpAh(3),              & 
& cplcgWCgWCAh(3),cplAhhhasiga(3),cplAhHhSMVZ(3,3),cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),   & 
& cplAhcHpVWp(3,3),cplcFdFdHhSML(3,3,3),cplcFdFdHhSMR(3,3,3),cplcFdFdVZL(3,3),           & 
& cplcFdFdVZR(3,3),cplcFeFeHhSML(3,3,3),cplcFeFeHhSMR(3,3,3),cplcFeFeVZL(3,3),           & 
& cplcFeFeVZR(3,3),cplcFuFuHhSML(3,3,3),cplcFuFuHhSMR(3,3,3),cplcFuFuVZL(3,3),           & 
& cplcFuFuVZR(3,3),cplcgWpgWpHhSM(3),cplcgWpgWpVZ,cplcgWCgWCHhSM(3),cplcgWCgWCVZ,        & 
& cplhhahhaHhSM(3),cplhhasigaVZ,cplHhSMHhSMHhSM(3,3,3),cplHhSMHpcHp(3,3,3),              & 
& cplHhSMHpcVWp(3,3),cplHhSMsigasiga(3),cplHhSMcHpVWp(3,3),cplHhSMcVWpVWp(3),            & 
& cplHhSMVZVZ(3),cplHpcHpVZ(3,3),cplHpcVWpVZ(3),cplcHpVWpVZ(3),cplcVWpVWpVZ,             & 
& cplAhAhVZVZ1(3,3),cplAhHpcVWpVZ1(3,3),cplAhcHpVWpVZ1(3,3),cplHhSMHhSMVZVZ1(3,3),       & 
& cplHhSMHpcVWpVZ1(3,3),cplHhSMcHpVWpVZ1(3,3)

Complex(dp), Intent(out) :: Amp(2,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
Amp(:,gt1, gt2) = 0._dp 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MHhSM(gt2) 
Mex3 = MVZ 


! {Ah, HhSM, Ah}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MAh(i1) 
ML2 = MHhSM(i2) 
ML3 = MAh(i3) 
coup1 = cplAhAhHhSM(gt1,i1,i2)
coup2 = cplAhAhHhSM(i1,i3,gt2)
coup3 = cplAhHhSMVZ(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Ah, HhSM, VZ}
Do i1=1,3
  Do i2=1,3
ML1 = MAh(i1) 
ML2 = MHhSM(i2) 
ML3 = MVZ 
coup1 = cplAhAhHhSM(gt1,i1,i2)
coup2 = -cplAhHhSMVZ(i1,gt2)
coup3 = cplHhSMVZVZ(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Fd, Fd, Fd}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFd(i1) 
ML2 = MFd(i2) 
ML3 = MFd(i3) 
coup1L = cplcFdFdAhL(i2,i1,gt1)
coup1R = cplcFdFdAhR(i2,i1,gt1)
coup2L = cplcFdFdHhSML(i1,i3,gt2)
coup2R = cplcFdFdHhSMR(i1,i3,gt2)
coup3L = -cplcFdFdVZR(i3,i2)
coup3R = -cplcFdFdVZL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(6)*AmpC 
    End Do
  End Do
End Do


! {Fe, Fe, Fe}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFe(i1) 
ML2 = MFe(i2) 
ML3 = MFe(i3) 
coup1L = cplcFeFeAhL(i2,i1,gt1)
coup1R = cplcFeFeAhR(i2,i1,gt1)
coup2L = cplcFeFeHhSML(i1,i3,gt2)
coup2R = cplcFeFeHhSMR(i1,i3,gt2)
coup3L = -cplcFeFeVZR(i3,i2)
coup3R = -cplcFeFeVZL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(2)*AmpC 
    End Do
  End Do
End Do


! {Fu, Fu, Fu}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFu(i1) 
ML2 = MFu(i2) 
ML3 = MFu(i3) 
coup1L = cplcFuFuAhL(i2,i1,gt1)
coup1R = cplcFuFuAhR(i2,i1,gt1)
coup2L = cplcFuFuHhSML(i1,i3,gt2)
coup2R = cplcFuFuHhSMR(i1,i3,gt2)
coup3L = -cplcFuFuVZR(i3,i2)
coup3R = -cplcFuFuVZL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(6)*AmpC 
    End Do
  End Do
End Do


! {gWp, gWp, gWp}
ML1 = MVWp 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcgWpgWpAh(gt1)
coup2 = cplcgWpgWpHhSM(gt2)
coup3 = cplcgWpgWpVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(2)*AmpC 


! {gWpC, gWpC, gWpC}
ML1 = MVWp 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcgWCgWCAh(gt1)
coup2 = cplcgWCgWCHhSM(gt2)
coup3 = cplcgWCgWCVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(2)*AmpC 


! {hha, siga, hha}
ML1 = Mhha 
ML2 = Msiga 
ML3 = Mhha 
coup1 = cplAhhhasiga(gt1)
coup2 = cplhhahhaHhSM(gt2)
coup3 = cplhhasigaVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {HhSM, Ah, HhSM}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHhSM(i1) 
ML2 = MAh(i2) 
ML3 = MHhSM(i3) 
coup1 = cplAhAhHhSM(gt1,i2,i1)
coup2 = cplHhSMHhSMHhSM(gt2,i1,i3)
coup3 = -cplAhHhSMVZ(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {HhSM, VZ, HhSM}
Do i1=1,3
    Do i3=1,3
ML1 = MHhSM(i1) 
ML2 = MVZ 
ML3 = MHhSM(i3) 
coup1 = -cplAhHhSMVZ(gt1,i1)
coup2 = cplHhSMHhSMHhSM(gt2,i1,i3)
coup3 = cplHhSMVZVZ(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, Hp, Hp}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplHhSMHpcHp(gt2,i3,i1)
coup3 = -cplHpcHpVZ(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(2)*AmpC 
    End Do
  End Do
End Do


! {Hp, VWp, Hp}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = -cplAhHpcVWp(gt1,i1)
coup2 = cplHhSMHpcHp(gt2,i3,i1)
coup3 = cplcHpVWpVZ(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, Hp, VWp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplHhSMcHpVWp(gt2,i1)
coup3 = cplHpcVWpVZ(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, VWp, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MVWp 
coup1 = -cplAhHpcVWp(gt1,i1)
coup2 = cplHhSMcHpVWp(gt2,i1)
coup3 = -cplcVWpVWpVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {siga, hha, siga}
ML1 = Msiga 
ML2 = Mhha 
ML3 = Msiga 
coup1 = cplAhhhasiga(gt1)
coup2 = cplHhSMsigasiga(gt2)
coup3 = -cplhhasigaVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {VWp, Hp, Hp}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = -cplAhcHpVWp(gt1,i2)
coup2 = cplHhSMHpcVWp(gt2,i3)
coup3 = -cplHpcHpVZ(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VWp, Hp, VWp}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = -cplAhcHpVWp(gt1,i2)
coup2 = cplHhSMcVWpVWp(gt2)
coup3 = cplHpcVWpVZ(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do


! {VZ, HhSM, Ah}
  Do i2=1,3
    Do i3=1,3
ML1 = MVZ 
ML2 = MHhSM(i2) 
ML3 = MAh(i3) 
coup1 = -cplAhHhSMVZ(gt1,i2)
coup2 = -cplAhHhSMVZ(i3,gt2)
coup3 = cplAhHhSMVZ(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VZ, HhSM, VZ}
  Do i2=1,3
ML1 = MVZ 
ML2 = MHhSM(i2) 
ML3 = MVZ 
coup1 = -cplAhHhSMVZ(gt1,i2)
coup2 = cplHhSMVZVZ(gt2)
coup3 = cplHhSMVZVZ(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do


! {conj[Hp], conj[VWp], conj[Hp]}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = -cplAhcHpVWp(gt1,i1)
coup2 = cplHhSMHpcHp(gt2,i1,i3)
coup3 = cplHpcVWpVZ(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {conj[Hp], conj[Hp], conj[VWp]}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplAhHpcHp(gt1,i2,i1)
coup2 = cplHhSMHpcVWp(gt2,i1)
coup3 = cplcHpVWpVZ(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {conj[Hp], conj[VWp], conj[VWp]}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MVWp 
coup1 = -cplAhcHpVWp(gt1,i1)
coup2 = cplHhSMHpcVWp(gt2,i1)
coup3 = cplcVWpVWpVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {conj[VWp], conj[Hp], conj[Hp]}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = -cplAhHpcVWp(gt1,i2)
coup2 = cplHhSMcHpVWp(gt2,i3)
coup3 = cplHpcHpVZ(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {conj[VWp], conj[Hp], conj[VWp]}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = -cplAhHpcVWp(gt1,i2)
coup2 = cplHhSMcVWpVWp(gt2)
coup3 = cplcHpVWpVZ(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do


! {HhSM, VZ}
Do i1=1,3
ML1 = MHhSM(i1) 
ML2 = MVZ 
coup1 = cplAhHhSMVZ(gt1,i1)
coup2 = cplHhSMHhSMVZVZ1(gt2,i1)
Call Amp_VERTEX_StoSV_Topology2_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {Hp, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
coup1 = cplAhHpcVWp(gt1,i1)
coup2 = cplHhSMcHpVWpVZ1(gt2,i1)
Call Amp_VERTEX_StoSV_Topology2_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {VWp, Hp}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
coup1 = cplAhcHpVWp(gt1,i2)
coup2 = cplHhSMHpcVWpVZ1(gt2,i2)
Call Amp_VERTEX_StoSV_Topology2_VS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do


! {Ah, VZ}
Do i1=1,3
ML1 = MAh(i1) 
ML2 = MVZ 
coup1 = cplAhAhVZVZ1(gt1,i1)
coup2 = -cplAhHhSMVZ(i1,gt2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology3_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 

End Do


! {Hp, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
coup1 = cplAhHpcVWpVZ1(gt1,i1)
coup2 = cplHhSMcHpVWp(gt2,i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology3_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 

End Do


! {VWp, Hp}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
coup1 = cplAhcHpVWpVZ1(gt1,i2)
coup2 = cplHhSMHpcVWp(gt2,i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology3_VS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 

  End Do
  End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_AhToHhSMVZ


Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhToHhSMVZ(MAh,MFd,MFe,MFu,Mhha,               & 
& MHhSM,MHp,Msiga,MVWp,MVZ,MAh2,MFd2,MFe2,MFu2,Mhha2,MHhSM2,MHp2,Msiga2,MVWp2,           & 
& MVZ2,cplAhAhHhSM,cplcFdFdAhL,cplcFdFdAhR,cplcFeFeAhL,cplcFeFeAhR,cplcFuFuAhL,          & 
& cplcFuFuAhR,cplcgWpgWpAh,cplcgWCgWCAh,cplAhhhasiga,cplAhHhSMVZ,cplAhHpcHp,             & 
& cplAhHpcVWp,cplAhcHpVWp,cplcFdFdHhSML,cplcFdFdHhSMR,cplcFdFdVZL,cplcFdFdVZR,           & 
& cplcFeFeHhSML,cplcFeFeHhSMR,cplcFeFeVZL,cplcFeFeVZR,cplcFuFuHhSML,cplcFuFuHhSMR,       & 
& cplcFuFuVZL,cplcFuFuVZR,cplcgWpgWpHhSM,cplcgWpgWpVZ,cplcgWCgWCHhSM,cplcgWCgWCVZ,       & 
& cplhhahhaHhSM,cplhhasigaVZ,cplHhSMHhSMHhSM,cplHhSMHpcHp,cplHhSMHpcVWp,cplHhSMsigasiga, & 
& cplHhSMcHpVWp,cplHhSMcVWpVWp,cplHhSMVZVZ,cplHpcHpVZ,cplHpcVWpVZ,cplcHpVWpVZ,           & 
& cplcVWpVWpVZ,cplAhAhVZVZ1,cplAhHpcVWpVZ1,cplAhcHpVWpVZ1,cplHhSMHhSMVZVZ1,              & 
& cplHhSMHpcVWpVZ1,cplHhSMcHpVWpVZ1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),Mhha,MHhSM(3),MHp(3),Msiga,MVWp,MVZ,MAh2(3),              & 
& MFd2(3),MFe2(3),MFu2(3),Mhha2,MHhSM2(3),MHp2(3),Msiga2,MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhAhHhSM(3,3,3),cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFeFeAhL(3,3,3),          & 
& cplcFeFeAhR(3,3,3),cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcgWpgWpAh(3),              & 
& cplcgWCgWCAh(3),cplAhhhasiga(3),cplAhHhSMVZ(3,3),cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),   & 
& cplAhcHpVWp(3,3),cplcFdFdHhSML(3,3,3),cplcFdFdHhSMR(3,3,3),cplcFdFdVZL(3,3),           & 
& cplcFdFdVZR(3,3),cplcFeFeHhSML(3,3,3),cplcFeFeHhSMR(3,3,3),cplcFeFeVZL(3,3),           & 
& cplcFeFeVZR(3,3),cplcFuFuHhSML(3,3,3),cplcFuFuHhSMR(3,3,3),cplcFuFuVZL(3,3),           & 
& cplcFuFuVZR(3,3),cplcgWpgWpHhSM(3),cplcgWpgWpVZ,cplcgWCgWCHhSM(3),cplcgWCgWCVZ,        & 
& cplhhahhaHhSM(3),cplhhasigaVZ,cplHhSMHhSMHhSM(3,3,3),cplHhSMHpcHp(3,3,3),              & 
& cplHhSMHpcVWp(3,3),cplHhSMsigasiga(3),cplHhSMcHpVWp(3,3),cplHhSMcVWpVWp(3),            & 
& cplHhSMVZVZ(3),cplHpcHpVZ(3,3),cplHpcVWpVZ(3),cplcHpVWpVZ(3),cplcVWpVWpVZ,             & 
& cplAhAhVZVZ1(3,3),cplAhHpcVWpVZ1(3,3),cplAhcHpVWpVZ1(3,3),cplHhSMHhSMVZVZ1(3,3),       & 
& cplHhSMHpcVWpVZ1(3,3),cplHhSMcHpVWpVZ1(3,3)

Complex(dp), Intent(out) :: Amp(2,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
Amp(:,gt1, gt2) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MHhSM(gt2) 
Mex3 = MVZ 
  End Do
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhToHhSMVZ


Subroutine Amplitude_Tree_4HDM_S3_AhTocHpHp(cplAhHpcHp,MAh,MHp,MAh2,MHp2,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MHp(3),MAh2(3),MHp2(3)

Complex(dp), Intent(in) :: cplAhHpcHp(3,3,3)

Complex(dp) :: Amp(3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 

Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MHp(gt2) 
Mex3 = MHp(gt3) 
! Tree-Level Vertex 
coupT1 = cplAhHpcHp(gt1,gt3,gt2)
Call TreeAmp_StoSS(Mex1,Mex2,Mex3,coupT1,AmpC) 
! Colour and symmetry factor 
Amp(gt1, gt2, gt3) = AmpC 
    End Do
  End Do
End Do
End Subroutine Amplitude_Tree_4HDM_S3_AhTocHpHp


Subroutine Gamma_Real_4HDM_S3_AhTocHpHp(MLambda,em,gs,cplAhHpcHp,MAh,MHp,             & 
& GammarealPhoton,GammarealGluon)

Implicit None

Complex(dp), Intent(in) :: cplAhHpcHp(3,3,3)

Real(dp), Intent(in) :: MAh(3),MHp(3)

Real(dp), Intent(in) :: MLambda, em, gs 

Real(dp), Intent(out) :: GammarealPhoton(3,3,3), GammarealGluon(3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3, kont 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 

Real(dp) :: Mloop1, Mloop2, Mloop3 
Complex(dp) :: Coup 
 
Do i1=2,3
  Do i2=2,3
    Do i3=2,3
Coup = cplAhHpcHp(i1,i3,i2)
Mex1 = MAh(i1)
Mex2 = MHp(i2)
Mex3 = MHp(i3)
If (Mex1.gt.(Mex2+Mex3)) Then 
 Call hardradiationSSS(Mex1,Mex2,Mex3,MLambda,em,0._dp,0._dp,0._dp,1._dp,-1._dp,1._dp,Coup,Gammarealphoton(i1,i2,i3),kont)
  GammarealGluon(i1,i2,i3) = 0._dp 
Else 
  GammarealGluon(i1,i2,i3) = 0._dp 
  GammarealPhoton(i1,i2,i3) = 0._dp 

End if 
    End Do
  End Do
End Do
End Subroutine Gamma_Real_4HDM_S3_AhTocHpHp


Subroutine Amplitude_WAVE_4HDM_S3_AhTocHpHp(cplAhHpcHp,ctcplAhHpcHp,MAh,              & 
& MAh2,MHp,MHp2,ZfAh,ZfHp,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MAh2(3),MHp(3),MHp2(3)

Complex(dp), Intent(in) :: cplAhHpcHp(3,3,3)

Complex(dp), Intent(in) :: ctcplAhHpcHp(3,3,3)

Complex(dp), Intent(in) :: ZfAh(3,3),ZfHp(3,3)

Complex(dp), Intent(out) :: Amp(3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MHp(gt2) 
Mex3 = MHp(gt3) 
!----------------------------- 
! Coupling counter term 
!----------------------------- 
ZcoupT1 = ctcplAhHpcHp(gt1,gt3,gt2) 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
Do i1=1,3
ZcoupT1 = ZcoupT1 + 0.5_dp*ZfAh(i1,gt1)*cplAhHpcHp(i1,gt3,gt2)
End Do


! External Field 2 
Do i1=1,3
ZcoupT1 = ZcoupT1 + 0.5_dp*Conjg(ZfHp(i1,gt2))*cplAhHpcHp(gt1,gt3,i1)
End Do


! External Field 3 
Do i1=1,3
ZcoupT1 = ZcoupT1 + 0.5_dp*ZfHp(i1,gt3)*cplAhHpcHp(gt1,i1,gt2)
End Do


! Getting the amplitude 
Call TreeAmp_StoSS(Mex1,Mex2,Mex3,ZcoupT1,AmpC) 
Amp(gt1, gt2, gt3) = AmpC 
    End Do
  End Do
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_AhTocHpHp


Subroutine Amplitude_VERTEX_4HDM_S3_AhTocHpHp(MAh,MFd,MFe,MFu,MHap,Mhha,              & 
& MHhSM,MHp,Msiga,MVP,MVWp,MVZ,MAh2,MFd2,MFe2,MFu2,MHap2,Mhha2,MHhSM2,MHp2,              & 
& Msiga2,MVP2,MVWp2,MVZ2,cplAhAhHhSM,cplcFdFdAhL,cplcFdFdAhR,cplcFeFeAhL,cplcFeFeAhR,    & 
& cplcFuFuAhL,cplcFuFuAhR,cplcgWpgWpAh,cplcgWCgWCAh,cplAhhhasiga,cplAhHhSMVZ,            & 
& cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplcFuFdHpL,cplcFuFdHpR,cplcFvFeHpL,cplcFvFeHpR,    & 
& cplcFdFucHpL,cplcFdFucHpR,cplcFeFvcHpL,cplcFeFvcHpR,cplcgZgWpcHp,cplcgZgWCHp,          & 
& cplcgWpgZHp,cplcgWCgZcHp,cplHaphhacHp,cplHapsigacHp,cplhhaHpcHap,cplHhSMHpcHp,         & 
& cplHhSMHpcVWp,cplHhSMcHpVWp,cplHpsigacHap,cplHpcHpVP,cplHpcVWpVP,cplHpcHpVZ,           & 
& cplHpcVWpVZ,cplcHpVPVWp,cplcHpVWpVZ,cplAhAhHpcHp1,cplAhHaphhacHp1,cplAhHapsigacHp1,    & 
& cplAhhhaHpcHap1,cplAhHhSMHpcHp1,cplAhHpsigacHap1,cplAhHpcVWpVP1,cplAhHpcVWpVZ1,        & 
& cplAhcHpVPVWp1,cplAhcHpVWpVZ1,cplHpHpcHpcHp1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHap,Mhha,MHhSM(3),MHp(3),Msiga,MVP,MVWp,MVZ,             & 
& MAh2(3),MFd2(3),MFe2(3),MFu2(3),MHap2,Mhha2,MHhSM2(3),MHp2(3),Msiga2,MVP2,             & 
& MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhAhHhSM(3,3,3),cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFeFeAhL(3,3,3),          & 
& cplcFeFeAhR(3,3,3),cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcgWpgWpAh(3),              & 
& cplcgWCgWCAh(3),cplAhhhasiga(3),cplAhHhSMVZ(3,3),cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),   & 
& cplAhcHpVWp(3,3),cplcFuFdHpL(3,3,3),cplcFuFdHpR(3,3,3),cplcFvFeHpL(3,3,3),             & 
& cplcFvFeHpR(3,3,3),cplcFdFucHpL(3,3,3),cplcFdFucHpR(3,3,3),cplcFeFvcHpL(3,3,3),        & 
& cplcFeFvcHpR(3,3,3),cplcgZgWpcHp(3),cplcgZgWCHp(3),cplcgWpgZHp(3),cplcgWCgZcHp(3),     & 
& cplHaphhacHp(3),cplHapsigacHp(3),cplhhaHpcHap(3),cplHhSMHpcHp(3,3,3),cplHhSMHpcVWp(3,3),& 
& cplHhSMcHpVWp(3,3),cplHpsigacHap(3),cplHpcHpVP(3,3),cplHpcVWpVP(3),cplHpcHpVZ(3,3),    & 
& cplHpcVWpVZ(3),cplcHpVPVWp(3),cplcHpVWpVZ(3),cplAhAhHpcHp1(3,3,3,3),cplAhHaphhacHp1(3,3),& 
& cplAhHapsigacHp1(3,3),cplAhhhaHpcHap1(3,3),cplAhHhSMHpcHp1(3,3,3,3),cplAhHpsigacHap1(3,3),& 
& cplAhHpcVWpVP1(3,3),cplAhHpcVWpVZ1(3,3),cplAhcHpVPVWp1(3,3),cplAhcHpVWpVZ1(3,3),       & 
& cplHpHpcHpcHp1(3,3,3,3)

Complex(dp), Intent(out) :: Amp(3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
Amp(gt1, gt2, gt3) = 0._dp 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MHp(gt2) 
Mex3 = MHp(gt3) 


! {Ah, HhSM, Hp}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MAh(i1) 
ML2 = MHhSM(i2) 
ML3 = MHp(i3) 
coup1 = cplAhAhHhSM(gt1,i1,i2)
coup2 = cplAhHpcHp(i1,i3,gt2)
coup3 = cplHhSMHpcHp(i2,gt3,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Ah, HhSM, VWp}
Do i1=1,3
  Do i2=1,3
ML1 = MAh(i1) 
ML2 = MHhSM(i2) 
ML3 = MVWp 
coup1 = cplAhAhHhSM(gt1,i1,i2)
coup2 = cplAhcHpVWp(i1,gt2)
coup3 = -cplHhSMHpcVWp(i2,gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Fd, Fd, Fu}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFd(i1) 
ML2 = MFd(i2) 
ML3 = MFu(i3) 
coup1L = cplcFdFdAhL(i2,i1,gt1)
coup1R = cplcFdFdAhR(i2,i1,gt1)
coup2L = cplcFdFucHpL(i1,i3,gt2)
coup2R = cplcFdFucHpR(i1,i3,gt2)
coup3L = cplcFuFdHpL(i3,i2,gt3)
coup3R = cplcFuFdHpR(i3,i2,gt3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(3)*AmpC 
    End Do
  End Do
End Do


! {Fe, Fe, Fv}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFe(i1) 
ML2 = MFe(i2) 
ML3 = 0. 
coup1L = cplcFeFeAhL(i2,i1,gt1)
coup1R = cplcFeFeAhR(i2,i1,gt1)
coup2L = cplcFeFvcHpL(i1,i3,gt2)
coup2R = cplcFeFvcHpR(i1,i3,gt2)
coup3L = cplcFvFeHpL(i3,i2,gt3)
coup3R = cplcFvFeHpR(i3,i2,gt3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {gWpC, gWpC, gZ}
ML1 = MVWp 
ML2 = MVWp 
ML3 = MVZ 
coup1 = cplcgWCgWCAh(gt1)
coup2 = cplcgWCgZcHp(gt2)
coup3 = cplcgZgWCHp(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {hha, siga, Hap}
ML1 = Mhha 
ML2 = Msiga 
ML3 = MHap 
coup1 = cplAhhhasiga(gt1)
coup2 = cplHaphhacHp(gt2)
coup3 = cplHpsigacHap(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {HhSM, Ah, Hp}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHhSM(i1) 
ML2 = MAh(i2) 
ML3 = MHp(i3) 
coup1 = cplAhAhHhSM(gt1,i2,i1)
coup2 = cplHhSMHpcHp(i1,i3,gt2)
coup3 = cplAhHpcHp(i2,gt3,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {HhSM, VZ, Hp}
Do i1=1,3
    Do i3=1,3
ML1 = MHhSM(i1) 
ML2 = MVZ 
ML3 = MHp(i3) 
coup1 = -cplAhHhSMVZ(gt1,i1)
coup2 = cplHhSMHpcHp(i1,i3,gt2)
coup3 = cplHpcHpVZ(gt3,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {HhSM, Ah, VWp}
Do i1=1,3
  Do i2=1,3
ML1 = MHhSM(i1) 
ML2 = MAh(i2) 
ML3 = MVWp 
coup1 = cplAhAhHhSM(gt1,i2,i1)
coup2 = cplHhSMcHpVWp(i1,gt2)
coup3 = -cplAhHpcVWp(i2,gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {HhSM, VZ, VWp}
Do i1=1,3
ML1 = MHhSM(i1) 
ML2 = MVZ 
ML3 = MVWp 
coup1 = -cplAhHhSMVZ(gt1,i1)
coup2 = cplHhSMcHpVWp(i1,gt2)
coup3 = cplHpcVWpVZ(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
End Do


! {siga, hha, Hap}
ML1 = Msiga 
ML2 = Mhha 
ML3 = MHap 
coup1 = cplAhhhasiga(gt1)
coup2 = cplHapsigacHp(gt2)
coup3 = cplhhaHpcHap(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {VZ, HhSM, Hp}
  Do i2=1,3
    Do i3=1,3
ML1 = MVZ 
ML2 = MHhSM(i2) 
ML3 = MHp(i3) 
coup1 = -cplAhHhSMVZ(gt1,i2)
coup2 = cplHpcHpVZ(i3,gt2)
coup3 = cplHhSMHpcHp(i2,gt3,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VZ, HhSM, VWp}
  Do i2=1,3
ML1 = MVZ 
ML2 = MHhSM(i2) 
ML3 = MVWp 
coup1 = -cplAhHhSMVZ(gt1,i2)
coup2 = cplcHpVWpVZ(gt2)
coup3 = -cplHhSMHpcVWp(i2,gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do


! {bar[Fu], bar[Fu], bar[Fd]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFu(i1) 
ML2 = MFu(i2) 
ML3 = MFd(i3) 
coup1L = cplcFuFuAhL(i1,i2,gt1)
coup1R = cplcFuFuAhR(i1,i2,gt1)
coup2L = cplcFdFucHpL(i3,i1,gt2)
coup2R = cplcFdFucHpR(i3,i1,gt2)
coup3L = cplcFuFdHpL(i2,i3,gt3)
coup3R = cplcFuFdHpR(i2,i3,gt3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(3)*AmpC 
    End Do
  End Do
End Do


! {bar[gWp], bar[gWp], bar[gZ]}
ML1 = MVWp 
ML2 = MVWp 
ML3 = MVZ 
coup1 = cplcgWpgWpAh(gt1)
coup2 = cplcgZgWpcHp(gt2)
coup3 = cplcgWpgZHp(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {conj[Hp], conj[Hp], Ah}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MAh(i3) 
coup1 = cplAhHpcHp(gt1,i2,i1)
coup2 = cplAhHpcHp(i3,i1,gt2)
coup3 = cplAhHpcHp(i3,gt3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {conj[Hp], conj[VWp], Ah}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MAh(i3) 
coup1 = -cplAhcHpVWp(gt1,i1)
coup2 = cplAhHpcHp(i3,i1,gt2)
coup3 = -cplAhHpcVWp(i3,gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {conj[Hp], conj[Hp], HhSM}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MHhSM(i3) 
coup1 = cplAhHpcHp(gt1,i2,i1)
coup2 = cplHhSMHpcHp(i3,i1,gt2)
coup3 = cplHhSMHpcHp(i3,gt3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {conj[Hp], conj[VWp], HhSM}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MHhSM(i3) 
coup1 = -cplAhcHpVWp(gt1,i1)
coup2 = cplHhSMHpcHp(i3,i1,gt2)
coup3 = -cplHhSMHpcVWp(i3,gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {conj[Hp], conj[Hp], VP}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MVP 
coup1 = cplAhHpcHp(gt1,i2,i1)
coup2 = cplHpcHpVP(i1,gt2)
coup3 = cplHpcHpVP(gt3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {conj[Hp], conj[VWp], VP}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MVP 
coup1 = -cplAhcHpVWp(gt1,i1)
coup2 = cplHpcHpVP(i1,gt2)
coup3 = cplHpcVWpVP(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
End Do


! {conj[Hp], conj[Hp], VZ}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MVZ 
coup1 = cplAhHpcHp(gt1,i2,i1)
coup2 = cplHpcHpVZ(i1,gt2)
coup3 = cplHpcHpVZ(gt3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {conj[Hp], conj[VWp], VZ}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MVZ 
coup1 = -cplAhcHpVWp(gt1,i1)
coup2 = cplHpcHpVZ(i1,gt2)
coup3 = cplHpcVWpVZ(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
End Do


! {conj[VWp], conj[Hp], Ah}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MAh(i3) 
coup1 = -cplAhHpcVWp(gt1,i2)
coup2 = cplAhcHpVWp(i3,gt2)
coup3 = cplAhHpcHp(i3,gt3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {conj[VWp], conj[Hp], HhSM}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MHhSM(i3) 
coup1 = -cplAhHpcVWp(gt1,i2)
coup2 = cplHhSMcHpVWp(i3,gt2)
coup3 = cplHhSMHpcHp(i3,gt3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {conj[VWp], conj[Hp], VP}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MVP 
coup1 = -cplAhHpcVWp(gt1,i2)
coup2 = cplcHpVPVWp(gt2)
coup3 = cplHpcHpVP(gt3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do


! {conj[VWp], conj[Hp], VZ}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MVZ 
coup1 = -cplAhHpcVWp(gt1,i2)
coup2 = cplcHpVWpVZ(gt2)
coup3 = cplHpcHpVZ(gt3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do


! {Ah, HhSM}
Do i1=1,3
  Do i2=1,3
ML1 = MAh(i1) 
ML2 = MHhSM(i2) 
coup1 = cplAhAhHhSM(gt1,i1,i2)
coup2 = cplAhHhSMHpcHp1(i1,i2,gt3,gt2)
Call Amp_VERTEX_StoSS_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, Hp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplHpHpcHpcHp1(gt3,i2,gt2,i1)
Call Amp_VERTEX_StoSS_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Ah, Hp}
Do i1=1,3
  Do i2=1,3
ML1 = MAh(i1) 
ML2 = MHp(i2) 
coup1 = cplAhAhHpcHp1(gt1,i1,gt3,i2)
coup2 = cplAhHpcHp(i1,i2,gt2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 

  End Do
End Do


! {hha, Hap}
ML1 = Mhha 
ML2 = MHap 
coup1 = cplAhhhaHpcHap1(gt1,gt3)
coup2 = cplHaphhacHp(gt2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 



! {HhSM, Hp}
Do i1=1,3
  Do i2=1,3
ML1 = MHhSM(i1) 
ML2 = MHp(i2) 
coup1 = cplAhHhSMHpcHp1(gt1,i1,gt3,i2)
coup2 = cplHhSMHpcHp(i1,i2,gt2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 

  End Do
End Do


! {siga, Hap}
ML1 = Msiga 
ML2 = MHap 
coup1 = cplAhHpsigacHap1(gt1,gt3)
coup2 = cplHapsigacHp(gt2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 



! {VP, VWp}
ML1 = MVP 
ML2 = MVWp 
coup1 = cplAhHpcVWpVP1(gt1,gt3)
coup2 = cplcHpVPVWp(gt2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 



! {VZ, VWp}
ML1 = MVZ 
ML2 = MVWp 
coup1 = cplAhHpcVWpVZ1(gt1,gt3)
coup2 = cplcHpVWpVZ(gt2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 



! {Ah, conj[Hp]}
Do i1=1,3
  Do i2=1,3
ML1 = MAh(i1) 
ML2 = MHp(i2) 
coup1 = cplAhAhHpcHp1(gt1,i1,i2,gt2)
coup2 = cplAhHpcHp(i1,gt3,i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 

  End Do
End Do


! {Hap, hha}
ML1 = MHap 
ML2 = Mhha 
coup1 = cplAhHaphhacHp1(gt1,gt2)
coup2 = cplhhaHpcHap(gt3)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 



! {Hap, siga}
ML1 = MHap 
ML2 = Msiga 
coup1 = cplAhHapsigacHp1(gt1,gt2)
coup2 = cplHpsigacHap(gt3)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 



! {HhSM, conj[Hp]}
Do i1=1,3
  Do i2=1,3
ML1 = MHhSM(i1) 
ML2 = MHp(i2) 
coup1 = cplAhHhSMHpcHp1(gt1,i1,i2,gt2)
coup2 = cplHhSMHpcHp(i1,gt3,i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 

  End Do
End Do


! {VP, conj[VWp]}
ML1 = MVP 
ML2 = MVWp 
coup1 = cplAhcHpVPVWp1(gt1,gt2)
coup2 = cplHpcVWpVP(gt3)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 



! {VWp, VZ}
ML1 = MVWp 
ML2 = MVZ 
coup1 = cplAhcHpVWpVZ1(gt1,gt2)
coup2 = cplHpcVWpVZ(gt3)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 

    End Do
  End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_AhTocHpHp


Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhTocHpHp(MAh,MFd,MFe,MFu,MHap,Mhha,           & 
& MHhSM,MHp,Msiga,MVP,MVWp,MVZ,MAh2,MFd2,MFe2,MFu2,MHap2,Mhha2,MHhSM2,MHp2,              & 
& Msiga2,MVP2,MVWp2,MVZ2,cplAhAhHhSM,cplcFdFdAhL,cplcFdFdAhR,cplcFeFeAhL,cplcFeFeAhR,    & 
& cplcFuFuAhL,cplcFuFuAhR,cplcgWpgWpAh,cplcgWCgWCAh,cplAhhhasiga,cplAhHhSMVZ,            & 
& cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplcFuFdHpL,cplcFuFdHpR,cplcFvFeHpL,cplcFvFeHpR,    & 
& cplcFdFucHpL,cplcFdFucHpR,cplcFeFvcHpL,cplcFeFvcHpR,cplcgZgWpcHp,cplcgZgWCHp,          & 
& cplcgWpgZHp,cplcgWCgZcHp,cplHaphhacHp,cplHapsigacHp,cplhhaHpcHap,cplHhSMHpcHp,         & 
& cplHhSMHpcVWp,cplHhSMcHpVWp,cplHpsigacHap,cplHpcHpVP,cplHpcVWpVP,cplHpcHpVZ,           & 
& cplHpcVWpVZ,cplcHpVPVWp,cplcHpVWpVZ,cplAhAhHpcHp1,cplAhHaphhacHp1,cplAhHapsigacHp1,    & 
& cplAhhhaHpcHap1,cplAhHhSMHpcHp1,cplAhHpsigacHap1,cplAhHpcVWpVP1,cplAhHpcVWpVZ1,        & 
& cplAhcHpVPVWp1,cplAhcHpVWpVZ1,cplHpHpcHpcHp1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHap,Mhha,MHhSM(3),MHp(3),Msiga,MVP,MVWp,MVZ,             & 
& MAh2(3),MFd2(3),MFe2(3),MFu2(3),MHap2,Mhha2,MHhSM2(3),MHp2(3),Msiga2,MVP2,             & 
& MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhAhHhSM(3,3,3),cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFeFeAhL(3,3,3),          & 
& cplcFeFeAhR(3,3,3),cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcgWpgWpAh(3),              & 
& cplcgWCgWCAh(3),cplAhhhasiga(3),cplAhHhSMVZ(3,3),cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),   & 
& cplAhcHpVWp(3,3),cplcFuFdHpL(3,3,3),cplcFuFdHpR(3,3,3),cplcFvFeHpL(3,3,3),             & 
& cplcFvFeHpR(3,3,3),cplcFdFucHpL(3,3,3),cplcFdFucHpR(3,3,3),cplcFeFvcHpL(3,3,3),        & 
& cplcFeFvcHpR(3,3,3),cplcgZgWpcHp(3),cplcgZgWCHp(3),cplcgWpgZHp(3),cplcgWCgZcHp(3),     & 
& cplHaphhacHp(3),cplHapsigacHp(3),cplhhaHpcHap(3),cplHhSMHpcHp(3,3,3),cplHhSMHpcVWp(3,3),& 
& cplHhSMcHpVWp(3,3),cplHpsigacHap(3),cplHpcHpVP(3,3),cplHpcVWpVP(3),cplHpcHpVZ(3,3),    & 
& cplHpcVWpVZ(3),cplcHpVPVWp(3),cplcHpVWpVZ(3),cplAhAhHpcHp1(3,3,3,3),cplAhHaphhacHp1(3,3),& 
& cplAhHapsigacHp1(3,3),cplAhhhaHpcHap1(3,3),cplAhHhSMHpcHp1(3,3,3,3),cplAhHpsigacHap1(3,3),& 
& cplAhHpcVWpVP1(3,3),cplAhHpcVWpVZ1(3,3),cplAhcHpVPVWp1(3,3),cplAhcHpVWpVZ1(3,3),       & 
& cplHpHpcHpcHp1(3,3,3,3)

Complex(dp), Intent(out) :: Amp(3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
Amp(gt1, gt2, gt3) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MHp(gt2) 
Mex3 = MHp(gt3) 


! {conj[Hp], conj[Hp], VP}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MVP 
coup1 = cplAhHpcHp(gt1,i2,i1)
coup2 = cplHpcHpVP(i1,gt2)
coup3 = cplHpcHpVP(gt3,i2)
Call Amp_VERTEX_StoSS_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {conj[Hp], conj[VWp], VP}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MVP 
coup1 = -cplAhcHpVWp(gt1,i1)
coup2 = cplHpcHpVP(i1,gt2)
coup3 = cplHpcVWpVP(gt3)
Call Amp_VERTEX_StoSS_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
End Do


! {conj[VWp], conj[Hp], VP}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MVP 
coup1 = -cplAhHpcVWp(gt1,i2)
coup2 = cplcHpVPVWp(gt2)
coup3 = cplHpcHpVP(gt3,i2)
Call Amp_VERTEX_StoSS_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do


! {VP, VWp}
ML1 = MVP 
ML2 = MVWp 
coup1 = cplAhHpcVWpVP1(gt1,gt3)
coup2 = cplcHpVPVWp(gt2)
Call Amp_VERTEX_StoSS_Topology3_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 



! {VP, conj[VWp]}
ML1 = MVP 
ML2 = MVWp 
coup1 = cplAhcHpVPVWp1(gt1,gt2)
coup2 = cplHpcVWpVP(gt3)
Call Amp_VERTEX_StoSS_Topology4_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 

    End Do
  End Do
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhTocHpHp


Subroutine Amplitude_Tree_4HDM_S3_AhToHpcVWp(cplAhHpcVWp,MAh,MHp,MVWp,MAh2,           & 
& MHp2,MVWp2,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MHp(3),MVWp,MAh2(3),MHp2(3),MVWp2

Complex(dp), Intent(in) :: cplAhHpcVWp(3,3)

Complex(dp) :: Amp(2,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 

Do gt1=1,3
  Do gt2=1,3
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MHp(gt2) 
Mex3 = MVWp 
! Tree-Level Vertex 
coupT1 = cplAhHpcVWp(gt1,gt2)
Call TreeAmp_StoSV(Mex1,Mex2,Mex3,coupT1,AmpC) 
! Colour and symmetry factor 
Amp(:,gt1, gt2) = AmpC 
  End Do
End Do
End Subroutine Amplitude_Tree_4HDM_S3_AhToHpcVWp


Subroutine Gamma_Real_4HDM_S3_AhToHpcVWp(MLambda,em,gs,cplAhHpcVWp,MAh,               & 
& MHp,MVWp,GammarealPhoton,GammarealGluon)

Implicit None

Complex(dp), Intent(in) :: cplAhHpcVWp(3,3)

Real(dp), Intent(in) :: MAh(3),MHp(3),MVWp

Real(dp), Intent(in) :: MLambda, em, gs 

Real(dp), Intent(out) :: GammarealPhoton(3,3), GammarealGluon(3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3, kont 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 

Real(dp) :: Mloop1, Mloop2, Mloop3 
Complex(dp) :: Coup 
 
Do i1=2,3
  Do i2=2,3
Coup = cplAhHpcVWp(i1,i2)
Mex1 = MAh(i1)
Mex2 = MHp(i2)
Mex3 = MVWp
If (Mex1.gt.(Mex2+Mex3)) Then 
 Call hardradiationSSV(Mex1,Mex2,Mex3,MLambda,em,0._dp,1._dp,-1._dp,Coup,Gammarealphoton(i1,i2),kont)
 GammarealGluon(i1,i2) = 0._dp 
Else 
  GammarealGluon(i1,i2) = 0._dp 
  GammarealPhoton(i1,i2) = 0._dp 

End if 
  End Do
End Do
End Subroutine Gamma_Real_4HDM_S3_AhToHpcVWp


Subroutine Amplitude_WAVE_4HDM_S3_AhToHpcVWp(cplAhHpcVWp,ctcplAhHpcVWp,               & 
& MAh,MAh2,MHp,MHp2,MVWp,MVWp2,ZfAh,ZfHp,ZfVWp,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MAh2(3),MHp(3),MHp2(3),MVWp,MVWp2

Complex(dp), Intent(in) :: cplAhHpcVWp(3,3)

Complex(dp), Intent(in) :: ctcplAhHpcVWp(3,3)

Complex(dp), Intent(in) :: ZfAh(3,3),ZfHp(3,3),ZfVWp

Complex(dp), Intent(out) :: Amp(2,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
  Do gt2=1,3
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MHp(gt2) 
Mex3 = MVWp 
!----------------------------- 
! Coupling counter term 
!----------------------------- 
ZcoupT1 = ctcplAhHpcVWp(gt1,gt2) 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
Do i1=1,3
ZcoupT1 = ZcoupT1 + 0.5_dp*ZfAh(i1,gt1)*cplAhHpcVWp(i1,gt2)
End Do


! External Field 2 
Do i1=1,3
ZcoupT1 = ZcoupT1 + 0.5_dp*ZfHp(i1,gt2)*cplAhHpcVWp(gt1,i1)
End Do


! External Field 3 
ZcoupT1 = ZcoupT1 + 0.5_dp*ZfVWp*cplAhHpcVWp(gt1,gt2)


! Getting the amplitude 
Call TreeAmp_StoSV(Mex1,Mex2,Mex3,ZcoupT1,AmpC) 
Amp(:,gt1, gt2) = AmpC 
  End Do
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_AhToHpcVWp


Subroutine Amplitude_VERTEX_4HDM_S3_AhToHpcVWp(MAh,MFd,MFe,MFu,MHap,Mhha,             & 
& MHhSM,MHp,Msiga,MVP,MVWp,MVZ,MAh2,MFd2,MFe2,MFu2,MHap2,Mhha2,MHhSM2,MHp2,              & 
& Msiga2,MVP2,MVWp2,MVZ2,cplAhAhHhSM,cplcFdFdAhL,cplcFdFdAhR,cplcFeFeAhL,cplcFeFeAhR,    & 
& cplcFuFuAhL,cplcFuFuAhR,cplcgWpgWpAh,cplcgWCgWCAh,cplAhhhasiga,cplAhHhSMVZ,            & 
& cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplcFuFdHpL,cplcFuFdHpR,cplcFvFeHpL,cplcFvFeHpR,    & 
& cplcFdFucVWpL,cplcFdFucVWpR,cplcFeFvcVWpL,cplcFeFvcVWpR,cplcgWpgAHp,cplcgAgWpcVWp,     & 
& cplcgZgWpcVWp,cplcgZgWCHp,cplcgWpgZHp,cplcgWCgZcVWp,cplHaphhacVWp,cplHapsigacVWp,      & 
& cplhhaHpcHap,cplHhSMHpcHp,cplHhSMHpcVWp,cplHhSMcVWpVWp,cplHpsigacHap,cplHpcHpVP,       & 
& cplHpcVWpVP,cplHpcHpVZ,cplHpcVWpVZ,cplcVWpVPVWp,cplcVWpVWpVZ,cplAhAhcVWpVWp1,          & 
& cplAhHpcVWpVP1,cplAhHpcVWpVZ1,cplHhSMHpcVWpVZ1,cplHpcHpcVWpVWp1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHap,Mhha,MHhSM(3),MHp(3),Msiga,MVP,MVWp,MVZ,             & 
& MAh2(3),MFd2(3),MFe2(3),MFu2(3),MHap2,Mhha2,MHhSM2(3),MHp2(3),Msiga2,MVP2,             & 
& MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhAhHhSM(3,3,3),cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFeFeAhL(3,3,3),          & 
& cplcFeFeAhR(3,3,3),cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcgWpgWpAh(3),              & 
& cplcgWCgWCAh(3),cplAhhhasiga(3),cplAhHhSMVZ(3,3),cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),   & 
& cplAhcHpVWp(3,3),cplcFuFdHpL(3,3,3),cplcFuFdHpR(3,3,3),cplcFvFeHpL(3,3,3),             & 
& cplcFvFeHpR(3,3,3),cplcFdFucVWpL(3,3),cplcFdFucVWpR(3,3),cplcFeFvcVWpL(3,3),           & 
& cplcFeFvcVWpR(3,3),cplcgWpgAHp(3),cplcgAgWpcVWp,cplcgZgWpcVWp,cplcgZgWCHp(3),          & 
& cplcgWpgZHp(3),cplcgWCgZcVWp,cplHaphhacVWp,cplHapsigacVWp,cplhhaHpcHap(3),             & 
& cplHhSMHpcHp(3,3,3),cplHhSMHpcVWp(3,3),cplHhSMcVWpVWp(3),cplHpsigacHap(3),             & 
& cplHpcHpVP(3,3),cplHpcVWpVP(3),cplHpcHpVZ(3,3),cplHpcVWpVZ(3),cplcVWpVPVWp,            & 
& cplcVWpVWpVZ,cplAhAhcVWpVWp1(3,3),cplAhHpcVWpVP1(3,3),cplAhHpcVWpVZ1(3,3),             & 
& cplHhSMHpcVWpVZ1(3,3),cplHpcHpcVWpVWp1(3,3)

Complex(dp), Intent(out) :: Amp(2,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
Amp(:,gt1, gt2) = 0._dp 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MHp(gt2) 
Mex3 = MVWp 


! {Ah, HhSM, conj[Hp]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MAh(i1) 
ML2 = MHhSM(i2) 
ML3 = MHp(i3) 
coup1 = cplAhAhHhSM(gt1,i1,i2)
coup2 = cplAhHpcHp(i1,gt2,i3)
coup3 = -cplHhSMHpcVWp(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Ah, HhSM, conj[VWp]}
Do i1=1,3
  Do i2=1,3
ML1 = MAh(i1) 
ML2 = MHhSM(i2) 
ML3 = MVWp 
coup1 = cplAhAhHhSM(gt1,i1,i2)
coup2 = -cplAhHpcVWp(i1,gt2)
coup3 = cplHhSMcVWpVWp(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Fu, Fu, Fd}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFu(i1) 
ML2 = MFu(i2) 
ML3 = MFd(i3) 
coup1L = cplcFuFuAhL(i2,i1,gt1)
coup1R = cplcFuFuAhR(i2,i1,gt1)
coup2L = cplcFuFdHpL(i1,i3,gt2)
coup2R = cplcFuFdHpR(i1,i3,gt2)
coup3L = -cplcFdFucVWpR(i3,i2)
coup3R = -cplcFdFucVWpL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(3)*AmpC 
    End Do
  End Do
End Do


! {gWp, gWp, gP}
ML1 = MVWp 
ML2 = MVWp 
ML3 = MVP 
coup1 = cplcgWpgWpAh(gt1)
coup2 = cplcgWpgAHp(gt2)
coup3 = cplcgAgWpcVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {gWp, gWp, gZ}
ML1 = MVWp 
ML2 = MVWp 
ML3 = MVZ 
coup1 = cplcgWpgWpAh(gt1)
coup2 = cplcgWpgZHp(gt2)
coup3 = cplcgZgWpcVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {hha, siga, conj[Hap]}
ML1 = Mhha 
ML2 = Msiga 
ML3 = MHap 
coup1 = cplAhhhasiga(gt1)
coup2 = cplhhaHpcHap(gt2)
coup3 = cplHapsigacVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {HhSM, Ah, conj[Hp]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHhSM(i1) 
ML2 = MAh(i2) 
ML3 = MHp(i3) 
coup1 = cplAhAhHhSM(gt1,i2,i1)
coup2 = cplHhSMHpcHp(i1,gt2,i3)
coup3 = -cplAhHpcVWp(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {HhSM, VZ, conj[Hp]}
Do i1=1,3
    Do i3=1,3
ML1 = MHhSM(i1) 
ML2 = MVZ 
ML3 = MHp(i3) 
coup1 = -cplAhHhSMVZ(gt1,i1)
coup2 = cplHhSMHpcHp(i1,gt2,i3)
coup3 = cplHpcVWpVZ(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {HhSM, VZ, conj[VWp]}
Do i1=1,3
ML1 = MHhSM(i1) 
ML2 = MVZ 
ML3 = MVWp 
coup1 = -cplAhHhSMVZ(gt1,i1)
coup2 = -cplHhSMHpcVWp(i1,gt2)
coup3 = -cplcVWpVWpVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {Hp, Hp, Ah}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MAh(i3) 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplAhHpcHp(i3,gt2,i1)
coup3 = cplAhHpcVWp(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Hp, Hp, HhSM}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MHhSM(i3) 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplHhSMHpcHp(i3,gt2,i1)
coup3 = cplHhSMHpcVWp(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Hp, VWp, HhSM}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MHhSM(i3) 
coup1 = -cplAhHpcVWp(gt1,i1)
coup2 = cplHhSMHpcHp(i3,gt2,i1)
coup3 = cplHhSMcVWpVWp(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, Hp, VP}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MVP 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplHpcHpVP(gt2,i1)
coup3 = cplHpcVWpVP(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, VWp, VP}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MVP 
coup1 = -cplAhHpcVWp(gt1,i1)
coup2 = cplHpcHpVP(gt2,i1)
coup3 = -cplcVWpVPVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {Hp, Hp, VZ}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MVZ 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplHpcHpVZ(gt2,i1)
coup3 = cplHpcVWpVZ(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, VWp, VZ}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MVZ 
coup1 = -cplAhHpcVWp(gt1,i1)
coup2 = cplHpcHpVZ(gt2,i1)
coup3 = cplcVWpVWpVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {siga, hha, conj[Hap]}
ML1 = Msiga 
ML2 = Mhha 
ML3 = MHap 
coup1 = cplAhhhasiga(gt1)
coup2 = cplHpsigacHap(gt2)
coup3 = cplHaphhacVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {VWp, Hp, Ah}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MAh(i3) 
coup1 = -cplAhcHpVWp(gt1,i2)
coup2 = -cplAhHpcVWp(i3,gt2)
coup3 = cplAhHpcVWp(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VWp, Hp, HhSM}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MHhSM(i3) 
coup1 = -cplAhcHpVWp(gt1,i2)
coup2 = -cplHhSMHpcVWp(i3,gt2)
coup3 = cplHhSMHpcVWp(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VWp, Hp, VP}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MVP 
coup1 = -cplAhcHpVWp(gt1,i2)
coup2 = cplHpcVWpVP(gt2)
coup3 = cplHpcVWpVP(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do


! {VWp, Hp, VZ}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MVZ 
coup1 = -cplAhcHpVWp(gt1,i2)
coup2 = cplHpcVWpVZ(gt2)
coup3 = cplHpcVWpVZ(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do


! {VZ, HhSM, conj[Hp]}
  Do i2=1,3
    Do i3=1,3
ML1 = MVZ 
ML2 = MHhSM(i2) 
ML3 = MHp(i3) 
coup1 = -cplAhHhSMVZ(gt1,i2)
coup2 = cplHpcHpVZ(gt2,i3)
coup3 = -cplHhSMHpcVWp(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VZ, HhSM, conj[VWp]}
  Do i2=1,3
ML1 = MVZ 
ML2 = MHhSM(i2) 
ML3 = MVWp 
coup1 = -cplAhHhSMVZ(gt1,i2)
coup2 = cplHpcVWpVZ(gt2)
coup3 = cplHhSMcVWpVWp(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do


! {bar[Fd], bar[Fd], bar[Fu]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFd(i1) 
ML2 = MFd(i2) 
ML3 = MFu(i3) 
coup1L = cplcFdFdAhL(i1,i2,gt1)
coup1R = cplcFdFdAhR(i1,i2,gt1)
coup2L = cplcFuFdHpL(i3,i1,gt2)
coup2R = cplcFuFdHpR(i3,i1,gt2)
coup3L = cplcFdFucVWpL(i2,i3)
coup3R = cplcFdFucVWpR(i2,i3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(3)*AmpC 
    End Do
  End Do
End Do


! {bar[Fe], bar[Fe], bar[Fv]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFe(i1) 
ML2 = MFe(i2) 
ML3 = 0. 
coup1L = cplcFeFeAhL(i1,i2,gt1)
coup1R = cplcFeFeAhR(i1,i2,gt1)
coup2L = cplcFvFeHpL(i3,i1,gt2)
coup2R = cplcFvFeHpR(i3,i1,gt2)
coup3L = cplcFeFvcVWpL(i2,i3)
coup3R = cplcFeFvcVWpR(i2,i3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {bar[gWpC], bar[gWpC], bar[gZ]}
ML1 = MVWp 
ML2 = MVWp 
ML3 = MVZ 
coup1 = cplcgWCgWCAh(gt1)
coup2 = cplcgZgWCHp(gt2)
coup3 = cplcgWCgZcVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {HhSM, VZ}
Do i1=1,3
ML1 = MHhSM(i1) 
ML2 = MVZ 
coup1 = cplAhHhSMVZ(gt1,i1)
coup2 = cplHhSMHpcVWpVZ1(i1,gt2)
Call Amp_VERTEX_StoSV_Topology2_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {Hp, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
coup1 = cplAhHpcVWp(gt1,i1)
coup2 = cplHpcHpcVWpVWp1(gt2,i1)
Call Amp_VERTEX_StoSV_Topology2_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {Ah, conj[VWp]}
Do i1=1,3
ML1 = MAh(i1) 
ML2 = MVWp 
coup1 = cplAhAhcVWpVWp1(gt1,i1)
coup2 = -cplAhHpcVWp(i1,gt2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology3_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 

End Do


! {Hp, VP}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVP 
coup1 = cplAhHpcVWpVP1(gt1,i1)
coup2 = cplHpcHpVP(gt2,i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology3_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 

End Do


! {Hp, VZ}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVZ 
coup1 = cplAhHpcVWpVZ1(gt1,i1)
coup2 = cplHpcHpVZ(gt2,i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology3_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 

End Do
  End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_AhToHpcVWp


Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhToHpcVWp(MAh,MFd,MFe,MFu,MHap,               & 
& Mhha,MHhSM,MHp,Msiga,MVP,MVWp,MVZ,MAh2,MFd2,MFe2,MFu2,MHap2,Mhha2,MHhSM2,              & 
& MHp2,Msiga2,MVP2,MVWp2,MVZ2,cplAhAhHhSM,cplcFdFdAhL,cplcFdFdAhR,cplcFeFeAhL,           & 
& cplcFeFeAhR,cplcFuFuAhL,cplcFuFuAhR,cplcgWpgWpAh,cplcgWCgWCAh,cplAhhhasiga,            & 
& cplAhHhSMVZ,cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplcFuFdHpL,cplcFuFdHpR,cplcFvFeHpL,    & 
& cplcFvFeHpR,cplcFdFucVWpL,cplcFdFucVWpR,cplcFeFvcVWpL,cplcFeFvcVWpR,cplcgWpgAHp,       & 
& cplcgAgWpcVWp,cplcgZgWpcVWp,cplcgZgWCHp,cplcgWpgZHp,cplcgWCgZcVWp,cplHaphhacVWp,       & 
& cplHapsigacVWp,cplhhaHpcHap,cplHhSMHpcHp,cplHhSMHpcVWp,cplHhSMcVWpVWp,cplHpsigacHap,   & 
& cplHpcHpVP,cplHpcVWpVP,cplHpcHpVZ,cplHpcVWpVZ,cplcVWpVPVWp,cplcVWpVWpVZ,               & 
& cplAhAhcVWpVWp1,cplAhHpcVWpVP1,cplAhHpcVWpVZ1,cplHhSMHpcVWpVZ1,cplHpcHpcVWpVWp1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHap,Mhha,MHhSM(3),MHp(3),Msiga,MVP,MVWp,MVZ,             & 
& MAh2(3),MFd2(3),MFe2(3),MFu2(3),MHap2,Mhha2,MHhSM2(3),MHp2(3),Msiga2,MVP2,             & 
& MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhAhHhSM(3,3,3),cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFeFeAhL(3,3,3),          & 
& cplcFeFeAhR(3,3,3),cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcgWpgWpAh(3),              & 
& cplcgWCgWCAh(3),cplAhhhasiga(3),cplAhHhSMVZ(3,3),cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),   & 
& cplAhcHpVWp(3,3),cplcFuFdHpL(3,3,3),cplcFuFdHpR(3,3,3),cplcFvFeHpL(3,3,3),             & 
& cplcFvFeHpR(3,3,3),cplcFdFucVWpL(3,3),cplcFdFucVWpR(3,3),cplcFeFvcVWpL(3,3),           & 
& cplcFeFvcVWpR(3,3),cplcgWpgAHp(3),cplcgAgWpcVWp,cplcgZgWpcVWp,cplcgZgWCHp(3),          & 
& cplcgWpgZHp(3),cplcgWCgZcVWp,cplHaphhacVWp,cplHapsigacVWp,cplhhaHpcHap(3),             & 
& cplHhSMHpcHp(3,3,3),cplHhSMHpcVWp(3,3),cplHhSMcVWpVWp(3),cplHpsigacHap(3),             & 
& cplHpcHpVP(3,3),cplHpcVWpVP(3),cplHpcHpVZ(3,3),cplHpcVWpVZ(3),cplcVWpVPVWp,            & 
& cplcVWpVWpVZ,cplAhAhcVWpVWp1(3,3),cplAhHpcVWpVP1(3,3),cplAhHpcVWpVZ1(3,3),             & 
& cplHhSMHpcVWpVZ1(3,3),cplHpcHpcVWpVWp1(3,3)

Complex(dp), Intent(out) :: Amp(2,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
Amp(:,gt1, gt2) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MHp(gt2) 
Mex3 = MVWp 


! {Hp, Hp, VP}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MVP 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplHpcHpVP(gt2,i1)
coup3 = cplHpcVWpVP(i2)
Call Amp_VERTEX_StoSV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, VWp, VP}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MVP 
coup1 = -cplAhHpcVWp(gt1,i1)
coup2 = cplHpcHpVP(gt2,i1)
coup3 = -cplcVWpVPVWp
Call Amp_VERTEX_StoSV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {VWp, Hp, VP}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MVP 
coup1 = -cplAhcHpVWp(gt1,i2)
coup2 = cplHpcVWpVP(gt2)
coup3 = cplHpcVWpVP(i2)
Call Amp_VERTEX_StoSV_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do


! {Hp, VP}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVP 
coup1 = cplAhHpcVWpVP1(gt1,i1)
coup2 = cplHpcHpVP(gt2,i1)
Call Amp_VERTEX_StoSV_Topology3_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 

End Do
  End Do
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhToHpcVWp


Subroutine Amplitude_WAVE_4HDM_S3_AhToAhAh(MAh,MAh2,ZfAh,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MAh2(3)

Complex(dp), Intent(in) :: ZfAh(3,3)

Complex(dp), Intent(out) :: Amp(3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MAh(gt2) 
Mex3 = MAh(gt3) 
ZcoupT1 = 0._dp 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
! Vanishing 


! External Field 2 
! Vanishing 


! External Field 3 
! Vanishing 
Amp(gt1, gt2, gt3) = 0._dp
    End Do
  End Do
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_AhToAhAh


Subroutine Amplitude_VERTEX_4HDM_S3_AhToAhAh(MAh,MFd,MFe,MFu,MHp,MVWp,MAh2,           & 
& MFd2,MFe2,MFu2,MHp2,MVWp2,cplcFdFdAhL,cplcFdFdAhR,cplcFeFeAhL,cplcFeFeAhR,             & 
& cplcFuFuAhL,cplcFuFuAhR,cplcgWpgWpAh,cplcgWCgWCAh,cplAhHpcHp,cplAhHpcVWp,              & 
& cplAhcHpVWp,cplAhAhHpcHp1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHp(3),MVWp,MAh2(3),MFd2(3),MFe2(3),MFu2(3),              & 
& MHp2(3),MVWp2

Complex(dp), Intent(in) :: cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFeFeAhL(3,3,3),cplcFeFeAhR(3,3,3),          & 
& cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcgWpgWpAh(3),cplcgWCgWCAh(3),cplAhHpcHp(3,3,3),& 
& cplAhHpcVWp(3,3),cplAhcHpVWp(3,3),cplAhAhHpcHp1(3,3,3,3)

Complex(dp), Intent(out) :: Amp(3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
Amp(gt1, gt2, gt3) = 0._dp 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MAh(gt2) 
Mex3 = MAh(gt3) 


! {Fd, Fd, Fd}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFd(i1) 
ML2 = MFd(i2) 
ML3 = MFd(i3) 
coup1L = cplcFdFdAhL(i2,i1,gt1)
coup1R = cplcFdFdAhR(i2,i1,gt1)
coup2L = cplcFdFdAhL(i1,i3,gt2)
coup2R = cplcFdFdAhR(i1,i3,gt2)
coup3L = cplcFdFdAhL(i3,i2,gt3)
coup3R = cplcFdFdAhR(i3,i2,gt3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(6)*AmpC 
    End Do
  End Do
End Do


! {Fe, Fe, Fe}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFe(i1) 
ML2 = MFe(i2) 
ML3 = MFe(i3) 
coup1L = cplcFeFeAhL(i2,i1,gt1)
coup1R = cplcFeFeAhR(i2,i1,gt1)
coup2L = cplcFeFeAhL(i1,i3,gt2)
coup2R = cplcFeFeAhR(i1,i3,gt2)
coup3L = cplcFeFeAhL(i3,i2,gt3)
coup3R = cplcFeFeAhR(i3,i2,gt3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(2)*AmpC 
    End Do
  End Do
End Do


! {Fu, Fu, Fu}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFu(i1) 
ML2 = MFu(i2) 
ML3 = MFu(i3) 
coup1L = cplcFuFuAhL(i2,i1,gt1)
coup1R = cplcFuFuAhR(i2,i1,gt1)
coup2L = cplcFuFuAhL(i1,i3,gt2)
coup2R = cplcFuFuAhR(i1,i3,gt2)
coup3L = cplcFuFuAhL(i3,i2,gt3)
coup3R = cplcFuFuAhR(i3,i2,gt3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(6)*AmpC 
    End Do
  End Do
End Do


! {gWp, gWp, gWp}
ML1 = MVWp 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcgWpgWpAh(gt1)
coup2 = cplcgWpgWpAh(gt2)
coup3 = cplcgWpgWpAh(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(2)*AmpC 


! {gWpC, gWpC, gWpC}
ML1 = MVWp 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcgWCgWCAh(gt1)
coup2 = cplcgWCgWCAh(gt2)
coup3 = cplcgWCgWCAh(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(2)*AmpC 


! {Hp, Hp, Hp}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplAhHpcHp(gt2,i3,i1)
coup3 = cplAhHpcHp(gt3,i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(2)*AmpC 
    End Do
  End Do
End Do


! {Hp, VWp, Hp}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = -cplAhHpcVWp(gt1,i1)
coup2 = cplAhHpcHp(gt2,i3,i1)
coup3 = cplAhcHpVWp(gt3,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, Hp, VWp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = -cplAhcHpVWp(gt2,i1)
coup3 = cplAhHpcVWp(gt3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {VWp, Hp, Hp}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = -cplAhcHpVWp(gt1,i2)
coup2 = -cplAhHpcVWp(gt2,i3)
coup3 = cplAhHpcHp(gt3,i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {conj[Hp], conj[VWp], conj[Hp]}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = -cplAhcHpVWp(gt1,i1)
coup2 = cplAhHpcHp(gt2,i1,i3)
coup3 = cplAhHpcVWp(gt3,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {conj[Hp], conj[Hp], conj[VWp]}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplAhHpcHp(gt1,i2,i1)
coup2 = -cplAhHpcVWp(gt2,i1)
coup3 = cplAhcHpVWp(gt3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {conj[VWp], conj[Hp], conj[Hp]}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = -cplAhHpcVWp(gt1,i2)
coup2 = -cplAhcHpVWp(gt2,i3)
coup3 = cplAhHpcHp(gt3,i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {Hp, Hp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplAhAhHpcHp1(gt2,gt3,i2,i1)
Call Amp_VERTEX_StoSS_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, Hp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
coup1 = cplAhAhHpcHp1(gt1,gt3,i1,i2)
coup2 = cplAhHpcHp(gt2,i2,i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 

  End Do
End Do


! {Hp, Hp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
coup1 = cplAhAhHpcHp1(gt1,gt2,i1,i2)
coup2 = cplAhHpcHp(gt3,i2,i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 

  End Do
End Do
    End Do
  End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_AhToAhAh


Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhToAhAh(MAh,MFd,MFe,MFu,MHp,MVWp,             & 
& MAh2,MFd2,MFe2,MFu2,MHp2,MVWp2,cplcFdFdAhL,cplcFdFdAhR,cplcFeFeAhL,cplcFeFeAhR,        & 
& cplcFuFuAhL,cplcFuFuAhR,cplcgWpgWpAh,cplcgWCgWCAh,cplAhHpcHp,cplAhHpcVWp,              & 
& cplAhcHpVWp,cplAhAhHpcHp1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHp(3),MVWp,MAh2(3),MFd2(3),MFe2(3),MFu2(3),              & 
& MHp2(3),MVWp2

Complex(dp), Intent(in) :: cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFeFeAhL(3,3,3),cplcFeFeAhR(3,3,3),          & 
& cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcgWpgWpAh(3),cplcgWCgWCAh(3),cplAhHpcHp(3,3,3),& 
& cplAhHpcVWp(3,3),cplAhcHpVWp(3,3),cplAhAhHpcHp1(3,3,3,3)

Complex(dp), Intent(out) :: Amp(3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
Amp(gt1, gt2, gt3) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MAh(gt2) 
Mex3 = MAh(gt3) 
    End Do
  End Do
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhToAhAh


Subroutine Amplitude_WAVE_4HDM_S3_AhToAhVP(MAh,MAh2,MVP,MVP2,ZfAh,ZfVP,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MAh2(3),MVP,MVP2

Complex(dp), Intent(in) :: ZfAh(3,3),ZfVP

Complex(dp), Intent(out) :: Amp(2,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
  Do gt2=1,3
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MAh(gt2) 
Mex3 = MVP 
ZcoupT1 = 0._dp 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
! Vanishing 


! External Field 2 
! Vanishing 


! External Field 3 
Amp(:,gt1, gt2) = 0._dp
  End Do
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_AhToAhVP


Subroutine Amplitude_VERTEX_4HDM_S3_AhToAhVP(MAh,MFd,MFe,MFu,MHp,MVP,MVWp,            & 
& MAh2,MFd2,MFe2,MFu2,MHp2,MVP2,MVWp2,cplcFdFdAhL,cplcFdFdAhR,cplcFeFeAhL,               & 
& cplcFeFeAhR,cplcFuFuAhL,cplcFuFuAhR,cplcgWpgWpAh,cplcgWCgWCAh,cplAhHpcHp,              & 
& cplAhHpcVWp,cplAhcHpVWp,cplcFdFdVPL,cplcFdFdVPR,cplcFeFeVPL,cplcFeFeVPR,               & 
& cplcFuFuVPL,cplcFuFuVPR,cplcgWpgWpVP,cplcgWCgWCVP,cplHpcHpVP,cplHpcVWpVP,              & 
& cplcHpVPVWp,cplcVWpVPVWp,cplAhHpcVWpVP1,cplAhcHpVPVWp1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHp(3),MVP,MVWp,MAh2(3),MFd2(3),MFe2(3),MFu2(3),          & 
& MHp2(3),MVP2,MVWp2

Complex(dp), Intent(in) :: cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFeFeAhL(3,3,3),cplcFeFeAhR(3,3,3),          & 
& cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcgWpgWpAh(3),cplcgWCgWCAh(3),cplAhHpcHp(3,3,3),& 
& cplAhHpcVWp(3,3),cplAhcHpVWp(3,3),cplcFdFdVPL(3,3),cplcFdFdVPR(3,3),cplcFeFeVPL(3,3),  & 
& cplcFeFeVPR(3,3),cplcFuFuVPL(3,3),cplcFuFuVPR(3,3),cplcgWpgWpVP,cplcgWCgWCVP,          & 
& cplHpcHpVP(3,3),cplHpcVWpVP(3),cplcHpVPVWp(3),cplcVWpVPVWp,cplAhHpcVWpVP1(3,3),        & 
& cplAhcHpVPVWp1(3,3)

Complex(dp), Intent(out) :: Amp(2,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
Amp(:,gt1, gt2) = 0._dp 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MAh(gt2) 
Mex3 = MVP 


! {Fd, Fd, Fd}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFd(i1) 
ML2 = MFd(i2) 
ML3 = MFd(i3) 
coup1L = cplcFdFdAhL(i2,i1,gt1)
coup1R = cplcFdFdAhR(i2,i1,gt1)
coup2L = cplcFdFdAhL(i1,i3,gt2)
coup2R = cplcFdFdAhR(i1,i3,gt2)
coup3L = -cplcFdFdVPR(i3,i2)
coup3R = -cplcFdFdVPL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(6)*AmpC 
    End Do
  End Do
End Do


! {Fe, Fe, Fe}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFe(i1) 
ML2 = MFe(i2) 
ML3 = MFe(i3) 
coup1L = cplcFeFeAhL(i2,i1,gt1)
coup1R = cplcFeFeAhR(i2,i1,gt1)
coup2L = cplcFeFeAhL(i1,i3,gt2)
coup2R = cplcFeFeAhR(i1,i3,gt2)
coup3L = -cplcFeFeVPR(i3,i2)
coup3R = -cplcFeFeVPL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(2)*AmpC 
    End Do
  End Do
End Do


! {Fu, Fu, Fu}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFu(i1) 
ML2 = MFu(i2) 
ML3 = MFu(i3) 
coup1L = cplcFuFuAhL(i2,i1,gt1)
coup1R = cplcFuFuAhR(i2,i1,gt1)
coup2L = cplcFuFuAhL(i1,i3,gt2)
coup2R = cplcFuFuAhR(i1,i3,gt2)
coup3L = -cplcFuFuVPR(i3,i2)
coup3R = -cplcFuFuVPL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(6)*AmpC 
    End Do
  End Do
End Do


! {gWp, gWp, gWp}
ML1 = MVWp 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcgWpgWpAh(gt1)
coup2 = cplcgWpgWpAh(gt2)
coup3 = cplcgWpgWpVP
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(2)*AmpC 


! {gWpC, gWpC, gWpC}
ML1 = MVWp 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcgWCgWCAh(gt1)
coup2 = cplcgWCgWCAh(gt2)
coup3 = cplcgWCgWCVP
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(2)*AmpC 


! {Hp, Hp, Hp}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplAhHpcHp(gt2,i3,i1)
coup3 = -cplHpcHpVP(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(2)*AmpC 
    End Do
  End Do
End Do


! {Hp, VWp, Hp}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = -cplAhHpcVWp(gt1,i1)
coup2 = cplAhHpcHp(gt2,i3,i1)
coup3 = cplcHpVPVWp(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, Hp, VWp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplAhcHpVWp(gt2,i1)
coup3 = cplHpcVWpVP(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, VWp, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MVWp 
coup1 = -cplAhHpcVWp(gt1,i1)
coup2 = cplAhcHpVWp(gt2,i1)
coup3 = cplcVWpVPVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {VWp, Hp, Hp}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = -cplAhcHpVWp(gt1,i2)
coup2 = cplAhHpcVWp(gt2,i3)
coup3 = -cplHpcHpVP(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {conj[Hp], conj[VWp], conj[Hp]}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = -cplAhcHpVWp(gt1,i1)
coup2 = cplAhHpcHp(gt2,i1,i3)
coup3 = cplHpcVWpVP(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {conj[Hp], conj[Hp], conj[VWp]}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplAhHpcHp(gt1,i2,i1)
coup2 = cplAhHpcVWp(gt2,i1)
coup3 = cplcHpVPVWp(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {conj[Hp], conj[VWp], conj[VWp]}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MVWp 
coup1 = -cplAhcHpVWp(gt1,i1)
coup2 = cplAhHpcVWp(gt2,i1)
coup3 = -cplcVWpVPVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {conj[VWp], conj[Hp], conj[Hp]}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = -cplAhHpcVWp(gt1,i2)
coup2 = cplAhcHpVWp(gt2,i3)
coup3 = cplHpcHpVP(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {Hp, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
coup1 = cplAhHpcVWp(gt1,i1)
coup2 = cplAhcHpVPVWp1(gt2,i1)
Call Amp_VERTEX_StoSV_Topology2_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {VWp, Hp}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
coup1 = cplAhcHpVWp(gt1,i2)
coup2 = cplAhHpcVWpVP1(gt2,i2)
Call Amp_VERTEX_StoSV_Topology2_VS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do


! {Hp, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
coup1 = cplAhHpcVWpVP1(gt1,i1)
coup2 = cplAhcHpVWp(gt2,i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology3_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 

End Do


! {VWp, Hp}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
coup1 = cplAhcHpVPVWp1(gt1,i2)
coup2 = cplAhHpcVWp(gt2,i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology3_VS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 

  End Do
  End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_AhToAhVP


Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhToAhVP(MAh,MFd,MFe,MFu,MHp,MVP,              & 
& MVWp,MAh2,MFd2,MFe2,MFu2,MHp2,MVP2,MVWp2,cplcFdFdAhL,cplcFdFdAhR,cplcFeFeAhL,          & 
& cplcFeFeAhR,cplcFuFuAhL,cplcFuFuAhR,cplcgWpgWpAh,cplcgWCgWCAh,cplAhHpcHp,              & 
& cplAhHpcVWp,cplAhcHpVWp,cplcFdFdVPL,cplcFdFdVPR,cplcFeFeVPL,cplcFeFeVPR,               & 
& cplcFuFuVPL,cplcFuFuVPR,cplcgWpgWpVP,cplcgWCgWCVP,cplHpcHpVP,cplHpcVWpVP,              & 
& cplcHpVPVWp,cplcVWpVPVWp,cplAhHpcVWpVP1,cplAhcHpVPVWp1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHp(3),MVP,MVWp,MAh2(3),MFd2(3),MFe2(3),MFu2(3),          & 
& MHp2(3),MVP2,MVWp2

Complex(dp), Intent(in) :: cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFeFeAhL(3,3,3),cplcFeFeAhR(3,3,3),          & 
& cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcgWpgWpAh(3),cplcgWCgWCAh(3),cplAhHpcHp(3,3,3),& 
& cplAhHpcVWp(3,3),cplAhcHpVWp(3,3),cplcFdFdVPL(3,3),cplcFdFdVPR(3,3),cplcFeFeVPL(3,3),  & 
& cplcFeFeVPR(3,3),cplcFuFuVPL(3,3),cplcFuFuVPR(3,3),cplcgWpgWpVP,cplcgWCgWCVP,          & 
& cplHpcHpVP(3,3),cplHpcVWpVP(3),cplcHpVPVWp(3),cplcVWpVPVWp,cplAhHpcVWpVP1(3,3),        & 
& cplAhcHpVPVWp1(3,3)

Complex(dp), Intent(out) :: Amp(2,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
Amp(:,gt1, gt2) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MAh(gt2) 
Mex3 = MVP 
  End Do
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhToAhVP


Subroutine Amplitude_WAVE_4HDM_S3_AhToAhVZ(MAh,MAh2,MVZ,MVZ2,ZfAh,ZfVZ,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MAh2(3),MVZ,MVZ2

Complex(dp), Intent(in) :: ZfAh(3,3),ZfVZ

Complex(dp), Intent(out) :: Amp(2,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
  Do gt2=1,3
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MAh(gt2) 
Mex3 = MVZ 
ZcoupT1 = 0._dp 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
! Vanishing 


! External Field 2 
! Vanishing 


! External Field 3 
Amp(:,gt1, gt2) = 0._dp
  End Do
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_AhToAhVZ


Subroutine Amplitude_VERTEX_4HDM_S3_AhToAhVZ(MAh,MFd,MFe,MFu,MHp,MVWp,MVZ,            & 
& MAh2,MFd2,MFe2,MFu2,MHp2,MVWp2,MVZ2,cplcFdFdAhL,cplcFdFdAhR,cplcFeFeAhL,               & 
& cplcFeFeAhR,cplcFuFuAhL,cplcFuFuAhR,cplcgWpgWpAh,cplcgWCgWCAh,cplAhHpcHp,              & 
& cplAhHpcVWp,cplAhcHpVWp,cplcFdFdVZL,cplcFdFdVZR,cplcFeFeVZL,cplcFeFeVZR,               & 
& cplcFuFuVZL,cplcFuFuVZR,cplcgWpgWpVZ,cplcgWCgWCVZ,cplHpcHpVZ,cplHpcVWpVZ,              & 
& cplcHpVWpVZ,cplcVWpVWpVZ,cplAhHpcVWpVZ1,cplAhcHpVWpVZ1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHp(3),MVWp,MVZ,MAh2(3),MFd2(3),MFe2(3),MFu2(3),          & 
& MHp2(3),MVWp2,MVZ2

Complex(dp), Intent(in) :: cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFeFeAhL(3,3,3),cplcFeFeAhR(3,3,3),          & 
& cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcgWpgWpAh(3),cplcgWCgWCAh(3),cplAhHpcHp(3,3,3),& 
& cplAhHpcVWp(3,3),cplAhcHpVWp(3,3),cplcFdFdVZL(3,3),cplcFdFdVZR(3,3),cplcFeFeVZL(3,3),  & 
& cplcFeFeVZR(3,3),cplcFuFuVZL(3,3),cplcFuFuVZR(3,3),cplcgWpgWpVZ,cplcgWCgWCVZ,          & 
& cplHpcHpVZ(3,3),cplHpcVWpVZ(3),cplcHpVWpVZ(3),cplcVWpVWpVZ,cplAhHpcVWpVZ1(3,3),        & 
& cplAhcHpVWpVZ1(3,3)

Complex(dp), Intent(out) :: Amp(2,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
Amp(:,gt1, gt2) = 0._dp 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MAh(gt2) 
Mex3 = MVZ 


! {Fd, Fd, Fd}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFd(i1) 
ML2 = MFd(i2) 
ML3 = MFd(i3) 
coup1L = cplcFdFdAhL(i2,i1,gt1)
coup1R = cplcFdFdAhR(i2,i1,gt1)
coup2L = cplcFdFdAhL(i1,i3,gt2)
coup2R = cplcFdFdAhR(i1,i3,gt2)
coup3L = -cplcFdFdVZR(i3,i2)
coup3R = -cplcFdFdVZL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(6)*AmpC 
    End Do
  End Do
End Do


! {Fe, Fe, Fe}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFe(i1) 
ML2 = MFe(i2) 
ML3 = MFe(i3) 
coup1L = cplcFeFeAhL(i2,i1,gt1)
coup1R = cplcFeFeAhR(i2,i1,gt1)
coup2L = cplcFeFeAhL(i1,i3,gt2)
coup2R = cplcFeFeAhR(i1,i3,gt2)
coup3L = -cplcFeFeVZR(i3,i2)
coup3R = -cplcFeFeVZL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(2)*AmpC 
    End Do
  End Do
End Do


! {Fu, Fu, Fu}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFu(i1) 
ML2 = MFu(i2) 
ML3 = MFu(i3) 
coup1L = cplcFuFuAhL(i2,i1,gt1)
coup1R = cplcFuFuAhR(i2,i1,gt1)
coup2L = cplcFuFuAhL(i1,i3,gt2)
coup2R = cplcFuFuAhR(i1,i3,gt2)
coup3L = -cplcFuFuVZR(i3,i2)
coup3R = -cplcFuFuVZL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(6)*AmpC 
    End Do
  End Do
End Do


! {gWp, gWp, gWp}
ML1 = MVWp 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcgWpgWpAh(gt1)
coup2 = cplcgWpgWpAh(gt2)
coup3 = cplcgWpgWpVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(2)*AmpC 


! {gWpC, gWpC, gWpC}
ML1 = MVWp 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcgWCgWCAh(gt1)
coup2 = cplcgWCgWCAh(gt2)
coup3 = cplcgWCgWCVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(2)*AmpC 


! {Hp, Hp, Hp}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplAhHpcHp(gt2,i3,i1)
coup3 = -cplHpcHpVZ(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(2)*AmpC 
    End Do
  End Do
End Do


! {Hp, VWp, Hp}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = -cplAhHpcVWp(gt1,i1)
coup2 = cplAhHpcHp(gt2,i3,i1)
coup3 = cplcHpVWpVZ(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, Hp, VWp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplAhcHpVWp(gt2,i1)
coup3 = cplHpcVWpVZ(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, VWp, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MVWp 
coup1 = -cplAhHpcVWp(gt1,i1)
coup2 = cplAhcHpVWp(gt2,i1)
coup3 = -cplcVWpVWpVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {VWp, Hp, Hp}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = -cplAhcHpVWp(gt1,i2)
coup2 = cplAhHpcVWp(gt2,i3)
coup3 = -cplHpcHpVZ(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {conj[Hp], conj[VWp], conj[Hp]}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = -cplAhcHpVWp(gt1,i1)
coup2 = cplAhHpcHp(gt2,i1,i3)
coup3 = cplHpcVWpVZ(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {conj[Hp], conj[Hp], conj[VWp]}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplAhHpcHp(gt1,i2,i1)
coup2 = cplAhHpcVWp(gt2,i1)
coup3 = cplcHpVWpVZ(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {conj[Hp], conj[VWp], conj[VWp]}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MVWp 
coup1 = -cplAhcHpVWp(gt1,i1)
coup2 = cplAhHpcVWp(gt2,i1)
coup3 = cplcVWpVWpVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {conj[VWp], conj[Hp], conj[Hp]}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = -cplAhHpcVWp(gt1,i2)
coup2 = cplAhcHpVWp(gt2,i3)
coup3 = cplHpcHpVZ(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {Hp, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
coup1 = cplAhHpcVWp(gt1,i1)
coup2 = cplAhcHpVWpVZ1(gt2,i1)
Call Amp_VERTEX_StoSV_Topology2_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {VWp, Hp}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
coup1 = cplAhcHpVWp(gt1,i2)
coup2 = cplAhHpcVWpVZ1(gt2,i2)
Call Amp_VERTEX_StoSV_Topology2_VS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do


! {Hp, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
coup1 = cplAhHpcVWpVZ1(gt1,i1)
coup2 = cplAhcHpVWp(gt2,i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology3_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 

End Do


! {VWp, Hp}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
coup1 = cplAhcHpVWpVZ1(gt1,i2)
coup2 = cplAhHpcVWp(gt2,i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology3_VS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 

  End Do
  End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_AhToAhVZ


Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhToAhVZ(MAh,MFd,MFe,MFu,MHp,MVWp,             & 
& MVZ,MAh2,MFd2,MFe2,MFu2,MHp2,MVWp2,MVZ2,cplcFdFdAhL,cplcFdFdAhR,cplcFeFeAhL,           & 
& cplcFeFeAhR,cplcFuFuAhL,cplcFuFuAhR,cplcgWpgWpAh,cplcgWCgWCAh,cplAhHpcHp,              & 
& cplAhHpcVWp,cplAhcHpVWp,cplcFdFdVZL,cplcFdFdVZR,cplcFeFeVZL,cplcFeFeVZR,               & 
& cplcFuFuVZL,cplcFuFuVZR,cplcgWpgWpVZ,cplcgWCgWCVZ,cplHpcHpVZ,cplHpcVWpVZ,              & 
& cplcHpVWpVZ,cplcVWpVWpVZ,cplAhHpcVWpVZ1,cplAhcHpVWpVZ1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHp(3),MVWp,MVZ,MAh2(3),MFd2(3),MFe2(3),MFu2(3),          & 
& MHp2(3),MVWp2,MVZ2

Complex(dp), Intent(in) :: cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFeFeAhL(3,3,3),cplcFeFeAhR(3,3,3),          & 
& cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcgWpgWpAh(3),cplcgWCgWCAh(3),cplAhHpcHp(3,3,3),& 
& cplAhHpcVWp(3,3),cplAhcHpVWp(3,3),cplcFdFdVZL(3,3),cplcFdFdVZR(3,3),cplcFeFeVZL(3,3),  & 
& cplcFeFeVZR(3,3),cplcFuFuVZL(3,3),cplcFuFuVZR(3,3),cplcgWpgWpVZ,cplcgWCgWCVZ,          & 
& cplHpcHpVZ(3,3),cplHpcVWpVZ(3),cplcHpVWpVZ(3),cplcVWpVWpVZ,cplAhHpcVWpVZ1(3,3),        & 
& cplAhcHpVWpVZ1(3,3)

Complex(dp), Intent(out) :: Amp(2,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
Amp(:,gt1, gt2) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MAh(gt2) 
Mex3 = MVZ 
  End Do
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhToAhVZ


Subroutine Amplitude_WAVE_4HDM_S3_AhToFvcFv(MAh,MAh2,ZfAh,ZfvL,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MAh2(3)

Complex(dp), Intent(in) :: ZfAh(3,3),ZfvL(3,3)

Complex(dp), Intent(out) :: Amp(2,3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
! External masses 
Mex1 = MAh(gt1) 
Mex2 = 0. 
Mex3 = 0. 
ZcoupT1L = 0._dp 
ZcoupT1R = 0._dp 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
! Vanishing 


! External Field 2 
! Vanishing 


! External Field 3 
! Vanishing 
Amp(:,gt1, gt2, gt3) = 0._dp
    End Do
  End Do
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_AhToFvcFv


Subroutine Amplitude_VERTEX_4HDM_S3_AhToFvcFv(MAh,MFe,MHp,MVWp,MAh2,MFe2,             & 
& MHp2,MVWp2,cplcFeFeAhL,cplcFeFeAhR,cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplcFvFeHpL,     & 
& cplcFvFeHpR,cplcFvFeVWpL,cplcFvFeVWpR,cplcFeFvcHpL,cplcFeFvcHpR,cplcFeFvcVWpL,         & 
& cplcFeFvcVWpR,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFe(3),MHp(3),MVWp,MAh2(3),MFe2(3),MHp2(3),MVWp2

Complex(dp), Intent(in) :: cplcFeFeAhL(3,3,3),cplcFeFeAhR(3,3,3),cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),             & 
& cplAhcHpVWp(3,3),cplcFvFeHpL(3,3,3),cplcFvFeHpR(3,3,3),cplcFvFeVWpL(3,3),              & 
& cplcFvFeVWpR(3,3),cplcFeFvcHpL(3,3,3),cplcFeFvcHpR(3,3,3),cplcFeFvcVWpL(3,3),          & 
& cplcFeFvcVWpR(3,3)

Complex(dp), Intent(out) :: Amp(2,3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
Amp(:,gt1, gt2, gt3) = 0._dp 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = 0. 
Mex3 = 0. 


! {Fe, Fe, conj[Hp]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFe(i1) 
ML2 = MFe(i2) 
ML3 = MHp(i3) 
coup1L = cplcFeFeAhL(i2,i1,gt1)
coup1R = cplcFeFeAhR(i2,i1,gt1)
coup2L = cplcFeFvcHpL(i1,gt2,i3)
coup2R = cplcFeFvcHpR(i1,gt2,i3)
coup3L = cplcFvFeHpL(gt3,i2,i3)
coup3R = cplcFvFeHpR(gt3,i2,i3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_FFS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Fe, Fe, conj[VWp]}
Do i1=1,3
  Do i2=1,3
ML1 = MFe(i1) 
ML2 = MFe(i2) 
ML3 = MVWp 
coup1L = cplcFeFeAhL(i2,i1,gt1)
coup1R = cplcFeFeAhR(i2,i1,gt1)
coup2L = -cplcFeFvcVWpR(i1,gt2)
coup2R = -cplcFeFvcVWpL(i1,gt2)
coup3L = -cplcFvFeVWpR(gt3,i2)
coup3R = -cplcFvFeVWpL(gt3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_FFV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, Hp, bar[Fe]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MFe(i3) 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2L = cplcFeFvcHpL(i3,gt2,i1)
coup2R = cplcFeFvcHpR(i3,gt2,i1)
coup3L = cplcFvFeHpL(gt3,i3,i2)
coup3R = cplcFvFeHpR(gt3,i3,i2)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_SSF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Hp, VWp, bar[Fe]}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MFe(i3) 
coup1 = cplAhHpcVWp(gt1,i1)
coup2L = cplcFeFvcHpL(i3,gt2,i1)
coup2R = cplcFeFvcHpR(i3,gt2,i1)
coup3L = -cplcFvFeVWpR(gt3,i3)
coup3R = -cplcFvFeVWpL(gt3,i3)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_SVF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {VWp, Hp, bar[Fe]}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MFe(i3) 
coup1 = cplAhcHpVWp(gt1,i2)
coup2L = -cplcFeFvcVWpR(i3,gt2)
coup2R = -cplcFeFvcVWpL(i3,gt2)
coup3L = cplcFvFeHpL(gt3,i3,i2)
coup3R = cplcFvFeHpR(gt3,i3,i2)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_VSF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
    End Do
  End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_AhToFvcFv


Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhToFvcFv(MAh,MFe,MHp,MVWp,MAh2,               & 
& MFe2,MHp2,MVWp2,cplcFeFeAhL,cplcFeFeAhR,cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,            & 
& cplcFvFeHpL,cplcFvFeHpR,cplcFvFeVWpL,cplcFvFeVWpR,cplcFeFvcHpL,cplcFeFvcHpR,           & 
& cplcFeFvcVWpL,cplcFeFvcVWpR,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFe(3),MHp(3),MVWp,MAh2(3),MFe2(3),MHp2(3),MVWp2

Complex(dp), Intent(in) :: cplcFeFeAhL(3,3,3),cplcFeFeAhR(3,3,3),cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),             & 
& cplAhcHpVWp(3,3),cplcFvFeHpL(3,3,3),cplcFvFeHpR(3,3,3),cplcFvFeVWpL(3,3),              & 
& cplcFvFeVWpR(3,3),cplcFeFvcHpL(3,3,3),cplcFeFvcHpR(3,3,3),cplcFeFvcVWpL(3,3),          & 
& cplcFeFvcVWpR(3,3)

Complex(dp), Intent(out) :: Amp(2,3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
Amp(:,gt1, gt2, gt3) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = 0. 
Mex3 = 0. 
    End Do
  End Do
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhToFvcFv


Subroutine Amplitude_WAVE_4HDM_S3_AhToHapcHap(MAh,MAh2,MHap,MHap2,ZfAh,               & 
& ZfHap,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MAh2(3),MHap,MHap2

Complex(dp), Intent(in) :: ZfAh(3,3),ZfHap

Complex(dp), Intent(out) :: Amp(3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MHap 
Mex3 = MHap 
ZcoupT1 = 0._dp 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
! Vanishing 


! External Field 2 
! Vanishing 


! External Field 3 
! Vanishing 
Amp(gt1) = 0._dp
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_AhToHapcHap


Subroutine Amplitude_VERTEX_4HDM_S3_AhToHapcHap(MAh,MHap,Mhha,MHhSM,MHp,              & 
& Msiga,MVWp,MVZ,MAh2,MHap2,Mhha2,MHhSM2,MHp2,Msiga2,MVWp2,MVZ2,cplAhhhasiga,            & 
& cplAhHhSMVZ,cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplHaphhacHp,cplHaphhacVWp,             & 
& cplHapHhSMcHap,cplHapsigacHp,cplHapsigacVWp,cplHapcHapVZ,cplhhaHpcHap,cplhhacHapVWp,   & 
& cplHpsigacHap,cplsigacHapVWp,cplAhHaphhacHp1,cplAhHapsigacHp1,cplAhhhaHpcHap1,         & 
& cplAhHpsigacHap1,cplHapHpcHapcHp1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MHap,Mhha,MHhSM(3),MHp(3),Msiga,MVWp,MVZ,MAh2(3),MHap2,Mhha2,MHhSM2(3),        & 
& MHp2(3),Msiga2,MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhhhasiga(3),cplAhHhSMVZ(3,3),cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),cplAhcHpVWp(3,3), & 
& cplHaphhacHp(3),cplHaphhacVWp,cplHapHhSMcHap(3),cplHapsigacHp(3),cplHapsigacVWp,       & 
& cplHapcHapVZ,cplhhaHpcHap(3),cplhhacHapVWp,cplHpsigacHap(3),cplsigacHapVWp,            & 
& cplAhHaphhacHp1(3,3),cplAhHapsigacHp1(3,3),cplAhhhaHpcHap1(3,3),cplAhHpsigacHap1(3,3), & 
& cplHapHpcHapcHp1(3,3)

Complex(dp), Intent(out) :: Amp(3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
Amp(gt1) = 0._dp 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MHap 
Mex3 = MHap 


! {hha, siga, conj[Hp]}
    Do i3=1,3
ML1 = Mhha 
ML2 = Msiga 
ML3 = MHp(i3) 
coup1 = cplAhhhasiga(gt1)
coup2 = cplHaphhacHp(i3)
coup3 = cplHpsigacHap(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
    End Do


! {hha, siga, conj[VWp]}
ML1 = Mhha 
ML2 = Msiga 
ML3 = MVWp 
coup1 = cplAhhhasiga(gt1)
coup2 = -cplHaphhacVWp
coup3 = -cplsigacHapVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 


! {HhSM, VZ, conj[Hap]}
Do i1=1,3
ML1 = MHhSM(i1) 
ML2 = MVZ 
ML3 = MHap 
coup1 = -cplAhHhSMVZ(gt1,i1)
coup2 = cplHapHhSMcHap(i1)
coup3 = -cplHapcHapVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
End Do


! {Hp, Hp, hha}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = Mhha 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplHaphhacHp(i1)
coup3 = cplhhaHpcHap(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, VWp, hha}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = Mhha 
coup1 = -cplAhHpcVWp(gt1,i1)
coup2 = cplHaphhacHp(i1)
coup3 = -cplhhacHapVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
End Do


! {Hp, Hp, siga}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = Msiga 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplHapsigacHp(i1)
coup3 = cplHpsigacHap(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, VWp, siga}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = Msiga 
coup1 = -cplAhHpcVWp(gt1,i1)
coup2 = cplHapsigacHp(i1)
coup3 = -cplsigacHapVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
End Do


! {siga, hha, conj[Hp]}
    Do i3=1,3
ML1 = Msiga 
ML2 = Mhha 
ML3 = MHp(i3) 
coup1 = cplAhhhasiga(gt1)
coup2 = cplHapsigacHp(i3)
coup3 = cplhhaHpcHap(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
    End Do


! {siga, hha, conj[VWp]}
ML1 = Msiga 
ML2 = Mhha 
ML3 = MVWp 
coup1 = cplAhhhasiga(gt1)
coup2 = -cplHapsigacVWp
coup3 = -cplhhacHapVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 


! {VWp, Hp, hha}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = Mhha 
coup1 = -cplAhcHpVWp(gt1,i2)
coup2 = -cplHaphhacVWp
coup3 = cplhhaHpcHap(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do


! {VWp, Hp, siga}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = Msiga 
coup1 = -cplAhcHpVWp(gt1,i2)
coup2 = -cplHapsigacVWp
coup3 = cplHpsigacHap(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do


! {VZ, HhSM, conj[Hap]}
  Do i2=1,3
ML1 = MVZ 
ML2 = MHhSM(i2) 
ML3 = MHap 
coup1 = -cplAhHhSMVZ(gt1,i2)
coup2 = -cplHapcHapVZ
coup3 = cplHapHhSMcHap(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do


! {Hp, Hp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplHapHpcHapcHp1(i2,i1)
Call Amp_VERTEX_StoSS_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {hha, conj[Hp]}
  Do i2=1,3
ML1 = Mhha 
ML2 = MHp(i2) 
coup1 = cplAhhhaHpcHap1(gt1,i2)
coup2 = cplHaphhacHp(i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 

  End Do


! {Hp, siga}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = Msiga 
coup1 = cplAhHpsigacHap1(gt1,i1)
coup2 = cplHapsigacHp(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 

End Do


! {hha, Hp}
  Do i2=1,3
ML1 = Mhha 
ML2 = MHp(i2) 
coup1 = cplAhHaphhacHp1(gt1,i2)
coup2 = cplhhaHpcHap(i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 

  End Do


! {siga, Hp}
  Do i2=1,3
ML1 = Msiga 
ML2 = MHp(i2) 
coup1 = cplAhHapsigacHp1(gt1,i2)
coup2 = cplHpsigacHap(i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 

  End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_AhToHapcHap


Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhToHapcHap(MAh,MHap,Mhha,MHhSM,               & 
& MHp,Msiga,MVWp,MVZ,MAh2,MHap2,Mhha2,MHhSM2,MHp2,Msiga2,MVWp2,MVZ2,cplAhhhasiga,        & 
& cplAhHhSMVZ,cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplHaphhacHp,cplHaphhacVWp,             & 
& cplHapHhSMcHap,cplHapsigacHp,cplHapsigacVWp,cplHapcHapVZ,cplhhaHpcHap,cplhhacHapVWp,   & 
& cplHpsigacHap,cplsigacHapVWp,cplAhHaphhacHp1,cplAhHapsigacHp1,cplAhhhaHpcHap1,         & 
& cplAhHpsigacHap1,cplHapHpcHapcHp1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MHap,Mhha,MHhSM(3),MHp(3),Msiga,MVWp,MVZ,MAh2(3),MHap2,Mhha2,MHhSM2(3),        & 
& MHp2(3),Msiga2,MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhhhasiga(3),cplAhHhSMVZ(3,3),cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),cplAhcHpVWp(3,3), & 
& cplHaphhacHp(3),cplHaphhacVWp,cplHapHhSMcHap(3),cplHapsigacHp(3),cplHapsigacVWp,       & 
& cplHapcHapVZ,cplhhaHpcHap(3),cplhhacHapVWp,cplHpsigacHap(3),cplsigacHapVWp,            & 
& cplAhHaphhacHp1(3,3),cplAhHapsigacHp1(3,3),cplAhhhaHpcHap1(3,3),cplAhHpsigacHap1(3,3), & 
& cplHapHpcHapcHp1(3,3)

Complex(dp), Intent(out) :: Amp(3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
Amp(gt1) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MHap 
Mex3 = MHap 
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhToHapcHap


Subroutine Amplitude_WAVE_4HDM_S3_AhTohhahha(MAh,MAh2,Mhha,Mhha2,ZfAh,Zfhha,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MAh2(3),Mhha,Mhha2

Complex(dp), Intent(in) :: ZfAh(3,3),Zfhha

Complex(dp), Intent(out) :: Amp(3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
! External masses 
Mex1 = MAh(gt1) 
Mex2 = Mhha 
Mex3 = Mhha 
ZcoupT1 = 0._dp 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
! Vanishing 


! External Field 2 
! Vanishing 


! External Field 3 
! Vanishing 
Amp(gt1) = 0._dp
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_AhTohhahha


Subroutine Amplitude_VERTEX_4HDM_S3_AhTohhahha(MAh,MHap,Mhha,MHp,MVWp,MAh2,           & 
& MHap2,Mhha2,MHp2,MVWp2,cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplHaphhacHp,cplHaphhacVWp,  & 
& cplhhaHpcHap,cplhhacHapVWp,cplAhHaphhacHp1,cplAhhhaHpcHap1,cplhhahhaHpcHp1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MHap,Mhha,MHp(3),MVWp,MAh2(3),MHap2,Mhha2,MHp2(3),MVWp2

Complex(dp), Intent(in) :: cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),cplAhcHpVWp(3,3),cplHaphhacHp(3),cplHaphhacVWp,    & 
& cplhhaHpcHap(3),cplhhacHapVWp,cplAhHaphhacHp1(3,3),cplAhhhaHpcHap1(3,3),               & 
& cplhhahhaHpcHp1(3,3)

Complex(dp), Intent(out) :: Amp(3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
Amp(gt1) = 0._dp 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = Mhha 
Mex3 = Mhha 


! {Hp, Hp, Hap}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MHap 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplHaphhacHp(i1)
coup3 = cplhhaHpcHap(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, VWp, Hap}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MHap 
coup1 = -cplAhHpcVWp(gt1,i1)
coup2 = cplHaphhacHp(i1)
coup3 = cplhhacHapVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
End Do


! {VWp, Hp, Hap}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MHap 
coup1 = -cplAhcHpVWp(gt1,i2)
coup2 = cplHaphhacVWp
coup3 = cplhhaHpcHap(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do


! {conj[Hp], conj[Hp], conj[Hap]}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MHap 
coup1 = cplAhHpcHp(gt1,i2,i1)
coup2 = cplhhaHpcHap(i1)
coup3 = cplHaphhacHp(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {conj[Hp], conj[VWp], conj[Hap]}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MHap 
coup1 = -cplAhcHpVWp(gt1,i1)
coup2 = cplhhaHpcHap(i1)
coup3 = -cplHaphhacVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
End Do


! {conj[VWp], conj[Hp], conj[Hap]}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MHap 
coup1 = -cplAhHpcVWp(gt1,i2)
coup2 = -cplhhacHapVWp
coup3 = cplHaphhacHp(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do


! {Hp, Hp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplhhahhaHpcHp1(i2,i1)
Call Amp_VERTEX_StoSS_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hap, Hp}
  Do i2=1,3
ML1 = MHap 
ML2 = MHp(i2) 
coup1 = cplAhHaphhacHp1(gt1,i2)
coup2 = cplhhaHpcHap(i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 

  End Do


! {Hp, Hap}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MHap 
coup1 = cplAhhhaHpcHap1(gt1,i1)
coup2 = cplHaphhacHp(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 

End Do


! {Hap, Hp}
  Do i2=1,3
ML1 = MHap 
ML2 = MHp(i2) 
coup1 = cplAhHaphhacHp1(gt1,i2)
coup2 = cplhhaHpcHap(i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 

  End Do


! {Hp, Hap}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MHap 
coup1 = cplAhhhaHpcHap1(gt1,i1)
coup2 = cplHaphhacHp(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 

End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_AhTohhahha


Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhTohhahha(MAh,MHap,Mhha,MHp,MVWp,             & 
& MAh2,MHap2,Mhha2,MHp2,MVWp2,cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplHaphhacHp,           & 
& cplHaphhacVWp,cplhhaHpcHap,cplhhacHapVWp,cplAhHaphhacHp1,cplAhhhaHpcHap1,              & 
& cplhhahhaHpcHp1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MHap,Mhha,MHp(3),MVWp,MAh2(3),MHap2,Mhha2,MHp2(3),MVWp2

Complex(dp), Intent(in) :: cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),cplAhcHpVWp(3,3),cplHaphhacHp(3),cplHaphhacVWp,    & 
& cplhhaHpcHap(3),cplhhacHapVWp,cplAhHaphhacHp1(3,3),cplAhhhaHpcHap1(3,3),               & 
& cplhhahhaHpcHp1(3,3)

Complex(dp), Intent(out) :: Amp(3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
Amp(gt1) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = Mhha 
Mex3 = Mhha 
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhTohhahha


Subroutine Amplitude_WAVE_4HDM_S3_AhToHhSMHhSM(MAh,MAh2,MHhSM,MHhSM2,ZfAh,            & 
& ZfHhSM,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MAh2(3),MHhSM(3),MHhSM2(3)

Complex(dp), Intent(in) :: ZfAh(3,3),ZfHhSM(3,3)

Complex(dp), Intent(out) :: Amp(3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MHhSM(gt2) 
Mex3 = MHhSM(gt3) 
ZcoupT1 = 0._dp 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
! Vanishing 


! External Field 2 
! Vanishing 


! External Field 3 
! Vanishing 
Amp(gt1, gt2, gt3) = 0._dp
    End Do
  End Do
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_AhToHhSMHhSM


Subroutine Amplitude_VERTEX_4HDM_S3_AhToHhSMHhSM(MAh,MFd,MFe,MFu,MHhSM,               & 
& MHp,MVWp,MAh2,MFd2,MFe2,MFu2,MHhSM2,MHp2,MVWp2,cplcFdFdAhL,cplcFdFdAhR,cplcFeFeAhL,    & 
& cplcFeFeAhR,cplcFuFuAhL,cplcFuFuAhR,cplcgWpgWpAh,cplcgWCgWCAh,cplAhHpcHp,              & 
& cplAhHpcVWp,cplAhcHpVWp,cplcFdFdHhSML,cplcFdFdHhSMR,cplcFeFeHhSML,cplcFeFeHhSMR,       & 
& cplcFuFuHhSML,cplcFuFuHhSMR,cplcgWpgWpHhSM,cplcgWCgWCHhSM,cplHhSMHpcHp,cplHhSMHpcVWp,  & 
& cplHhSMcHpVWp,cplHhSMcVWpVWp,cplAhHhSMHpcHp1,cplHhSMHhSMHpcHp1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHhSM(3),MHp(3),MVWp,MAh2(3),MFd2(3),MFe2(3),             & 
& MFu2(3),MHhSM2(3),MHp2(3),MVWp2

Complex(dp), Intent(in) :: cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFeFeAhL(3,3,3),cplcFeFeAhR(3,3,3),          & 
& cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcgWpgWpAh(3),cplcgWCgWCAh(3),cplAhHpcHp(3,3,3),& 
& cplAhHpcVWp(3,3),cplAhcHpVWp(3,3),cplcFdFdHhSML(3,3,3),cplcFdFdHhSMR(3,3,3),           & 
& cplcFeFeHhSML(3,3,3),cplcFeFeHhSMR(3,3,3),cplcFuFuHhSML(3,3,3),cplcFuFuHhSMR(3,3,3),   & 
& cplcgWpgWpHhSM(3),cplcgWCgWCHhSM(3),cplHhSMHpcHp(3,3,3),cplHhSMHpcVWp(3,3),            & 
& cplHhSMcHpVWp(3,3),cplHhSMcVWpVWp(3),cplAhHhSMHpcHp1(3,3,3,3),cplHhSMHhSMHpcHp1(3,3,3,3)

Complex(dp), Intent(out) :: Amp(3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
Amp(gt1, gt2, gt3) = 0._dp 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MHhSM(gt2) 
Mex3 = MHhSM(gt3) 


! {Fd, Fd, Fd}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFd(i1) 
ML2 = MFd(i2) 
ML3 = MFd(i3) 
coup1L = cplcFdFdAhL(i2,i1,gt1)
coup1R = cplcFdFdAhR(i2,i1,gt1)
coup2L = cplcFdFdHhSML(i1,i3,gt2)
coup2R = cplcFdFdHhSMR(i1,i3,gt2)
coup3L = cplcFdFdHhSML(i3,i2,gt3)
coup3R = cplcFdFdHhSMR(i3,i2,gt3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(6)*AmpC 
    End Do
  End Do
End Do


! {Fe, Fe, Fe}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFe(i1) 
ML2 = MFe(i2) 
ML3 = MFe(i3) 
coup1L = cplcFeFeAhL(i2,i1,gt1)
coup1R = cplcFeFeAhR(i2,i1,gt1)
coup2L = cplcFeFeHhSML(i1,i3,gt2)
coup2R = cplcFeFeHhSMR(i1,i3,gt2)
coup3L = cplcFeFeHhSML(i3,i2,gt3)
coup3R = cplcFeFeHhSMR(i3,i2,gt3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(2)*AmpC 
    End Do
  End Do
End Do


! {Fu, Fu, Fu}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFu(i1) 
ML2 = MFu(i2) 
ML3 = MFu(i3) 
coup1L = cplcFuFuAhL(i2,i1,gt1)
coup1R = cplcFuFuAhR(i2,i1,gt1)
coup2L = cplcFuFuHhSML(i1,i3,gt2)
coup2R = cplcFuFuHhSMR(i1,i3,gt2)
coup3L = cplcFuFuHhSML(i3,i2,gt3)
coup3R = cplcFuFuHhSMR(i3,i2,gt3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(6)*AmpC 
    End Do
  End Do
End Do


! {gWp, gWp, gWp}
ML1 = MVWp 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcgWpgWpAh(gt1)
coup2 = cplcgWpgWpHhSM(gt2)
coup3 = cplcgWpgWpHhSM(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(2)*AmpC 


! {gWpC, gWpC, gWpC}
ML1 = MVWp 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcgWCgWCAh(gt1)
coup2 = cplcgWCgWCHhSM(gt2)
coup3 = cplcgWCgWCHhSM(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(2)*AmpC 


! {Hp, Hp, Hp}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplHhSMHpcHp(gt2,i3,i1)
coup3 = cplHhSMHpcHp(gt3,i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(2)*AmpC 
    End Do
  End Do
End Do


! {Hp, VWp, Hp}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = -cplAhHpcVWp(gt1,i1)
coup2 = cplHhSMHpcHp(gt2,i3,i1)
coup3 = cplHhSMcHpVWp(gt3,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, Hp, VWp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = -cplHhSMcHpVWp(gt2,i1)
coup3 = cplHhSMHpcVWp(gt3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, VWp, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MVWp 
coup1 = -cplAhHpcVWp(gt1,i1)
coup2 = -cplHhSMcHpVWp(gt2,i1)
coup3 = cplHhSMcVWpVWp(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
End Do


! {VWp, Hp, Hp}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = -cplAhcHpVWp(gt1,i2)
coup2 = -cplHhSMHpcVWp(gt2,i3)
coup3 = cplHhSMHpcHp(gt3,i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VWp, Hp, VWp}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = -cplAhcHpVWp(gt1,i2)
coup2 = cplHhSMcVWpVWp(gt2)
coup3 = cplHhSMHpcVWp(gt3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do


! {conj[Hp], conj[VWp], conj[Hp]}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = -cplAhcHpVWp(gt1,i1)
coup2 = cplHhSMHpcHp(gt2,i1,i3)
coup3 = cplHhSMHpcVWp(gt3,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {conj[Hp], conj[Hp], conj[VWp]}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplAhHpcHp(gt1,i2,i1)
coup2 = -cplHhSMHpcVWp(gt2,i1)
coup3 = cplHhSMcHpVWp(gt3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {conj[Hp], conj[VWp], conj[VWp]}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MVWp 
coup1 = -cplAhcHpVWp(gt1,i1)
coup2 = -cplHhSMHpcVWp(gt2,i1)
coup3 = cplHhSMcVWpVWp(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
End Do


! {conj[VWp], conj[Hp], conj[Hp]}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = -cplAhHpcVWp(gt1,i2)
coup2 = -cplHhSMcHpVWp(gt2,i3)
coup3 = cplHhSMHpcHp(gt3,i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {conj[VWp], conj[Hp], conj[VWp]}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = -cplAhHpcVWp(gt1,i2)
coup2 = cplHhSMcVWpVWp(gt2)
coup3 = cplHhSMcHpVWp(gt3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do


! {Hp, Hp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplHhSMHhSMHpcHp1(gt2,gt3,i2,i1)
Call Amp_VERTEX_StoSS_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, Hp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
coup1 = cplAhHhSMHpcHp1(gt1,gt3,i1,i2)
coup2 = cplHhSMHpcHp(gt2,i2,i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 

  End Do
End Do


! {Hp, Hp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
coup1 = cplAhHhSMHpcHp1(gt1,gt2,i1,i2)
coup2 = cplHhSMHpcHp(gt3,i2,i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 

  End Do
End Do
    End Do
  End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_AhToHhSMHhSM


Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhToHhSMHhSM(MAh,MFd,MFe,MFu,MHhSM,            & 
& MHp,MVWp,MAh2,MFd2,MFe2,MFu2,MHhSM2,MHp2,MVWp2,cplcFdFdAhL,cplcFdFdAhR,cplcFeFeAhL,    & 
& cplcFeFeAhR,cplcFuFuAhL,cplcFuFuAhR,cplcgWpgWpAh,cplcgWCgWCAh,cplAhHpcHp,              & 
& cplAhHpcVWp,cplAhcHpVWp,cplcFdFdHhSML,cplcFdFdHhSMR,cplcFeFeHhSML,cplcFeFeHhSMR,       & 
& cplcFuFuHhSML,cplcFuFuHhSMR,cplcgWpgWpHhSM,cplcgWCgWCHhSM,cplHhSMHpcHp,cplHhSMHpcVWp,  & 
& cplHhSMcHpVWp,cplHhSMcVWpVWp,cplAhHhSMHpcHp1,cplHhSMHhSMHpcHp1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHhSM(3),MHp(3),MVWp,MAh2(3),MFd2(3),MFe2(3),             & 
& MFu2(3),MHhSM2(3),MHp2(3),MVWp2

Complex(dp), Intent(in) :: cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFeFeAhL(3,3,3),cplcFeFeAhR(3,3,3),          & 
& cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcgWpgWpAh(3),cplcgWCgWCAh(3),cplAhHpcHp(3,3,3),& 
& cplAhHpcVWp(3,3),cplAhcHpVWp(3,3),cplcFdFdHhSML(3,3,3),cplcFdFdHhSMR(3,3,3),           & 
& cplcFeFeHhSML(3,3,3),cplcFeFeHhSMR(3,3,3),cplcFuFuHhSML(3,3,3),cplcFuFuHhSMR(3,3,3),   & 
& cplcgWpgWpHhSM(3),cplcgWCgWCHhSM(3),cplHhSMHpcHp(3,3,3),cplHhSMHpcVWp(3,3),            & 
& cplHhSMcHpVWp(3,3),cplHhSMcVWpVWp(3),cplAhHhSMHpcHp1(3,3,3,3),cplHhSMHhSMHpcHp1(3,3,3,3)

Complex(dp), Intent(out) :: Amp(3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
Amp(gt1, gt2, gt3) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MHhSM(gt2) 
Mex3 = MHhSM(gt3) 
    End Do
  End Do
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhToHhSMHhSM


Subroutine Amplitude_WAVE_4HDM_S3_AhToHhSMVP(cplAhHhSMVZ,ctcplAhHhSMVZ,               & 
& MAh,MAh2,MHhSM,MHhSM2,MVP,MVP2,MVZ,MVZ2,ZfAh,ZfHhSM,ZfVP,ZfVZVP,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MAh2(3),MHhSM(3),MHhSM2(3),MVP,MVP2,MVZ,MVZ2

Complex(dp), Intent(in) :: cplAhHhSMVZ(3,3)

Complex(dp), Intent(in) :: ctcplAhHhSMVZ(3,3)

Complex(dp), Intent(in) :: ZfAh(3,3),ZfHhSM(3,3),ZfVP,ZfVZVP

Complex(dp), Intent(out) :: Amp(2,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
  Do gt2=1,3
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MHhSM(gt2) 
Mex3 = MVP 
ZcoupT1 = 0._dp 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
! Vanishing 


! External Field 2 
! Vanishing 


! External Field 3 
ZcoupT1 = ZcoupT1 + 0.5_dp*ZfVZVP*cplAhHhSMVZ(gt1,gt2)


! Getting the amplitude 
Call TreeAmp_StoSV(Mex1,Mex2,Mex3,ZcoupT1,AmpC) 
Amp(:,gt1, gt2) = AmpC 
  End Do
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_AhToHhSMVP


Subroutine Amplitude_VERTEX_4HDM_S3_AhToHhSMVP(MAh,MFd,MFe,MFu,MHhSM,MHp,             & 
& MVP,MVWp,MAh2,MFd2,MFe2,MFu2,MHhSM2,MHp2,MVP2,MVWp2,cplcFdFdAhL,cplcFdFdAhR,           & 
& cplcFeFeAhL,cplcFeFeAhR,cplcFuFuAhL,cplcFuFuAhR,cplcgWpgWpAh,cplcgWCgWCAh,             & 
& cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplcFdFdHhSML,cplcFdFdHhSMR,cplcFdFdVPL,            & 
& cplcFdFdVPR,cplcFeFeHhSML,cplcFeFeHhSMR,cplcFeFeVPL,cplcFeFeVPR,cplcFuFuHhSML,         & 
& cplcFuFuHhSMR,cplcFuFuVPL,cplcFuFuVPR,cplcgWpgWpHhSM,cplcgWpgWpVP,cplcgWCgWCHhSM,      & 
& cplcgWCgWCVP,cplHhSMHpcHp,cplHhSMHpcVWp,cplHhSMcHpVWp,cplHhSMcVWpVWp,cplHpcHpVP,       & 
& cplHpcVWpVP,cplcHpVPVWp,cplcVWpVPVWp,cplAhHpcVWpVP1,cplAhcHpVPVWp1,cplHhSMHpcVWpVP1,   & 
& cplHhSMcHpVPVWp1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHhSM(3),MHp(3),MVP,MVWp,MAh2(3),MFd2(3),MFe2(3),         & 
& MFu2(3),MHhSM2(3),MHp2(3),MVP2,MVWp2

Complex(dp), Intent(in) :: cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFeFeAhL(3,3,3),cplcFeFeAhR(3,3,3),          & 
& cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcgWpgWpAh(3),cplcgWCgWCAh(3),cplAhHpcHp(3,3,3),& 
& cplAhHpcVWp(3,3),cplAhcHpVWp(3,3),cplcFdFdHhSML(3,3,3),cplcFdFdHhSMR(3,3,3),           & 
& cplcFdFdVPL(3,3),cplcFdFdVPR(3,3),cplcFeFeHhSML(3,3,3),cplcFeFeHhSMR(3,3,3),           & 
& cplcFeFeVPL(3,3),cplcFeFeVPR(3,3),cplcFuFuHhSML(3,3,3),cplcFuFuHhSMR(3,3,3),           & 
& cplcFuFuVPL(3,3),cplcFuFuVPR(3,3),cplcgWpgWpHhSM(3),cplcgWpgWpVP,cplcgWCgWCHhSM(3),    & 
& cplcgWCgWCVP,cplHhSMHpcHp(3,3,3),cplHhSMHpcVWp(3,3),cplHhSMcHpVWp(3,3),cplHhSMcVWpVWp(3),& 
& cplHpcHpVP(3,3),cplHpcVWpVP(3),cplcHpVPVWp(3),cplcVWpVPVWp,cplAhHpcVWpVP1(3,3),        & 
& cplAhcHpVPVWp1(3,3),cplHhSMHpcVWpVP1(3,3),cplHhSMcHpVPVWp1(3,3)

Complex(dp), Intent(out) :: Amp(2,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
Amp(:,gt1, gt2) = 0._dp 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MHhSM(gt2) 
Mex3 = MVP 


! {Fd, Fd, Fd}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFd(i1) 
ML2 = MFd(i2) 
ML3 = MFd(i3) 
coup1L = cplcFdFdAhL(i2,i1,gt1)
coup1R = cplcFdFdAhR(i2,i1,gt1)
coup2L = cplcFdFdHhSML(i1,i3,gt2)
coup2R = cplcFdFdHhSMR(i1,i3,gt2)
coup3L = -cplcFdFdVPR(i3,i2)
coup3R = -cplcFdFdVPL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(6)*AmpC 
    End Do
  End Do
End Do


! {Fe, Fe, Fe}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFe(i1) 
ML2 = MFe(i2) 
ML3 = MFe(i3) 
coup1L = cplcFeFeAhL(i2,i1,gt1)
coup1R = cplcFeFeAhR(i2,i1,gt1)
coup2L = cplcFeFeHhSML(i1,i3,gt2)
coup2R = cplcFeFeHhSMR(i1,i3,gt2)
coup3L = -cplcFeFeVPR(i3,i2)
coup3R = -cplcFeFeVPL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(2)*AmpC 
    End Do
  End Do
End Do


! {Fu, Fu, Fu}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFu(i1) 
ML2 = MFu(i2) 
ML3 = MFu(i3) 
coup1L = cplcFuFuAhL(i2,i1,gt1)
coup1R = cplcFuFuAhR(i2,i1,gt1)
coup2L = cplcFuFuHhSML(i1,i3,gt2)
coup2R = cplcFuFuHhSMR(i1,i3,gt2)
coup3L = -cplcFuFuVPR(i3,i2)
coup3R = -cplcFuFuVPL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(6)*AmpC 
    End Do
  End Do
End Do


! {gWp, gWp, gWp}
ML1 = MVWp 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcgWpgWpAh(gt1)
coup2 = cplcgWpgWpHhSM(gt2)
coup3 = cplcgWpgWpVP
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(2)*AmpC 


! {gWpC, gWpC, gWpC}
ML1 = MVWp 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcgWCgWCAh(gt1)
coup2 = cplcgWCgWCHhSM(gt2)
coup3 = cplcgWCgWCVP
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(2)*AmpC 


! {Hp, Hp, Hp}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplHhSMHpcHp(gt2,i3,i1)
coup3 = -cplHpcHpVP(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(2)*AmpC 
    End Do
  End Do
End Do


! {Hp, VWp, Hp}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = -cplAhHpcVWp(gt1,i1)
coup2 = cplHhSMHpcHp(gt2,i3,i1)
coup3 = cplcHpVPVWp(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, Hp, VWp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplHhSMcHpVWp(gt2,i1)
coup3 = cplHpcVWpVP(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, VWp, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MVWp 
coup1 = -cplAhHpcVWp(gt1,i1)
coup2 = cplHhSMcHpVWp(gt2,i1)
coup3 = cplcVWpVPVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {VWp, Hp, Hp}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = -cplAhcHpVWp(gt1,i2)
coup2 = cplHhSMHpcVWp(gt2,i3)
coup3 = -cplHpcHpVP(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VWp, Hp, VWp}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = -cplAhcHpVWp(gt1,i2)
coup2 = cplHhSMcVWpVWp(gt2)
coup3 = cplHpcVWpVP(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do


! {conj[Hp], conj[VWp], conj[Hp]}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = -cplAhcHpVWp(gt1,i1)
coup2 = cplHhSMHpcHp(gt2,i1,i3)
coup3 = cplHpcVWpVP(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {conj[Hp], conj[Hp], conj[VWp]}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplAhHpcHp(gt1,i2,i1)
coup2 = cplHhSMHpcVWp(gt2,i1)
coup3 = cplcHpVPVWp(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {conj[Hp], conj[VWp], conj[VWp]}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MVWp 
coup1 = -cplAhcHpVWp(gt1,i1)
coup2 = cplHhSMHpcVWp(gt2,i1)
coup3 = -cplcVWpVPVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {conj[VWp], conj[Hp], conj[Hp]}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = -cplAhHpcVWp(gt1,i2)
coup2 = cplHhSMcHpVWp(gt2,i3)
coup3 = cplHpcHpVP(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {conj[VWp], conj[Hp], conj[VWp]}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = -cplAhHpcVWp(gt1,i2)
coup2 = cplHhSMcVWpVWp(gt2)
coup3 = cplcHpVPVWp(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do


! {Hp, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
coup1 = cplAhHpcVWp(gt1,i1)
coup2 = cplHhSMcHpVPVWp1(gt2,i1)
Call Amp_VERTEX_StoSV_Topology2_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {VWp, Hp}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
coup1 = cplAhcHpVWp(gt1,i2)
coup2 = cplHhSMHpcVWpVP1(gt2,i2)
Call Amp_VERTEX_StoSV_Topology2_VS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do


! {Hp, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
coup1 = cplAhHpcVWpVP1(gt1,i1)
coup2 = cplHhSMcHpVWp(gt2,i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology3_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 

End Do


! {VWp, Hp}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
coup1 = cplAhcHpVPVWp1(gt1,i2)
coup2 = cplHhSMHpcVWp(gt2,i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology3_VS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 

  End Do
  End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_AhToHhSMVP


Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhToHhSMVP(MAh,MFd,MFe,MFu,MHhSM,              & 
& MHp,MVP,MVWp,MAh2,MFd2,MFe2,MFu2,MHhSM2,MHp2,MVP2,MVWp2,cplcFdFdAhL,cplcFdFdAhR,       & 
& cplcFeFeAhL,cplcFeFeAhR,cplcFuFuAhL,cplcFuFuAhR,cplcgWpgWpAh,cplcgWCgWCAh,             & 
& cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplcFdFdHhSML,cplcFdFdHhSMR,cplcFdFdVPL,            & 
& cplcFdFdVPR,cplcFeFeHhSML,cplcFeFeHhSMR,cplcFeFeVPL,cplcFeFeVPR,cplcFuFuHhSML,         & 
& cplcFuFuHhSMR,cplcFuFuVPL,cplcFuFuVPR,cplcgWpgWpHhSM,cplcgWpgWpVP,cplcgWCgWCHhSM,      & 
& cplcgWCgWCVP,cplHhSMHpcHp,cplHhSMHpcVWp,cplHhSMcHpVWp,cplHhSMcVWpVWp,cplHpcHpVP,       & 
& cplHpcVWpVP,cplcHpVPVWp,cplcVWpVPVWp,cplAhHpcVWpVP1,cplAhcHpVPVWp1,cplHhSMHpcVWpVP1,   & 
& cplHhSMcHpVPVWp1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHhSM(3),MHp(3),MVP,MVWp,MAh2(3),MFd2(3),MFe2(3),         & 
& MFu2(3),MHhSM2(3),MHp2(3),MVP2,MVWp2

Complex(dp), Intent(in) :: cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFeFeAhL(3,3,3),cplcFeFeAhR(3,3,3),          & 
& cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcgWpgWpAh(3),cplcgWCgWCAh(3),cplAhHpcHp(3,3,3),& 
& cplAhHpcVWp(3,3),cplAhcHpVWp(3,3),cplcFdFdHhSML(3,3,3),cplcFdFdHhSMR(3,3,3),           & 
& cplcFdFdVPL(3,3),cplcFdFdVPR(3,3),cplcFeFeHhSML(3,3,3),cplcFeFeHhSMR(3,3,3),           & 
& cplcFeFeVPL(3,3),cplcFeFeVPR(3,3),cplcFuFuHhSML(3,3,3),cplcFuFuHhSMR(3,3,3),           & 
& cplcFuFuVPL(3,3),cplcFuFuVPR(3,3),cplcgWpgWpHhSM(3),cplcgWpgWpVP,cplcgWCgWCHhSM(3),    & 
& cplcgWCgWCVP,cplHhSMHpcHp(3,3,3),cplHhSMHpcVWp(3,3),cplHhSMcHpVWp(3,3),cplHhSMcVWpVWp(3),& 
& cplHpcHpVP(3,3),cplHpcVWpVP(3),cplcHpVPVWp(3),cplcVWpVPVWp,cplAhHpcVWpVP1(3,3),        & 
& cplAhcHpVPVWp1(3,3),cplHhSMHpcVWpVP1(3,3),cplHhSMcHpVPVWp1(3,3)

Complex(dp), Intent(out) :: Amp(2,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
Amp(:,gt1, gt2) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MHhSM(gt2) 
Mex3 = MVP 
  End Do
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhToHhSMVP


Subroutine Amplitude_WAVE_4HDM_S3_AhTosigasiga(MAh,MAh2,Msiga,Msiga2,ZfAh,            & 
& Zfsiga,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MAh2(3),Msiga,Msiga2

Complex(dp), Intent(in) :: ZfAh(3,3),Zfsiga

Complex(dp), Intent(out) :: Amp(3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
! External masses 
Mex1 = MAh(gt1) 
Mex2 = Msiga 
Mex3 = Msiga 
ZcoupT1 = 0._dp 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
! Vanishing 


! External Field 2 
! Vanishing 


! External Field 3 
! Vanishing 
Amp(gt1) = 0._dp
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_AhTosigasiga


Subroutine Amplitude_VERTEX_4HDM_S3_AhTosigasiga(MAh,MHap,MHp,Msiga,MVWp,             & 
& MAh2,MHap2,MHp2,Msiga2,MVWp2,cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplHapsigacHp,         & 
& cplHapsigacVWp,cplHpsigacHap,cplsigacHapVWp,cplAhHapsigacHp1,cplAhHpsigacHap1,         & 
& cplHpsigasigacHp1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MHap,MHp(3),Msiga,MVWp,MAh2(3),MHap2,MHp2(3),Msiga2,MVWp2

Complex(dp), Intent(in) :: cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),cplAhcHpVWp(3,3),cplHapsigacHp(3),cplHapsigacVWp,  & 
& cplHpsigacHap(3),cplsigacHapVWp,cplAhHapsigacHp1(3,3),cplAhHpsigacHap1(3,3),           & 
& cplHpsigasigacHp1(3,3)

Complex(dp), Intent(out) :: Amp(3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
Amp(gt1) = 0._dp 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = Msiga 
Mex3 = Msiga 


! {Hp, Hp, Hap}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MHap 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplHapsigacHp(i1)
coup3 = cplHpsigacHap(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, VWp, Hap}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MHap 
coup1 = -cplAhHpcVWp(gt1,i1)
coup2 = cplHapsigacHp(i1)
coup3 = cplsigacHapVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
End Do


! {VWp, Hp, Hap}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MHap 
coup1 = -cplAhcHpVWp(gt1,i2)
coup2 = cplHapsigacVWp
coup3 = cplHpsigacHap(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do


! {conj[Hp], conj[Hp], conj[Hap]}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MHap 
coup1 = cplAhHpcHp(gt1,i2,i1)
coup2 = cplHpsigacHap(i1)
coup3 = cplHapsigacHp(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {conj[Hp], conj[VWp], conj[Hap]}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MHap 
coup1 = -cplAhcHpVWp(gt1,i1)
coup2 = cplHpsigacHap(i1)
coup3 = -cplHapsigacVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
End Do


! {conj[VWp], conj[Hp], conj[Hap]}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MHap 
coup1 = -cplAhHpcVWp(gt1,i2)
coup2 = -cplsigacHapVWp
coup3 = cplHapsigacHp(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do


! {Hp, Hp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplHpsigasigacHp1(i2,i1)
Call Amp_VERTEX_StoSS_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hap, Hp}
  Do i2=1,3
ML1 = MHap 
ML2 = MHp(i2) 
coup1 = cplAhHapsigacHp1(gt1,i2)
coup2 = cplHpsigacHap(i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 

  End Do


! {Hp, Hap}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MHap 
coup1 = cplAhHpsigacHap1(gt1,i1)
coup2 = cplHapsigacHp(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 

End Do


! {Hap, Hp}
  Do i2=1,3
ML1 = MHap 
ML2 = MHp(i2) 
coup1 = cplAhHapsigacHp1(gt1,i2)
coup2 = cplHpsigacHap(i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 

  End Do


! {Hp, Hap}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MHap 
coup1 = cplAhHpsigacHap1(gt1,i1)
coup2 = cplHapsigacHp(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 

End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_AhTosigasiga


Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhTosigasiga(MAh,MHap,MHp,Msiga,               & 
& MVWp,MAh2,MHap2,MHp2,Msiga2,MVWp2,cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplHapsigacHp,    & 
& cplHapsigacVWp,cplHpsigacHap,cplsigacHapVWp,cplAhHapsigacHp1,cplAhHpsigacHap1,         & 
& cplHpsigasigacHp1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MHap,MHp(3),Msiga,MVWp,MAh2(3),MHap2,MHp2(3),Msiga2,MVWp2

Complex(dp), Intent(in) :: cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),cplAhcHpVWp(3,3),cplHapsigacHp(3),cplHapsigacVWp,  & 
& cplHpsigacHap(3),cplsigacHapVWp,cplAhHapsigacHp1(3,3),cplAhHpsigacHap1(3,3),           & 
& cplHpsigasigacHp1(3,3)

Complex(dp), Intent(out) :: Amp(3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
Amp(gt1) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = Msiga 
Mex3 = Msiga 
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhTosigasiga


Subroutine Amplitude_WAVE_4HDM_S3_AhToVGVG(MAh,MAh2,MVG,MVG2,ZfAh,ZfVG,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MAh2(3),MVG,MVG2

Complex(dp), Intent(in) :: ZfAh(3,3),ZfVG

Complex(dp), Intent(out) :: Amp(2,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MVG 
Mex3 = MVG 
ZcoupT1 = 0._dp 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
! Vanishing 


! External Field 2 
! Vanishing 


! External Field 3 
Amp(:,gt1) = 0._dp
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_AhToVGVG


Subroutine Amplitude_VERTEX_4HDM_S3_AhToVGVG(MAh,MFd,MFu,MVG,MAh2,MFd2,               & 
& MFu2,MVG2,cplcFdFdAhL,cplcFdFdAhR,cplcFuFuAhL,cplcFuFuAhR,cplcFdFdVGL,cplcFdFdVGR,     & 
& cplcFuFuVGL,cplcFuFuVGR,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFu(3),MVG,MAh2(3),MFd2(3),MFu2(3),MVG2

Complex(dp), Intent(in) :: cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),          & 
& cplcFdFdVGL(3,3),cplcFdFdVGR(3,3),cplcFuFuVGL(3,3),cplcFuFuVGR(3,3)

Complex(dp), Intent(out) :: Amp(2,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
Amp(:,gt1) = 0._dp 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MVG 
Mex3 = MVG 


! {Fd, Fd, Fd}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFd(i1) 
ML2 = MFd(i2) 
ML3 = MFd(i3) 
coup1L = cplcFdFdAhL(i2,i1,gt1)
coup1R = cplcFdFdAhR(i2,i1,gt1)
coup2L = -cplcFdFdVGR(i1,i3)
coup2R = -cplcFdFdVGL(i1,i3)
coup3L = -cplcFdFdVGR(i3,i2)
coup3R = -cplcFdFdVGL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Fu, Fu, Fu}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFu(i1) 
ML2 = MFu(i2) 
ML3 = MFu(i3) 
coup1L = cplcFuFuAhL(i2,i1,gt1)
coup1R = cplcFuFuAhR(i2,i1,gt1)
coup2L = -cplcFuFuVGR(i1,i3)
coup2R = -cplcFuFuVGL(i1,i3)
coup3L = -cplcFuFuVGR(i3,i2)
coup3R = -cplcFuFuVGL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_AhToVGVG


Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhToVGVG(MAh,MFd,MFu,MVG,MAh2,MFd2,            & 
& MFu2,MVG2,cplcFdFdAhL,cplcFdFdAhR,cplcFuFuAhL,cplcFuFuAhR,cplcFdFdVGL,cplcFdFdVGR,     & 
& cplcFuFuVGL,cplcFuFuVGR,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFu(3),MVG,MAh2(3),MFd2(3),MFu2(3),MVG2

Complex(dp), Intent(in) :: cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),          & 
& cplcFdFdVGL(3,3),cplcFdFdVGR(3,3),cplcFuFuVGL(3,3),cplcFuFuVGR(3,3)

Complex(dp), Intent(out) :: Amp(2,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
Amp(:,gt1) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MVG 
Mex3 = MVG 
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhToVGVG


Subroutine Amplitude_WAVE_4HDM_S3_AhToVPVP(MAh,MAh2,MVP,MVP2,ZfAh,ZfVP,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MAh2(3),MVP,MVP2

Complex(dp), Intent(in) :: ZfAh(3,3),ZfVP

Complex(dp), Intent(out) :: Amp(2,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MVP 
Mex3 = MVP 
ZcoupT1 = 0._dp 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
! Vanishing 


! External Field 2 
! Vanishing 


! External Field 3 
Amp(:,gt1) = 0._dp
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_AhToVPVP


Subroutine Amplitude_VERTEX_4HDM_S3_AhToVPVP(MAh,MFd,MFe,MFu,MHp,MVP,MVWp,            & 
& MAh2,MFd2,MFe2,MFu2,MHp2,MVP2,MVWp2,cplcFdFdAhL,cplcFdFdAhR,cplcFeFeAhL,               & 
& cplcFeFeAhR,cplcFuFuAhL,cplcFuFuAhR,cplcgWpgWpAh,cplcgWCgWCAh,cplAhHpcHp,              & 
& cplAhHpcVWp,cplAhcHpVWp,cplcFdFdVPL,cplcFdFdVPR,cplcFeFeVPL,cplcFeFeVPR,               & 
& cplcFuFuVPL,cplcFuFuVPR,cplcgWpgWpVP,cplcgWCgWCVP,cplHpcHpVP,cplHpcVWpVP,              & 
& cplcHpVPVWp,cplcVWpVPVWp,cplAhHpcVWpVP1,cplAhcHpVPVWp1,cplHpcHpVPVP1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHp(3),MVP,MVWp,MAh2(3),MFd2(3),MFe2(3),MFu2(3),          & 
& MHp2(3),MVP2,MVWp2

Complex(dp), Intent(in) :: cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFeFeAhL(3,3,3),cplcFeFeAhR(3,3,3),          & 
& cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcgWpgWpAh(3),cplcgWCgWCAh(3),cplAhHpcHp(3,3,3),& 
& cplAhHpcVWp(3,3),cplAhcHpVWp(3,3),cplcFdFdVPL(3,3),cplcFdFdVPR(3,3),cplcFeFeVPL(3,3),  & 
& cplcFeFeVPR(3,3),cplcFuFuVPL(3,3),cplcFuFuVPR(3,3),cplcgWpgWpVP,cplcgWCgWCVP,          & 
& cplHpcHpVP(3,3),cplHpcVWpVP(3),cplcHpVPVWp(3),cplcVWpVPVWp,cplAhHpcVWpVP1(3,3),        & 
& cplAhcHpVPVWp1(3,3),cplHpcHpVPVP1(3,3)

Complex(dp), Intent(out) :: Amp(2,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
Amp(:,gt1) = 0._dp 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MVP 
Mex3 = MVP 


! {Fd, Fd, Fd}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFd(i1) 
ML2 = MFd(i2) 
ML3 = MFd(i3) 
coup1L = cplcFdFdAhL(i2,i1,gt1)
coup1R = cplcFdFdAhR(i2,i1,gt1)
coup2L = -cplcFdFdVPR(i1,i3)
coup2R = -cplcFdFdVPL(i1,i3)
coup3L = -cplcFdFdVPR(i3,i2)
coup3R = -cplcFdFdVPL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(6)*AmpC 
    End Do
  End Do
End Do


! {Fe, Fe, Fe}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFe(i1) 
ML2 = MFe(i2) 
ML3 = MFe(i3) 
coup1L = cplcFeFeAhL(i2,i1,gt1)
coup1R = cplcFeFeAhR(i2,i1,gt1)
coup2L = -cplcFeFeVPR(i1,i3)
coup2R = -cplcFeFeVPL(i1,i3)
coup3L = -cplcFeFeVPR(i3,i2)
coup3R = -cplcFeFeVPL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(2)*AmpC 
    End Do
  End Do
End Do


! {Fu, Fu, Fu}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFu(i1) 
ML2 = MFu(i2) 
ML3 = MFu(i3) 
coup1L = cplcFuFuAhL(i2,i1,gt1)
coup1R = cplcFuFuAhR(i2,i1,gt1)
coup2L = -cplcFuFuVPR(i1,i3)
coup2R = -cplcFuFuVPL(i1,i3)
coup3L = -cplcFuFuVPR(i3,i2)
coup3R = -cplcFuFuVPL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(6)*AmpC 
    End Do
  End Do
End Do


! {gWp, gWp, gWp}
ML1 = MVWp 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcgWpgWpAh(gt1)
coup2 = cplcgWpgWpVP
coup3 = cplcgWpgWpVP
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(2)*AmpC 


! {gWpC, gWpC, gWpC}
ML1 = MVWp 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcgWCgWCAh(gt1)
coup2 = cplcgWCgWCVP
coup3 = cplcgWCgWCVP
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(2)*AmpC 


! {Hp, Hp, Hp}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = -cplHpcHpVP(i3,i1)
coup3 = -cplHpcHpVP(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(2)*AmpC 
    End Do
  End Do
End Do


! {Hp, VWp, Hp}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = cplAhHpcVWp(gt1,i1)
coup2 = -cplHpcHpVP(i3,i1)
coup3 = cplcHpVPVWp(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, Hp, VWp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplcHpVPVWp(i1)
coup3 = cplHpcVWpVP(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, VWp, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplAhHpcVWp(gt1,i1)
coup2 = cplcHpVPVWp(i1)
coup3 = cplcVWpVPVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
End Do


! {VWp, Hp, Hp}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplAhcHpVWp(gt1,i2)
coup2 = cplHpcVWpVP(i3)
coup3 = -cplHpcHpVP(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VWp, Hp, VWp}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplAhcHpVWp(gt1,i2)
coup2 = cplcVWpVPVWp
coup3 = cplHpcVWpVP(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
  End Do


! {conj[Hp], conj[VWp], conj[Hp]}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = cplAhcHpVWp(gt1,i1)
coup2 = cplHpcHpVP(i1,i3)
coup3 = cplHpcVWpVP(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {conj[Hp], conj[Hp], conj[VWp]}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplAhHpcHp(gt1,i2,i1)
coup2 = cplHpcVWpVP(i1)
coup3 = cplcHpVPVWp(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {conj[Hp], conj[VWp], conj[VWp]}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplAhcHpVWp(gt1,i1)
coup2 = cplHpcVWpVP(i1)
coup3 = -cplcVWpVPVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
End Do


! {conj[VWp], conj[Hp], conj[Hp]}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplAhHpcVWp(gt1,i2)
coup2 = cplcHpVPVWp(i3)
coup3 = cplHpcHpVP(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {conj[VWp], conj[Hp], conj[VWp]}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplAhHpcVWp(gt1,i2)
coup2 = -cplcVWpVPVWp
coup3 = cplcHpVPVWp(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
  End Do


! {Hp, Hp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplHpcHpVPVP1(i2,i1)
Call Amp_VERTEX_StoVV_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
coup1 = cplAhHpcVWpVP1(gt1,i1)
coup2 = cplcHpVPVWp(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology3_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 

End Do


! {VWp, Hp}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
coup1 = cplAhcHpVPVWp1(gt1,i2)
coup2 = cplHpcVWpVP(i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology3_VS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 

  End Do


! {Hp, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
coup1 = cplAhHpcVWpVP1(gt1,i1)
coup2 = cplcHpVPVWp(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology4_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 

End Do


! {VWp, Hp}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
coup1 = cplAhcHpVPVWp1(gt1,i2)
coup2 = cplHpcVWpVP(i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology4_VS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 

  End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_AhToVPVP


Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhToVPVP(MAh,MFd,MFe,MFu,MHp,MVP,              & 
& MVWp,MAh2,MFd2,MFe2,MFu2,MHp2,MVP2,MVWp2,cplcFdFdAhL,cplcFdFdAhR,cplcFeFeAhL,          & 
& cplcFeFeAhR,cplcFuFuAhL,cplcFuFuAhR,cplcgWpgWpAh,cplcgWCgWCAh,cplAhHpcHp,              & 
& cplAhHpcVWp,cplAhcHpVWp,cplcFdFdVPL,cplcFdFdVPR,cplcFeFeVPL,cplcFeFeVPR,               & 
& cplcFuFuVPL,cplcFuFuVPR,cplcgWpgWpVP,cplcgWCgWCVP,cplHpcHpVP,cplHpcVWpVP,              & 
& cplcHpVPVWp,cplcVWpVPVWp,cplAhHpcVWpVP1,cplAhcHpVPVWp1,cplHpcHpVPVP1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHp(3),MVP,MVWp,MAh2(3),MFd2(3),MFe2(3),MFu2(3),          & 
& MHp2(3),MVP2,MVWp2

Complex(dp), Intent(in) :: cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFeFeAhL(3,3,3),cplcFeFeAhR(3,3,3),          & 
& cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcgWpgWpAh(3),cplcgWCgWCAh(3),cplAhHpcHp(3,3,3),& 
& cplAhHpcVWp(3,3),cplAhcHpVWp(3,3),cplcFdFdVPL(3,3),cplcFdFdVPR(3,3),cplcFeFeVPL(3,3),  & 
& cplcFeFeVPR(3,3),cplcFuFuVPL(3,3),cplcFuFuVPR(3,3),cplcgWpgWpVP,cplcgWCgWCVP,          & 
& cplHpcHpVP(3,3),cplHpcVWpVP(3),cplcHpVPVWp(3),cplcVWpVPVWp,cplAhHpcVWpVP1(3,3),        & 
& cplAhcHpVPVWp1(3,3),cplHpcHpVPVP1(3,3)

Complex(dp), Intent(out) :: Amp(2,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
Amp(:,gt1) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MVP 
Mex3 = MVP 
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhToVPVP


Subroutine Amplitude_WAVE_4HDM_S3_AhToVPVZ(MAh,MAh2,MVP,MVP2,MVZ,MVZ2,ZfAh,           & 
& ZfVP,ZfVZ,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MAh2(3),MVP,MVP2,MVZ,MVZ2

Complex(dp), Intent(in) :: ZfAh(3,3),ZfVP,ZfVZ

Complex(dp), Intent(out) :: Amp(2,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MVP 
Mex3 = MVZ 
ZcoupT1 = 0._dp 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
! Vanishing 


! External Field 2 
! Vanishing 


! External Field 3 
Amp(:,gt1) = 0._dp
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_AhToVPVZ


Subroutine Amplitude_VERTEX_4HDM_S3_AhToVPVZ(MAh,MFd,MFe,MFu,MHp,MVP,MVWp,            & 
& MVZ,MAh2,MFd2,MFe2,MFu2,MHp2,MVP2,MVWp2,MVZ2,cplcFdFdAhL,cplcFdFdAhR,cplcFeFeAhL,      & 
& cplcFeFeAhR,cplcFuFuAhL,cplcFuFuAhR,cplcgWpgWpAh,cplcgWCgWCAh,cplAhHpcHp,              & 
& cplAhHpcVWp,cplAhcHpVWp,cplcFdFdVPL,cplcFdFdVPR,cplcFdFdVZL,cplcFdFdVZR,               & 
& cplcFeFeVPL,cplcFeFeVPR,cplcFeFeVZL,cplcFeFeVZR,cplcFuFuVPL,cplcFuFuVPR,               & 
& cplcFuFuVZL,cplcFuFuVZR,cplcgWpgWpVP,cplcgWpgWpVZ,cplcgWCgWCVP,cplcgWCgWCVZ,           & 
& cplHpcHpVP,cplHpcVWpVP,cplHpcHpVZ,cplHpcVWpVZ,cplcHpVPVWp,cplcVWpVPVWp,cplcHpVWpVZ,    & 
& cplcVWpVWpVZ,cplAhHpcVWpVP1,cplAhHpcVWpVZ1,cplAhcHpVPVWp1,cplAhcHpVWpVZ1,              & 
& cplHpcHpVPVZ1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHp(3),MVP,MVWp,MVZ,MAh2(3),MFd2(3),MFe2(3),              & 
& MFu2(3),MHp2(3),MVP2,MVWp2,MVZ2

Complex(dp), Intent(in) :: cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFeFeAhL(3,3,3),cplcFeFeAhR(3,3,3),          & 
& cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcgWpgWpAh(3),cplcgWCgWCAh(3),cplAhHpcHp(3,3,3),& 
& cplAhHpcVWp(3,3),cplAhcHpVWp(3,3),cplcFdFdVPL(3,3),cplcFdFdVPR(3,3),cplcFdFdVZL(3,3),  & 
& cplcFdFdVZR(3,3),cplcFeFeVPL(3,3),cplcFeFeVPR(3,3),cplcFeFeVZL(3,3),cplcFeFeVZR(3,3),  & 
& cplcFuFuVPL(3,3),cplcFuFuVPR(3,3),cplcFuFuVZL(3,3),cplcFuFuVZR(3,3),cplcgWpgWpVP,      & 
& cplcgWpgWpVZ,cplcgWCgWCVP,cplcgWCgWCVZ,cplHpcHpVP(3,3),cplHpcVWpVP(3),cplHpcHpVZ(3,3), & 
& cplHpcVWpVZ(3),cplcHpVPVWp(3),cplcVWpVPVWp,cplcHpVWpVZ(3),cplcVWpVWpVZ,cplAhHpcVWpVP1(3,3),& 
& cplAhHpcVWpVZ1(3,3),cplAhcHpVPVWp1(3,3),cplAhcHpVWpVZ1(3,3),cplHpcHpVPVZ1(3,3)

Complex(dp), Intent(out) :: Amp(2,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
Amp(:,gt1) = 0._dp 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MVP 
Mex3 = MVZ 


! {Fd, Fd, Fd}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFd(i1) 
ML2 = MFd(i2) 
ML3 = MFd(i3) 
coup1L = cplcFdFdAhL(i2,i1,gt1)
coup1R = cplcFdFdAhR(i2,i1,gt1)
coup2L = -cplcFdFdVPR(i1,i3)
coup2R = -cplcFdFdVPL(i1,i3)
coup3L = -cplcFdFdVZR(i3,i2)
coup3R = -cplcFdFdVZL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(6)*AmpC 
    End Do
  End Do
End Do


! {Fe, Fe, Fe}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFe(i1) 
ML2 = MFe(i2) 
ML3 = MFe(i3) 
coup1L = cplcFeFeAhL(i2,i1,gt1)
coup1R = cplcFeFeAhR(i2,i1,gt1)
coup2L = -cplcFeFeVPR(i1,i3)
coup2R = -cplcFeFeVPL(i1,i3)
coup3L = -cplcFeFeVZR(i3,i2)
coup3R = -cplcFeFeVZL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(2)*AmpC 
    End Do
  End Do
End Do


! {Fu, Fu, Fu}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFu(i1) 
ML2 = MFu(i2) 
ML3 = MFu(i3) 
coup1L = cplcFuFuAhL(i2,i1,gt1)
coup1R = cplcFuFuAhR(i2,i1,gt1)
coup2L = -cplcFuFuVPR(i1,i3)
coup2R = -cplcFuFuVPL(i1,i3)
coup3L = -cplcFuFuVZR(i3,i2)
coup3R = -cplcFuFuVZL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(6)*AmpC 
    End Do
  End Do
End Do


! {gWp, gWp, gWp}
ML1 = MVWp 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcgWpgWpAh(gt1)
coup2 = cplcgWpgWpVP
coup3 = cplcgWpgWpVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(2)*AmpC 


! {gWpC, gWpC, gWpC}
ML1 = MVWp 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcgWCgWCAh(gt1)
coup2 = cplcgWCgWCVP
coup3 = cplcgWCgWCVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(2)*AmpC 


! {Hp, Hp, Hp}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = -cplHpcHpVP(i3,i1)
coup3 = -cplHpcHpVZ(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(2)*AmpC 
    End Do
  End Do
End Do


! {Hp, VWp, Hp}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = cplAhHpcVWp(gt1,i1)
coup2 = -cplHpcHpVP(i3,i1)
coup3 = cplcHpVWpVZ(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, Hp, VWp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplcHpVPVWp(i1)
coup3 = cplHpcVWpVZ(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, VWp, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplAhHpcVWp(gt1,i1)
coup2 = cplcHpVPVWp(i1)
coup3 = -cplcVWpVWpVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
End Do


! {VWp, Hp, Hp}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplAhcHpVWp(gt1,i2)
coup2 = cplHpcVWpVP(i3)
coup3 = -cplHpcHpVZ(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VWp, Hp, VWp}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplAhcHpVWp(gt1,i2)
coup2 = cplcVWpVPVWp
coup3 = cplHpcVWpVZ(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
  End Do


! {conj[Hp], conj[VWp], conj[Hp]}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = cplAhcHpVWp(gt1,i1)
coup2 = cplHpcHpVP(i1,i3)
coup3 = cplHpcVWpVZ(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {conj[Hp], conj[Hp], conj[VWp]}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplAhHpcHp(gt1,i2,i1)
coup2 = cplHpcVWpVP(i1)
coup3 = cplcHpVWpVZ(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {conj[Hp], conj[VWp], conj[VWp]}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplAhcHpVWp(gt1,i1)
coup2 = cplHpcVWpVP(i1)
coup3 = cplcVWpVWpVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
End Do


! {conj[VWp], conj[Hp], conj[Hp]}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplAhHpcVWp(gt1,i2)
coup2 = cplcHpVPVWp(i3)
coup3 = cplHpcHpVZ(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {conj[VWp], conj[Hp], conj[VWp]}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplAhHpcVWp(gt1,i2)
coup2 = -cplcVWpVPVWp
coup3 = cplcHpVWpVZ(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
  End Do


! {Hp, Hp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplHpcHpVPVZ1(i2,i1)
Call Amp_VERTEX_StoVV_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
coup1 = cplAhHpcVWpVZ1(gt1,i1)
coup2 = cplcHpVPVWp(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology3_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 

End Do


! {VWp, Hp}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
coup1 = cplAhcHpVWpVZ1(gt1,i2)
coup2 = cplHpcVWpVP(i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology3_VS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 

  End Do


! {Hp, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
coup1 = cplAhHpcVWpVP1(gt1,i1)
coup2 = cplcHpVWpVZ(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology4_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 

End Do


! {VWp, Hp}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
coup1 = cplAhcHpVPVWp1(gt1,i2)
coup2 = cplHpcVWpVZ(i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology4_VS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 

  End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_AhToVPVZ


Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhToVPVZ(MAh,MFd,MFe,MFu,MHp,MVP,              & 
& MVWp,MVZ,MAh2,MFd2,MFe2,MFu2,MHp2,MVP2,MVWp2,MVZ2,cplcFdFdAhL,cplcFdFdAhR,             & 
& cplcFeFeAhL,cplcFeFeAhR,cplcFuFuAhL,cplcFuFuAhR,cplcgWpgWpAh,cplcgWCgWCAh,             & 
& cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplcFdFdVPL,cplcFdFdVPR,cplcFdFdVZL,cplcFdFdVZR,    & 
& cplcFeFeVPL,cplcFeFeVPR,cplcFeFeVZL,cplcFeFeVZR,cplcFuFuVPL,cplcFuFuVPR,               & 
& cplcFuFuVZL,cplcFuFuVZR,cplcgWpgWpVP,cplcgWpgWpVZ,cplcgWCgWCVP,cplcgWCgWCVZ,           & 
& cplHpcHpVP,cplHpcVWpVP,cplHpcHpVZ,cplHpcVWpVZ,cplcHpVPVWp,cplcVWpVPVWp,cplcHpVWpVZ,    & 
& cplcVWpVWpVZ,cplAhHpcVWpVP1,cplAhHpcVWpVZ1,cplAhcHpVPVWp1,cplAhcHpVWpVZ1,              & 
& cplHpcHpVPVZ1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHp(3),MVP,MVWp,MVZ,MAh2(3),MFd2(3),MFe2(3),              & 
& MFu2(3),MHp2(3),MVP2,MVWp2,MVZ2

Complex(dp), Intent(in) :: cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFeFeAhL(3,3,3),cplcFeFeAhR(3,3,3),          & 
& cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcgWpgWpAh(3),cplcgWCgWCAh(3),cplAhHpcHp(3,3,3),& 
& cplAhHpcVWp(3,3),cplAhcHpVWp(3,3),cplcFdFdVPL(3,3),cplcFdFdVPR(3,3),cplcFdFdVZL(3,3),  & 
& cplcFdFdVZR(3,3),cplcFeFeVPL(3,3),cplcFeFeVPR(3,3),cplcFeFeVZL(3,3),cplcFeFeVZR(3,3),  & 
& cplcFuFuVPL(3,3),cplcFuFuVPR(3,3),cplcFuFuVZL(3,3),cplcFuFuVZR(3,3),cplcgWpgWpVP,      & 
& cplcgWpgWpVZ,cplcgWCgWCVP,cplcgWCgWCVZ,cplHpcHpVP(3,3),cplHpcVWpVP(3),cplHpcHpVZ(3,3), & 
& cplHpcVWpVZ(3),cplcHpVPVWp(3),cplcVWpVPVWp,cplcHpVWpVZ(3),cplcVWpVWpVZ,cplAhHpcVWpVP1(3,3),& 
& cplAhHpcVWpVZ1(3,3),cplAhcHpVPVWp1(3,3),cplAhcHpVWpVZ1(3,3),cplHpcHpVPVZ1(3,3)

Complex(dp), Intent(out) :: Amp(2,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
Amp(:,gt1) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MVP 
Mex3 = MVZ 
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhToVPVZ


Subroutine Amplitude_WAVE_4HDM_S3_AhToVWpcVWp(MAh,MAh2,MVWp,MVWp2,ZfAh,               & 
& ZfVWp,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MAh2(3),MVWp,MVWp2

Complex(dp), Intent(in) :: ZfAh(3,3),ZfVWp

Complex(dp), Intent(out) :: Amp(2,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MVWp 
Mex3 = MVWp 
ZcoupT1 = 0._dp 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
! Vanishing 


! External Field 2 
! Vanishing 


! External Field 3 
Amp(:,gt1) = 0._dp
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_AhToVWpcVWp


Subroutine Amplitude_VERTEX_4HDM_S3_AhToVWpcVWp(MAh,MFd,MFe,MFu,MHap,Mhha,            & 
& MHhSM,MHp,Msiga,MVP,MVWp,MVZ,MAh2,MFd2,MFe2,MFu2,MHap2,Mhha2,MHhSM2,MHp2,              & 
& Msiga2,MVP2,MVWp2,MVZ2,cplAhAhHhSM,cplcFdFdAhL,cplcFdFdAhR,cplcFeFeAhL,cplcFeFeAhR,    & 
& cplcFuFuAhL,cplcFuFuAhR,cplcgWpgWpAh,cplcgWCgWCAh,cplAhhhasiga,cplAhHhSMVZ,            & 
& cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplcFuFdVWpL,cplcFuFdVWpR,cplcFvFeVWpL,             & 
& cplcFvFeVWpR,cplcFdFucVWpL,cplcFdFucVWpR,cplcFeFvcVWpL,cplcFeFvcVWpR,cplcgWpgAVWp,     & 
& cplcgWCgAcVWp,cplcgAgWpcVWp,cplcgZgWpcVWp,cplcgAgWCVWp,cplcgZgWCVWp,cplcgWpgZVWp,      & 
& cplcgWCgZcVWp,cplHaphhacVWp,cplHapsigacVWp,cplhhacHapVWp,cplHhSMHpcVWp,cplHhSMcHpVWp,  & 
& cplHhSMcVWpVWp,cplHpcVWpVP,cplHpcVWpVZ,cplsigacHapVWp,cplcHpVPVWp,cplcVWpVPVWp,        & 
& cplcHpVWpVZ,cplcVWpVWpVZ,cplAhHpcVWpVP1,cplAhHpcVWpVZ1,cplAhcHpVPVWp1,cplAhcHpVWpVZ1,  & 
& cplHpcHpcVWpVWp1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHap,Mhha,MHhSM(3),MHp(3),Msiga,MVP,MVWp,MVZ,             & 
& MAh2(3),MFd2(3),MFe2(3),MFu2(3),MHap2,Mhha2,MHhSM2(3),MHp2(3),Msiga2,MVP2,             & 
& MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhAhHhSM(3,3,3),cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFeFeAhL(3,3,3),          & 
& cplcFeFeAhR(3,3,3),cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcgWpgWpAh(3),              & 
& cplcgWCgWCAh(3),cplAhhhasiga(3),cplAhHhSMVZ(3,3),cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),   & 
& cplAhcHpVWp(3,3),cplcFuFdVWpL(3,3),cplcFuFdVWpR(3,3),cplcFvFeVWpL(3,3),cplcFvFeVWpR(3,3),& 
& cplcFdFucVWpL(3,3),cplcFdFucVWpR(3,3),cplcFeFvcVWpL(3,3),cplcFeFvcVWpR(3,3),           & 
& cplcgWpgAVWp,cplcgWCgAcVWp,cplcgAgWpcVWp,cplcgZgWpcVWp,cplcgAgWCVWp,cplcgZgWCVWp,      & 
& cplcgWpgZVWp,cplcgWCgZcVWp,cplHaphhacVWp,cplHapsigacVWp,cplhhacHapVWp,cplHhSMHpcVWp(3,3),& 
& cplHhSMcHpVWp(3,3),cplHhSMcVWpVWp(3),cplHpcVWpVP(3),cplHpcVWpVZ(3),cplsigacHapVWp,     & 
& cplcHpVPVWp(3),cplcVWpVPVWp,cplcHpVWpVZ(3),cplcVWpVWpVZ,cplAhHpcVWpVP1(3,3),           & 
& cplAhHpcVWpVZ1(3,3),cplAhcHpVPVWp1(3,3),cplAhcHpVWpVZ1(3,3),cplHpcHpcVWpVWp1(3,3)

Complex(dp), Intent(out) :: Amp(2,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
Amp(:,gt1) = 0._dp 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MVWp 
Mex3 = MVWp 


! {Ah, HhSM, conj[Hp]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MAh(i1) 
ML2 = MHhSM(i2) 
ML3 = MHp(i3) 
coup1 = cplAhAhHhSM(gt1,i1,i2)
coup2 = cplAhcHpVWp(i1,i3)
coup3 = -cplHhSMHpcVWp(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Fu, Fu, Fd}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFu(i1) 
ML2 = MFu(i2) 
ML3 = MFd(i3) 
coup1L = cplcFuFuAhL(i2,i1,gt1)
coup1R = cplcFuFuAhR(i2,i1,gt1)
coup2L = -cplcFuFdVWpR(i1,i3)
coup2R = -cplcFuFdVWpL(i1,i3)
coup3L = -cplcFdFucVWpR(i3,i2)
coup3R = -cplcFdFucVWpL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(3)*AmpC 
    End Do
  End Do
End Do


! {gWp, gWp, gP}
ML1 = MVWp 
ML2 = MVWp 
ML3 = MVP 
coup1 = cplcgWpgWpAh(gt1)
coup2 = cplcgWpgAVWp
coup3 = cplcgAgWpcVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {gWp, gWp, gZ}
ML1 = MVWp 
ML2 = MVWp 
ML3 = MVZ 
coup1 = cplcgWpgWpAh(gt1)
coup2 = cplcgWpgZVWp
coup3 = cplcgZgWpcVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {hha, siga, conj[Hap]}
ML1 = Mhha 
ML2 = Msiga 
ML3 = MHap 
coup1 = cplAhhhasiga(gt1)
coup2 = cplhhacHapVWp
coup3 = cplHapsigacVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {HhSM, Ah, conj[Hp]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHhSM(i1) 
ML2 = MAh(i2) 
ML3 = MHp(i3) 
coup1 = cplAhAhHhSM(gt1,i2,i1)
coup2 = cplHhSMcHpVWp(i1,i3)
coup3 = -cplAhHpcVWp(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {HhSM, VZ, conj[Hp]}
Do i1=1,3
    Do i3=1,3
ML1 = MHhSM(i1) 
ML2 = MVZ 
ML3 = MHp(i3) 
coup1 = cplAhHhSMVZ(gt1,i1)
coup2 = cplHhSMcHpVWp(i1,i3)
coup3 = cplHpcVWpVZ(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {HhSM, VZ, conj[VWp]}
Do i1=1,3
ML1 = MHhSM(i1) 
ML2 = MVZ 
ML3 = MVWp 
coup1 = cplAhHhSMVZ(gt1,i1)
coup2 = cplHhSMcVWpVWp(i1)
coup3 = -cplcVWpVWpVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
End Do


! {Hp, Hp, Ah}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MAh(i3) 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = -cplAhcHpVWp(i3,i1)
coup3 = cplAhHpcVWp(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Hp, Hp, HhSM}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MHhSM(i3) 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = -cplHhSMcHpVWp(i3,i1)
coup3 = cplHhSMHpcVWp(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Hp, VWp, HhSM}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MHhSM(i3) 
coup1 = cplAhHpcVWp(gt1,i1)
coup2 = -cplHhSMcHpVWp(i3,i1)
coup3 = cplHhSMcVWpVWp(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, Hp, VP}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MVP 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplcHpVPVWp(i1)
coup3 = cplHpcVWpVP(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, VWp, VP}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MVP 
coup1 = cplAhHpcVWp(gt1,i1)
coup2 = cplcHpVPVWp(i1)
coup3 = -cplcVWpVPVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
End Do


! {Hp, Hp, VZ}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MVZ 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplcHpVWpVZ(i1)
coup3 = cplHpcVWpVZ(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, VWp, VZ}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MVZ 
coup1 = cplAhHpcVWp(gt1,i1)
coup2 = cplcHpVWpVZ(i1)
coup3 = cplcVWpVWpVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
End Do


! {siga, hha, conj[Hap]}
ML1 = Msiga 
ML2 = Mhha 
ML3 = MHap 
coup1 = cplAhhhasiga(gt1)
coup2 = cplsigacHapVWp
coup3 = cplHaphhacVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {VWp, Hp, HhSM}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MHhSM(i3) 
coup1 = cplAhcHpVWp(gt1,i2)
coup2 = cplHhSMcVWpVWp(i3)
coup3 = cplHhSMHpcVWp(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VWp, Hp, VP}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MVP 
coup1 = cplAhcHpVWp(gt1,i2)
coup2 = -cplcVWpVPVWp
coup3 = cplHpcVWpVP(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
  End Do


! {VWp, Hp, VZ}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MVZ 
coup1 = cplAhcHpVWp(gt1,i2)
coup2 = cplcVWpVWpVZ
coup3 = cplHpcVWpVZ(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
  End Do


! {VZ, HhSM, conj[Hp]}
  Do i2=1,3
    Do i3=1,3
ML1 = MVZ 
ML2 = MHhSM(i2) 
ML3 = MHp(i3) 
coup1 = cplAhHhSMVZ(gt1,i2)
coup2 = cplcHpVWpVZ(i3)
coup3 = -cplHhSMHpcVWp(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VZ, HhSM, conj[VWp]}
  Do i2=1,3
ML1 = MVZ 
ML2 = MHhSM(i2) 
ML3 = MVWp 
coup1 = cplAhHhSMVZ(gt1,i2)
coup2 = -cplcVWpVWpVZ
coup3 = cplHhSMcVWpVWp(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
  End Do


! {bar[Fd], bar[Fd], bar[Fu]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFd(i1) 
ML2 = MFd(i2) 
ML3 = MFu(i3) 
coup1L = cplcFdFdAhL(i1,i2,gt1)
coup1R = cplcFdFdAhR(i1,i2,gt1)
coup2L = cplcFuFdVWpL(i3,i1)
coup2R = cplcFuFdVWpR(i3,i1)
coup3L = cplcFdFucVWpL(i2,i3)
coup3R = cplcFdFucVWpR(i2,i3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(3)*AmpC 
    End Do
  End Do
End Do


! {bar[Fe], bar[Fe], bar[Fv]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFe(i1) 
ML2 = MFe(i2) 
ML3 = 0. 
coup1L = cplcFeFeAhL(i1,i2,gt1)
coup1R = cplcFeFeAhR(i1,i2,gt1)
coup2L = cplcFvFeVWpL(i3,i1)
coup2R = cplcFvFeVWpR(i3,i1)
coup3L = cplcFeFvcVWpL(i2,i3)
coup3R = cplcFeFvcVWpR(i2,i3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {bar[gWpC], bar[gWpC], bar[gP]}
ML1 = MVWp 
ML2 = MVWp 
ML3 = MVP 
coup1 = cplcgWCgWCAh(gt1)
coup2 = cplcgAgWCVWp
coup3 = cplcgWCgAcVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {bar[gWpC], bar[gWpC], bar[gZ]}
ML1 = MVWp 
ML2 = MVWp 
ML3 = MVZ 
coup1 = cplcgWCgWCAh(gt1)
coup2 = cplcgZgWCVWp
coup3 = cplcgWCgZcVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {Hp, Hp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplHpcHpcVWpVWp1(i2,i1)
Call Amp_VERTEX_StoVV_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, VP}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVP 
coup1 = cplAhHpcVWpVP1(gt1,i1)
coup2 = cplcHpVPVWp(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology3_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 

End Do


! {Hp, VZ}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVZ 
coup1 = cplAhHpcVWpVZ1(gt1,i1)
coup2 = cplcHpVWpVZ(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology3_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 

End Do


! {VP, Hp}
  Do i2=1,3
ML1 = MVP 
ML2 = MHp(i2) 
coup1 = cplAhcHpVPVWp1(gt1,i2)
coup2 = cplHpcVWpVP(i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology4_VS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 

  End Do


! {VZ, Hp}
  Do i2=1,3
ML1 = MVZ 
ML2 = MHp(i2) 
coup1 = cplAhcHpVWpVZ1(gt1,i2)
coup2 = cplHpcVWpVZ(i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology4_VS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 

  End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_AhToVWpcVWp


Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhToVWpcVWp(MAh,MFd,MFe,MFu,MHap,              & 
& Mhha,MHhSM,MHp,Msiga,MVP,MVWp,MVZ,MAh2,MFd2,MFe2,MFu2,MHap2,Mhha2,MHhSM2,              & 
& MHp2,Msiga2,MVP2,MVWp2,MVZ2,cplAhAhHhSM,cplcFdFdAhL,cplcFdFdAhR,cplcFeFeAhL,           & 
& cplcFeFeAhR,cplcFuFuAhL,cplcFuFuAhR,cplcgWpgWpAh,cplcgWCgWCAh,cplAhhhasiga,            & 
& cplAhHhSMVZ,cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplcFuFdVWpL,cplcFuFdVWpR,              & 
& cplcFvFeVWpL,cplcFvFeVWpR,cplcFdFucVWpL,cplcFdFucVWpR,cplcFeFvcVWpL,cplcFeFvcVWpR,     & 
& cplcgWpgAVWp,cplcgWCgAcVWp,cplcgAgWpcVWp,cplcgZgWpcVWp,cplcgAgWCVWp,cplcgZgWCVWp,      & 
& cplcgWpgZVWp,cplcgWCgZcVWp,cplHaphhacVWp,cplHapsigacVWp,cplhhacHapVWp,cplHhSMHpcVWp,   & 
& cplHhSMcHpVWp,cplHhSMcVWpVWp,cplHpcVWpVP,cplHpcVWpVZ,cplsigacHapVWp,cplcHpVPVWp,       & 
& cplcVWpVPVWp,cplcHpVWpVZ,cplcVWpVWpVZ,cplAhHpcVWpVP1,cplAhHpcVWpVZ1,cplAhcHpVPVWp1,    & 
& cplAhcHpVWpVZ1,cplHpcHpcVWpVWp1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHap,Mhha,MHhSM(3),MHp(3),Msiga,MVP,MVWp,MVZ,             & 
& MAh2(3),MFd2(3),MFe2(3),MFu2(3),MHap2,Mhha2,MHhSM2(3),MHp2(3),Msiga2,MVP2,             & 
& MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhAhHhSM(3,3,3),cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFeFeAhL(3,3,3),          & 
& cplcFeFeAhR(3,3,3),cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcgWpgWpAh(3),              & 
& cplcgWCgWCAh(3),cplAhhhasiga(3),cplAhHhSMVZ(3,3),cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),   & 
& cplAhcHpVWp(3,3),cplcFuFdVWpL(3,3),cplcFuFdVWpR(3,3),cplcFvFeVWpL(3,3),cplcFvFeVWpR(3,3),& 
& cplcFdFucVWpL(3,3),cplcFdFucVWpR(3,3),cplcFeFvcVWpL(3,3),cplcFeFvcVWpR(3,3),           & 
& cplcgWpgAVWp,cplcgWCgAcVWp,cplcgAgWpcVWp,cplcgZgWpcVWp,cplcgAgWCVWp,cplcgZgWCVWp,      & 
& cplcgWpgZVWp,cplcgWCgZcVWp,cplHaphhacVWp,cplHapsigacVWp,cplhhacHapVWp,cplHhSMHpcVWp(3,3),& 
& cplHhSMcHpVWp(3,3),cplHhSMcVWpVWp(3),cplHpcVWpVP(3),cplHpcVWpVZ(3),cplsigacHapVWp,     & 
& cplcHpVPVWp(3),cplcVWpVPVWp,cplcHpVWpVZ(3),cplcVWpVWpVZ,cplAhHpcVWpVP1(3,3),           & 
& cplAhHpcVWpVZ1(3,3),cplAhcHpVPVWp1(3,3),cplAhcHpVWpVZ1(3,3),cplHpcHpcVWpVWp1(3,3)

Complex(dp), Intent(out) :: Amp(2,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
Amp(:,gt1) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MVWp 
Mex3 = MVWp 


! {Hp, Hp, VP}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MVP 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplcHpVPVWp(i1)
coup3 = cplHpcVWpVP(i2)
Call Amp_VERTEX_StoVV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, VWp, VP}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MVP 
coup1 = cplAhHpcVWp(gt1,i1)
coup2 = cplcHpVPVWp(i1)
coup3 = -cplcVWpVPVWp
Call Amp_VERTEX_StoVV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
End Do


! {VWp, Hp, VP}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MVP 
coup1 = cplAhcHpVWp(gt1,i2)
coup2 = -cplcVWpVPVWp
coup3 = cplHpcVWpVP(i2)
Call Amp_VERTEX_StoVV_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
  End Do


! {Hp, VP}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVP 
coup1 = cplAhHpcVWpVP1(gt1,i1)
coup2 = cplcHpVPVWp(i1)
Call Amp_VERTEX_StoVV_Topology3_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 

End Do


! {VP, Hp}
  Do i2=1,3
ML1 = MVP 
ML2 = MHp(i2) 
coup1 = cplAhcHpVPVWp1(gt1,i2)
coup2 = cplHpcVWpVP(i2)
Call Amp_VERTEX_StoVV_Topology4_VS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 

  End Do
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhToVWpcVWp


Subroutine Amplitude_WAVE_4HDM_S3_AhToVZVZ(MAh,MAh2,MVZ,MVZ2,ZfAh,ZfVZ,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MAh2(3),MVZ,MVZ2

Complex(dp), Intent(in) :: ZfAh(3,3),ZfVZ

Complex(dp), Intent(out) :: Amp(2,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MVZ 
Mex3 = MVZ 
ZcoupT1 = 0._dp 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
! Vanishing 


! External Field 2 
! Vanishing 


! External Field 3 
Amp(:,gt1) = 0._dp
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_AhToVZVZ


Subroutine Amplitude_VERTEX_4HDM_S3_AhToVZVZ(MAh,MFd,MFe,MFu,MHp,MVWp,MVZ,            & 
& MAh2,MFd2,MFe2,MFu2,MHp2,MVWp2,MVZ2,cplcFdFdAhL,cplcFdFdAhR,cplcFeFeAhL,               & 
& cplcFeFeAhR,cplcFuFuAhL,cplcFuFuAhR,cplcgWpgWpAh,cplcgWCgWCAh,cplAhHpcHp,              & 
& cplAhHpcVWp,cplAhcHpVWp,cplcFdFdVZL,cplcFdFdVZR,cplcFeFeVZL,cplcFeFeVZR,               & 
& cplcFuFuVZL,cplcFuFuVZR,cplcgWpgWpVZ,cplcgWCgWCVZ,cplHpcHpVZ,cplHpcVWpVZ,              & 
& cplcHpVWpVZ,cplcVWpVWpVZ,cplAhHpcVWpVZ1,cplAhcHpVWpVZ1,cplHpcHpVZVZ1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHp(3),MVWp,MVZ,MAh2(3),MFd2(3),MFe2(3),MFu2(3),          & 
& MHp2(3),MVWp2,MVZ2

Complex(dp), Intent(in) :: cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFeFeAhL(3,3,3),cplcFeFeAhR(3,3,3),          & 
& cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcgWpgWpAh(3),cplcgWCgWCAh(3),cplAhHpcHp(3,3,3),& 
& cplAhHpcVWp(3,3),cplAhcHpVWp(3,3),cplcFdFdVZL(3,3),cplcFdFdVZR(3,3),cplcFeFeVZL(3,3),  & 
& cplcFeFeVZR(3,3),cplcFuFuVZL(3,3),cplcFuFuVZR(3,3),cplcgWpgWpVZ,cplcgWCgWCVZ,          & 
& cplHpcHpVZ(3,3),cplHpcVWpVZ(3),cplcHpVWpVZ(3),cplcVWpVWpVZ,cplAhHpcVWpVZ1(3,3),        & 
& cplAhcHpVWpVZ1(3,3),cplHpcHpVZVZ1(3,3)

Complex(dp), Intent(out) :: Amp(2,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
Amp(:,gt1) = 0._dp 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MVZ 
Mex3 = MVZ 


! {Fd, Fd, Fd}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFd(i1) 
ML2 = MFd(i2) 
ML3 = MFd(i3) 
coup1L = cplcFdFdAhL(i2,i1,gt1)
coup1R = cplcFdFdAhR(i2,i1,gt1)
coup2L = -cplcFdFdVZR(i1,i3)
coup2R = -cplcFdFdVZL(i1,i3)
coup3L = -cplcFdFdVZR(i3,i2)
coup3R = -cplcFdFdVZL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(6)*AmpC 
    End Do
  End Do
End Do


! {Fe, Fe, Fe}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFe(i1) 
ML2 = MFe(i2) 
ML3 = MFe(i3) 
coup1L = cplcFeFeAhL(i2,i1,gt1)
coup1R = cplcFeFeAhR(i2,i1,gt1)
coup2L = -cplcFeFeVZR(i1,i3)
coup2R = -cplcFeFeVZL(i1,i3)
coup3L = -cplcFeFeVZR(i3,i2)
coup3R = -cplcFeFeVZL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(2)*AmpC 
    End Do
  End Do
End Do


! {Fu, Fu, Fu}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFu(i1) 
ML2 = MFu(i2) 
ML3 = MFu(i3) 
coup1L = cplcFuFuAhL(i2,i1,gt1)
coup1R = cplcFuFuAhR(i2,i1,gt1)
coup2L = -cplcFuFuVZR(i1,i3)
coup2R = -cplcFuFuVZL(i1,i3)
coup3L = -cplcFuFuVZR(i3,i2)
coup3R = -cplcFuFuVZL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(6)*AmpC 
    End Do
  End Do
End Do


! {gWp, gWp, gWp}
ML1 = MVWp 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcgWpgWpAh(gt1)
coup2 = cplcgWpgWpVZ
coup3 = cplcgWpgWpVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(2)*AmpC 


! {gWpC, gWpC, gWpC}
ML1 = MVWp 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcgWCgWCAh(gt1)
coup2 = cplcgWCgWCVZ
coup3 = cplcgWCgWCVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(2)*AmpC 


! {Hp, Hp, Hp}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = -cplHpcHpVZ(i3,i1)
coup3 = -cplHpcHpVZ(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(2)*AmpC 
    End Do
  End Do
End Do


! {Hp, VWp, Hp}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = cplAhHpcVWp(gt1,i1)
coup2 = -cplHpcHpVZ(i3,i1)
coup3 = cplcHpVWpVZ(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, Hp, VWp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplcHpVWpVZ(i1)
coup3 = cplHpcVWpVZ(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, VWp, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplAhHpcVWp(gt1,i1)
coup2 = cplcHpVWpVZ(i1)
coup3 = -cplcVWpVWpVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
End Do


! {VWp, Hp, Hp}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplAhcHpVWp(gt1,i2)
coup2 = cplHpcVWpVZ(i3)
coup3 = -cplHpcHpVZ(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VWp, Hp, VWp}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplAhcHpVWp(gt1,i2)
coup2 = -cplcVWpVWpVZ
coup3 = cplHpcVWpVZ(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
  End Do


! {conj[Hp], conj[VWp], conj[Hp]}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = cplAhcHpVWp(gt1,i1)
coup2 = cplHpcHpVZ(i1,i3)
coup3 = cplHpcVWpVZ(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {conj[Hp], conj[Hp], conj[VWp]}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplAhHpcHp(gt1,i2,i1)
coup2 = cplHpcVWpVZ(i1)
coup3 = cplcHpVWpVZ(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {conj[Hp], conj[VWp], conj[VWp]}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplAhcHpVWp(gt1,i1)
coup2 = cplHpcVWpVZ(i1)
coup3 = cplcVWpVWpVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
End Do


! {conj[VWp], conj[Hp], conj[Hp]}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplAhHpcVWp(gt1,i2)
coup2 = cplcHpVWpVZ(i3)
coup3 = cplHpcHpVZ(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {conj[VWp], conj[Hp], conj[VWp]}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplAhHpcVWp(gt1,i2)
coup2 = cplcVWpVWpVZ
coup3 = cplcHpVWpVZ(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
  End Do


! {Hp, Hp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
coup1 = cplAhHpcHp(gt1,i1,i2)
coup2 = cplHpcHpVZVZ1(i2,i1)
Call Amp_VERTEX_StoVV_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
coup1 = cplAhHpcVWpVZ1(gt1,i1)
coup2 = cplcHpVWpVZ(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology3_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 

End Do


! {VWp, Hp}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
coup1 = cplAhcHpVWpVZ1(gt1,i2)
coup2 = cplHpcVWpVZ(i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology3_VS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 

  End Do


! {Hp, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
coup1 = cplAhHpcVWpVZ1(gt1,i1)
coup2 = cplcHpVWpVZ(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology4_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 

End Do


! {VWp, Hp}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHp(i2) 
coup1 = cplAhcHpVWpVZ1(gt1,i2)
coup2 = cplHpcVWpVZ(i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology4_VS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 

  End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_AhToVZVZ


Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhToVZVZ(MAh,MFd,MFe,MFu,MHp,MVWp,             & 
& MVZ,MAh2,MFd2,MFe2,MFu2,MHp2,MVWp2,MVZ2,cplcFdFdAhL,cplcFdFdAhR,cplcFeFeAhL,           & 
& cplcFeFeAhR,cplcFuFuAhL,cplcFuFuAhR,cplcgWpgWpAh,cplcgWCgWCAh,cplAhHpcHp,              & 
& cplAhHpcVWp,cplAhcHpVWp,cplcFdFdVZL,cplcFdFdVZR,cplcFeFeVZL,cplcFeFeVZR,               & 
& cplcFuFuVZL,cplcFuFuVZR,cplcgWpgWpVZ,cplcgWCgWCVZ,cplHpcHpVZ,cplHpcVWpVZ,              & 
& cplcHpVWpVZ,cplcVWpVWpVZ,cplAhHpcVWpVZ1,cplAhcHpVWpVZ1,cplHpcHpVZVZ1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHp(3),MVWp,MVZ,MAh2(3),MFd2(3),MFe2(3),MFu2(3),          & 
& MHp2(3),MVWp2,MVZ2

Complex(dp), Intent(in) :: cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFeFeAhL(3,3,3),cplcFeFeAhR(3,3,3),          & 
& cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcgWpgWpAh(3),cplcgWCgWCAh(3),cplAhHpcHp(3,3,3),& 
& cplAhHpcVWp(3,3),cplAhcHpVWp(3,3),cplcFdFdVZL(3,3),cplcFdFdVZR(3,3),cplcFeFeVZL(3,3),  & 
& cplcFeFeVZR(3,3),cplcFuFuVZL(3,3),cplcFuFuVZR(3,3),cplcgWpgWpVZ,cplcgWCgWCVZ,          & 
& cplHpcHpVZ(3,3),cplHpcVWpVZ(3),cplcHpVWpVZ(3),cplcVWpVWpVZ,cplAhHpcVWpVZ1(3,3),        & 
& cplAhcHpVWpVZ1(3,3),cplHpcHpVZVZ1(3,3)

Complex(dp), Intent(out) :: Amp(2,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
Amp(:,gt1) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MAh(gt1) 
Mex2 = MVZ 
Mex3 = MVZ 
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_AhToVZVZ



End Module OneLoopDecay_Ah_4HDM_S3
