! -----------------------------------------------------------------------------  
! This file was automatically created by SARAH version 4.12.3 
! SARAH References: arXiv:0806.0538, 0909.2863, 1002.0840, 1207.0906, 1309.7223  
! (c) Florian Staub, 2013  
! ------------------------------------------------------------------------------  
! File created at 8:13 on 5.4.2018   
! ----------------------------------------------------------------------  
 
 
Module OneLoopDecay_Hp_4HDM_S3
Use Control 
Use Settings 
Use LoopFunctions 
Use AddLoopFunctions 
Use Model_Data_4HDM_S3 
Use DecayFFS 
Use DecayFFV 
Use DecaySSS 
Use DecaySFF 
Use DecaySSV 
Use DecaySVV 
Use Bremsstrahlung 

Contains 

Subroutine Amplitude_Tree_4HDM_S3_HpToHpAh(cplAhHpcHp,MAh,MHp,MAh2,MHp2,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MHp(3),MAh2(3),MHp2(3)

Complex(dp), Intent(in) :: cplAhHpcHp(3,3,3)

Complex(dp) :: Amp(3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 

Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MHp(gt2) 
Mex3 = MAh(gt3) 
! Tree-Level Vertex 
coupT1 = cplAhHpcHp(gt3,gt2,gt1)
Call TreeAmp_StoSS(Mex1,Mex2,Mex3,coupT1,AmpC) 
! Colour and symmetry factor 
Amp(gt1, gt2, gt3) = AmpC 
    End Do
  End Do
End Do
End Subroutine Amplitude_Tree_4HDM_S3_HpToHpAh


Subroutine Gamma_Real_4HDM_S3_HpToHpAh(MLambda,em,gs,cplAhHpcHp,MAh,MHp,              & 
& GammarealPhoton,GammarealGluon)

Implicit None

Complex(dp), Intent(in) :: cplAhHpcHp(3,3,3)

Real(dp), Intent(in) :: MAh(3),MHp(3)

Real(dp), Intent(in) :: MLambda, em, gs 

Real(dp), Intent(out) :: GammarealPhoton(3,3,3), GammarealGluon(3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3, kont 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 

Real(dp) :: Mloop1, Mloop2, Mloop3 
Complex(dp) :: Coup 
 
Do i1=2,3
  Do i2=2,3
    Do i3=2,3
Coup = cplAhHpcHp(i3,i2,i1)
Mex1 = MHp(i1)
Mex2 = MHp(i2)
Mex3 = MAh(i3)
If (Mex1.gt.(Mex2+Mex3)) Then 
 Call hardradiationSSS(Mex1,Mex2,Mex3,MLambda,em,1._dp,1._dp,0._dp,1._dp,0._dp,0._dp,Coup,Gammarealphoton(i1,i2,i3),kont)
  GammarealGluon(i1,i2,i3) = 0._dp 
Else 
  GammarealGluon(i1,i2,i3) = 0._dp 
  GammarealPhoton(i1,i2,i3) = 0._dp 

End if 
    End Do
  End Do
End Do
End Subroutine Gamma_Real_4HDM_S3_HpToHpAh


Subroutine Amplitude_WAVE_4HDM_S3_HpToHpAh(cplAhHpcHp,ctcplAhHpcHp,MAh,               & 
& MAh2,MHp,MHp2,ZfAh,ZfHp,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MAh2(3),MHp(3),MHp2(3)

Complex(dp), Intent(in) :: cplAhHpcHp(3,3,3)

Complex(dp), Intent(in) :: ctcplAhHpcHp(3,3,3)

Complex(dp), Intent(in) :: ZfAh(3,3),ZfHp(3,3)

Complex(dp), Intent(out) :: Amp(3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MHp(gt2) 
Mex3 = MAh(gt3) 
!----------------------------- 
! Coupling counter term 
!----------------------------- 
ZcoupT1 = ctcplAhHpcHp(gt3,gt2,gt1) 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
Do i1=1,3
ZcoupT1 = ZcoupT1 + 0.5_dp*Conjg(ZfHp(i1,gt1))*cplAhHpcHp(gt3,gt2,i1)
End Do


! External Field 2 
Do i1=1,3
ZcoupT1 = ZcoupT1 + 0.5_dp*ZfHp(i1,gt2)*cplAhHpcHp(gt3,i1,gt1)
End Do


! External Field 3 
Do i1=1,3
ZcoupT1 = ZcoupT1 + 0.5_dp*ZfAh(i1,gt3)*cplAhHpcHp(i1,gt2,gt1)
End Do


! Getting the amplitude 
Call TreeAmp_StoSS(Mex1,Mex2,Mex3,ZcoupT1,AmpC) 
Amp(gt1, gt2, gt3) = AmpC 
    End Do
  End Do
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_HpToHpAh


Subroutine Amplitude_VERTEX_4HDM_S3_HpToHpAh(MAh,MFd,MFe,MFu,MHap,Mhha,               & 
& MHhSM,MHp,Msiga,MVP,MVWp,MVZ,MAh2,MFd2,MFe2,MFu2,MHap2,Mhha2,MHhSM2,MHp2,              & 
& Msiga2,MVP2,MVWp2,MVZ2,cplAhAhHhSM,cplcFdFdAhL,cplcFdFdAhR,cplcFeFeAhL,cplcFeFeAhR,    & 
& cplcFuFuAhL,cplcFuFuAhR,cplcgWpgWpAh,cplcgWCgWCAh,cplAhhhasiga,cplAhHhSMVZ,            & 
& cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplcFuFdHpL,cplcFuFdHpR,cplcFvFeHpL,cplcFvFeHpR,    & 
& cplcFdFucHpL,cplcFdFucHpR,cplcFeFvcHpL,cplcFeFvcHpR,cplcgZgWpcHp,cplcgZgWCHp,          & 
& cplcgWpgZHp,cplcgWCgZcHp,cplHaphhacHp,cplHapsigacHp,cplhhaHpcHap,cplHhSMHpcHp,         & 
& cplHhSMHpcVWp,cplHhSMcHpVWp,cplHpsigacHap,cplHpcHpVP,cplHpcVWpVP,cplHpcHpVZ,           & 
& cplHpcVWpVZ,cplcHpVPVWp,cplcHpVWpVZ,cplAhAhHpcHp1,cplAhHaphhacHp1,cplAhHapsigacHp1,    & 
& cplAhhhaHpcHap1,cplAhHhSMHpcHp1,cplAhHpsigacHap1,cplAhHpcVWpVP1,cplAhHpcVWpVZ1,        & 
& cplAhcHpVPVWp1,cplAhcHpVWpVZ1,cplHpHpcHpcHp1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHap,Mhha,MHhSM(3),MHp(3),Msiga,MVP,MVWp,MVZ,             & 
& MAh2(3),MFd2(3),MFe2(3),MFu2(3),MHap2,Mhha2,MHhSM2(3),MHp2(3),Msiga2,MVP2,             & 
& MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhAhHhSM(3,3,3),cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFeFeAhL(3,3,3),          & 
& cplcFeFeAhR(3,3,3),cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcgWpgWpAh(3),              & 
& cplcgWCgWCAh(3),cplAhhhasiga(3),cplAhHhSMVZ(3,3),cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),   & 
& cplAhcHpVWp(3,3),cplcFuFdHpL(3,3,3),cplcFuFdHpR(3,3,3),cplcFvFeHpL(3,3,3),             & 
& cplcFvFeHpR(3,3,3),cplcFdFucHpL(3,3,3),cplcFdFucHpR(3,3,3),cplcFeFvcHpL(3,3,3),        & 
& cplcFeFvcHpR(3,3,3),cplcgZgWpcHp(3),cplcgZgWCHp(3),cplcgWpgZHp(3),cplcgWCgZcHp(3),     & 
& cplHaphhacHp(3),cplHapsigacHp(3),cplhhaHpcHap(3),cplHhSMHpcHp(3,3,3),cplHhSMHpcVWp(3,3),& 
& cplHhSMcHpVWp(3,3),cplHpsigacHap(3),cplHpcHpVP(3,3),cplHpcVWpVP(3),cplHpcHpVZ(3,3),    & 
& cplHpcVWpVZ(3),cplcHpVPVWp(3),cplcHpVWpVZ(3),cplAhAhHpcHp1(3,3,3,3),cplAhHaphhacHp1(3,3),& 
& cplAhHapsigacHp1(3,3),cplAhhhaHpcHap1(3,3),cplAhHhSMHpcHp1(3,3,3,3),cplAhHpsigacHap1(3,3),& 
& cplAhHpcVWpVP1(3,3),cplAhHpcVWpVZ1(3,3),cplAhcHpVPVWp1(3,3),cplAhcHpVWpVZ1(3,3),       & 
& cplHpHpcHpcHp1(3,3,3,3)

Complex(dp), Intent(out) :: Amp(3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
Amp(gt1, gt2, gt3) = 0._dp 
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MHp(gt2) 
Mex3 = MAh(gt3) 


! {Ah, conj[Hp], conj[Hp]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MAh(i1) 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplAhHpcHp(i1,i2,gt1)
coup2 = cplAhHpcHp(i1,gt2,i3)
coup3 = cplAhHpcHp(gt3,i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Ah, conj[VWp], conj[Hp]}
Do i1=1,3
    Do i3=1,3
ML1 = MAh(i1) 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = cplAhcHpVWp(i1,gt1)
coup2 = cplAhHpcHp(i1,gt2,i3)
coup3 = cplAhHpcVWp(gt3,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Ah, conj[Hp], conj[VWp]}
Do i1=1,3
  Do i2=1,3
ML1 = MAh(i1) 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplAhHpcHp(i1,i2,gt1)
coup2 = cplAhHpcVWp(i1,gt2)
coup3 = cplAhcHpVWp(gt3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Fu, Fd, Fd}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFu(i1) 
ML2 = MFd(i2) 
ML3 = MFd(i3) 
coup1L = cplcFdFucHpL(i2,i1,gt1)
coup1R = cplcFdFucHpR(i2,i1,gt1)
coup2L = cplcFuFdHpL(i1,i3,gt2)
coup2R = cplcFuFdHpR(i1,i3,gt2)
coup3L = cplcFdFdAhL(i3,i2,gt3)
coup3R = cplcFdFdAhR(i3,i2,gt3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(3)*AmpC 
    End Do
  End Do
End Do


! {Fv, Fe, Fe}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = 0. 
ML2 = MFe(i2) 
ML3 = MFe(i3) 
coup1L = cplcFeFvcHpL(i2,i1,gt1)
coup1R = cplcFeFvcHpR(i2,i1,gt1)
coup2L = cplcFvFeHpL(i1,i3,gt2)
coup2R = cplcFvFeHpR(i1,i3,gt2)
coup3L = cplcFeFeAhL(i3,i2,gt3)
coup3R = cplcFeFeAhR(i3,i2,gt3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {gZ, gWpC, gWpC}
ML1 = MVZ 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcgWCgZcHp(gt1)
coup2 = cplcgZgWCHp(gt2)
coup3 = cplcgWCgWCAh(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {Hap, siga, hha}
ML1 = MHap 
ML2 = Msiga 
ML3 = Mhha 
coup1 = cplHapsigacHp(gt1)
coup2 = cplhhaHpcHap(gt2)
coup3 = cplAhhhasiga(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {Hap, hha, siga}
ML1 = MHap 
ML2 = Mhha 
ML3 = Msiga 
coup1 = cplHaphhacHp(gt1)
coup2 = cplHpsigacHap(gt2)
coup3 = cplAhhhasiga(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {HhSM, conj[Hp], conj[Hp]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHhSM(i1) 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplHhSMHpcHp(i1,i2,gt1)
coup2 = cplHhSMHpcHp(i1,gt2,i3)
coup3 = cplAhHpcHp(gt3,i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {HhSM, conj[VWp], conj[Hp]}
Do i1=1,3
    Do i3=1,3
ML1 = MHhSM(i1) 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = cplHhSMcHpVWp(i1,gt1)
coup2 = cplHhSMHpcHp(i1,gt2,i3)
coup3 = cplAhHpcVWp(gt3,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {HhSM, conj[Hp], conj[VWp]}
Do i1=1,3
  Do i2=1,3
ML1 = MHhSM(i1) 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplHhSMHpcHp(i1,i2,gt1)
coup2 = cplHhSMHpcVWp(i1,gt2)
coup3 = cplAhcHpVWp(gt3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, HhSM, Ah}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MHhSM(i2) 
ML3 = MAh(i3) 
coup1 = cplHhSMHpcHp(i2,i1,gt1)
coup2 = cplAhHpcHp(i3,gt2,i1)
coup3 = cplAhAhHhSM(gt3,i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Hp, Ah, HhSM}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MAh(i2) 
ML3 = MHhSM(i3) 
coup1 = cplAhHpcHp(i2,i1,gt1)
coup2 = cplHhSMHpcHp(i3,gt2,i1)
coup3 = cplAhAhHhSM(gt3,i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Hp, VZ, HhSM}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVZ 
ML3 = MHhSM(i3) 
coup1 = cplHpcHpVZ(i1,gt1)
coup2 = cplHhSMHpcHp(i3,gt2,i1)
coup3 = cplAhHhSMVZ(gt3,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, HhSM, VZ}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHhSM(i2) 
ML3 = MVZ 
coup1 = cplHhSMHpcHp(i2,i1,gt1)
coup2 = -cplHpcHpVZ(gt2,i1)
coup3 = cplAhHhSMVZ(gt3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {VP, conj[Hp], conj[Hp]}
  Do i2=1,3
    Do i3=1,3
ML1 = MVP 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplHpcHpVP(i2,gt1)
coup2 = -cplHpcHpVP(gt2,i3)
coup3 = cplAhHpcHp(gt3,i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VP, conj[VWp], conj[Hp]}
    Do i3=1,3
ML1 = MVP 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = cplcHpVPVWp(gt1)
coup2 = -cplHpcHpVP(gt2,i3)
coup3 = cplAhHpcVWp(gt3,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do


! {VP, conj[Hp], conj[VWp]}
  Do i2=1,3
ML1 = MVP 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplHpcHpVP(i2,gt1)
coup2 = cplHpcVWpVP(gt2)
coup3 = cplAhcHpVWp(gt3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do


! {VWp, HhSM, Ah}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHhSM(i2) 
ML3 = MAh(i3) 
coup1 = cplHhSMcHpVWp(i2,gt1)
coup2 = cplAhHpcVWp(i3,gt2)
coup3 = cplAhAhHhSM(gt3,i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VWp, Ah, HhSM}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MAh(i2) 
ML3 = MHhSM(i3) 
coup1 = cplAhcHpVWp(i2,gt1)
coup2 = cplHhSMHpcVWp(i3,gt2)
coup3 = cplAhAhHhSM(gt3,i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VWp, VZ, HhSM}
    Do i3=1,3
ML1 = MVWp 
ML2 = MVZ 
ML3 = MHhSM(i3) 
coup1 = cplcHpVWpVZ(gt1)
coup2 = cplHhSMHpcVWp(i3,gt2)
coup3 = cplAhHhSMVZ(gt3,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do


! {VWp, HhSM, VZ}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHhSM(i2) 
ML3 = MVZ 
coup1 = cplHhSMcHpVWp(i2,gt1)
coup2 = cplHpcVWpVZ(gt2)
coup3 = cplAhHhSMVZ(gt3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do


! {VZ, conj[Hp], conj[Hp]}
  Do i2=1,3
    Do i3=1,3
ML1 = MVZ 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplHpcHpVZ(i2,gt1)
coup2 = -cplHpcHpVZ(gt2,i3)
coup3 = cplAhHpcHp(gt3,i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VZ, conj[VWp], conj[Hp]}
    Do i3=1,3
ML1 = MVZ 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = cplcHpVWpVZ(gt1)
coup2 = -cplHpcHpVZ(gt2,i3)
coup3 = cplAhHpcVWp(gt3,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do


! {VZ, conj[Hp], conj[VWp]}
  Do i2=1,3
ML1 = MVZ 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplHpcHpVZ(i2,gt1)
coup2 = cplHpcVWpVZ(gt2)
coup3 = cplAhcHpVWp(gt3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do


! {bar[Fd], bar[Fu], bar[Fu]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFd(i1) 
ML2 = MFu(i2) 
ML3 = MFu(i3) 
coup1L = cplcFdFucHpL(i1,i2,gt1)
coup1R = cplcFdFucHpR(i1,i2,gt1)
coup2L = cplcFuFdHpL(i3,i1,gt2)
coup2R = cplcFuFdHpR(i3,i1,gt2)
coup3L = cplcFuFuAhL(i2,i3,gt3)
coup3R = cplcFuFuAhR(i2,i3,gt3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(3)*AmpC 
    End Do
  End Do
End Do


! {bar[gZ], bar[gWp], bar[gWp]}
ML1 = MVZ 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcgZgWpcHp(gt1)
coup2 = cplcgWpgZHp(gt2)
coup3 = cplcgWpgWpAh(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {Ah, conj[Hp]}
Do i1=1,3
  Do i2=1,3
ML1 = MAh(i1) 
ML2 = MHp(i2) 
coup1 = cplAhHpcHp(i1,i2,gt1)
coup2 = cplAhAhHpcHp1(gt3,i1,gt2,i2)
Call Amp_VERTEX_StoSS_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hap, hha}
ML1 = MHap 
ML2 = Mhha 
coup1 = cplHaphhacHp(gt1)
coup2 = cplAhhhaHpcHap1(gt3,gt2)
Call Amp_VERTEX_StoSS_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {Hap, siga}
ML1 = MHap 
ML2 = Msiga 
coup1 = cplHapsigacHp(gt1)
coup2 = cplAhHpsigacHap1(gt3,gt2)
Call Amp_VERTEX_StoSS_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {HhSM, conj[Hp]}
Do i1=1,3
  Do i2=1,3
ML1 = MHhSM(i1) 
ML2 = MHp(i2) 
coup1 = cplHhSMHpcHp(i1,i2,gt1)
coup2 = cplAhHhSMHpcHp1(gt3,i1,gt2,i2)
Call Amp_VERTEX_StoSS_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {VP, conj[VWp]}
ML1 = MVP 
ML2 = MVWp 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplAhHpcVWpVP1(gt3,gt2)
Call Amp_VERTEX_StoSS_Topology2_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {VWp, VZ}
ML1 = MVWp 
ML2 = MVZ 
coup1 = cplcHpVWpVZ(gt1)
coup2 = cplAhHpcVWpVZ1(gt3,gt2)
Call Amp_VERTEX_StoSS_Topology2_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {Ah, conj[Hp]}
Do i1=1,3
  Do i2=1,3
ML1 = MAh(i1) 
ML2 = MHp(i2) 
coup1 = cplAhAhHpcHp1(gt3,i1,i2,gt1)
coup2 = cplAhHpcHp(i1,gt2,i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 

  End Do
End Do


! {Hap, hha}
ML1 = MHap 
ML2 = Mhha 
coup1 = cplAhHaphhacHp1(gt3,gt1)
coup2 = cplhhaHpcHap(gt2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 



! {Hap, siga}
ML1 = MHap 
ML2 = Msiga 
coup1 = cplAhHapsigacHp1(gt3,gt1)
coup2 = cplHpsigacHap(gt2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 



! {HhSM, conj[Hp]}
Do i1=1,3
  Do i2=1,3
ML1 = MHhSM(i1) 
ML2 = MHp(i2) 
coup1 = cplAhHhSMHpcHp1(gt3,i1,i2,gt1)
coup2 = cplHhSMHpcHp(i1,gt2,i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 

  End Do
End Do


! {VP, conj[VWp]}
ML1 = MVP 
ML2 = MVWp 
coup1 = cplAhcHpVPVWp1(gt3,gt1)
coup2 = cplHpcVWpVP(gt2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 



! {VWp, VZ}
ML1 = MVWp 
ML2 = MVZ 
coup1 = cplAhcHpVWpVZ1(gt3,gt1)
coup2 = cplHpcVWpVZ(gt2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 



! {Ah, HhSM}
Do i1=1,3
  Do i2=1,3
ML1 = MAh(i1) 
ML2 = MHhSM(i2) 
coup1 = cplAhHhSMHpcHp1(i1,i2,gt2,gt1)
coup2 = cplAhAhHhSM(gt3,i1,i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 

  End Do
End Do


! {Hp, Hp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
coup1 = cplHpHpcHpcHp1(gt2,i1,gt1,i2)
coup2 = cplAhHpcHp(gt3,i2,i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 

  End Do
End Do
    End Do
  End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_HpToHpAh


Subroutine Amplitude_IR_VERTEX_4HDM_S3_HpToHpAh(MAh,MFd,MFe,MFu,MHap,Mhha,            & 
& MHhSM,MHp,Msiga,MVP,MVWp,MVZ,MAh2,MFd2,MFe2,MFu2,MHap2,Mhha2,MHhSM2,MHp2,              & 
& Msiga2,MVP2,MVWp2,MVZ2,cplAhAhHhSM,cplcFdFdAhL,cplcFdFdAhR,cplcFeFeAhL,cplcFeFeAhR,    & 
& cplcFuFuAhL,cplcFuFuAhR,cplcgWpgWpAh,cplcgWCgWCAh,cplAhhhasiga,cplAhHhSMVZ,            & 
& cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplcFuFdHpL,cplcFuFdHpR,cplcFvFeHpL,cplcFvFeHpR,    & 
& cplcFdFucHpL,cplcFdFucHpR,cplcFeFvcHpL,cplcFeFvcHpR,cplcgZgWpcHp,cplcgZgWCHp,          & 
& cplcgWpgZHp,cplcgWCgZcHp,cplHaphhacHp,cplHapsigacHp,cplhhaHpcHap,cplHhSMHpcHp,         & 
& cplHhSMHpcVWp,cplHhSMcHpVWp,cplHpsigacHap,cplHpcHpVP,cplHpcVWpVP,cplHpcHpVZ,           & 
& cplHpcVWpVZ,cplcHpVPVWp,cplcHpVWpVZ,cplAhAhHpcHp1,cplAhHaphhacHp1,cplAhHapsigacHp1,    & 
& cplAhhhaHpcHap1,cplAhHhSMHpcHp1,cplAhHpsigacHap1,cplAhHpcVWpVP1,cplAhHpcVWpVZ1,        & 
& cplAhcHpVPVWp1,cplAhcHpVWpVZ1,cplHpHpcHpcHp1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHap,Mhha,MHhSM(3),MHp(3),Msiga,MVP,MVWp,MVZ,             & 
& MAh2(3),MFd2(3),MFe2(3),MFu2(3),MHap2,Mhha2,MHhSM2(3),MHp2(3),Msiga2,MVP2,             & 
& MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhAhHhSM(3,3,3),cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFeFeAhL(3,3,3),          & 
& cplcFeFeAhR(3,3,3),cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcgWpgWpAh(3),              & 
& cplcgWCgWCAh(3),cplAhhhasiga(3),cplAhHhSMVZ(3,3),cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),   & 
& cplAhcHpVWp(3,3),cplcFuFdHpL(3,3,3),cplcFuFdHpR(3,3,3),cplcFvFeHpL(3,3,3),             & 
& cplcFvFeHpR(3,3,3),cplcFdFucHpL(3,3,3),cplcFdFucHpR(3,3,3),cplcFeFvcHpL(3,3,3),        & 
& cplcFeFvcHpR(3,3,3),cplcgZgWpcHp(3),cplcgZgWCHp(3),cplcgWpgZHp(3),cplcgWCgZcHp(3),     & 
& cplHaphhacHp(3),cplHapsigacHp(3),cplhhaHpcHap(3),cplHhSMHpcHp(3,3,3),cplHhSMHpcVWp(3,3),& 
& cplHhSMcHpVWp(3,3),cplHpsigacHap(3),cplHpcHpVP(3,3),cplHpcVWpVP(3),cplHpcHpVZ(3,3),    & 
& cplHpcVWpVZ(3),cplcHpVPVWp(3),cplcHpVWpVZ(3),cplAhAhHpcHp1(3,3,3,3),cplAhHaphhacHp1(3,3),& 
& cplAhHapsigacHp1(3,3),cplAhhhaHpcHap1(3,3),cplAhHhSMHpcHp1(3,3,3,3),cplAhHpsigacHap1(3,3),& 
& cplAhHpcVWpVP1(3,3),cplAhHpcVWpVZ1(3,3),cplAhcHpVPVWp1(3,3),cplAhcHpVWpVZ1(3,3),       & 
& cplHpHpcHpcHp1(3,3,3,3)

Complex(dp), Intent(out) :: Amp(3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
Amp(gt1, gt2, gt3) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MHp(gt2) 
Mex3 = MAh(gt3) 


! {VP, conj[Hp], conj[Hp]}
  Do i2=1,3
    Do i3=1,3
ML1 = MVP 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplHpcHpVP(i2,gt1)
coup2 = -cplHpcHpVP(gt2,i3)
coup3 = cplAhHpcHp(gt3,i3,i2)
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VP, conj[VWp], conj[Hp]}
    Do i3=1,3
ML1 = MVP 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = cplcHpVPVWp(gt1)
coup2 = -cplHpcHpVP(gt2,i3)
coup3 = cplAhHpcVWp(gt3,i3)
Call Amp_VERTEX_StoSS_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do


! {VP, conj[Hp], conj[VWp]}
  Do i2=1,3
ML1 = MVP 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplHpcHpVP(i2,gt1)
coup2 = cplHpcVWpVP(gt2)
coup3 = cplAhcHpVWp(gt3,i2)
Call Amp_VERTEX_StoSS_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do


! {VP, conj[VWp]}
ML1 = MVP 
ML2 = MVWp 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplAhHpcVWpVP1(gt3,gt2)
Call Amp_VERTEX_StoSS_Topology2_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {VP, conj[VWp]}
ML1 = MVP 
ML2 = MVWp 
coup1 = cplAhcHpVPVWp1(gt3,gt1)
coup2 = cplHpcVWpVP(gt2)
Call Amp_VERTEX_StoSS_Topology3_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 

    End Do
  End Do
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_HpToHpAh


Subroutine Amplitude_Tree_4HDM_S3_HpToAhVWp(cplAhcHpVWp,MAh,MHp,MVWp,MAh2,            & 
& MHp2,MVWp2,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MHp(3),MVWp,MAh2(3),MHp2(3),MVWp2

Complex(dp), Intent(in) :: cplAhcHpVWp(3,3)

Complex(dp) :: Amp(2,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 

Do gt1=1,3
  Do gt2=1,3
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MAh(gt2) 
Mex3 = MVWp 
! Tree-Level Vertex 
coupT1 = -cplAhcHpVWp(gt2,gt1)
Call TreeAmp_StoSV(Mex1,Mex2,Mex3,coupT1,AmpC) 
! Colour and symmetry factor 
Amp(:,gt1, gt2) = AmpC 
  End Do
End Do
End Subroutine Amplitude_Tree_4HDM_S3_HpToAhVWp


Subroutine Gamma_Real_4HDM_S3_HpToAhVWp(MLambda,em,gs,cplAhcHpVWp,MAh,MHp,            & 
& MVWp,GammarealPhoton,GammarealGluon)

Implicit None

Complex(dp), Intent(in) :: cplAhcHpVWp(3,3)

Real(dp), Intent(in) :: MAh(3),MHp(3),MVWp

Real(dp), Intent(in) :: MLambda, em, gs 

Real(dp), Intent(out) :: GammarealPhoton(3,3), GammarealGluon(3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3, kont 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 

Real(dp) :: Mloop1, Mloop2, Mloop3 
Complex(dp) :: Coup 
 
Do i1=2,3
  Do i2=2,3
Coup = cplAhcHpVWp(i2,i1)
Mex1 = MHp(i1)
Mex2 = MAh(i2)
Mex3 = MVWp
If (Mex1.gt.(Mex2+Mex3)) Then 
 Call hardradiationSSV(Mex1,Mex2,Mex3,MLambda,em,1._dp,0._dp,1._dp,Coup,Gammarealphoton(i1,i2),kont)
 GammarealGluon(i1,i2) = 0._dp 
Else 
  GammarealGluon(i1,i2) = 0._dp 
  GammarealPhoton(i1,i2) = 0._dp 

End if 
  End Do
End Do
End Subroutine Gamma_Real_4HDM_S3_HpToAhVWp


Subroutine Amplitude_WAVE_4HDM_S3_HpToAhVWp(cplAhcHpVWp,ctcplAhcHpVWp,MAh,            & 
& MAh2,MHp,MHp2,MVWp,MVWp2,ZfAh,ZfHp,ZfVWp,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MAh2(3),MHp(3),MHp2(3),MVWp,MVWp2

Complex(dp), Intent(in) :: cplAhcHpVWp(3,3)

Complex(dp), Intent(in) :: ctcplAhcHpVWp(3,3)

Complex(dp), Intent(in) :: ZfAh(3,3),ZfHp(3,3),ZfVWp

Complex(dp), Intent(out) :: Amp(2,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
  Do gt2=1,3
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MAh(gt2) 
Mex3 = MVWp 
!----------------------------- 
! Coupling counter term 
!----------------------------- 
ZcoupT1 = ctcplAhcHpVWp(gt2,gt1) 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
Do i1=1,3
ZcoupT1 = ZcoupT1 + 0.5_dp*Conjg(ZfHp(i1,gt1))*cplAhcHpVWp(gt2,i1)
End Do


! External Field 2 
Do i1=1,3
ZcoupT1 = ZcoupT1 + 0.5_dp*ZfAh(i1,gt2)*cplAhcHpVWp(i1,gt1)
End Do


! External Field 3 
ZcoupT1 = ZcoupT1 + 0.5_dp*ZfVWp*cplAhcHpVWp(gt2,gt1)


! Getting the amplitude 
Call TreeAmp_StoSV(Mex1,Mex2,Mex3,-ZcoupT1,AmpC) 
Amp(:,gt1, gt2) = AmpC 
  End Do
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_HpToAhVWp


Subroutine Amplitude_VERTEX_4HDM_S3_HpToAhVWp(MAh,MFd,MFe,MFu,MHap,Mhha,              & 
& MHhSM,MHp,Msiga,MVP,MVWp,MVZ,MAh2,MFd2,MFe2,MFu2,MHap2,Mhha2,MHhSM2,MHp2,              & 
& Msiga2,MVP2,MVWp2,MVZ2,cplAhAhHhSM,cplcFdFdAhL,cplcFdFdAhR,cplcFeFeAhL,cplcFeFeAhR,    & 
& cplcFuFuAhL,cplcFuFuAhR,cplcgWpgWpAh,cplcgWCgWCAh,cplAhhhasiga,cplAhHhSMVZ,            & 
& cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplcFuFdVWpL,cplcFuFdVWpR,cplcFvFeVWpL,             & 
& cplcFvFeVWpR,cplcFdFucHpL,cplcFdFucHpR,cplcFeFvcHpL,cplcFeFvcHpR,cplcgWCgAcHp,         & 
& cplcgZgWpcHp,cplcgAgWCVWp,cplcgZgWCVWp,cplcgWpgZVWp,cplcgWCgZcHp,cplHaphhacHp,         & 
& cplHapsigacHp,cplhhacHapVWp,cplHhSMHpcHp,cplHhSMcHpVWp,cplHhSMcVWpVWp,cplHpcHpVP,      & 
& cplHpcHpVZ,cplsigacHapVWp,cplcHpVPVWp,cplcVWpVPVWp,cplcHpVWpVZ,cplcVWpVWpVZ,           & 
& cplAhAhcVWpVWp1,cplAhcHpVPVWp1,cplAhcHpVWpVZ1,cplHhSMcHpVWpVZ1,cplHpcHpcVWpVWp1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHap,Mhha,MHhSM(3),MHp(3),Msiga,MVP,MVWp,MVZ,             & 
& MAh2(3),MFd2(3),MFe2(3),MFu2(3),MHap2,Mhha2,MHhSM2(3),MHp2(3),Msiga2,MVP2,             & 
& MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhAhHhSM(3,3,3),cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFeFeAhL(3,3,3),          & 
& cplcFeFeAhR(3,3,3),cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcgWpgWpAh(3),              & 
& cplcgWCgWCAh(3),cplAhhhasiga(3),cplAhHhSMVZ(3,3),cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),   & 
& cplAhcHpVWp(3,3),cplcFuFdVWpL(3,3),cplcFuFdVWpR(3,3),cplcFvFeVWpL(3,3),cplcFvFeVWpR(3,3),& 
& cplcFdFucHpL(3,3,3),cplcFdFucHpR(3,3,3),cplcFeFvcHpL(3,3,3),cplcFeFvcHpR(3,3,3),       & 
& cplcgWCgAcHp(3),cplcgZgWpcHp(3),cplcgAgWCVWp,cplcgZgWCVWp,cplcgWpgZVWp,cplcgWCgZcHp(3),& 
& cplHaphhacHp(3),cplHapsigacHp(3),cplhhacHapVWp,cplHhSMHpcHp(3,3,3),cplHhSMcHpVWp(3,3), & 
& cplHhSMcVWpVWp(3),cplHpcHpVP(3,3),cplHpcHpVZ(3,3),cplsigacHapVWp,cplcHpVPVWp(3),       & 
& cplcVWpVPVWp,cplcHpVWpVZ(3),cplcVWpVWpVZ,cplAhAhcVWpVWp1(3,3),cplAhcHpVPVWp1(3,3),     & 
& cplAhcHpVWpVZ1(3,3),cplHhSMcHpVWpVZ1(3,3),cplHpcHpcVWpVWp1(3,3)

Complex(dp), Intent(out) :: Amp(2,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
Amp(:,gt1, gt2) = 0._dp 
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MAh(gt2) 
Mex3 = MVWp 


! {Ah, conj[Hp], HhSM}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MAh(i1) 
ML2 = MHp(i2) 
ML3 = MHhSM(i3) 
coup1 = cplAhHpcHp(i1,i2,gt1)
coup2 = cplAhAhHhSM(gt2,i1,i3)
coup3 = cplHhSMcHpVWp(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Ah, conj[VWp], HhSM}
Do i1=1,3
    Do i3=1,3
ML1 = MAh(i1) 
ML2 = MVWp 
ML3 = MHhSM(i3) 
coup1 = cplAhcHpVWp(i1,gt1)
coup2 = cplAhAhHhSM(gt2,i1,i3)
coup3 = cplHhSMcVWpVWp(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Fu, Fd, Fu}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFu(i1) 
ML2 = MFd(i2) 
ML3 = MFu(i3) 
coup1L = cplcFdFucHpL(i2,i1,gt1)
coup1R = cplcFdFucHpR(i2,i1,gt1)
coup2L = cplcFuFuAhL(i1,i3,gt2)
coup2R = cplcFuFuAhR(i1,i3,gt2)
coup3L = -cplcFuFdVWpR(i3,i2)
coup3R = -cplcFuFdVWpL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(3)*AmpC 
    End Do
  End Do
End Do


! {gWp, gZ, gWp}
ML1 = MVWp 
ML2 = MVZ 
ML3 = MVWp 
coup1 = cplcgZgWpcHp(gt1)
coup2 = cplcgWpgWpAh(gt2)
coup3 = cplcgWpgZVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {hha, conj[Hap], siga}
ML1 = Mhha 
ML2 = MHap 
ML3 = Msiga 
coup1 = cplHaphhacHp(gt1)
coup2 = cplAhhhasiga(gt2)
coup3 = cplsigacHapVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {HhSM, conj[Hp], Ah}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHhSM(i1) 
ML2 = MHp(i2) 
ML3 = MAh(i3) 
coup1 = cplHhSMHpcHp(i1,i2,gt1)
coup2 = cplAhAhHhSM(gt2,i3,i1)
coup3 = cplAhcHpVWp(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {HhSM, conj[Hp], VZ}
Do i1=1,3
  Do i2=1,3
ML1 = MHhSM(i1) 
ML2 = MHp(i2) 
ML3 = MVZ 
coup1 = cplHhSMHpcHp(i1,i2,gt1)
coup2 = cplAhHhSMVZ(gt2,i1)
coup3 = cplcHpVWpVZ(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {HhSM, conj[VWp], VZ}
Do i1=1,3
ML1 = MHhSM(i1) 
ML2 = MVWp 
ML3 = MVZ 
coup1 = cplHhSMcHpVWp(i1,gt1)
coup2 = cplAhHhSMVZ(gt2,i1)
coup3 = -cplcVWpVWpVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {Hp, Ah, Hp}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MAh(i2) 
ML3 = MHp(i3) 
coup1 = cplAhHpcHp(i2,i1,gt1)
coup2 = cplAhHpcHp(gt2,i3,i1)
coup3 = -cplAhcHpVWp(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Hp, HhSM, Hp}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MHhSM(i2) 
ML3 = MHp(i3) 
coup1 = cplHhSMHpcHp(i2,i1,gt1)
coup2 = cplAhHpcHp(gt2,i3,i1)
coup3 = -cplHhSMcHpVWp(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Hp, VP, Hp}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVP 
ML3 = MHp(i3) 
coup1 = cplHpcHpVP(i1,gt1)
coup2 = cplAhHpcHp(gt2,i3,i1)
coup3 = cplcHpVPVWp(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, VZ, Hp}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVZ 
ML3 = MHp(i3) 
coup1 = cplHpcHpVZ(i1,gt1)
coup2 = cplAhHpcHp(gt2,i3,i1)
coup3 = cplcHpVWpVZ(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, HhSM, VWp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHhSM(i2) 
ML3 = MVWp 
coup1 = cplHhSMHpcHp(i2,i1,gt1)
coup2 = cplAhcHpVWp(gt2,i1)
coup3 = cplHhSMcVWpVWp(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, VP, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVP 
ML3 = MVWp 
coup1 = cplHpcHpVP(i1,gt1)
coup2 = cplAhcHpVWp(gt2,i1)
coup3 = -cplcVWpVPVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {Hp, VZ, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVZ 
ML3 = MVWp 
coup1 = cplHpcHpVZ(i1,gt1)
coup2 = cplAhcHpVWp(gt2,i1)
coup3 = cplcVWpVWpVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {siga, conj[Hap], hha}
ML1 = Msiga 
ML2 = MHap 
ML3 = Mhha 
coup1 = cplHapsigacHp(gt1)
coup2 = cplAhhhasiga(gt2)
coup3 = cplhhacHapVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {VWp, Ah, Hp}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MAh(i2) 
ML3 = MHp(i3) 
coup1 = cplAhcHpVWp(i2,gt1)
coup2 = cplAhHpcVWp(gt2,i3)
coup3 = -cplAhcHpVWp(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VWp, HhSM, Hp}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHhSM(i2) 
ML3 = MHp(i3) 
coup1 = cplHhSMcHpVWp(i2,gt1)
coup2 = cplAhHpcVWp(gt2,i3)
coup3 = -cplHhSMcHpVWp(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VWp, VP, Hp}
    Do i3=1,3
ML1 = MVWp 
ML2 = MVP 
ML3 = MHp(i3) 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplAhHpcVWp(gt2,i3)
coup3 = cplcHpVPVWp(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do


! {VWp, VZ, Hp}
    Do i3=1,3
ML1 = MVWp 
ML2 = MVZ 
ML3 = MHp(i3) 
coup1 = cplcHpVWpVZ(gt1)
coup2 = cplAhHpcVWp(gt2,i3)
coup3 = cplcHpVWpVZ(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do


! {VZ, conj[Hp], HhSM}
  Do i2=1,3
    Do i3=1,3
ML1 = MVZ 
ML2 = MHp(i2) 
ML3 = MHhSM(i3) 
coup1 = cplHpcHpVZ(i2,gt1)
coup2 = cplAhHhSMVZ(gt2,i3)
coup3 = cplHhSMcHpVWp(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VZ, conj[VWp], HhSM}
    Do i3=1,3
ML1 = MVZ 
ML2 = MVWp 
ML3 = MHhSM(i3) 
coup1 = cplcHpVWpVZ(gt1)
coup2 = cplAhHhSMVZ(gt2,i3)
coup3 = cplHhSMcVWpVWp(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do


! {bar[Fd], bar[Fu], bar[Fd]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFd(i1) 
ML2 = MFu(i2) 
ML3 = MFd(i3) 
coup1L = cplcFdFucHpL(i1,i2,gt1)
coup1R = cplcFdFucHpR(i1,i2,gt1)
coup2L = cplcFdFdAhL(i3,i1,gt2)
coup2R = cplcFdFdAhR(i3,i1,gt2)
coup3L = cplcFuFdVWpL(i2,i3)
coup3R = cplcFuFdVWpR(i2,i3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(3)*AmpC 
    End Do
  End Do
End Do


! {bar[Fe], bar[Fv], bar[Fe]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFe(i1) 
ML2 = 0. 
ML3 = MFe(i3) 
coup1L = cplcFeFvcHpL(i1,i2,gt1)
coup1R = cplcFeFvcHpR(i1,i2,gt1)
coup2L = cplcFeFeAhL(i3,i1,gt2)
coup2R = cplcFeFeAhR(i3,i1,gt2)
coup3L = cplcFvFeVWpL(i2,i3)
coup3R = cplcFvFeVWpR(i2,i3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {bar[gWpC], bar[gP], bar[gWpC]}
ML1 = MVWp 
ML2 = MVP 
ML3 = MVWp 
coup1 = cplcgWCgAcHp(gt1)
coup2 = cplcgWCgWCAh(gt2)
coup3 = cplcgAgWCVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {bar[gWpC], bar[gZ], bar[gWpC]}
ML1 = MVWp 
ML2 = MVZ 
ML3 = MVWp 
coup1 = cplcgWCgZcHp(gt1)
coup2 = cplcgWCgWCAh(gt2)
coup3 = cplcgZgWCVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {Ah, conj[VWp]}
Do i1=1,3
ML1 = MAh(i1) 
ML2 = MVWp 
coup1 = -cplAhcHpVWp(i1,gt1)
coup2 = cplAhAhcVWpVWp1(gt2,i1)
Call Amp_VERTEX_StoSV_Topology2_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {Hp, VP}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVP 
coup1 = -cplHpcHpVP(i1,gt1)
coup2 = cplAhcHpVPVWp1(gt2,i1)
Call Amp_VERTEX_StoSV_Topology2_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {Hp, VZ}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVZ 
coup1 = -cplHpcHpVZ(i1,gt1)
coup2 = cplAhcHpVWpVZ1(gt2,i1)
Call Amp_VERTEX_StoSV_Topology2_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {HhSM, VZ}
Do i1=1,3
ML1 = MHhSM(i1) 
ML2 = MVZ 
coup1 = cplHhSMcHpVWpVZ1(i1,gt1)
coup2 = cplAhHhSMVZ(gt2,i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology3_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 

End Do


! {Hp, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
coup1 = cplHpcHpcVWpVWp1(i1,gt1)
coup2 = cplAhcHpVWp(gt2,i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology3_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 

End Do
  End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_HpToAhVWp


Subroutine Amplitude_IR_VERTEX_4HDM_S3_HpToAhVWp(MAh,MFd,MFe,MFu,MHap,Mhha,           & 
& MHhSM,MHp,Msiga,MVP,MVWp,MVZ,MAh2,MFd2,MFe2,MFu2,MHap2,Mhha2,MHhSM2,MHp2,              & 
& Msiga2,MVP2,MVWp2,MVZ2,cplAhAhHhSM,cplcFdFdAhL,cplcFdFdAhR,cplcFeFeAhL,cplcFeFeAhR,    & 
& cplcFuFuAhL,cplcFuFuAhR,cplcgWpgWpAh,cplcgWCgWCAh,cplAhhhasiga,cplAhHhSMVZ,            & 
& cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplcFuFdVWpL,cplcFuFdVWpR,cplcFvFeVWpL,             & 
& cplcFvFeVWpR,cplcFdFucHpL,cplcFdFucHpR,cplcFeFvcHpL,cplcFeFvcHpR,cplcgWCgAcHp,         & 
& cplcgZgWpcHp,cplcgAgWCVWp,cplcgZgWCVWp,cplcgWpgZVWp,cplcgWCgZcHp,cplHaphhacHp,         & 
& cplHapsigacHp,cplhhacHapVWp,cplHhSMHpcHp,cplHhSMcHpVWp,cplHhSMcVWpVWp,cplHpcHpVP,      & 
& cplHpcHpVZ,cplsigacHapVWp,cplcHpVPVWp,cplcVWpVPVWp,cplcHpVWpVZ,cplcVWpVWpVZ,           & 
& cplAhAhcVWpVWp1,cplAhcHpVPVWp1,cplAhcHpVWpVZ1,cplHhSMcHpVWpVZ1,cplHpcHpcVWpVWp1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHap,Mhha,MHhSM(3),MHp(3),Msiga,MVP,MVWp,MVZ,             & 
& MAh2(3),MFd2(3),MFe2(3),MFu2(3),MHap2,Mhha2,MHhSM2(3),MHp2(3),Msiga2,MVP2,             & 
& MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhAhHhSM(3,3,3),cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFeFeAhL(3,3,3),          & 
& cplcFeFeAhR(3,3,3),cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),cplcgWpgWpAh(3),              & 
& cplcgWCgWCAh(3),cplAhhhasiga(3),cplAhHhSMVZ(3,3),cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),   & 
& cplAhcHpVWp(3,3),cplcFuFdVWpL(3,3),cplcFuFdVWpR(3,3),cplcFvFeVWpL(3,3),cplcFvFeVWpR(3,3),& 
& cplcFdFucHpL(3,3,3),cplcFdFucHpR(3,3,3),cplcFeFvcHpL(3,3,3),cplcFeFvcHpR(3,3,3),       & 
& cplcgWCgAcHp(3),cplcgZgWpcHp(3),cplcgAgWCVWp,cplcgZgWCVWp,cplcgWpgZVWp,cplcgWCgZcHp(3),& 
& cplHaphhacHp(3),cplHapsigacHp(3),cplhhacHapVWp,cplHhSMHpcHp(3,3,3),cplHhSMcHpVWp(3,3), & 
& cplHhSMcVWpVWp(3),cplHpcHpVP(3,3),cplHpcHpVZ(3,3),cplsigacHapVWp,cplcHpVPVWp(3),       & 
& cplcVWpVPVWp,cplcHpVWpVZ(3),cplcVWpVWpVZ,cplAhAhcVWpVWp1(3,3),cplAhcHpVPVWp1(3,3),     & 
& cplAhcHpVWpVZ1(3,3),cplHhSMcHpVWpVZ1(3,3),cplHpcHpcVWpVWp1(3,3)

Complex(dp), Intent(out) :: Amp(2,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
Amp(:,gt1, gt2) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MAh(gt2) 
Mex3 = MVWp 


! {Hp, VP, Hp}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVP 
ML3 = MHp(i3) 
coup1 = cplHpcHpVP(i1,gt1)
coup2 = cplAhHpcHp(gt2,i3,i1)
coup3 = cplcHpVPVWp(i3)
Call Amp_VERTEX_StoSV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, VP, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVP 
ML3 = MVWp 
coup1 = cplHpcHpVP(i1,gt1)
coup2 = cplAhcHpVWp(gt2,i1)
coup3 = -cplcVWpVPVWp
Call Amp_VERTEX_StoSV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {VWp, VP, Hp}
    Do i3=1,3
ML1 = MVWp 
ML2 = MVP 
ML3 = MHp(i3) 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplAhHpcVWp(gt2,i3)
coup3 = cplcHpVPVWp(i3)
Call Amp_VERTEX_StoSV_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do


! {Hp, VP}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVP 
coup1 = -cplHpcHpVP(i1,gt1)
coup2 = cplAhcHpVPVWp1(gt2,i1)
Call Amp_VERTEX_StoSV_Topology2_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do
  End Do
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_HpToAhVWp


Subroutine Amplitude_Tree_4HDM_S3_HpTocFdFu(cplcFdFucHpL,cplcFdFucHpR,MFd,            & 
& MFu,MHp,MFd2,MFu2,MHp2,Amp)

Implicit None

Real(dp), Intent(in) :: MFd(3),MFu(3),MHp(3),MFd2(3),MFu2(3),MHp2(3)

Complex(dp), Intent(in) :: cplcFdFucHpL(3,3,3),cplcFdFucHpR(3,3,3)

Complex(dp) :: Amp(2,3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 

Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MFd(gt2) 
Mex3 = MFu(gt3) 
! Tree-Level Vertex 
coupT1L = cplcFdFucHpL(gt2,gt3,gt1)
coupT1R = cplcFdFucHpR(gt2,gt3,gt1)
Call TreeAmp_StoFF(Mex1,Mex2,Mex3,coupT1L,coupT1R,AmpC) 
! Colour and symmetry factor 
Amp(:,gt1, gt2, gt3) = AmpC 
    End Do
  End Do
End Do
End Subroutine Amplitude_Tree_4HDM_S3_HpTocFdFu


Subroutine Gamma_Real_4HDM_S3_HpTocFdFu(MLambda,em,gs,cplcFdFucHpL,cplcFdFucHpR,      & 
& MFd,MFu,MHp,GammarealPhoton,GammarealGluon)

Implicit None

Complex(dp), Intent(in) :: cplcFdFucHpL(3,3,3),cplcFdFucHpR(3,3,3)

Real(dp), Intent(in) :: MFd(3),MFu(3),MHp(3)

Real(dp), Intent(in) :: MLambda, em, gs 

Real(dp), Intent(out) :: GammarealPhoton(3,3,3), GammarealGluon(3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3, kont 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 

Real(dp) :: Mloop1, Mloop2, Mloop3 
Complex(dp) :: CoupL, CoupR 
 
Do i1=2,3
  Do i2=1,3
    Do i3=1,3
CoupL = cplcFdFucHpL(i2,i3,i1)
CoupR = cplcFdFucHpR(i2,i3,i1)
Mex1 = MHp(i1)
Mex2 = MFd(i2)
Mex3 = MFu(i3)
If (Mex1.gt.(Mex2+Mex3)) Then 
 Call hardradiationSFF(Mex1,Mex2,Mex3,MLambda,em,3._dp,1._dp,2._dp,1._dp/3._dp,2._dp/3._dp,4._dp/3._dp,CoupL,CoupR,Gammarealphoton(i1,i2,i3),kont)
 Call hardradiationSFF(Mex1,Mex2,Mex3,MLambda,gs,0._dp,0._dp,0._dp,4._dp,-4._dp,4._dp,CoupL,CoupR,Gammarealgluon(i1,i2,i3),kont)
Else 
  GammarealGluon(i1,i2,i3) = 0._dp 
  GammarealPhoton(i1,i2,i3) = 0._dp 

End if 
    End Do
  End Do
End Do
End Subroutine Gamma_Real_4HDM_S3_HpTocFdFu


Subroutine Amplitude_WAVE_4HDM_S3_HpTocFdFu(cplcFdFucHpL,cplcFdFucHpR,ctcplcFdFucHpL, & 
& ctcplcFdFucHpR,MFd,MFd2,MFu,MFu2,MHp,MHp2,ZfDL,ZfDR,ZfHp,ZfUL,ZfUR,Amp)

Implicit None

Real(dp), Intent(in) :: MFd(3),MFd2(3),MFu(3),MFu2(3),MHp(3),MHp2(3)

Complex(dp), Intent(in) :: cplcFdFucHpL(3,3,3),cplcFdFucHpR(3,3,3)

Complex(dp), Intent(in) :: ctcplcFdFucHpL(3,3,3),ctcplcFdFucHpR(3,3,3)

Complex(dp), Intent(in) :: ZfDL(3,3),ZfDR(3,3),ZfHp(3,3),ZfUL(3,3),ZfUR(3,3)

Complex(dp), Intent(out) :: Amp(2,3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MFd(gt2) 
Mex3 = MFu(gt3) 
!----------------------------- 
! Coupling counter term 
!----------------------------- 
ZcoupT1L = ctcplcFdFucHpL(gt2,gt3,gt1) 
ZcoupT1R = ctcplcFdFucHpR(gt2,gt3,gt1) 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
Do i1=1,3
ZcoupT1L = ZcoupT1L + 0.5_dp*Conjg(ZfHp(i1,gt1))*cplcFdFucHpL(gt2,gt3,i1)
ZcoupT1R = ZcoupT1R + 0.5_dp*Conjg(ZfHp(i1,gt1))*cplcFdFucHpR(gt2,gt3,i1)
End Do


! External Field 2 
Do i1=1,3
ZcoupT1L = ZcoupT1L + 0.5_dp*ZfDR(i1,gt2)*cplcFdFucHpL(i1,gt3,gt1)
ZcoupT1R = ZcoupT1R + 0.5_dp*Conjg(ZfDL(i1,gt2))*cplcFdFucHpR(i1,gt3,gt1)
End Do


! External Field 3 
Do i1=1,3
ZcoupT1L = ZcoupT1L + 0.5_dp*ZfUL(i1,gt3)*cplcFdFucHpL(gt2,i1,gt1)
ZcoupT1R = ZcoupT1R + 0.5_dp*Conjg(ZfUR(i1,gt3))*cplcFdFucHpR(gt2,i1,gt1)
End Do


! Getting the amplitude 
Call TreeAmp_StoFF(Mex1,Mex2,Mex3,ZcoupT1L,ZcoupT1R,AmpC) 
Amp(:,gt1, gt2, gt3) = AmpC 
    End Do
  End Do
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_HpTocFdFu


Subroutine Amplitude_VERTEX_4HDM_S3_HpTocFdFu(MAh,MFd,MFu,MHhSM,MHp,MVG,              & 
& MVP,MVWp,MVZ,MAh2,MFd2,MFu2,MHhSM2,MHp2,MVG2,MVP2,MVWp2,MVZ2,cplcFdFdAhL,              & 
& cplcFdFdAhR,cplcFuFuAhL,cplcFuFuAhR,cplAhHpcHp,cplAhcHpVWp,cplcFdFdHhSML,              & 
& cplcFdFdHhSMR,cplcFdFdVGL,cplcFdFdVGR,cplcFdFdVPL,cplcFdFdVPR,cplcFdFdVZL,             & 
& cplcFdFdVZR,cplcFuFuHhSML,cplcFuFuHhSMR,cplcFuFuVGL,cplcFuFuVGR,cplcFuFuVPL,           & 
& cplcFuFuVPR,cplcFuFuVZL,cplcFuFuVZR,cplcFdFucHpL,cplcFdFucHpR,cplcFdFucVWpL,           & 
& cplcFdFucVWpR,cplHhSMHpcHp,cplHhSMcHpVWp,cplHpcHpVP,cplHpcHpVZ,cplcHpVPVWp,            & 
& cplcHpVWpVZ,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFu(3),MHhSM(3),MHp(3),MVG,MVP,MVWp,MVZ,MAh2(3),MFd2(3),MFu2(3),        & 
& MHhSM2(3),MHp2(3),MVG2,MVP2,MVWp2,MVZ2

Complex(dp), Intent(in) :: cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),          & 
& cplAhHpcHp(3,3,3),cplAhcHpVWp(3,3),cplcFdFdHhSML(3,3,3),cplcFdFdHhSMR(3,3,3),          & 
& cplcFdFdVGL(3,3),cplcFdFdVGR(3,3),cplcFdFdVPL(3,3),cplcFdFdVPR(3,3),cplcFdFdVZL(3,3),  & 
& cplcFdFdVZR(3,3),cplcFuFuHhSML(3,3,3),cplcFuFuHhSMR(3,3,3),cplcFuFuVGL(3,3),           & 
& cplcFuFuVGR(3,3),cplcFuFuVPL(3,3),cplcFuFuVPR(3,3),cplcFuFuVZL(3,3),cplcFuFuVZR(3,3),  & 
& cplcFdFucHpL(3,3,3),cplcFdFucHpR(3,3,3),cplcFdFucVWpL(3,3),cplcFdFucVWpR(3,3),         & 
& cplHhSMHpcHp(3,3,3),cplHhSMcHpVWp(3,3),cplHpcHpVP(3,3),cplHpcHpVZ(3,3),cplcHpVPVWp(3), & 
& cplcHpVWpVZ(3)

Complex(dp), Intent(out) :: Amp(2,3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
Amp(:,gt1, gt2, gt3) = 0._dp 
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MFd(gt2) 
Mex3 = MFu(gt3) 


! {Ah, conj[Hp], Fd}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MAh(i1) 
ML2 = MHp(i2) 
ML3 = MFd(i3) 
coup1 = cplAhHpcHp(i1,i2,gt1)
coup2L = cplcFdFdAhL(gt2,i3,i1)
coup2R = cplcFdFdAhR(gt2,i3,i1)
coup3L = cplcFdFucHpL(i3,gt3,i2)
coup3R = cplcFdFucHpR(i3,gt3,i2)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_SSF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Ah, conj[VWp], Fd}
Do i1=1,3
    Do i3=1,3
ML1 = MAh(i1) 
ML2 = MVWp 
ML3 = MFd(i3) 
coup1 = -cplAhcHpVWp(i1,gt1)
coup2L = cplcFdFdAhL(gt2,i3,i1)
coup2R = cplcFdFdAhR(gt2,i3,i1)
coup3L = cplcFdFucVWpL(i3,gt3)
coup3R = cplcFdFucVWpR(i3,gt3)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_SVF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {HhSM, conj[Hp], Fd}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHhSM(i1) 
ML2 = MHp(i2) 
ML3 = MFd(i3) 
coup1 = cplHhSMHpcHp(i1,i2,gt1)
coup2L = cplcFdFdHhSML(gt2,i3,i1)
coup2R = cplcFdFdHhSMR(gt2,i3,i1)
coup3L = cplcFdFucHpL(i3,gt3,i2)
coup3R = cplcFdFucHpR(i3,gt3,i2)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_SSF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {HhSM, conj[VWp], Fd}
Do i1=1,3
    Do i3=1,3
ML1 = MHhSM(i1) 
ML2 = MVWp 
ML3 = MFd(i3) 
coup1 = -cplHhSMcHpVWp(i1,gt1)
coup2L = cplcFdFdHhSML(gt2,i3,i1)
coup2R = cplcFdFdHhSMR(gt2,i3,i1)
coup3L = cplcFdFucVWpL(i3,gt3)
coup3R = cplcFdFucVWpR(i3,gt3)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_SVF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, Ah, Fu}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MAh(i2) 
ML3 = MFu(i3) 
coup1 = cplAhHpcHp(i2,i1,gt1)
coup2L = cplcFdFucHpL(gt2,i3,i1)
coup2R = cplcFdFucHpR(gt2,i3,i1)
coup3L = cplcFuFuAhL(i3,gt3,i2)
coup3R = cplcFuFuAhR(i3,gt3,i2)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_SSF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Hp, HhSM, Fu}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MHhSM(i2) 
ML3 = MFu(i3) 
coup1 = cplHhSMHpcHp(i2,i1,gt1)
coup2L = cplcFdFucHpL(gt2,i3,i1)
coup2R = cplcFdFucHpR(gt2,i3,i1)
coup3L = cplcFuFuHhSML(i3,gt3,i2)
coup3R = cplcFuFuHhSMR(i3,gt3,i2)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_SSF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Hp, VP, Fu}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVP 
ML3 = MFu(i3) 
coup1 = -cplHpcHpVP(i1,gt1)
coup2L = cplcFdFucHpL(gt2,i3,i1)
coup2R = cplcFdFucHpR(gt2,i3,i1)
coup3L = cplcFuFuVPL(i3,gt3)
coup3R = cplcFuFuVPR(i3,gt3)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_SVF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, VZ, Fu}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVZ 
ML3 = MFu(i3) 
coup1 = -cplHpcHpVZ(i1,gt1)
coup2L = cplcFdFucHpL(gt2,i3,i1)
coup2R = cplcFdFucHpR(gt2,i3,i1)
coup3L = cplcFuFuVZL(i3,gt3)
coup3R = cplcFuFuVZR(i3,gt3)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_SVF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {VP, conj[Hp], Fd}
  Do i2=1,3
    Do i3=1,3
ML1 = MVP 
ML2 = MHp(i2) 
ML3 = MFd(i3) 
coup1 = -cplHpcHpVP(i2,gt1)
coup2L = cplcFdFdVPL(gt2,i3)
coup2R = cplcFdFdVPR(gt2,i3)
coup3L = cplcFdFucHpL(i3,gt3,i2)
coup3R = cplcFdFucHpR(i3,gt3,i2)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_VSF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VP, conj[VWp], Fd}
    Do i3=1,3
ML1 = MVP 
ML2 = MVWp 
ML3 = MFd(i3) 
coup1 = cplcHpVPVWp(gt1)
coup2L = cplcFdFdVPL(gt2,i3)
coup2R = cplcFdFdVPR(gt2,i3)
coup3L = cplcFdFucVWpL(i3,gt3)
coup3R = cplcFdFucVWpR(i3,gt3)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_VVF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do


! {VWp, Ah, Fu}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MAh(i2) 
ML3 = MFu(i3) 
coup1 = -cplAhcHpVWp(i2,gt1)
coup2L = cplcFdFucVWpL(gt2,i3)
coup2R = cplcFdFucVWpR(gt2,i3)
coup3L = cplcFuFuAhL(i3,gt3,i2)
coup3R = cplcFuFuAhR(i3,gt3,i2)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_VSF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VWp, HhSM, Fu}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHhSM(i2) 
ML3 = MFu(i3) 
coup1 = -cplHhSMcHpVWp(i2,gt1)
coup2L = cplcFdFucVWpL(gt2,i3)
coup2R = cplcFdFucVWpR(gt2,i3)
coup3L = cplcFuFuHhSML(i3,gt3,i2)
coup3R = cplcFuFuHhSMR(i3,gt3,i2)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_VSF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VWp, VP, Fu}
    Do i3=1,3
ML1 = MVWp 
ML2 = MVP 
ML3 = MFu(i3) 
coup1 = cplcHpVPVWp(gt1)
coup2L = cplcFdFucVWpL(gt2,i3)
coup2R = cplcFdFucVWpR(gt2,i3)
coup3L = cplcFuFuVPL(i3,gt3)
coup3R = cplcFuFuVPR(i3,gt3)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_VVF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do


! {VWp, VZ, Fu}
    Do i3=1,3
ML1 = MVWp 
ML2 = MVZ 
ML3 = MFu(i3) 
coup1 = cplcHpVWpVZ(gt1)
coup2L = cplcFdFucVWpL(gt2,i3)
coup2R = cplcFdFucVWpR(gt2,i3)
coup3L = cplcFuFuVZL(i3,gt3)
coup3R = cplcFuFuVZR(i3,gt3)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_VVF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do


! {VZ, conj[Hp], Fd}
  Do i2=1,3
    Do i3=1,3
ML1 = MVZ 
ML2 = MHp(i2) 
ML3 = MFd(i3) 
coup1 = -cplHpcHpVZ(i2,gt1)
coup2L = cplcFdFdVZL(gt2,i3)
coup2R = cplcFdFdVZR(gt2,i3)
coup3L = cplcFdFucHpL(i3,gt3,i2)
coup3R = cplcFdFucHpR(i3,gt3,i2)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_VSF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VZ, conj[VWp], Fd}
    Do i3=1,3
ML1 = MVZ 
ML2 = MVWp 
ML3 = MFd(i3) 
coup1 = cplcHpVWpVZ(gt1)
coup2L = cplcFdFdVZL(gt2,i3)
coup2R = cplcFdFdVZR(gt2,i3)
coup3L = cplcFdFucVWpL(i3,gt3)
coup3R = cplcFdFucVWpR(i3,gt3)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_VVF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do


! {bar[Fd], bar[Fu], Ah}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFd(i1) 
ML2 = MFu(i2) 
ML3 = MAh(i3) 
coup1L = cplcFdFucHpL(i1,i2,gt1)
coup1R = cplcFdFucHpR(i1,i2,gt1)
coup2L = cplcFdFdAhL(gt2,i1,i3)
coup2R = cplcFdFdAhR(gt2,i1,i3)
coup3L = cplcFuFuAhL(i2,gt3,i3)
coup3R = cplcFuFuAhR(i2,gt3,i3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_FFS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {bar[Fd], bar[Fu], HhSM}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFd(i1) 
ML2 = MFu(i2) 
ML3 = MHhSM(i3) 
coup1L = cplcFdFucHpL(i1,i2,gt1)
coup1R = cplcFdFucHpR(i1,i2,gt1)
coup2L = cplcFdFdHhSML(gt2,i1,i3)
coup2R = cplcFdFdHhSMR(gt2,i1,i3)
coup3L = cplcFuFuHhSML(i2,gt3,i3)
coup3R = cplcFuFuHhSMR(i2,gt3,i3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_FFS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {bar[Fd], bar[Fu], VG}
Do i1=1,3
  Do i2=1,3
ML1 = MFd(i1) 
ML2 = MFu(i2) 
ML3 = MVG 
coup1L = cplcFdFucHpL(i1,i2,gt1)
coup1R = cplcFdFucHpR(i1,i2,gt1)
coup2L = cplcFdFdVGL(gt2,i1)
coup2R = cplcFdFdVGR(gt2,i1)
coup3L = cplcFuFuVGL(i2,gt3)
coup3R = cplcFuFuVGR(i2,gt3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_FFV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(4._dp/3._dp)*AmpC 
  End Do
End Do


! {bar[Fd], bar[Fu], VP}
Do i1=1,3
  Do i2=1,3
ML1 = MFd(i1) 
ML2 = MFu(i2) 
ML3 = MVP 
coup1L = cplcFdFucHpL(i1,i2,gt1)
coup1R = cplcFdFucHpR(i1,i2,gt1)
coup2L = cplcFdFdVPL(gt2,i1)
coup2R = cplcFdFdVPR(gt2,i1)
coup3L = cplcFuFuVPL(i2,gt3)
coup3R = cplcFuFuVPR(i2,gt3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_FFV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {bar[Fd], bar[Fu], VZ}
Do i1=1,3
  Do i2=1,3
ML1 = MFd(i1) 
ML2 = MFu(i2) 
ML3 = MVZ 
coup1L = cplcFdFucHpL(i1,i2,gt1)
coup1R = cplcFdFucHpR(i1,i2,gt1)
coup2L = cplcFdFdVZL(gt2,i1)
coup2R = cplcFdFdVZR(gt2,i1)
coup3L = cplcFuFuVZL(i2,gt3)
coup3R = cplcFuFuVZR(i2,gt3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_FFV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do
    End Do
  End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_HpTocFdFu


Subroutine Amplitude_IR_VERTEX_4HDM_S3_HpTocFdFu(MAh,MFd,MFu,MHhSM,MHp,               & 
& MVG,MVP,MVWp,MVZ,MAh2,MFd2,MFu2,MHhSM2,MHp2,MVG2,MVP2,MVWp2,MVZ2,cplcFdFdAhL,          & 
& cplcFdFdAhR,cplcFuFuAhL,cplcFuFuAhR,cplAhHpcHp,cplAhcHpVWp,cplcFdFdHhSML,              & 
& cplcFdFdHhSMR,cplcFdFdVGL,cplcFdFdVGR,cplcFdFdVPL,cplcFdFdVPR,cplcFdFdVZL,             & 
& cplcFdFdVZR,cplcFuFuHhSML,cplcFuFuHhSMR,cplcFuFuVGL,cplcFuFuVGR,cplcFuFuVPL,           & 
& cplcFuFuVPR,cplcFuFuVZL,cplcFuFuVZR,cplcFdFucHpL,cplcFdFucHpR,cplcFdFucVWpL,           & 
& cplcFdFucVWpR,cplHhSMHpcHp,cplHhSMcHpVWp,cplHpcHpVP,cplHpcHpVZ,cplcHpVPVWp,            & 
& cplcHpVWpVZ,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFu(3),MHhSM(3),MHp(3),MVG,MVP,MVWp,MVZ,MAh2(3),MFd2(3),MFu2(3),        & 
& MHhSM2(3),MHp2(3),MVG2,MVP2,MVWp2,MVZ2

Complex(dp), Intent(in) :: cplcFdFdAhL(3,3,3),cplcFdFdAhR(3,3,3),cplcFuFuAhL(3,3,3),cplcFuFuAhR(3,3,3),          & 
& cplAhHpcHp(3,3,3),cplAhcHpVWp(3,3),cplcFdFdHhSML(3,3,3),cplcFdFdHhSMR(3,3,3),          & 
& cplcFdFdVGL(3,3),cplcFdFdVGR(3,3),cplcFdFdVPL(3,3),cplcFdFdVPR(3,3),cplcFdFdVZL(3,3),  & 
& cplcFdFdVZR(3,3),cplcFuFuHhSML(3,3,3),cplcFuFuHhSMR(3,3,3),cplcFuFuVGL(3,3),           & 
& cplcFuFuVGR(3,3),cplcFuFuVPL(3,3),cplcFuFuVPR(3,3),cplcFuFuVZL(3,3),cplcFuFuVZR(3,3),  & 
& cplcFdFucHpL(3,3,3),cplcFdFucHpR(3,3,3),cplcFdFucVWpL(3,3),cplcFdFucVWpR(3,3),         & 
& cplHhSMHpcHp(3,3,3),cplHhSMcHpVWp(3,3),cplHpcHpVP(3,3),cplHpcHpVZ(3,3),cplcHpVPVWp(3), & 
& cplcHpVWpVZ(3)

Complex(dp), Intent(out) :: Amp(2,3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
Amp(:,gt1, gt2, gt3) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MFd(gt2) 
Mex3 = MFu(gt3) 


! {Hp, VP, Fu}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVP 
ML3 = MFu(i3) 
coup1 = -cplHpcHpVP(i1,gt1)
coup2L = cplcFdFucHpL(gt2,i3,i1)
coup2R = cplcFdFucHpR(gt2,i3,i1)
coup3L = cplcFuFuVPL(i3,gt3)
coup3R = cplcFuFuVPR(i3,gt3)
Call Amp_VERTEX_StoFF_Topology1_SVF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {VP, conj[Hp], Fd}
  Do i2=1,3
    Do i3=1,3
ML1 = MVP 
ML2 = MHp(i2) 
ML3 = MFd(i3) 
coup1 = -cplHpcHpVP(i2,gt1)
coup2L = cplcFdFdVPL(gt2,i3)
coup2R = cplcFdFdVPR(gt2,i3)
coup3L = cplcFdFucHpL(i3,gt3,i2)
coup3R = cplcFdFucHpR(i3,gt3,i2)
Call Amp_VERTEX_StoFF_Topology1_VSF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VP, conj[VWp], Fd}
    Do i3=1,3
ML1 = MVP 
ML2 = MVWp 
ML3 = MFd(i3) 
coup1 = cplcHpVPVWp(gt1)
coup2L = cplcFdFdVPL(gt2,i3)
coup2R = cplcFdFdVPR(gt2,i3)
coup3L = cplcFdFucVWpL(i3,gt3)
coup3R = cplcFdFucVWpR(i3,gt3)
Call Amp_VERTEX_StoFF_Topology1_VVF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do


! {VWp, VP, Fu}
    Do i3=1,3
ML1 = MVWp 
ML2 = MVP 
ML3 = MFu(i3) 
coup1 = cplcHpVPVWp(gt1)
coup2L = cplcFdFucVWpL(gt2,i3)
coup2R = cplcFdFucVWpR(gt2,i3)
coup3L = cplcFuFuVPL(i3,gt3)
coup3R = cplcFuFuVPR(i3,gt3)
Call Amp_VERTEX_StoFF_Topology1_VVF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do


! {bar[Fd], bar[Fu], VG}
Do i1=1,3
  Do i2=1,3
ML1 = MFd(i1) 
ML2 = MFu(i2) 
ML3 = MVG 
coup1L = cplcFdFucHpL(i1,i2,gt1)
coup1R = cplcFdFucHpR(i1,i2,gt1)
coup2L = cplcFdFdVGL(gt2,i1)
coup2R = cplcFdFdVGR(gt2,i1)
coup3L = cplcFuFuVGL(i2,gt3)
coup3R = cplcFuFuVGR(i2,gt3)
Call Amp_VERTEX_StoFF_Topology1_FFV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(4._dp/3._dp)*AmpC 
  End Do
End Do


! {bar[Fd], bar[Fu], VP}
Do i1=1,3
  Do i2=1,3
ML1 = MFd(i1) 
ML2 = MFu(i2) 
ML3 = MVP 
coup1L = cplcFdFucHpL(i1,i2,gt1)
coup1R = cplcFdFucHpR(i1,i2,gt1)
coup2L = cplcFdFdVPL(gt2,i1)
coup2R = cplcFdFdVPR(gt2,i1)
coup3L = cplcFuFuVPL(i2,gt3)
coup3R = cplcFuFuVPR(i2,gt3)
Call Amp_VERTEX_StoFF_Topology1_FFV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do
    End Do
  End Do
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_HpTocFdFu


Subroutine Amplitude_Tree_4HDM_S3_HpTocFeFv(cplcFeFvcHpL,cplcFeFvcHpR,MFe,            & 
& MHp,MFe2,MHp2,Amp)

Implicit None

Real(dp), Intent(in) :: MFe(3),MHp(3),MFe2(3),MHp2(3)

Complex(dp), Intent(in) :: cplcFeFvcHpL(3,3,3),cplcFeFvcHpR(3,3,3)

Complex(dp) :: Amp(2,3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 

Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MFe(gt2) 
Mex3 = 0. 
! Tree-Level Vertex 
coupT1L = cplcFeFvcHpL(gt2,gt3,gt1)
coupT1R = cplcFeFvcHpR(gt2,gt3,gt1)
Call TreeAmp_StoFF(Mex1,Mex2,Mex3,coupT1L,coupT1R,AmpC) 
! Colour and symmetry factor 
Amp(:,gt1, gt2, gt3) = AmpC 
    End Do
  End Do
End Do
End Subroutine Amplitude_Tree_4HDM_S3_HpTocFeFv


Subroutine Gamma_Real_4HDM_S3_HpTocFeFv(MLambda,em,gs,cplcFeFvcHpL,cplcFeFvcHpR,      & 
& MFe,MHp,GammarealPhoton,GammarealGluon)

Implicit None

Complex(dp), Intent(in) :: cplcFeFvcHpL(3,3,3),cplcFeFvcHpR(3,3,3)

Real(dp), Intent(in) :: MFe(3),MHp(3)

Real(dp), Intent(in) :: MLambda, em, gs 

Real(dp), Intent(out) :: GammarealPhoton(3,3,3), GammarealGluon(3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3, kont 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 

Real(dp) :: Mloop1, Mloop2, Mloop3 
Complex(dp) :: CoupL, CoupR 
 
Do i1=2,3
  Do i2=1,3
    Do i3=1,3
CoupL = cplcFeFvcHpL(i2,i3,i1)
CoupR = cplcFeFvcHpR(i2,i3,i1)
Mex1 = MHp(i1)
Mex2 = MFe(i2)
Mex3 = 0.
If (Mex1.gt.(Mex2+Mex3)) Then 
 Call hardradiationSFF(Mex1,Mex2,Mex3,MLambda,em,1._dp,1._dp,0._dp,1._dp,0._dp,0._dp,CoupL,CoupR,Gammarealphoton(i1,i2,i3),kont)
  GammarealGluon(i1,i2,i3) = 0._dp 
Else 
  GammarealGluon(i1,i2,i3) = 0._dp 
  GammarealPhoton(i1,i2,i3) = 0._dp 

End if 
    End Do
  End Do
End Do
End Subroutine Gamma_Real_4HDM_S3_HpTocFeFv


Subroutine Amplitude_WAVE_4HDM_S3_HpTocFeFv(cplcFeFvcHpL,cplcFeFvcHpR,ctcplcFeFvcHpL, & 
& ctcplcFeFvcHpR,MFe,MFe2,MHp,MHp2,ZfEL,ZfER,ZfHp,ZfvL,Amp)

Implicit None

Real(dp), Intent(in) :: MFe(3),MFe2(3),MHp(3),MHp2(3)

Complex(dp), Intent(in) :: cplcFeFvcHpL(3,3,3),cplcFeFvcHpR(3,3,3)

Complex(dp), Intent(in) :: ctcplcFeFvcHpL(3,3,3),ctcplcFeFvcHpR(3,3,3)

Complex(dp), Intent(in) :: ZfEL(3,3),ZfER(3,3),ZfHp(3,3),ZfvL(3,3)

Complex(dp), Intent(out) :: Amp(2,3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MFe(gt2) 
Mex3 = 0. 
!----------------------------- 
! Coupling counter term 
!----------------------------- 
ZcoupT1L = ctcplcFeFvcHpL(gt2,gt3,gt1) 
ZcoupT1R = ctcplcFeFvcHpR(gt2,gt3,gt1) 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
Do i1=1,3
ZcoupT1L = ZcoupT1L + 0.5_dp*Conjg(ZfHp(i1,gt1))*cplcFeFvcHpL(gt2,gt3,i1)
ZcoupT1R = ZcoupT1R + 0.5_dp*Conjg(ZfHp(i1,gt1))*cplcFeFvcHpR(gt2,gt3,i1)
End Do


! External Field 2 
Do i1=1,3
ZcoupT1L = ZcoupT1L + 0.5_dp*ZfER(i1,gt2)*cplcFeFvcHpL(i1,gt3,gt1)
ZcoupT1R = ZcoupT1R + 0.5_dp*Conjg(ZfEL(i1,gt2))*cplcFeFvcHpR(i1,gt3,gt1)
End Do


! External Field 3 
Do i1=1,3
ZcoupT1L = ZcoupT1L + 0.5_dp*ZfvL(i1,gt3)*cplcFeFvcHpL(gt2,i1,gt1)
ZcoupT1R = ZcoupT1R + 0.5_dp*0*cplcFeFvcHpR(gt2,i1,gt1)
End Do


! Getting the amplitude 
Call TreeAmp_StoFF(Mex1,Mex2,Mex3,ZcoupT1L,ZcoupT1R,AmpC) 
Amp(:,gt1, gt2, gt3) = AmpC 
    End Do
  End Do
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_HpTocFeFv


Subroutine Amplitude_VERTEX_4HDM_S3_HpTocFeFv(MAh,MFe,MHhSM,MHp,MVP,MVWp,             & 
& MVZ,MAh2,MFe2,MHhSM2,MHp2,MVP2,MVWp2,MVZ2,cplcFeFeAhL,cplcFeFeAhR,cplAhHpcHp,          & 
& cplAhcHpVWp,cplcFeFeHhSML,cplcFeFeHhSMR,cplcFeFeVPL,cplcFeFeVPR,cplcFeFeVZL,           & 
& cplcFeFeVZR,cplcFvFvVZL,cplcFvFvVZR,cplcFeFvcHpL,cplcFeFvcHpR,cplcFeFvcVWpL,           & 
& cplcFeFvcVWpR,cplHhSMHpcHp,cplHhSMcHpVWp,cplHpcHpVP,cplHpcHpVZ,cplcHpVPVWp,            & 
& cplcHpVWpVZ,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFe(3),MHhSM(3),MHp(3),MVP,MVWp,MVZ,MAh2(3),MFe2(3),MHhSM2(3),MHp2(3),         & 
& MVP2,MVWp2,MVZ2

Complex(dp), Intent(in) :: cplcFeFeAhL(3,3,3),cplcFeFeAhR(3,3,3),cplAhHpcHp(3,3,3),cplAhcHpVWp(3,3),             & 
& cplcFeFeHhSML(3,3,3),cplcFeFeHhSMR(3,3,3),cplcFeFeVPL(3,3),cplcFeFeVPR(3,3),           & 
& cplcFeFeVZL(3,3),cplcFeFeVZR(3,3),cplcFvFvVZL(3,3),cplcFvFvVZR(3,3),cplcFeFvcHpL(3,3,3),& 
& cplcFeFvcHpR(3,3,3),cplcFeFvcVWpL(3,3),cplcFeFvcVWpR(3,3),cplHhSMHpcHp(3,3,3),         & 
& cplHhSMcHpVWp(3,3),cplHpcHpVP(3,3),cplHpcHpVZ(3,3),cplcHpVPVWp(3),cplcHpVWpVZ(3)

Complex(dp), Intent(out) :: Amp(2,3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
Amp(:,gt1, gt2, gt3) = 0._dp 
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MFe(gt2) 
Mex3 = 0. 


! {Ah, conj[Hp], Fe}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MAh(i1) 
ML2 = MHp(i2) 
ML3 = MFe(i3) 
coup1 = cplAhHpcHp(i1,i2,gt1)
coup2L = cplcFeFeAhL(gt2,i3,i1)
coup2R = cplcFeFeAhR(gt2,i3,i1)
coup3L = cplcFeFvcHpL(i3,gt3,i2)
coup3R = cplcFeFvcHpR(i3,gt3,i2)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_SSF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Ah, conj[VWp], Fe}
Do i1=1,3
    Do i3=1,3
ML1 = MAh(i1) 
ML2 = MVWp 
ML3 = MFe(i3) 
coup1 = -cplAhcHpVWp(i1,gt1)
coup2L = cplcFeFeAhL(gt2,i3,i1)
coup2R = cplcFeFeAhR(gt2,i3,i1)
coup3L = cplcFeFvcVWpL(i3,gt3)
coup3R = cplcFeFvcVWpR(i3,gt3)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_SVF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {HhSM, conj[Hp], Fe}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHhSM(i1) 
ML2 = MHp(i2) 
ML3 = MFe(i3) 
coup1 = cplHhSMHpcHp(i1,i2,gt1)
coup2L = cplcFeFeHhSML(gt2,i3,i1)
coup2R = cplcFeFeHhSMR(gt2,i3,i1)
coup3L = cplcFeFvcHpL(i3,gt3,i2)
coup3R = cplcFeFvcHpR(i3,gt3,i2)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_SSF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {HhSM, conj[VWp], Fe}
Do i1=1,3
    Do i3=1,3
ML1 = MHhSM(i1) 
ML2 = MVWp 
ML3 = MFe(i3) 
coup1 = -cplHhSMcHpVWp(i1,gt1)
coup2L = cplcFeFeHhSML(gt2,i3,i1)
coup2R = cplcFeFeHhSMR(gt2,i3,i1)
coup3L = cplcFeFvcVWpL(i3,gt3)
coup3R = cplcFeFvcVWpR(i3,gt3)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_SVF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, VZ, Fv}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVZ 
ML3 = 0. 
coup1 = -cplHpcHpVZ(i1,gt1)
coup2L = cplcFeFvcHpL(gt2,i3,i1)
coup2R = cplcFeFvcHpR(gt2,i3,i1)
coup3L = cplcFvFvVZL(i3,gt3)
coup3R = cplcFvFvVZR(i3,gt3)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_SVF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {VP, conj[Hp], Fe}
  Do i2=1,3
    Do i3=1,3
ML1 = MVP 
ML2 = MHp(i2) 
ML3 = MFe(i3) 
coup1 = -cplHpcHpVP(i2,gt1)
coup2L = cplcFeFeVPL(gt2,i3)
coup2R = cplcFeFeVPR(gt2,i3)
coup3L = cplcFeFvcHpL(i3,gt3,i2)
coup3R = cplcFeFvcHpR(i3,gt3,i2)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_VSF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VP, conj[VWp], Fe}
    Do i3=1,3
ML1 = MVP 
ML2 = MVWp 
ML3 = MFe(i3) 
coup1 = cplcHpVPVWp(gt1)
coup2L = cplcFeFeVPL(gt2,i3)
coup2R = cplcFeFeVPR(gt2,i3)
coup3L = cplcFeFvcVWpL(i3,gt3)
coup3R = cplcFeFvcVWpR(i3,gt3)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_VVF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do


! {VWp, VZ, Fv}
    Do i3=1,3
ML1 = MVWp 
ML2 = MVZ 
ML3 = 0. 
coup1 = cplcHpVWpVZ(gt1)
coup2L = cplcFeFvcVWpL(gt2,i3)
coup2R = cplcFeFvcVWpR(gt2,i3)
coup3L = cplcFvFvVZL(i3,gt3)
coup3R = cplcFvFvVZR(i3,gt3)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_VVF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do


! {VZ, conj[Hp], Fe}
  Do i2=1,3
    Do i3=1,3
ML1 = MVZ 
ML2 = MHp(i2) 
ML3 = MFe(i3) 
coup1 = -cplHpcHpVZ(i2,gt1)
coup2L = cplcFeFeVZL(gt2,i3)
coup2R = cplcFeFeVZR(gt2,i3)
coup3L = cplcFeFvcHpL(i3,gt3,i2)
coup3R = cplcFeFvcHpR(i3,gt3,i2)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_VSF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VZ, conj[VWp], Fe}
    Do i3=1,3
ML1 = MVZ 
ML2 = MVWp 
ML3 = MFe(i3) 
coup1 = cplcHpVWpVZ(gt1)
coup2L = cplcFeFeVZL(gt2,i3)
coup2R = cplcFeFeVZR(gt2,i3)
coup3L = cplcFeFvcVWpL(i3,gt3)
coup3R = cplcFeFvcVWpR(i3,gt3)
If ((Abs(coup1))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_VVF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do


! {bar[Fe], bar[Fv], VZ}
Do i1=1,3
  Do i2=1,3
ML1 = MFe(i1) 
ML2 = 0. 
ML3 = MVZ 
coup1L = cplcFeFvcHpL(i1,i2,gt1)
coup1R = cplcFeFvcHpR(i1,i2,gt1)
coup2L = cplcFeFeVZL(gt2,i1)
coup2R = cplcFeFeVZR(gt2,i1)
coup3L = cplcFvFvVZL(i2,gt3)
coup3R = cplcFvFvVZR(i2,gt3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoFF_Topology1_FFV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do
    End Do
  End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_HpTocFeFv


Subroutine Amplitude_IR_VERTEX_4HDM_S3_HpTocFeFv(MAh,MFe,MHhSM,MHp,MVP,               & 
& MVWp,MVZ,MAh2,MFe2,MHhSM2,MHp2,MVP2,MVWp2,MVZ2,cplcFeFeAhL,cplcFeFeAhR,cplAhHpcHp,     & 
& cplAhcHpVWp,cplcFeFeHhSML,cplcFeFeHhSMR,cplcFeFeVPL,cplcFeFeVPR,cplcFeFeVZL,           & 
& cplcFeFeVZR,cplcFvFvVZL,cplcFvFvVZR,cplcFeFvcHpL,cplcFeFvcHpR,cplcFeFvcVWpL,           & 
& cplcFeFvcVWpR,cplHhSMHpcHp,cplHhSMcHpVWp,cplHpcHpVP,cplHpcHpVZ,cplcHpVPVWp,            & 
& cplcHpVWpVZ,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFe(3),MHhSM(3),MHp(3),MVP,MVWp,MVZ,MAh2(3),MFe2(3),MHhSM2(3),MHp2(3),         & 
& MVP2,MVWp2,MVZ2

Complex(dp), Intent(in) :: cplcFeFeAhL(3,3,3),cplcFeFeAhR(3,3,3),cplAhHpcHp(3,3,3),cplAhcHpVWp(3,3),             & 
& cplcFeFeHhSML(3,3,3),cplcFeFeHhSMR(3,3,3),cplcFeFeVPL(3,3),cplcFeFeVPR(3,3),           & 
& cplcFeFeVZL(3,3),cplcFeFeVZR(3,3),cplcFvFvVZL(3,3),cplcFvFvVZR(3,3),cplcFeFvcHpL(3,3,3),& 
& cplcFeFvcHpR(3,3,3),cplcFeFvcVWpL(3,3),cplcFeFvcVWpR(3,3),cplHhSMHpcHp(3,3,3),         & 
& cplHhSMcHpVWp(3,3),cplHpcHpVP(3,3),cplHpcHpVZ(3,3),cplcHpVPVWp(3),cplcHpVWpVZ(3)

Complex(dp), Intent(out) :: Amp(2,3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
Amp(:,gt1, gt2, gt3) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MFe(gt2) 
Mex3 = 0. 


! {VP, conj[Hp], Fe}
  Do i2=1,3
    Do i3=1,3
ML1 = MVP 
ML2 = MHp(i2) 
ML3 = MFe(i3) 
coup1 = -cplHpcHpVP(i2,gt1)
coup2L = cplcFeFeVPL(gt2,i3)
coup2R = cplcFeFeVPR(gt2,i3)
coup3L = cplcFeFvcHpL(i3,gt3,i2)
coup3R = cplcFeFvcHpR(i3,gt3,i2)
Call Amp_VERTEX_StoFF_Topology1_VSF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VP, conj[VWp], Fe}
    Do i3=1,3
ML1 = MVP 
ML2 = MVWp 
ML3 = MFe(i3) 
coup1 = cplcHpVPVWp(gt1)
coup2L = cplcFeFeVPL(gt2,i3)
coup2R = cplcFeFeVPR(gt2,i3)
coup3L = cplcFeFvcVWpL(i3,gt3)
coup3R = cplcFeFvcVWpR(i3,gt3)
Call Amp_VERTEX_StoFF_Topology1_VVF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2L,coup2R,coup3L,coup3R,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2, gt3) = Amp(:,gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
    End Do
  End Do
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_HpTocFeFv


Subroutine Amplitude_Tree_4HDM_S3_HpTohhaHap(cplHaphhacHp,MHap,Mhha,MHp,              & 
& MHap2,Mhha2,MHp2,Amp)

Implicit None

Real(dp), Intent(in) :: MHap,Mhha,MHp(3),MHap2,Mhha2,MHp2(3)

Complex(dp), Intent(in) :: cplHaphhacHp(3)

Complex(dp) :: Amp(3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 

Do gt1=1,3
! External masses 
Mex1 = MHp(gt1) 
Mex2 = Mhha 
Mex3 = MHap 
! Tree-Level Vertex 
coupT1 = cplHaphhacHp(gt1)
Call TreeAmp_StoSS(Mex1,Mex2,Mex3,coupT1,AmpC) 
! Colour and symmetry factor 
Amp(gt1) = AmpC 
End Do
End Subroutine Amplitude_Tree_4HDM_S3_HpTohhaHap


Subroutine Gamma_Real_4HDM_S3_HpTohhaHap(MLambda,em,gs,cplHaphhacHp,MHap,             & 
& Mhha,MHp,GammarealPhoton,GammarealGluon)

Implicit None

Complex(dp), Intent(in) :: cplHaphhacHp(3)

Real(dp), Intent(in) :: MHap,Mhha,MHp(3)

Real(dp), Intent(in) :: MLambda, em, gs 

Real(dp), Intent(out) :: GammarealPhoton(3), GammarealGluon(3) 

Integer :: i1, i2, i3, gt1, gt2, gt3, kont 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 

Real(dp) :: Mloop1, Mloop2, Mloop3 
Complex(dp) :: Coup 
 
Do i1=2,3
Coup = cplHaphhacHp(i1)
Mex1 = MHp(i1)
Mex2 = Mhha
Mex3 = MHap
If (Mex1.gt.(Mex2+Mex3)) Then 
 Call hardradiationSSS(Mex1,Mex2,Mex3,MLambda,em,1._dp,0._dp,1._dp,0._dp,0._dp,1._dp,Coup,Gammarealphoton(i1),kont)
  GammarealGluon(i1) = 0._dp 
Else 
  GammarealGluon(i1) = 0._dp 
  GammarealPhoton(i1) = 0._dp 

End if 
End Do
End Subroutine Gamma_Real_4HDM_S3_HpTohhaHap


Subroutine Amplitude_WAVE_4HDM_S3_HpTohhaHap(cplHaphhacHp,ctcplHaphhacHp,             & 
& MHap,MHap2,Mhha,Mhha2,MHp,MHp2,ZfHap,Zfhha,ZfHp,Amp)

Implicit None

Real(dp), Intent(in) :: MHap,MHap2,Mhha,Mhha2,MHp(3),MHp2(3)

Complex(dp), Intent(in) :: cplHaphhacHp(3)

Complex(dp), Intent(in) :: ctcplHaphhacHp(3)

Complex(dp), Intent(in) :: ZfHap,Zfhha,ZfHp(3,3)

Complex(dp), Intent(out) :: Amp(3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
! External masses 
Mex1 = MHp(gt1) 
Mex2 = Mhha 
Mex3 = MHap 
!----------------------------- 
! Coupling counter term 
!----------------------------- 
ZcoupT1 = ctcplHaphhacHp(gt1) 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
Do i1=1,3
ZcoupT1 = ZcoupT1 + 0.5_dp*Conjg(ZfHp(i1,gt1))*cplHaphhacHp(i1)
End Do


! External Field 2 
ZcoupT1 = ZcoupT1 + 0.5_dp*Zfhha*cplHaphhacHp(gt1)


! External Field 3 
ZcoupT1 = ZcoupT1 + 0.5_dp*ZfHap*cplHaphhacHp(gt1)


! Getting the amplitude 
Call TreeAmp_StoSS(Mex1,Mex2,Mex3,ZcoupT1,AmpC) 
Amp(gt1) = AmpC 
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_HpTohhaHap


Subroutine Amplitude_VERTEX_4HDM_S3_HpTohhaHap(MAh,MHap,Mhha,MHhSM,MHp,               & 
& Msiga,MVP,MVWp,MVZ,MAh2,MHap2,Mhha2,MHhSM2,MHp2,Msiga2,MVP2,MVWp2,MVZ2,cplAhhhasiga,   & 
& cplAhHpcHp,cplAhcHpVWp,cplHaphhacHp,cplHaphhacVWp,cplHapHhSMcHap,cplHapsigacHp,        & 
& cplHapsigacVWp,cplHapcHapVP,cplHapcHapVZ,cplhhahhaHhSM,cplhhaHpcHap,cplhhasigaVZ,      & 
& cplhhacHapVWp,cplHhSMHpcHp,cplHhSMcHpVWp,cplHpcHpVP,cplHpcHpVZ,cplcHpVPVWp,            & 
& cplcHpVWpVZ,cplAhHaphhacHp1,cplAhHapsigacHp1,cplHapHapcHpcHp1,cplHaphhahhacHap1,       & 
& cplHaphhaHhSMcHp1,cplHaphhacVWpVP1,cplHaphhacVWpVZ1,cplHapHpcHapcHp1,cplhhahhaHpcHp1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MHap,Mhha,MHhSM(3),MHp(3),Msiga,MVP,MVWp,MVZ,MAh2(3),MHap2,Mhha2,              & 
& MHhSM2(3),MHp2(3),Msiga2,MVP2,MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhhhasiga(3),cplAhHpcHp(3,3,3),cplAhcHpVWp(3,3),cplHaphhacHp(3),cplHaphhacVWp,     & 
& cplHapHhSMcHap(3),cplHapsigacHp(3),cplHapsigacVWp,cplHapcHapVP,cplHapcHapVZ,           & 
& cplhhahhaHhSM(3),cplhhaHpcHap(3),cplhhasigaVZ,cplhhacHapVWp,cplHhSMHpcHp(3,3,3),       & 
& cplHhSMcHpVWp(3,3),cplHpcHpVP(3,3),cplHpcHpVZ(3,3),cplcHpVPVWp(3),cplcHpVWpVZ(3),      & 
& cplAhHaphhacHp1(3,3),cplAhHapsigacHp1(3,3),cplHapHapcHpcHp1(3,3),cplHaphhahhacHap1,    & 
& cplHaphhaHhSMcHp1(3,3),cplHaphhacVWpVP1,cplHaphhacVWpVZ1,cplHapHpcHapcHp1(3,3),        & 
& cplhhahhaHpcHp1(3,3)

Complex(dp), Intent(out) :: Amp(3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
Amp(gt1) = 0._dp 
! External masses 
Mex1 = MHp(gt1) 
Mex2 = Mhha 
Mex3 = MHap 


! {Ah, conj[Hp], siga}
Do i1=1,3
  Do i2=1,3
ML1 = MAh(i1) 
ML2 = MHp(i2) 
ML3 = Msiga 
coup1 = cplAhHpcHp(i1,i2,gt1)
coup2 = cplAhhhasiga(i1)
coup3 = cplHapsigacHp(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Ah, conj[VWp], siga}
Do i1=1,3
ML1 = MAh(i1) 
ML2 = MVWp 
ML3 = Msiga 
coup1 = cplAhcHpVWp(i1,gt1)
coup2 = cplAhhhasiga(i1)
coup3 = cplHapsigacVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
End Do


! {Hap, hha, Hp}
    Do i3=1,3
ML1 = MHap 
ML2 = Mhha 
ML3 = MHp(i3) 
coup1 = cplHaphhacHp(gt1)
coup2 = cplhhaHpcHap(i3)
coup3 = cplHaphhacHp(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
    End Do


! {Hap, siga, Hp}
    Do i3=1,3
ML1 = MHap 
ML2 = Msiga 
ML3 = MHp(i3) 
coup1 = cplHapsigacHp(gt1)
coup2 = cplhhaHpcHap(i3)
coup3 = cplHapsigacHp(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
    End Do


! {Hap, hha, VWp}
ML1 = MHap 
ML2 = Mhha 
ML3 = MVWp 
coup1 = cplHaphhacHp(gt1)
coup2 = -cplhhacHapVWp
coup3 = cplHaphhacVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 


! {Hap, siga, VWp}
ML1 = MHap 
ML2 = Msiga 
ML3 = MVWp 
coup1 = cplHapsigacHp(gt1)
coup2 = -cplhhacHapVWp
coup3 = cplHapsigacVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 


! {hha, conj[Hap], HhSM}
    Do i3=1,3
ML1 = Mhha 
ML2 = MHap 
ML3 = MHhSM(i3) 
coup1 = cplHaphhacHp(gt1)
coup2 = cplhhahhaHhSM(i3)
coup3 = cplHapHhSMcHap(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
    End Do


! {HhSM, conj[Hp], hha}
Do i1=1,3
  Do i2=1,3
ML1 = MHhSM(i1) 
ML2 = MHp(i2) 
ML3 = Mhha 
coup1 = cplHhSMHpcHp(i1,i2,gt1)
coup2 = cplhhahhaHhSM(i1)
coup3 = cplHaphhacHp(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {HhSM, conj[VWp], hha}
Do i1=1,3
ML1 = MHhSM(i1) 
ML2 = MVWp 
ML3 = Mhha 
coup1 = cplHhSMcHpVWp(i1,gt1)
coup2 = cplhhahhaHhSM(i1)
coup3 = cplHaphhacVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
End Do


! {Hp, HhSM, Hap}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHhSM(i2) 
ML3 = MHap 
coup1 = cplHhSMHpcHp(i2,i1,gt1)
coup2 = cplHaphhacHp(i1)
coup3 = cplHapHhSMcHap(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, VP, Hap}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVP 
ML3 = MHap 
coup1 = cplHpcHpVP(i1,gt1)
coup2 = cplHaphhacHp(i1)
coup3 = cplHapcHapVP
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
End Do


! {Hp, VZ, Hap}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVZ 
ML3 = MHap 
coup1 = cplHpcHpVZ(i1,gt1)
coup2 = cplHaphhacHp(i1)
coup3 = cplHapcHapVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
End Do


! {siga, conj[Hap], VZ}
ML1 = Msiga 
ML2 = MHap 
ML3 = MVZ 
coup1 = cplHapsigacHp(gt1)
coup2 = -cplhhasigaVZ
coup3 = cplHapcHapVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 


! {VWp, HhSM, Hap}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHhSM(i2) 
ML3 = MHap 
coup1 = cplHhSMcHpVWp(i2,gt1)
coup2 = cplHaphhacVWp
coup3 = cplHapHhSMcHap(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do


! {VWp, VP, Hap}
ML1 = MVWp 
ML2 = MVP 
ML3 = MHap 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplHaphhacVWp
coup3 = cplHapcHapVP
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 


! {VWp, VZ, Hap}
ML1 = MVWp 
ML2 = MVZ 
ML3 = MHap 
coup1 = cplcHpVWpVZ(gt1)
coup2 = cplHaphhacVWp
coup3 = cplHapcHapVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 


! {VZ, conj[Hp], siga}
  Do i2=1,3
ML1 = MVZ 
ML2 = MHp(i2) 
ML3 = Msiga 
coup1 = cplHpcHpVZ(i2,gt1)
coup2 = -cplhhasigaVZ
coup3 = cplHapsigacHp(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do


! {VZ, conj[VWp], siga}
ML1 = MVZ 
ML2 = MVWp 
ML3 = Msiga 
coup1 = cplcHpVWpVZ(gt1)
coup2 = -cplhhasigaVZ
coup3 = cplHapsigacVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 


! {Ah, conj[Hp]}
Do i1=1,3
  Do i2=1,3
ML1 = MAh(i1) 
ML2 = MHp(i2) 
coup1 = cplAhHpcHp(i1,i2,gt1)
coup2 = cplAhHaphhacHp1(i1,i2)
Call Amp_VERTEX_StoSS_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hap, hha}
ML1 = MHap 
ML2 = Mhha 
coup1 = cplHaphhacHp(gt1)
coup2 = cplHaphhahhacHap1
Call Amp_VERTEX_StoSS_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 


! {HhSM, conj[Hp]}
Do i1=1,3
  Do i2=1,3
ML1 = MHhSM(i1) 
ML2 = MHp(i2) 
coup1 = cplHhSMHpcHp(i1,i2,gt1)
coup2 = cplHaphhaHhSMcHp1(i1,i2)
Call Amp_VERTEX_StoSS_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {VP, conj[VWp]}
ML1 = MVP 
ML2 = MVWp 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplHaphhacVWpVP1
Call Amp_VERTEX_StoSS_Topology2_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 


! {VWp, VZ}
ML1 = MVWp 
ML2 = MVZ 
coup1 = cplcHpVWpVZ(gt1)
coup2 = cplHaphhacVWpVZ1
Call Amp_VERTEX_StoSS_Topology2_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 


! {Ah, siga}
Do i1=1,3
ML1 = MAh(i1) 
ML2 = Msiga 
coup1 = cplAhHapsigacHp1(i1,gt1)
coup2 = cplAhhhasiga(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 

End Do


! {Hap, Hp}
  Do i2=1,3
ML1 = MHap 
ML2 = MHp(i2) 
coup1 = cplHapHapcHpcHp1(gt1,i2)
coup2 = cplhhaHpcHap(i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 

  End Do


! {hha, HhSM}
  Do i2=1,3
ML1 = Mhha 
ML2 = MHhSM(i2) 
coup1 = cplHaphhaHhSMcHp1(i2,gt1)
coup2 = cplhhahhaHhSM(i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 

  End Do


! {Hp, Hap}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MHap 
coup1 = cplHapHpcHapcHp1(i1,gt1)
coup2 = cplHaphhacHp(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 

End Do


! {Hap, HhSM}
  Do i2=1,3
ML1 = MHap 
ML2 = MHhSM(i2) 
coup1 = cplHaphhaHhSMcHp1(i2,gt1)
coup2 = cplHapHhSMcHap(i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 

  End Do


! {hha, conj[Hp]}
  Do i2=1,3
ML1 = Mhha 
ML2 = MHp(i2) 
coup1 = cplhhahhaHpcHp1(i2,gt1)
coup2 = cplHaphhacHp(i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 

  End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_HpTohhaHap


Subroutine Amplitude_IR_VERTEX_4HDM_S3_HpTohhaHap(MAh,MHap,Mhha,MHhSM,MHp,            & 
& Msiga,MVP,MVWp,MVZ,MAh2,MHap2,Mhha2,MHhSM2,MHp2,Msiga2,MVP2,MVWp2,MVZ2,cplAhhhasiga,   & 
& cplAhHpcHp,cplAhcHpVWp,cplHaphhacHp,cplHaphhacVWp,cplHapHhSMcHap,cplHapsigacHp,        & 
& cplHapsigacVWp,cplHapcHapVP,cplHapcHapVZ,cplhhahhaHhSM,cplhhaHpcHap,cplhhasigaVZ,      & 
& cplhhacHapVWp,cplHhSMHpcHp,cplHhSMcHpVWp,cplHpcHpVP,cplHpcHpVZ,cplcHpVPVWp,            & 
& cplcHpVWpVZ,cplAhHaphhacHp1,cplAhHapsigacHp1,cplHapHapcHpcHp1,cplHaphhahhacHap1,       & 
& cplHaphhaHhSMcHp1,cplHaphhacVWpVP1,cplHaphhacVWpVZ1,cplHapHpcHapcHp1,cplhhahhaHpcHp1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MHap,Mhha,MHhSM(3),MHp(3),Msiga,MVP,MVWp,MVZ,MAh2(3),MHap2,Mhha2,              & 
& MHhSM2(3),MHp2(3),Msiga2,MVP2,MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhhhasiga(3),cplAhHpcHp(3,3,3),cplAhcHpVWp(3,3),cplHaphhacHp(3),cplHaphhacVWp,     & 
& cplHapHhSMcHap(3),cplHapsigacHp(3),cplHapsigacVWp,cplHapcHapVP,cplHapcHapVZ,           & 
& cplhhahhaHhSM(3),cplhhaHpcHap(3),cplhhasigaVZ,cplhhacHapVWp,cplHhSMHpcHp(3,3,3),       & 
& cplHhSMcHpVWp(3,3),cplHpcHpVP(3,3),cplHpcHpVZ(3,3),cplcHpVPVWp(3),cplcHpVWpVZ(3),      & 
& cplAhHaphhacHp1(3,3),cplAhHapsigacHp1(3,3),cplHapHapcHpcHp1(3,3),cplHaphhahhacHap1,    & 
& cplHaphhaHhSMcHp1(3,3),cplHaphhacVWpVP1,cplHaphhacVWpVZ1,cplHapHpcHapcHp1(3,3),        & 
& cplhhahhaHpcHp1(3,3)

Complex(dp), Intent(out) :: Amp(3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
Amp(gt1) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MHp(gt1) 
Mex2 = Mhha 
Mex3 = MHap 


! {Hp, VP, Hap}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVP 
ML3 = MHap 
coup1 = cplHpcHpVP(i1,gt1)
coup2 = cplHaphhacHp(i1)
coup3 = cplHapcHapVP
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
End Do


! {VWp, VP, Hap}
ML1 = MVWp 
ML2 = MVP 
ML3 = MHap 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplHaphhacVWp
coup3 = cplHapcHapVP
Call Amp_VERTEX_StoSS_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 


! {VP, conj[VWp]}
ML1 = MVP 
ML2 = MVWp 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplHaphhacVWpVP1
Call Amp_VERTEX_StoSS_Topology2_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_HpTohhaHap


Subroutine Amplitude_Tree_4HDM_S3_HpTosigaHap(cplHapsigacHp,MHap,MHp,Msiga,           & 
& MHap2,MHp2,Msiga2,Amp)

Implicit None

Real(dp), Intent(in) :: MHap,MHp(3),Msiga,MHap2,MHp2(3),Msiga2

Complex(dp), Intent(in) :: cplHapsigacHp(3)

Complex(dp) :: Amp(3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 

Do gt1=1,3
! External masses 
Mex1 = MHp(gt1) 
Mex2 = Msiga 
Mex3 = MHap 
! Tree-Level Vertex 
coupT1 = cplHapsigacHp(gt1)
Call TreeAmp_StoSS(Mex1,Mex2,Mex3,coupT1,AmpC) 
! Colour and symmetry factor 
Amp(gt1) = AmpC 
End Do
End Subroutine Amplitude_Tree_4HDM_S3_HpTosigaHap


Subroutine Gamma_Real_4HDM_S3_HpTosigaHap(MLambda,em,gs,cplHapsigacHp,MHap,           & 
& MHp,Msiga,GammarealPhoton,GammarealGluon)

Implicit None

Complex(dp), Intent(in) :: cplHapsigacHp(3)

Real(dp), Intent(in) :: MHap,MHp(3),Msiga

Real(dp), Intent(in) :: MLambda, em, gs 

Real(dp), Intent(out) :: GammarealPhoton(3), GammarealGluon(3) 

Integer :: i1, i2, i3, gt1, gt2, gt3, kont 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 

Real(dp) :: Mloop1, Mloop2, Mloop3 
Complex(dp) :: Coup 
 
Do i1=2,3
Coup = cplHapsigacHp(i1)
Mex1 = MHp(i1)
Mex2 = Msiga
Mex3 = MHap
If (Mex1.gt.(Mex2+Mex3)) Then 
 Call hardradiationSSS(Mex1,Mex2,Mex3,MLambda,em,1._dp,0._dp,1._dp,0._dp,0._dp,1._dp,Coup,Gammarealphoton(i1),kont)
  GammarealGluon(i1) = 0._dp 
Else 
  GammarealGluon(i1) = 0._dp 
  GammarealPhoton(i1) = 0._dp 

End if 
End Do
End Subroutine Gamma_Real_4HDM_S3_HpTosigaHap


Subroutine Amplitude_WAVE_4HDM_S3_HpTosigaHap(cplHapsigacHp,ctcplHapsigacHp,          & 
& MHap,MHap2,MHp,MHp2,Msiga,Msiga2,ZfHap,ZfHp,Zfsiga,Amp)

Implicit None

Real(dp), Intent(in) :: MHap,MHap2,MHp(3),MHp2(3),Msiga,Msiga2

Complex(dp), Intent(in) :: cplHapsigacHp(3)

Complex(dp), Intent(in) :: ctcplHapsigacHp(3)

Complex(dp), Intent(in) :: ZfHap,ZfHp(3,3),Zfsiga

Complex(dp), Intent(out) :: Amp(3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
! External masses 
Mex1 = MHp(gt1) 
Mex2 = Msiga 
Mex3 = MHap 
!----------------------------- 
! Coupling counter term 
!----------------------------- 
ZcoupT1 = ctcplHapsigacHp(gt1) 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
Do i1=1,3
ZcoupT1 = ZcoupT1 + 0.5_dp*Conjg(ZfHp(i1,gt1))*cplHapsigacHp(i1)
End Do


! External Field 2 
ZcoupT1 = ZcoupT1 + 0.5_dp*Zfsiga*cplHapsigacHp(gt1)


! External Field 3 
ZcoupT1 = ZcoupT1 + 0.5_dp*ZfHap*cplHapsigacHp(gt1)


! Getting the amplitude 
Call TreeAmp_StoSS(Mex1,Mex2,Mex3,ZcoupT1,AmpC) 
Amp(gt1) = AmpC 
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_HpTosigaHap


Subroutine Amplitude_VERTEX_4HDM_S3_HpTosigaHap(MAh,MHap,Mhha,MHhSM,MHp,              & 
& Msiga,MVP,MVWp,MVZ,MAh2,MHap2,Mhha2,MHhSM2,MHp2,Msiga2,MVP2,MVWp2,MVZ2,cplAhhhasiga,   & 
& cplAhHpcHp,cplAhcHpVWp,cplHaphhacHp,cplHaphhacVWp,cplHapHhSMcHap,cplHapsigacHp,        & 
& cplHapsigacVWp,cplHapcHapVP,cplHapcHapVZ,cplhhasigaVZ,cplHhSMHpcHp,cplHhSMsigasiga,    & 
& cplHhSMcHpVWp,cplHpsigacHap,cplHpcHpVP,cplHpcHpVZ,cplsigacHapVWp,cplcHpVPVWp,          & 
& cplcHpVWpVZ,cplAhHaphhacHp1,cplAhHapsigacHp1,cplHapHapcHpcHp1,cplHapHhSMsigacHp1,      & 
& cplHapHpcHapcHp1,cplHapsigasigacHap1,cplHapsigacVWpVP1,cplHapsigacVWpVZ1,              & 
& cplHpsigasigacHp1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MHap,Mhha,MHhSM(3),MHp(3),Msiga,MVP,MVWp,MVZ,MAh2(3),MHap2,Mhha2,              & 
& MHhSM2(3),MHp2(3),Msiga2,MVP2,MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhhhasiga(3),cplAhHpcHp(3,3,3),cplAhcHpVWp(3,3),cplHaphhacHp(3),cplHaphhacVWp,     & 
& cplHapHhSMcHap(3),cplHapsigacHp(3),cplHapsigacVWp,cplHapcHapVP,cplHapcHapVZ,           & 
& cplhhasigaVZ,cplHhSMHpcHp(3,3,3),cplHhSMsigasiga(3),cplHhSMcHpVWp(3,3),cplHpsigacHap(3),& 
& cplHpcHpVP(3,3),cplHpcHpVZ(3,3),cplsigacHapVWp,cplcHpVPVWp(3),cplcHpVWpVZ(3),          & 
& cplAhHaphhacHp1(3,3),cplAhHapsigacHp1(3,3),cplHapHapcHpcHp1(3,3),cplHapHhSMsigacHp1(3,3),& 
& cplHapHpcHapcHp1(3,3),cplHapsigasigacHap1,cplHapsigacVWpVP1,cplHapsigacVWpVZ1,         & 
& cplHpsigasigacHp1(3,3)

Complex(dp), Intent(out) :: Amp(3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
Amp(gt1) = 0._dp 
! External masses 
Mex1 = MHp(gt1) 
Mex2 = Msiga 
Mex3 = MHap 


! {Ah, conj[Hp], hha}
Do i1=1,3
  Do i2=1,3
ML1 = MAh(i1) 
ML2 = MHp(i2) 
ML3 = Mhha 
coup1 = cplAhHpcHp(i1,i2,gt1)
coup2 = cplAhhhasiga(i1)
coup3 = cplHaphhacHp(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Ah, conj[VWp], hha}
Do i1=1,3
ML1 = MAh(i1) 
ML2 = MVWp 
ML3 = Mhha 
coup1 = cplAhcHpVWp(i1,gt1)
coup2 = cplAhhhasiga(i1)
coup3 = cplHaphhacVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
End Do


! {Hap, hha, Hp}
    Do i3=1,3
ML1 = MHap 
ML2 = Mhha 
ML3 = MHp(i3) 
coup1 = cplHaphhacHp(gt1)
coup2 = cplHpsigacHap(i3)
coup3 = cplHaphhacHp(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
    End Do


! {Hap, siga, Hp}
    Do i3=1,3
ML1 = MHap 
ML2 = Msiga 
ML3 = MHp(i3) 
coup1 = cplHapsigacHp(gt1)
coup2 = cplHpsigacHap(i3)
coup3 = cplHapsigacHp(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
    End Do


! {Hap, hha, VWp}
ML1 = MHap 
ML2 = Mhha 
ML3 = MVWp 
coup1 = cplHaphhacHp(gt1)
coup2 = -cplsigacHapVWp
coup3 = cplHaphhacVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 


! {Hap, siga, VWp}
ML1 = MHap 
ML2 = Msiga 
ML3 = MVWp 
coup1 = cplHapsigacHp(gt1)
coup2 = -cplsigacHapVWp
coup3 = cplHapsigacVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 


! {hha, conj[Hap], VZ}
ML1 = Mhha 
ML2 = MHap 
ML3 = MVZ 
coup1 = cplHaphhacHp(gt1)
coup2 = cplhhasigaVZ
coup3 = cplHapcHapVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 


! {HhSM, conj[Hp], siga}
Do i1=1,3
  Do i2=1,3
ML1 = MHhSM(i1) 
ML2 = MHp(i2) 
ML3 = Msiga 
coup1 = cplHhSMHpcHp(i1,i2,gt1)
coup2 = cplHhSMsigasiga(i1)
coup3 = cplHapsigacHp(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {HhSM, conj[VWp], siga}
Do i1=1,3
ML1 = MHhSM(i1) 
ML2 = MVWp 
ML3 = Msiga 
coup1 = cplHhSMcHpVWp(i1,gt1)
coup2 = cplHhSMsigasiga(i1)
coup3 = cplHapsigacVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
End Do


! {Hp, HhSM, Hap}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHhSM(i2) 
ML3 = MHap 
coup1 = cplHhSMHpcHp(i2,i1,gt1)
coup2 = cplHapsigacHp(i1)
coup3 = cplHapHhSMcHap(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, VP, Hap}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVP 
ML3 = MHap 
coup1 = cplHpcHpVP(i1,gt1)
coup2 = cplHapsigacHp(i1)
coup3 = cplHapcHapVP
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
End Do


! {Hp, VZ, Hap}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVZ 
ML3 = MHap 
coup1 = cplHpcHpVZ(i1,gt1)
coup2 = cplHapsigacHp(i1)
coup3 = cplHapcHapVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
End Do


! {siga, conj[Hap], HhSM}
    Do i3=1,3
ML1 = Msiga 
ML2 = MHap 
ML3 = MHhSM(i3) 
coup1 = cplHapsigacHp(gt1)
coup2 = cplHhSMsigasiga(i3)
coup3 = cplHapHhSMcHap(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
    End Do


! {VWp, HhSM, Hap}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHhSM(i2) 
ML3 = MHap 
coup1 = cplHhSMcHpVWp(i2,gt1)
coup2 = cplHapsigacVWp
coup3 = cplHapHhSMcHap(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do


! {VWp, VP, Hap}
ML1 = MVWp 
ML2 = MVP 
ML3 = MHap 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplHapsigacVWp
coup3 = cplHapcHapVP
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 


! {VWp, VZ, Hap}
ML1 = MVWp 
ML2 = MVZ 
ML3 = MHap 
coup1 = cplcHpVWpVZ(gt1)
coup2 = cplHapsigacVWp
coup3 = cplHapcHapVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 


! {VZ, conj[Hp], hha}
  Do i2=1,3
ML1 = MVZ 
ML2 = MHp(i2) 
ML3 = Mhha 
coup1 = cplHpcHpVZ(i2,gt1)
coup2 = cplhhasigaVZ
coup3 = cplHaphhacHp(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do


! {VZ, conj[VWp], hha}
ML1 = MVZ 
ML2 = MVWp 
ML3 = Mhha 
coup1 = cplcHpVWpVZ(gt1)
coup2 = cplhhasigaVZ
coup3 = cplHaphhacVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 


! {Ah, conj[Hp]}
Do i1=1,3
  Do i2=1,3
ML1 = MAh(i1) 
ML2 = MHp(i2) 
coup1 = cplAhHpcHp(i1,i2,gt1)
coup2 = cplAhHapsigacHp1(i1,i2)
Call Amp_VERTEX_StoSS_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hap, siga}
ML1 = MHap 
ML2 = Msiga 
coup1 = cplHapsigacHp(gt1)
coup2 = cplHapsigasigacHap1
Call Amp_VERTEX_StoSS_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 


! {HhSM, conj[Hp]}
Do i1=1,3
  Do i2=1,3
ML1 = MHhSM(i1) 
ML2 = MHp(i2) 
coup1 = cplHhSMHpcHp(i1,i2,gt1)
coup2 = cplHapHhSMsigacHp1(i1,i2)
Call Amp_VERTEX_StoSS_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {VP, conj[VWp]}
ML1 = MVP 
ML2 = MVWp 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplHapsigacVWpVP1
Call Amp_VERTEX_StoSS_Topology2_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 


! {VWp, VZ}
ML1 = MVWp 
ML2 = MVZ 
coup1 = cplcHpVWpVZ(gt1)
coup2 = cplHapsigacVWpVZ1
Call Amp_VERTEX_StoSS_Topology2_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 


! {Ah, hha}
Do i1=1,3
ML1 = MAh(i1) 
ML2 = Mhha 
coup1 = cplAhHaphhacHp1(i1,gt1)
coup2 = cplAhhhasiga(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 

End Do


! {Hap, Hp}
  Do i2=1,3
ML1 = MHap 
ML2 = MHp(i2) 
coup1 = cplHapHapcHpcHp1(gt1,i2)
coup2 = cplHpsigacHap(i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 

  End Do


! {HhSM, siga}
Do i1=1,3
ML1 = MHhSM(i1) 
ML2 = Msiga 
coup1 = cplHapHhSMsigacHp1(i1,gt1)
coup2 = cplHhSMsigasiga(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 

End Do


! {Hp, Hap}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MHap 
coup1 = cplHapHpcHapcHp1(i1,gt1)
coup2 = cplHapsigacHp(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 

End Do


! {Hap, HhSM}
  Do i2=1,3
ML1 = MHap 
ML2 = MHhSM(i2) 
coup1 = cplHapHhSMsigacHp1(i2,gt1)
coup2 = cplHapHhSMcHap(i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 

  End Do


! {Hp, siga}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = Msiga 
coup1 = cplHpsigasigacHp1(i1,gt1)
coup2 = cplHapsigacHp(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 

End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_HpTosigaHap


Subroutine Amplitude_IR_VERTEX_4HDM_S3_HpTosigaHap(MAh,MHap,Mhha,MHhSM,               & 
& MHp,Msiga,MVP,MVWp,MVZ,MAh2,MHap2,Mhha2,MHhSM2,MHp2,Msiga2,MVP2,MVWp2,MVZ2,            & 
& cplAhhhasiga,cplAhHpcHp,cplAhcHpVWp,cplHaphhacHp,cplHaphhacVWp,cplHapHhSMcHap,         & 
& cplHapsigacHp,cplHapsigacVWp,cplHapcHapVP,cplHapcHapVZ,cplhhasigaVZ,cplHhSMHpcHp,      & 
& cplHhSMsigasiga,cplHhSMcHpVWp,cplHpsigacHap,cplHpcHpVP,cplHpcHpVZ,cplsigacHapVWp,      & 
& cplcHpVPVWp,cplcHpVWpVZ,cplAhHaphhacHp1,cplAhHapsigacHp1,cplHapHapcHpcHp1,             & 
& cplHapHhSMsigacHp1,cplHapHpcHapcHp1,cplHapsigasigacHap1,cplHapsigacVWpVP1,             & 
& cplHapsigacVWpVZ1,cplHpsigasigacHp1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MHap,Mhha,MHhSM(3),MHp(3),Msiga,MVP,MVWp,MVZ,MAh2(3),MHap2,Mhha2,              & 
& MHhSM2(3),MHp2(3),Msiga2,MVP2,MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhhhasiga(3),cplAhHpcHp(3,3,3),cplAhcHpVWp(3,3),cplHaphhacHp(3),cplHaphhacVWp,     & 
& cplHapHhSMcHap(3),cplHapsigacHp(3),cplHapsigacVWp,cplHapcHapVP,cplHapcHapVZ,           & 
& cplhhasigaVZ,cplHhSMHpcHp(3,3,3),cplHhSMsigasiga(3),cplHhSMcHpVWp(3,3),cplHpsigacHap(3),& 
& cplHpcHpVP(3,3),cplHpcHpVZ(3,3),cplsigacHapVWp,cplcHpVPVWp(3),cplcHpVWpVZ(3),          & 
& cplAhHaphhacHp1(3,3),cplAhHapsigacHp1(3,3),cplHapHapcHpcHp1(3,3),cplHapHhSMsigacHp1(3,3),& 
& cplHapHpcHapcHp1(3,3),cplHapsigasigacHap1,cplHapsigacVWpVP1,cplHapsigacVWpVZ1,         & 
& cplHpsigasigacHp1(3,3)

Complex(dp), Intent(out) :: Amp(3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
Amp(gt1) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MHp(gt1) 
Mex2 = Msiga 
Mex3 = MHap 


! {Hp, VP, Hap}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVP 
ML3 = MHap 
coup1 = cplHpcHpVP(i1,gt1)
coup2 = cplHapsigacHp(i1)
coup3 = cplHapcHapVP
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
End Do


! {VWp, VP, Hap}
ML1 = MVWp 
ML2 = MVP 
ML3 = MHap 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplHapsigacVWp
coup3 = cplHapcHapVP
Call Amp_VERTEX_StoSS_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 


! {VP, conj[VWp]}
ML1 = MVP 
ML2 = MVWp 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplHapsigacVWpVP1
Call Amp_VERTEX_StoSS_Topology2_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1) = Amp(gt1) + oo16pi2*(1)*AmpC 
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_HpTosigaHap


Subroutine Amplitude_Tree_4HDM_S3_HpToHpHhSM(cplHhSMHpcHp,MHhSM,MHp,MHhSM2,MHp2,Amp)

Implicit None

Real(dp), Intent(in) :: MHhSM(3),MHp(3),MHhSM2(3),MHp2(3)

Complex(dp), Intent(in) :: cplHhSMHpcHp(3,3,3)

Complex(dp) :: Amp(3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 

Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MHp(gt2) 
Mex3 = MHhSM(gt3) 
! Tree-Level Vertex 
coupT1 = cplHhSMHpcHp(gt3,gt2,gt1)
Call TreeAmp_StoSS(Mex1,Mex2,Mex3,coupT1,AmpC) 
! Colour and symmetry factor 
Amp(gt1, gt2, gt3) = AmpC 
    End Do
  End Do
End Do
End Subroutine Amplitude_Tree_4HDM_S3_HpToHpHhSM


Subroutine Gamma_Real_4HDM_S3_HpToHpHhSM(MLambda,em,gs,cplHhSMHpcHp,MHhSM,            & 
& MHp,GammarealPhoton,GammarealGluon)

Implicit None

Complex(dp), Intent(in) :: cplHhSMHpcHp(3,3,3)

Real(dp), Intent(in) :: MHhSM(3),MHp(3)

Real(dp), Intent(in) :: MLambda, em, gs 

Real(dp), Intent(out) :: GammarealPhoton(3,3,3), GammarealGluon(3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3, kont 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 

Real(dp) :: Mloop1, Mloop2, Mloop3 
Complex(dp) :: Coup 
 
Do i1=2,3
  Do i2=2,3
    Do i3=1,3
Coup = cplHhSMHpcHp(i3,i2,i1)
Mex1 = MHp(i1)
Mex2 = MHp(i2)
Mex3 = MHhSM(i3)
If (Mex1.gt.(Mex2+Mex3)) Then 
 Call hardradiationSSS(Mex1,Mex2,Mex3,MLambda,em,1._dp,1._dp,0._dp,1._dp,0._dp,0._dp,Coup,Gammarealphoton(i1,i2,i3),kont)
  GammarealGluon(i1,i2,i3) = 0._dp 
Else 
  GammarealGluon(i1,i2,i3) = 0._dp 
  GammarealPhoton(i1,i2,i3) = 0._dp 

End if 
    End Do
  End Do
End Do
End Subroutine Gamma_Real_4HDM_S3_HpToHpHhSM


Subroutine Amplitude_WAVE_4HDM_S3_HpToHpHhSM(cplHhSMHpcHp,ctcplHhSMHpcHp,             & 
& MHhSM,MHhSM2,MHp,MHp2,ZfHhSM,ZfHp,Amp)

Implicit None

Real(dp), Intent(in) :: MHhSM(3),MHhSM2(3),MHp(3),MHp2(3)

Complex(dp), Intent(in) :: cplHhSMHpcHp(3,3,3)

Complex(dp), Intent(in) :: ctcplHhSMHpcHp(3,3,3)

Complex(dp), Intent(in) :: ZfHhSM(3,3),ZfHp(3,3)

Complex(dp), Intent(out) :: Amp(3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MHp(gt2) 
Mex3 = MHhSM(gt3) 
!----------------------------- 
! Coupling counter term 
!----------------------------- 
ZcoupT1 = ctcplHhSMHpcHp(gt3,gt2,gt1) 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
Do i1=1,3
ZcoupT1 = ZcoupT1 + 0.5_dp*Conjg(ZfHp(i1,gt1))*cplHhSMHpcHp(gt3,gt2,i1)
End Do


! External Field 2 
Do i1=1,3
ZcoupT1 = ZcoupT1 + 0.5_dp*ZfHp(i1,gt2)*cplHhSMHpcHp(gt3,i1,gt1)
End Do


! External Field 3 
Do i1=1,3
ZcoupT1 = ZcoupT1 + 0.5_dp*ZfHhSM(i1,gt3)*cplHhSMHpcHp(i1,gt2,gt1)
End Do


! Getting the amplitude 
Call TreeAmp_StoSS(Mex1,Mex2,Mex3,ZcoupT1,AmpC) 
Amp(gt1, gt2, gt3) = AmpC 
    End Do
  End Do
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_HpToHpHhSM


Subroutine Amplitude_VERTEX_4HDM_S3_HpToHpHhSM(MAh,MFd,MFe,MFu,MHap,Mhha,             & 
& MHhSM,MHp,Msiga,MVP,MVWp,MVZ,MAh2,MFd2,MFe2,MFu2,MHap2,Mhha2,MHhSM2,MHp2,              & 
& Msiga2,MVP2,MVWp2,MVZ2,cplAhAhHhSM,cplAhHhSMVZ,cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,     & 
& cplcFdFdHhSML,cplcFdFdHhSMR,cplcFuFdHpL,cplcFuFdHpR,cplcFeFeHhSML,cplcFeFeHhSMR,       & 
& cplcFvFeHpL,cplcFvFeHpR,cplcFuFuHhSML,cplcFuFuHhSMR,cplcFdFucHpL,cplcFdFucHpR,         & 
& cplcFeFvcHpL,cplcFeFvcHpR,cplcgWpgWpHhSM,cplcgZgWpcHp,cplcgWCgWCHhSM,cplcgZgWCHp,      & 
& cplcgZgZHhSM,cplcgWpgZHp,cplcgWCgZcHp,cplHaphhacHp,cplHapHhSMcHap,cplHapsigacHp,       & 
& cplhhahhaHhSM,cplhhaHpcHap,cplHhSMHhSMHhSM,cplHhSMHpcHp,cplHhSMHpcVWp,cplHhSMsigasiga, & 
& cplHhSMcHpVWp,cplHhSMcVWpVWp,cplHhSMVZVZ,cplHpsigacHap,cplHpcHpVP,cplHpcVWpVP,         & 
& cplHpcHpVZ,cplHpcVWpVZ,cplcHpVPVWp,cplcHpVWpVZ,cplAhAhHpcHp1,cplAhHhSMHpcHp1,          & 
& cplHaphhaHhSMcHp1,cplHapHhSMsigacHp1,cplHapHpcHapcHp1,cplhhahhaHpcHp1,cplhhaHhSMHpcHap1,& 
& cplHhSMHhSMHpcHp1,cplHhSMHpsigacHap1,cplHhSMHpcVWpVP1,cplHhSMHpcVWpVZ1,cplHhSMcHpVPVWp1,& 
& cplHhSMcHpVWpVZ1,cplHpHpcHpcHp1,cplHpsigasigacHp1,cplHpcHpcVWpVWp1,cplHpcHpVZVZ1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHap,Mhha,MHhSM(3),MHp(3),Msiga,MVP,MVWp,MVZ,             & 
& MAh2(3),MFd2(3),MFe2(3),MFu2(3),MHap2,Mhha2,MHhSM2(3),MHp2(3),Msiga2,MVP2,             & 
& MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhAhHhSM(3,3,3),cplAhHhSMVZ(3,3),cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),               & 
& cplAhcHpVWp(3,3),cplcFdFdHhSML(3,3,3),cplcFdFdHhSMR(3,3,3),cplcFuFdHpL(3,3,3),         & 
& cplcFuFdHpR(3,3,3),cplcFeFeHhSML(3,3,3),cplcFeFeHhSMR(3,3,3),cplcFvFeHpL(3,3,3),       & 
& cplcFvFeHpR(3,3,3),cplcFuFuHhSML(3,3,3),cplcFuFuHhSMR(3,3,3),cplcFdFucHpL(3,3,3),      & 
& cplcFdFucHpR(3,3,3),cplcFeFvcHpL(3,3,3),cplcFeFvcHpR(3,3,3),cplcgWpgWpHhSM(3),         & 
& cplcgZgWpcHp(3),cplcgWCgWCHhSM(3),cplcgZgWCHp(3),cplcgZgZHhSM(3),cplcgWpgZHp(3),       & 
& cplcgWCgZcHp(3),cplHaphhacHp(3),cplHapHhSMcHap(3),cplHapsigacHp(3),cplhhahhaHhSM(3),   & 
& cplhhaHpcHap(3),cplHhSMHhSMHhSM(3,3,3),cplHhSMHpcHp(3,3,3),cplHhSMHpcVWp(3,3),         & 
& cplHhSMsigasiga(3),cplHhSMcHpVWp(3,3),cplHhSMcVWpVWp(3),cplHhSMVZVZ(3),cplHpsigacHap(3),& 
& cplHpcHpVP(3,3),cplHpcVWpVP(3),cplHpcHpVZ(3,3),cplHpcVWpVZ(3),cplcHpVPVWp(3),          & 
& cplcHpVWpVZ(3),cplAhAhHpcHp1(3,3,3,3),cplAhHhSMHpcHp1(3,3,3,3),cplHaphhaHhSMcHp1(3,3), & 
& cplHapHhSMsigacHp1(3,3),cplHapHpcHapcHp1(3,3),cplhhahhaHpcHp1(3,3),cplhhaHhSMHpcHap1(3,3),& 
& cplHhSMHhSMHpcHp1(3,3,3,3),cplHhSMHpsigacHap1(3,3),cplHhSMHpcVWpVP1(3,3),              & 
& cplHhSMHpcVWpVZ1(3,3),cplHhSMcHpVPVWp1(3,3),cplHhSMcHpVWpVZ1(3,3),cplHpHpcHpcHp1(3,3,3,3),& 
& cplHpsigasigacHp1(3,3),cplHpcHpcVWpVWp1(3,3),cplHpcHpVZVZ1(3,3)

Complex(dp), Intent(out) :: Amp(3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
Amp(gt1, gt2, gt3) = 0._dp 
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MHp(gt2) 
Mex3 = MHhSM(gt3) 


! {Ah, conj[Hp], conj[Hp]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MAh(i1) 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplAhHpcHp(i1,i2,gt1)
coup2 = cplAhHpcHp(i1,gt2,i3)
coup3 = cplHhSMHpcHp(gt3,i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Ah, conj[VWp], conj[Hp]}
Do i1=1,3
    Do i3=1,3
ML1 = MAh(i1) 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = cplAhcHpVWp(i1,gt1)
coup2 = cplAhHpcHp(i1,gt2,i3)
coup3 = cplHhSMHpcVWp(gt3,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Ah, conj[Hp], conj[VWp]}
Do i1=1,3
  Do i2=1,3
ML1 = MAh(i1) 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplAhHpcHp(i1,i2,gt1)
coup2 = cplAhHpcVWp(i1,gt2)
coup3 = cplHhSMcHpVWp(gt3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Ah, conj[VWp], conj[VWp]}
Do i1=1,3
ML1 = MAh(i1) 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplAhcHpVWp(i1,gt1)
coup2 = cplAhHpcVWp(i1,gt2)
coup3 = cplHhSMcVWpVWp(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
End Do


! {Fu, Fd, Fd}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFu(i1) 
ML2 = MFd(i2) 
ML3 = MFd(i3) 
coup1L = cplcFdFucHpL(i2,i1,gt1)
coup1R = cplcFdFucHpR(i2,i1,gt1)
coup2L = cplcFuFdHpL(i1,i3,gt2)
coup2R = cplcFuFdHpR(i1,i3,gt2)
coup3L = cplcFdFdHhSML(i3,i2,gt3)
coup3R = cplcFdFdHhSMR(i3,i2,gt3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(3)*AmpC 
    End Do
  End Do
End Do


! {Fv, Fe, Fe}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = 0. 
ML2 = MFe(i2) 
ML3 = MFe(i3) 
coup1L = cplcFeFvcHpL(i2,i1,gt1)
coup1R = cplcFeFvcHpR(i2,i1,gt1)
coup2L = cplcFvFeHpL(i1,i3,gt2)
coup2R = cplcFvFeHpR(i1,i3,gt2)
coup3L = cplcFeFeHhSML(i3,i2,gt3)
coup3R = cplcFeFeHhSMR(i3,i2,gt3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {gWp, gZ, gZ}
ML1 = MVWp 
ML2 = MVZ 
ML3 = MVZ 
coup1 = cplcgZgWpcHp(gt1)
coup2 = cplcgWpgZHp(gt2)
coup3 = cplcgZgZHhSM(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {gZ, gWpC, gWpC}
ML1 = MVZ 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcgWCgZcHp(gt1)
coup2 = cplcgZgWCHp(gt2)
coup3 = cplcgWCgWCHhSM(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {Hap, hha, hha}
ML1 = MHap 
ML2 = Mhha 
ML3 = Mhha 
coup1 = cplHaphhacHp(gt1)
coup2 = cplhhaHpcHap(gt2)
coup3 = cplhhahhaHhSM(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {Hap, siga, siga}
ML1 = MHap 
ML2 = Msiga 
ML3 = Msiga 
coup1 = cplHapsigacHp(gt1)
coup2 = cplHpsigacHap(gt2)
coup3 = cplHhSMsigasiga(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {hha, conj[Hap], conj[Hap]}
ML1 = Mhha 
ML2 = MHap 
ML3 = MHap 
coup1 = cplHaphhacHp(gt1)
coup2 = cplhhaHpcHap(gt2)
coup3 = cplHapHhSMcHap(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {HhSM, conj[Hp], conj[Hp]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHhSM(i1) 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplHhSMHpcHp(i1,i2,gt1)
coup2 = cplHhSMHpcHp(i1,gt2,i3)
coup3 = cplHhSMHpcHp(gt3,i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {HhSM, conj[VWp], conj[Hp]}
Do i1=1,3
    Do i3=1,3
ML1 = MHhSM(i1) 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = cplHhSMcHpVWp(i1,gt1)
coup2 = cplHhSMHpcHp(i1,gt2,i3)
coup3 = cplHhSMHpcVWp(gt3,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {HhSM, conj[Hp], conj[VWp]}
Do i1=1,3
  Do i2=1,3
ML1 = MHhSM(i1) 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplHhSMHpcHp(i1,i2,gt1)
coup2 = cplHhSMHpcVWp(i1,gt2)
coup3 = cplHhSMcHpVWp(gt3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {HhSM, conj[VWp], conj[VWp]}
Do i1=1,3
ML1 = MHhSM(i1) 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplHhSMcHpVWp(i1,gt1)
coup2 = cplHhSMHpcVWp(i1,gt2)
coup3 = cplHhSMcVWpVWp(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
End Do


! {Hp, Ah, Ah}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MAh(i2) 
ML3 = MAh(i3) 
coup1 = cplAhHpcHp(i2,i1,gt1)
coup2 = cplAhHpcHp(i3,gt2,i1)
coup3 = cplAhAhHhSM(i3,i2,gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Hp, VZ, Ah}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVZ 
ML3 = MAh(i3) 
coup1 = cplHpcHpVZ(i1,gt1)
coup2 = cplAhHpcHp(i3,gt2,i1)
coup3 = -cplAhHhSMVZ(i3,gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, HhSM, HhSM}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MHhSM(i2) 
ML3 = MHhSM(i3) 
coup1 = cplHhSMHpcHp(i2,i1,gt1)
coup2 = cplHhSMHpcHp(i3,gt2,i1)
coup3 = cplHhSMHhSMHhSM(gt3,i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Hp, Ah, VZ}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MAh(i2) 
ML3 = MVZ 
coup1 = cplAhHpcHp(i2,i1,gt1)
coup2 = -cplHpcHpVZ(gt2,i1)
coup3 = -cplAhHhSMVZ(i2,gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, VZ, VZ}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVZ 
ML3 = MVZ 
coup1 = cplHpcHpVZ(i1,gt1)
coup2 = -cplHpcHpVZ(gt2,i1)
coup3 = cplHhSMVZVZ(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
End Do


! {siga, conj[Hap], conj[Hap]}
ML1 = Msiga 
ML2 = MHap 
ML3 = MHap 
coup1 = cplHapsigacHp(gt1)
coup2 = cplHpsigacHap(gt2)
coup3 = cplHapHhSMcHap(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {VP, conj[Hp], conj[Hp]}
  Do i2=1,3
    Do i3=1,3
ML1 = MVP 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplHpcHpVP(i2,gt1)
coup2 = -cplHpcHpVP(gt2,i3)
coup3 = cplHhSMHpcHp(gt3,i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VP, conj[VWp], conj[Hp]}
    Do i3=1,3
ML1 = MVP 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = cplcHpVPVWp(gt1)
coup2 = -cplHpcHpVP(gt2,i3)
coup3 = cplHhSMHpcVWp(gt3,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do


! {VP, conj[Hp], conj[VWp]}
  Do i2=1,3
ML1 = MVP 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplHpcHpVP(i2,gt1)
coup2 = cplHpcVWpVP(gt2)
coup3 = cplHhSMcHpVWp(gt3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do


! {VP, conj[VWp], conj[VWp]}
ML1 = MVP 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplHpcVWpVP(gt2)
coup3 = cplHhSMcVWpVWp(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {VWp, Ah, Ah}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MAh(i2) 
ML3 = MAh(i3) 
coup1 = cplAhcHpVWp(i2,gt1)
coup2 = cplAhHpcVWp(i3,gt2)
coup3 = cplAhAhHhSM(i3,i2,gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VWp, VZ, Ah}
    Do i3=1,3
ML1 = MVWp 
ML2 = MVZ 
ML3 = MAh(i3) 
coup1 = cplcHpVWpVZ(gt1)
coup2 = cplAhHpcVWp(i3,gt2)
coup3 = -cplAhHhSMVZ(i3,gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do


! {VWp, HhSM, HhSM}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHhSM(i2) 
ML3 = MHhSM(i3) 
coup1 = cplHhSMcHpVWp(i2,gt1)
coup2 = cplHhSMHpcVWp(i3,gt2)
coup3 = cplHhSMHhSMHhSM(gt3,i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VWp, Ah, VZ}
  Do i2=1,3
ML1 = MVWp 
ML2 = MAh(i2) 
ML3 = MVZ 
coup1 = cplAhcHpVWp(i2,gt1)
coup2 = cplHpcVWpVZ(gt2)
coup3 = -cplAhHhSMVZ(i2,gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do


! {VWp, VZ, VZ}
ML1 = MVWp 
ML2 = MVZ 
ML3 = MVZ 
coup1 = cplcHpVWpVZ(gt1)
coup2 = cplHpcVWpVZ(gt2)
coup3 = cplHhSMVZVZ(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {VZ, conj[Hp], conj[Hp]}
  Do i2=1,3
    Do i3=1,3
ML1 = MVZ 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplHpcHpVZ(i2,gt1)
coup2 = -cplHpcHpVZ(gt2,i3)
coup3 = cplHhSMHpcHp(gt3,i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VZ, conj[VWp], conj[Hp]}
    Do i3=1,3
ML1 = MVZ 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = cplcHpVWpVZ(gt1)
coup2 = -cplHpcHpVZ(gt2,i3)
coup3 = cplHhSMHpcVWp(gt3,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do


! {VZ, conj[Hp], conj[VWp]}
  Do i2=1,3
ML1 = MVZ 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplHpcHpVZ(i2,gt1)
coup2 = cplHpcVWpVZ(gt2)
coup3 = cplHhSMcHpVWp(gt3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do


! {VZ, conj[VWp], conj[VWp]}
ML1 = MVZ 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcHpVWpVZ(gt1)
coup2 = cplHpcVWpVZ(gt2)
coup3 = cplHhSMcVWpVWp(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_VVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {bar[Fd], bar[Fu], bar[Fu]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFd(i1) 
ML2 = MFu(i2) 
ML3 = MFu(i3) 
coup1L = cplcFdFucHpL(i1,i2,gt1)
coup1R = cplcFdFucHpR(i1,i2,gt1)
coup2L = cplcFuFdHpL(i3,i1,gt2)
coup2R = cplcFuFdHpR(i3,i1,gt2)
coup3L = cplcFuFuHhSML(i2,i3,gt3)
coup3R = cplcFuFuHhSMR(i2,i3,gt3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(3)*AmpC 
    End Do
  End Do
End Do


! {bar[gWpC], bar[gZ], bar[gZ]}
ML1 = MVWp 
ML2 = MVZ 
ML3 = MVZ 
coup1 = cplcgWCgZcHp(gt1)
coup2 = cplcgZgWCHp(gt2)
coup3 = cplcgZgZHhSM(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {bar[gZ], bar[gWp], bar[gWp]}
ML1 = MVZ 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcgZgWpcHp(gt1)
coup2 = cplcgWpgZHp(gt2)
coup3 = cplcgWpgWpHhSM(gt3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {Ah, conj[Hp]}
Do i1=1,3
  Do i2=1,3
ML1 = MAh(i1) 
ML2 = MHp(i2) 
coup1 = cplAhHpcHp(i1,i2,gt1)
coup2 = cplAhHhSMHpcHp1(i1,gt3,gt2,i2)
Call Amp_VERTEX_StoSS_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hap, hha}
ML1 = MHap 
ML2 = Mhha 
coup1 = cplHaphhacHp(gt1)
coup2 = cplhhaHhSMHpcHap1(gt3,gt2)
Call Amp_VERTEX_StoSS_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {Hap, siga}
ML1 = MHap 
ML2 = Msiga 
coup1 = cplHapsigacHp(gt1)
coup2 = cplHhSMHpsigacHap1(gt3,gt2)
Call Amp_VERTEX_StoSS_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {HhSM, conj[Hp]}
Do i1=1,3
  Do i2=1,3
ML1 = MHhSM(i1) 
ML2 = MHp(i2) 
coup1 = cplHhSMHpcHp(i1,i2,gt1)
coup2 = cplHhSMHhSMHpcHp1(gt3,i1,gt2,i2)
Call Amp_VERTEX_StoSS_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {VP, conj[VWp]}
ML1 = MVP 
ML2 = MVWp 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplHhSMHpcVWpVP1(gt3,gt2)
Call Amp_VERTEX_StoSS_Topology2_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {VWp, VZ}
ML1 = MVWp 
ML2 = MVZ 
coup1 = cplcHpVWpVZ(gt1)
coup2 = cplHhSMHpcVWpVZ1(gt3,gt2)
Call Amp_VERTEX_StoSS_Topology2_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {Ah, conj[Hp]}
Do i1=1,3
  Do i2=1,3
ML1 = MAh(i1) 
ML2 = MHp(i2) 
coup1 = cplAhHhSMHpcHp1(i1,gt3,i2,gt1)
coup2 = cplAhHpcHp(i1,gt2,i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 

  End Do
End Do


! {Hap, hha}
ML1 = MHap 
ML2 = Mhha 
coup1 = cplHaphhaHhSMcHp1(gt3,gt1)
coup2 = cplhhaHpcHap(gt2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 



! {Hap, siga}
ML1 = MHap 
ML2 = Msiga 
coup1 = cplHapHhSMsigacHp1(gt3,gt1)
coup2 = cplHpsigacHap(gt2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 



! {HhSM, conj[Hp]}
Do i1=1,3
  Do i2=1,3
ML1 = MHhSM(i1) 
ML2 = MHp(i2) 
coup1 = cplHhSMHhSMHpcHp1(gt3,i1,i2,gt1)
coup2 = cplHhSMHpcHp(i1,gt2,i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 

  End Do
End Do


! {VP, conj[VWp]}
ML1 = MVP 
ML2 = MVWp 
coup1 = cplHhSMcHpVPVWp1(gt3,gt1)
coup2 = cplHpcVWpVP(gt2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 



! {VWp, VZ}
ML1 = MVWp 
ML2 = MVZ 
coup1 = cplHhSMcHpVWpVZ1(gt3,gt1)
coup2 = cplHpcVWpVZ(gt2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology3_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 



! {Ah, Ah}
Do i1=1,3
  Do i2=1,3
ML1 = MAh(i1) 
ML2 = MAh(i2) 
coup1 = cplAhAhHpcHp1(i1,i2,gt2,gt1)
coup2 = cplAhAhHhSM(i1,i2,gt3)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1._dp/2._dp)*AmpC 

  End Do
End Do


! {Hap, Hap}
ML1 = MHap 
ML2 = MHap 
coup1 = cplHapHpcHapcHp1(gt2,gt1)
coup2 = cplHapHhSMcHap(gt3)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 



! {hha, hha}
ML1 = Mhha 
ML2 = Mhha 
coup1 = cplhhahhaHpcHp1(gt2,gt1)
coup2 = cplhhahhaHhSM(gt3)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1._dp/2._dp)*AmpC 



! {HhSM, HhSM}
Do i1=1,3
  Do i2=1,3
ML1 = MHhSM(i1) 
ML2 = MHhSM(i2) 
coup1 = cplHhSMHhSMHpcHp1(i1,i2,gt2,gt1)
coup2 = cplHhSMHhSMHhSM(gt3,i1,i2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1._dp/2._dp)*AmpC 

  End Do
End Do


! {Hp, Hp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHp(i2) 
coup1 = cplHpHpcHpcHp1(gt2,i1,gt1,i2)
coup2 = cplHhSMHpcHp(gt3,i2,i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 

  End Do
End Do


! {siga, siga}
ML1 = Msiga 
ML2 = Msiga 
coup1 = cplHpsigasigacHp1(gt2,gt1)
coup2 = cplHhSMsigasiga(gt3)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1._dp/2._dp)*AmpC 



! {VWp, VWp}
ML1 = MVWp 
ML2 = MVWp 
coup1 = cplHpcHpcVWpVWp1(gt2,gt1)
coup2 = cplHhSMcVWpVWp(gt3)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 



! {VZ, VZ}
ML1 = MVZ 
ML2 = MVZ 
coup1 = cplHpcHpVZVZ1(gt2,gt1)
coup2 = cplHhSMVZVZ(gt3)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSS_Topology4_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1._dp/2._dp)*AmpC 

    End Do
  End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_HpToHpHhSM


Subroutine Amplitude_IR_VERTEX_4HDM_S3_HpToHpHhSM(MAh,MFd,MFe,MFu,MHap,               & 
& Mhha,MHhSM,MHp,Msiga,MVP,MVWp,MVZ,MAh2,MFd2,MFe2,MFu2,MHap2,Mhha2,MHhSM2,              & 
& MHp2,Msiga2,MVP2,MVWp2,MVZ2,cplAhAhHhSM,cplAhHhSMVZ,cplAhHpcHp,cplAhHpcVWp,            & 
& cplAhcHpVWp,cplcFdFdHhSML,cplcFdFdHhSMR,cplcFuFdHpL,cplcFuFdHpR,cplcFeFeHhSML,         & 
& cplcFeFeHhSMR,cplcFvFeHpL,cplcFvFeHpR,cplcFuFuHhSML,cplcFuFuHhSMR,cplcFdFucHpL,        & 
& cplcFdFucHpR,cplcFeFvcHpL,cplcFeFvcHpR,cplcgWpgWpHhSM,cplcgZgWpcHp,cplcgWCgWCHhSM,     & 
& cplcgZgWCHp,cplcgZgZHhSM,cplcgWpgZHp,cplcgWCgZcHp,cplHaphhacHp,cplHapHhSMcHap,         & 
& cplHapsigacHp,cplhhahhaHhSM,cplhhaHpcHap,cplHhSMHhSMHhSM,cplHhSMHpcHp,cplHhSMHpcVWp,   & 
& cplHhSMsigasiga,cplHhSMcHpVWp,cplHhSMcVWpVWp,cplHhSMVZVZ,cplHpsigacHap,cplHpcHpVP,     & 
& cplHpcVWpVP,cplHpcHpVZ,cplHpcVWpVZ,cplcHpVPVWp,cplcHpVWpVZ,cplAhAhHpcHp1,              & 
& cplAhHhSMHpcHp1,cplHaphhaHhSMcHp1,cplHapHhSMsigacHp1,cplHapHpcHapcHp1,cplhhahhaHpcHp1, & 
& cplhhaHhSMHpcHap1,cplHhSMHhSMHpcHp1,cplHhSMHpsigacHap1,cplHhSMHpcVWpVP1,               & 
& cplHhSMHpcVWpVZ1,cplHhSMcHpVPVWp1,cplHhSMcHpVWpVZ1,cplHpHpcHpcHp1,cplHpsigasigacHp1,   & 
& cplHpcHpcVWpVWp1,cplHpcHpVZVZ1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHap,Mhha,MHhSM(3),MHp(3),Msiga,MVP,MVWp,MVZ,             & 
& MAh2(3),MFd2(3),MFe2(3),MFu2(3),MHap2,Mhha2,MHhSM2(3),MHp2(3),Msiga2,MVP2,             & 
& MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhAhHhSM(3,3,3),cplAhHhSMVZ(3,3),cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),               & 
& cplAhcHpVWp(3,3),cplcFdFdHhSML(3,3,3),cplcFdFdHhSMR(3,3,3),cplcFuFdHpL(3,3,3),         & 
& cplcFuFdHpR(3,3,3),cplcFeFeHhSML(3,3,3),cplcFeFeHhSMR(3,3,3),cplcFvFeHpL(3,3,3),       & 
& cplcFvFeHpR(3,3,3),cplcFuFuHhSML(3,3,3),cplcFuFuHhSMR(3,3,3),cplcFdFucHpL(3,3,3),      & 
& cplcFdFucHpR(3,3,3),cplcFeFvcHpL(3,3,3),cplcFeFvcHpR(3,3,3),cplcgWpgWpHhSM(3),         & 
& cplcgZgWpcHp(3),cplcgWCgWCHhSM(3),cplcgZgWCHp(3),cplcgZgZHhSM(3),cplcgWpgZHp(3),       & 
& cplcgWCgZcHp(3),cplHaphhacHp(3),cplHapHhSMcHap(3),cplHapsigacHp(3),cplhhahhaHhSM(3),   & 
& cplhhaHpcHap(3),cplHhSMHhSMHhSM(3,3,3),cplHhSMHpcHp(3,3,3),cplHhSMHpcVWp(3,3),         & 
& cplHhSMsigasiga(3),cplHhSMcHpVWp(3,3),cplHhSMcVWpVWp(3),cplHhSMVZVZ(3),cplHpsigacHap(3),& 
& cplHpcHpVP(3,3),cplHpcVWpVP(3),cplHpcHpVZ(3,3),cplHpcVWpVZ(3),cplcHpVPVWp(3),          & 
& cplcHpVWpVZ(3),cplAhAhHpcHp1(3,3,3,3),cplAhHhSMHpcHp1(3,3,3,3),cplHaphhaHhSMcHp1(3,3), & 
& cplHapHhSMsigacHp1(3,3),cplHapHpcHapcHp1(3,3),cplhhahhaHpcHp1(3,3),cplhhaHhSMHpcHap1(3,3),& 
& cplHhSMHhSMHpcHp1(3,3,3,3),cplHhSMHpsigacHap1(3,3),cplHhSMHpcVWpVP1(3,3),              & 
& cplHhSMHpcVWpVZ1(3,3),cplHhSMcHpVPVWp1(3,3),cplHhSMcHpVWpVZ1(3,3),cplHpHpcHpcHp1(3,3,3,3),& 
& cplHpsigasigacHp1(3,3),cplHpcHpcVWpVWp1(3,3),cplHpcHpVZVZ1(3,3)

Complex(dp), Intent(out) :: Amp(3,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
    Do gt3=1,3
Amp(gt1, gt2, gt3) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MHp(gt2) 
Mex3 = MHhSM(gt3) 


! {VP, conj[Hp], conj[Hp]}
  Do i2=1,3
    Do i3=1,3
ML1 = MVP 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplHpcHpVP(i2,gt1)
coup2 = -cplHpcHpVP(gt2,i3)
coup3 = cplHhSMHpcHp(gt3,i3,i2)
Call Amp_VERTEX_StoSS_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VP, conj[VWp], conj[Hp]}
    Do i3=1,3
ML1 = MVP 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = cplcHpVPVWp(gt1)
coup2 = -cplHpcHpVP(gt2,i3)
coup3 = cplHhSMHpcVWp(gt3,i3)
Call Amp_VERTEX_StoSS_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
    End Do


! {VP, conj[Hp], conj[VWp]}
  Do i2=1,3
ML1 = MVP 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplHpcHpVP(i2,gt1)
coup2 = cplHpcVWpVP(gt2)
coup3 = cplHhSMcHpVWp(gt3,i2)
Call Amp_VERTEX_StoSS_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 
  End Do


! {VP, conj[VWp], conj[VWp]}
ML1 = MVP 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplHpcVWpVP(gt2)
coup3 = cplHhSMcVWpVWp(gt3)
Call Amp_VERTEX_StoSS_Topology1_VVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {VP, conj[VWp]}
ML1 = MVP 
ML2 = MVWp 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplHhSMHpcVWpVP1(gt3,gt2)
Call Amp_VERTEX_StoSS_Topology2_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 


! {VP, conj[VWp]}
ML1 = MVP 
ML2 = MVWp 
coup1 = cplHhSMcHpVPVWp1(gt3,gt1)
coup2 = cplHpcVWpVP(gt2)
Call Amp_VERTEX_StoSS_Topology3_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(gt1, gt2, gt3) = Amp(gt1, gt2, gt3) + oo16pi2*(1)*AmpC 

    End Do
  End Do
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_HpToHpHhSM


Subroutine Amplitude_Tree_4HDM_S3_HpToHhSMVWp(cplHhSMcHpVWp,MHhSM,MHp,MVWp,           & 
& MHhSM2,MHp2,MVWp2,Amp)

Implicit None

Real(dp), Intent(in) :: MHhSM(3),MHp(3),MVWp,MHhSM2(3),MHp2(3),MVWp2

Complex(dp), Intent(in) :: cplHhSMcHpVWp(3,3)

Complex(dp) :: Amp(2,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 

Do gt1=1,3
  Do gt2=1,3
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MHhSM(gt2) 
Mex3 = MVWp 
! Tree-Level Vertex 
coupT1 = -cplHhSMcHpVWp(gt2,gt1)
Call TreeAmp_StoSV(Mex1,Mex2,Mex3,coupT1,AmpC) 
! Colour and symmetry factor 
Amp(:,gt1, gt2) = AmpC 
  End Do
End Do
End Subroutine Amplitude_Tree_4HDM_S3_HpToHhSMVWp


Subroutine Gamma_Real_4HDM_S3_HpToHhSMVWp(MLambda,em,gs,cplHhSMcHpVWp,MHhSM,          & 
& MHp,MVWp,GammarealPhoton,GammarealGluon)

Implicit None

Complex(dp), Intent(in) :: cplHhSMcHpVWp(3,3)

Real(dp), Intent(in) :: MHhSM(3),MHp(3),MVWp

Real(dp), Intent(in) :: MLambda, em, gs 

Real(dp), Intent(out) :: GammarealPhoton(3,3), GammarealGluon(3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3, kont 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 

Real(dp) :: Mloop1, Mloop2, Mloop3 
Complex(dp) :: Coup 
 
Do i1=2,3
  Do i2=1,3
Coup = cplHhSMcHpVWp(i2,i1)
Mex1 = MHp(i1)
Mex2 = MHhSM(i2)
Mex3 = MVWp
If (Mex1.gt.(Mex2+Mex3)) Then 
 Call hardradiationSSV(Mex1,Mex2,Mex3,MLambda,em,1._dp,0._dp,1._dp,Coup,Gammarealphoton(i1,i2),kont)
 GammarealGluon(i1,i2) = 0._dp 
Else 
  GammarealGluon(i1,i2) = 0._dp 
  GammarealPhoton(i1,i2) = 0._dp 

End if 
  End Do
End Do
End Subroutine Gamma_Real_4HDM_S3_HpToHhSMVWp


Subroutine Amplitude_WAVE_4HDM_S3_HpToHhSMVWp(cplHhSMcHpVWp,ctcplHhSMcHpVWp,          & 
& MHhSM,MHhSM2,MHp,MHp2,MVWp,MVWp2,ZfHhSM,ZfHp,ZfVWp,Amp)

Implicit None

Real(dp), Intent(in) :: MHhSM(3),MHhSM2(3),MHp(3),MHp2(3),MVWp,MVWp2

Complex(dp), Intent(in) :: cplHhSMcHpVWp(3,3)

Complex(dp), Intent(in) :: ctcplHhSMcHpVWp(3,3)

Complex(dp), Intent(in) :: ZfHhSM(3,3),ZfHp(3,3),ZfVWp

Complex(dp), Intent(out) :: Amp(2,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
  Do gt2=1,3
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MHhSM(gt2) 
Mex3 = MVWp 
!----------------------------- 
! Coupling counter term 
!----------------------------- 
ZcoupT1 = ctcplHhSMcHpVWp(gt2,gt1) 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
Do i1=1,3
ZcoupT1 = ZcoupT1 + 0.5_dp*Conjg(ZfHp(i1,gt1))*cplHhSMcHpVWp(gt2,i1)
End Do


! External Field 2 
Do i1=1,3
ZcoupT1 = ZcoupT1 + 0.5_dp*ZfHhSM(i1,gt2)*cplHhSMcHpVWp(i1,gt1)
End Do


! External Field 3 
ZcoupT1 = ZcoupT1 + 0.5_dp*ZfVWp*cplHhSMcHpVWp(gt2,gt1)


! Getting the amplitude 
Call TreeAmp_StoSV(Mex1,Mex2,Mex3,-ZcoupT1,AmpC) 
Amp(:,gt1, gt2) = AmpC 
  End Do
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_HpToHhSMVWp


Subroutine Amplitude_VERTEX_4HDM_S3_HpToHhSMVWp(MAh,MFd,MFe,MFu,MHap,Mhha,            & 
& MHhSM,MHp,Msiga,MVP,MVWp,MVZ,MAh2,MFd2,MFe2,MFu2,MHap2,Mhha2,MHhSM2,MHp2,              & 
& Msiga2,MVP2,MVWp2,MVZ2,cplAhAhHhSM,cplAhHhSMVZ,cplAhHpcHp,cplAhcHpVWp,cplcFdFdHhSML,   & 
& cplcFdFdHhSMR,cplcFuFdVWpL,cplcFuFdVWpR,cplcFeFeHhSML,cplcFeFeHhSMR,cplcFvFeVWpL,      & 
& cplcFvFeVWpR,cplcFuFuHhSML,cplcFuFuHhSMR,cplcFdFucHpL,cplcFdFucHpR,cplcFeFvcHpL,       & 
& cplcFeFvcHpR,cplcgZgAHhSM,cplcgWCgAcHp,cplcgWpgWpHhSM,cplcgZgWpcHp,cplcgWCgWCHhSM,     & 
& cplcgAgWCVWp,cplcgZgWCVWp,cplcgZgZHhSM,cplcgWpgZVWp,cplcgWCgZcHp,cplHaphhacHp,         & 
& cplHapHhSMcHap,cplHapsigacHp,cplhhahhaHhSM,cplhhacHapVWp,cplHhSMHhSMHhSM,              & 
& cplHhSMHpcHp,cplHhSMHpcVWp,cplHhSMsigasiga,cplHhSMcHpVWp,cplHhSMcVWpVWp,               & 
& cplHhSMVZVZ,cplHpcHpVP,cplHpcHpVZ,cplsigacHapVWp,cplcHpVPVWp,cplcVWpVPVWp,             & 
& cplcHpVWpVZ,cplcVWpVWpVZ,cplAhcHpVWpVZ1,cplHhSMHhSMcVWpVWp1,cplHhSMcHpVPVWp1,          & 
& cplHhSMcHpVWpVZ1,cplHpcHpcVWpVWp1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHap,Mhha,MHhSM(3),MHp(3),Msiga,MVP,MVWp,MVZ,             & 
& MAh2(3),MFd2(3),MFe2(3),MFu2(3),MHap2,Mhha2,MHhSM2(3),MHp2(3),Msiga2,MVP2,             & 
& MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhAhHhSM(3,3,3),cplAhHhSMVZ(3,3),cplAhHpcHp(3,3,3),cplAhcHpVWp(3,3),               & 
& cplcFdFdHhSML(3,3,3),cplcFdFdHhSMR(3,3,3),cplcFuFdVWpL(3,3),cplcFuFdVWpR(3,3),         & 
& cplcFeFeHhSML(3,3,3),cplcFeFeHhSMR(3,3,3),cplcFvFeVWpL(3,3),cplcFvFeVWpR(3,3),         & 
& cplcFuFuHhSML(3,3,3),cplcFuFuHhSMR(3,3,3),cplcFdFucHpL(3,3,3),cplcFdFucHpR(3,3,3),     & 
& cplcFeFvcHpL(3,3,3),cplcFeFvcHpR(3,3,3),cplcgZgAHhSM(3),cplcgWCgAcHp(3),               & 
& cplcgWpgWpHhSM(3),cplcgZgWpcHp(3),cplcgWCgWCHhSM(3),cplcgAgWCVWp,cplcgZgWCVWp,         & 
& cplcgZgZHhSM(3),cplcgWpgZVWp,cplcgWCgZcHp(3),cplHaphhacHp(3),cplHapHhSMcHap(3),        & 
& cplHapsigacHp(3),cplhhahhaHhSM(3),cplhhacHapVWp,cplHhSMHhSMHhSM(3,3,3),cplHhSMHpcHp(3,3,3),& 
& cplHhSMHpcVWp(3,3),cplHhSMsigasiga(3),cplHhSMcHpVWp(3,3),cplHhSMcVWpVWp(3),            & 
& cplHhSMVZVZ(3),cplHpcHpVP(3,3),cplHpcHpVZ(3,3),cplsigacHapVWp,cplcHpVPVWp(3),          & 
& cplcVWpVPVWp,cplcHpVWpVZ(3),cplcVWpVWpVZ,cplAhcHpVWpVZ1(3,3),cplHhSMHhSMcVWpVWp1(3,3), & 
& cplHhSMcHpVPVWp1(3,3),cplHhSMcHpVWpVZ1(3,3),cplHpcHpcVWpVWp1(3,3)

Complex(dp), Intent(out) :: Amp(2,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
Amp(:,gt1, gt2) = 0._dp 
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MHhSM(gt2) 
Mex3 = MVWp 


! {Ah, conj[Hp], Ah}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MAh(i1) 
ML2 = MHp(i2) 
ML3 = MAh(i3) 
coup1 = cplAhHpcHp(i1,i2,gt1)
coup2 = cplAhAhHhSM(i1,i3,gt2)
coup3 = cplAhcHpVWp(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Ah, conj[Hp], VZ}
Do i1=1,3
  Do i2=1,3
ML1 = MAh(i1) 
ML2 = MHp(i2) 
ML3 = MVZ 
coup1 = cplAhHpcHp(i1,i2,gt1)
coup2 = -cplAhHhSMVZ(i1,gt2)
coup3 = cplcHpVWpVZ(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Ah, conj[VWp], VZ}
Do i1=1,3
ML1 = MAh(i1) 
ML2 = MVWp 
ML3 = MVZ 
coup1 = cplAhcHpVWp(i1,gt1)
coup2 = -cplAhHhSMVZ(i1,gt2)
coup3 = -cplcVWpVWpVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {Fu, Fd, Fu}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFu(i1) 
ML2 = MFd(i2) 
ML3 = MFu(i3) 
coup1L = cplcFdFucHpL(i2,i1,gt1)
coup1R = cplcFdFucHpR(i2,i1,gt1)
coup2L = cplcFuFuHhSML(i1,i3,gt2)
coup2R = cplcFuFuHhSMR(i1,i3,gt2)
coup3L = -cplcFuFdVWpR(i3,i2)
coup3R = -cplcFuFdVWpL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(3)*AmpC 
    End Do
  End Do
End Do


! {gWp, gZ, gWp}
ML1 = MVWp 
ML2 = MVZ 
ML3 = MVWp 
coup1 = cplcgZgWpcHp(gt1)
coup2 = cplcgWpgWpHhSM(gt2)
coup3 = cplcgWpgZVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {gZ, gWpC, gP}
ML1 = MVZ 
ML2 = MVWp 
ML3 = MVP 
coup1 = cplcgWCgZcHp(gt1)
coup2 = cplcgZgAHhSM(gt2)
coup3 = cplcgAgWCVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {gZ, gWpC, gZ}
ML1 = MVZ 
ML2 = MVWp 
ML3 = MVZ 
coup1 = cplcgWCgZcHp(gt1)
coup2 = cplcgZgZHhSM(gt2)
coup3 = cplcgZgWCVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {Hap, hha, Hap}
ML1 = MHap 
ML2 = Mhha 
ML3 = MHap 
coup1 = cplHaphhacHp(gt1)
coup2 = cplHapHhSMcHap(gt2)
coup3 = -cplhhacHapVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {Hap, siga, Hap}
ML1 = MHap 
ML2 = Msiga 
ML3 = MHap 
coup1 = cplHapsigacHp(gt1)
coup2 = cplHapHhSMcHap(gt2)
coup3 = -cplsigacHapVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {hha, conj[Hap], hha}
ML1 = Mhha 
ML2 = MHap 
ML3 = Mhha 
coup1 = cplHaphhacHp(gt1)
coup2 = cplhhahhaHhSM(gt2)
coup3 = cplhhacHapVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {HhSM, conj[Hp], HhSM}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHhSM(i1) 
ML2 = MHp(i2) 
ML3 = MHhSM(i3) 
coup1 = cplHhSMHpcHp(i1,i2,gt1)
coup2 = cplHhSMHhSMHhSM(gt2,i1,i3)
coup3 = cplHhSMcHpVWp(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {HhSM, conj[VWp], HhSM}
Do i1=1,3
    Do i3=1,3
ML1 = MHhSM(i1) 
ML2 = MVWp 
ML3 = MHhSM(i3) 
coup1 = cplHhSMcHpVWp(i1,gt1)
coup2 = cplHhSMHhSMHhSM(gt2,i1,i3)
coup3 = cplHhSMcVWpVWp(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, Ah, Hp}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MAh(i2) 
ML3 = MHp(i3) 
coup1 = cplAhHpcHp(i2,i1,gt1)
coup2 = cplHhSMHpcHp(gt2,i3,i1)
coup3 = -cplAhcHpVWp(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Hp, HhSM, Hp}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MHhSM(i2) 
ML3 = MHp(i3) 
coup1 = cplHhSMHpcHp(i2,i1,gt1)
coup2 = cplHhSMHpcHp(gt2,i3,i1)
coup3 = -cplHhSMcHpVWp(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Hp, VP, Hp}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVP 
ML3 = MHp(i3) 
coup1 = cplHpcHpVP(i1,gt1)
coup2 = cplHhSMHpcHp(gt2,i3,i1)
coup3 = cplcHpVPVWp(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, VZ, Hp}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVZ 
ML3 = MHp(i3) 
coup1 = cplHpcHpVZ(i1,gt1)
coup2 = cplHhSMHpcHp(gt2,i3,i1)
coup3 = cplcHpVWpVZ(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, HhSM, VWp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHhSM(i2) 
ML3 = MVWp 
coup1 = cplHhSMHpcHp(i2,i1,gt1)
coup2 = cplHhSMcHpVWp(gt2,i1)
coup3 = cplHhSMcVWpVWp(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, VP, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVP 
ML3 = MVWp 
coup1 = cplHpcHpVP(i1,gt1)
coup2 = cplHhSMcHpVWp(gt2,i1)
coup3 = -cplcVWpVPVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {Hp, VZ, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVZ 
ML3 = MVWp 
coup1 = cplHpcHpVZ(i1,gt1)
coup2 = cplHhSMcHpVWp(gt2,i1)
coup3 = cplcVWpVWpVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {siga, conj[Hap], siga}
ML1 = Msiga 
ML2 = MHap 
ML3 = Msiga 
coup1 = cplHapsigacHp(gt1)
coup2 = cplHhSMsigasiga(gt2)
coup3 = cplsigacHapVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {VWp, Ah, Hp}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MAh(i2) 
ML3 = MHp(i3) 
coup1 = cplAhcHpVWp(i2,gt1)
coup2 = cplHhSMHpcVWp(gt2,i3)
coup3 = -cplAhcHpVWp(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VWp, HhSM, Hp}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHhSM(i2) 
ML3 = MHp(i3) 
coup1 = cplHhSMcHpVWp(i2,gt1)
coup2 = cplHhSMHpcVWp(gt2,i3)
coup3 = -cplHhSMcHpVWp(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VWp, VP, Hp}
    Do i3=1,3
ML1 = MVWp 
ML2 = MVP 
ML3 = MHp(i3) 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplHhSMHpcVWp(gt2,i3)
coup3 = cplcHpVPVWp(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do


! {VWp, VZ, Hp}
    Do i3=1,3
ML1 = MVWp 
ML2 = MVZ 
ML3 = MHp(i3) 
coup1 = cplcHpVWpVZ(gt1)
coup2 = cplHhSMHpcVWp(gt2,i3)
coup3 = cplcHpVWpVZ(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do


! {VWp, HhSM, VWp}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHhSM(i2) 
ML3 = MVWp 
coup1 = cplHhSMcHpVWp(i2,gt1)
coup2 = cplHhSMcVWpVWp(gt2)
coup3 = cplHhSMcVWpVWp(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do


! {VWp, VP, VWp}
ML1 = MVWp 
ML2 = MVP 
ML3 = MVWp 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplHhSMcVWpVWp(gt2)
coup3 = -cplcVWpVPVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {VWp, VZ, VWp}
ML1 = MVWp 
ML2 = MVZ 
ML3 = MVWp 
coup1 = cplcHpVWpVZ(gt1)
coup2 = cplHhSMcVWpVWp(gt2)
coup3 = cplcVWpVWpVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {VZ, conj[Hp], Ah}
  Do i2=1,3
    Do i3=1,3
ML1 = MVZ 
ML2 = MHp(i2) 
ML3 = MAh(i3) 
coup1 = cplHpcHpVZ(i2,gt1)
coup2 = -cplAhHhSMVZ(i3,gt2)
coup3 = cplAhcHpVWp(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VZ, conj[Hp], VZ}
  Do i2=1,3
ML1 = MVZ 
ML2 = MHp(i2) 
ML3 = MVZ 
coup1 = cplHpcHpVZ(i2,gt1)
coup2 = cplHhSMVZVZ(gt2)
coup3 = cplcHpVWpVZ(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do


! {VZ, conj[VWp], VZ}
ML1 = MVZ 
ML2 = MVWp 
ML3 = MVZ 
coup1 = cplcHpVWpVZ(gt1)
coup2 = cplHhSMVZVZ(gt2)
coup3 = -cplcVWpVWpVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {bar[Fd], bar[Fu], bar[Fd]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFd(i1) 
ML2 = MFu(i2) 
ML3 = MFd(i3) 
coup1L = cplcFdFucHpL(i1,i2,gt1)
coup1R = cplcFdFucHpR(i1,i2,gt1)
coup2L = cplcFdFdHhSML(i3,i1,gt2)
coup2R = cplcFdFdHhSMR(i3,i1,gt2)
coup3L = cplcFuFdVWpL(i2,i3)
coup3R = cplcFuFdVWpR(i2,i3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(3)*AmpC 
    End Do
  End Do
End Do


! {bar[Fe], bar[Fv], bar[Fe]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFe(i1) 
ML2 = 0. 
ML3 = MFe(i3) 
coup1L = cplcFeFvcHpL(i1,i2,gt1)
coup1R = cplcFeFvcHpR(i1,i2,gt1)
coup2L = cplcFeFeHhSML(i3,i1,gt2)
coup2R = cplcFeFeHhSMR(i3,i1,gt2)
coup3L = cplcFvFeVWpL(i2,i3)
coup3R = cplcFvFeVWpR(i2,i3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {bar[gWpC], bar[gP], bar[gWpC]}
ML1 = MVWp 
ML2 = MVP 
ML3 = MVWp 
coup1 = cplcgWCgAcHp(gt1)
coup2 = cplcgWCgWCHhSM(gt2)
coup3 = cplcgAgWCVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {bar[gWpC], bar[gZ], bar[gWpC]}
ML1 = MVWp 
ML2 = MVZ 
ML3 = MVWp 
coup1 = cplcgWCgZcHp(gt1)
coup2 = cplcgWCgWCHhSM(gt2)
coup3 = cplcgZgWCVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {bar[gZ], bar[gWp], bar[gZ]}
ML1 = MVZ 
ML2 = MVWp 
ML3 = MVZ 
coup1 = cplcgZgWpcHp(gt1)
coup2 = cplcgZgZHhSM(gt2)
coup3 = cplcgWpgZVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {HhSM, conj[VWp]}
Do i1=1,3
ML1 = MHhSM(i1) 
ML2 = MVWp 
coup1 = -cplHhSMcHpVWp(i1,gt1)
coup2 = cplHhSMHhSMcVWpVWp1(gt2,i1)
Call Amp_VERTEX_StoSV_Topology2_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {Hp, VP}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVP 
coup1 = -cplHpcHpVP(i1,gt1)
coup2 = cplHhSMcHpVPVWp1(gt2,i1)
Call Amp_VERTEX_StoSV_Topology2_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {Hp, VZ}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVZ 
coup1 = -cplHpcHpVZ(i1,gt1)
coup2 = cplHhSMcHpVWpVZ1(gt2,i1)
Call Amp_VERTEX_StoSV_Topology2_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {Ah, VZ}
Do i1=1,3
ML1 = MAh(i1) 
ML2 = MVZ 
coup1 = cplAhcHpVWpVZ1(i1,gt1)
coup2 = -cplAhHhSMVZ(i1,gt2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology3_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 

End Do


! {Hp, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
coup1 = cplHpcHpcVWpVWp1(i1,gt1)
coup2 = cplHhSMcHpVWp(gt2,i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology3_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 

End Do
  End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_HpToHhSMVWp


Subroutine Amplitude_IR_VERTEX_4HDM_S3_HpToHhSMVWp(MAh,MFd,MFe,MFu,MHap,              & 
& Mhha,MHhSM,MHp,Msiga,MVP,MVWp,MVZ,MAh2,MFd2,MFe2,MFu2,MHap2,Mhha2,MHhSM2,              & 
& MHp2,Msiga2,MVP2,MVWp2,MVZ2,cplAhAhHhSM,cplAhHhSMVZ,cplAhHpcHp,cplAhcHpVWp,            & 
& cplcFdFdHhSML,cplcFdFdHhSMR,cplcFuFdVWpL,cplcFuFdVWpR,cplcFeFeHhSML,cplcFeFeHhSMR,     & 
& cplcFvFeVWpL,cplcFvFeVWpR,cplcFuFuHhSML,cplcFuFuHhSMR,cplcFdFucHpL,cplcFdFucHpR,       & 
& cplcFeFvcHpL,cplcFeFvcHpR,cplcgZgAHhSM,cplcgWCgAcHp,cplcgWpgWpHhSM,cplcgZgWpcHp,       & 
& cplcgWCgWCHhSM,cplcgAgWCVWp,cplcgZgWCVWp,cplcgZgZHhSM,cplcgWpgZVWp,cplcgWCgZcHp,       & 
& cplHaphhacHp,cplHapHhSMcHap,cplHapsigacHp,cplhhahhaHhSM,cplhhacHapVWp,cplHhSMHhSMHhSM, & 
& cplHhSMHpcHp,cplHhSMHpcVWp,cplHhSMsigasiga,cplHhSMcHpVWp,cplHhSMcVWpVWp,               & 
& cplHhSMVZVZ,cplHpcHpVP,cplHpcHpVZ,cplsigacHapVWp,cplcHpVPVWp,cplcVWpVPVWp,             & 
& cplcHpVWpVZ,cplcVWpVWpVZ,cplAhcHpVWpVZ1,cplHhSMHhSMcVWpVWp1,cplHhSMcHpVPVWp1,          & 
& cplHhSMcHpVWpVZ1,cplHpcHpcVWpVWp1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHap,Mhha,MHhSM(3),MHp(3),Msiga,MVP,MVWp,MVZ,             & 
& MAh2(3),MFd2(3),MFe2(3),MFu2(3),MHap2,Mhha2,MHhSM2(3),MHp2(3),Msiga2,MVP2,             & 
& MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhAhHhSM(3,3,3),cplAhHhSMVZ(3,3),cplAhHpcHp(3,3,3),cplAhcHpVWp(3,3),               & 
& cplcFdFdHhSML(3,3,3),cplcFdFdHhSMR(3,3,3),cplcFuFdVWpL(3,3),cplcFuFdVWpR(3,3),         & 
& cplcFeFeHhSML(3,3,3),cplcFeFeHhSMR(3,3,3),cplcFvFeVWpL(3,3),cplcFvFeVWpR(3,3),         & 
& cplcFuFuHhSML(3,3,3),cplcFuFuHhSMR(3,3,3),cplcFdFucHpL(3,3,3),cplcFdFucHpR(3,3,3),     & 
& cplcFeFvcHpL(3,3,3),cplcFeFvcHpR(3,3,3),cplcgZgAHhSM(3),cplcgWCgAcHp(3),               & 
& cplcgWpgWpHhSM(3),cplcgZgWpcHp(3),cplcgWCgWCHhSM(3),cplcgAgWCVWp,cplcgZgWCVWp,         & 
& cplcgZgZHhSM(3),cplcgWpgZVWp,cplcgWCgZcHp(3),cplHaphhacHp(3),cplHapHhSMcHap(3),        & 
& cplHapsigacHp(3),cplhhahhaHhSM(3),cplhhacHapVWp,cplHhSMHhSMHhSM(3,3,3),cplHhSMHpcHp(3,3,3),& 
& cplHhSMHpcVWp(3,3),cplHhSMsigasiga(3),cplHhSMcHpVWp(3,3),cplHhSMcVWpVWp(3),            & 
& cplHhSMVZVZ(3),cplHpcHpVP(3,3),cplHpcHpVZ(3,3),cplsigacHapVWp,cplcHpVPVWp(3),          & 
& cplcVWpVPVWp,cplcHpVWpVZ(3),cplcVWpVWpVZ,cplAhcHpVWpVZ1(3,3),cplHhSMHhSMcVWpVWp1(3,3), & 
& cplHhSMcHpVPVWp1(3,3),cplHhSMcHpVWpVZ1(3,3),cplHpcHpcVWpVWp1(3,3)

Complex(dp), Intent(out) :: Amp(2,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
Amp(:,gt1, gt2) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MHhSM(gt2) 
Mex3 = MVWp 


! {Hp, VP, Hp}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVP 
ML3 = MHp(i3) 
coup1 = cplHpcHpVP(i1,gt1)
coup2 = cplHhSMHpcHp(gt2,i3,i1)
coup3 = cplcHpVPVWp(i3)
Call Amp_VERTEX_StoSV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, VP, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVP 
ML3 = MVWp 
coup1 = cplHpcHpVP(i1,gt1)
coup2 = cplHhSMcHpVWp(gt2,i1)
coup3 = -cplcVWpVPVWp
Call Amp_VERTEX_StoSV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {VWp, VP, Hp}
    Do i3=1,3
ML1 = MVWp 
ML2 = MVP 
ML3 = MHp(i3) 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplHhSMHpcVWp(gt2,i3)
coup3 = cplcHpVPVWp(i3)
Call Amp_VERTEX_StoSV_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do


! {VWp, VP, VWp}
ML1 = MVWp 
ML2 = MVP 
ML3 = MVWp 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplHhSMcVWpVWp(gt2)
coup3 = -cplcVWpVPVWp
Call Amp_VERTEX_StoSV_Topology1_VVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {Hp, VP}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVP 
coup1 = -cplHpcHpVP(i1,gt1)
coup2 = cplHhSMcHpVPVWp1(gt2,i1)
Call Amp_VERTEX_StoSV_Topology2_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do
  End Do
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_HpToHhSMVWp


Subroutine Amplitude_Tree_4HDM_S3_HpToHpVZ(cplHpcHpVZ,MHp,MVZ,MHp2,MVZ2,Amp)

Implicit None

Real(dp), Intent(in) :: MHp(3),MVZ,MHp2(3),MVZ2

Complex(dp), Intent(in) :: cplHpcHpVZ(3,3)

Complex(dp) :: Amp(2,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 

Do gt1=1,3
  Do gt2=1,3
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MHp(gt2) 
Mex3 = MVZ 
! Tree-Level Vertex 
coupT1 = -cplHpcHpVZ(gt2,gt1)
Call TreeAmp_StoSV(Mex1,Mex2,Mex3,coupT1,AmpC) 
! Colour and symmetry factor 
Amp(:,gt1, gt2) = AmpC 
  End Do
End Do
End Subroutine Amplitude_Tree_4HDM_S3_HpToHpVZ


Subroutine Gamma_Real_4HDM_S3_HpToHpVZ(MLambda,em,gs,cplHpcHpVZ,MHp,MVZ,              & 
& GammarealPhoton,GammarealGluon)

Implicit None

Complex(dp), Intent(in) :: cplHpcHpVZ(3,3)

Real(dp), Intent(in) :: MHp(3),MVZ

Real(dp), Intent(in) :: MLambda, em, gs 

Real(dp), Intent(out) :: GammarealPhoton(3,3), GammarealGluon(3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3, kont 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 

Real(dp) :: Mloop1, Mloop2, Mloop3 
Complex(dp) :: Coup 
 
Do i1=2,3
  Do i2=2,3
Coup = cplHpcHpVZ(i2,i1)
Mex1 = MHp(i1)
Mex2 = MHp(i2)
Mex3 = MVZ
If (Mex1.gt.(Mex2+Mex3)) Then 
 Call hardradiationSSV(Mex1,Mex2,Mex3,MLambda,em,1._dp,1._dp,0._dp,Coup,Gammarealphoton(i1,i2),kont)
 GammarealGluon(i1,i2) = 0._dp 
Else 
  GammarealGluon(i1,i2) = 0._dp 
  GammarealPhoton(i1,i2) = 0._dp 

End if 
  End Do
End Do
End Subroutine Gamma_Real_4HDM_S3_HpToHpVZ


Subroutine Amplitude_WAVE_4HDM_S3_HpToHpVZ(cplHpcHpVP,cplHpcHpVZ,ctcplHpcHpVP,        & 
& ctcplHpcHpVZ,MHp,MHp2,MVP,MVP2,MVZ,MVZ2,ZfHp,ZfVPVZ,ZfVZ,Amp)

Implicit None

Real(dp), Intent(in) :: MHp(3),MHp2(3),MVP,MVP2,MVZ,MVZ2

Complex(dp), Intent(in) :: cplHpcHpVP(3,3),cplHpcHpVZ(3,3)

Complex(dp), Intent(in) :: ctcplHpcHpVP(3,3),ctcplHpcHpVZ(3,3)

Complex(dp), Intent(in) :: ZfHp(3,3),ZfVPVZ,ZfVZ

Complex(dp), Intent(out) :: Amp(2,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
  Do gt2=1,3
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MHp(gt2) 
Mex3 = MVZ 
!----------------------------- 
! Coupling counter term 
!----------------------------- 
ZcoupT1 = ctcplHpcHpVZ(gt2,gt1) 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
Do i1=1,3
ZcoupT1 = ZcoupT1 + 0.5_dp*Conjg(ZfHp(i1,gt1))*cplHpcHpVZ(gt2,i1)
End Do


! External Field 2 
Do i1=1,3
ZcoupT1 = ZcoupT1 + 0.5_dp*ZfHp(i1,gt2)*cplHpcHpVZ(i1,gt1)
End Do


! External Field 3 
ZcoupT1 = ZcoupT1 + 0.5_dp*ZfVPVZ*cplHpcHpVP(gt2,gt1)
ZcoupT1 = ZcoupT1 + 0.5_dp*ZfVZ*cplHpcHpVZ(gt2,gt1)


! Getting the amplitude 
Call TreeAmp_StoSV(Mex1,Mex2,Mex3,-ZcoupT1,AmpC) 
Amp(:,gt1, gt2) = AmpC 
  End Do
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_HpToHpVZ


Subroutine Amplitude_VERTEX_4HDM_S3_HpToHpVZ(MAh,MFd,MFe,MFu,MHap,Mhha,               & 
& MHhSM,MHp,Msiga,MVP,MVWp,MVZ,MAh2,MFd2,MFe2,MFu2,MHap2,Mhha2,MHhSM2,MHp2,              & 
& Msiga2,MVP2,MVWp2,MVZ2,cplAhHhSMVZ,cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplcFuFdHpL,     & 
& cplcFuFdHpR,cplcFdFdVZL,cplcFdFdVZR,cplcFvFeHpL,cplcFvFeHpR,cplcFeFeVZL,               & 
& cplcFeFeVZR,cplcFuFuVZL,cplcFuFuVZR,cplcFdFucHpL,cplcFdFucHpR,cplcFvFvVZL,             & 
& cplcFvFvVZR,cplcFeFvcHpL,cplcFeFvcHpR,cplcgWpgWpVZ,cplcgZgWpcHp,cplcgZgWCHp,           & 
& cplcgWCgWCVZ,cplcgWpgZHp,cplcgWCgZcHp,cplHaphhacHp,cplHapsigacHp,cplHapcHapVZ,         & 
& cplhhaHpcHap,cplhhasigaVZ,cplHhSMHpcHp,cplHhSMHpcVWp,cplHhSMcHpVWp,cplHhSMVZVZ,        & 
& cplHpsigacHap,cplHpcHpVP,cplHpcVWpVP,cplHpcHpVZ,cplHpcVWpVZ,cplcHpVPVWp,               & 
& cplcHpVWpVZ,cplcVWpVWpVZ,cplAhHpcVWpVZ1,cplAhcHpVWpVZ1,cplHhSMHpcVWpVZ1,               & 
& cplHhSMcHpVWpVZ1,cplHpcHpVPVZ1,cplHpcHpVZVZ1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHap,Mhha,MHhSM(3),MHp(3),Msiga,MVP,MVWp,MVZ,             & 
& MAh2(3),MFd2(3),MFe2(3),MFu2(3),MHap2,Mhha2,MHhSM2(3),MHp2(3),Msiga2,MVP2,             & 
& MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhHhSMVZ(3,3),cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),cplAhcHpVWp(3,3),cplcFuFdHpL(3,3,3),& 
& cplcFuFdHpR(3,3,3),cplcFdFdVZL(3,3),cplcFdFdVZR(3,3),cplcFvFeHpL(3,3,3),               & 
& cplcFvFeHpR(3,3,3),cplcFeFeVZL(3,3),cplcFeFeVZR(3,3),cplcFuFuVZL(3,3),cplcFuFuVZR(3,3),& 
& cplcFdFucHpL(3,3,3),cplcFdFucHpR(3,3,3),cplcFvFvVZL(3,3),cplcFvFvVZR(3,3),             & 
& cplcFeFvcHpL(3,3,3),cplcFeFvcHpR(3,3,3),cplcgWpgWpVZ,cplcgZgWpcHp(3),cplcgZgWCHp(3),   & 
& cplcgWCgWCVZ,cplcgWpgZHp(3),cplcgWCgZcHp(3),cplHaphhacHp(3),cplHapsigacHp(3),          & 
& cplHapcHapVZ,cplhhaHpcHap(3),cplhhasigaVZ,cplHhSMHpcHp(3,3,3),cplHhSMHpcVWp(3,3),      & 
& cplHhSMcHpVWp(3,3),cplHhSMVZVZ(3),cplHpsigacHap(3),cplHpcHpVP(3,3),cplHpcVWpVP(3),     & 
& cplHpcHpVZ(3,3),cplHpcVWpVZ(3),cplcHpVPVWp(3),cplcHpVWpVZ(3),cplcVWpVWpVZ,             & 
& cplAhHpcVWpVZ1(3,3),cplAhcHpVWpVZ1(3,3),cplHhSMHpcVWpVZ1(3,3),cplHhSMcHpVWpVZ1(3,3),   & 
& cplHpcHpVPVZ1(3,3),cplHpcHpVZVZ1(3,3)

Complex(dp), Intent(out) :: Amp(2,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
Amp(:,gt1, gt2) = 0._dp 
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MHp(gt2) 
Mex3 = MVZ 


! {Ah, conj[Hp], conj[Hp]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MAh(i1) 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplAhHpcHp(i1,i2,gt1)
coup2 = cplAhHpcHp(i1,gt2,i3)
coup3 = cplHpcHpVZ(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Ah, conj[VWp], conj[Hp]}
Do i1=1,3
    Do i3=1,3
ML1 = MAh(i1) 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = cplAhcHpVWp(i1,gt1)
coup2 = cplAhHpcHp(i1,gt2,i3)
coup3 = cplHpcVWpVZ(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Ah, conj[Hp], conj[VWp]}
Do i1=1,3
  Do i2=1,3
ML1 = MAh(i1) 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplAhHpcHp(i1,i2,gt1)
coup2 = -cplAhHpcVWp(i1,gt2)
coup3 = cplcHpVWpVZ(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Ah, conj[VWp], conj[VWp]}
Do i1=1,3
ML1 = MAh(i1) 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplAhcHpVWp(i1,gt1)
coup2 = -cplAhHpcVWp(i1,gt2)
coup3 = cplcVWpVWpVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {Fu, Fd, Fd}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFu(i1) 
ML2 = MFd(i2) 
ML3 = MFd(i3) 
coup1L = cplcFdFucHpL(i2,i1,gt1)
coup1R = cplcFdFucHpR(i2,i1,gt1)
coup2L = cplcFuFdHpL(i1,i3,gt2)
coup2R = cplcFuFdHpR(i1,i3,gt2)
coup3L = -cplcFdFdVZR(i3,i2)
coup3R = -cplcFdFdVZL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(3)*AmpC 
    End Do
  End Do
End Do


! {Fv, Fe, Fe}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = 0. 
ML2 = MFe(i2) 
ML3 = MFe(i3) 
coup1L = cplcFeFvcHpL(i2,i1,gt1)
coup1R = cplcFeFvcHpR(i2,i1,gt1)
coup2L = cplcFvFeHpL(i1,i3,gt2)
coup2R = cplcFvFeHpR(i1,i3,gt2)
coup3L = -cplcFeFeVZR(i3,i2)
coup3R = -cplcFeFeVZL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {gZ, gWpC, gWpC}
ML1 = MVZ 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcgWCgZcHp(gt1)
coup2 = cplcgZgWCHp(gt2)
coup3 = cplcgWCgWCVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {Hap, siga, hha}
ML1 = MHap 
ML2 = Msiga 
ML3 = Mhha 
coup1 = cplHapsigacHp(gt1)
coup2 = cplhhaHpcHap(gt2)
coup3 = cplhhasigaVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {Hap, hha, siga}
ML1 = MHap 
ML2 = Mhha 
ML3 = Msiga 
coup1 = cplHaphhacHp(gt1)
coup2 = cplHpsigacHap(gt2)
coup3 = -cplhhasigaVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {hha, conj[Hap], conj[Hap]}
ML1 = Mhha 
ML2 = MHap 
ML3 = MHap 
coup1 = cplHaphhacHp(gt1)
coup2 = cplhhaHpcHap(gt2)
coup3 = cplHapcHapVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {HhSM, conj[Hp], conj[Hp]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHhSM(i1) 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplHhSMHpcHp(i1,i2,gt1)
coup2 = cplHhSMHpcHp(i1,gt2,i3)
coup3 = cplHpcHpVZ(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {HhSM, conj[VWp], conj[Hp]}
Do i1=1,3
    Do i3=1,3
ML1 = MHhSM(i1) 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = cplHhSMcHpVWp(i1,gt1)
coup2 = cplHhSMHpcHp(i1,gt2,i3)
coup3 = cplHpcVWpVZ(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {HhSM, conj[Hp], conj[VWp]}
Do i1=1,3
  Do i2=1,3
ML1 = MHhSM(i1) 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplHhSMHpcHp(i1,i2,gt1)
coup2 = -cplHhSMHpcVWp(i1,gt2)
coup3 = cplcHpVWpVZ(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {HhSM, conj[VWp], conj[VWp]}
Do i1=1,3
ML1 = MHhSM(i1) 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplHhSMcHpVWp(i1,gt1)
coup2 = -cplHhSMHpcVWp(i1,gt2)
coup3 = cplcVWpVWpVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {Hp, HhSM, Ah}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MHhSM(i2) 
ML3 = MAh(i3) 
coup1 = cplHhSMHpcHp(i2,i1,gt1)
coup2 = cplAhHpcHp(i3,gt2,i1)
coup3 = cplAhHhSMVZ(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Hp, Ah, HhSM}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MAh(i2) 
ML3 = MHhSM(i3) 
coup1 = cplAhHpcHp(i2,i1,gt1)
coup2 = cplHhSMHpcHp(i3,gt2,i1)
coup3 = -cplAhHhSMVZ(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Hp, VZ, HhSM}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVZ 
ML3 = MHhSM(i3) 
coup1 = cplHpcHpVZ(i1,gt1)
coup2 = cplHhSMHpcHp(i3,gt2,i1)
coup3 = cplHhSMVZVZ(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, HhSM, VZ}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHhSM(i2) 
ML3 = MVZ 
coup1 = cplHhSMHpcHp(i2,i1,gt1)
coup2 = cplHpcHpVZ(gt2,i1)
coup3 = cplHhSMVZVZ(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {siga, conj[Hap], conj[Hap]}
ML1 = Msiga 
ML2 = MHap 
ML3 = MHap 
coup1 = cplHapsigacHp(gt1)
coup2 = cplHpsigacHap(gt2)
coup3 = cplHapcHapVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {VP, conj[Hp], conj[Hp]}
  Do i2=1,3
    Do i3=1,3
ML1 = MVP 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplHpcHpVP(i2,gt1)
coup2 = cplHpcHpVP(gt2,i3)
coup3 = cplHpcHpVZ(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VP, conj[VWp], conj[Hp]}
    Do i3=1,3
ML1 = MVP 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplHpcHpVP(gt2,i3)
coup3 = cplHpcVWpVZ(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do


! {VP, conj[Hp], conj[VWp]}
  Do i2=1,3
ML1 = MVP 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplHpcHpVP(i2,gt1)
coup2 = cplHpcVWpVP(gt2)
coup3 = cplcHpVWpVZ(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do


! {VP, conj[VWp], conj[VWp]}
ML1 = MVP 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplHpcVWpVP(gt2)
coup3 = cplcVWpVWpVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {VWp, HhSM, Ah}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHhSM(i2) 
ML3 = MAh(i3) 
coup1 = cplHhSMcHpVWp(i2,gt1)
coup2 = -cplAhHpcVWp(i3,gt2)
coup3 = cplAhHhSMVZ(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VWp, Ah, HhSM}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MAh(i2) 
ML3 = MHhSM(i3) 
coup1 = cplAhcHpVWp(i2,gt1)
coup2 = -cplHhSMHpcVWp(i3,gt2)
coup3 = -cplAhHhSMVZ(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VWp, VZ, HhSM}
    Do i3=1,3
ML1 = MVWp 
ML2 = MVZ 
ML3 = MHhSM(i3) 
coup1 = cplcHpVWpVZ(gt1)
coup2 = -cplHhSMHpcVWp(i3,gt2)
coup3 = cplHhSMVZVZ(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do


! {VWp, HhSM, VZ}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHhSM(i2) 
ML3 = MVZ 
coup1 = cplHhSMcHpVWp(i2,gt1)
coup2 = cplHpcVWpVZ(gt2)
coup3 = cplHhSMVZVZ(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do


! {VZ, conj[Hp], conj[Hp]}
  Do i2=1,3
    Do i3=1,3
ML1 = MVZ 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplHpcHpVZ(i2,gt1)
coup2 = cplHpcHpVZ(gt2,i3)
coup3 = cplHpcHpVZ(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VZ, conj[VWp], conj[Hp]}
    Do i3=1,3
ML1 = MVZ 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = cplcHpVWpVZ(gt1)
coup2 = cplHpcHpVZ(gt2,i3)
coup3 = cplHpcVWpVZ(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do


! {VZ, conj[Hp], conj[VWp]}
  Do i2=1,3
ML1 = MVZ 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplHpcHpVZ(i2,gt1)
coup2 = cplHpcVWpVZ(gt2)
coup3 = cplcHpVWpVZ(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do


! {VZ, conj[VWp], conj[VWp]}
ML1 = MVZ 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcHpVWpVZ(gt1)
coup2 = cplHpcVWpVZ(gt2)
coup3 = cplcVWpVWpVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {bar[Fd], bar[Fu], bar[Fu]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFd(i1) 
ML2 = MFu(i2) 
ML3 = MFu(i3) 
coup1L = cplcFdFucHpL(i1,i2,gt1)
coup1R = cplcFdFucHpR(i1,i2,gt1)
coup2L = cplcFuFdHpL(i3,i1,gt2)
coup2R = cplcFuFdHpR(i3,i1,gt2)
coup3L = cplcFuFuVZL(i2,i3)
coup3R = cplcFuFuVZR(i2,i3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(3)*AmpC 
    End Do
  End Do
End Do


! {bar[Fe], bar[Fv], bar[Fv]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFe(i1) 
ML2 = 0. 
ML3 = 0. 
coup1L = cplcFeFvcHpL(i1,i2,gt1)
coup1R = cplcFeFvcHpR(i1,i2,gt1)
coup2L = cplcFvFeHpL(i3,i1,gt2)
coup2R = cplcFvFeHpR(i3,i1,gt2)
coup3L = cplcFvFvVZL(i2,i3)
coup3R = cplcFvFvVZR(i2,i3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {bar[gZ], bar[gWp], bar[gWp]}
ML1 = MVZ 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcgZgWpcHp(gt1)
coup2 = cplcgWpgZHp(gt2)
coup3 = cplcgWpgWpVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {Ah, conj[VWp]}
Do i1=1,3
ML1 = MAh(i1) 
ML2 = MVWp 
coup1 = -cplAhcHpVWp(i1,gt1)
coup2 = cplAhHpcVWpVZ1(i1,gt2)
Call Amp_VERTEX_StoSV_Topology2_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {HhSM, conj[VWp]}
Do i1=1,3
ML1 = MHhSM(i1) 
ML2 = MVWp 
coup1 = -cplHhSMcHpVWp(i1,gt1)
coup2 = cplHhSMHpcVWpVZ1(i1,gt2)
Call Amp_VERTEX_StoSV_Topology2_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {Hp, VP}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVP 
coup1 = -cplHpcHpVP(i1,gt1)
coup2 = cplHpcHpVPVZ1(gt2,i1)
Call Amp_VERTEX_StoSV_Topology2_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {Hp, VZ}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVZ 
coup1 = -cplHpcHpVZ(i1,gt1)
coup2 = cplHpcHpVZVZ1(gt2,i1)
Call Amp_VERTEX_StoSV_Topology2_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {Ah, conj[VWp]}
Do i1=1,3
ML1 = MAh(i1) 
ML2 = MVWp 
coup1 = cplAhcHpVWpVZ1(i1,gt1)
coup2 = -cplAhHpcVWp(i1,gt2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology3_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 

End Do


! {HhSM, conj[VWp]}
Do i1=1,3
ML1 = MHhSM(i1) 
ML2 = MVWp 
coup1 = cplHhSMcHpVWpVZ1(i1,gt1)
coup2 = -cplHhSMHpcVWp(i1,gt2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology3_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 

End Do


! {Hp, VP}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVP 
coup1 = cplHpcHpVPVZ1(i1,gt1)
coup2 = cplHpcHpVP(gt2,i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology3_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 

End Do


! {Hp, VZ}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVZ 
coup1 = cplHpcHpVZVZ1(i1,gt1)
coup2 = cplHpcHpVZ(gt2,i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology3_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 

End Do
  End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_HpToHpVZ


Subroutine Amplitude_IR_VERTEX_4HDM_S3_HpToHpVZ(MAh,MFd,MFe,MFu,MHap,Mhha,            & 
& MHhSM,MHp,Msiga,MVP,MVWp,MVZ,MAh2,MFd2,MFe2,MFu2,MHap2,Mhha2,MHhSM2,MHp2,              & 
& Msiga2,MVP2,MVWp2,MVZ2,cplAhHhSMVZ,cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplcFuFdHpL,     & 
& cplcFuFdHpR,cplcFdFdVZL,cplcFdFdVZR,cplcFvFeHpL,cplcFvFeHpR,cplcFeFeVZL,               & 
& cplcFeFeVZR,cplcFuFuVZL,cplcFuFuVZR,cplcFdFucHpL,cplcFdFucHpR,cplcFvFvVZL,             & 
& cplcFvFvVZR,cplcFeFvcHpL,cplcFeFvcHpR,cplcgWpgWpVZ,cplcgZgWpcHp,cplcgZgWCHp,           & 
& cplcgWCgWCVZ,cplcgWpgZHp,cplcgWCgZcHp,cplHaphhacHp,cplHapsigacHp,cplHapcHapVZ,         & 
& cplhhaHpcHap,cplhhasigaVZ,cplHhSMHpcHp,cplHhSMHpcVWp,cplHhSMcHpVWp,cplHhSMVZVZ,        & 
& cplHpsigacHap,cplHpcHpVP,cplHpcVWpVP,cplHpcHpVZ,cplHpcVWpVZ,cplcHpVPVWp,               & 
& cplcHpVWpVZ,cplcVWpVWpVZ,cplAhHpcVWpVZ1,cplAhcHpVWpVZ1,cplHhSMHpcVWpVZ1,               & 
& cplHhSMcHpVWpVZ1,cplHpcHpVPVZ1,cplHpcHpVZVZ1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHap,Mhha,MHhSM(3),MHp(3),Msiga,MVP,MVWp,MVZ,             & 
& MAh2(3),MFd2(3),MFe2(3),MFu2(3),MHap2,Mhha2,MHhSM2(3),MHp2(3),Msiga2,MVP2,             & 
& MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhHhSMVZ(3,3),cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),cplAhcHpVWp(3,3),cplcFuFdHpL(3,3,3),& 
& cplcFuFdHpR(3,3,3),cplcFdFdVZL(3,3),cplcFdFdVZR(3,3),cplcFvFeHpL(3,3,3),               & 
& cplcFvFeHpR(3,3,3),cplcFeFeVZL(3,3),cplcFeFeVZR(3,3),cplcFuFuVZL(3,3),cplcFuFuVZR(3,3),& 
& cplcFdFucHpL(3,3,3),cplcFdFucHpR(3,3,3),cplcFvFvVZL(3,3),cplcFvFvVZR(3,3),             & 
& cplcFeFvcHpL(3,3,3),cplcFeFvcHpR(3,3,3),cplcgWpgWpVZ,cplcgZgWpcHp(3),cplcgZgWCHp(3),   & 
& cplcgWCgWCVZ,cplcgWpgZHp(3),cplcgWCgZcHp(3),cplHaphhacHp(3),cplHapsigacHp(3),          & 
& cplHapcHapVZ,cplhhaHpcHap(3),cplhhasigaVZ,cplHhSMHpcHp(3,3,3),cplHhSMHpcVWp(3,3),      & 
& cplHhSMcHpVWp(3,3),cplHhSMVZVZ(3),cplHpsigacHap(3),cplHpcHpVP(3,3),cplHpcVWpVP(3),     & 
& cplHpcHpVZ(3,3),cplHpcVWpVZ(3),cplcHpVPVWp(3),cplcHpVWpVZ(3),cplcVWpVWpVZ,             & 
& cplAhHpcVWpVZ1(3,3),cplAhcHpVWpVZ1(3,3),cplHhSMHpcVWpVZ1(3,3),cplHhSMcHpVWpVZ1(3,3),   & 
& cplHpcHpVPVZ1(3,3),cplHpcHpVZVZ1(3,3)

Complex(dp), Intent(out) :: Amp(2,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
Amp(:,gt1, gt2) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MHp(gt2) 
Mex3 = MVZ 


! {VP, conj[Hp], conj[Hp]}
  Do i2=1,3
    Do i3=1,3
ML1 = MVP 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplHpcHpVP(i2,gt1)
coup2 = cplHpcHpVP(gt2,i3)
coup3 = cplHpcHpVZ(i3,i2)
Call Amp_VERTEX_StoSV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VP, conj[VWp], conj[Hp]}
    Do i3=1,3
ML1 = MVP 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplHpcHpVP(gt2,i3)
coup3 = cplHpcVWpVZ(i3)
Call Amp_VERTEX_StoSV_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do


! {VP, conj[Hp], conj[VWp]}
  Do i2=1,3
ML1 = MVP 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplHpcHpVP(i2,gt1)
coup2 = cplHpcVWpVP(gt2)
coup3 = cplcHpVWpVZ(i2)
Call Amp_VERTEX_StoSV_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do


! {VP, conj[VWp], conj[VWp]}
ML1 = MVP 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplHpcVWpVP(gt2)
coup3 = cplcVWpVWpVZ
Call Amp_VERTEX_StoSV_Topology1_VVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {Hp, VP}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVP 
coup1 = -cplHpcHpVP(i1,gt1)
coup2 = cplHpcHpVPVZ1(gt2,i1)
Call Amp_VERTEX_StoSV_Topology2_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {Hp, VP}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVP 
coup1 = cplHpcHpVPVZ1(i1,gt1)
coup2 = cplHpcHpVP(gt2,i1)
Call Amp_VERTEX_StoSV_Topology3_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 

End Do
  End Do
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_HpToHpVZ


Subroutine Amplitude_Tree_4HDM_S3_HpToVZVWp(cplcHpVWpVZ,MHp,MVWp,MVZ,MHp2,            & 
& MVWp2,MVZ2,Amp)

Implicit None

Real(dp), Intent(in) :: MHp(3),MVWp,MVZ,MHp2(3),MVWp2,MVZ2

Complex(dp), Intent(in) :: cplcHpVWpVZ(3)

Complex(dp) :: Amp(2,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 

Do gt1=1,3
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MVZ 
Mex3 = MVWp 
! Tree-Level Vertex 
coupT1 = cplcHpVWpVZ(gt1)
Call TreeAmp_StoVV(Mex1,Mex2,Mex3,coupT1,AmpC) 
! Colour and symmetry factor 
Amp(:,gt1) = AmpC 
End Do
End Subroutine Amplitude_Tree_4HDM_S3_HpToVZVWp


Subroutine Gamma_Real_4HDM_S3_HpToVZVWp(MLambda,em,gs,cplcHpVWpVZ,MHp,MVWp,           & 
& MVZ,GammarealPhoton,GammarealGluon)

Implicit None

Complex(dp), Intent(in) :: cplcHpVWpVZ(3)

Real(dp), Intent(in) :: MHp(3),MVWp,MVZ

Real(dp), Intent(in) :: MLambda, em, gs 

Real(dp), Intent(out) :: GammarealPhoton(3), GammarealGluon(3) 

Integer :: i1, i2, i3, gt1, gt2, gt3, kont 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 

Real(dp) :: Mloop1, Mloop2, Mloop3 
Complex(dp) :: Coup 
 
Do i1=2,3
Coup = cplcHpVWpVZ(i1)
Mex1 = MHp(i1)
Mex2 = MVZ
Mex3 = MVWp
If (Mex1.gt.(Mex2+Mex3)) Then 
  GammarealGluon(i1) = 0._dp 
 Call hardphotonSVV(Mex1,Mex2,Mex3,MLambda,em,1._dp,0._dp,1._dp,Coup,Gammarealphoton(i1),kont)
Else 
  GammarealGluon(i1) = 0._dp 
  GammarealPhoton(i1) = 0._dp 

End if 
End Do
End Subroutine Gamma_Real_4HDM_S3_HpToVZVWp


Subroutine Amplitude_WAVE_4HDM_S3_HpToVZVWp(cplcHpVPVWp,cplcHpVWpVZ,ctcplcHpVPVWp,    & 
& ctcplcHpVWpVZ,MHp,MHp2,MVP,MVP2,MVWp,MVWp2,MVZ,MVZ2,ZfHp,ZfVWp,ZfVZ,Amp)

Implicit None

Real(dp), Intent(in) :: MHp(3),MHp2(3),MVP,MVP2,MVWp,MVWp2,MVZ,MVZ2

Complex(dp), Intent(in) :: cplcHpVPVWp(3),cplcHpVWpVZ(3)

Complex(dp), Intent(in) :: ctcplcHpVPVWp(3),ctcplcHpVWpVZ(3)

Complex(dp), Intent(in) :: ZfHp(3,3),ZfVWp,ZfVZ

Complex(dp), Intent(out) :: Amp(2,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MVZ 
Mex3 = MVWp 
!----------------------------- 
! Coupling counter term 
!----------------------------- 
ZcoupT1 = ctcplcHpVWpVZ(gt1) 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
Do i1=1,3
ZcoupT1 = ZcoupT1 + 0.5_dp*Conjg(ZfHp(i1,gt1))*cplcHpVWpVZ(i1)
End Do


! External Field 2 
ZcoupT1 = ZcoupT1 + 0.5_dp*ZfVZ*cplcHpVWpVZ(gt1)


! External Field 3 
ZcoupT1 = ZcoupT1 + 0.5_dp*ZfVWp*cplcHpVWpVZ(gt1)


! Getting the amplitude 
Call TreeAmp_StoVV(Mex1,Mex2,Mex3,ZcoupT1,AmpC) 
Amp(:,gt1) = AmpC 
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_HpToVZVWp


Subroutine Amplitude_VERTEX_4HDM_S3_HpToVZVWp(MAh,MFd,MFe,MFu,MHap,Mhha,              & 
& MHhSM,MHp,Msiga,MVP,MVWp,MVZ,MAh2,MFd2,MFe2,MFu2,MHap2,Mhha2,MHhSM2,MHp2,              & 
& Msiga2,MVP2,MVWp2,MVZ2,cplAhHhSMVZ,cplAhHpcHp,cplAhcHpVWp,cplcFuFdVWpL,cplcFuFdVWpR,   & 
& cplcFdFdVZL,cplcFdFdVZR,cplcFvFeVWpL,cplcFvFeVWpR,cplcFeFeVZL,cplcFeFeVZR,             & 
& cplcFuFuVZL,cplcFuFuVZR,cplcFdFucHpL,cplcFdFucHpR,cplcFvFvVZL,cplcFvFvVZR,             & 
& cplcFeFvcHpL,cplcFeFvcHpR,cplcgWCgAcHp,cplcgWpgWpVZ,cplcgZgWpcHp,cplcgAgWCVWp,         & 
& cplcgZgWCVWp,cplcgWCgWCVZ,cplcgWpgZVWp,cplcgWCgZcHp,cplHaphhacHp,cplHapsigacHp,        & 
& cplHapcHapVZ,cplhhasigaVZ,cplhhacHapVWp,cplHhSMHpcHp,cplHhSMcHpVWp,cplHhSMcVWpVWp,     & 
& cplHhSMVZVZ,cplHpcHpVP,cplHpcHpVZ,cplHpcVWpVZ,cplsigacHapVWp,cplcHpVPVWp,              & 
& cplcVWpVPVWp,cplcHpVWpVZ,cplcVWpVWpVZ,cplAhcHpVWpVZ1,cplhhacHapVWpVZ1,cplHhSMcHpVWpVZ1,& 
& cplHpcHpVPVZ1,cplHpcHpcVWpVWp1,cplHpcHpVZVZ1,cplsigacHapVWpVZ1,cplcVWpVPVWpVZ3Q,       & 
& cplcVWpVPVWpVZ2Q,cplcVWpVPVWpVZ1Q,cplcVWpVWpVZVZ2Q,cplcVWpVWpVZVZ3Q,cplcVWpVWpVZVZ1Q,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHap,Mhha,MHhSM(3),MHp(3),Msiga,MVP,MVWp,MVZ,             & 
& MAh2(3),MFd2(3),MFe2(3),MFu2(3),MHap2,Mhha2,MHhSM2(3),MHp2(3),Msiga2,MVP2,             & 
& MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhHhSMVZ(3,3),cplAhHpcHp(3,3,3),cplAhcHpVWp(3,3),cplcFuFdVWpL(3,3),cplcFuFdVWpR(3,3),& 
& cplcFdFdVZL(3,3),cplcFdFdVZR(3,3),cplcFvFeVWpL(3,3),cplcFvFeVWpR(3,3),cplcFeFeVZL(3,3),& 
& cplcFeFeVZR(3,3),cplcFuFuVZL(3,3),cplcFuFuVZR(3,3),cplcFdFucHpL(3,3,3),cplcFdFucHpR(3,3,3),& 
& cplcFvFvVZL(3,3),cplcFvFvVZR(3,3),cplcFeFvcHpL(3,3,3),cplcFeFvcHpR(3,3,3),             & 
& cplcgWCgAcHp(3),cplcgWpgWpVZ,cplcgZgWpcHp(3),cplcgAgWCVWp,cplcgZgWCVWp,cplcgWCgWCVZ,   & 
& cplcgWpgZVWp,cplcgWCgZcHp(3),cplHaphhacHp(3),cplHapsigacHp(3),cplHapcHapVZ,            & 
& cplhhasigaVZ,cplhhacHapVWp,cplHhSMHpcHp(3,3,3),cplHhSMcHpVWp(3,3),cplHhSMcVWpVWp(3),   & 
& cplHhSMVZVZ(3),cplHpcHpVP(3,3),cplHpcHpVZ(3,3),cplHpcVWpVZ(3),cplsigacHapVWp,          & 
& cplcHpVPVWp(3),cplcVWpVPVWp,cplcHpVWpVZ(3),cplcVWpVWpVZ,cplAhcHpVWpVZ1(3,3),           & 
& cplhhacHapVWpVZ1,cplHhSMcHpVWpVZ1(3,3),cplHpcHpVPVZ1(3,3),cplHpcHpcVWpVWp1(3,3),       & 
& cplHpcHpVZVZ1(3,3),cplsigacHapVWpVZ1,cplcVWpVPVWpVZ3Q,cplcVWpVPVWpVZ2Q,cplcVWpVPVWpVZ1Q,& 
& cplcVWpVWpVZVZ2Q,cplcVWpVWpVZVZ3Q,cplcVWpVWpVZVZ1Q

Complex(dp), Intent(out) :: Amp(2,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
Amp(:,gt1) = 0._dp 
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MVZ 
Mex3 = MVWp 


! {Ah, conj[Hp], HhSM}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MAh(i1) 
ML2 = MHp(i2) 
ML3 = MHhSM(i3) 
coup1 = cplAhHpcHp(i1,i2,gt1)
coup2 = cplAhHhSMVZ(i1,i3)
coup3 = cplHhSMcHpVWp(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Ah, conj[VWp], HhSM}
Do i1=1,3
    Do i3=1,3
ML1 = MAh(i1) 
ML2 = MVWp 
ML3 = MHhSM(i3) 
coup1 = -cplAhcHpVWp(i1,gt1)
coup2 = cplAhHhSMVZ(i1,i3)
coup3 = cplHhSMcVWpVWp(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Fu, Fd, Fu}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFu(i1) 
ML2 = MFd(i2) 
ML3 = MFu(i3) 
coup1L = cplcFdFucHpL(i2,i1,gt1)
coup1R = cplcFdFucHpR(i2,i1,gt1)
coup2L = -cplcFuFuVZR(i1,i3)
coup2R = -cplcFuFuVZL(i1,i3)
coup3L = -cplcFuFdVWpR(i3,i2)
coup3R = -cplcFuFdVWpL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(3)*AmpC 
    End Do
  End Do
End Do


! {Fv, Fe, Fv}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = 0. 
ML2 = MFe(i2) 
ML3 = 0. 
coup1L = cplcFeFvcHpL(i2,i1,gt1)
coup1R = cplcFeFvcHpR(i2,i1,gt1)
coup2L = -cplcFvFvVZR(i1,i3)
coup2R = -cplcFvFvVZL(i1,i3)
coup3L = -cplcFvFeVWpR(i3,i2)
coup3R = -cplcFvFeVWpL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {gWp, gZ, gWp}
ML1 = MVWp 
ML2 = MVZ 
ML3 = MVWp 
coup1 = cplcgZgWpcHp(gt1)
coup2 = cplcgWpgWpVZ
coup3 = cplcgWpgZVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {Hap, hha, Hap}
ML1 = MHap 
ML2 = Mhha 
ML3 = MHap 
coup1 = cplHaphhacHp(gt1)
coup2 = -cplHapcHapVZ
coup3 = -cplhhacHapVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {Hap, siga, Hap}
ML1 = MHap 
ML2 = Msiga 
ML3 = MHap 
coup1 = cplHapsigacHp(gt1)
coup2 = -cplHapcHapVZ
coup3 = -cplsigacHapVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {hha, conj[Hap], siga}
ML1 = Mhha 
ML2 = MHap 
ML3 = Msiga 
coup1 = cplHaphhacHp(gt1)
coup2 = cplhhasigaVZ
coup3 = cplsigacHapVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {HhSM, conj[Hp], Ah}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHhSM(i1) 
ML2 = MHp(i2) 
ML3 = MAh(i3) 
coup1 = cplHhSMHpcHp(i1,i2,gt1)
coup2 = -cplAhHhSMVZ(i3,i1)
coup3 = cplAhcHpVWp(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {HhSM, conj[Hp], VZ}
Do i1=1,3
  Do i2=1,3
ML1 = MHhSM(i1) 
ML2 = MHp(i2) 
ML3 = MVZ 
coup1 = cplHhSMHpcHp(i1,i2,gt1)
coup2 = cplHhSMVZVZ(i1)
coup3 = cplcHpVWpVZ(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {HhSM, conj[VWp], VZ}
Do i1=1,3
ML1 = MHhSM(i1) 
ML2 = MVWp 
ML3 = MVZ 
coup1 = -cplHhSMcHpVWp(i1,gt1)
coup2 = cplHhSMVZVZ(i1)
coup3 = -cplcVWpVWpVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
End Do


! {Hp, Ah, Hp}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MAh(i2) 
ML3 = MHp(i3) 
coup1 = cplAhHpcHp(i2,i1,gt1)
coup2 = -cplHpcHpVZ(i3,i1)
coup3 = -cplAhcHpVWp(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Hp, HhSM, Hp}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MHhSM(i2) 
ML3 = MHp(i3) 
coup1 = cplHhSMHpcHp(i2,i1,gt1)
coup2 = -cplHpcHpVZ(i3,i1)
coup3 = -cplHhSMcHpVWp(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Hp, VP, Hp}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVP 
ML3 = MHp(i3) 
coup1 = -cplHpcHpVP(i1,gt1)
coup2 = -cplHpcHpVZ(i3,i1)
coup3 = cplcHpVPVWp(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, VZ, Hp}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVZ 
ML3 = MHp(i3) 
coup1 = -cplHpcHpVZ(i1,gt1)
coup2 = -cplHpcHpVZ(i3,i1)
coup3 = cplcHpVWpVZ(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, HhSM, VWp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHhSM(i2) 
ML3 = MVWp 
coup1 = cplHhSMHpcHp(i2,i1,gt1)
coup2 = cplcHpVWpVZ(i1)
coup3 = cplHhSMcVWpVWp(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, VP, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVP 
ML3 = MVWp 
coup1 = -cplHpcHpVP(i1,gt1)
coup2 = cplcHpVWpVZ(i1)
coup3 = -cplcVWpVPVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
End Do


! {Hp, VZ, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVZ 
ML3 = MVWp 
coup1 = -cplHpcHpVZ(i1,gt1)
coup2 = cplcHpVWpVZ(i1)
coup3 = cplcVWpVWpVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
End Do


! {siga, conj[Hap], hha}
ML1 = Msiga 
ML2 = MHap 
ML3 = Mhha 
coup1 = cplHapsigacHp(gt1)
coup2 = -cplhhasigaVZ
coup3 = cplhhacHapVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {VWp, Ah, Hp}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MAh(i2) 
ML3 = MHp(i3) 
coup1 = -cplAhcHpVWp(i2,gt1)
coup2 = cplHpcVWpVZ(i3)
coup3 = -cplAhcHpVWp(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VWp, HhSM, Hp}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHhSM(i2) 
ML3 = MHp(i3) 
coup1 = -cplHhSMcHpVWp(i2,gt1)
coup2 = cplHpcVWpVZ(i3)
coup3 = -cplHhSMcHpVWp(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VWp, VP, Hp}
    Do i3=1,3
ML1 = MVWp 
ML2 = MVP 
ML3 = MHp(i3) 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplHpcVWpVZ(i3)
coup3 = cplcHpVPVWp(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do


! {VWp, VZ, Hp}
    Do i3=1,3
ML1 = MVWp 
ML2 = MVZ 
ML3 = MHp(i3) 
coup1 = cplcHpVWpVZ(gt1)
coup2 = cplHpcVWpVZ(i3)
coup3 = cplcHpVWpVZ(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do


! {VWp, HhSM, VWp}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHhSM(i2) 
ML3 = MVWp 
coup1 = -cplHhSMcHpVWp(i2,gt1)
coup2 = -cplcVWpVWpVZ
coup3 = cplHhSMcVWpVWp(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
  End Do


! {VWp, VP, VWp}
ML1 = MVWp 
ML2 = MVP 
ML3 = MVWp 
coup1 = cplcHpVPVWp(gt1)
coup2 = -cplcVWpVWpVZ
coup3 = -cplcVWpVPVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {VWp, VZ, VWp}
ML1 = MVWp 
ML2 = MVZ 
ML3 = MVWp 
coup1 = cplcHpVWpVZ(gt1)
coup2 = -cplcVWpVWpVZ
coup3 = cplcVWpVWpVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {VZ, conj[Hp], HhSM}
  Do i2=1,3
    Do i3=1,3
ML1 = MVZ 
ML2 = MHp(i2) 
ML3 = MHhSM(i3) 
coup1 = -cplHpcHpVZ(i2,gt1)
coup2 = cplHhSMVZVZ(i3)
coup3 = cplHhSMcHpVWp(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VZ, conj[VWp], HhSM}
    Do i3=1,3
ML1 = MVZ 
ML2 = MVWp 
ML3 = MHhSM(i3) 
coup1 = cplcHpVWpVZ(gt1)
coup2 = cplHhSMVZVZ(i3)
coup3 = cplHhSMcVWpVWp(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do


! {bar[Fd], bar[Fu], bar[Fd]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFd(i1) 
ML2 = MFu(i2) 
ML3 = MFd(i3) 
coup1L = cplcFdFucHpL(i1,i2,gt1)
coup1R = cplcFdFucHpR(i1,i2,gt1)
coup2L = cplcFdFdVZL(i3,i1)
coup2R = cplcFdFdVZR(i3,i1)
coup3L = cplcFuFdVWpL(i2,i3)
coup3R = cplcFuFdVWpR(i2,i3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(3)*AmpC 
    End Do
  End Do
End Do


! {bar[Fe], bar[Fv], bar[Fe]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFe(i1) 
ML2 = 0. 
ML3 = MFe(i3) 
coup1L = cplcFeFvcHpL(i1,i2,gt1)
coup1R = cplcFeFvcHpR(i1,i2,gt1)
coup2L = cplcFeFeVZL(i3,i1)
coup2R = cplcFeFeVZR(i3,i1)
coup3L = cplcFvFeVWpL(i2,i3)
coup3R = cplcFvFeVWpR(i2,i3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {bar[gWpC], bar[gP], bar[gWpC]}
ML1 = MVWp 
ML2 = MVP 
ML3 = MVWp 
coup1 = cplcgWCgAcHp(gt1)
coup2 = cplcgWCgWCVZ
coup3 = cplcgAgWCVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {bar[gWpC], bar[gZ], bar[gWpC]}
ML1 = MVWp 
ML2 = MVZ 
ML3 = MVWp 
coup1 = cplcgWCgZcHp(gt1)
coup2 = cplcgWCgWCVZ
coup3 = cplcgZgWCVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {Ah, conj[Hp]}
Do i1=1,3
  Do i2=1,3
ML1 = MAh(i1) 
ML2 = MHp(i2) 
coup1 = cplAhHpcHp(i1,i2,gt1)
coup2 = cplAhcHpVWpVZ1(i1,i2)
Call Amp_VERTEX_StoVV_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hap, hha}
ML1 = MHap 
ML2 = Mhha 
coup1 = cplHaphhacHp(gt1)
coup2 = cplhhacHapVWpVZ1
Call Amp_VERTEX_StoVV_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {Hap, siga}
ML1 = MHap 
ML2 = Msiga 
coup1 = cplHapsigacHp(gt1)
coup2 = cplsigacHapVWpVZ1
Call Amp_VERTEX_StoVV_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {HhSM, conj[Hp]}
Do i1=1,3
  Do i2=1,3
ML1 = MHhSM(i1) 
ML2 = MHp(i2) 
coup1 = cplHhSMHpcHp(i1,i2,gt1)
coup2 = cplHhSMcHpVWpVZ1(i1,i2)
Call Amp_VERTEX_StoVV_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {VP, conj[VWp]}
ML1 = MVP 
ML2 = MVWp 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplcVWpVPVWpVZ1Q
coup2a = coup2 
coup2 = cplcVWpVPVWpVZ2Q
coup2b = coup2 
coup2 = cplcVWpVPVWpVZ3Q
coup2c = coup2 
If (Abs(coup1)*(Abs(coup2a)+Abs(coup2b)+Abs(coup2c)) .gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology2_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2a,coup2b,coup2c,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {VWp, VZ}
ML1 = MVWp 
ML2 = MVZ 
coup1 = cplcHpVWpVZ(gt1)
coup2 = cplcVWpVWpVZVZ1Q
coup2c = coup2 
coup2 = cplcVWpVWpVZVZ2Q
coup2b = coup2 
coup2 = cplcVWpVWpVZVZ3Q
coup2a = coup2 
If (Abs(coup1)*(Abs(coup2a)+Abs(coup2b)+Abs(coup2c)) .gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology2_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2a,coup2b,coup2c,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {HhSM, VZ}
Do i1=1,3
ML1 = MHhSM(i1) 
ML2 = MVZ 
coup1 = cplHhSMcHpVWpVZ1(i1,gt1)
coup2 = cplHhSMVZVZ(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology3_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 

End Do


! {Hp, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
coup1 = cplHpcHpcVWpVWp1(i1,gt1)
coup2 = cplcHpVWpVZ(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology3_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 

End Do


! {HhSM, conj[VWp]}
Do i1=1,3
ML1 = MHhSM(i1) 
ML2 = MVWp 
coup1 = cplHhSMcHpVWpVZ1(i1,gt1)
coup2 = cplHhSMcVWpVWp(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology4_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 

End Do


! {Hp, VP}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVP 
coup1 = cplHpcHpVPVZ1(i1,gt1)
coup2 = cplcHpVPVWp(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology4_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 

End Do


! {Hp, VZ}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVZ 
coup1 = cplHpcHpVZVZ1(i1,gt1)
coup2 = cplcHpVWpVZ(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology4_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 

End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_HpToVZVWp


Subroutine Amplitude_IR_VERTEX_4HDM_S3_HpToVZVWp(MAh,MFd,MFe,MFu,MHap,Mhha,           & 
& MHhSM,MHp,Msiga,MVP,MVWp,MVZ,MAh2,MFd2,MFe2,MFu2,MHap2,Mhha2,MHhSM2,MHp2,              & 
& Msiga2,MVP2,MVWp2,MVZ2,cplAhHhSMVZ,cplAhHpcHp,cplAhcHpVWp,cplcFuFdVWpL,cplcFuFdVWpR,   & 
& cplcFdFdVZL,cplcFdFdVZR,cplcFvFeVWpL,cplcFvFeVWpR,cplcFeFeVZL,cplcFeFeVZR,             & 
& cplcFuFuVZL,cplcFuFuVZR,cplcFdFucHpL,cplcFdFucHpR,cplcFvFvVZL,cplcFvFvVZR,             & 
& cplcFeFvcHpL,cplcFeFvcHpR,cplcgWCgAcHp,cplcgWpgWpVZ,cplcgZgWpcHp,cplcgAgWCVWp,         & 
& cplcgZgWCVWp,cplcgWCgWCVZ,cplcgWpgZVWp,cplcgWCgZcHp,cplHaphhacHp,cplHapsigacHp,        & 
& cplHapcHapVZ,cplhhasigaVZ,cplhhacHapVWp,cplHhSMHpcHp,cplHhSMcHpVWp,cplHhSMcVWpVWp,     & 
& cplHhSMVZVZ,cplHpcHpVP,cplHpcHpVZ,cplHpcVWpVZ,cplsigacHapVWp,cplcHpVPVWp,              & 
& cplcVWpVPVWp,cplcHpVWpVZ,cplcVWpVWpVZ,cplAhcHpVWpVZ1,cplhhacHapVWpVZ1,cplHhSMcHpVWpVZ1,& 
& cplHpcHpVPVZ1,cplHpcHpcVWpVWp1,cplHpcHpVZVZ1,cplsigacHapVWpVZ1,cplcVWpVPVWpVZ3Q,       & 
& cplcVWpVPVWpVZ2Q,cplcVWpVPVWpVZ1Q,cplcVWpVWpVZVZ2Q,cplcVWpVWpVZVZ3Q,cplcVWpVWpVZVZ1Q,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHap,Mhha,MHhSM(3),MHp(3),Msiga,MVP,MVWp,MVZ,             & 
& MAh2(3),MFd2(3),MFe2(3),MFu2(3),MHap2,Mhha2,MHhSM2(3),MHp2(3),Msiga2,MVP2,             & 
& MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhHhSMVZ(3,3),cplAhHpcHp(3,3,3),cplAhcHpVWp(3,3),cplcFuFdVWpL(3,3),cplcFuFdVWpR(3,3),& 
& cplcFdFdVZL(3,3),cplcFdFdVZR(3,3),cplcFvFeVWpL(3,3),cplcFvFeVWpR(3,3),cplcFeFeVZL(3,3),& 
& cplcFeFeVZR(3,3),cplcFuFuVZL(3,3),cplcFuFuVZR(3,3),cplcFdFucHpL(3,3,3),cplcFdFucHpR(3,3,3),& 
& cplcFvFvVZL(3,3),cplcFvFvVZR(3,3),cplcFeFvcHpL(3,3,3),cplcFeFvcHpR(3,3,3),             & 
& cplcgWCgAcHp(3),cplcgWpgWpVZ,cplcgZgWpcHp(3),cplcgAgWCVWp,cplcgZgWCVWp,cplcgWCgWCVZ,   & 
& cplcgWpgZVWp,cplcgWCgZcHp(3),cplHaphhacHp(3),cplHapsigacHp(3),cplHapcHapVZ,            & 
& cplhhasigaVZ,cplhhacHapVWp,cplHhSMHpcHp(3,3,3),cplHhSMcHpVWp(3,3),cplHhSMcVWpVWp(3),   & 
& cplHhSMVZVZ(3),cplHpcHpVP(3,3),cplHpcHpVZ(3,3),cplHpcVWpVZ(3),cplsigacHapVWp,          & 
& cplcHpVPVWp(3),cplcVWpVPVWp,cplcHpVWpVZ(3),cplcVWpVWpVZ,cplAhcHpVWpVZ1(3,3),           & 
& cplhhacHapVWpVZ1,cplHhSMcHpVWpVZ1(3,3),cplHpcHpVPVZ1(3,3),cplHpcHpcVWpVWp1(3,3),       & 
& cplHpcHpVZVZ1(3,3),cplsigacHapVWpVZ1,cplcVWpVPVWpVZ3Q,cplcVWpVPVWpVZ2Q,cplcVWpVPVWpVZ1Q,& 
& cplcVWpVWpVZVZ2Q,cplcVWpVWpVZVZ3Q,cplcVWpVWpVZVZ1Q

Complex(dp), Intent(out) :: Amp(2,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
Amp(:,gt1) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MVZ 
Mex3 = MVWp 


! {Hp, VP, Hp}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVP 
ML3 = MHp(i3) 
coup1 = -cplHpcHpVP(i1,gt1)
coup2 = -cplHpcHpVZ(i3,i1)
coup3 = cplcHpVPVWp(i3)
Call Amp_VERTEX_StoVV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, VP, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVP 
ML3 = MVWp 
coup1 = -cplHpcHpVP(i1,gt1)
coup2 = cplcHpVWpVZ(i1)
coup3 = -cplcVWpVPVWp
Call Amp_VERTEX_StoVV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
End Do


! {VWp, VP, Hp}
    Do i3=1,3
ML1 = MVWp 
ML2 = MVP 
ML3 = MHp(i3) 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplHpcVWpVZ(i3)
coup3 = cplcHpVPVWp(i3)
Call Amp_VERTEX_StoVV_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do


! {VWp, VP, VWp}
ML1 = MVWp 
ML2 = MVP 
ML3 = MVWp 
coup1 = cplcHpVPVWp(gt1)
coup2 = -cplcVWpVWpVZ
coup3 = -cplcVWpVPVWp
Call Amp_VERTEX_StoVV_Topology1_VVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {VP, conj[VWp]}
ML1 = MVP 
ML2 = MVWp 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplcVWpVPVWpVZ1Q
coup2a = coup2 
coup2 = cplcVWpVPVWpVZ2Q
coup2b = coup2 
coup2 = cplcVWpVPVWpVZ3Q
coup2c = coup2 
Call Amp_VERTEX_StoVV_Topology2_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2a,coup2b,coup2c,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {Hp, VP}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVP 
coup1 = cplHpcHpVPVZ1(i1,gt1)
coup2 = cplcHpVPVWp(i1)
Call Amp_VERTEX_StoVV_Topology4_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 

End Do
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_HpToVZVWp


Subroutine Amplitude_WAVE_4HDM_S3_HpToHpVP(cplHpcHpVP,cplHpcHpVZ,ctcplHpcHpVP,        & 
& ctcplHpcHpVZ,MHp,MHp2,MVP,MVP2,ZfHp,ZfVP,ZfVZVP,Amp)

Implicit None

Real(dp), Intent(in) :: MHp(3),MHp2(3),MVP,MVP2

Complex(dp), Intent(in) :: cplHpcHpVP(3,3),cplHpcHpVZ(3,3)

Complex(dp), Intent(in) :: ctcplHpcHpVP(3,3),ctcplHpcHpVZ(3,3)

Complex(dp), Intent(in) :: ZfHp(3,3),ZfVP,ZfVZVP

Complex(dp), Intent(out) :: Amp(2,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
  Do gt2=1,3
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MHp(gt2) 
Mex3 = MVP 
ZcoupT1 = 0._dp 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
Do i1=1,3
ZcoupT1 = ZcoupT1 + 0.5_dp*Conjg(ZfHp(i1,gt1))*cplHpcHpVP(gt2,i1)
End Do


! External Field 2 
Do i1=1,3
ZcoupT1 = ZcoupT1 + 0.5_dp*ZfHp(i1,gt2)*cplHpcHpVP(i1,gt1)
End Do


! External Field 3 
ZcoupT1 = ZcoupT1 + 0.5_dp*ZfVZVP*cplHpcHpVZ(gt2,gt1)


! Getting the amplitude 
Call TreeAmp_StoSV(Mex1,Mex2,Mex3,-ZcoupT1,AmpC) 
Amp(:,gt1, gt2) = AmpC 
  End Do
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_HpToHpVP


Subroutine Amplitude_VERTEX_4HDM_S3_HpToHpVP(MAh,MFd,MFe,MFu,MHap,Mhha,               & 
& MHhSM,MHp,Msiga,MVP,MVWp,MVZ,MAh2,MFd2,MFe2,MFu2,MHap2,Mhha2,MHhSM2,MHp2,              & 
& Msiga2,MVP2,MVWp2,MVZ2,cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplcFuFdHpL,cplcFuFdHpR,     & 
& cplcFdFdVPL,cplcFdFdVPR,cplcFvFeHpL,cplcFvFeHpR,cplcFeFeVPL,cplcFeFeVPR,               & 
& cplcFuFuVPL,cplcFuFuVPR,cplcFdFucHpL,cplcFdFucHpR,cplcFeFvcHpL,cplcFeFvcHpR,           & 
& cplcgWpgWpVP,cplcgZgWpcHp,cplcgZgWCHp,cplcgWCgWCVP,cplcgWpgZHp,cplcgWCgZcHp,           & 
& cplHaphhacHp,cplHapsigacHp,cplHapcHapVP,cplhhaHpcHap,cplHhSMHpcHp,cplHhSMHpcVWp,       & 
& cplHhSMcHpVWp,cplHpsigacHap,cplHpcHpVP,cplHpcVWpVP,cplHpcHpVZ,cplHpcVWpVZ,             & 
& cplcHpVPVWp,cplcVWpVPVWp,cplcHpVWpVZ,cplAhHpcVWpVP1,cplAhcHpVPVWp1,cplHhSMHpcVWpVP1,   & 
& cplHhSMcHpVPVWp1,cplHpcHpVPVP1,cplHpcHpVPVZ1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHap,Mhha,MHhSM(3),MHp(3),Msiga,MVP,MVWp,MVZ,             & 
& MAh2(3),MFd2(3),MFe2(3),MFu2(3),MHap2,Mhha2,MHhSM2(3),MHp2(3),Msiga2,MVP2,             & 
& MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),cplAhcHpVWp(3,3),cplcFuFdHpL(3,3,3),               & 
& cplcFuFdHpR(3,3,3),cplcFdFdVPL(3,3),cplcFdFdVPR(3,3),cplcFvFeHpL(3,3,3),               & 
& cplcFvFeHpR(3,3,3),cplcFeFeVPL(3,3),cplcFeFeVPR(3,3),cplcFuFuVPL(3,3),cplcFuFuVPR(3,3),& 
& cplcFdFucHpL(3,3,3),cplcFdFucHpR(3,3,3),cplcFeFvcHpL(3,3,3),cplcFeFvcHpR(3,3,3),       & 
& cplcgWpgWpVP,cplcgZgWpcHp(3),cplcgZgWCHp(3),cplcgWCgWCVP,cplcgWpgZHp(3),               & 
& cplcgWCgZcHp(3),cplHaphhacHp(3),cplHapsigacHp(3),cplHapcHapVP,cplhhaHpcHap(3),         & 
& cplHhSMHpcHp(3,3,3),cplHhSMHpcVWp(3,3),cplHhSMcHpVWp(3,3),cplHpsigacHap(3),            & 
& cplHpcHpVP(3,3),cplHpcVWpVP(3),cplHpcHpVZ(3,3),cplHpcVWpVZ(3),cplcHpVPVWp(3),          & 
& cplcVWpVPVWp,cplcHpVWpVZ(3),cplAhHpcVWpVP1(3,3),cplAhcHpVPVWp1(3,3),cplHhSMHpcVWpVP1(3,3),& 
& cplHhSMcHpVPVWp1(3,3),cplHpcHpVPVP1(3,3),cplHpcHpVPVZ1(3,3)

Complex(dp), Intent(out) :: Amp(2,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
Amp(:,gt1, gt2) = 0._dp 
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MHp(gt2) 
Mex3 = MVP 


! {Ah, conj[Hp], conj[Hp]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MAh(i1) 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplAhHpcHp(i1,i2,gt1)
coup2 = cplAhHpcHp(i1,gt2,i3)
coup3 = cplHpcHpVP(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Ah, conj[VWp], conj[Hp]}
Do i1=1,3
    Do i3=1,3
ML1 = MAh(i1) 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = cplAhcHpVWp(i1,gt1)
coup2 = cplAhHpcHp(i1,gt2,i3)
coup3 = cplHpcVWpVP(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Ah, conj[Hp], conj[VWp]}
Do i1=1,3
  Do i2=1,3
ML1 = MAh(i1) 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplAhHpcHp(i1,i2,gt1)
coup2 = -cplAhHpcVWp(i1,gt2)
coup3 = cplcHpVPVWp(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Ah, conj[VWp], conj[VWp]}
Do i1=1,3
ML1 = MAh(i1) 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplAhcHpVWp(i1,gt1)
coup2 = -cplAhHpcVWp(i1,gt2)
coup3 = -cplcVWpVPVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {Fu, Fd, Fd}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFu(i1) 
ML2 = MFd(i2) 
ML3 = MFd(i3) 
coup1L = cplcFdFucHpL(i2,i1,gt1)
coup1R = cplcFdFucHpR(i2,i1,gt1)
coup2L = cplcFuFdHpL(i1,i3,gt2)
coup2R = cplcFuFdHpR(i1,i3,gt2)
coup3L = -cplcFdFdVPR(i3,i2)
coup3R = -cplcFdFdVPL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(3)*AmpC 
    End Do
  End Do
End Do


! {Fv, Fe, Fe}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = 0. 
ML2 = MFe(i2) 
ML3 = MFe(i3) 
coup1L = cplcFeFvcHpL(i2,i1,gt1)
coup1R = cplcFeFvcHpR(i2,i1,gt1)
coup2L = cplcFvFeHpL(i1,i3,gt2)
coup2R = cplcFvFeHpR(i1,i3,gt2)
coup3L = -cplcFeFeVPR(i3,i2)
coup3R = -cplcFeFeVPL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {gZ, gWpC, gWpC}
ML1 = MVZ 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcgWCgZcHp(gt1)
coup2 = cplcgZgWCHp(gt2)
coup3 = cplcgWCgWCVP
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {hha, conj[Hap], conj[Hap]}
ML1 = Mhha 
ML2 = MHap 
ML3 = MHap 
coup1 = cplHaphhacHp(gt1)
coup2 = cplhhaHpcHap(gt2)
coup3 = cplHapcHapVP
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {HhSM, conj[Hp], conj[Hp]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHhSM(i1) 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplHhSMHpcHp(i1,i2,gt1)
coup2 = cplHhSMHpcHp(i1,gt2,i3)
coup3 = cplHpcHpVP(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {HhSM, conj[VWp], conj[Hp]}
Do i1=1,3
    Do i3=1,3
ML1 = MHhSM(i1) 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = cplHhSMcHpVWp(i1,gt1)
coup2 = cplHhSMHpcHp(i1,gt2,i3)
coup3 = cplHpcVWpVP(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {HhSM, conj[Hp], conj[VWp]}
Do i1=1,3
  Do i2=1,3
ML1 = MHhSM(i1) 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplHhSMHpcHp(i1,i2,gt1)
coup2 = -cplHhSMHpcVWp(i1,gt2)
coup3 = cplcHpVPVWp(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {HhSM, conj[VWp], conj[VWp]}
Do i1=1,3
ML1 = MHhSM(i1) 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplHhSMcHpVWp(i1,gt1)
coup2 = -cplHhSMHpcVWp(i1,gt2)
coup3 = -cplcVWpVPVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {siga, conj[Hap], conj[Hap]}
ML1 = Msiga 
ML2 = MHap 
ML3 = MHap 
coup1 = cplHapsigacHp(gt1)
coup2 = cplHpsigacHap(gt2)
coup3 = cplHapcHapVP
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {VP, conj[Hp], conj[Hp]}
  Do i2=1,3
    Do i3=1,3
ML1 = MVP 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplHpcHpVP(i2,gt1)
coup2 = cplHpcHpVP(gt2,i3)
coup3 = cplHpcHpVP(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VP, conj[VWp], conj[Hp]}
    Do i3=1,3
ML1 = MVP 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplHpcHpVP(gt2,i3)
coup3 = cplHpcVWpVP(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do


! {VP, conj[Hp], conj[VWp]}
  Do i2=1,3
ML1 = MVP 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplHpcHpVP(i2,gt1)
coup2 = cplHpcVWpVP(gt2)
coup3 = cplcHpVPVWp(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do


! {VP, conj[VWp], conj[VWp]}
ML1 = MVP 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplHpcVWpVP(gt2)
coup3 = -cplcVWpVPVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {VZ, conj[Hp], conj[Hp]}
  Do i2=1,3
    Do i3=1,3
ML1 = MVZ 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplHpcHpVZ(i2,gt1)
coup2 = cplHpcHpVZ(gt2,i3)
coup3 = cplHpcHpVP(i3,i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VZ, conj[VWp], conj[Hp]}
    Do i3=1,3
ML1 = MVZ 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = cplcHpVWpVZ(gt1)
coup2 = cplHpcHpVZ(gt2,i3)
coup3 = cplHpcVWpVP(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do


! {VZ, conj[Hp], conj[VWp]}
  Do i2=1,3
ML1 = MVZ 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplHpcHpVZ(i2,gt1)
coup2 = cplHpcVWpVZ(gt2)
coup3 = cplcHpVPVWp(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do


! {VZ, conj[VWp], conj[VWp]}
ML1 = MVZ 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcHpVWpVZ(gt1)
coup2 = cplHpcVWpVZ(gt2)
coup3 = -cplcVWpVPVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_VVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {bar[Fd], bar[Fu], bar[Fu]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFd(i1) 
ML2 = MFu(i2) 
ML3 = MFu(i3) 
coup1L = cplcFdFucHpL(i1,i2,gt1)
coup1R = cplcFdFucHpR(i1,i2,gt1)
coup2L = cplcFuFdHpL(i3,i1,gt2)
coup2R = cplcFuFdHpR(i3,i1,gt2)
coup3L = cplcFuFuVPL(i2,i3)
coup3R = cplcFuFuVPR(i2,i3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(3)*AmpC 
    End Do
  End Do
End Do


! {bar[gZ], bar[gWp], bar[gWp]}
ML1 = MVZ 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcgZgWpcHp(gt1)
coup2 = cplcgWpgZHp(gt2)
coup3 = cplcgWpgWpVP
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {Ah, conj[VWp]}
Do i1=1,3
ML1 = MAh(i1) 
ML2 = MVWp 
coup1 = -cplAhcHpVWp(i1,gt1)
coup2 = cplAhHpcVWpVP1(i1,gt2)
Call Amp_VERTEX_StoSV_Topology2_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {HhSM, conj[VWp]}
Do i1=1,3
ML1 = MHhSM(i1) 
ML2 = MVWp 
coup1 = -cplHhSMcHpVWp(i1,gt1)
coup2 = cplHhSMHpcVWpVP1(i1,gt2)
Call Amp_VERTEX_StoSV_Topology2_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {Hp, VP}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVP 
coup1 = -cplHpcHpVP(i1,gt1)
coup2 = cplHpcHpVPVP1(gt2,i1)
Call Amp_VERTEX_StoSV_Topology2_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {Hp, VZ}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVZ 
coup1 = -cplHpcHpVZ(i1,gt1)
coup2 = cplHpcHpVPVZ1(gt2,i1)
Call Amp_VERTEX_StoSV_Topology2_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {Ah, conj[VWp]}
Do i1=1,3
ML1 = MAh(i1) 
ML2 = MVWp 
coup1 = cplAhcHpVPVWp1(i1,gt1)
coup2 = -cplAhHpcVWp(i1,gt2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology3_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 

End Do


! {HhSM, conj[VWp]}
Do i1=1,3
ML1 = MHhSM(i1) 
ML2 = MVWp 
coup1 = cplHhSMcHpVPVWp1(i1,gt1)
coup2 = -cplHhSMHpcVWp(i1,gt2)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology3_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 

End Do


! {Hp, VP}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVP 
coup1 = cplHpcHpVPVP1(i1,gt1)
coup2 = cplHpcHpVP(gt2,i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology3_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 

End Do


! {Hp, VZ}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVZ 
coup1 = cplHpcHpVPVZ1(i1,gt1)
coup2 = cplHpcHpVZ(gt2,i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoSV_Topology3_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 

End Do
  End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_HpToHpVP


Subroutine Amplitude_IR_VERTEX_4HDM_S3_HpToHpVP(MAh,MFd,MFe,MFu,MHap,Mhha,            & 
& MHhSM,MHp,Msiga,MVP,MVWp,MVZ,MAh2,MFd2,MFe2,MFu2,MHap2,Mhha2,MHhSM2,MHp2,              & 
& Msiga2,MVP2,MVWp2,MVZ2,cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplcFuFdHpL,cplcFuFdHpR,     & 
& cplcFdFdVPL,cplcFdFdVPR,cplcFvFeHpL,cplcFvFeHpR,cplcFeFeVPL,cplcFeFeVPR,               & 
& cplcFuFuVPL,cplcFuFuVPR,cplcFdFucHpL,cplcFdFucHpR,cplcFeFvcHpL,cplcFeFvcHpR,           & 
& cplcgWpgWpVP,cplcgZgWpcHp,cplcgZgWCHp,cplcgWCgWCVP,cplcgWpgZHp,cplcgWCgZcHp,           & 
& cplHaphhacHp,cplHapsigacHp,cplHapcHapVP,cplhhaHpcHap,cplHhSMHpcHp,cplHhSMHpcVWp,       & 
& cplHhSMcHpVWp,cplHpsigacHap,cplHpcHpVP,cplHpcVWpVP,cplHpcHpVZ,cplHpcVWpVZ,             & 
& cplcHpVPVWp,cplcVWpVPVWp,cplcHpVWpVZ,cplAhHpcVWpVP1,cplAhcHpVPVWp1,cplHhSMHpcVWpVP1,   & 
& cplHhSMcHpVPVWp1,cplHpcHpVPVP1,cplHpcHpVPVZ1,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHap,Mhha,MHhSM(3),MHp(3),Msiga,MVP,MVWp,MVZ,             & 
& MAh2(3),MFd2(3),MFe2(3),MFu2(3),MHap2,Mhha2,MHhSM2(3),MHp2(3),Msiga2,MVP2,             & 
& MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhHpcHp(3,3,3),cplAhHpcVWp(3,3),cplAhcHpVWp(3,3),cplcFuFdHpL(3,3,3),               & 
& cplcFuFdHpR(3,3,3),cplcFdFdVPL(3,3),cplcFdFdVPR(3,3),cplcFvFeHpL(3,3,3),               & 
& cplcFvFeHpR(3,3,3),cplcFeFeVPL(3,3),cplcFeFeVPR(3,3),cplcFuFuVPL(3,3),cplcFuFuVPR(3,3),& 
& cplcFdFucHpL(3,3,3),cplcFdFucHpR(3,3,3),cplcFeFvcHpL(3,3,3),cplcFeFvcHpR(3,3,3),       & 
& cplcgWpgWpVP,cplcgZgWpcHp(3),cplcgZgWCHp(3),cplcgWCgWCVP,cplcgWpgZHp(3),               & 
& cplcgWCgZcHp(3),cplHaphhacHp(3),cplHapsigacHp(3),cplHapcHapVP,cplhhaHpcHap(3),         & 
& cplHhSMHpcHp(3,3,3),cplHhSMHpcVWp(3,3),cplHhSMcHpVWp(3,3),cplHpsigacHap(3),            & 
& cplHpcHpVP(3,3),cplHpcVWpVP(3),cplHpcHpVZ(3,3),cplHpcVWpVZ(3),cplcHpVPVWp(3),          & 
& cplcVWpVPVWp,cplcHpVWpVZ(3),cplAhHpcVWpVP1(3,3),cplAhcHpVPVWp1(3,3),cplHhSMHpcVWpVP1(3,3),& 
& cplHhSMcHpVPVWp1(3,3),cplHpcHpVPVP1(3,3),cplHpcHpVPVZ1(3,3)

Complex(dp), Intent(out) :: Amp(2,3,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
  Do gt2=1,3
Amp(:,gt1, gt2) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MHp(gt2) 
Mex3 = MVP 


! {VP, conj[Hp], conj[Hp]}
  Do i2=1,3
    Do i3=1,3
ML1 = MVP 
ML2 = MHp(i2) 
ML3 = MHp(i3) 
coup1 = cplHpcHpVP(i2,gt1)
coup2 = cplHpcHpVP(gt2,i3)
coup3 = cplHpcHpVP(i3,i2)
Call Amp_VERTEX_StoSV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VP, conj[VWp], conj[Hp]}
    Do i3=1,3
ML1 = MVP 
ML2 = MVWp 
ML3 = MHp(i3) 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplHpcHpVP(gt2,i3)
coup3 = cplHpcVWpVP(i3)
Call Amp_VERTEX_StoSV_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
    End Do


! {VP, conj[Hp], conj[VWp]}
  Do i2=1,3
ML1 = MVP 
ML2 = MHp(i2) 
ML3 = MVWp 
coup1 = cplHpcHpVP(i2,gt1)
coup2 = cplHpcVWpVP(gt2)
coup3 = cplcHpVPVWp(i2)
Call Amp_VERTEX_StoSV_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
  End Do


! {VP, conj[VWp], conj[VWp]}
ML1 = MVP 
ML2 = MVWp 
ML3 = MVWp 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplHpcVWpVP(gt2)
coup3 = -cplcVWpVPVWp
Call Amp_VERTEX_StoSV_Topology1_VVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 


! {Hp, VP}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVP 
coup1 = -cplHpcHpVP(i1,gt1)
coup2 = cplHpcHpVPVP1(gt2,i1)
Call Amp_VERTEX_StoSV_Topology2_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 
End Do


! {Hp, VP}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVP 
coup1 = cplHpcHpVPVP1(i1,gt1)
coup2 = cplHpcHpVP(gt2,i1)
Call Amp_VERTEX_StoSV_Topology3_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1, gt2) = Amp(:,gt1, gt2) + oo16pi2*(1)*AmpC 

End Do
  End Do
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_HpToHpVP


Subroutine Amplitude_WAVE_4HDM_S3_HpToVPVWp(cplcHpVPVWp,cplcHpVWpVZ,ctcplcHpVPVWp,    & 
& ctcplcHpVWpVZ,MHp,MHp2,MVP,MVP2,MVWp,MVWp2,ZfHp,ZfVP,ZfVWp,Amp)

Implicit None

Real(dp), Intent(in) :: MHp(3),MHp2(3),MVP,MVP2,MVWp,MVWp2

Complex(dp), Intent(in) :: cplcHpVPVWp(3),cplcHpVWpVZ(3)

Complex(dp), Intent(in) :: ctcplcHpVPVWp(3),ctcplcHpVWpVZ(3)

Complex(dp), Intent(in) :: ZfHp(3,3),ZfVP,ZfVWp

Complex(dp), Intent(out) :: Amp(2,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Complex(dp) :: coupT1, coupT1L, coupT1R 
Complex(dp) :: TcoupT1, TcoupT1L, TcoupT1R 
Complex(dp) :: ZcoupT1, ZcoupT1L, ZcoupT1R 

Do gt1=1,3
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MVP 
Mex3 = MVWp 
!----------------------------- 
! Coupling counter term 
!----------------------------- 
ZcoupT1 = ctcplcHpVPVWp(gt1) 
!----------------------------- 
! Multiply Z-factors 
!----------------------------- 
! External Field 1 
Do i1=1,3
ZcoupT1 = ZcoupT1 + 0.5_dp*Conjg(ZfHp(i1,gt1))*cplcHpVPVWp(i1)
End Do


! External Field 2 
ZcoupT1 = ZcoupT1 + 0.5_dp*ZfVP*cplcHpVPVWp(gt1)


! External Field 3 
ZcoupT1 = ZcoupT1 + 0.5_dp*ZfVWp*cplcHpVPVWp(gt1)


! Getting the amplitude 
Call TreeAmp_StoVV(Mex1,Mex2,Mex3,ZcoupT1,AmpC) 
Amp(:,gt1) = AmpC 
End Do
End Subroutine Amplitude_WAVE_4HDM_S3_HpToVPVWp


Subroutine Amplitude_VERTEX_4HDM_S3_HpToVPVWp(MAh,MFd,MFe,MFu,MHap,Mhha,              & 
& MHhSM,MHp,Msiga,MVP,MVWp,MVZ,MAh2,MFd2,MFe2,MFu2,MHap2,Mhha2,MHhSM2,MHp2,              & 
& Msiga2,MVP2,MVWp2,MVZ2,cplAhHpcHp,cplAhcHpVWp,cplcFdFdVPL,cplcFdFdVPR,cplcFuFdVWpL,    & 
& cplcFuFdVWpR,cplcFeFeVPL,cplcFeFeVPR,cplcFvFeVWpL,cplcFvFeVWpR,cplcFuFuVPL,            & 
& cplcFuFuVPR,cplcFdFucHpL,cplcFdFucHpR,cplcFeFvcHpL,cplcFeFvcHpR,cplcgWCgAcHp,          & 
& cplcgWpgWpVP,cplcgZgWpcHp,cplcgWCgWCVP,cplcgAgWCVWp,cplcgZgWCVWp,cplcgWpgZVWp,         & 
& cplcgWCgZcHp,cplHaphhacHp,cplHapsigacHp,cplHapcHapVP,cplhhacHapVWp,cplHhSMHpcHp,       & 
& cplHhSMcHpVWp,cplHhSMcVWpVWp,cplHpcHpVP,cplHpcVWpVP,cplHpcHpVZ,cplsigacHapVWp,         & 
& cplcHpVPVWp,cplcVWpVPVWp,cplcHpVWpVZ,cplcVWpVWpVZ,cplAhcHpVPVWp1,cplhhacHapVPVWp1,     & 
& cplHhSMcHpVPVWp1,cplHpcHpVPVP1,cplHpcHpVPVZ1,cplHpcHpcVWpVWp1,cplsigacHapVPVWp1,       & 
& cplcVWpVPVPVWp3Q,cplcVWpVPVPVWp1Q,cplcVWpVPVPVWp2Q,cplcVWpVPVWpVZ3Q,cplcVWpVPVWpVZ2Q,  & 
& cplcVWpVPVWpVZ1Q,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHap,Mhha,MHhSM(3),MHp(3),Msiga,MVP,MVWp,MVZ,             & 
& MAh2(3),MFd2(3),MFe2(3),MFu2(3),MHap2,Mhha2,MHhSM2(3),MHp2(3),Msiga2,MVP2,             & 
& MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhHpcHp(3,3,3),cplAhcHpVWp(3,3),cplcFdFdVPL(3,3),cplcFdFdVPR(3,3),cplcFuFdVWpL(3,3),& 
& cplcFuFdVWpR(3,3),cplcFeFeVPL(3,3),cplcFeFeVPR(3,3),cplcFvFeVWpL(3,3),cplcFvFeVWpR(3,3),& 
& cplcFuFuVPL(3,3),cplcFuFuVPR(3,3),cplcFdFucHpL(3,3,3),cplcFdFucHpR(3,3,3),             & 
& cplcFeFvcHpL(3,3,3),cplcFeFvcHpR(3,3,3),cplcgWCgAcHp(3),cplcgWpgWpVP,cplcgZgWpcHp(3),  & 
& cplcgWCgWCVP,cplcgAgWCVWp,cplcgZgWCVWp,cplcgWpgZVWp,cplcgWCgZcHp(3),cplHaphhacHp(3),   & 
& cplHapsigacHp(3),cplHapcHapVP,cplhhacHapVWp,cplHhSMHpcHp(3,3,3),cplHhSMcHpVWp(3,3),    & 
& cplHhSMcVWpVWp(3),cplHpcHpVP(3,3),cplHpcVWpVP(3),cplHpcHpVZ(3,3),cplsigacHapVWp,       & 
& cplcHpVPVWp(3),cplcVWpVPVWp,cplcHpVWpVZ(3),cplcVWpVWpVZ,cplAhcHpVPVWp1(3,3),           & 
& cplhhacHapVPVWp1,cplHhSMcHpVPVWp1(3,3),cplHpcHpVPVP1(3,3),cplHpcHpVPVZ1(3,3),          & 
& cplHpcHpcVWpVWp1(3,3),cplsigacHapVPVWp1,cplcVWpVPVPVWp3Q,cplcVWpVPVPVWp1Q,             & 
& cplcVWpVPVPVWp2Q,cplcVWpVPVWpVZ3Q,cplcVWpVPVWpVZ2Q,cplcVWpVPVWpVZ1Q

Complex(dp), Intent(out) :: Amp(2,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
Amp(:,gt1) = 0._dp 
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MVP 
Mex3 = MVWp 


! {Fu, Fd, Fu}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFu(i1) 
ML2 = MFd(i2) 
ML3 = MFu(i3) 
coup1L = cplcFdFucHpL(i2,i1,gt1)
coup1R = cplcFdFucHpR(i2,i1,gt1)
coup2L = -cplcFuFuVPR(i1,i3)
coup2R = -cplcFuFuVPL(i1,i3)
coup3L = -cplcFuFdVWpR(i3,i2)
coup3R = -cplcFuFdVWpL(i3,i2)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(3)*AmpC 
    End Do
  End Do
End Do


! {gWp, gZ, gWp}
ML1 = MVWp 
ML2 = MVZ 
ML3 = MVWp 
coup1 = cplcgZgWpcHp(gt1)
coup2 = cplcgWpgWpVP
coup3 = cplcgWpgZVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {Hap, hha, Hap}
ML1 = MHap 
ML2 = Mhha 
ML3 = MHap 
coup1 = cplHaphhacHp(gt1)
coup2 = -cplHapcHapVP
coup3 = -cplhhacHapVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {Hap, siga, Hap}
ML1 = MHap 
ML2 = Msiga 
ML3 = MHap 
coup1 = cplHapsigacHp(gt1)
coup2 = -cplHapcHapVP
coup3 = -cplsigacHapVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {Hp, Ah, Hp}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MAh(i2) 
ML3 = MHp(i3) 
coup1 = cplAhHpcHp(i2,i1,gt1)
coup2 = -cplHpcHpVP(i3,i1)
coup3 = -cplAhcHpVWp(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Hp, HhSM, Hp}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MHhSM(i2) 
ML3 = MHp(i3) 
coup1 = cplHhSMHpcHp(i2,i1,gt1)
coup2 = -cplHpcHpVP(i3,i1)
coup3 = -cplHhSMcHpVWp(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {Hp, VP, Hp}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVP 
ML3 = MHp(i3) 
coup1 = -cplHpcHpVP(i1,gt1)
coup2 = -cplHpcHpVP(i3,i1)
coup3 = cplcHpVPVWp(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, VZ, Hp}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVZ 
ML3 = MHp(i3) 
coup1 = -cplHpcHpVZ(i1,gt1)
coup2 = -cplHpcHpVP(i3,i1)
coup3 = cplcHpVWpVZ(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, HhSM, VWp}
Do i1=1,3
  Do i2=1,3
ML1 = MHp(i1) 
ML2 = MHhSM(i2) 
ML3 = MVWp 
coup1 = cplHhSMHpcHp(i2,i1,gt1)
coup2 = cplcHpVPVWp(i1)
coup3 = cplHhSMcVWpVWp(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hp, VP, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVP 
ML3 = MVWp 
coup1 = -cplHpcHpVP(i1,gt1)
coup2 = cplcHpVPVWp(i1)
coup3 = -cplcVWpVPVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
End Do


! {Hp, VZ, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVZ 
ML3 = MVWp 
coup1 = -cplHpcHpVZ(i1,gt1)
coup2 = cplcHpVPVWp(i1)
coup3 = cplcVWpVWpVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
End Do


! {VWp, Ah, Hp}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MAh(i2) 
ML3 = MHp(i3) 
coup1 = -cplAhcHpVWp(i2,gt1)
coup2 = cplHpcVWpVP(i3)
coup3 = -cplAhcHpVWp(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VWp, HhSM, Hp}
  Do i2=1,3
    Do i3=1,3
ML1 = MVWp 
ML2 = MHhSM(i2) 
ML3 = MHp(i3) 
coup1 = -cplHhSMcHpVWp(i2,gt1)
coup2 = cplHpcVWpVP(i3)
coup3 = -cplHhSMcHpVWp(i2,i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VSS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
  End Do


! {VWp, VP, Hp}
    Do i3=1,3
ML1 = MVWp 
ML2 = MVP 
ML3 = MHp(i3) 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplHpcVWpVP(i3)
coup3 = cplcHpVPVWp(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do


! {VWp, VZ, Hp}
    Do i3=1,3
ML1 = MVWp 
ML2 = MVZ 
ML3 = MHp(i3) 
coup1 = cplcHpVWpVZ(gt1)
coup2 = cplHpcVWpVP(i3)
coup3 = cplcHpVWpVZ(i3)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do


! {VWp, HhSM, VWp}
  Do i2=1,3
ML1 = MVWp 
ML2 = MHhSM(i2) 
ML3 = MVWp 
coup1 = -cplHhSMcHpVWp(i2,gt1)
coup2 = cplcVWpVPVWp
coup3 = cplHhSMcVWpVWp(i2)
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VSV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
  End Do


! {VWp, VP, VWp}
ML1 = MVWp 
ML2 = MVP 
ML3 = MVWp 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplcVWpVPVWp
coup3 = -cplcVWpVPVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {VWp, VZ, VWp}
ML1 = MVWp 
ML2 = MVZ 
ML3 = MVWp 
coup1 = cplcHpVWpVZ(gt1)
coup2 = cplcVWpVPVWp
coup3 = cplcVWpVWpVZ
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_VVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {bar[Fd], bar[Fu], bar[Fd]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFd(i1) 
ML2 = MFu(i2) 
ML3 = MFd(i3) 
coup1L = cplcFdFucHpL(i1,i2,gt1)
coup1R = cplcFdFucHpR(i1,i2,gt1)
coup2L = cplcFdFdVPL(i3,i1)
coup2R = cplcFdFdVPR(i3,i1)
coup3L = cplcFuFdVWpL(i2,i3)
coup3R = cplcFuFdVWpR(i2,i3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(3)*AmpC 
    End Do
  End Do
End Do


! {bar[Fe], bar[Fv], bar[Fe]}
Do i1=1,3
  Do i2=1,3
    Do i3=1,3
ML1 = MFe(i1) 
ML2 = 0. 
ML3 = MFe(i3) 
coup1L = cplcFeFvcHpL(i1,i2,gt1)
coup1R = cplcFeFvcHpR(i1,i2,gt1)
coup2L = cplcFeFeVPL(i3,i1)
coup2R = cplcFeFeVPR(i3,i1)
coup3L = cplcFvFeVWpL(i2,i3)
coup3R = cplcFvFeVWpR(i2,i3)
If ((Abs(coup1L)+Abs(coup1R))*(Abs(coup2L)+Abs(coup2R))*(Abs(coup3L)+Abs(coup3R)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_FFF(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1L,coup1R,coup2L,coup2R,coup3L,coup3R,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
  End Do
End Do


! {bar[gWpC], bar[gP], bar[gWpC]}
ML1 = MVWp 
ML2 = MVP 
ML3 = MVWp 
coup1 = cplcgWCgAcHp(gt1)
coup2 = cplcgWCgWCVP
coup3 = cplcgAgWCVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {bar[gWpC], bar[gZ], bar[gWpC]}
ML1 = MVWp 
ML2 = MVZ 
ML3 = MVWp 
coup1 = cplcgWCgZcHp(gt1)
coup2 = cplcgWCgWCVP
coup3 = cplcgZgWCVWp
If ((Abs(coup1))*(Abs(coup2))*(Abs(coup3)).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology1_UUU(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {Ah, conj[Hp]}
Do i1=1,3
  Do i2=1,3
ML1 = MAh(i1) 
ML2 = MHp(i2) 
coup1 = cplAhHpcHp(i1,i2,gt1)
coup2 = cplAhcHpVPVWp1(i1,i2)
Call Amp_VERTEX_StoVV_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {Hap, hha}
ML1 = MHap 
ML2 = Mhha 
coup1 = cplHaphhacHp(gt1)
coup2 = cplhhacHapVPVWp1
Call Amp_VERTEX_StoVV_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {Hap, siga}
ML1 = MHap 
ML2 = Msiga 
coup1 = cplHapsigacHp(gt1)
coup2 = cplsigacHapVPVWp1
Call Amp_VERTEX_StoVV_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {HhSM, conj[Hp]}
Do i1=1,3
  Do i2=1,3
ML1 = MHhSM(i1) 
ML2 = MHp(i2) 
coup1 = cplHhSMHpcHp(i1,i2,gt1)
coup2 = cplHhSMcHpVPVWp1(i1,i2)
Call Amp_VERTEX_StoVV_Topology2_SS(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
  End Do
End Do


! {VP, conj[VWp]}
ML1 = MVP 
ML2 = MVWp 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplcVWpVPVPVWp1Q
coup2c = coup2 
coup2 = cplcVWpVPVPVWp2Q
coup2a = coup2 
coup2 = cplcVWpVPVPVWp3Q
coup2b = coup2 
If (Abs(coup1)*(Abs(coup2a)+Abs(coup2b)+Abs(coup2c)) .gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology2_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2a,coup2b,coup2c,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {VWp, VZ}
ML1 = MVWp 
ML2 = MVZ 
coup1 = cplcHpVWpVZ(gt1)
coup2 = cplcVWpVPVWpVZ1Q
coup2b = coup2 
coup2 = cplcVWpVPVWpVZ2Q
coup2c = coup2 
coup2 = cplcVWpVPVWpVZ3Q
coup2a = coup2 
If (Abs(coup1)*(Abs(coup2a)+Abs(coup2b)+Abs(coup2c)) .gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology2_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2a,coup2b,coup2c,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {Hp, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVWp 
coup1 = cplHpcHpcVWpVWp1(i1,gt1)
coup2 = cplcHpVPVWp(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology3_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 

End Do


! {HhSM, conj[VWp]}
Do i1=1,3
ML1 = MHhSM(i1) 
ML2 = MVWp 
coup1 = cplHhSMcHpVPVWp1(i1,gt1)
coup2 = cplHhSMcVWpVWp(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology4_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 

End Do


! {Hp, VP}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVP 
coup1 = cplHpcHpVPVP1(i1,gt1)
coup2 = cplcHpVPVWp(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology4_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 

End Do


! {Hp, VZ}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVZ 
coup1 = cplHpcHpVPVZ1(i1,gt1)
coup2 = cplcHpVWpVZ(i1)
If (Abs(coup1)*Abs(coup2).gt.epsCoup) Then 
Call Amp_VERTEX_StoVV_Topology4_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
Else
 AmpC = 0._dp
End if
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 

End Do
End Do
End Subroutine Amplitude_VERTEX_4HDM_S3_HpToVPVWp


Subroutine Amplitude_IR_VERTEX_4HDM_S3_HpToVPVWp(MAh,MFd,MFe,MFu,MHap,Mhha,           & 
& MHhSM,MHp,Msiga,MVP,MVWp,MVZ,MAh2,MFd2,MFe2,MFu2,MHap2,Mhha2,MHhSM2,MHp2,              & 
& Msiga2,MVP2,MVWp2,MVZ2,cplAhHpcHp,cplAhcHpVWp,cplcFdFdVPL,cplcFdFdVPR,cplcFuFdVWpL,    & 
& cplcFuFdVWpR,cplcFeFeVPL,cplcFeFeVPR,cplcFvFeVWpL,cplcFvFeVWpR,cplcFuFuVPL,            & 
& cplcFuFuVPR,cplcFdFucHpL,cplcFdFucHpR,cplcFeFvcHpL,cplcFeFvcHpR,cplcgWCgAcHp,          & 
& cplcgWpgWpVP,cplcgZgWpcHp,cplcgWCgWCVP,cplcgAgWCVWp,cplcgZgWCVWp,cplcgWpgZVWp,         & 
& cplcgWCgZcHp,cplHaphhacHp,cplHapsigacHp,cplHapcHapVP,cplhhacHapVWp,cplHhSMHpcHp,       & 
& cplHhSMcHpVWp,cplHhSMcVWpVWp,cplHpcHpVP,cplHpcVWpVP,cplHpcHpVZ,cplsigacHapVWp,         & 
& cplcHpVPVWp,cplcVWpVPVWp,cplcHpVWpVZ,cplcVWpVWpVZ,cplAhcHpVPVWp1,cplhhacHapVPVWp1,     & 
& cplHhSMcHpVPVWp1,cplHpcHpVPVP1,cplHpcHpVPVZ1,cplHpcHpcVWpVWp1,cplsigacHapVPVWp1,       & 
& cplcVWpVPVPVWp3Q,cplcVWpVPVPVWp1Q,cplcVWpVPVPVWp2Q,cplcVWpVPVWpVZ3Q,cplcVWpVPVWpVZ2Q,  & 
& cplcVWpVPVWpVZ1Q,Amp)

Implicit None

Real(dp), Intent(in) :: MAh(3),MFd(3),MFe(3),MFu(3),MHap,Mhha,MHhSM(3),MHp(3),Msiga,MVP,MVWp,MVZ,             & 
& MAh2(3),MFd2(3),MFe2(3),MFu2(3),MHap2,Mhha2,MHhSM2(3),MHp2(3),Msiga2,MVP2,             & 
& MVWp2,MVZ2

Complex(dp), Intent(in) :: cplAhHpcHp(3,3,3),cplAhcHpVWp(3,3),cplcFdFdVPL(3,3),cplcFdFdVPR(3,3),cplcFuFdVWpL(3,3),& 
& cplcFuFdVWpR(3,3),cplcFeFeVPL(3,3),cplcFeFeVPR(3,3),cplcFvFeVWpL(3,3),cplcFvFeVWpR(3,3),& 
& cplcFuFuVPL(3,3),cplcFuFuVPR(3,3),cplcFdFucHpL(3,3,3),cplcFdFucHpR(3,3,3),             & 
& cplcFeFvcHpL(3,3,3),cplcFeFvcHpR(3,3,3),cplcgWCgAcHp(3),cplcgWpgWpVP,cplcgZgWpcHp(3),  & 
& cplcgWCgWCVP,cplcgAgWCVWp,cplcgZgWCVWp,cplcgWpgZVWp,cplcgWCgZcHp(3),cplHaphhacHp(3),   & 
& cplHapsigacHp(3),cplHapcHapVP,cplhhacHapVWp,cplHhSMHpcHp(3,3,3),cplHhSMcHpVWp(3,3),    & 
& cplHhSMcVWpVWp(3),cplHpcHpVP(3,3),cplHpcVWpVP(3),cplHpcHpVZ(3,3),cplsigacHapVWp,       & 
& cplcHpVPVWp(3),cplcVWpVPVWp,cplcHpVWpVZ(3),cplcVWpVWpVZ,cplAhcHpVPVWp1(3,3),           & 
& cplhhacHapVPVWp1,cplHhSMcHpVPVWp1(3,3),cplHpcHpVPVP1(3,3),cplHpcHpVPVZ1(3,3),          & 
& cplHpcHpcVWpVWp1(3,3),cplsigacHapVPVWp1,cplcVWpVPVPVWp3Q,cplcVWpVPVPVWp1Q,             & 
& cplcVWpVPVPVWp2Q,cplcVWpVPVWpVZ3Q,cplcVWpVPVWpVZ2Q,cplcVWpVPVWpVZ1Q

Complex(dp), Intent(out) :: Amp(2,3) 

Integer :: i1, i2, i3, gt1, gt2, gt3 
Complex(dp) :: AmpC(2) 
Real(dp) :: Mex1, Mex2, Mex3, ExtRMsq 
Real(dp) :: ML1, ML2, ML3 
Complex(dp) :: coupT1, coupT1L, coupT1R, coup1, coup1L, coup1R 
Complex(dp) :: coup2, coup2L, coup2R, coup3, coup3L, coup3R, coup2a,coup2b,coup2c 
Do gt1=1,3
Amp(:,gt1) = 0._dp 
IRdivOnly =.true. 
! External masses 
Mex1 = MHp(gt1) 
Mex2 = MVP 
Mex3 = MVWp 


! {Hp, VP, Hp}
Do i1=1,3
    Do i3=1,3
ML1 = MHp(i1) 
ML2 = MVP 
ML3 = MHp(i3) 
coup1 = -cplHpcHpVP(i1,gt1)
coup2 = -cplHpcHpVP(i3,i1)
coup3 = cplcHpVPVWp(i3)
Call Amp_VERTEX_StoVV_Topology1_SVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do
End Do


! {Hp, VP, VWp}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVP 
ML3 = MVWp 
coup1 = -cplHpcHpVP(i1,gt1)
coup2 = cplcHpVPVWp(i1)
coup3 = -cplcVWpVPVWp
Call Amp_VERTEX_StoVV_Topology1_SVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
End Do


! {VWp, VP, Hp}
    Do i3=1,3
ML1 = MVWp 
ML2 = MVP 
ML3 = MHp(i3) 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplHpcVWpVP(i3)
coup3 = cplcHpVPVWp(i3)
Call Amp_VERTEX_StoVV_Topology1_VVS(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 
    End Do


! {VWp, VP, VWp}
ML1 = MVWp 
ML2 = MVP 
ML3 = MVWp 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplcVWpVPVWp
coup3 = -cplcVWpVPVWp
Call Amp_VERTEX_StoVV_Topology1_VVV(Mex1,Mex2,Mex3,ML1,ML2,ML3,coup1,coup2,coup3,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {VP, conj[VWp]}
ML1 = MVP 
ML2 = MVWp 
coup1 = cplcHpVPVWp(gt1)
coup2 = cplcVWpVPVPVWp1Q
coup2c = coup2 
coup2 = cplcVWpVPVPVWp2Q
coup2a = coup2 
coup2 = cplcVWpVPVPVWp3Q
coup2b = coup2 
Call Amp_VERTEX_StoVV_Topology2_VV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2a,coup2b,coup2c,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 


! {Hp, VP}
Do i1=1,3
ML1 = MHp(i1) 
ML2 = MVP 
coup1 = cplHpcHpVPVP1(i1,gt1)
coup2 = cplcHpVPVWp(i1)
Call Amp_VERTEX_StoVV_Topology4_SV(Mex1,Mex2,Mex3,ML1,ML2,coup1,coup2,AmpC) 
! Colour and symmetry Factor 
Amp(:,gt1) = Amp(:,gt1) + oo16pi2*(1)*AmpC 

End Do
End Do

IRdivOnly =.false. 
End Subroutine Amplitude_IR_VERTEX_4HDM_S3_HpToVPVWp



End Module OneLoopDecay_Hp_4HDM_S3
